/*  Check to insure the mk4 hairlines are between 
    expected pixels.

    This code was written by Alice Lecinski, September 2001.

    I strongly suggest *not* editting this code at all, unless
    you are absolutely sure you've found an error that
    needs fixing.

    If you edit it, you risk destroying the integrity of the
    code.  So if you do edit it, insure results pre and post
    actually match.

*/

#include <stdio.h>
#include <ctype.h>

#include "mk4v2.h"
#include "mk4headv2.h"

int OkHair(Hd,Lo,Hi)
    struct mk4_header *Hd; 
    float Lo, Hi;
{
    float hairLolimlo, hairLolimhi, hairHilimlo, hairHilimhi;

    hairLolimlo= 92.;
    hairLolimhi=110.;
    hairHilimlo=270.;
    hairHilimhi=282.;

    /* This routine really needs to check the date of the data
       and see if the hairlines are appropriate for that era.
       Right now, it is very simple and uses the very broad
       criteria above.
    */

    if((Lo>hairLolimlo)&&(Lo<hairLolimhi) && 
       (Hi>hairHilimlo)&&(Hi<hairHilimhi)) {
	return(TRUE);
    }
    else {
	fprintf(stderr,
	    "HairLines were not between the expected places\n\
	    %.0f<%.0f<%.0f    ---  %.0f<%.0f<%.0f\n",
	    hairLolimlo,Lo,hairLolimhi,
	    hairHilimlo,Hi,hairHilimhi);
	return(FALSE);
    }
}
