/*
 *	ShowHeader
 *
 *	Read the current header and show it on the screen
 *	A user command to be entered at the keyboard to show
 *	the contents of the current data header.
 *	A good diagnostic tool.
 *
 *	David Elmore
 *
 *	Tue Jan 18 18:09:36 GMT 1994
 */

#include	<stdio.h>
#include	<sys/mman.h>
#include	<fcntl.h>

#define		DPMON
#include	"include/dpmon_header.h"
#include	"include/image.h"
#include	"include/optics_names.h"

extern		void	exit(),perror();

main (argc,argv)
int	argc;
char	*argv[];
{

caddr_t	address,mmap();
unsigned	short	*image_start;
int	i,fildes;
off_t	offset = 0;
size_t size = (NUM_ROW+1)*NUM_COL*2;  

/* Open shared memory */

fildes	= open ( "/opt/d/Data/image_memory",O_RDWR|O_CREAT,0666 );

if ( fildes != -1 )
	{
	address = mmap ( (caddr_t)0, size, (PROT_READ|PROT_WRITE),
			MAP_SHARED, fildes, offset );
	if ( address != (caddr_t)-1 )
		{
		image_start = (unsigned short *) address;
		image_start += NUM_COL;
		}
	else
		perror ( "mmap fail" );
	}
else
	{
	perror ("open fail");
	exit ( 1 );
	}


/* Now do something wierd...have the header structure pointer */
/* set to the image address.  This will put header info in the first */
/* row of camera data */
	Image_header = (struct dpmon_header*) address;

/********** From here down, copy as header list template */

printf ( "Version: %d  ", Image_header->Version );
printf ( "%02d/%02d/%02d %02d:%02d:%02d\n",
		Image_header->Month+1,
		Image_header->Day,
		Image_header->Year,
		Image_header->Hour,
		Image_header->Minute,
		Image_header->Sec);

printf ( "Image: %dx%d,   %d summed, %d/100 sec., %d gain factor\n",
		Image_header->Xdim,
		Image_header->Ydim,
		Image_header->Nsum,
		Image_header->Exposure,
		Image_header->Gain );

printf ( "Occulting Disk Size %d arc-sec\n",Image_header->Odisk );

if ( (Image_header->Type > 0) && (Image_header->Type < NUM_TYPE) )
	printf ( "Observation Type %s\n",type_str[Image_header->Type] );
else
	printf ( "Observation Type Unknown\n" );

for ( i=0 ; i<NUM_DEVICES ; i++ )
	{
	printf ( "%s	%s\n",
	device_str[i],device_position_str[i][Image_header->Optics[i]] );
	}

}

