function sunazel, date, lat, lon
; calculates the elevation of the sun for the given date and location
; the deltaT value must be in decimal hrs.
; date must be given in [yr,month,day,UT]

date = double(date)
lat = double(lat)
lon = double(lon)

date0 = date
date0(3,*) = date0(3,*)*0.0d

jd = juliandate(date)
jd0 = juliandate(date0)

rad = sunradec(jd)
sidT = ut2apsid(jd0,date(3,*))
ae = azel(rad(0,*),rad(1,*),sidT,lat,lon)

ae=[ae,rad]

return,ae
end
