;+
; avgmk4.pro	Routine to average a list of images
;
; AUTHOR	David Elmore   20 July 2001
;-

!y.title = 'Daily Average pB'
!x.title = 'Height (R-Sun)'
!p.title = 'Average pB vs. Height'
!p.font = 1
!p.thick = 1.6
!p.ticklen = 1
!p.charsize = 1.6
!x.style = 1
!y.style = 1
!x.ticks = 10
!x.range = [1.10, 2.8]
!y.range = [1.e-10, 1.e-6]

NUMPIX  = 384
NUMAZ   = 720
azplace = 220

olddalsa = 'n'
correctfile0 = 'fred'
correctfile1 = 'fred'
close, 15 & openr, 15, '/thisbe/e/elmore/MkIV/settings'
readf, 15, olddalsa
readf, 15, biasfac
readf, 15, gamma
readf, 15, phaseoffset
readf, 15, correctfile0
readf, 15, correctfile1
readf, 15, linelow
readf, 15, linehigh
readf, 15, pixoff
readf, 15, pixscale

height = findgen (NUMPIX) * pixscale + pixoff

hdr = intarr (512)
img = fltarr (NUMPIX, NUMAZ)
avgimg = fltarr (NUMPIX, NUMAZ)


listname = 'avglist'
filename = 'fred'

close, 2
openr, 2, listname
readf, 2, filename
numimg = 0
while ( not eof (2) ) do begin
	numimg = numimg + 1
	readf, 2, filename
endwhile
rays = fltarr (numimg, NUMPIX)

close, 2
openr, 2, listname
readf, 2, filename

window, 0, xs=NUMAZ, ys=NUMPIX
numimg = 0
while ( not eof (2) ) do begin
	print, filename
	close, 1
	openr, 1, filename
	readu, 1, hdr
	readu, 1, img
	img = float (img) * 1.e-10
	avgimg = avgimg + img
	rays [numimg, *] = img [*, azplace] 
	numimg = numimg + 1
	tv, bytscl (transpose (alog10 (img + 2.0e-9)), -9, -5)
	readf, 2, filename
endwhile

avgimg = avgimg / numimg 
tv, bytscl (transpose (alog10 (avgimg + 2.0e-9)), -9, -5)
close, 1 & openw, 1, 'avg_corona.CalpB'
writeu, 1, hdr
writeu, 1, avgimg * 1.e10
close, 1


window, 2, xs=512, ys=512

;--- What is mean and std dev for each height?

avgheight      = fltarr (NUMAZ)
avgheightplus  = fltarr (NUMAZ)
avgheightminus = fltarr (NUMAZ)
avgheightmax   = fltarr (NUMAZ)
avgheightmin   = fltarr (NUMAZ)
for ii = 0, NUMPIX-1 do begin
	res = moment (avgimg [ii, *], sdev = derf)
	avgheight      [ii] = res (0)
	avgheightplus  [ii] = res (0) + derf
	avgheightminus [ii] = res (0) - derf
	avgheightmax   [ii] = max (avgimg (ii, *))
	avgheightmin   [ii] = min (avgimg (ii, *))
endfor

close, 1
openw, 1, 'corona_model'
writeu, 1, avgheight
close, 1


;--- Create azimuthally binned data.

binsize = 20
binimg = fltarr (NUMPIX, NUMAZ / binsize)
for jj=0, NUMAZ-1 do begin
	kk = jj / binsize
	binimg [*, kk] = binimg [*, kk] + img [*, jj]
endfor
for kk=0, NUMAZ/binsize - 1 do binimg [*, kk] = binimg [*, kk] / binsize
	
print, "Set plot device"
stop
plot_oo, height, avgheight
oplot, height, avgheightplus, psym=3
oplot, height, avgheightminus, psym=3
;oplot, height, avgheightmax, psym=3
;oplot, height, avgheightmin, psym=3

stop

;--- What is the stdev for each height over the day?

daystdev  = fltarr (NUMPIX)
daymean   = fltarr (NUMPIX)
polystdev = fltarr (NUMPIX)
imgnum = findgen (numimg)
for jj=0, NUMPIX-1 do begin
	res = moment (rays [*, jj], sdev=derf)
	coef = poly_fit (imgnum, rays [*, jj], 2, yfit, yband, sigma)
	daystdev  [jj] = derf
	daymean   [jj] = res (0)
	polystdev [jj] = sigma
endfor

!p.title='Mean and Standard Deviation at One Azimuth'
!y.title='pB'
plot_oo, height, daymean
oplot, height, daystdev, psym=3
oplot, height, polystdev, psym=1
stop

!p.title='pB:  10 degree binned azimuths'
plot_oo, height, binimg(*, 0), psym=3
for kk = 1, binsize-1 do begin
	oplot, height, binimg(*, kk), psym=3
endfor
end

