;+
; NAME	doppler_plot
;
; PURPOSE	Plot the equatorial doppler profile for CHIP B2 filter.
;
; HISTORY	Andrew L. Stanger   HAO/NCAR24 May 2000
;-

PRO doppler_plot, data_file

nval = 0
imgname = ''
xval = 0.0
yval = 0.0

close, 10
openr, 10, data_file
readf, 10, nval
readf, 10, imgname

eqdist = fltarr (nval)
rawbrt = fltarr (nval)

for i = 0, nval-1 DO	$
    BEGIN
    readf, 10, xval, yval
    eqdist [i] = xval
    rawbrt [i] = yval
    END
close, 10

ymin = MIN (rawbrt, max=ymax)
iymin = fix (ymin) - 1
iymax = fix (ymax + 0.5) + 1

print, 'eqdist: ', eqdist
print, 'rawbrt: ', rawbrt

set_plot, 'ps'
device, filename='doppler_plot.ps'
plot, eqdist, rawbrt,	$
      title='CHIP doppler shift 00d104.180602.csr',	$
      xtitle='Equatorial Distance [Rsun]',	$
      ytitle='Raw Intensity (Ave. Brightest 20 percent)',			$
;      yrange = [iymin,iymax]
      yrange = [3150.0, 3300.0]

device, /close
set_plot, 'x'

END
