;+
; fixmk4fits.pro   IDL procedure
;
; PURPOSE
;	Read a Mk4 FITS file and fix the BITPIX parameter.
;	It originally was incorrectly set to 1.  Change it to 8.
;
; SYNTAX
;	fixmk4fits, 'fits_list'
;
; PROCEDURES USED
;	readfits
;	writefits
;	fxaddpar
;
; HISTORY
;	Author: Andrew L. Stanger   HAO/NCAR   8 January 2001
;-

pro fixmk4fits, fits_list

fits_name = ''				; Define FITS file name variable.
comment = 'BINARY HEADER INFO; VARIABLE LENGTH FIELDS.'

CLOSE, 1

print, 'fits_list: ', fits_list

OPENR, 1, fits_list			; Open list file.

WHILE (NOT EOF (1)) DO	$		; File processing loop.
   BEGIN
      READF, 1, fits_name		; Read FITS file name from list file.

      print, fits_name

      fxhmodify, fits_name, 'EXTEND', 'T'		; Add extend parameter.
      fxhmodify, fits_name, 'BITPIX',  8, EXTENSION=1	; Change bitpix to 8.
   END
CLOSE, 1

 END
