PRO picspec3, fits_list

; MLSO/PICS spectral test.
; Plot pixel intensity sum versus Filter setting.

   halle = [-0.25, -0.20, -0.15, -0.10, -0.05,				$
	     0.00,							$
	     0.05,  0.10,  0.15,  0.20,  0.25]

   file = ''
   pbsum   = fltarr (15)
   imghour = fltarr (15)
   lun = 1
   CLOSE, lun
   OPENR, lun, fits_list

   imgnum = -1
   WHILE (NOT EOF (lun)) DO                     $
   BEGIN
      imgnum = imgnum + 1
      READF, lun, file				; Read file name from list.
      PRINT, 'Read file: ', file, FORMAT = '(A)'
      fimg = readfits (file, hdu)		; Read FITS image.

      ;--- Extract information from FITS header.

      xdim = fxpar (hdu, 'NAXIS1')
      ydim = fxpar (hdu, 'NAXIS2')
      xcen = fxpar (hdu, 'CRPIX1')
      ycen = fxpar (hdu, 'CRPIX2')
      cdelt1 = fxpar (hdu, 'CDELT1')
      cdelt2 = fxpar (hdu, 'CDELT2')
      crradius = fxpar (hdu, 'CRRADIUS')
      pang = fxpar (hdu, 'SOLAR_P0')
      datamin = fxpar (hdu, 'DATAMIN')
      datamax = fxpar (hdu, 'DATAMAX')
      dispmin = fxpar (hdu, 'DISPMIN')
      dispmax = fxpar (hdu, 'DISPMAX')
      time_obs = fxpar (hdu, "TIME-OBS")
      hour   = STRMID (time_obs, 0, 2)
      minute = STRMID (time_obs, 3, 2)
      second = STRMID (time_obs, 6, 2)
      pbhour   = float (hour)
      pbminute = float (minute)
      pbsecond = float (second)
      imghour [imgnum] = pbhour + pbminute / 60.0 + pbsecond / 3600.0

      img = fltarr (xdim, ydim - 1)
      img = fimg (*, 1:ydim-1)
      sum = 0.0
      FOR iy = 0, ydim - 2 DO		$
	 FOR ix = 0, xdim -1 DO		$
	    BEGIN
	       sum = sum + img (ix, iy)
	    END
      pbsum [imgnum] = sum
   END
   CLOSE, lun

   SET_PLOT, 'PS'
   DEVICE, FILENAME='picspec3.ps'

   PLOT, imghour, pbsum, YRANGE = [1.0E+8,2.0E+8],	$
	 TITLE  = 'PICS SPECTRAL TEST  23 MAR 1999',	$
	 XTITLE='hour',	$
	 YTITLE = 'PIXEL INTENSITY SUM [BSUN]'

   DEVICE, /CLOSE
   SET_PLOT, 'X'
END
