/* acos_dev.h
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Definitions needed for MLSO/ACOS device names and positions.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR    9 Nov 1995
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#define NUM_CHAR    16
#define NUM_TYPE    14
#define NUM_DEVICES 13
#define NUM_POSITIONS 8
#define NUM_DRIVE_TYPES 4

#ifdef ACOS

char imgnam [NUM_TYPE][NUM_CHAR] =
   {
   "CHIP_MAJOR",
   "CHIP_MINOR",
   "CHIP_CONTINUUM",
   "CHIP_WATER",
   "CHIP_MAJOR_DARK",
   "CHIP_MINOR_DARK",
   "CHIP_CONTINUUM_DARK",
   "CHIP_WATER_DARK",
   "CHIP_MAJOR_DIFFUSER",
   "CHIP_MINOR_DIFFUSER",
   "CHIP_CONTINUUM_DIFFUSER",
   "CHIP_WATER_DIFFUSER",
   "CHIP_OTHER",
   "CHIP_LAST"
   } ;

char devnam [NUM_DEVICES][NUM_CHAR] =
   {
   "Filter Stage",
   "O2 Stage",
   "CHIP cover",
   "CHIP Diffuser",
   "CHIP Strobe",
   "dPMon/LowK Strobe",
   "Occulting Limits",
   "Cover",
   "Polarizer Stage",
   "Filter Wheel",
   "Polarizer Wheel",
   "Objective Wheel",
   "Occulting Wheel"
   } ;

char devpos [NUM_DEVICES][NUM_POSITIONS][NUM_CHAR] =
   {
   "Unknown", "In", "Out", "Error", 0, 0, 0, 0,
   "Unknown", "LowK", "dPMon", "Error", 0, 0, 0, 0,
   "Unknown", "In", "Out", "Error", 0, 0, 0, 0,
   "Unknown", "In", "Out", "Error", 0, 0, 0, 0,
   "None", "CHIP", "illegal", "illegal", 0, 0, 0, 0,
   "None", "dPMon/LowK", "illegal", "illegal", 0, 0, 0, 0,
   "Unknown", "CW Limit", "CCW Limit", "Error", 0, 0, 0, 0,
   "Unknown", "In", "Out", "Error", 0, 0, 0, 0,
   "Unknown", "In", "Out", "Error", 0, 0, 0, 0,
   "658.1", "654.0", "Dark", "Dark", "Dark", "655.5", "656.3", "657.1", 
   "0", "45", "90", "135", "180", "225", "270", "315", 
   "Clear", "Diffuser", "Opal", "Polarizer", "Error", "Error", "Error", "Error",
   "Wedge", "Lowk", "Clear", "Offset", "Reticule", "Occult", "Error", "Error"
   } ;

char devdrv [NUM_DEVICES][NUM_DRIVE_TYPES][NUM_CHAR] =
   {
   "Stop", "In",   "Out",   "Stop", 
   "Stop", "Lowk", "dPMon", "Stop", 
   "Stop", "In",   "Out",   "Stop", 
   "Stop", "In",   "Out",   "Stop", 
   0,      0,      0,       0, 
   0,      0,      0,       0, 
   0,      0,      0,       0, 
   "Stop", "In",   "Out",   "Stop", 
   "Stop", "In",   "Out",   "Stop", 
   "Stop", "CW",   "CCW",   "Stop", 
   "Stop", "CW",   "CCW",   "Stop", 
   "Stop", "CW",   "CCW",   "Stop", 
   "Stop", "CW",   "CCW",   "Stop"
   } ;

#else
extern  char    imgnam [NUM_TYPE][NUM_CHAR] ;
extern  char    devnam [NUM_DEVICES][NUM_CHAR] ;
extern  char    devpos [NUM_DEVICES][NUM_POSITIONS][NUM_CHAR] ;
extern  char    devdrv [NUM_DEVICES][NUM_DRIVE_TYPES][NUM_CHAR] ;
#endif
