
struct acos_info		/* MLSO/ACOS housekeeping info. */
   {
   int swvers   ;		/* Software version number.	*/
   int ttype    ;		/* Telescope type [0-2].	*/
   int dtype	;		/* Data type [1-8]		*/
   int xdim	;		/* Image width			*/
   int ydim	;		/* Image height			*/
   int zdim	;		/* Image depth			*/
   int nbypx	;		/* # bytes/pixel		*/
   int dmin	;		/* Data minimum value		*/
   int dmax	;		/* Data maximum value		*/
   int smin	;		/* Display min value		*/
   int smax	;		/* Display max value		*/
   int year	;		/* Image year			*/
   int month	;		/* Image month			*/
   int day	;		/* Image day (of month)		*/
   int doy	;		/* Image day-of-year		*/
   int hour	;		/* Image hour			*/
   int minute	;		/* Image minute			*/
   int second	;		/* Image second			*/
   int cal_year ;		/* Calibration year.		*/
   int cal_month;		/* Calibration month.		*/
   int cal_day	;		/* Calibration day.		*/
   int navg	;		/* # images averaged  		*/
   float expdur	;		/* Exposure duration (sec)	*/
   float gain	;		/* Gain	factor			*/
   float odisk  ;               /* Occulting disk (arcsec)      */
   float bscale ;		/* Brightness scaling factor.	*/
   float bzero  ;		/* Brightness scaling offset.	*/
   float pixrs	;		/* # pixels/Rsun		*/
   float pangle	;		/* P-angle (degrees)		*/
   float bangle	;		/* B-angle (degrees)		*/
   float langle	;		/* L-angle (degrees)		*/
   float ra     ;		/* Right Ascension (degrees)    */
   float dec    ;		/* Declination (degrees)        */
   float hangle	;		/* Hour-angle (degrees)		*/
   float nangle ;		/* Angle (CCW) of north w.r.t. +X axis. */
   float elev   ;		/* Solar elevation (degrees)	*/
   float azimuth;		/* Solar azimuth (degrees)	*/
   float airmass;		/* Airmass.			*/
   float rsun   ;		/* Solar radius (arcsec)	*/
   float xcen	;		/* X-axis sun center		*/
   float ycen	;		/* Y-axis sun center		*/
   float rmin   ;		/* Inner FOV radius (Rsun)      */
   float rmax   ;		/* Outer FOV radius (Rsun)      */
   float wavelen;		/* Filter Wavelength (nm)       */
   float wavewid;		/* Filter Banpass (nm)          */
   char optdev [NUM_DEV][18];	/* Names of optical devices	*/
   char optpos [NUM_DEV][18];	/* Positions of optical devices	*/
   char optdrv [NUM_DEV][18];	/* Drive requests of optical devices	*/
   } ;


#ifdef ACOS
   struct acos_info ACOSIS ;
   struct acos_info *ACOSI = &ACOSIS ;
#else
   extern struct acos_info ACOSIS ;
   extern struct acos_info *ACOSI ;
#endif

