/* acosfits.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Convert an MLSO/ACOS image to FITS format.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR    9 November 1995
 * 20 Feb 96: Modify to allow multiple input files on command line.
 *            Remove extension file inputs on command line.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#define ACOS
#include "acoslib.h"
#define MAXFILES 250

main (argc, argv)

int argc ;
char *argv [] ;

{
   char imgbuf ;
   static char flist [MAXFILES][80] ;
   static char linbuf [84] ;
   static char name [80] ;
   static char namext1 [80] = "\0" ;
   static char namext2 [80] = "\0" ;
   static char namext3 [80] = "\0" ;
   static char namimg [80] ;
   static char namlst [80] ;
   FILE *LIST, *IN, *OUT ;
   int argp = 1 ;
   int findex = 0 ;		/* File index. */
   int hduflag = 1 ;		/* HDU (header data unit) flag. */
   				/* 1: primary image; no extension.        */
				/* 2: primary image; extension exists.    */
				/* 3: extension image; append to namfits. */
   int nf = 0 ;
   int numfil = 0 ;
   int pmode = 0 ;		/* Print mode: 0=silent, 1=verbose. */

 if (argc == 1)			/* No arguments. */
       {
      fprintf (stderr, "usage: %s image_file[s]  | @image_file_list\n",
	       argv [0]) ;
      exit (-1) ;
      }
   else
      {
      nf  = 0 ;
      while (argp < argc)	/* Copy filenames into flist array. */
	 {
         strcpy (name, argv [argp]) ;

         if (name [0] == '@')	/* List of filenames. */
            {
            strcpy (namlst, &name [1]) ;
            if ((LIST = fopen (namlst, "r")) == NULL)
               {
               fprintf (stderr, "Unable to open list file %s\n", namlst) ;
               exit (-2) ;
               }
            while (fscanf (LIST, "%s", name) != EOF)
               {
               strcpy (&flist [nf++][0], name) ;  /* Copy filenames to flist. */
               }
            fclose (LIST) ;
            }
         else
            strcpy (&flist [nf++][0], argv [argp]) ;

	 argp++ ;
	 }
      numfil = nf ;
      }

loop:

   strcpy (namimg, &flist [findex++][0]) ;

   acostofits (namimg, namext1, hduflag, pmode) ;

   if (findex < numfil) goto loop ;

   exit (0) ;
}
