/* acosfits.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Convert an MLSO/ACOS image to FITS format.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR    9 November 1995
 * 20 Feb 96: Modify to allow multiple input files on command line.
 *            Remove extension file inputs on command line.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#define ACOS
#define START

#include "/home/cordyn/mlsofits/lib/acos/mechanism_defs.h"
#include "/home/cordyn/mlsofits/lib/acos/acos.h"
#include "/home/cordyn/mlsofits/lib/acos/acos_info.h"
#include "/home/cordyn/mlsofits/lib/acos/acos_header.h"
#include "/home/cordyn/mlsofits/lib/acos/room.h"
#include "/home/cordyn/mlsofits/lib/acos/device.h"
#include "/home/cordyn/mlsofits/analog.h"
#include "/home/cordyn/mlsofits/lcvr.h"
#include "/home/cordyn/mlsofits/mic.h"

#define MAXFILES 250

main (argc, argv)

int argc ;
char *argv [] ;

{
   char imgbuf ;
   char *w;
   static char flist [MAXFILES][80] ;
   static char linbuf [84] ;
   static char filenm [80] ;
   static char namext1 [80] = "\0" ;
   static char namext2 [80] = "\0" ;
   static char namext3 [80] = "\0" ;
   static char namimg [80] ;
   static char namlst [80] ;
   FILE *lfid ;
   int ii;
   int argp = 1 ;
   int findex = 0 ;		/* File index. */
   int hduflag = 1 ;		/* HDU (header data unit) flag. */
   				/* 1: primary image; no extension.        */
				/* 2: primary image; extension exists.    */
				/* 3: extension image; append to namfits. */
   int nf = 0 ;
   int numfil = 0 ;
   int pmode = 0 ;		/* Print mode: 0=silent, 1=verbose. */
   int nodel = 0 ;              /* Whether or not to delete the image
                                 * after conversion to fits.
                                */

 if (argc == 1)			/* No arguments. */
       {
      fprintf (stderr, "usage: %s [-nodel] image_file[s]  | @image_file_list\n",
	       argv [0]) ;
      exit (-1) ;
      }
   else
      {
      w = argv[1];      /* First check for flag arguments. */
      if (*w == '-') {
	 switch (w[1]) {
            case 'n':   nodel=1 ;
                        break;
            default:
                        fprintf (stderr," unknown flag %s\n",argv[1]);
                        exit(1);
         }
	 argp++;
      }

      nf  = 0 ;
      while (argp < argc)	/* Copy filenames into flist array. */
	 {
         strcpy (filenm, argv [argp]) ;

         if (filenm [0] == '@')	/* List of filenames. */
            {
            strcpy (namlst, &filenm [1]) ;
            if ((lfid = fopen (namlst, "r")) == NULL)
               {
               fprintf (stderr, "Unable to open list file %s\n", namlst) ;
               exit (-2) ;
               }
            while (fscanf (lfid, "%s", filenm) != EOF)
               {
               strcpy (&flist [nf++][0], filenm) ;  /* Copy filenames to flist. */
               }
            fclose (lfid) ;
            }
         else
            strcpy (&flist [nf++][0], argv [argp]) ;

	 argp++ ;
	 }
      numfil = nf ;
      }

loop:

   strcpy (namimg, &flist [findex++][0]) ;
   /*
   fprintf(stderr,"\t\tProcessing %s\n",namimg);
   */

   ii = acostofits (namimg, namext1, hduflag, pmode, nodel ) ;

   if (findex < numfil) goto loop ;

   exit (0) ;
}
