/**************************************************************************
 * get_os_type.c
 *
 * determines OS at runtime
 *
 */

#include "os_type.h"
#include <stdio.h>

int get_os_type (isremote, remote_system, remote_login)
int isremote;
char *remote_system;
char *remote_login;

{

  FILE *result;
  int i, res;
  char line[256];

  if (isremote) {
/*  Note that the remote case is much more tricky than the local one.  For
 *  the local test you can just test the status on pclose.  For the remote
 *  one, the result of the rsh command is always successful even if the
 *  remote command itself failed.  So, we resort to echoing the status as a
 *  part of the rsh command and reading the status that is returned.
 */
    res = 0;
#ifdef SGI
    strcpy (line, "/usr/bsd/rsh ");
#else  SGI
    strcpy (line, "rsh ");
#endif SGI
    strcat (line, remote_system);
    if (strlen (remote_login) > 0) {
      strcat (line, " -l ");
      strcat (line, remote_login);
    }
    strcat (line, " 'sun ; echo $status'");
    result = popen (line, "r");
    if (result != NULL) {
      while (fgets (line, 256, result) == line) {
/*      printf ("The line was %s\n", line);  */
	if (strchr (line, '0') != NULL) res = SUN_OS;
      }
      pclose (result);
    }
    if (res != 0) return (res);
#ifdef SGI
    strcpy (line, "/usr/bsd/rsh ");
#else  SGI
    strcpy (line, "rsh ");
#endif SGI
    strcat (line, remote_system);
    if (strlen (remote_login) > 0) {
      strcat (line, " -l ");
      strcat (line, remote_login);
    }
    strcat (line, " '4d ; echo $status'");
    result = popen (line, "r");
    if (result != NULL) {
      while (fgets (line, 256, result) == line) {
/*      printf ("The line was %s\n", line);  */
	if (strchr (line, '0') != NULL) res = SGI_OS;
      }
      pclose (result);
    }
    if (res != 0) return (res);
  } else {
    res = -1;
    result = popen ("sun", "r");
    if (result != NULL) {
      while (fgets (line, 256, result) == line) {
/*      printf ("The line was %s\n", line);  */
      }
      res = pclose (result);
      if (res == 0) return (SUN_OS);
    }
    result = popen ("4d", "r");
    if (result != NULL) {
      while (fgets (line, 256, result) == line) {
/*      printf ("The line was %s\n", line);  */
      }
      res = pclose (result);
      if (res == 0) return (SGI_OS);
    }
  }
  return (0);
}




