function carr_jd_fn, ca,lon

; MODIFIED MAY 11 2000
;Convert from Carrington rotation and Longitude to (Julian Date -2440000)

carrot = double(0.0)
lonmax = double(0.0) 

JD_low = double(0.0)

carrot = double(ca)
lonmax = double(lon)

if (lonmax eq 0.0) then begin
  lonmax = double(360.0)
  carrot = carrot + double(1.0)
endif


incl = double(7.25)

JD_DD = double(0.0)
Lo = double(0.0) 

JD_orig = double(0.0) 

JD_DD = carrot+(double(360.0)-lonmax)/double(360.0)
JD_DD = JD_DD - double(1750.0)
JD_DD = JD_DD*double(27.2753)  
JD_DD = JD_DD + double(5871.91)

JD_orig = JD_DD

JD_low = JD_DD + double(3.0)
JD_DD = JD_DD - double(3.0)

; for each of the dates labeling the bottom x-axis of the 1st plot.

incr = double(0.1)

for MM = long(0), 10000 do begin
   
  JD_DD = JD_DD + incr

  ;nn = JD_DD - 2451545.0
  ; 2440000 - 2451545 = 11545
  nn = JD_DD - double(11545.0)
  LL = double(280.460) + double(0.9856474)*nn
  gg = double(357.528) + double(0.9856003)*nn
  sun = LL + double(1.915)*sin(gg*!dpi/double(180.0)) + $
  double(0.020)*sin(double(2.0)*gg*!dpi/double(180.0))

; Explains where the number 43243.25 comes from
; omega = 73.0 + 40.0/60.0+ 50.25*((JD_DD+2440000.0 - $
; 2396756.75)/365.25)/3600.0

  omega = double(73.0) + double(40.0)/double(60.0) + $
  double(50.25)*((JD_DD+ double(43243.25))/double(365.25))/double(3600.0)

; Explains where the number 41780.0 comes from
; ww = 360.0/25.38*(JD_DD+2440000.0 - 2398220.0)

  ww = double(360.0)/double(25.38)*(JD_DD+double(41780.00))
  ww = (ww/double(360.00) - fix(ww/double(360.0)))*double(360.0)

  Bosin = sin((sun-omega)*!dpi/double(180.00))*sin(incl*!dpi/double(180.0))
  Bocos = sqrt(double(1.0) - Bosin^2)

  Bo = atan(Bosin,Bocos)*double(180.0)/!dpi

  LoWsin = cos(incl*!dpi/double(180.0))*sin((omega-sun)*!dpi/double(180.0))/cos(Bo*!dpi/double(180.0))
  LoWcos = -cos((omega-sun)*!dpi/double(180.0))/cos(Bo*!dpi/double(180.0))
  LoW = atan(LoWsin,LoWcos)*double(180.0)/!dpi

  if LoW lt double(0.0) then LoW = LoW + double(360.0)
  Lo = LoW - ww

  if Lo lt double(0.0) then Lo = Lo + double(360.0)

  long_diff = Lo - lonmax

  ;print,incr,JD_DD,Lo,lonmax

  if ( (long_diff lt 0.0) and (abs(long_diff) lt 100.0)) then begin 

      JD_DD = JD_DD - incr
      incr = incr/double(10.0)
      if (incr lt double(1.0e-8)) then goto,DONE

  endif

  if ( (long_diff gt 0.0) and (abs(long_diff) gt 100.0)) then begin

      JD_DD = JD_DD - incr
      incr = incr/double(10.0)
      if (incr lt double(1.0e-8)) then goto,DONE

  endif

endfor

DONE:

caldat,(JD_DD+double(2440000.0)),mmm,ddd,yyy
dayfr = JD_DD-long(JD_DD) + double(0.5)
if (dayfr ge 1.0) then dayfr = dayfr - double(1.0)


return,JD_DD

end
