/*
 * solar.c - solar ephemeris calculations.  Produces sun's
 * ra, dec, az, el, p, b0, sradius calculations
 *
 * SEE ALSO: astrotime.c for time calculations, jday, and last for
 * unix commands, astro.h for miscellaneous definitions.
 */
#include	<stdio.h>
#include "astro.h"

main(argc,argv)
int argc;
char **argv;
{
	long gmt;
	long jday;
	ANGLE Az, El, Sradius, P, B0, L0, Last, Ra, Dec, Ha, Airmass;
	long hh,mm,ss;

	fscanf ( stdin,"%ld %ld %ld %ld",&jday,&hh,&mm,&ss );
	gmt = hmstosec(hh,mm,ss);

	Last = last(jday,gmt);			/* radians -> degrees */
	Last = fr2d(Last) * 24./ 360.;	/* degrees -> hours */
	Last = fmod(fmod(Last,24.)+24.,24.);	/* positive angle */

	azel((long)jday,(long)gmt,&Az,&El,&Sradius,&P,&B0,&L0);
	solarEphm((long)jday,(long)gmt,&Ra,&Dec,&Sradius,&P,&B0,&L0);

	fprintf(stdout,"%lg\n", fr2d(Sradius) * 7200. / 2.3 );

 }
