/* sepe.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Test sepheme.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   16 February 2000
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include "astro.h"

main (argc, argv)

int argc ;
char *argv [] ;

{
    extern int jday () ;
    extern int sepheme () ;

    int  jd ;
    int year, month, day ;
    int hh, mm, ss ;
    ANGLE az, el, sradius, pang, b0, l0, lst ;
    ANGLE ra, dec, ha, airmass ;

    if (argc < 7)
	{
	printf ("usage: %s year month day hour minute second\n", argv [0]) ;
	exit (0) ;
	}

    sscanf (argv [1], "%d", &year) ;
    sscanf (argv [2], "%d", &month) ;
    sscanf (argv [3], "%d", &day) ;
    sscanf (argv [4], "%d", &hh) ;
    sscanf (argv [5], "%d", &mm) ;
    sscanf (argv [6], "%d", &ss) ;

   fprintf (stdout, "sep> date: %4d %02d %02d\n", year, month, day) ;

    jd = jday (year, month, day) ;

   fprintf (stdout, "sep> jday: %d\n", jd) ;

    sepheme (jd, hh, mm, ss,
	    &az, &el, &sradius, &pang, &b0, &l0, &lst,
	    &ra, &dec, &ha, &airmass) ;

   fprintf (stdout, "az:      %f\n", az) ;
   fprintf (stdout, "el:      %f\n", el) ;
   fprintf (stdout, "sradius: %f\n", sradius) ;
   fprintf (stdout, "pang:    %f\n", pang) ;
   fprintf (stdout, "b0:      %f\n", b0) ;
   fprintf (stdout, "l0:      %f\n", l0) ;
   fprintf (stdout, "lst:     %f\n", lst) ;
   fprintf (stdout, "ra:      %f\n", ra) ;
   fprintf (stdout, "dec:     %f\n", dec) ;
   fprintf (stdout, "ha:      %f\n", ha) ;
   fprintf (stdout, "airmass: %f\n", airmass) ;

   exit (0) ;
}
