PRO cavity_model

;--- Image array: Mk4 cartesian coordinate image size.

img = FLTARR (960, 960)

;--- Create FITS header (based upon image size & data type).

mkhdr, hdu, img 

;--- Add various keywords to FITS header.

fxaddpar, hdu, 'ORIGIN',   'HAO',    ' High Altitude Observatory'
fxaddpar, hdu, 'TELESCOP', 'CM v1.0', ' Cavity Model v1.0 Sarah Gibson'
fxaddpar, hdu, 'DATE-OBS', date_obs, ' YYYY-MM-DD'
fxaddpar, hdu, 'TIME-OBS', time_obs, ' HH:MM:SS [UT]'
fxaddpar, hdu, 'OBJECT',   'CORONA', ' solar corona'
fxaddpar, hdu, 'TYPE_OBS', 'pB',     ' polarization Brightness'
fxaddpar, hdu, 'VIGNET',   'N',      ' image vignetted: [Y or N]'
fxaddpar, hdu, 'DATAFORM', 'CARTESIAN',     ' data format'
fxaddpar, hdu, 'COORDNAM', 'HELIO-CENTRIC', ' dordinate system'
fxaddpar, hdu, 'CTYPE1,    'X',      ' axis 1 type: X'
fxaddpar, hdu, 'CRPIX1,    479.5,    ' X sun center [pixel]'
fxaddpar, hdu, 'CRVAL1,    0.0,      ' X sun center [arcsec]'
fxaddpar, hdu, 'CDELT1,    5.917744, ' X coord increment [arcsec/pixel]'
fxaddpar, hdu, 'CROTA1,    0.0,      ' X rotation [deg] from reference'
fxaddpar, hdu, 'CTYPE2,    'Y',      ' axis 2 type: Y'
fxaddpar, hdu, 'CRPIX2,    479.5,    ' Y sun center [pixel]'
fxaddpar, hdu, 'CRVAL2,    0.0,      ' Y sun center [arcsec]'
fxaddpar, hdu, 'CDELT2,    5.917744, ' Y coord increment [arcsec/pixel]'
fxaddpar, hdu, 'CROTA2,    0.0,      ' Y rotation [deg] from reference'
fxaddpar, hdu, 'CRRADIUS', 160.0,    ' pixels per solar radius'
fxaddpar, hdu, 'RSUN',     960.0,    ' solar radius [arcsec]'
fxaddpar, hdu, 'SOLAR_P0', 0.0,      ' solar P-angle [degrees]'
fxaddpar, hdu, 'SOLAR_B0', 0.0,      ' solar B-angle [degrees]'
fxaddpar, hdu, 'BUNIT',    'Bsun',   ' Bsun = average solar disk brightness'
fxaddpar, hdu, 'BSCALE',   1.0,      ' Bsun = data * BSCALE + BZERO'
fxaddpar, hdu, 'BZERO,     0.0,      ''
fxaddpar, hdu, 'DATAMIN',  imin,     ' Bsun units'
fxaddpar, hdu, 'DATAMAX',  imax,     ' Bsun units'
fxaddpar, hdu, 'DISPMIN',  dmin,     ' Bsun units'
fxaddpar, hdu, 'DIRAXIS1', 'RIGHT',  ' display direction for axis 1 [X]'
fxaddpar, hdu, 'DIRAXIS2', 'UP',     ' display direction for axis 2 [Y]'
fxaddpar, hdu, 'RMIN',     rmin,     ' inner field-of-view limit [Rsun]''
fxaddpar, hdu, 'RMAX',     rmax,     ' outer field-of-view limit [Rsun]''

;--- Write FITS file.

writefits, 'cavity.model.1.fts', img, hdu

END
