;+
; chgparfits.pro   IDL procedure
;
; PURPOSE
;	Read a FITS image and change the parameter value of a keyword. 
;
; SYNTAX
;	chgparfits, 'fits_list', key, param
;
; PROCEDURES USED
;	readfits
;	fxaddpar
;	writefits
;
; HISTORY
;	Author: Andrew L. Stanger   22 October 1997
;-

pro chgparfits, fits_list, key, param, com

fits_name = ''				; Define FITS file name variable.

IF (N_ELEMENTS (key) EQ 0) THEN	$
BEGIN
   PRINT, 'Keyword not specified.'
   EXIT
END

IF (N_ELEMENTS (param) EQ 0) THEN	$
BEGIN
   PRINT, 'Parameter Value not specified.'
   EXIT
END

CLOSE, 1
OPENR, 1, fits_list			; Open list file.

WHILE (NOT EOF (1)) DO	$		; File processing loop.
   BEGIN
      READF, 1, fits_name		; Read FITS file name from list file.
      img = readfits (fits_name, hdu)	; Read FITS image & header.

      ; -- Modify FITS header.

      IF (N_ELEMENTS (com) NE 0) THEN	$
         fxaddpar, hdu, key, param, com	$
      ELSE				$
         fxaddpar, hdu, key, param

      ; -- Write FITS image to disk.

      writefits, fits_name, img, hdu

   END
CLOSE, 1

END
