c#######################################################################
      function cfun (rr)
c
c-----------------------------------------------------------------------
c
c ****** Coronal light scattering function [Billings 1966].
c
c ****** R is the radius in units of R-sun.
c
c-----------------------------------------------------------------------
c
      parameter (a1=8.69e-7)
      parameter (a2=0.37)
      parameter (a3=0.63)
c
c-----------------------------------------------------------------------
c
      r = amax1 (1.0001, rr)
c
      a     = 1.0 / r / r
      ra    = 1.0 / r
      r1a   = sqrt (1.0 - a)
      afunc = r1a * a
      b1    = (1.0 - a) / ra
      b2    = 1.0 + 3.0 *a
      b3    = alog ((1.0 + ra) / r1a)
      bf    = b1 * b2 * b3
      b4    = 1.0 - 3.0 * a
      bfunc = -1.0 / 8.0 * (b4 - bf)
      cfun  = a1 * (a2 * afunc + a3 * bfunc)
c
      return
      end
c#######################################################################
