c#######################################################################
      function rhoval (rv, tv, pv)
c
c-----------------------------------------------------------------------
c
      common /fldcom/ nr, nt, np, iprh, ipth, ipph, iprho, 
     &                nrm1, ntm1, ipr, ipt, ippb
c
c-----------------------------------------------------------------------
c
      pointer (iprh, rh), (ipth, th), (ipph, ph)
      pointer (iprho, rho)
c
c-----------------------------------------------------------------------
c
      parameter (pi=3.14159265358979)
c
c-----------------------------------------------------------------------
c
c ****** Sin and cos of the solar P and B0 angles.
c
      common /pb0com/ sp, cp, sb, cb
c
c-----------------------------------------------------------------------
c
c ****** Central meridian longitude.
c
      common /cmdcom/ emu
c
c-----------------------------------------------------------------------
c
c ****** Transform to Cartesian coordinates.
c
      call s2c (rv, tv, pv, x0, y0, z0)
c
c ****** Apply the solar P angle transformation.
c
      x1 = x0
      y1 = cp * y0 + sp * z0
      z1 = -sp * y0 + cp * z0
c
c ****** Apply the solar B0 angle transformation.
c
      x2 = cb * x1 - sb * z1
      y2 = y1
      z2 = sb * x1 + cb * z1
c
c ****** Transform back to spherical coordinates.
c
      call c2s (x2, y2, z2, rrv, ttv, ppv)
c
c ****** Transform to the appropriate central meridian longitude.
c
      ppv = ppv + emu
      ppv = amod (ppv, 2.*pi)
      if (ppv .lt. 0.0) ppv = ppv + 2.0 * pi
c
      if (np .eq. 1) then
        rhoval = f2d (nr, nt, rh, th, rho, rrv, ttv)
      else
        rhoval = f3d (nr, nt, np, rh, th, ph, rho, rrv, ttv, ppv)
      end if
c
      return
      end
c#######################################################################
