SHELL  = /bin/sh
BASE   = /usr/local/dx
DXARCH = linux
HDF    = /telesto/d/stanger/sw/hdf
SPDX   = /usr/local/dx

BIN = $(BASE)/bin
include $(BASE)/lib_$(DXARCH)/arch.mak
include ../Make.$(DXARCH)


#set compiler flags

HDFLIBS = -L$(HDF)/lib -lmfhdf -ldf -ljpeg -lz
CFLAGS = -I./ -I$(BASE)/include -I$(HDF)/include $(DX_CFLAGS) $(ARCHCFLAGS) 
FFLAGS = -I$(HDF)/include  $(ARCHFFLAGS)
LDFLAGS = -L$(BASE)/lib_$(DXARCH) -g
LIBS = -lDX $(DX_GL_LINK_LIBS) $(DXEXECLINKLIBS)
OLIBS = -lDXlite -lm


#default rules

.c.o: ; $(CC) -c $(DXABI) $(DX_RTL_CFLAGS) $(CFLAGS) $*.c 

.C.o: ; $(CC) -c $(DXABI) $(DX_RTL_CFLAGS) $(CFLAGS) $*.C 

.F.o: ; $(F77) $(FFLAGS) -c $*.F

.f.o: ; $(F77) $(FFLAGS) -c $*.f

# make the user files

userreadmas.c: readmas.mdf
	$(BIN)/mdf2c -m readmas.mdf > userreadmas.c

# create the necessary executable

phdf2txt: phdf2txt.o
	$(F77) $(LDFLAGS) -o $@ phdf2txt.o $(HDFLIBS)

pinfo: pinfo.o
	$(F77) $(LDFLAGS) -o $@ pinfo.o $(HDFLIBS)

pinterp: pinterp.o
	$(F77) $(LDFLAGS) -o $@ pinterp.o $(HDFLIBS)

read_mas_density: read_mas_density.o userreadmas.o csubs.o
	$(CC) $(DXABI) $(LDFLAGS) -o $@ read_mas_density.o \
	userreadmas.o csubs.o \
        $(DX_RTL_LDFLAGS) $(SYSLIBS) -L$(HDF)/lib/ -lmfhdf -ldf -ljpeg -lz
#	cp readmas readmas.mdf $(SPDX)/spdx-dist/modules/

readmas: readmas.o userreadmas.o csubs.o
	$(CC) $(DXABI) $(LDFLAGS) -o $@ readmas.o userreadmas.o csubs.o \
        $(DX_RTL_LDFLAGS) $(SYSLIBS) -L$(HDF)/lib/ -lmfhdf -ldf -ljpeg -lz
	cp readmas readmas.mdf $(SPDX)/spdx-dist/modules/

tstmas: tstmas.o csubs.o
	$(CC) -o $@  tstmas.o csubs.o \
	-L$(HDF)/lib/ -lmfhdf -ldf -ljpeg -lz

clean:
	- rm *.o

distclean: clean
	- rm readmhdhdf readmhdhdfdbl readmhdhdf53 readmhdhdfdbl53 
	- rm lastclosed lastcloseddbl lastclosed53 lastcloseddbl53 




