/* revorder.c
 * -----------------------------------------------------------------------------
 * Reverse byte order.
 * -----------------------------------------------------------------------------
 * Andrew L. Stanger   HAO/NCAR   17 Feb 2003
 * -----------------------------------------------------------------------------
 */

void
revorder (unsigned char * buf, int nelem, int nbyelem)

/* buf:         array
 * nelem:       # elements in array
 * nbyelem:     # bytes per element
 */

{
    int ib, ie ;
    unsigned char *org ;
    unsigned char rev [8] ;

    for (ie = 0; ie < nelem; ie++)	/* Elements loop. */
        {
	org = buf + ie * nbyelem ;
        for (ib = 0; ib < nbyelem; ib++)	/* Copy in reverse order. */
	    {
	    rev [ib] = *(org + nbyelem - ib - 1) ;
	    }

        for (ib = 0; ib < nbyelem; ib++)	/* Copy back to original. */
	    {
	    *(org + ib) = rev [ib] ;
	    }
        }
}
