/* get_cmap.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Fetch SGI color look-up table values.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 30 October 1991
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <gl/gl.h>

get_cmap (begindex, numindex, red, green, blue)

int begindex;		/* starting index value for color LUT. */
int numindex;		/* # consecutive entries. */
unsigned char red [];		/* Red intensities. */
unsigned char green [];		/* Green intensities. */
unsigned char blue [];		/* Blue intensities. */

{
   int ic;
   Colorindex im;
   short rcomp, gcomp, bcomp;

   noport ();
   foreground ();
   winopen ("map");

   for (ic = 0; ic < numindex; ic++)
      {
      im = (Colorindex) (ic + begindex);
      getmcolor (im, &rcomp, &gcomp, &bcomp);

      red [ic]   = (unsigned char) rcomp;
      green [ic] = (unsigned char) gcomp;
      blue [ic]  = (unsigned char) bcomp;
      }

   gexit ();
   return (0);
}
