/* loadlut.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Load SGI color look-up tables.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 8 March 1991
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <gl/gl.h>

loadlut (begindex, numindex, r, g, b)

int begindex;		/* starting index value for color LUT. */
int numindex;		/* # consecutive entries. */
short r [], g [], b [];	/* arrays containing Red/Green/Blue color intensities.*/
{
   Colorindex it;		/* Colorindex = unsigned short. */
   int ic;
   short red, green, blue;

   noport ();
   foreground ();
   winopen ("map");

   for (ic = 0; ic < numindex; ic++)
      {
      it = ic + begindex;
      red   = (short) r [ic] & 0xff;
      green = (short) g [ic] & 0xff;
      blue  = (short) b [ic] & 0xff;
/*      printf ("loadlut> %d %3d %3d %3d\n", it, r [ic], g [ic], b [ic]); */
      mapcolor (it, red, green, blue);
      }
   gexit (0);
   return (0);
}
