/* put_cmap.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Write SGI color look-up table values.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 *  7 September 1993
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <gl/gl.h>

put_cmap (begindex, numindex, red, green, blue)

int begindex;			/* starting index value for color LUT. */
int numindex;			/* # consecutive entries. */
unsigned char red [];		/* Red intensities. */
unsigned char green [];		/* Green intensities. */
unsigned char blue [];		/* Blue intensities. */

{
   int ic;
   Colorindex im;
   short rcomp, gcomp, bcomp;

   noport ();
   foreground ();
   winopen ("map");

   for (ic = 0; ic < numindex; ic++)
      {
      im = (Colorindex) (ic + begindex);

      rcomp = (short) (red   [ic] & 0377);
      gcomp = (short) (green [ic] & 0377);
      bcomp = (short) (blue  [ic] & 0377);

      mapcolor (im, &rcomp, &gcomp, &bcomp);
      }

   gexit (0);
   return (0);
}
