/* put_scmap.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Write SGI color look-up table values.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 *  7 September 1993
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <gl/gl.h>

put_scmap (begindex, numindex, red, green, blue)

int begindex;			/* starting index value for color LUT. */
int numindex;			/* # consecutive entries. */
unsigned short red [];		/* Red intensities. */
unsigned short green [];	/* Green intensities. */
unsigned short blue [];		/* Blue intensities. */

{
   int ic;
   Colorindex im;
   short rcomp, gcomp, bcomp;

   noport ();
   foreground ();
   winopen ("map");

   for (ic = 0; ic < numindex; ic++)
      {
      im = (Colorindex) (ic + begindex);

      rcomp = (short) (red   [ic] & 0377);
      gcomp = (short) (green [ic] & 0377);
      bcomp = (short) (blue  [ic] & 0377);

      mapcolor (im, rcomp, gcomp, bcomp);
      gflush ();
      }

   gexit ();
   return (0);
}
