/* savelut.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Save SGI color look-up table to a disk file.
 * Load saved color table file by using "clut".
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 30 October 1991
 * 13 October 1992: append ".lut" to filename.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

main (argc, argv)

int argc;
char *argv [];

{
   int i;
   int idot = -1;
   int begindex = 512;				/* offset for start of map. */
   int numindex = 256;				/* # entries in color map. */
   static unsigned char r [256];		/* Red color intensities. */
   static unsigned char g [256];		/* Green color intensities. */
   static unsigned char b [256];		/* Blue color intensities.*/
   static char namemap [80];			/* Colormap filename. */
   FILE *MAP;


   /*** Fetch command line argument (if present). ***/

   if (argc < 2)
      {
      fprintf (stderr, "usage: %s colormap_filename\n", argv [0]);
      exit (-1);
      }
   else
      strcpy (namemap, argv [1]);

   /*** Append ".lut" to namemap (unless it is the current suffix). ***/

   for (i = 0; i < strlen (namemap); i++)
      if (namemap [i] == '.')  idot = i;
   if ((idot == -1) || (strcmp (&namemap [idot], ".lut") != 0))
         strcat (namemap, ".lut");

   /*** Retrieve colormap values from logical table #2 (offset = 512). ***/

   get_cmap (begindex, numindex, r, g, b);

   /*** Write colormap information to disk file. ***/

   if ((MAP = fopen (namemap, "w")) == NULL)
      {
      fprintf (stderr, "Unable to create file: %s\n", namemap);
      exit (-2);
      }

   for (i = 0; i < numindex; i++)
      {
      fprintf (MAP, "%3d %3d %3d %3d\n", i, r [i], g [i], b [i]);
      }
   fclose (MAP);

   exit (0);
}
