/* tstpat.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *** Generate Grinnell test pattern image for hue/exposure tests.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger
 * 24 May 1983: 11/34 IDL code written.
 * 27 July 84 -> 19 February 1985: converted from 11/34 (IDL) to VAX 750 (C).
 * 14 May 1985
 * 10 December 1986: reverse order of top & bottom patterns.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <grin.h>

main()

{

#define nx 14
#define ny 102
#define nxc 168
#define nyc 14

int lgrdev = 0;	/* Grinnell device number. */
int ich = 0;	/* Channel number. */
u_char a[nyc*nxc];
u_char b[ny*nx];
u_char c[ny*nx];
u_char d[nyc*nxc];
u_char aval, bval, cval, dval;
int na, nb, nc, nd;
int lh, lv;
int ix, iy;
int i, l;
int ix1, ix2, ix3, ix4;
int iy1, iy2, iy3, iy4;

   printf ("Enter Grinnell Device [0,1]: ");
   scanf  ("%d", &lgrdev);
   if(lgrdev == 0)  printf ("Enter Grinnell channel [0,1,2]: ");
   	else printf ("Enter Grinnell channel [0,1,2,3]: ");
   scanf  ("%d", &ich);

/* Initialize grinnell, erase specified image and all overalys. */

   gr_start(lgrdev);	/* Allocate Grinnell 'lgrdev'. */
/*   gsave(); */		/* Save Grinnell status. */
   init();		/* Initialize Grinnell. */
   disp(ich);		/* Display channel 'ich'. */
   rwech(ich);		/* Set read/write/erase channel to 'ich'. */
   gr_erase(ich);	/* Erase channel 'ich'. */

/* Define dimensions of color bar arrays. */

   na = nxc*nyc;
   nb = nx*ny;
   nc = nx*ny;
   nd = nxc*nyc;

/* Create top and bottom color bars. */

   l = 0;

   for (lh = 0; lh < 3; lh++)
     {
     ix = (lh * (nxc + 2)) + 1;
     for (lv = 0; lv < 8; lv++)
       {
       l = l + 1;
       aval = (u_char) (l+192);
       dval = (u_char) (l+216);
       for (i = 0; i < na; i++)
         {
         a[i] = aval;
         d[i] = dval;
         }
       iy1 = (127 - lv * (nyc+2));
       iy4 = (510 - lv * (nyc+2));
       if (lh == 1)
         {
         iy1 = ((lv+1) * (nyc+2)) -   1;
         iy4 = ((lv+1) * (nyc+2)) + 382;
         }
       wboxb (a,ix,iy1,nxc,nyc,"rd");
       wboxb (d,ix,iy4,nxc,nyc,"rd");
       printf ("lh:%d lv:%d ix:%d iy1:%d iy4:%d\n", lh, lv, ix, iy1, iy4);
       } 
    }

/* Create middle two color bands. */
        
   iy2 = 247;
   iy3 = 367;

   for (l = 0; l < 32; l++)
     {
     bval = (u_char) (l+129);
     cval = (u_char) (l+161);
     for (i = 0; i < nb; i++)
       {
        b[i] = bval;
        c[i] = cval;
       }
     ix2 = l * (nx+2) + 1;
     ix3 = 513 - (nx+2) - ix2;
     wboxb (b,ix2,iy2,nx,ny,"rd");
     wboxb (c,ix3,iy3,nx,ny,"rd");
     printf ("l:%d ix2:%d iy2:%d ix3:%d iy3:%d \n", l, ix2, iy2, ix3, iy3);
     } 

/* Draw border around image. */

   wvec (0,0,0,511);
   wvec (0,511,511,511);
   wvec (511,511,511,0);
   wvec (511,0,0,0);

/* Restore previous Grinnell status. */
/*
 *  grestore();
 */
}
