/* wrlincol.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Make R/G/B color tables and write to both a disk file & the IRIS.
 * Use maximum range of color over range of numerical levels specified.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger
 * 28 April 1989: swrmaxcol
 * 25 June 1990: add mid-range control point.
 *  8 March 1991: adapt for SGI Iris.
 * 30 December 1992: linear color scale.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

main ()

{
static short red [256], green [256], blue [256];
static char namfil [] = "lincol.lut";
int i;					/* general purpose index counter. */
int delta1, minval1, maxval1;
int delta2, minval2, maxval2;
int delta3, minval3, maxval3;
FILE *FD;

   /*** Set RGB values for image. ***/

   minval1 =   0;
   minval2 =   0;
   minval3 =   0;
   maxval1 = 255;
   maxval2 = 255;
   maxval3 = 255;

   fprintf (stderr, "Enter min & max values for red   : ");
   fscanf  (stdin,  "%d,%d,%d", &minval1, &maxval1);
   fprintf (stderr, "Enter min & max values for green : ");
   fscanf  (stdin,  "%d,%d,%d", &minval2, &maxval2);
   fprintf (stderr, "Enter min & max values for blue  : ");
   fscanf  (stdin,  "%d,%d,%d", &minval3, &maxval3);

   if (maxval1 > 255)  maxval1 = 255;
   if (maxval2 > 255)  maxval2 = 255;
   if (maxval3 > 255)  maxval3 = 255;

   for (i = 0; i < minval1; i++) red [i] =    0;
   for (i = 0; i < minval2; i++) green [i] =  0;
   for (i = 0; i < minval3; i++) blue [i] =   0;

   delta1 = maxval1 - minval1 + 1;
   for (i = minval1; i <= maxval1; i++)
      red [i] =
	 ((short) (((float) (i - minval1) / (float) delta1) * 125.0) & 0377);

   delta2 = maxval2 - minval2 + 2;
   for (i = minval2; i <= maxval2; i++)
      green [i] =
	 ((short) (((float) (i - minval2) / (float) delta2) * 125.0) & 0377);

   delta3 = maxval3 - minval3 + 3;
   for (i = minval3; i <= maxval3; i++)
      blue [i] =
	 ((short) (((float) (i - minval3) / (float) delta3) * 125.0) & 0377);

   /*** Annotation levels. ***/

/*
   red [250] =  255;  green [250] =  255;  blue [250] =    0;

   red [251] = green [251] = blue [251] = 125;

   red [252] =    0;  green [252] =    0;  blue [252] =  255;

   red [253] =    0;  green [253] =  255;  blue [253] =    0;

   red [254] =  255;  green [254] =    0;  blue [254] =    0;

   red [255] =  255;  green [255] =  255;  blue [255] =  255;
 */

   /*** Create color table file and fill with red, green & blue arrays. ***/

   if ((FD = fopen (namfil, "w")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", namfil);
      exit (-1);
      }

   for (i = 0; i < 256; i++)
      fprintf (FD, "%3d %3d %3d %3d\n", i, red [i], green [i], blue [i]);

   fclose (FD);

   exit (0);
}
