pro correl, m, y, r, py, pp, c, w
; program for correlation of PES & LISS Data, SP201-03
; arrays are 239,558 bytes (elements) long

m=getspartan('T95_MET')		; Mission Elapsed Time (WLC)
m=m/3600.			; convert MET to hours
y=getspartan('T95_YFP')		; LISS 1 Yaw Fine Position
r=getspartan('T95_RFP')		; LISS 1 Roll Fine Position
py=getspartan('T95_PESY')	; PES Yaw
pp=getspartan('T95_PESP')	; PES Pitch
c=getspartan('T95_CSP')		; LISS CSP = Yes if value > 2000
w=getspartan('T95_LWLC')	; LISS 2 Active if > 255

j=30001

met1 = dblarr(j)
met2 = dblarr(j)
met3 = dblarr(j)
l1yaw = fltarr(j)
l1roll = fltarr(j)
l2yaw = fltarr(j)
l2roll = fltarr(j)
pesyl1 = fltarr(j)
pespl1 = fltarr(j)
pesyl2 = fltarr(j)
pespl2 = fltarr(j)

for i=0,30000 do begin
  case 1 of
    (c(i) GE 2000) AND (W(i) LE 50.0): begin		; LISS 1 Control
	met1(i)= m(i)
	l1yaw(i)= y(i)
	l1roll(i)=r(i)
	pesyl1(i)=py(i)
	pespl1(i)=pp(i)
				       end
    (c(i) GE 2000) AND (W(i) GE 250.0): begin		; LISS 2 Control
	met2(i)= m(i)
	l2yaw(i)= y(i)
	l2roll(i)=r(i)
	pesyl2(i)=py(i)
	pespl2(i)=pp(i)
				        end
    else: met3(i)=m(i)
  endcase
endfor

set_plot, 'x'
plot, met1, l1yaw
plot, met2, l2yaw

;!fancy=2
;!p.title='SP201-03 WLC, September, 1995'
;!x.title='MET, hours'
;
;!y.title='YFP, arcsec'
;set_plot,'ps'
;device,filename='yfp_1.ps'
;plot,m,y,xrange=[0,3],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='yfp_2.ps'
;plot,m,y,xrange=[3,6],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='yfp_3.ps'
;plot,m,y,xrange=[6,9],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='yfp_4.ps'
;plot,m,y,xrange=[9,12],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='yfp_5.ps'
;plot,m,y,xrange=[12,15],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='yfp_6.ps'
;plot,m,y,xrange=[15,18],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='yfp_7.ps'
;plot,m,y,xrange=[18,21],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='yfp_8.ps'
;plot,m,y,xrange=[21,24],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='yfp_9.ps'
;plot,m,y,xrange=[24,27],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='yfp_10.ps'
;plot,m,y,xrange=[27,30],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='yfp_11.ps'
;plot,m,y,xrange=[30,33],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='yfp_12.ps'
;plot,m,y,xrange=[33,36],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='yfp_13.ps'
;plot,m,y,xrange=[36,39],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='yfp_14.ps'
;plot,m,y,xrange=[39,42],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='yfp_15.ps'
;plot,m,y,xrange=[42,45],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;!y.title='RFP, arcsec'
;device,filename='rfp_1.ps'
;plot,m,r,xrange=[0,3],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='rfp_2.ps'
;plot,m,r,xrange=[3,6],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='rfp_3.ps'
;plot,m,r,xrange=[6,9],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='rfp_4.ps'
;plot,m,r,xrange=[9,12],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='rfp_5.ps'
;plot,m,r,xrange=[12,15],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='rfp_6.ps'
;plot,m,r,xrange=[15,18],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='rfp_7.ps'
;plot,m,r,xrange=[18,21],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='rfp_8.ps'
;plot,m,r,xrange=[21,24],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='rfp_9.ps'
;plot,m,r,xrange=[24,27],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='rfp_10.ps'
;plot,m,r,xrange=[27,30],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='rfp_11.ps'
;plot,m,r,xrange=[30,33],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='rfp_12.ps'
;plot,m,r,xrange=[33,36],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='rfp_13.ps'
;plot,m,r,xrange=[36,39],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='rfp_14.ps'
;plot,m,r,xrange=[39,42],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;device,filename='rfp_15.ps'
;plot,m,r,xrange=[42,45],yrange=[-100,100]
;oplot,m,c
;oplot,m,w
;device,/close
;
;set_plot,'x'

end
