;+ --------------------------------------------------------------------------- +
; NAME:  
;	CPINIT
;
; PURPOSE:   
;	Initializes variable for CP (IDL procedure).
;
; CATEGORY:
;	CP initialization
;
; CALLING SEQUENCE:
;	CPINIT
;
; CALLED BY:  
;	CP.PRO
;
; CALLS TO:  
;	none
;
; INPUTS: 
;	none
;
; OPTIONAL INPUTS: 
;	none
;
; OUTPUTS: 
;	none
;
; OPTIONAL OUTPUTS: none
;
; COMMON BLOCKS: 
;	cp_img.common
;	cp_date.common
;
; SIDE EFFECTS: 
;	none
;
; RESTRICTIONS:
;	none
;
; PROCEDURE:
;	Sets variables in  cp_img & cp_date common blocks to be	1-dimensional
;	arrays, with 2-elements (to allow for difference images).
;
; MODIFICATION HISTORY:
;	31 March 1993 - Andrew L. Stanger (HAO/NCAR)
;- --------------------------------------------------------------------------- -

pro cpinit

@cp_img.common
; COMMON cp_img, nbypx, npx, npy, ifw, ipw, ism, iexp, ires, icm, iroll, iframe,
;                xcen, ycen, pixrs

@cp_date.common
; COMMON cpdate, iyear, idoy, imonth, iday, ihour, iminute, isecond

   nbypx   = intarr (2)
   npx     = intarr (2)
   npy     = intarr (2)
   ifw     = intarr (2)
   ipw     = intarr (2)
   ism     = intarr (2)
   iexp    = intarr (2)
   ires    = intarr (2)
   icm     = intarr (2)
   iroll   = intarr (2)
   iframe  = intarr (2)
   xcen    = fltarr (2)
   ycen    = fltarr (2)
   pixrs   = fltarr (2)

   iyear   = intarr (2)
   idoy    = intarr (2)
   imonth  = intarr (2)
   iday    = intarr (2)
   ihour   = intarr (2)
   iminute = intarr (2)
   isecond = intarr (2)

return
end
;- --------------------------------------------------------------------------- -
