;+ -----------------------------------------------------------------------------
;  cpinterp.pro :   IDL procedure
;+ -----------------------------------------------------------------------------
;  Linear interpolation.
;+ -----------------------------------------------------------------------------
;  Andrew L. Stanger   HAO/NCAR
;  25 March 1993
;+ -----------------------------------------------------------------------------
;  ival: short integer array
;  ibeg: beginning index.
;  iend: endind index.
;  vbeg: beginning value.
;  vend: ending value.
;+ -----------------------------------------------------------------------------

pro cpinterp, ival, ibeg, iend, vbeg, vend

   for i = ibeg, iend do $
   begin
      ival (i) = fix (((i - ibeg) / float (iend - ibeg)) * (vend - vbeg) + vbeg)
   end

   return
end

