/* date_conv.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Date conversion routines.
 * C programming language.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

 
static int day_tab[2][13] =
	{
	{0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},
	{0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},
	};

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

day_of_year (year, month, day)	/* Return day-of-year from month & day. */

int year, month, day;

{
	int i, leap;

	leap = (year % 4 == 0  &&  year % 100 != 0  ||  year % 400 == 0);

	for (i=1; i < month; i++)
		day += day_tab[leap][i];

	return (day);
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

month_day (year, doy, pmonth, pday)	/* Set month & day from day-of-year. */

int year, doy, *pmonth, *pday;

{
	int i, leap;

	leap = (year % 4 == 0 && year % 100 != 0 || year % 400 == 0);

	for (i = 1; doy > day_tab[leap][i]; i++)
		doy -= day_tab[leap][i];

	*pmonth = i;
	*pday = doy;

	return;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

char *
month_name (n)	/* Return name of n-th month. */

int n;

{
	static char *name[] =
		{
		"BAD",
		"JAN",
		"FEB",
		"MAR",
		"APR",
		"MAY",
		"JUN",
		"JUL",
		"AUG",
		"SEP",
		"OCT",
		"NOV",
		"DEC"
		};

	return ((n < 1 || n > 12) ? name[0] : name[n]);

}
