/* rdfimg(namimg)
 * . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
 * Read floating-point SMM C/P image from disk file into memory array.
 * . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
 * Solar Maximum Mission   Coronagraph/Polarimeter
 * Andrew L. Stanger
 * 5 November 1986
 */

#include <stdio.h>
#include "/u/stanger/smm/cpsize.h"
#include "/u/stanger/smm/hskp.h"

struct	hskp	H;

char	*malloc();	/* System allocation function. */

/* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

char	*
rdfimg(namimg)

char  *namimg;	/* Pointer to image disk file name. */

{
register   char	*image;	/* Pointer to image array. */
register   int	imgfd;	/* File descriptor for image disk file. */
register   int	imgsiz; /* Image size (bytes) (excluding hskp & bitmap). */
register   long	nread;

/* Decommutate Housekeeping. */

   cphskp(namimg);	

/*   printf("rdfimg> npix: %d nbypix: %d\n", npix, nbypix); */

/* Open image file. */

   if((imgfd = open(namimg, 0)) < 0)
     { fprintf(stderr,"rdfimg> Can't open file %s\n", namimg);  return(NULL); }

/* Position I/O pointer to beginning of video data in image disk file. */

   if (lseek(imgfd,(long)(npix*2),0) == -1)
      { fprintf(stderr,"rdfimg> seek error.\n");  return(NULL); }

   imgsiz = (npix*npix*nbypix);
   if((image = malloc(imgsiz)) == NULL)
     {  fprintf(stderr,"rdfimg> malloc error.");
        exit(1);
     }

   if ((nread = read(imgfd, image, imgsiz)) <= 0)
      { fprintf(stderr,"rdfimg> image read error.\n");  return(NULL); }

/*   printf("rdfimg> nread: %d\n", nread); */

   if (close(imgfd) == -1)
      { fprintf(stderr,"rdfimg> file close error.%s\n", namimg);  return(NULL);}
  return(image);
}
