/* smm_avg (image)
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Convert an SMM C/P image from high to low resolution.
 * . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
 * Rose Reynolds   HAO/NCAR   SMM C/P   (extracted from 'smmsubs.c'.)
 * 29 August 1984
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

smm_avg (image)

char *image;	/* Pointer to image array. */

{
register char *bl, *bl1, *rbim;
register u_short  *il, *il1, *rim;
int i,j,size;
int temp;

	size = SMM_dim * SMM_dim / 4;

/* One byte per pixel. */

	if( H.nbypix == 1 )
	   {
		bl = image;
		rbim = image;
		for(i=0; i<SMM_dim; i+=2)
		   {
		   bl1 = bl + SMM_dim;
		   for(j=0; j<SMM_dim; j+=2)
			{
			temp = ((*bl++)&0377) + ((*bl1++)&0377) +
				((*bl++)&0377) + ((*bl1++)&0377);
				*rbim++ =  temp/4 ;
			}
		   bl = bl1;
		   }
		return( 0 );
	   }

	else 

/* 2 bytes per pixel. */

	   {
		il = (u_short *) image;
		rim = (u_short *) image;
		for(i=0; i<SMM_dim; i+=2)
		   {
		   il1 = il + SMM_dim;
		   for(j=0; j<SMM_dim; j+=2)
			{
			*rim++ = (*il++ + *il++ + *il1++ + *il1++)/4;
			}
		   il = il1;
		   }
		return( 0 );
	   }
}
