/* swap.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Swap bytes in SMM C/P calbrated images for use on
 * Integrated Solutions machines.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#define npix 448

main()
{
char namcal[80];
char namswp[80];
short hk[npix];
short bm[npix];
short imgcal[npix*npix];

short pixhi, pixlo;
int idot;
int nbyrec;
int nelem;
int nbyimg;
int fdcal, fdswp;
int i;

   printf ("Enter calibrated image file name : ");
   scanf ("%s", namcal);

/* Derive output file name from input image name. */

   idot = -1;
   for (i=0; i<strlen(namcal); i++) if (namcal[i] == '.')  idot = i;
   if (idot < 0)  idot = strlen(namcal) - 1;
   strcpy (namswp, namcal);
   namswp[idot] = '.';
   namswp[idot+1] = 's';
   namswp[idot+2] = 'w';
   namswp[idot+3] = 'p';
   namswp[idot+4] = '\0';
   printf ("idot: %d\n", idot);
   printf ("namswp: %s\n", namswp);

/* Open calibrated image file. */

   nbyrec = npix * sizeof(short);
   nelem = npix*npix;
   nbyimg = nelem * sizeof(short);

   if ((fdcal = open (namcal, 0)) <= 0)
      {
      printf ("Invalid file: %s  fdcal:%d\n", namcal, fdcal);
      exit (-1);
      }

/* Open output file. */

   fdswp = creat (namswp, 0644);
   close (fdswp);
   if ((fdswp = open (namswp, 1)) <= 0)
      {
      printf ("Invalid file: %s  fdswp:%d\n", namswp, fdswp);
      exit (-1);
      }

/* Read housekeeping & bitmap records. */

   read (fdcal, hk, nbyrec);
   read (fdcal, bm, nbyrec);

/* Write housekeeping & bitmap records to output file. */

   write (fdswp, hk, nbyrec);
   write (fdswp, bm, nbyrec);

/* Read calibrated image into memory. */

   read (fdcal, imgcal, nbyimg);

/* Swap bytes and write to output file. */

   for (i=0; i<nelem; i++)
      {
      pixhi = (imgcal[i] & 0177400) >> 8;
      pixlo = (imgcal[i] &    0377) << 8;
      imgcal[i] = (pixlo | pixhi);
      }
   write (fdswp, imgcal, nbyimg);

   close (fdcal);
   close (fdswp);
}
