      program ajack
c***
c*** Compute absolute values for parameters, not normalized ones.
c***
c
      data lun/10/
c
      dt = 5.0
      nang = 14
      u = .40
      pi = acos(-1.0)
      degrad = pi/180.0
      const = 1.2478e-25/(1.-u/3.)
      nrad = 30
      deltax = 0.25
      x = 1.00
c
      open (unit=lun,file='ajack.dat',status='new',access='sequential')
      write (lun, 11)
   11 format ('Jack: Computes Bt, Br, polarization, pB.')
c
      do 60 l = 1, nrad
         x = x + deltax
         write (lun, 12) x
   12    format (/10x,'------- Impact parameter: ', f6.2,
     .   ' solar radii -------'/
     .   1h , 4x, 'angle   B (tan)  B (rad)', 5x, 'B', 7x, 'pol',
     .   6x, 'pB', 6x, 'distance')
         rho2 = x*x
         t = 0.
c
         do 50 i = 1, nang
            r = x/cos(t*degrad)
            s = 1./r
            s2 = s*s
            c2 = 1. - s2
            c = sqrt(c2)
            g = alog((1.+s)/c)
            ar = c*s2
            cr = 4./3.-c-(c*c2/3.)
            bf = -(1.-3.*s2-c2*(1.+3.*s2)*g/s)/8.
            dr = (5.+s2-c2*(5.-s2)*g/s)/8.
            tt = (1.-u)*cr+u*dr
            tr = rho2*((1.-u)*ar+u*bf)/(r*r)
            q = tt-tr
            w = tt+q

            bt = tt
            pb = tr
            br = q
            b = w
            pol = tr/w

            if (t .ne. 0.) go to 15
            tt = const*tt
            tr = const*tr
            q = tt-tr
            w = tt+q
            b1 = w
            pb1 = tr

   15       write (lun, 16) t, bt, br, b, pol, pb, r
   16       format (1h , f10.5, 4f9.5, f10.5, f10.3)
            t = t + dt
   50    continue
c
         write (lun,51) b1, pb1
   51    format (1h /1h ,
     .   '  brightness of one electron in plane of sky =',
     .   1pe15.3/1h , 42x, 'pB =', e15.3)
   60    continue
c
         close (lun)
         stop
         end
