      program cpden
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c*** Image Density program for SMM C/P images.
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c Andrew L. Stanger   HAO/NCAR   SMM C/P
c 25 September 1986
c . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
      parameter (npmax = 896, ncmax = 112)
      implicit integer (u)
      common /center/ ixcen, iycen
      common /hskdat/ ires, ip, ir, lp, lr, ifw, ism, ipw
      common /size/   npix, npix4, nbypix, idtype
      common /cor/ lvs, lfc
c
      character*32 namimg
      character*12 namemc
      character*12 namden
      integer image (npmax, npmax)
      integer o644
      real bk (ncmax, ncmax)
      real bmin, bmax, binc
c
      data o644/o'644'/
      data namemc /'cpden.mc'/
      data namden /'cpden.den'/
      data lvs/1/, lfc/0/
      data lunden/11/
c . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
      write(*,5)
    5 format(1x,'Enter image file name: ',$)
      read (*,6) namimg
    6 format(a32)
c
      call rdimg (image, namimg)
c
      write (*,*) 'Image contents: (80-89,56)'
      write (*,15) (image(i,56),i=80,89)
   15 format (1x,10i7)
c
c--- Convert intensity to density.
c
      call imgden (image,bk,nx,ny,bmin,bmax)
c
c--- Write image to disk file.
c
      lunden = ucreat(namden,o644)
      nclose = uclose (lunden)
      lunden = uopen (namden, 1)
      if (lunden .le. 0)  then
         write (*,17) lunden
   17    format(1x,'Invalid image file name: ',a12)
         stop
      endif
      nbytes = 112 * 112 * 4
      nwrite = uwrite (lunden,bk,nbytes)
      nclose = uclose (lunden)
c
c--- Contour image.
c
      bmin = 1.e+16
      bmax = 1.e+19
      binc = 5.e+16
      write (*,*) 'bmin,bmax,binc: ',bmin,bmax,binc
      call q8qini (namemc, .false.)
      call conrec (bk, ncmax, nx, ny, bmin, bmax, binc, 0, -1, 0)
      call frame
c
      stop
      end
