      subroutine cphskp(lhk,namfil)
c--------------------------------------------------------------------------
c*** Decommutate selected items from SMM C/P housekeeping record.
c--------------------------------------------------------------------------
c    Andrew L. Stanger   HAO/NCAR   SMM C/P
c    30 September 1986
c    3 December 1986: add roll change for SMM #2; add common area 'gmt'.
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      implicit integer (u)
      common /center/ ixcen, iycen
      common /const/  pi, raddeg, degrad, pixr, rpix, rsun
      common /gmt/ iyear, idoy, ihour, imin, isec
      common /hskdat/ ires, ip, ir, lp, lr, ifw, ism, ipw, iroll
      common /size/   npix, npix4, nbypix, idtype
c
      character*32 namfil
      character*2 namres(2), namstw(4)
      character*4 npw, ncm, nampw(4), namcm(4)
      character*8 nfw, nsm, namfw(8), namsm(9)
      character*1 hskp(288)
      real vidcen(2,9), ww6cen(2,9)
      integer lih(4), liv(4)
      integer ihskp(288)
      integer met, met1, met2, met3
      integer o16, o17, o60, o74, o300, o360, o377, mskrol, o37
c
c... Disk centers (vs. sector mirror) for raw vidicon data (v34520).
c    (no geometric correction applied.)
c
      data vidcen/ 36.3, 499.8,                                         sw
     *            213.1, 193.6,                                         s
     *            539.9,   3.3,                                         se
     *            820.0,  87.0,                                         e
     *            892.4, 361.5,                                         ne
     *            718.6, 679.3,                                         n
     *            386.7, 856.4,                                         nw
     *            104.3, 792.1,                                         w
     *            447.0, 447.0/                                         n+e+s+w
c
c... Disk centers (vs. sector mirror) for calibrated data (c34520)
c    processed with geometric correction ww6cor.
c
      data ww6cen/ 47.9, 507.5,                                         sw
     *            222.2, 205.6,                                         s
     *            529.7,  40.3,                                         se
     *            814.6,  85.4,                                         e
     *            884.0, 353.4,                                         ne
     *            714.8, 671.1,                                         n
     *            393.2, 824.1,                                         nw
     *            113.6, 786.4,                                         w
     *            447.0, 447.0/                                         n+e+s+w
c
      data nch/32/
      data namres/1hh,1hl/
      data namfw/3hred,6hhalpha,5hclear,4hblue,6hwidebd,5hgreen,
     *           1h ,1h /
      data namsm/2hsw,5hs:unf,2hse,5he:2.0,2hne,5hn:mtf,2hnw,5hw:0.0,
     *           4hnesw/
      data nampw/3hclr,3h+60,3h-60,3h0dg/
      data namstw/1hm,1ha,1hs,1hf/
      data namcm/3hmov,3hout,3h in,3hbad/
      data o16/o'16'/, o17/o'17'/, o60/o'60'/, o74/o'74'/ 
      data o300/o'300'/, o360/o'360'/, o377/o'377'/
      data mskrol/o'37777777740'/, o37/o'37'/
      data pi /3.141592654/
c * arcseconds per solar radius.
      data secrad /961./
c * arcseconds per pixel (Hi res).
      data secpix /5.933/
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
c... Verify proper form for image file name.
c
      do 10 i = 1, nch
        iext = i + 1
        if(namfil(i:i) .eq. '.')  go to 15
   10 continue
      write (*,11)
   11 format(1x,'invalid file name . . . need extension')
      nch = 0
      return
c
   12 write (*,13) namfil
   13 format(1x,'Error trying to open file : ',a32)
      return
c
c... Open image file.
c... Read housekeeping record.
c
   15 lhk = uopen(namfil, 0)
      if (lhk .le. 0)  write(*,16) lhk
   16 format(1x,'cphskp> uopen error ... lhk: ',i3)
      nread = uread(lhk,hskp,288)
      nclose = uclose(lhk)
c
c... Copy housekeeping from character to integer array.
c
      do 20 i = 1, 288
        ihskp(i) = hskp(i)
   20 continue
c
c... Extract essential information from housekeeping record.
c
      iyear = iand(ihskp(1),o377)
      itemp = iand(ihskp(2),o377)
      itemp = itemp * 256
      idoy =  iand(ihskp(3),o377) + itemp
      met1 = iand(ihskp(7),o377)
      met2 = iand(ihskp(8),o377)
      met3 = iand(ihskp(9),o377)
      met  = (met1 * 65536) + (met2 * 256) + met3
      kpw = iand(ihskp(4),o300) / 64
      kres = iand(ihskp(4),4) / 4
      ih = iand(ihskp(10),o360) / 16
      iv = iand(ihskp(10),o17)
      lih(1) = iand(ih,8) / 8
      lih(2) = iand(ih,4) / 4
      lih(3) = iand(ih,2) / 2
      lih(4) = iand(ih,1)
      liv(1) = iand(iv,8) / 8
      liv(2) = iand(iv,4) / 4
      liv(3) = iand(iv,2) / 2
      liv(4) = iand(iv,1)
      itemp = iand(ihskp(11),o377) * 16
      iexp = iand(ihskp(12),o360) / 16 + itemp
c
c--- Roll (degrees).
c    6 m.s.bits of roll register are the 6 m.s.bits of S/C roll (18 bits)
c    6 l.s.bits of roll register are the 6 m.s.bits of S/C time.
c
      isign = iand(ihskp(12),8)/8
c
c... Least significant roll bit (smm#2) = 7.16197 degrees.
c
      if(iyear .ge. 84)  then
        roll = iand(ihskp(12),7)*4 + iand(ihskp(13),o300)/64
        radrol = roll
        if (isign .eq. 1)  radrol = - float(iand((inot(roll)+1),o37))
        rollwt = 7.16197
      endif
c
c... Least significant roll bit (smm#1) = .111906 degrees.
c
      if(iyear .eq. 80)  then
        roll = iand(ihskp(12),7)*256 + iand(ihskp(13),o377)
        radrol = roll
        if (isign .eq. 1)  radrol = - float(iand((inot(roll)+1),o3777))
        rollwt = 0.111906
      endif
c
      roll = radrol * rollwt
c
c* Set roll to closest 10 degrees.
c
      iroll = roll
      if (iroll .gt. 0)  iroll = roll + 7
      iroll = (iroll / 10) * 10
c
      iglpos = iand(ihskp(14),o377)
      kglstw = iand(ihskp(15),o300) / 64
      ksm = iand(ihskp(15),o74) / 4
      kcm = iand(ihskp(16),o60) / 16
      ifw = iand(ihskp(16),o16) / 2
      ihour = iand(ihskp(21),o377)
      imin = iand(ihskp(22),o377)
      isec = iand(ihskp(25),o377)
      itemp = iand(ihskp(31),o377) * 16
      imgcnt = iand(ihskp(32),o360) / 16 + itemp
      imqual = iand(ihskp(80),o377)
c
      ism = (ksm + 1) / 2
      if (ksm .eq. 0)  ism = 9
      ires = kres + 1
      icm  = kcm + 1
      iglstw = kglstw + 1
c
c... Polaroid wheel:
c    ipw = 0 clear
c        = 1 p1 (+60 degrees)
c        = 2 p2 (  0 degrees)
c        = 3 p3 (-60 degrees)
c
      ipw = kpw
      if(kpw .eq. 2)  ipw = 3
      if(kpw .eq. 3)  ipw = 2
c
c... Names for mechanism positions.
c
      nsm = namsm(ism)
      nfw = namfw(ifw)
      npw = nampw(kpw+1)
      ncm = namcm(icm)
      nglstw = namstw(iglstw)
      nres = namres(ires)
c
c... Display instrument configuration on terminal screen.
c
      write (*,31)
   31 format(/1x,'--file name--',1x,'---met--',1x,'-----gmt----',
     * 1x,' %q',1x,' img ',1x,'ih-iv-res',1x,' exp',1x,'  fw  ',
     * 1x,'pol',1x,'5303',1x,' sm  ',1x,'roll',1x,' cm')
c
      write (*,32) namfil,met,iyear,idoy,ihour,imin,
     *         imqual,imgcnt,lih,liv,nres,iexp,nfw,npw,iglpos,
     *         nglstw,nsm,iroll,ncm
   32 format(1x,a13,1x,i8,1x,i2,1h:,i3,1h:,i2,1h:,i2,1x,i3,i6,
     * 1x,8i1,a1,1x,i4,1x,a6,1x,a3,1x,i3,a1,1x,a5,1x,i4,1x,a3)
c
c... Compute start/end pixel/line coordinates for C/P image.
c    (resolution-dependent)
c
      ip = 1
      lp = 896 / ires
      ir = 1
      lr = 896 / ires
      ihs = 0
      ivs = 0
c
      do 40 i = 1, 4
        if(lih(i) .eq. 0 .and. ihs .eq. 0)  ip = ip + 224 / ires
        if(liv(i) .eq. 0 .and. ivs .eq. 0)  ir = ir + 224 / ires
        if(lih(i) .eq. 1)  ihs = 1
        if(liv(i) .eq. 1)  ivs = 1
        if(lih(i) .eq. 0 .and. ihs .eq. 1)  lp = lp - 224 / ires
        if(liv(i) .eq. 0 .and. ivs .eq. 1)  lr = lr - 224 / ires
   40 continue
c
c      write *, 'ip,ir : ', ip, ir, '   lp,lr : ', lp, lr
c
c... idtype : data type.
c             = 1  raw image data (dn units, 0-255).
c             = 2  Txxxxx volume data (equiv. seconds * 5, 0-255).
c             = 3  early calibrated data (10**-12 b/bsun units, 16 bits).
c             = 4  calibrated data (10**-11 b/bsun units, 16 bits).
c    data type is inferred from the first letter of the filename extension.
c
c    a C/P filename has the following format :
c    ydddhhmms.vxx : type 1
c             .txx :      2
c             .wxx :      3
c             .cxx :      4
c    where y = year, 0 => 1980
c          ddd = day-of-year, hh = hour, mm = minute, s = sec/10.
c          x = arbitrary character.
c
      idtype = 4
      if(namfil(iext:iext) .eq. 'v')  idtype = 1
      if(namfil(iext:iext) .eq. 't')  idtype = 2
      if(namfil(iext:iext) .eq. 'w')  idtype = 3
      nbypix = 2
      if(idtype .eq. 1 .or. idtype .eq. 2)  nbypix = 1
c      write (*,*) 'data type: ', idtype
c      write (*,*) nbypix, ' byte(s) per pixel.'
c
c... Look up disk center location according to sector mirror.
c
c--- Raw DN images :
c    (no geometric distortion correction)
c
      if(idtype .ne. 1)  go to 50
        ixcen = vidcen(1,ism) + 0.5
        iycen = vidcen(2,ism) + 0.5
      go to 55
c
c--- Equivalent second and calibrated images :
c    (smmcor and ww6cor geometric corrections) 
c
   50 ixcen = ww6cen(1,ism) + 0.5
      iycen = ww6cen(2,ism) + 0.5
c
   55 npix  = (lp - ip + 1)
      npix4 = npix / 4
c
c--- Set up scale variables.

      raddeg = pi / 180.
      degrad = 180. / pi
      pixr = secrad / (secpix * ires)
      if (ism .eq. 9)  pixr = pixr * 0.5
      rpix = 1. / pixr
c      write(*,*) 'pi: ', pi, ' raddeg: ',raddeg, ' degrad: ',degrad 
c      write(*,*) 'secrad: ',secrad,' secpix: ',secpix
c      write(*,*) 'pixr: ',pixr,' rpix: ',rpix
c
      return
      end
