c * fcorona(r,th)
c * ----------------------------------------------------------------------
c * Determines F-corona for radius r (Rsun units)
c *----------------------------------------------------------------------
c * Andrew L. Stanger   NCAR/HAO   SMM C/P
c * 5 December 1986: F-corona equation taken from ATM/WLC Technical Memo #15.
c * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c * r: radius (R/Rsun).
c * th: position angle (degrees).
c *
      function fcorona (r, th)
      real r
      real th

      real s

c * Scale factor for calibrated images.
      data Cexp / 1.e-11 /

c * Conversion factor: radians / degree.
      data raddeg / 0.017453293 /

c * ------------------------------------------------------------------ *

      s = sin (th * raddeg)
      fcorona = Cexp * 4739.6 * (1.0 + 0.23732 * s*s) *  r**(-2.72375)

      return
      end
