      program jack
c
      data lun/10/
c
      dt = 2.0
      nang = 35
      u = .40
      pi = acos(-1.0)
      degrad = pi/180.0
      const = 1.2478e-25/(1.-u/3.)
      nrad = 25
      x = 1.4
c
      open(unit=lun,file='jack.dat',status='new',access='sequential')
c
      do 8 l = 1,nrad
      x = x + .1
      write(lun,3)
    3 format (///)
      write(lun,1) x
    1 format (/10x,'For impact parameter of',f6.2,' solar radii'/
     .1h ,4x,'angle   B(tan)   B(rad)',6x,'B',7x,'pol',6x,'pB',5x,
     .'distance')
      rho2 = x*x
      t = 0.
c
      do 5 i = 1,nang
      r = x/cos(t*degrad)
      s = 1./r
      s2 = s*s
      c2 = 1. - s2
      c = sqrt(c2)
      g = alog((1.+s)/c)
      ar = c*s2
      cr = 4./3.-c-(c*c2/3.)
      bf = -(1.-3.*s2-c2*(1.+3.*s2)*g/s)/8.
      dr = (5.+s2-c2*(5.-s2)*g/s)/8.
      tt = (1.-u)*cr+u*dr
      tr = rho2*((1.-u)*ar+u*bf)/(r*r)
      q = tt-tr
      w = tt+q
      if (t.gt.0.) go to 4
      ten = w
    4 bt = tt/ten
      pb = tr/ten
      br = q/ten
      b = w/ten
      pol = tr/w
      if (t.ne.0.) go to 9
      tt = const*tt
      tr = const*tr
      q = tt-tr
      w = tt+q
      b1 = w
      pb1 = tr
    9 write(lun,2) t,bt,br,b,pol,pb,r
    2 format(1h ,f10.5,4f9.5,f10.5,f10.2)
      t = t + dt
    5 continue
c
      write(lun,11) b1,pb1
   11 format (1h /1h ,'  brightness of one electron in plane of sky =',
     .1pe15.3/1h ,10x,'pB =',e15.3)
    8 continue
c
      close(lun)
      call exit
      end
