      program xd
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c*** Absolute/Excess image density program for SMM C/P images.
c * Output image is 112x112 real numbers; no housekeeping or bitmap.
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c Andrew L. Stanger   HAO/NCAR   SMM C/P
c 15 October 1986
c . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
      parameter (npmax = 896, ncmax = 112)
      implicit integer (u)
      common /center/ ixcen, iycen
      common /hskdat/ ires, ip, ir, lp, lr, ifw, ism, ipw
      common /size/   npix, npix4, nbypix, idtype
      common /opt/ lsv, lfc, lden, ldif
c
      character*1 type
      character*32 namref
      character*32 namcmp
      character*40 namemc
      character*40 namimg
      integer*2 imgref (npmax, npmax)
      integer*2 imgcmp (npmax, npmax)
      integer o644
      real den (ncmax, ncmax)
      real dmin, dmax, dinc
c
      data o644/o'644'/
      data namemc /'xd.mc'/
      data namimg /'xd.den'/
      data lsv/1/, lfc/0/, lden/0/, ldif/0/
      data lunimg/11/
      data nset /0/
      data nhi /0/
      data ndot /-231/
c . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
      write (*,*) 'Program xd: Excess/Absolute Brightness/Density'
      write (*,1)
    1 format(1x,'Density (d) or Brightness (b) ? '$)
      read (*,2) type
    2 format(a1)
      if (type .eq. 'd')  lden = 1
c
      write (*,3)
    3 format(1x,
     . 'Enter reference image file name (type "none" to omit) : ',$)
      read (*,4) namref
    4 format(a32)
      ldif = 0
      if (namref .ne. 'none')  ldif = 1
c
      write(*,5)
    5 format(1x,'Enter comparison image file name: ',$)
      read (*,6) namcmp
    6 format(a32)
c
c--- Read image(s) into memory.
c
      if (ldif .eq. 1)  call rdimg (imgref, namref)
      call rdimg (imgcmp, namcmp)
c
c--- Convert intensity to columnar density (electrons per cm^2).
c
      if (lden .eq. 1)  then
         write (*,*) 'Computing density . . . please wait.'
      else
         write (*,*) 'Computing intensity . . . please wait.'
      endif
         
      call xden (imgref,imgcmp,den,nx,ny,dmin,dmax)
c
c--- Create output file names for density image and contour metacode.
c
      lastch = 0
      idot = 0
      do 10 i = 1, 32
         namimg(i:i) = namcmp(i:i)
         namemc(i:i) = namcmp(i:i)
         if (namcmp(i:i) .ne. ' ')  lastch = i
         if (namcmp(i:i) .eq. '.')  idot = i
   10 continue
      if (idot .eq. 0)  then
         idot = lastch+1
         namimg(idot:idot) = '.'
         namemc(idot:idot) = '.'
      endif
c
      do 15 i = idot+1,40
         namimg(i:i) = ' '
         namemc(i:i) = ' '
   15 continue
c
      if (lden .eq. 1)  then
         namimg(idot+1:idot+1) = 'd'
         namimg(idot+2:idot+2) = 'e'
         namimg(idot+3:idot+3) = 'n'
      else
         namimg(idot+1:idot+1) = 'b'
         namimg(idot+2:idot+2) = 'r'
         namimg(idot+3:idot+3) = 't'
      endif
c
      namemc(idot+1:idot+1) = 'm'
      namemc(idot+2:idot+2) = 'c'
c
      nlink = unlink (namimg)
      nlink = unlink (namemc)
c
c--- Write image to disk file.
c
      lunimg = ucreat(namimg,o644)
      nclose = uclose (lunimg)
      lunimg = uopen (namimg, 1)
      if (lunimg .le. 0)  then
         write (*,17) lunimg
   17    format(1x,'Invalid image file name: ',a12)
         stop
      endif
      nbytes = ncmax * ncmax * 4
      nwrite = uwrite (lunimg,den,nbytes)
      nclose = uclose (lunimg)
c
c--- Contour image.
c
c      dmin = 1.e+16
c      dmax = 1.e+19
c      dinc = 5.e+16
c
      write (*,*) 'image...min & max values: ',dmin,dmax
      if (dmax .gt. 5.e-8  .and. lden .eq. 0)  dmax = 5.e-8
      if (dmax .gt. 5.e+18 .and. lden .eq. 1)  dmax = 5.e+18
      if (dmin .lt. 0)  then
         if (-dmin .lt. dmax)  then
            dmax = -dmin
         else
            dmin = -dmax
         endif
      endif
c
      dinc = (dmax - dmin) / 50.
      write (*,*) 'contour...dmin,dmax,dinc: ',dmin,dmax,dinc
      write (*,*) 'Computing contour map.'
      call q8qini (namemc, .false.)
      call conrec (den, ncmax, nx, ny, dmin, dmax, dinc,
     .             nset, nhi, ndot)
      call frame
c
      stop
      end
