mogrify(1)							    mogrify(1)



NAME
       mogrify - mogrify an image

SYNOPSIS
       mogrify [ options ... ] file ...


DESCRIPTION
       Mogrify	transforms  an image or a sequence of images. These transforms
       include image scaling, image rotation, color reduction, and others. The
       transmogrified  image  overwrites  the original image, unless an option
       such as -format causes the output filename to  be  different  from  the
       input filename.

       The graphics formats supported by mogrify are listed in ImageMagick(1).

EXAMPLES
       To convert all the TIFF files in a particular directory to JPEG, use:

	   mogrify -format jpeg *.tiff

       To convert a directory full of JPEG images to thumbnails, use:

	   convert -size 120x120 *.jpg -resize 120x120 +profile '*'

       In this example, "-i size 120x120" gives a hint	to  the	 JPEG  decoder
       that  the  images are going to be downscaled to 120x120, allowing it to
       run faster by avoiding returning full-resolution images.	 The  "-resize
       120x120"	 specifies  the	 desired  dimensions of the output images.  It
       will be scaled so its largest dimension is 120 pixels.	The  "+profile
       '*'"  removes  any  ICM,	 EXIF,	IPTC,  or other profiles that might be
       present in the input and aren't needed in the thumbnails.

       To scale an image of a cockatoo to exactly 640 pixels in width and  480
       pixels in height, use:

	   mogrify -resize 640x480! cockatoo.miff

OPTIONS
       Options	are processed in command line order. Any option you specify on
       the command line remains in effect for the set of images that  follows,
       until the set is terminated by the appearance of any option or -noop.

       For a more detailed description of each option, see ImageMagick(1).


       -affine <matrix>
	      drawing transform matrix

       -antialias
	      remove pixel aliasing

       -background <color>
	      the background color

       -blur <radius>x<sigma>
	      blur the image with a gaussian operator

       -border <width>x<height>
	      surround the image with a border of color

       -bordercolor <color>
	      the border color

       -cache <threshold>
	      megabytes of memory available to the pixel cache

       -channel <type>
	      the type of channel

       -charcoal <factor>
	      simulate a charcoal drawing

       -colorize <value>
	      colorize the image with the pen color

       -colors <value>
	      preferred number of colors in the image

       -colorspace <value>
	      the type of colorspace

       -comment <string>
	      annotate an image with a comment

       -compress <type>
	      the type of image compression

       -contrast
	      enhance or reduce the image contrast

       -crop <width>x<height>{+-}<x>{+-}<y>{%}
	      preferred size and location of the cropped image

       -cycle <amount>
	      displace image colormap by amount

       -debug enable debug printout

       -delay <1/100ths of a second>
	      display the next image after pausing

       -density <width>x<height>
	      vertical and horizontal resolution in pixels of the image

       -depth <value>
	      depth of the image

       -despeckle
	      reduce the speckles within an image

       -display <host:display[.screen]>
	      specifies the X server to contact

       -dispose <method>
	      GIF disposal method

       -dither
	      apply Floyd/Steinberg error diffusion to the image

       -draw <string>
	      annotate an image with one or more graphic primitives

       -edge <radius>
	      detect edges within an image

       -emboss
	      emboss an image

       -encoding <type>
	      specify the font encoding

       -endian <type>
	      specify endianness (MSB or LSB) of output image

       -enhance
	      apply a digital filter to enhance a noisy image

       -equalize
	      perform histogram equalization to the image

       -fill <color>
	      color to use when filling a graphic primitive

       -filter <type>
	      use this type of filter when resizing an image

       -flip  create a "mirror image"

       -flop  create a "mirror image"

       -font <name>
	      use this font when annotating the image with text

       -format <type>
	      the image format type

       -frame <width>x<height>+<outer bevel width>+<inner bevel width>
	      surround the image with an ornamental border

       -fuzz <distance>{%}
	      colors within this distance are considered equal

       -gamma <value>
	      level of gamma correction

       -gaussian <radius>x<sigma>
	      blur the image with a gaussian operator

       -geometry <width>x<height>{+-}<x>{+-}<y>{%}{@} {!}{<}{>}
	      preferred size and location of the Image window.

       -gravity <type>
	      direction primitive  gravitates to when annotating the image.

       -help  print usage instructions

       -implode <factor>
	      implode image pixels about the center

       -interlace <type>
	      the type of interlacing scheme

       -label <name>
	      assign a label to an image

       -level <value>
	      adjust the level of image contrast

       -linewidth
	      the line width for subsequent draw operations

       -list <type>
	      the type of list

       -loop <iterations>
	      add Netscape loop extension to your GIF animation

       -map <filename>
	      choose a particular set of colors from this image

       -mask <filename>
	      Specify a clipping mask

       -matte store matte channel if the image has one

       -mattecolor <color>
	      specify the matte color

       -median <radius>
	      apply a median filter to the image

       -modulate <value>
	      vary the brightness, saturation, and hue of an image

       -monochrome
	      transform the image to black and white

       -negate
	      replace every pixel with its complementary color

       -noise <radius|type>
	      add or reduce noise in an image

       -noop  NOOP (no option)

       -normalize
	      transform image to span the full range of color values

       -opaque <color>
	      change this color to the pen color within the image

       -page <width>x<height>{+-}<x>{+-}<y>{%}{!}{<}{>}
	      size and location of an image canvas

       -paint <radius>
	      simulate an oil painting

       -pen <color>
	      specify the pen color for drawing operations

       -pointsize <value>
	      pointsize of the Postscript, OPTION1, or TrueType font

       -profile <filename>
	      add ICM, IPTC, or generic profile	 to image

       -quality <value>
	      JPEG/MIFF/PNG compression level

       -raise <width>x<height>
	      lighten or darken image edges

       -region <width>x<height>{+-}<x>{+-}<y>
	      apply options to a portion of the image

       -resize <width>x<height>{%}{@}{!}{<}{>}
	      resize an image

       -roll {+-}<x>{+-}<y>
	      roll an image vertically or horizontally

       -rotate <degrees>{<}{>}
	      apply Paeth image rotation to the image

       -sample <geometry>
	      scale image with pixel sampling

       -sampling_factor <horizontal_factor>x<vertical_factor>
	      sampling	factors	 used  by  JPEG	 or  MPEG-2  encoder  and  YUV
	      decoder/encoder.

       -scale <geometry>
	      scale the image.

       -scene <value>
	      set scene number

       -seed <value>
	      pseudo-random number generator seed value

       -segment <cluster threshold>x<smoothing threshold>
	      segment an image

       -shade <azimuth>x<elevation>
	      shade the image using a distant light source

       -sharpen <radius>x<sigma>
	      sharpen the image

       -shave <width>x<height>
	      shave pixels from the image edges

       -shear <x degrees>x<y degrees>
	      shear the image along the X or Y axis

       -size <width>x<height>{+offset}
	      width and height of the image

       -solarize <factor>
	      negate all pixels above the threshold level

       -spread <amount>
	      displace image pixels by a random amount

       -stroke <color>
	      color to use when stroking a graphic primitive

       -strokewidth <value>
	      set the stroke width

       -swirl <degrees>
	      swirl image pixels about the center

       -texture <filename>
	      name of texture to tile onto the image background

       -threshold <value>
	      threshold the image

       -tile <filename>
	      tile image when filling a graphic primitive

       -transform
	      transform the image

       -transparent <color>
	      make this color transparent within the image

       -treedepth <value>
	      tree depth for the color reduction algorithm

       -trim  trim an image

       -type <type>
	      the image type

       -units <type>
	      the type of image resolution

       -unsharp <radius>x<sigma>
	      sharpen the image with an unsharp mask operator

       -verbose
	      print detailed information about the image

       -view <string>
	      FlashPix viewing parameters

       -wave <amplitude>x<wavelength>
	      alter an image along a sine wave

	      For a more detailed description of each  option,	see  ImageMag-
	      ick(1).


IMAGE SEGMENTATION
       Use  -segment  to  segment  an image by analyzing the histograms of the
       color components and identifying units that are	homogeneous  with  the
       fuzzy c-means technique. The scale-space filter analyzes the histograms
       of the three color components of the image  and	identifies  a  set  of
       classes.	  The  extents	of  each class is used to coarsely segment the
       image with thresholding.	 The  color  associated	 with  each  class  is
       determined by the mean color of all pixels within the extents of a par-
       ticular class. Finally, any unclassified pixels	are  assigned  to  the
       closest class with the fuzzy c-means technique.

       The fuzzy c-Means algorithm can be summarized as follows:


       Build a histogram, one for each color component of the image.

       For each histogram, successively apply the scale-space filter and build
       an interval tree of zero crossings in the  second  derivative  at  each
       scale.  Analyze this scale-space "fingerprint" to determine which peaks
       or valleys in the histogram are most predominant.

       The fingerprint defines intervals on the axis of	 the  histogram.  Each
       interval	 contains  either a minima or a maxima in the original signal.
       If each color component lies within the maxima interval, that pixel  is
       considered "classified" and is assigned an unique class number.

       Any pixel that fails to be classified in the above thresholding pass is
       classified using the fuzzy c-Means technique. It is assigned to one  of
       the classes discovered in the histogram analysis phase.


       The  fuzzy c-Means technique attempts to cluster a pixel by finding the
       local minima of the generalized	within	group  sum  of	squared	 error
       objective  function.  A pixel is assigned to the closest class of which
       the fuzzy membership has a maximum value.

       For additional information see: <bq>Young Won Lim, Sang	Uk  Lee,  ``On
       The  Color  Image  Segmentation Algorithm Based on the Thresholding and
       the Fuzzy c-Means Techniques'', Pattern Recognition, Volume 23,	Number
       9, pages 935-952, 1990.</bq>

ENVIRONMENT
       DISPLAY
	      To get the default host, display number, and screen.

SEE ALSO
       display(1),  animate(1), identify(1), montage(1), convert(1), ImageMag-
       ick(1), composite(1)


COPYRIGHT
       Copyright (C) 2002 ImageMagick Studio

       Permission is hereby granted, free of charge, to any person obtaining a
       copy  of	 this  software and associated documentation files ("ImageMag-
       ick"), to deal in ImageMagick without  restriction,  including  without
       limitation the rights to use, copy, modify, merge, publish, distribute,
       sublicense, and/or sell copies of ImageMagick, and to permit persons to
       whom  the  ImageMagick  is furnished to do so, subject to the following
       conditions:

       The above copyright notice and this permission notice shall be included
       in all copies or substantial portions of ImageMagick.

       The software is provided "as is", without warranty of any kind, express
       or implied, including  but  not	limited	 to  the  warranties  of  mer-
       chantability,  fitness  for a particular purpose and noninfringement.In
       no event shall ImageMagick Studio be liable for any claim,  damages  or
       other  liability,  whether in an action of contract, tort or otherwise,
       arising from, out of or in connection with ImageMagick or  the  use  or
       other dealings in ImageMagick.

       Except  as contained in this notice, the name of the ImageMagick Studio
       LLC shall not be used in advertising or otherwise to promote the	 sale,
       use  or	other dealings in ImageMagick without prior written authoriza-
       tion from the ImageMagick Studio.

AUTHORS
	John Cristy, ImageMagick Studio LLC,
       Glenn Randers-Pehrson, ImageMagick Studio LLC.




ImageMagick		   Date: 2002/02/15 01:00:00		    mogrify(1)
