/*  Get the filenames for mk4 data.

    This code was written by Alice Lecinski, September 2001.

    It is modeled after Jay Chalmers code written 1986.
    (Although he'd probably complain if he saw how
    I've mangled it with comments, etc. ;-)

    I strongly suggest *not* editting this code at all, unless
    you are absolutely sure you've found an error that
    needs fixing.

    If you edit it, you risk destroying the integrity of the
    code.  So if you do edit it, insure results pre and post
    actually match.

*/

#include <stdio.h>
#include <ctype.h>

#include "mk4v2.h"
#include "mk4headv2.h"


/**********************  dofnm.c     ******************************/

dofnm (who, howfar ) int who, howfar ; {

    register char *p = piceos;  /* piceos is global, and always holds the root
				   filenm. */

    /* Have to go through "howfar" twice since some happens at the front
       of the filename, and some at the end...
    */

    switch (howfar) {

	case IS_raw_spln:          *p++ = 'C';    break;

	case IS_raw_rect:
	case IS_cal_rect:
	case IS_cal_rect_slit:
	case IS_cal_rect_byte:
	case IS_cal_avg_rect:
	case IS_cal_avg_rect_slit: *p++ = 'r';    break;

	default:   ;
    }
    switch (howfar) {
	case IS_raw:
	case IS_raw_spln:
	case IS_raw_rect:
	     switch (who) {
		case IS_i:     *p++ = 'i' ;    break;
		case IS_q:     *p++ = 'q' ;    break;
		case IS_u:     *p++ = 'u' ;    break;
		case IS_ba:    *p++ = 'b';    *p++ = 'a';    break;
		case IS_st:    *p++ = 's';    *p++ = 't';    break;
		case IS_sk:    *p++ = 's';    *p++ = 'k';    break;

		default:       *p++ = '_';
	     }
	     break;
	case IS_cal:
	case IS_cal_avg:
	case IS_cal_slit:
	case IS_cal_avg_slit:
	case IS_cal_rect:
	case IS_cal_rect_slit:
	case IS_cal_rect_byte:
	case IS_cal_avg_rect:
	case IS_cal_avg_rect_slit:
	     switch (who) {
		case IS_i:     *p++ = 'I' ;                    break;
		case IS_q:     *p++ = 'p' ;    *p++ = 'B' ;    break;
		case IS_u:     *p++ = 'U' ;                    break;
		case IS_tscp:  *p++ = 't'; *p++ = 's'; *p++ = 'c'; *p++ = 'p'; 
							       break;
		case IS_drift: *p++ = 'd'; 
			       *p++ = 'r'; *p++ = 'i'; *p++ = 'f'; *p++ = 't'; 
							       break;
		case IS_tscp_inv:
			       *p++ = 't'; *p++ = 's'; *p++ = 'c'; *p++ = 'p'; 
			       *p++ = 'i'; 
			       *p++ = 'n'; 
			       *p++ = 'v'; 

							       break;
		default:       *p++ = '_';
	     }
	     break;
	default: ;
    }
    switch (howfar) {
	case IS_cal_avg:
	case IS_cal_avg_slit:
	case IS_cal_avg_rect:
	case IS_cal_avg_rect_slit:
	         *p++ = '.'; *p++ = 'a'; *p++ = 'v'; *p++ = 'g'; break;
	default: ;
    }
    switch (howfar) {
	case IS_cal_slit:
	case IS_cal_avg_slit:
	case IS_cal_rect_slit:
	case IS_cal_avg_rect_slit:
	         *p++ = '.'; *p++ = 's'; *p++ = 'l'; *p++ = 'i'; *p++ = 't';
		 break;
	default: ;
    }
    switch (howfar) {
	case IS_cal_rect_byte:
	         *p++ = '.'; *p++ = 'b'; *p++ = 'y'; *p++ = 't'; *p++ = 'e';
		 break;
	default: ;
    }
    *p = '\0';
}


dopicnm (hd) register FH hd; {
    register char *p = picnm;
    static char months[] = "janfebmaraprmayjunjulaugsepoctnovdec";

    if((hd->ProcSteps >= IS_cal_avg)&&(hd->ProcSteps <= IS_cal_avg_rect_slit))
	timeflag=0;

    if (dayflag) {
	jdate (hd->Image.Juld + JULD_REF,   &mon, &day, &year);
	if (!doyflag) {
	    sprintf (p,"%02d%3.3s%02d.",
				       (year-1900>=100)?year-2000:year-1900,
				       months+(mon-1)*3,day);
	    p += 8; 
	}
	else {
	    doy = get_doy (mon, day, year);
	    sprintf (p,"%02dd%03d.",
				   (year-1900>=100)?year-2000:year-1900,
				   doy);
	    p += 7; 
	}
    }

    if (timeflag && !Secflag ) {
	sprintf (p,"%5.5s.", prtime(hd->Image.Time));
	p += 6; }
    if (timeflag && Secflag ) {
	sprintf (p,"%8.8s.", prtime(hd->Image.Time));
	p += 9; }
     
    /* Add the mk4 for ALL file types. */
    *p++ = 'm'; *p++ = 'k'; *p++ = '4'; *p++ = '.';

    *p = '\0';
    piceos = p;
}
