;+
; draw_pos.pro
;  
; PURPOSE	Draw a "+" symbol at the specified position.
;
; SYNTAX	draw_pos, xpos, ypos, length, color
;
;		pos_name	Identifier for the position
;  		xpos, ypos	position coordinates
;  		length		size of "+" mark [# pixels in radius]
;  		color		color index of "+" mark
;		cs		character size
;
; AUTHOR	Andrew L. Stanger   HAO/NCAR   21 Dec 2004
;-

PRO draw_pos, pos_name, xpos, ypos, length, color, cs

   xv = [xpos - 3, xpos + 3]
   yv = [ypos,     ypos    ]
   PLOTS, xv, yv, color=color, /DEVICE
   xv = [xpos,     xpos    ]
   yv = [ypos - 3, ypos + 3]
   PLOTS, xv, yv, color=color, /DEVICE

   XYOUTS, xpos + 5, ypos, STRTRIM (STRING (pos_name), 2),		$
                           color=color, charsize=cs, /DEVICE
END

