From lika@madhu.gsfc.nasa.gov Thu Apr  6 14:27 MDT 1995
Received: from madhu (madhu.gsfc.nasa.gov [128.183.57.192]) by hao.ucar.edu (8.6.11/8.6.6.Beta9) with SMTP id OAA10227 for <card@hao.ucar.edu>; Thu, 6 Apr 1995 14:27:01 -0600
Date: Thu, 6 Apr 1995 16:30:13 -0400
Message-Id: <95040616301369@madhu.gsfc.nasa.gov>
From: lika@madhu.gsfc.nasa.gov (Madhulika Guhathakurta, 301 286 0722)
To: card@hao.ucar.edu
Subject: This is the program that dumps the tape to disk.
X-VMS-To: SMTP%"card@hao.ucar.edu"
X-VMS-Cc: LIKA
Content-Type: text
Content-Length: 1571
Status: R

; DUMP_TAPE
; DUMP_TAPE dumps a SPARTAN 201 WLC digital tape to a disk file for use in
; reformatting.
; D.M. fecit, 26 May, 1993.
; Modified, 2 November, 1994 for 680 cluster tape choice.
;
print, '**** You MUST have a tape logical unit number defined. ****'
print, '**** That is, ther emust be a logical name of the form ****'
print, '**** mt<n>, where <n> is a single digit, e.g. mt0.     ****'
;
tape_unit = '' & read, 'Tape unit number [0 - 4]   ', tape_unit
tape_unit = fix(tape_unit)
;
mount, tape_unit
;
tape_header = intarr(4100) & taprd, tape_header, tape_unit
n_block = tape_header(0) & tape_number = tape_header(3)
tape_number = strmid(string(100 + tape_number, format = '(i3)'), 1, 2)
default_file_name = 'tape_' + tape_number + '.dat'
;
file_name = ''
read,'File name for dumped data [D = ' + default_file_name + ']      ', $
   file_name
if file_name eq '' then file_name = default_file_name
;
openw, dump_unit, 'spartan$data:' + file_name, 8192, /get_lun
w = assoc(dump_unit, bytarr(8192)) & b = bytarr(8200)
;
; Write last block first to allocate the disk space now.
;
w(n_block) = b(8:*)
;
on_ioerror, fred
!err = 0 & i_rec = 0
while !err ge 0 do begin
   taprd, b, tape_unit & w(i_rec) = b(8:*)
   if i_rec mod 50 eq 0 then print, $
      '%DUMP_TAPE-I-WORKING, wrote block ' + strtrim(i_rec,2) + ' to disk.'
   i_rec = i_rec + 1
end
;
fred: close, dump_unit
free_lun, dump_unit
dismount, tape_unit
print,'%DUMP_TAPE-S-FINISHED, closed file SPARTAN$DATA:' + file_name
print,'                       after writing ' + strtrim(i_rec,2) + ' blocks.'
;
end

