/* eclw.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Display an eclipse image on the SGI IRIS screen using GL library software.
 * . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
 * Andrew L. Stanger   HAO/NCAR   SMM C/P
 * 24 May 1991: use onemap color mode.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include <gl/gl.h>
#include <fmclient.h>
#include "/home/stanger/lib/include/img_scale.h"
int GRN = 1;

/* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */
main (argc, argv)

int argc;
char *argv[];

{
static char nampgm[80];	/* Program file name. */
static char namimg[80];	/* Image file name. */
static char answer[2];	/* Response to scaling question. */
char *rindex();		/* Index function. */
char *it;		/* File name pointer. */
char *parg;		/* Argument pointer. */

int glecl_view();	/* Image display function. */
int i;			/* Index. */
int ierr;		/* Error status from cpview(). */
int larg;		/* Length of scaling/disk flag argument. */
int linit = 1;		/* Image label flag [0=off,1=on]. */

/* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

   strcpy (nampgm, argv [0]);

   /*** Request information if not enough arguments are provided. ***/

   if (argc == 1)
      {
      fprintf (stderr, "Usage: %s [[-]s] [filename]\n", argv [0]);

      fprintf (stderr, "Enter eclipse image [960x640]file name: ");
      fscanf  (stdin,  "%s", namimg);

      lscale = 0;
      fprintf (stderr, "Override default intensity scaling [y/n] ? ");
      fscanf  (stdin,  "%s", answer);
      if (strncmp (answer, "y", 1) == 0 || strncmp (answer, "Y", 1) == 0)
      lscale = 1;
      }

   /*** Single argument: must be filename. ***/

   if (argc == 2)
      {
      lscale = 0;
      strcpy (namimg, argv[1]);
      }

   /*** Two arguments. ***/

   if (argc == 3)
      {
      if ((strncmp (argv[1], "-", 1) == 0) || (strncmp (argv[1], "s", 1) == 0))
         {
         parg = argv[1];
         larg = strlen (parg);
         if (*parg == '-')
	    {
            parg++;
            larg--;
            }
         if (*parg == 's')  lscale = 1;
         if (larg == 2)
            {
            parg++;
            if (*parg == 's')  lscale = 1;
            }
         }
      else
         {
         lscale = 0;
         }
      strcpy (namimg, argv[2]);
      }

   /*** Three arguments. ***/

   if (argc == 4)
      {
      fprintf (stderr, "Usage: %s [[-]sd] [filename]\n", argv [0]);
      exit (-1);
      }

   /*** Request intensity scaling values if lscale > 0. ***/

   if (lscale == 1)
      {
      fprintf (stderr,
               "Enter oldmin, oldmax, newmin, newmax, clipmin, clipmax: ");
      fscanf  (stdin,  "%f,%f,%f,%f,%f,%f",
               &foldmin, &foldmax, &fnewmin, &fnewmax, &fclipmin, &fclipmax);
      oldmin =  (int) foldmin;    oldmax  = (int) foldmax;
      newmin =  (int) fnewmin;    newmax  = (int) fnewmax;
      clipmin = (int) fclipmin;   clipmax = (int) fclipmax;
      }
        
/*
 *  for (i=0; i<argc; i++)
 *	printf ("argv[%d]: %s\n", i, argv[i]);
 *  printf ("lscale: %d   ldisk: %d\n", lscale, ldisk);
 */

   /*** Initialize GL software. ***/

   foreground ();
   prefposition (311, 1270, 371, 1010);/* 960x640 window in upper right corner.*/
   fminit ();			/* Initialize SGI font manager. */

   winopen (nampgm);
   gl_wclear (BLACK);
/*
 *   multimap ();
 *   gconfig ();
 *   setmap (2);
 */

   /*** Invoke function to transfer image into frame buffer FB. ***/

   fprintf (stdout, "Displaying image: %s\n", namimg);
   if ((ierr = glecl_view (namimg)) < 0)
      {
      fprintf (stderr, "eclw error: %d\n", ierr);
      exit (-4);
      }
/*
 *   fprintf (stderr, "Type any character + <CR> to exit.\n");
 *   fscanf  (stdin,  "%s", answer);
 */
   sleep (15);
   gexit ();
   exit (0);
}
