/* egeo.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Geometric expansion/contraction for HAO Eclipse images (1700x1100 pixels).
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 11 October 1990
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

main (argc, argv)

int argc;
char *argv[];
{
static char namin [80];
static char namout [80];
static char inbuf [1100][1700];
static char outbuf [550][848];
int fdin, fdout;
int nread, nwrite, nclose;
int nbyin, nbyout;
int nxin = 1700;
int nyin = 1100;
int nxout = 848;
int nyout = 550;
float fx, fy;
float cxin, cyin;
float cxout, cyout;

   if (argc > 1)
      {
      strcpy (namin, argv [1]);
      }
   else
      {
      fprintf (stderr, "usage: egeo image_name\n");
      fprintf (stderr, "Enter Eclipse file name : ");
      fscanf  (stdin,  "%s", namin);
      }

   sprintf (namout, "%s.0", namin);
   fprintf (stderr, "Output file name: %s\n", namout);

   if ((fdin = open (namin, 0)) <= 0)
      {
      fprintf (stderr, "Unable to open file : %s\n", namin);
      exit (-2);
      }

   nbyin = nxin * nyin;
   nread = read (fdin, inbuf, nbyin);
   nclose = close (fdin);

   fx = 0.5;
   fy = 0.5;
/*
 *   fx = (float) nxout / (float) nxin;
 *   fy = (float) nyout / (float) nyin;
 */
   cxin = (float) nxin / 2.0;
   cyin = (float) nyin / 2.0;
   cxout = (float) nxout / 2.0;
   cyout = (float) nyout / 2.0;

   expconb (inbuf, nxin, nyin, outbuf, nxout, nyout,
	   fx, fy, cxin, cyin, cxout, cyout);

   fdout = creat (namout, 0644);
   nbyout = nxout * nyout;
   nwrite = write (fdout, outbuf, nbyout);
   nclose = close (fdout);
}
