/* egeo3.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Geometric expansion/contraction for HAO solar eclipse images.
 * size: (3000,2000) pixels, digitized by Eikonix electronic camera system.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 26 December 1990
 *  3 November 1994
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#define dxin  3000
#define dyin  2000
#define dxout 1200 
#define dyout  800 

main (argc, argv)

int argc;
char *argv[];
{
static char namin [80];
static char namout [80];
static char inbuf [dyin][dxin];
static char outbuf [dyout][dxout];
int fdin, fdout;
int nread, nwrite, nclose;
int nbyin, nbyout;
int nxin = dxin;
int nyin = dyin;
int nxout = dxout;
int nyout = dyout;
float fx, fy;
float cxin, cyin;
float cxout, cyout;

   if (argc > 1)
      {
      strcpy (namin, argv [1]);
      }
   else
      {
      fprintf (stderr, "usage: egeo3 image_name\n");
      fprintf (stderr, "Enter Eclipse file name : ");
      fscanf  (stdin,  "%s", namin);
      }

   sprintf (namout, "%s.3", namin);
   fprintf (stderr, "Output file name: %s\n", namout);

   if ((fdin = open (namin, 0)) <= 0)
      {
      fprintf (stderr, "Unable to open file : %s\n", namin);
      exit (-2);
      }

   nbyin = nxin * nyin;
   nread = read (fdin, inbuf, nbyin);
   nclose = close (fdin);

   fx = (float) nxout / (float) nxin;
   fy = (float) nyout / (float) nyin;

   cxin = (float) nxin / 2.0 - 0.5;
   cyin = (float) nyin / 2.0 - 0.5;
   cxout = (float) nxout / 2.0 - 0.5;
   cyout = (float) nyout / 2.0 - 0.5;

   expconb (inbuf, nxin, nyin, outbuf, nxout, nyout,
	   fx, fy, cxin, cyin, cxout, cyout);

   fdout = creat (namout, 0644);
   nbyout = nxout * nyout;
   nwrite = write (fdout, outbuf, nbyout);
   nclose = close (fdout);
}
