/* gl_cmap.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * SGI/GL utilities.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <gl/gl.h>

/* gl_wclear
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Clears GL window to color referenced by LUT index.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

gl_wclear (mapindex)

Colorindex mapindex;

{
   color (mapindex);
   clear ();

   return (0);
}

/* get_cmap 
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Saves SGI colormap contents in arrays CarrayR, CarrayG, CarrayB.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#define MAXCOLI 4095 

static short CarrayR[MAXCOLI+1], CarrayG[MAXCOLI+1], CarrayB[MAXCOLI+1];
unsigned short cindex;

get_cmap ()

{
   short rcomp, gcomp, bcomp;

   for (cindex = 0; cindex <= MAXCOLI; cindex++)
      {
      getmcolor (cindex, &rcomp, &gcomp, &bcomp);
      CarrayR [cindex] = rcomp;
      CarrayG [cindex] = gcomp;
      CarrayB [cindex] = bcomp;
    }
}

/* restore_cmap 
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Restores SGI colormap contents from arrays CarrayR, CarrayG, CarrayB.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

restore_cmap ()
{

   for (cindex = 0; cindex <= MAXCOLI; cindex++) 
      mapcolor (cindex, CarrayR [cindex], CarrayG [cindex], CarrayB [cindex]);
}
