/* intbyt.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Find min & max of short image.
 * Convert to byte image.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 11 January 1991
 * 29 May 1991: added command line arguments.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

main (argc, argv)

int argc;
char *argv [];
{
char *malloc ();
char namimg [80];
char namout [80];
char nampgm [80];
short *simg;
char *bytimg;
int fdin, fdout;
int imin = 1000000, imax = -1000000;
int intval;
int i;
int ix, iy;
int dx = 500, dy = 500;
int dmin = 0, dmax = 249;
int nelem;
int nbypix = 2;
int imgsiz;
float offset, slope;

   if (argc == 4)
      {
      strcpy (nampgm, argv [0]);
      strcpy (namimg, argv [1]);
      sscanf (argv [2], "%d", &dx);
      sscanf (argv [3], "%d", &dy);
      }
   else
      {
      fprintf (stderr, "usage: %s [ecl_name] [nx ny]\n", argv [0]);
      fprintf (stderr, "Enter short image file name: ");
      fscanf  (stdin,  "%s", namimg);
      fprintf (stderr, "Enter image size [pixels]: ");
      fscanf  (stdin,  "%d,%d", &dx, &dy);
      }
   sprintf (namout, "%s.byt", namimg);
   fprintf (stdout, "Output image name: %s\n", namout);
   fprintf (stdout, "dx: %d   dy: %d\n", dx, dy);

   nelem = dx * dy;
   imgsiz = nelem * nbypix;
   simg = (short *) malloc (imgsiz);
   bytimg = (char *) malloc (nelem);
   fdin = open (namimg, 0);
   read (fdin, simg, imgsiz);
   close (fdin);

   for (iy = 0; iy < dy; iy++)
      for (ix = 0; ix < dx; ix++)
	 {
	 if (*(simg + ix + iy*dx) < imin)  imin = *(simg + ix + iy*dx);
	 if (*(simg + ix + iy*dx) > imax)  imax = *(simg + ix + iy*dx);
	 }
   printf ("image: %s   min: %d   max: %d\n", namimg, imin, imax);

   slope = 250.0 / ((float) (imax - imin));
   offset = (float) imin;
   for (i=0; i < nelem; i++)
      {
      intval = (int) (((float) *(simg + i) - offset) * slope); 
      if (intval < dmin)  intval = dmin;
      if (intval > dmax)  intval = dmax;
      *(bytimg + i) = (char) (intval & 0377);
      }

   fdout = creat (namout, 0644);
   write (fdout, bytimg, nelem);
   close (fdout);
   exit (0);
}
