/* This program takes an image and resizes by the given reduction factors.
*/
#include "/home/yoda/rose/grin2/grin.h"
#include <math.h>

#define DtoR (3.14159265/180.0)

main(an,av)  int an ; char *av[] ;
{
    register u_char *uc ;
    register u_short *p , *q ;
    char *w , fnm[80] , ofnm[80] ;
    int i,j, dx , dy , new_dx , new_dy , DIM , FAC , NDIM ;
    float xcenter , ycenter , Nxcenter , Nycenter , xfact , yfact ;
    u_char  *Cimg ;
    u_short *Simg , *Nimg ;
    FILE   *fid ;
    
    FAC = NDIM = DIM = 0 ;  new_dx = new_dy = 0 ;   xfact = yfact = 0.0 ;

    if ( an < 8 ) { prsum() ; 
	printf ("\nEnter image file name: "); scanf  ("%s",fnm);
	printf ("\nEnter output image file name: "); scanf  ("%s",ofnm);
	printf ("\nEnter dx:  "); scanf  ("%d", &dx );
	printf ("\nEnter dy:  ");  scanf  ("%d", &dy );
	printf ("\nEnter new dx:  "); scanf  ("%d", &new_dx );
	printf ("\nEnter new dy:  ");  scanf  ("%d", &new_dy );
	printf ("\nEnter factor:  ");  scanf  ("%f", &xfact );
	yfact = xfact ;
    }
    while (--an) {
	if (*(w = *++av) == '-') {	/* Check for flag arguments */
	    switch (w[1]) {
		case 'd':  DIM++ ; 
			   --an ; w = *++av; sscanf(w,"%d",&dx); 
			   --an ; w = *++av; sscanf(w,"%d",&dy); 
			   break;
		case 'n':  NDIM++ ; 
			   --an ; w = *++av; sscanf(w,"%d",&new_dx); 
			   --an ; w = *++av; sscanf(w,"%d",&new_dy); 
			   break;
		case 'f':  FAC++ ; 
			   --an; w = *++av; sscanf(w,"%f",&xfact); yfact=xfact;
			   break ;
		default:   fprintf (stderr," unknown flag %s\n",*av);
		           prsum(); exit(10);
	    }
	}
	else {  strcpy( fnm , w ) ; 
		--an ; w = *++av ; strcpy ( ofnm , w ) ;
	}
    }
    printf ("\nProgram running...\n") ;

    if( new_dx || new_dy ) { NDIM++ ; FAC=0 ; }
    else                   { FAC++ ;  NDIM=0; }

    Cimg =  (u_char *)malloc( dx*dy ) ;
    Simg = (u_short *)malloc( dx*dy*2 ) ;

    if((fid=fopen(fnm,"r")) == NULL){
	fprintf(stderr,"resize> can\'t open file -->%s\n",fnm) ;
	exit(-1) ;
    }
    if( fseek(fid,0L,0) == -1 ){
	fprintf(stderr,"resize> seek error in %s.\n",fnm) ;
	exit(-1) ;
    }
    if (fread(Cimg,1,dx*dy,fid) <= 0 ){
	fprintf(stderr,"resize> read error in %s.\n",fnm) ;
	exit(-1) ;
    }
    fclose( fid ) ;

    uc = Cimg ;
    p = (u_short *)Simg ;
    for( i=0 ; i<dx*dy ; i++ ) *p++ = (u_short)*uc++ ;
    free((char *)Cimg) ;

    if ( NDIM ) {
	xfact = (float)new_dx / (float) dx ;
	yfact = (float)new_dy / (float) dy ;
        printf("New dimensions of %d and %d were given.\n",new_dx,new_dy);
    }
    else if ( FAC ) {
	new_dx = 1+ (int)(xfact*(float)dx)  ;
	new_dy = 1+ (int)(yfact*(float)dy) ;
        printf("A factor of %f was given.\n",xfact) ;
    }
    else {
	fprintf(stderr,
	"\n\007Neither a factor nor new dimensions were given.\n") ;
	prsum() ;
	exit(-5) ;
    }


    /*  Allocate some space for the new image. */
    Nimg = (u_short *)malloc (new_dx*new_dy*2) ;

    xcenter = (float)(dx-1)/2.0 ;
    ycenter = (float)(dy-1)/2.0 ;
    Nxcenter = (float)(new_dx-1)/2.0 ;
    Nycenter = (float)(new_dy-1)/2.0 ;



    expcon(Simg,dx,dy,
	   Nimg,new_dx,new_dy,xfact,yfact,
	   xcenter,ycenter,Nxcenter,Nycenter) ;
    free((char *)Simg) ;

    Cimg = (u_char *)malloc (new_dx*new_dy) ;
    uc = Cimg ;
    q = (u_short *)Nimg ;
    for( i=0 ; i<new_dx*new_dy ; i++ ) {
	if( *q >= 253 ) *q = 253 ;
	if( *q <= 0   ) *q = 253 ;
	*uc++ = (u_char)*q++ ;
    }

    fid = fopen(ofnm,"w");

    fwrite(Cimg, 1, new_dx*new_dy, fid);

    fclose(fid); 

    free((char *)Nimg) ;
    free((char *)Cimg) ;


}
prsum() {
static char help[] = "\
\n\
resize [-d dx dy] [-n new_dx new_dy] [-f factor] [infile] [outfile] \n\
\n\
This program takes an image and makes it the size specified by either the\n\
    \"new_dx\" and \"new_dy\" OR \"factor\" \n\
    If new_dx and new_dy are 0 then factor is used, or, \n\
    if factor is 0.0 then new_dy and new_dy are used. \n\
\n\
Example:              resize \n\
Example:              resize -d 4096 1200 -n 512 512 183050 183050.small \n\
Example:              resize -d 4096 1200 -f 0.25 183050 183050.small \n\
Example:              resize -d 4096 1200 -f 4.0 183050 183050.huge \n\
\n" ;
    fputs (help,stderr);
}
