/* This program takes an image and makes it 512 by 512, char or short ints,
   depending on what the input image was.
*/
#include <math.h>
#include "/home/yoda/rose/grin2/grin.h"



main(an,av)  int an ; char *av[] ;
{
    char filenm[80] ;
    static char ext[] = ".a" ;
    int i,j, newdx , newdy , Xdim=0 , CIMG=0 , SIMG=0 , Ydim=0 , header=0 ;
    int olddx , olddy ;
    register u_char *uc;
    register u_short *p , *q ;
    FILE *fid ;
    u_char  *Cimg ;
    u_short *Simg , *Nimg ;
    float Ncenter , Oxcenter , Oycenter ;
    float Xfact , Yfact ;
    long hdlength=0 ;
    int expcon() ;
    char *w ;
    
    newdx = 512 ;
    newdy = 512 ;

    if ( an <= 3 ) { prsum() ; exit(-5) ;
    }

    Ncenter = ((float)(newdx-1))/2.0 ;

    while (--an) {
	while (*(w = *++av) == '-') {	/* Check for flag arguments */
	    switch (w[1]) {
		case 'c':  CIMG++ ; 
			   break;
		case 's':  SIMG++ ; 
			   break;
		case 'h':  header++ ; --an ; w = *++av;
			   sscanf(w,"%ld",&hdlength) ;
			   break;
		case 'x':  Xdim++ ; --an ; w = *++av;
			   sscanf(w,"%d",&olddx) ;
			   break;
		case 'y':  Ydim++ ; --an ; w = *++av;
			   sscanf(w,"%d",&olddy) ;
			   break;
		default:   fprintf (stderr," unknown flag %s\n",*av);
		           prsum(); exit(10);
	    }
	   --an ; /* Get to the next arg */
	}

	strcpy(filenm,w) ;

    }
    if( CIMG + SIMG != 1 ) {
	fprintf(stderr,"One of -c or -s MUST be given\n") ;
	exit(-1) ;
    }
    if( Xdim + Ydim != 2 ) {
	fprintf(stderr,"Both -x and -y MUST be given\n") ;
	exit(-1) ;
    }
    fprintf(stderr,"Your image dimensions, %d, %d will be transformed to\n\
		    512 by 512 \n", olddx , olddy) ;

    if (CIMG) Cimg = (u_char *)malloc( olddx*olddy ) ;
    Simg = (u_short *)malloc( olddx*olddy*2 ) ;
    Nimg = (u_short *)malloc( newdx*newdy*2 ) ;

    Oxcenter = ((float)(olddx-1))/2.0 ;
    Oycenter = ((float)(olddy-1))/2.0 ;



    if((fid=fopen(filenm,"r")) == NULL){
	fprintf(stderr,"to512> can\'t open file --> %s\n",filenm);
	exit(-1) ;
    }

    if (fseek(fid,hdlength,0) == -1) {     /* Get past the header. */
	printf("to512> fseek failed in %s.\n",filenm); 
	exit(-1);
    }


    if ( CIMG ) {
	if (fread(Cimg,1,olddx*olddy,fid) <= 0 ){/* Read in image */
	    fprintf(stderr,"to512> read error in %s.\n",filenm) ;
	    exit(-1) ;
	}
    }
    else {
	if (fread(Simg,2,olddx*olddy,fid) <= 0 ){/* Read in image */
	    fprintf(stderr,"to512> read error in %s.\n",filenm) ;
	    exit(-1) ;
	}
    }
    fclose( fid ) ;




    if (CIMG) {
	uc = Cimg ; 
	p  = Simg ;
	for( j=0 ; j<olddx*olddy ; j++)  *p++ = (u_short)(*uc++ ) ;
	free((char *)Cimg) ;
    }

    Xfact = ((float)newdx) / ((float) olddx) ;
    Yfact = ((float)newdy) / ((float) olddy) ;

    expcon(Simg,olddx,olddy,
	   Nimg,newdx,newdy,Xfact,Yfact,
	   Oxcenter,Oycenter,Ncenter,Ncenter) ;

    free((char *)Simg) ;


    strcat(filenm, ext) ;
    fid = fopen(filenm,"w");

    fseek(fid, 0 , 0);

    if ( CIMG ) {
	Cimg = (u_char *)malloc( newdx*newdy ) ;
	p = Nimg ;
	uc = Cimg ;
	for( j=0 ; j<newdx*newdy ; j++)  *uc++ = (u_char)(*p++ ) ;
	fwrite(Cimg, 1, newdx*newdy, fid);
    }
    else {
	fwrite(Nimg, 2, newdx*newdy, fid);
    }




    fclose(fid); 

    free((char *)Nimg) ;
    free((char *)Cimg) ;
}



prsum() {
static char help[] = "\
\n\
to512 [-s] [-c] [-h hdrlength] [-x xdim] [-y ydim] [file] \n\
\n\
This program takes an image and shrinks or expands it to \n\
a 512 by 512 image.\n\
    The -s flag indicates an incoming short int image.\n\
    The -c flag indicates an incoming unsigned char image.\n\
    The -h flag indicates that there is a header at the beginning of the \n\
		image that is hdrlength bytes long.\n\
The resulting image has \".a\" appended to the end. \n\
\n\
Example:              to512 -h 452 -c -x 452 -y 452  181720.eikp \n\
\n" ;
    fputs (help,stderr);
}
