/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * fbsrfs.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Read byte image from WHIP frame buffer & convert it to a sun rasterfile.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

fbsrfs (FB, namsrf, xdim, ydim)

int FB;				/* WHIP frame buffer. */
char *namsrf;			/* Output sun rasterfile name. */
int xdim, ydim;			/* X/Y dimensions. */
{
   extern char *malloc ();
   unsigned char *cbuf;
   static unsigned char red [256], green [256], blue [256];

   int i;
   int ix, iy;			/* Indices for image array. */
   int nbypx;			/* # bytes per pixel. */
   int nbyimg;
   int rel = 0;			/* relative flag for fb_setaddr. */
   int row;			/* row index counter. */
   unsigned short off = 512;	/* Color level offset. */
   float frange;

   /*** Allocate memory for image array. ***/

   nbypx = 1;
   nbyimg = xdim * ydim * nbypx;

   cbuf = (unsigned char  *)  malloc (nbyimg);

   /*** Copy image from frame buffer to memory. ***/

   fb_setfb (FB);				/* Set current FB. */
   fb_xstep ();					/* Auto increment in x axis. */

   for (row = 0; row < ydim; row++)
      {
      fb_setaddr (FB, rel, 0, ydim - row - 1, 0);/* Set read address in FB. */
      fb_read (cbuf + row*xdim, xdim);		/* Read one row from FB. */
      }

   /*** Read color table. ***/

   cp_cmap (off, red, green, blue);

   /*** Create sun rasterfile and write to disk. ***/

   bytsrf (namsrf, cbuf, xdim, ydim, red, green, blue);

   free (cbuf);
   return (0);
}


/* cp_cmap
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copy color map to memory arrays.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
cp_cmap (offset, red, green, blue)

unsigned short offset;
unsigned char red [];
unsigned char green [];
unsigned char blue [];

{
   unsigned short ic, im;
   short rcomp, gcomp, bcomp;

   for (ic = 0; ic < 256; ic++)
      {
      im = ic + offset;
      getmcolor (im, &rcomp, &gcomp, &bcomp);

      red [ic]   = (unsigned char) rcomp;
      green [ic] = (unsigned char) gcomp;
      blue [ic]  = (unsigned char) bcomp;
      }

   return (0);
}
