/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * file_poly : Define polygon area using mouse device.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 14 November 1991
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

file_poly (namepv, poly, nver)

char namepv [];			/* Polygon vertex file name. */
int poly [][2];			/* Polygon vertex array. */
int *nver;			/* # vertices in polygon. */

{
   FILE *fdpv;
   int ip;			/* Vertex counter. */
   int xcp, ycp;		/* C/P x/y coordinates. */

   if ((fdpv = fopen (namepv, "r")) == NULL)
      {
      fprintf (stderr, "file_poly> unable to open file : %s\n", namepv);
      return (-1);
      }

   /*** Read "namepv" file to count the number of coordinate pairs. ***/

   ip = 0;
   while (fscanf (fdpv, "%d %d", &xcp, &ycp) != EOF)
      {
      poly [ip][0] = xcp;
      poly [ip][1] = ycp;
      ip++;
      }
   fclose (fdpv);

   *nver = ip - 1;			/* Exclude last pair (same as first). */

   fprintf (stdout, "file_poly> nver: %d\n", *nver);

   return (0);
}
