From lika@sdac.gsfc.nasa.gov Thu Apr  6 14:28 MDT 1995
Received: from SDAC (sdac.gsfc.nasa.gov [128.183.57.156]) by hao.ucar.edu (8.6.11/8.6.6.Beta9) with SMTP id OAA10242 for <card@hao.ucar.edu>; Thu, 6 Apr 1995 14:28:27 -0600
From: lika@sdac.gsfc.nasa.gov
Date: Thu, 6 Apr 1995 16:28:08 -0400
Message-Id: <95040616280820@sdac.gsfc.nasa.gov>
To: card@hao.ucar.edu
Subject: Find_image.pro is used by reformat program
X-VMS-To: SMTP%"card@hao.ucar.edu"
Content-Type: text
Content-Length: 657
Status: R

; FIND_IMAGE
; FIND_IMAGE finds the vector indices of the beginning of putative image
; data frames in the SPARTAN 201 WLC data.
; D.M. fecit, 16 May, 1993.
;
pro find_image, data_array, image_frame
;
; First two and sixth synch pattern bytes to identify image data frames.
; (Hope this is enough.)
;
b0 = '33'xb & b1 = '2a'xb & bd = 4b
;
w0 = where(data_array eq b0) & w1 = where(data_array eq b1)
w2 = where(data_array eq bd)
a1 = data_array(w0 + 1) & a2 = data_array(w0 + 5)
wz = where((a1 eq b1)*(a2 eq bd))
wx = w0(wz) & n_frame = n_elements(wx)
;
print,'FIND_IMAGE-I-N_FRAME, number of image frames found =', n_frame
;
image_frame = wx
;
return & end

