#include <stdio.h>
#include <math.h>

/* -------------------------------------------------------------------------- */

int MMmult (A, ax, ay, B, bx, by, C, cx, cy) 

	   float *A, *B, *C;
	   int   ax, bx, cx;
	   int   ay, by, cy;
{
    int ii, jj, kk;
    float *pA , *pB , *pC;
    float *vel;

    /* Check to see that the multiplication is valid. */

    if ( ax != by )
	{
	fprintf (stderr, 
	"Can\'t do the multiplication. Sizes don\'t match. ax %d by %d\n", 
	ax, by);
	return (-1);
        }
    if ( ay != cy )
	{
	fprintf (stderr, 
	"Can\'t do the multiplication. Sizes don\'t match. ay %d cy %d\n", 
	ay, cy);
	return (-2);
    }
    if ( bx != cx )
	{
	fprintf (stderr, 
	"Can\'t do the multiplication. Sizes don\'t match. bx %d cx %d\n", 
	bx, cx);
	return (-2);
        }

    pA = A;
    pB = B;
    pC = C;
    for (kk=0; kk<bx; kk++)
	{
	pA = A;
	pC = C + kk;
	for (jj=0; jj<ay; jj++)
	    {
	    *pC =0.;
	    vel = pB + kk;
	    for (ii=0; ii<ax; ii++)
		{   /* ax == by */
		*pC += *pA * (*vel);
		vel += bx;
		pA++;
	        }
	    pC += cx;
	    }
        }
    return (0);
}

/* -------------------------------------------------------------------------- */

int
transpose (A, B, nx, ny)  

    float *A, *B;
    int nx, ny;
{
    int ii, jj;
    int bx;
    float *pA, *pB;

    bx = ny;

    pB = B;
    pA = A;
    for (jj=0; jj<ny; jj++)
	{
	pB = B + jj;
	for (ii=0; ii<nx; ii++)
	    {
	    *pB = *pA;
	    pA++;
	    pB+=bx;
	    }
        }
    return (0) ;
}

/* -------------------------------------------------------------------------- */

int
AbsTotal (array, nn, psum) 

    float *array;
    int  nn;
    float *psum;
{
    int ii;
    float *pa;
    double sum , dtmp;

    sum=0.;
    pa = array;
    for (ii=0; ii<nn; ii++)
	{
	dtmp = (double) (*pa);
	sum += fabs (dtmp);
	pa++;
        }
    *psum = (float) sum ;

    return (0) ;
}

/* -------------------------------------------------------------------------- */

int
GetDiagV (V, alpha, nterms)

    float *V, *alpha;
    int nterms;
{
    int ii;
    float *pV;
    double dtemp;

    pV = V;
    for (ii=0; ii<nterms; ii++)
	{
	dtemp = (double) (*(alpha + ii + ii * nterms));
	*pV   = (float) sqrt (dtemp);
	pV++;
        }

    return (0) ;
}

/* -------------------------------------------------------------------------- */

int
AugmentDiag (A, augment, nterms)

    float *A, augment;
    int nterms;
{
    int ii;

    for (ii=0; ii<nterms; ii++)
	{
	*(A + ii + ii * nterms) *= augment ;
        }

    return (0) ;
}

/* -------------------------------------------------------------------------- */

