#include <stdio.h>

/* -------------------------------------------------------------------------- */

int
VVplus(A,B,C,n)  /* A+B = C */
    float *A,*B,*C;
    int n;
{
    int ii;
    float *pA,*pB,*pC;

    pA = A;
    pB = B;
    pC = C;
    for (ii=0; ii<n; ii++)
	{   
	*pC = *pA + *pB ;
	pA++; 
	pB++;
	pC++; 
        } 

    return (0) ;
}

/* -------------------------------------------------------------------------- */

int
VVminus (A,B,C,n)  /* A-B = C */

    float *A,*B,*C;
    int n;
{
    int ii;
    float *pA,*pB,*pC;

    pA = A;
    pB = B;
    pC= C;
    for (ii=0; ii<n; ii++)
	{   
	*pC = *pA - *pB ;
	pA++; 
	pB++;
	pC++; 
        } 

    return (0) ;
}

/* -------------------------------------------------------------------------- */

int
VVmult (A,B,C,n)  /* A*B = C */

    float *A,*B,*C;
    int n;
{
    int ii;
    float ftmp;
    float *pA,*pB,*pC;

    pA = A;
    pB = B;
    pC = C;
    for (ii=0; ii<n; ii++)
	{   
	ftmp  = *pA;
	ftmp *= *pB;
	*pC   = ftmp;
	pA++; 
	pB++;
	pC++; 
        } 

    return (0) ;
}

/* -------------------------------------------------------------------------- */

int
VVdivide (A,B,C,n)  /* A/B = C */

    float *A,*B,*C;
    int n;
{
    int ii;
    float *pA,*pB,*pC;

    pA = A;
    pB = B;
    pC = C;
    for (ii=0; ii<n; ii++)
	{   
	*pC = (*pB == 0.0) ? 0.0 : *pA / *pB ;
	pA++; 
	pB++;
	pC++; 
        } 

    return (0) ;
}

/* -------------------------------------------------------------------------- */

int
VVcopy (A,B,n)  /* Copy A to B  */

    float *A,*B;
    int n;
{
    int ii;
    float *pA,*pB;

    pA = A;
    pB = B;
    for (ii=0; ii<n; ii++)
	{   
	*pB = *pA ;
	pA++; 
	pB++;
        }

    return (0) ;
}

/* -------------------------------------------------------------------------- */

int
Vplus (A,value,n)  /* A = A + value  */

    float *A;
    float value;
    int n;
{
    int ii;
    float *pA;

    pA = A;
    for (ii=0; ii<n; ii++)
	{   
	*pA += value;
	pA++; 
        }

    return (0) ;
}

/* -------------------------------------------------------------------------- */

int
Vminus (A,value,n)  /* A = A - value  */

    float *A;
    float value;
    int n;
{
    int ii;
    float *pA;

    pA = A;
    for (ii=0; ii<n; ii++)
	{   
	*pA -= value;
	pA++; 
        }

    return (0) ;
}

/* -------------------------------------------------------------------------- */

int
Vmult (A,value,n)  /* A = A * value  */

    float *A;
    float value;
    int n;
{
    int ii;
    float *pA;

    pA = A;
    for (ii=0; ii<n; ii++)
	{   
	*pA *= value;
	pA++; 
        }

    return (0) ;
}

/* -------------------------------------------------------------------------- */

int
Vover (A,n)  /* A = 1. / A */

    float *A;
    int n;
{
    int ii;
    float value, ovvalue;
    float *pA;

    pA = A;
    for (ii=0; ii<n; ii++)
	{   
	value = *pA;
	ovvalue = ( value != 0.0 ) ? 1.0 / value : 0.0 ;
	*pA = ovvalue;
	pA++; 
        }

    return (0) ;
}

/* -------------------------------------------------------------------------- */

int
Vinitialize (A,value,n)  /* A = value  */

    float *A;
    float value;
    int n;
{
    int ii;
    float *pA;

    pA = A;
    for (ii=0; ii<n; ii++)
	{   
	*pA = value;
	pA++; 
        }

    return (0) ;
}

/* -------------------------------------------------------------------------- */

int
iVminus (A,value,n)  /* A = A - value  */

    int *A;
    int value;
    int n;
{
    int ii;
    int *pA;

    pA = A;
    for (ii=0; ii<n; ii++)
	{   
	*pA -= value;
	pA++; 
        }

    return (0) ;
}

/* -------------------------------------------------------------------------- */

