/* dofnm4.c
 *
 * dofnm (who, howfar)
 * dopicnm (hd)
 */

#include <stdio.h>
#include <ctype.h>

#include "mk4v2.h"
#include "mk4headv2.h"


/**********************  dofnm.c     ******************************/

/*** dofnm: add MLSO/Mark-IV extensions to file name. ***/

dofnm (who, howfar )

int who, howfar ;

{
    /* piceos is global, and always hold the root filenm. */

    register char *p = piceos;

    /* Have to go through "howfar" twice since some happens at the front
     * of the filename, and some at the end...
     */

    switch (howfar)
	{

	case IS_raw_spln:          *p++ = 'C';    break;

	case IS_raw_rect:
	case IS_cal_rect:
	case IS_cal_rect_slit:
	case IS_cal_rect_byte:
	case IS_cal_avg_rect:
	case IS_cal_avg_rect_slit: *p++ = 'r';    break;

	default:   ;
        }

    switch (howfar)
	{
	case IS_raw:
	case IS_raw_spln:
	case IS_raw_rect:
	    switch (who)
	        {
		case IS_i:     *p++ = 'i' ;    break;
		case IS_q:     *p++ = 'q' ;    break;
		case IS_u:     *p++ = 'u' ;    break;
		case IS_ba:    *p++ = 'b';    *p++ = 'a';    break;
		case IS_st:    *p++ = 's';    *p++ = 't';    break;
		case IS_sk:    *p++ = 's';    *p++ = 'k';    break;

		default:       *p++ = '_';
	        }
	    break;
	case IS_cal:
	case IS_cal_avg:
	case IS_cal_rect:
	case IS_cal_rect_slit:
	case IS_cal_rect_byte:
	case IS_cal_avg_rect:
	case IS_cal_avg_rect_slit:
	    switch (who)
                {
		case IS_i:     *p++ = 'I' ;                    break;
		case IS_q:     *p++ = 'p' ;    *p++ = 'B' ;    break;
		case IS_u:     *p++ = 'U' ;                    break;
		case IS_tscp:  *p++ = 't'; *p++ = 's'; *p++ = 'c'; *p++ = 'p'; 
							       break;

		default:       *p++ = '_';
	        }
	    break;
	default: ;
        }

    switch (howfar)
	{
	case IS_cal_avg:
	case IS_cal_avg_rect:
	case IS_cal_avg_rect_slit:
	         *p++ = '.'; *p++ = 'a'; *p++ = 'v'; *p++ = 'g'; break;
	default: ;
        }

    switch (howfar)
	{
	case IS_cal_rect_slit:
	case IS_cal_avg_rect_slit:
	         *p++ = '.'; *p++ = 's'; *p++ = 'l'; *p++ = 'i'; *p++ = 't';
		 break;
	default: ;
        }

    switch (howfar)
	{
	case IS_cal_rect_byte:
	         *p++ = '.'; *p++ = 'b'; *p++ = 'y'; *p++ = 't'; *p++ = 'e';
		 break;
	default: ;
        }

    *p = '\0';
    return (0) ;
}



/**********************  dopicnm.c     ******************************/

/*** dopicnm: create MLSO/Mark-IV image file name base. ***/

dopicnm (hd)

register FH hd;

{
    register char *p = picnm;
    static char months [] = "janfebmaraprmayjunjulaugsepoctnovdec";

    if ((hd->ProcSteps >= IS_cal_avg) &&
	(hd->ProcSteps <= IS_cal_avg_rect_slit))
	timeflag = 0;

    if (dayflag)
	{
	jdate (hd->Image.Juld + 2415021, &mon, &day, &year);
	if (!doyflag)
	    {
	    sprintf (p,"%2d%3.3s%02d.", year - 1900, months + (mon-1) * 3, day);
	    p += 8; 
	    }
	else
	    {
	    doy = get_doy (mon, day, year);
	    sprintf (p,"%2dd%03d.",year-1900,doy);
	    p += 7; 
	    }
        }

    if (timeflag && !Secflag)
	{
	sprintf (p, "%5.5s.", prtime (hd->Image.Time));
	p += 6;
	}

    if (timeflag && Secflag)
	{
	sprintf (p, "%8.8s.", prtime (hd->Image.Time));
	p += 9;
	}
     
    /*** Add the mk4 for ALL file types. ***/

    *p++ = 'm'; *p++ = 'k'; *p++ = '4'; *p++ = '.';

    *p = '\0';
    piceos = p;
    return (0) ;
}
