/* mk4hdp.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Print Mk4 binary header contents.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR    2 Nov 2001
 *  5 Feb 2003 : "spare1" replaced by "SkyTxUsed".
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "mk4v2.h"
#include "mk4headv2.h"

int
mk4hdp (hd)

struct mk4_header *hd ;

{
   int pmode = 1 ;

   /*** Mk4 binary header contents. ***/

   if (pmode >= 1)
   {
   fprintf (stdout, "hd->Image.Year:            %8d\n", hd->Image.Year) ;
   fprintf (stdout, "hd->Image.Month:           %8d\n", hd->Image.Month) ;
   fprintf (stdout, "hd->Image.Day:             %8d\n", hd->Image.Day) ;
   fprintf (stdout, "hd->Image.Hour:            %8d\n", hd->Image.Hour) ;
   fprintf (stdout, "hd->Image.Minute:          %8d\n", hd->Image.Minute) ;
   fprintf (stdout, "hd->Image.CentiSec:        %8d\n", hd->Image.CentiSec) ;
   fprintf (stdout, "hd->Image.Juld:            %8d\n", hd->Image.Juld) ;
   fprintf (stdout, "hd->Image.Doy:             %8d\n", hd->Image.Doy) ;
   fprintf (stdout, "hd->Image.Time:            %8d\n", hd->Image.Time) ;
   fprintf (stdout, "hd->Xdim:                  %8d\n", hd->Xdim) ;
   fprintf (stdout, "hd->Ydim:                  %8d\n", hd->Ydim) ;
   fprintf (stdout, "hd->Duration:              %8d\n", hd->Duration) ;
   fprintf (stdout, "hd->JuldRef:               %8d\n", hd->JuldRef) ;
   fprintf (stdout, "hd->ImgDataType:           %8d\n", hd->ImgDataType) ;
   fprintf (stdout, "hd->Fill1 [0]:             %8d\n", hd->Fill1 [0]) ;
   fprintf (stdout, "hd->Fill1 [1]:             %8d\n", hd->Fill1 [1]) ;
   fprintf (stdout, "hd->Pangle:                %8.2f\n", hd->Pangle) ;
   fprintf (stdout, "hd->Bangle:                %8.2f\n", hd->Bangle) ;
   fprintf (stdout, "hd->Langle:                %8.2f\n", hd->Langle) ;
   fprintf (stdout, "hd->RA:                    %8.2f\n", hd->RA) ;
   fprintf (stdout, "hd->Dec:                   %8.2f\n", hd->Dec) ;
   fprintf (stdout, "hd->HA:                    %8.2f\n", hd->HA) ;
   fprintf (stdout, "hd->Elevation:             %8.2f\n", hd->Elevation) ;
   fprintf (stdout, "hd->Azimuth:               %8.2f\n", hd->Azimuth) ;
   fprintf (stdout, "hd->Amass:                 %8.2f\n", hd->Amass) ;
   fprintf (stdout, "hd->Radius:                %8.2f\n", hd->Radius) ;
   fprintf (stdout, "hd->SkyTx:                 %8.2f\n", hd->SkyTx) ;
   fprintf (stdout, "hd->InstrPhs:              %8.2f\n", hd->InstrPhs) ;
   fprintf (stdout, "hd->SkyTxUsed:             %8.2f\n", hd->SkyTxUsed) ;
   fprintf (stdout, "hd->data_scale:           %8.3e\n",  hd->data_scale) ;
   fprintf (stdout, "hd->data_offset:           %8.2f\n", hd->data_offset) ;
   fprintf (stdout, "hd->spare2:                %8.2f\n", hd->spare2) ;
   fprintf (stdout, "hd->orighairspot [0]:      %8.2f\n", hd->orig_hairspot [0]) ;
   fprintf (stdout, "hd->orighairspot [1]:      %8.2f\n", hd->orig_hairspot [1]) ;
   fprintf (stdout, "hd->hairspot [0]:          %8.2f\n", hd->hairspot [0]) ;
   fprintf (stdout, "hd->hairspot [1]:          %8.2f\n", hd->hairspot [1]) ;

   fprintf (stdout, "hd->Xcen:                  %8.2f\n", hd->Xcen) ;
   fprintf (stdout, "hd->Ycen:                  %8.2f\n", hd->Ycen) ;
   fprintf (stdout, "hd->pixscl:                %8.2f\n", hd->pixscl) ;
   fprintf (stdout, "hd->r0:                    %8.6f\n", hd->r0) ;
   fprintf (stdout, "hd->dr:                %12.8f\n",    hd->dr) ;
   fprintf (stdout, "hd->rmax:                  %8.2f\n", hd->rmax) ;
   fprintf (stdout, "hd->theta_min:             %8.2f\n", hd->theta_min) ;
   fprintf (stdout, "hd->theta_max:             %8.2f\n", hd->theta_max) ;
   fprintf (stdout, "hd->raw_theta_min:         %8.2f\n", hd->raw_theta_min) ;
   fprintf (stdout, "hd->raw_theta_max:         %8.2f\n", hd->raw_theta_max) ;
   fprintf (stdout, "hd->backlash:              %8.2f\n", hd->backlash) ;
   fprintf (stdout, "hd->Phase:                 %8.2f\n", hd->Phase) ;
   fprintf (stdout, "hd->ObsType:               %8d\n", hd->ObsType) ;
   fprintf (stdout, "hd->DataType:              %8d\n", hd->DataType) ;
   fprintf (stdout, "hd->ProcSteps:             %8d\n", hd->ProcSteps) ;
   fprintf (stdout, "hd->Direction:             %8d\n", hd->Direction) ;
   fprintf (stdout, "hd->Nray:                  %8d\n", hd->Nray) ;
   fprintf (stdout, "hd->Pixels:                %8d\n", hd->Pixels) ;
   fprintf (stdout, "hd->Fill2 [0]:             %8d\n", hd->Fill2 [0]) ;
   fprintf (stdout, "hd->Date_calibrated.Year:     %8d\n", hd->Date_calibrated.Year) ;
   fprintf (stdout, "hd->Date_calibrated.Month:    %8d\n", hd->Date_calibrated.Month) ;
   fprintf (stdout, "hd->Date_calibrated.Day:      %8d\n", hd->Date_calibrated.Day) ;
   fprintf (stdout, "hd->Date_calibrated.Hour:     %8d\n", hd->Date_calibrated.Hour) ;
   fprintf (stdout, "hd->Date_calibrated.Minute:   %8d\n", hd->Date_calibrated.Minute) ;
   fprintf (stdout, "hd->Date_calibrated.CentiSec: %8d\n", hd->Date_calibrated.CentiSec) ;
   fprintf (stdout, "hd->Date_calibrated.Juld:     %8d\n", hd->Date_calibrated.Juld) ;
   fprintf (stdout, "hd->Date_calibrated.Doy:      %8d\n", hd->Date_calibrated.Doy) ;
   fprintf (stdout, "hd->Date_calibrated.Time:     %8d\n", hd->Date_calibrated.Time) ;
   fprintf (stdout, "hd->tscpfile:              %s\n", hd->tscpfile) ;
   fprintf (stdout, "hd->reffile:               %s\n", hd->reffile) ;
   fprintf (stdout, "hd->version:               %s\n", hd->version) ;
   fprintf (stdout, "hd->AvgTimes:              %s\n", hd->AvgTimes) ;

   fprintf (stdout, "hd->ID.JuldRange[0]:   %12.2f\n", hd->ID.JuldRange [0]) ;
   fprintf (stdout, "hd->ID.JuldRange[1]:   %12.2f\n", hd->ID.JuldRange [1]) ;
   fprintf (stdout, "hd->ID.Bopal:              %8.2f\n", hd->ID.Bopal) ;
   fprintf (stdout, "hd->ID.trt:                %8.2f\n", hd->ID.trt) ;
   fprintf (stdout, "hd->ID.fpt:                %8.2f\n", hd->ID.fpt) ;
   fprintf (stdout, "hd->ID.IDspare:            %8.2f\n", hd->ID.IDspare) ;
   fprintf (stdout, "hd->ID.kappa:              %8.2f\n", hd->ID.kappa) ;
   fprintf (stdout, "hd->ID.BarrelOffset:       %8.2f\n", hd->ID.BarrelOffset) ;
   fprintf (stdout, "hd->ID.hairspot[0]:        %8.2f\n", hd->ID.hairspot[0]) ;
   fprintf (stdout, "hd->ID.hairspot[1]:        %8.2f\n", hd->ID.hairspot[1]) ;
   fprintf (stdout, "hd->ID.r0:                 %8.6f\n", hd->ID.r0) ;
   fprintf (stdout, "hd->ID.dr:             %12.8f\n",    hd->ID.dr) ;
   fprintf (stdout, "hd->ID.goodRmin:           %8.2f\n", hd->ID.goodRmin) ;
   fprintf (stdout, "hd->ID.goodRmax:           %8.2f\n", hd->ID.goodRmax) ;
   fprintf (stdout, "hd->ID.biasspot[0]         %8.2f\n", hd->ID.biasspot[0]) ;
   fprintf (stdout, "hd->ID.biasspot[1]         %8.2f\n", hd->ID.biasspot[1]) ;
   fprintf (stdout, "hd->ID.ZeroSky:            %8.2f\n", hd->ID.ZeroSky) ;
   fprintf (stdout, "hd->ID.VenusCalFac:        %8.2f\n", hd->ID.VenusCalFac) ;
   fprintf (stdout, "hd->ID.ExtraCalFac:        %8.2f\n", hd->ID.ExtraCalFac) ;
   fprintf (stdout, "hd->ID.DiffractFac:        %8.2f\n", hd->ID.DiffractFac) ;
   fprintf (stdout, "hd->ID.DiffractPix:        %8d\n", hd->ID.DiffractPix) ;
   fprintf (stdout, "hd->ID.PhiPix:             %8d\n", hd->ID.PhiPix) ;
   fprintf (stdout, "hd->ID.PolarityCkPix:      %8d\n", hd->ID.PolarityCkPix) ;
   fprintf (stdout, "hd->ID.NegPix[0]           %8d\n", hd->ID.NegPix[0]) ;
   fprintf (stdout, "hd->ID.NegPix[1]           %8d\n", hd->ID.NegPix[1]) ;
   fprintf (stdout, "hd->ID.WrapPix[1]:         %8d\n", hd->ID.WrapPix[1]) ;
   fprintf (stdout, "hd->ID.RingSearch[0]:      %8d\n", hd->ID.RingSearch[0]) ;
   fprintf (stdout, "hd->ID.RingSearch[1]:      %8d\n", hd->ID.RingSearch[1]) ;
   fprintf (stdout, "hd->ID.RingFixPix:         %8d\n", hd->ID.RingFixPix) ;
   fprintf (stdout, "hd->ID.CorrectFile0:       %s\n", hd->ID.CorrectFile0) ;
   fprintf (stdout, "hd->ID.CorrectFile1:       %s\n", hd->ID.CorrectFile1) ;

/*
 *   fflush (stdout) ;
 */
   }

   return (0) ;
}
