/* read_long.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Author: Alice Lecinski   HAO/NCAR   read_long
 * Extracted from "rdwrtmk4.c" by Andrew L. Stanger   2 Nov 2001
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

int
read_long (filenm, img, imsz, doprint)

char *filenm;
long *img;
int   imsz;
int   doprint;
{
    int ii, hdsz;
    FILE *fid;

    if (doprint > 0) fprintf (stderr, "\tReading %s\n", filenm);

    if ( ( fid = fopen (filenm, "r") ) == NULL  )
	{
	fprintf (stderr, "Error opening %s for reading.\n", filenm);
	exit (-90);
	}

    if ( ( ii = fread (img, sizeof (long), imsz, fid)) != imsz )
	{
	fprintf (stderr, "Image read error:\n\
		 Only read %d longs from %s\nExpected %d", 
		 ii, filenm, imsz);
	fclose(fid);
	exit (-94);
	}

    fclose (fid);

    return (0) ;
}
