/* read_mk4_head.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Read Mk4 binary header.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   1 Nov 2001
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>

#include "mk4v2.h"
#include "mk4headv2.h"
#include "mk4fitsv2.h"

/* -------------------------------------------------------------------------- */

/*** Read MLSO/Mark-IV image header. ***/

int
read_mk4_head (namimg, hd, pmode) 

char *namimg ; 
struct mk4_header *hd ; 
int pmode ;
{
    int nbyhead ;
    int nread ;
    FILE *fid ;

    if (pmode > 0)
	fprintf (stderr, "read_mk4_head> read header %s \n", namimg) ;

    /*** Open file. ***/

    if ( ( fid = fopen (namimg, "r") ) == NULL  )
	{
	fprintf (stderr, "read_mk4_head> fopen error %s\n", namimg) ;
	exit (-1) ;
        }

    /*** Read header. ***/

    nbyhead = sizeof (mk4head) ;

    if ( ( nread = fread (hd, 1, nbyhead, fid)) != nbyhead )
	{
	fprintf (stderr, "read_mk4_head> %s nread:%d != %d",
		 namimg, nread, nbyhead) ;
	fclose (fid) ;
	exit (-2) ;
        }

    /*** Fill FITS information structure. ***/

    mk4hdu (hd, pmode) ;

    /*** Close file. ***/

    fclose (fid) ;

    return (0) ;
}

/* -------------------------------------------------------------------------- */

