/* fixmonth.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Increment DPM FITS month in DATE-OBS parameter.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   7 June 1994
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>

main (argc, argv)

int argc ;
char *argv [] ;
{
   static char hdu [36][80] ;		/* HDU buffer. */
   static char namimg [80] ;		/* Image filename. */
   static char namout [80] ;		/* Image filename. */
   static char line   [84] ;		/* Line buffer. */
   static char cmonth [4] ;		/* ASCII representation of month num. */
   char *fitbuf ;
   int fd ;				/* File descriptor. */
   int i ;
   int iarg = 0;			/* argument counter. */
   int idot ;				/* dot location in filename. */
   int month ;				/* Month. */
   int nbytes ;				/* # bytes in file. */
   struct stat FS, *fs ;

   fs = &FS ;				/* Assign pointer to FS structure. */

   while (++iarg < argc)
      {
      strcpy (namimg, argv [iarg]) ;			/* Get filename. */
      if ((fd = open (namimg, 0)) <= 0)			/* Open FITS file. */
	 {
	 fprintf (stderr, "Unable to open file: %s\n", namimg) ;
	 exit (-1) ;
	 }
      fstat (fd, fs) ;				/* Get file status struct. */
      nbytes = fs->st_size ;			/* Get file size (bytes). */
      fitbuf = (char *) malloc (nbytes) ;	/* Allocate memory. */
      printf ("%s\n", namimg) ;
      read (fd, fitbuf, nbytes) ;		/* Read image from disk. */

      strncpy (hdu, fitbuf, 2880) ;		/* Copy first FITS record. */
      sscanf (&hdu [11][14], "%d", &month) ;	/* Get month value. */
      strncpy (line, &hdu [11][0], 80) ;	/* Copy line 11. */
      printf ("line 11: %80s\n", line) ;	/* Print line 11. */
      close (fd) ;				/* Close input file. */

      month += 1 ;				/* Increment month. */
      sprintf (cmonth, "%02d", month) ;		/* ASCII version of month num.*/
      strncpy (&hdu [11][14], cmonth, 2) ;	/* Write new month into hdu. */
      strncpy (line, &hdu [11][0], 80) ;	/* Copy line 11. */
      printf ("line 11: %80s\n", line) ;	/* Print line 11. */

      strncpy (fitbuf, hdu, 2880) ;

      for (i = 0 ; i < strlen (namimg) ; i++)
	 if (namimg [i] == '.')  idot = i ;
      strcpy (namout, namimg) ;
      namout [idot+1] = '\0' ;
      strcat  (namout, "fts") ;

      fd = creat (namout, 0644) ;		/* Open output file. */
      write (fd, fitbuf, nbytes) ;		/* Write to disc file. */
      close (fd) ;				/* Close output file. */
      free (fitbuf) ;
      }
}
