/* rdmk3st.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Read MLSO Mark-III scan times.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   23 February 1994
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "/home/stanger/lib/include/mk3lib.ext"

rdmk3st (namest)

char namest [] ;

{
   static short sbuf [720];
   static float st [720];
   FILE *FD;
   int i;
   float straw  = 0.0 ;
   float stadj  = 0.0 ;
   float stcor  = 0.0 ;

   mk3hskp (namest, 0) ;				/* Read MK3 tailer. */

   if ((FD = fopen (namest, "r")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", namest) ;
      exit (-1) ;
      }

   fread (sbuf, sizeof (short), MK3H->nray, FD) ;

   fclose (FD) ;

   printf ("rdmk3st> nray:%d\n", MK3H->nray) ;

   fprintf (stdout, "Scan Times: index, short, raw[sec]\n");

   for (i = 0; i < MK3H->nray; i++)
      {
      straw = ((float) sbuf [i] / 60.0) ;
      st [i] = straw ;
      fprintf (stdout, "%3d   %5d   %8.4f\n",
	       i, sbuf [i], straw);
      }

   return (0) ;
}
