/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * get_input : get input from keyboard or mouse.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
get_input (nampos, fdpos, xo, yo, xs, ys, xmaxscrn, ymaxscrn)

char nampos [];			/* Cursor measurement file. */
FILE *fdpos;			/* File descriptor: cursor measurement file. */
int *xo, *yo;			/* Window origin. */
int *xs, *ys;			/* Window size. */
int xmaxscrn, ymaxscrn;		/* Screen size. */

{
   short val;
   Colorindex dummy;		/* for strict ANSI C prototyping */
   int boxsize = 3;		/* size of box to indicate cursor points. */
   int dev;
   static int poly [100][2];
   int ip = 0;
   int xocp = 63, yocp = 510;	/* C/P image origin in window coordinates. */
   int xwin, ywin;		/* x/y window coordinates. */

   float xcp, ycp;		/* x/y coordinates for C/P image file. */
   float r, th;			/* radius & position angle for C/P image. */

   while (1)
      {
      while (qtest ())
         {
         dev = qread (&val);
         switch (dev)
            {
            case ESCKEY:	/* Terminate program. */
                 setvaluator (MOUSEX, (short)(*xs/2), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(*ys/2), 0, ymaxscrn);
                 fclose (fdpos);
                 if (measure == 0)  unlink (nampos);
                 closepl ();
                 fb_close ();
                 gexit ();
                 exit (0);
                 break;

            case REDRAW:	/* Clear window to black. */
                 reshapeviewport ();
                 getsize (*xs, *ys);
                 getorigin (*xo, *yo);
                 color (BLACK);
                 clear ();
                 break;

            case ZEROKEY:	/* Fill polygon. */
                 if (val == 1)
                    {
                    polyfill (poly, ip, color4);
                    acpmass ("none", namcmp, 0, 0.0, pgmlog, wpos, nwp);
                    }
                 break;

            case ONEKEY:	/* cursor associated with 1-key. */
                 setcursor (1, dummy, dummy);
                 setvaluator (MOUSEX, (short)(*xo + (0.5 * *xs)), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(*yo + (0.5 * *ys)), 0, ymaxscrn);
                 break;

            case TWOKEY:	/* cursor associated with 2-key. */
                 setcursor (2, dummy, dummy);
                 setvaluator (MOUSEX, (short)(*xo + (0.5 * *xs)), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(*yo + (0.5 * *ys)), 0, ymaxscrn);
                 break;

            case THREEKEY:	/* cursor associated with 3-key. */
                 setcursor (3, dummy, dummy);
                 setvaluator (MOUSEX, (short)(*xo + (0.5 * *xs)), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(*yo + (0.5 * *ys)), 0, ymaxscrn);
                 break;

            case LEFTMOUSE:	/* Left Mouse Button. */
                 measure++;
                 if (val == 1)	/* Read position when left key depressed. */
                    {
                    getdev (XY, mdev, mval);
                    xwin = mval [X] - *xo;		/* x window position. */
                    ywin = mval [Y] - *yo;		/* y window position. */
                    xcp = (float) (xwin - xocp); 	/* x C/P position. */
                    ycp = (float) (yocp - ywin); 	/* y C/P position. */
                    rcoord (&r, &th, &xcp, &ycp, -1, scroll);	/* Get r & th.*/
                    fprintf (stdout, " %3d  %3d  %3.0f  %3.0f  %5.2f  %6.2f\n",
                             xwin, ywin, xcp, ycp, r, th);
                    fprintf (fdpos, "%3d %3d\n", xwin, ywin);
/*
 *                    fprintf (fdpos,  " %3d  %3d  %3.0f  %3.0f  %5.2f  %6.2f\n",
 *                             xwin, ywin, xcp, ycp, r, th);
 */
                    wglbox (xwin, ywin, boxsize, RED);	/* Draw small box. */
                    poly [ip][0] = xwin;
                    poly [ip][1] = ywin;
                    ip++;
                    }
                 break;

            default:
                 break;
            }
         }
      }
}
