FREE_LUN getspartan, fn, c, nocon=nocon

; Gets the data associated with the mneumonic.
;
;	Author: G. Ucker
;	Date:	15 Nov 1993
;
; MODIFICATIONS:
;
;fmtloc = '/local/pcnfs/Spartan/programs/'

fmtloc = '/home/riker/stanger/idl/lib/card/'

dat = 0.0
c   = 0.0

ON_IOERROR,  NOT_FOUND

IF (n_params (0) EQ 0) THEN BEGIN
	IF (0) THEN BEGIN
		NOT_FOUND:
		PRINT, ' '
		PRINT, 'GETSPARTAN: File not found,  please try again... '
		PRINT, ' '
	ENDIF
	fn = ' '
	READ, 'Enter file mneumonic (no extension): ', fn
ENDIF

;--- Get YEAR from mneumonic.

fn   = STRUPCASE (STRTRIM (fn, 2))
spyr = STRMID (fn, 1, 2)

;--- Determine directory location for Database files.

CASE spyr OF
;	'93': dloc = '/local/pcnfs/tmp/Spartan/sp201-1/dbase/'
;	'94': dloc = '/local/pcnfs/tmp/Spartan/sp201-2/dbase/'
;	'95': dloc = '/local/pcnfs/tmp/Spartan/sp201-3/dbase/'
	'95': dloc = '/riker/d/spartan/sp201-3/dbase/'
;	'97': dloc = '/local/pcnfs/tmp/Spartan/sp201-4/dbase/'
	ELSE: BEGIN
		PRINT, 'Not finding the database... exiting...'
		RETURN, -1L
              END
ENDCASE

;--- Format Definitions.

fmt_defs = [fmtloc + 'sptmfmt' + spyr + '.lis', $
	    fmtloc + 'spimfmt' + spyr + '.lis', $
	    fmtloc + 'spmsfmt' + spyr + '.lis']

spgetfmt, fmt_defs, fmt

;--- Open data file.

GET_LUN, lun
OPENR, lun, dloc + fn + '.dat'

ON_IOERROR, NULL

st = FSTAT (lun)
it = WHERE (fmt(*).spyr EQ STRMID (fn, 0, 3))
i  = it (0)

IF (i GE 0) THEN BEGIN
	jt = WHERE (fmt(i).iname EQ STRMID (fn, 4, 100))
	j = jt (0)
ENDIF ELSE BEGIN
	PRINT, 'GETSPARTAN: spartan_yr not found... exiting...
	RETURN, dat
ENDELSE

IF (j GE 0) THEN BEGIN
CASE fmt(i).ilen(j) OF

	1:	BEGIN
		a = ASSOC (lun, BYTARR (st.size))
		dat = a (0)
		c = fmt(i).conv(*, j)
		END

	2:	BEGIN
		a = ASSOC (lun, intarr (st.size / fmt(i).ilen(j)))
		dat = a (0)
		c = fmt(i).conv(*, j)
		IF (NOT (KEYWORD_SET (nocon))) then $
			dat = FLOAT (dat) * c (0) / c (1) + c (2)
		END

	4:	BEGIN
		a = ASSOC (lun, LONARR (st.size / fmt(i).ilen(j)))
		dat = a(0)
		c = fmt(i).conv(*, j)
		IF (NOT (KEYWORD_SET (nocon))) THEN $
			dat = DOUBLE (dat) * c (0) / c (1) + c (2)
		END

	ELSE:	BEGIN
		a = ASSOC (lun, BYTARR (st.size))
		dat = a (0)
		c = fmt(i).conv(*, j)
		END

ENDCASE

ENDif ELSE BEGIN
	PRINT, 'GETSPARTAN: Item mneumonic not found in fmt,  exiting...'
	RETURN, dat
ENDELSE

CLOSE, lun
FREE_LUN, lun

RETURN, dat
END
