/* -----------------------------------------------------------------------------
 * curved.h - minimal curve editor variables.
 * -----------------------------------------------------------------------------
 * Paul Haeerli - 1985
 * -----------------------------------------------------------------------------
 */

float endgeom [4][3];
float geom [100][3];
int pt [100];

#define ADDPOINT        1
#define MOVEPOINT       2
#define INSERTPOINT     3
#define DELETEPOINT     4
#define CHANGEPOINT     5

#define BACKGROUND    254
#define LINE            0

#define ROUND           1
#define SQUARE          2

#define MOUSEXMAP (x)    ( (100.0*((x)-xorg))/xsize )
#define MOUSEYMAP (y)    ( (100.0*((y)-yorg))/ysize )

unsigned short raster [] = { 0xf800, 0x8800, 0x8800, 0x8800, 0xf800,
                             0x7000, 0x8800, 0x8800, 0x8800, 0x7000, };

Fontchar chars [] = { {0,0,0, 0, 0,0},
                      {0,5,5,-2,-2,5},
                      {5,5,5,-2,-2,5}, };

Matrix b_spline = { {-1.0/6.0, 1.0/2.0,  -1.0/2.0, 1.0/6.0},
                    { 1.0/2.0,    -1.0,   1.0/2.0,     0.0},
                    {-1.0/2.0,     0.0,   1.0/2.0,     0.0},
                    { 1.0/6.0, 2.0/3.0,   1.0/6.0,     0.0} };

Matrix lob_spline = { {     0.0,       0.0,       0.0,  0.0},
                      { 1.0/3.0,  -2.0/3.0,   1.0/3.0,  0.0},
                      {-7.0/6.0,   4.0/3.0,  -1.0/6.0,  0.0},
                      {     1.0,       0.0,       0.0,  0.0}, };

Matrix hib_spline = { {0.0,       0.0,       0.0,      0.0},
                      {0.0,   1.0/3.0,  -2.0/3.0,  1.0/3.0},
                      {0.0,  -1.0/2.0,       0.0,  1.0/2.0},
                      {0.0,   1.0/6.0,   2.0/3.0,  1.0/6.0}, };

Matrix c_spline =  { {-0.5,   1.5,  -1.5,   0.5},
                     { 1.0,  -2.5,   2.0,  -0.5},
                     {-0.5,   0.0,   0.5,   0.0},
                     { 0.0,   1.0,   0.0,   0.0} };

Matrix loc_spline = { { 0.0,   0.0,   0.0,  0.0},
                      { 0.5,  -1.0,   0.5,  0.0},
                      {-1.5,   2.0,  -0.5,  0.0},
                      { 1.0,   0.0,   0.0,  0.0} };

Matrix hic_spline = { {0.0,  0.0,  0.0,  0.0},
                      {0.0,  0.5, -1.0,  0.5},
                      {0.0, -0.5,  0.0,  0.5},
                      {0.0,  0.0,  1.0,  0.0} };

#define BSPLINE          100
#define LOBSPLINE        101
#define HIBSPLINE        102

int xsize, ysize;
int xorg, yorg;
float mx, my;
int curmode = ADDPOINT;
int points;
int menu;
