/* glcpz_scalers.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Draw solar radius measuring scale.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 *  4 April 1991: SGI/GL version.
 * 24 June  1993: fix "+" location for low resolution images.
 *  4 Jan   1994: 1024x1024 pixel display window.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include "/home/stanger/lib/include/cplib.ext"
#include "/home/stanger/lib/include/img_scale.ext"

glcp_scalers (cindex)

int cindex;	/* Color LUT index. */
{
int x;
int ixg = 127;	/* X-dimension offset for image in window. */
int dxg = 896;	/* X-dimension image size. */
int xgs, xgdim;
int gpixrs;	/* # pixels/Rsun. */
int tx =    8;	/* Size of 1/2 of tick mark. */
int tgx;
int yt;		/* frame buffer y-coordinate for top of tick mark. */
int ym;		/* frame buffer y-coordinate for middle of tick mark. */
int yb = 104;	/* frame buffer y-coordinate for bottom of tick mark. */
int ygb;
int kres ;

   kres = H.ires + 1 ;
   xgs   = ixg;
   xgdim = dxg;
   ygb   = yb ;
   tgx   = tx ;

   ym = ygb + tgx;
   yt = ym  + tgx;

   /*** Draw ticks along the bottom of the image. ***/

   gpixrs = (pixrs + 0.5) * kres;
   x = (int) xcen * kres + gMINROW;
   gl_wvec (x-tgx, ym, x+tgx, ym, cindex);
   gl_wvec (x, yt, x, ygb, cindex);

/*
 *   fprintf (stdout, "glcp_scalers> kres: %d   gpixrs: %6.2f\n",
 *	   kres, gpixrs);
 *   fprintf (stdout, "glcp_scalers> xgs: %4d   xgs+xgdim: %4d\n",
 *            xgs, xgs+xgdim);
 *   fprintf (stdout, "glcp_scalers> res:%d  pixrs:%5.2f gpixrs:%3d xcen:%5.2f x:%3d gMINROW:%3d\n",
 *	      H.ires, pixrs, gpixrs, xcen, x, gMINROW);
 */

   while ( ( (x += gpixrs) > xgs) && (x < (xgs + xgdim) ) )
      {
      gl_wvec (x, yt, x, ygb, cindex);
/*
 *      fprintf (stdout, "glcp_scalers>   x: %4d    yt: %4d   x: %4d   ygb: %4d\n",
 *               x, yt, x, ygb);
 */
      }

   x = (int) xcen * kres + gMINROW;
   while ( ( (x -= gpixrs) > xgs) && (x < (xgs + xgdim) ) )
      {
      gl_wvec (x, yt, x, ygb, cindex);
/*
 *      fprintf (stdout, "glcp_scalers>   x: %4d    yt: %4d     x: %4d   ygb: %4d\n",
 *               x, yt, x, ygb);
 */
      }

   return (0);
}
