/* glecl_view.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *  Display an eclipse image ('filename') in SGI IRIS GL window.
 * . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
 * NOTE: image intensity levels 251 through 254 are used for annotation
 *       and graphics.  Their colors will depend upon what hues are assigned
 *       to those intensity levels.
 * . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
 * Andrew L. Stanger   HAO/NCAR   SMM C/P
 * 24 May 1991: use onemap color mode.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include <gl/gl.h>
#include "/usr/people/smm/lib/src/gl/gl_color.h"


/* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

glecl_view (filename)

char *filename;		/* Pointer to filename array. */

{
   extern char *malloc ();
   int fd;
   int i;
   int bytsiz, imgsiz;
   Screencoord ix = 0, iy = 0;
   Screencoord nx = 960;
   Screencoord ny = 640;
   unsigned short *imgbuf;
   char *bytbuf;

   if ((fd = open (filename)) <= 0)
      {
      fprintf (stderr, "Unable to open file %s\n", filename);
      exit (-1);
      }

   bytsiz = nx * ny;
   bytbuf = (char *) malloc (bytsiz);
   read (fd, bytbuf, bytsiz);
   imgsiz = nx * ny * sizeof (short);
   imgbuf = (unsigned short *) malloc (imgsiz);
   for (i=0; i<bytsiz; i++)
      {
      *(imgbuf + i) = (unsigned short) *(bytbuf + i);
      if (i/1000*1000 == i)  fprintf (stdout, "i: %6d   imgbuf: %d\n",
                                      i, *(imgbuf + i));
      }
   
   rectwrite (ix, iy, nx-1, ny-1, imgbuf);

   return (0);
}
