/* poly_fill.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Polygon fill
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 4 November 1991: "Computer Graphics" by Donald Hearn & M. Pauline Baker
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
fill_area_solid (count, x, y)

int x [];		/* Array of x coordinates of vertices. */
int y [];		/* Array of y coordinates of vertices. */
int count;		/* # vertices. */
{
   struct entry
      {
      int ytop;		/* larger y coordinate for line. */
      int deltay;		/* x which goes with larger y. */
      float xint;		/* difference in y coordinates. */
      float dx;		/* x change per unit change in y. */
      };
   struct each_entry list [];
   struct list sides;

   int first_s, last_s;
   int side_count;
   int bottomscan;
   int x_int_count;
   int r;

   sort_bigy (count, x, y, sides, side_count, bottomscan);

   first_s = 1;
   last_s = 1;
   for (scan=sides [1].y_top; scan < bottomscan; scan--)
      {
      update_first_&_last (sides, count, scan, first_s, last_s);
      process_x_intersections (sides, scan, first_s, last_s, x_int_count);
      draw_lines (sides, scan, x_int_count, first_s);
      update_sides_list (sides);
      }
   return (0);
}


sort_on_bigger_y (n, x, y, sides, side_count, bottomscan)

int n;			/* */
int x [];		/* x coordinates of vertices. */
int y [];		/* y coordinates of vertices. */
struct list sides;
int side_count;
int bottomscan;
{
   int k;
   int x1, y1;
}


next_y (k)

int k;

{
/* returns value of next vertex whose y coordinate is not equal to y [k] */
   return (0);
}


put_in_dies_list (sides, entry, x1, y1, x2, y2, next_y)

struct list sides;
int entry;
int x1, y1;
int x2, y2;
int next_y;

{
   int maxy;
   float x2_temp;
   float x_change_temp;

   /* Make adjustments for problem vertices */
   x_change_temp = (x2 - x1) / (y2 - y1);
   x2_temp = x2;
   if ((y2 > y1) || (y2 < next_y))
      {
      y2 = y1 -1;
      x2_temp -= x_change_temp;
      }
   else
      {
      if ((y2 < y1) ||(y2 > next_y))
         {
         y2 += 1;
         x2_temp += x_change_temp;
         }
      }      

   /*** Insert into sides list. ***/

   if (y1 > y2)
      maxy = y1;
   else   
      maxy = y2;

   while ((entry > 1) && (maxy > sides [entry-1].y_top)
      {
      sides [entry] = sides [entry-1];
      entry -= 1;
      }

   with sides [entry]
      {
      y_top = maxy;
      delta_y = (int) abs ((double (y2-y1)) + 1;
      if (y1 > y2)
         x_int = x1;
      else
         x_int = x2_temp;
      x_change_per_scan = x_change_temp;
      }
   return (0);
}


sort_on_bigger_y ()

{
   side_count = 0;
   y1 = y [n];
   x1 = x [n];
   bottomscan = y [n];

   for (k=1; k<=n; i++)
      {
      if (y1 < y [k]		/* Put non-horizontal edges in table. */
         {
         side_count += 1;

         /* Pass old point, current point & y of next horiz. point. */

         put_in_sides_list (sides, side_count, x1, y1, x [k], y [k], next_y [k]);
         }
      else			/* Horizontal. */
         {
         			/* Draw x1,y1 to x[k],y1 with fill_color. */
         if (y [k] < bottomscan)  bottomscan = y [k];
         y1 = y [k];
         x1 = x [k];		/* Save for next side. */
         }
      }

   return (0);
}


update_first_&_last (sides, count, scan)

struct list sides;
int count;
int scan;
{
   int first_s, last_s;

   while ((sides [last_s + 1].y_top >= scan) && (last_s < count))
      last_s += 1;

   while (sides [first_s].delta_y == 0)
      first_s += 1;

   return (0);
}


process_x_intersections (sides, scan, first_s, last_s, x_int_count)

struct list sides;
int scan;
int first_s, last_s;
int x_int_count;
{
   int k;

/* Swap is predefined & reverses placement of two entries within table sides. */

}


sort_on_x (entry, first_s)
{
}

}
