/* gl_cmap.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * SGI/GL utilities.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <gl/gl.h>

/* gl_wclear
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Clears GL window to color referenced by LUT index.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

gl_wclear (mapindex)

Colorindex mapindex;

{
   color (mapindex);
   clear ();

   return (0);
}

/* get_cmap 
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Saves SGI colormap contents in arrays CarrayR, CarrayG, CarrayB.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#define MAXCOLI 4095 

static short CarrayR [MAXCOLI+1], CarrayG [MAXCOLI+1], CarrayB [MAXCOLI+1];
unsigned short Cindex;

get_cmap ()

{
   short rcomp, gcomp, bcomp;

   for (Cindex = 0; Cindex <= MAXCOLI; Cindex++)
      {
      getmcolor (Cindex, &rcomp, &gcomp, &bcomp);
      CarrayR [Cindex] = rcomp;
      CarrayG [Cindex] = gcomp;
      CarrayB [Cindex] = bcomp;
    }
}

/* restore_cmap 
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Restores SGI colormap contents from arrays CarrayR, CarrayG, CarrayB.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

restore_cmap ()
{

   for (Cindex = 0; Cindex <= MAXCOLI; Cindex++) 
      mapcolor (Cindex, CarrayR [Cindex], CarrayG [Cindex], CarrayB [Cindex]);
}
