/* glcp_scalers.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Draw solar radius measuring scale.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 *  4 April 1991: SGI/GL version.
 * 10 October 1995: yb = gMINROW - 11 (instead of fixed value of 52).
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include "/usr/people/smm/lib/include/cplib.ext"
#include "/usr/people/smm/lib/include/img_scale.ext"

glcp_scalers (cindex)

int cindex;	/* Color LUT index. */
{
int x;
int ixg = gMINCOL;
int dxg = npix;
int xgs, xgdim;
int gpixrs;
int tx = 4;	/* Size of 1/2 of tick mark. */
int tgx;
int yt;		/* frame buffer y-coordinate for top of tick mark. */
int ym;		/* frame buffer y-coordinate for middle of tick mark. */
int yb = 52;	/* frame buffer y-coordinate for bottom of tick mark. */
int ygb;

   yb = gMINROW - 11 ;

   if (nres == 1)
      {
      xgs = ixg;
      xgdim = dxg;
      ygb = yb;
      tgx = tx;
      }
   else
   if (nres == 2)
      {
      xgs = ixg * 2;
      xgdim = dxg * 2;
      ygb = yb * 2;
      tgx = tx * 2;
      }

   /*** Write black in Rsun scale box. ***/

/*    wsolid (0, xgs, ygb, xgdim, tgx), "ru"); */

    ym = ygb + tgx;
    yt = ym + tgx;

   /*** Draw ticks along the bottom of the image. ***/

    gpixrs = pixrs / nres;
    x = (int) xcen / nres + gMINCOL;
    gl_wvec (x-tgx, ym, x+tgx, ym, cindex);
    gl_wvec (x, yt, x, ygb, cindex);

    while (((x += gpixrs) > xgs) && (x < (xgs + xgdim)))
      {
      gl_wvec (x, yt, x, ygb, cindex);
      }

    x = (int) xcen / nres + gMINCOL;
    while (((x -= gpixrs) > xgs) && (x < (xgs + xgdim)))
      {
      gl_wvec (x, yt, x, ygb, cindex);
      }
   return (0);
}
