/*
 *  curpos.c:
 *
 * Shows how to define and run a program that has more than one cursor defined.
 */

#include <stdio.h>
#include <gl/gl.h>
#include <gl/device.h>
#define XY 2
#define X 0
#define Y 1

static Cursor fly = {0x0000, 0x1818, 0x2574, 0x2244, 
                     0x2184, 0xA185, 0xA185, 0xA185, 
                     0x518A, 0x2994, 0x1FF8, 0x15A8, 
                     0x2A54, 0x4BD2, 0x4422, 0x4002};

static unsigned short hourglass[16] = {0x7FFE, 0x43E2, 0x21C4, 0x308C,
                                       0x2814, 0x2424, 0x2244, 0x2244,
                                       0x23C4, 0x23C4, 0x27E4, 0x2FF4,
                                       0x33CC, 0x2004, 0x4002, 0x7FFE};

static Cursor plus = {0x0100, 0x0100, 0x0100, 0x0100,
                      0x0100, 0x0100, 0x0100, 0xFEFE,
                      0x0100, 0x0100, 0x0100, 0x0100,
                      0x0100, 0x0100, 0x0100, 0x0000};
 
static Cursor plus1 = {0x0100, 0x0100, 0x0100, 0x0100,
                       0x0100, 0x0100, 0x0380, 0xFEFE,
                       0x0380, 0x0100, 0x0100, 0x0100,
                       0x0100, 0x0100, 0x0100, 0x0000};
 
static Cursor asterisk = {0x8102, 0x4104, 0x2108, 0x1110,
                          0x0920, 0x0540, 0x0380, 0xFEFE,
                          0x0380, 0x0540, 0x0920, 0x1110,
                          0x2108, 0x4104, 0x8102, 0x0000};
 

main ()
{

   Device mdev [XY];
   short mval [XY];
   short val;
   short xpos, ypos, num;
   unsigned short cursor [128];
   long dev;
   long sx, sy;                 /* x/y size of current window   */
   long ox, oy;                 /* x/y origin of current window */
   long xscrnsize;              /* size of screen in x used to set globals */
   long xmaxscrn, ymaxscrn;     /* maximum size of screen in x and y       */
   Colorindex dummy;            /* for strict ANSI C prototyping */



   xscrnsize = getgdesc (GD_XPMAX);
   if (xscrnsize == 1280)
      {
      xmaxscrn = 1279;
      ymaxscrn = 1023;
      }
   else if (xscrnsize = 1023)
      {
      xmaxscrn = 1023;
      ymaxscrn = 767;
      }
   else
      {
      fprintf(stderr, "Something's EXTREMELY wrong:  ");
      fprintf(stderr, "xscrnsize=%d\n", xscrnsize);
      exit(-1) ;
      }

   winopen ("curpos");
   getsize (&sx, &sy);
   getorigin (&ox, &oy);
   qdevice (ESCKEY);
   qdevice (ONEKEY);
   qdevice (TWOKEY);
   qdevice (THREEKEY);
   qdevice (FOURKEY);
   qdevice (FIVEKEY);
   qdevice (SIXKEY);
   qdevice (LEFTMOUSE);
   qdevice (MIDDLEMOUSE);

   mdev [X] = MOUSEX;
   mdev [Y] = MOUSEY;

   curstype (C16X1);			/* Fly cursor. */
   defcursor (1, fly);
   curorigin (1,8,8);

   curstype (C16X1);			/* Hourglass cursor. */
   defcursor (2, hourglass);
   curorigin (2,8,8);

   curstype (CCROSS);			/* Crosshair cursor. */
   defcursor (3, cursor);
   curorigin (3,0,0);

   curstype (C16X1);			/* Small crosshair cursor. */
   defcursor (4, plus1);
   curorigin (4,7,7);

   curstype (C16X1);			/* Modified small crosshair cursor. */
   defcursor (5, plus1);
   curorigin (5,7,7);

   curstype (C16X1);			/* Asterisk cursor. */
   defcursor (6, asterisk);
   curorigin (6,7,7);

   setcursor (1, dummy, dummy);

   color (CYAN);
   clear ();

   while (1)
      {
      while (qtest ())
         {
         dev = qread (&val);
         switch (dev)
            {
            case ESCKEY:
                 setvaluator (MOUSEX, (short)(sx/2), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(sy/2), 0, ymaxscrn);
                 gexit ();
                 exit (1);
                 break;
            case REDRAW:
                 reshapeviewport ();
                 getsize (&sx, &sy);
                 getorigin (&ox, &oy);
                 color (CYAN);
                 clear ();
                 break;
            case ONEKEY:
                 setcursor (1, dummy, dummy);
                 setvaluator (MOUSEX, (short)(ox+(0.3125*sx)), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(oy+(0.6225*sy)), 0, ymaxscrn);
                 break;
            case TWOKEY:
                 setcursor (2, dummy, dummy);
                 setvaluator (MOUSEX, (short)(ox+(0.0825*sx)), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(oy+(0.0975*sy)), 0, ymaxscrn);
                 break;
            case THREEKEY:
                 setcursor (3, dummy, dummy);
                 setvaluator (MOUSEX, (short)(ox+(0.7825*sx)), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(oy+(0.2275*sy)), 0, ymaxscrn);
                 break;
            case FOURKEY:
                 setcursor (4, dummy, dummy);
                 setvaluator (MOUSEX, (short)(ox+(0.5*sx)), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(oy+(0.5*sy)), 0, ymaxscrn);
                 break;
            case FIVEKEY:
                 setcursor (5, dummy, dummy);
                 setvaluator (MOUSEX, (short)(ox+(0.5*sx)), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(oy+(0.5*sy)), 0, ymaxscrn);
                 break;
            case SIXKEY:
                 setcursor (6, dummy, dummy);
                 setvaluator (MOUSEX, (short)(ox+(0.5*sx)), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(oy+(0.5*sy)), 0, ymaxscrn);
                 break;
            case MIDDLEMOUSE:	/* Read position of mouse. */
            case LEFTMOUSE:	/* Read position of mouse. */
                 if (val == 1)
                    {
                    getdev (XY, mdev, mval);
                    xpos = mval [X] - ox;
                    ypos = mval [Y] - oy;
                    fprintf (stdout, "xpos: %3d   ypos: %3d\n", xpos, ypos);
                    }
                 break;
            default:
                 break;
            }
         }
      }
}
