/* rdmpos
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * Read mouse position.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 */
rdmpos (xmaxscrn, ymaxscrn, ox, oy, sx, sy, xwin, ywin)

long xmaxscrn, ymaxscrn;     /* maximum size of screen in x and y       */
long *ox, *oy;                 /* x/y origin of current window */
long *sx, *sy;                 /* x/y size of current window   */
long *xwin, *ywin;

{
   Device mdev [XY];
   short mval [XY];
   short val;
   long dev;

   mdev [X] = MOUSEX;
   mdev [Y] = MOUSEY;

   qreset ();
   qdevice (ESCKEY);
   qdevice (LEFTMOUSE);
   qdevice (MIDDLEMOUSE);

   while (1)
      {
      while (qtest ())
         {
         dev = qread (&val);
         switch (dev)
            {
            case ESCKEY:
                 setvaluator (MOUSEX, (short)(*sx/2), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(*sy/2), 0, ymaxscrn);
                 gexit ();
                 exit (1);
                 break;
            case REDRAW:
                 reshapeviewport ();
                 getsize (sx, sy);
                 getorigin (ox, oy);
                 color (CYAN);
                 clear ();
                 break;
            case MIDDLEMOUSE:	/* Read winition of mouse. */
            case LEFTMOUSE:	/* Read winition of mouse. */
                 if (val == 1)
                    {
                    getdev (XY, mdev, mval);
                    *xwin = mval [X] - *ox;
                    *ywin = mval [Y] - *oy;
                    printf ("mval: %3d %3d   ox/oy: %3d %3d   xwin/ywin: %3d %3d\n",
                             mval [0], mval [1], *ox, *oy, *xwin, *ywin);
                    qreset ();
                    return (0);
                    }
                 break;
            default:
                 break;
            }
         }
      }
}
