/*
 *  rdpos.c:
 *
 * Read cursor position.
 *
 * Andrew L. Stanger
 * 24 Oct 1991
 */

#include <stdio.h>
#include <gl/gl.h>
#include <gl/device.h>
#define XY 2
#define X 0
#define Y 1

main ()
{

   short num;
   unsigned short cursor [128];
   long xpos, ypos;
   long sx, sy;                 /* x/y size of current window   */
   long ox, oy;                 /* x/y origin of current window */
   long xscrnsize;              /* size of screen in x used to set globals */
   long xmaxscrn, ymaxscrn;     /* maximum size of screen in x and y       */
   Colorindex dummy;            /* for strict ANSI C prototyping */
   int i;

   /* ----------------------------------------------------------------------- */

   xscrnsize = getgdesc (GD_XPMAX);
   if (xscrnsize == 1280)
      {
      xmaxscrn = 1279;
      ymaxscrn = 1023;
      }
   else if (xscrnsize = 1023)
      {
      xmaxscrn = 1023;
      ymaxscrn = 767;
      }
   else
      {
      fprintf(stderr, "Something's EXTREMELY wrong:  ");
      fprintf(stderr, "xscrnsize=%d\n", xscrnsize);
      exit(-1) ;
      }

   winopen ("rdpos");
   getsize (&sx, &sy);
   getorigin (&ox, &oy);

   curstype (CCROSS);			/* Crosshair cursor. */
   defcursor (3, cursor);
   curorigin (3,0,0);

   setcursor (3, dummy, dummy);

   color (CYAN);
   clear ();

   for (i=0; i<4; i++)
      {
      rdmpos (xmaxscrn, ymaxscrn, &ox, &oy, &sx, &sy, &xpos, &ypos);
      fprintf (stdout, "i: %d   xpos: %3d   ypos: %3d\n", i, xpos, ypos);
      }

   sleep (5);
   gexit ();
   exit (0);
}


/* rdmpos
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * Read mouse position.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 */
rdmpos (xmaxscrn, ymaxscrn, ox, oy, sx, sy, xwin, ywin)

long xmaxscrn, ymaxscrn;     /* maximum size of screen in x and y       */
long *ox, *oy;                 /* x/y origin of current window */
long *sx, *sy;                 /* x/y size of current window   */
long *xwin, *ywin;

{
   Device mdev [XY];
   short mval [XY];
   short val;
   long dev;

   mdev [X] = MOUSEX;
   mdev [Y] = MOUSEY;

   qreset ();
   qdevice (ESCKEY);
   qdevice (LEFTMOUSE);
   qdevice (MIDDLEMOUSE);

   while (1)
      {
      while (qtest ())
         {
         dev = qread (&val);
         switch (dev)
            {
            case ESCKEY:
                 setvaluator (MOUSEX, (short)(*sx/2), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(*sy/2), 0, ymaxscrn);
                 gexit ();
                 exit (1);
                 break;
            case REDRAW:
                 reshapeviewport ();
                 getsize (sx, sy);
                 getorigin (ox, oy);
                 color (CYAN);
                 clear ();
                 break;
            case MIDDLEMOUSE:	/* Read winition of mouse. */
            case LEFTMOUSE:	/* Read winition of mouse. */
                 if (val == 1)
                    {
                    getdev (XY, mdev, mval);
                    *xwin = mval [X] - *ox;
                    *ywin = mval [Y] - *oy;
                    printf ("mval: %3d %3d   ox/oy: %3d %3d   xwin/ywin: %3d %3d\n",
                             mval [0], mval [1], *ox, *oy, *xwin, *ywin);
                    qreset ();
                    return (0);
                    }
                 break;
            default:
                 break;
            }
         }
      }
}
