/* get_scmap.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Save red/green/blue color values from a specified region of color LUTs.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 2 September 1992
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

get_scmap (min_level, num_levels, red, green, blue)

unsigned short min_level;	/* starting color level. */
unsigned short num_levels;	/* # levels to retrieve. */
unsigned char red [];		/* red color table. */
unsigned char green [];		/* green color table. */
unsigned char blue [];		/* blue color table. */

{
   unsigned short ic, im;
   short rcomp, gcomp, bcomp;

   for (ic = 0; ic < num_levels; ic++)
      {
      im = ic + min_level;
      getmcolor (im, &rcomp, &gcomp, &bcomp);

      red [ic]   = (unsigned char) rcomp;
      green [ic] = (unsigned char) gcomp;
      blue [ic]  = (unsigned char) bcomp;
      }

   return (0);
}
