/* avs.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Display 1991 composite-exposure, RGBA image using GL.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   18 Aug 93
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include <gl/gl.h>

main (argc, argv)

int argc;
char *argv [];
{
   extern char *malloc ();
   static char namimg [80] = "img_l18c.x";
   static char pix [4];
   char *cbuf;
   char *rbuf, *gbuf, *bbuf, *abuf;

   int dx;
   int dy;
   int fd;
   int i;
   int nbyimg;
   int npximg;

   unsigned long *imgbuf;

   fd = open (namimg, 0);

   read (fd, &dx, 4);
   read (fd, &dy, 4);

   printf ("dx:%d  dy:%d\n", dx, dy);

   npximg = dx * dy;
   nbyimg = npximg * sizeof (int);

   imgbuf = (unsigned long *) malloc (nbyimg);	/* RGBA packed image */
   rbuf = (char *) malloc (npximg);		/* red   */
   gbuf = (char *) malloc (npximg);		/* green */
   bbuf = (char *) malloc (npximg);		/* blue  */
   abuf = (char *) malloc (npximg);		/* alpha */

   read (fd, imgbuf, dx * dy * sizeof (int));

   for (i = 0; i < npximg; i++)
      {
      cbuf = (char *) (imgbuf + i);   
      *(rbuf + i) = *(cbuf + 0);
      *(gbuf + i) = *(cbuf + 1);
      *(bbuf + i) = *(cbuf + 2);
      *(abuf + i) = *(cbuf + 3);
      }

   noborder ();
   prefsize (dx, dy);
   winopen (argv [0]);
   lrectwrite (0, 0, dx-1, dy-1, imgbuf);
   sleep (30);
   gexit ();

   exit (0);
}
