/* gl_cmap.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * SGI/GL utilities.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <gl/gl.h>

/* gl_wclear
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Clears GL window to color referenced by LUT index.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

gl_wclear (mapindex)

Colorindex mapindex;

{
   color (mapindex);
   clear ();

   return (0);
}

/* get_cmap 
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Saves SGI colormap contents in arrays CarrayR, CarrayG, CarrayB.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#define MAXCOLI 4095 

static short CarrayR[MAXCOLI+1], CarrayG[MAXCOLI+1], CarrayB[MAXCOLI+1];

get_cmap ()

{
   short rcomp, gcomp, bcomp;
   unsigned short i;

   for (i = 0; i <= MAXCOLI; i++)
      {
      getmcolor (i, &rcomp, &gcomp, &bcomp);
      CarrayR [i] = rcomp;
      CarrayG [i] = gcomp;
      CarrayB [i] = bcomp;
    }
}

/* restore_cmap 
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Restores SGI colormap contents from arrays CarrayR, CarrayG, CarrayB.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

restore_cmap ()
{
   unsigned short i;
   for (i = 0; i <= MAXCOLI; i++) 
      mapcolor (i, CarrayR [i], CarrayG [i], CarrayB [i]);
}
