; $Id:	xloadct.pro,	v 1.8 1995/06/22 17:54:48	mattr Exp $

; Copyright (c) 1991-1993, Research Systems, Inc.  All rights reserved.
;       Unauthorized reproduction prohibited.

;-------------------------------------------------------------------------------
PRO XLCT_PSAVE			;Save/Restore our plotting state.
;  Swaps our state with the current state each time its called.
;-------------------------------------------------------------------------------

COMMON xloadct_com, r0, g0, b0, tfun, state, filename, cps, psave, pnt, $
	top, bot, silent, chop, lock, g_lbl, vbot, vtop, g_slider, $
	gamma, color, use_values, ncolors, cbot

tmp = { xlct_psave, win: !d.window, x: !x.s, y: !y.s }

IF (psave.win NE -1) THEN WSET, psave.win
!x.s = psave.x
!y.s = psave.y
psave = tmp
END

;-------------------------------------------------------------------------------
PRO xlct_draw_cps, i, c
;-------------------------------------------------------------------------------
COMMON colors, r_orig, g_orig, b_orig, r_curr, g_curr, b_curr
COMMON xloadct_com, r0, g0, b0, tfun, state, filename, cps, psave, pnt, $
	top, bot, silent, chop, lock, g_lbl, vbot, vtop, g_slider, $
	gamma, color, use_values, ncolors, cbot

tc = color
IF (N_ELEMENTS (c) GT 0) THEN BEGIN
    tc = c
    IF (c NE 0) THEN color = c
ENDIF

IF (i (0) EQ -1) THEN j = indgen (N_ELEMENTS (cps)) ELSE j = i

PLOTS, cps (j), tfun (j), /noclip, color = tc
PLOTS, cps (j), tfun (j), /noclip, psym=6, color = tc
END

;-------------------------------------------------------------------------------
PRO xlct_transfer
;-------------------------------------------------------------------------------
COMMON colors, r_orig, g_orig, b_orig, r_curr, g_curr, b_curr
COMMON xloadct_com, r0, g0, b0, tfun, state, filename, cps, psave, pnt, $
	top, bot, silent, chop, lock, g_lbl, vbot, vtop, g_slider, $
	gamma, color, use_values, ncolors, cbot

l = LONARR (ncolors)				; Subscripts
m = N_ELEMENTS (cps)

FOR i = 0, m - 2 DO BEGIN
    n = cps (i+1) - cps (i)			; Interval
    b = (tfun (i+1) - tfun (i)) / FLOAT (n)
    l (cps (i)) = FINDGEN (n) * b + (tfun (i) + cbot)
ENDFOR

l (ncolors - 1) = tfun (m-1)			; Last point

IF (use_values) THEN BEGIN
    r_curr (cbot) = (r = l (r_orig))
    g_curr (cbot) = (g = l (g_orig))
    b_curr (cbot) = (b = l (b_orig))
ENDIF ELSE BEGIN
    r_curr (cbot) = (r = r_orig (l))
    g_curr (cbot) = (g = g_orig (l))
    b_curr (cbot) = (b = b_orig (l))
ENDELSE

TVLCT, r,g,b, cbot
END

;-------------------------------------------------------------------------------
PRO xloadct_event, event
;-------------------------------------------------------------------------------
COMMON colors, r_orig, g_orig, b_orig, r_curr, g_curr, b_curr
COMMON xloadct_com, r0, g0, b0, tfun, state, filename, cps, psave, pnt, $
	top, bot, silent, chop, lock, g_lbl, vbot, vtop, g_slider, $
	gamma, color, use_values, ncolors, cbot


IF (event.id EQ state.draw) THEN BEGIN		;** PROCESS DRAWABLE EVENTS **
    IF (event.press NE 0) THEN BEGIN		;Pressed button?
	dmin = 1.0e+8				;Find closest control point
	xlct_psave				;Remove old
	p = CONVERT_COORD (event.x, event.y, /TO_DATA, /DEVICE)
	xlct_psave				;Restore old
	x = FIX (p (0))
	y = FIX (p (1))

	FOR i = 0, N_ELEMENTS (cps) - 1 DO BEGIN
            d = (p (0) - cps (i)) ^ 2 + (p (1) - tfun (i)) ^ 2  ; dist ^ 2
            IF (d LT dmin) THEN BEGIN
                dmin = d
		pnt = i
            ENDIF
	ENDFOR
	return
    ENDIF

    IF (event.release NE 0) THEN BEGIN		;Released button?
	pnt = -1
        return
    ENDIF
    IF (pnt LT 0) THEN return			;Don't care here...

    xlct_psave					;Remove old
    p = CONVERT_COORD (event.x, event.y, /TO_DATA, /DEVICE)	;Coord of mouse
    n = ncolors -1				;Into range....
    m = N_ELEMENTS (cps) - 1
    x = FIX (p (0)) > 0 < n
    IF (pnt EQ 0) THEN x = 0 else $		;1st & last are fixed
    IF (pnt EQ m) THEN x = n else $
    x = x > (cps (pnt-1) + 1) < (cps (pnt+1)-1)  ;Others must be between

    IF (pnt EQ 0) THEN xlct_draw_cps, [0, 1],0 $  ;Erase old segment
    ELSE IF (pnt EQ m) THEN xlct_draw_cps, [m-1, m],0 $
    ELSE xlct_draw_cps, [pnt-1, pnt, pnt+1], 0
    cps (pnt) = x
    tfun (pnt) = FIX (p (1)) > 0 < n
    xlct_transfer

    b = r_curr * 0.3 + g_curr * 0.586 + b_curr * 0.114	;Ntsc colors
    c = MAX (ABS (b - b (cbot)), j)	; *** J is color index furthest from 0

    IF (pnt EQ 0) THEN xlct_draw_cps, [0, 1], j $
    ELSE IF (pnt EQ m) THEN xlct_draw_cps, [m-1, m], j $
    ELSE xlct_draw_cps, [pnt-1, pnt, pnt+1], j

    xlct_psave		;Remove old
    return
ENDIF

WIDGET_CONTROL, event.id, GET_UVALUE = eventval

abstop = NCOLORS -1

IF (event.id EQ state.name_list) THEN BEGIN
    LOADCT, silent=silent, event.index, FILE=filename, NCOLORS=ncolors, $
		BOTTOM=cbot
    goto, set_gamma
ENDIF

CASE eventval OF
    "TOP":    BEGIN
		WIDGET_CONTROL, top, GET_VALUE = vtop
                IF (lock NE 0) THEN BEGIN
                        vbot = (vtop - lock) > 0 < 100
                        WIDGET_CONTROL, bot, SET_VALUE=vbot
                        ENDIF
                GOTO, set_gamma
              END

    "BOTTOM": BEGIN
		WIDGET_CONTROL, bot, GET_value = vbot
                IF (lock NE 0) THEN BEGIN
                        vtop = (vbot + lock) > 0 < 100
                        WIDGET_CONTROL, top, SET_VALUE=vtop
                        ENDIF
   set_gamma:
	IF (use_values) THEN nc = 256 ELSE nc = ncolors
	s = (nc - 1) / 100.0
	x0 = vbot * s
	x1 = vtop * s
	IF (x0 NE x1) THEN s = (nc - 1.0) / (x1 - x0) ELSE s = 1.0
	int = -s * x0
	IF (gamma EQ 1.0) THEN s = round (findgen (nc) * s + int > 0.0) $
	ELSE s = ((FINDGEN (nc) * (s / nc) + (int / nc) > 0.0) ^ gamma) * nc
	IF (chop NE 0) THEN BEGIN
	    too_high = WHERE (s GE nc, n)
	    IF (n gt 0) THEN s (too_high) = 0L
	    ENDIF
	IF (use_values) THEN BEGIN
	    s = s < 255L
	    l = LINDGEN (ncolors) + cbot
	    r_curr (cbot) = (r = s (r_orig (l)))
	    g_curr (cbot) = (g = s (g_orig (l)))
	    b_curr (cbot) = (b = s (b_orig (l)))
	ENDIF ELSE BEGIN
	    s = s + cbot
	    r_curr (cbot) = (r = r_orig (s))
	    g_curr (cbot) = (g = g_orig (s))
	    b_curr (cbot) = (b = b_orig (s))
 	ENDELSE
	tvlct, r,g,b, cbot
	ENDCASE

    "GAMMA": BEGIN
                WIDGET_CONTROL, g_slider, GET_VALUE = gamma
                gamma = 10 ^ ((gamma / 50.0) - 1)
                WIDGET_CONTROL, g_lbl, SET_VALUE = $
			STRING (gamma, format='(f6.3)')
		goto, set_gamma
             ENDCASE

    "GANG" : IF (event.value EQ 0) THEN lock = 0 ELSE lock = vtop - vbot

    "CHOP" : BEGIN
        chop = event.value
        goto, set_gamma         ;And redraw
        ENDCASE

    "VALUES": BEGIN
	use_values = event.value
	ENDCASE

    "HELP" : XDisplayFile, FILEPATH("xloadct.txt", subdir=['help', 'widget']), $
                TITLE = "Xloadct Help", $
                GROUP = event.top, $
                WIDTH = 55, $
                HEIGHT = 16

    "RESTORE" : BEGIN                   	;Restore the original tables
        r_curr = (r_orig = r0)
        g_curr = (g_orig = g0)
        b_curr = (b_orig = b0)
	tvlct, r_curr, g_curr, b_curr
        ENDCASE

    "OVERWRITE" : BEGIN                 	;Overwrite original tables
	r0 = (r_orig = r_curr)
	g0 = (g_orig = g_curr)
	b0 = (b_orig = b_curr)
    reset_all:
        WIDGET_CONTROL, top, SET_VALUE = 100
        WIDGET_CONTROL, bot, SET_VALUE = 0
        WIDGET_CONTROL, g_slider, SET_VALUE = 50
	vbot  = 0
	vtop  = 100
	gamma = 1.0
	GOTO, set_gamma
	ENDCASE

    "REVERSE" : BEGIN                   	;Reverse the table
	l = lindgen(ncolors) + cbot
        r_orig (cbot) = reverse (r_orig (l))
        g_orig (cbot) = reverse (g_orig (l))
        b_orig (cbot) = reverse (b_orig (l))
        goto, set_gamma                 ;And redraw
        ENDCASE

    "DONE": BEGIN
        WIDGET_CONTROL, event.top, /DESTROY
        r0 = 0 & g0 = 0 & b0 = 0		;Free common
        ENDCASE

    "NEWBASE": BEGIN
	mode = event.value
	b = ([0, 0, 1])(mode)		;Top base to map: 0 or 1.
	FOR i = 0, 1 DO WIDGET_CONTROL, state.bases(i), MAP=i eq b
	IF (b EQ 0) THEN BEGIN		;Table or option mode?
	   b = ([2,3,0])(mode)		;Bottom base to map (mode EQ 0 OR 1)
	   FOR i = 2, 3 DO WIDGET_CONTROL, state.bases (i), MAP=i EQ b
	   ENDIF
	IF (mode EQ 2) THEN BEGIN
	    reset_all = 1
	    xlct_psave			;Save old state
	    PLOT, [0, ncolors-1], [0, ncolors-1], xstyle=3, $
		ystyle=3, xmargin = [1,1], ymargin=[1,1], ticklen = -0.03, $
		/NODATA, $
		xtickname = replicate(' ', 10), ytickname = replicate(' ', 10)
	    goto, interp_cps
	    ENDIF
	
	ENDCASE

    "TFUNR": BEGIN
     reset_tfun:
	xlct_psave
	xlct_draw_cps, -1, 0			;Erase all
	tfun = cps				;Linear ramp
	goto, interp_cps
	ENDCASE

    "REMCP": BEGIN
	n = N_ELEMENTS (cps)
	IF (n GT 2) THEN BEGIN
	  xlct_psave
	  xlct_draw_cps, -1, 0
	  igap = 0
	  FOR i = 0, n - 2 DO $
		IF (cps (i+1) - cps (i)) LT (cps (igap+1) - cps (igap)) THEN $
			igap = i
	  keep = WHERE (indgen (n) NE (igap > 1))
	  cps = cps (keep)
	  tfun = tfun (keep)
	  goto, interp_cps
	  ENDIF
	ENDCASE

    "ADDCP": BEGIN
	xlct_psave
	xlct_draw_cps, -1, 0
	igap = 0				;Find largest gap
	FOR i = 0, N_ELEMENTS (cps) - 2 DO $
		IF (cps (i+1) - cps (i)) GT (cps (igap+1) - cps (igap)) THEN $
			igap = i
	cps = [cps (0:igap), (cps (igap) + cps (igap+1)) / 2, cps (igap+1:*)]
	tfun = [tfun (0:igap), (tfun (igap) + tfun (igap+1)) / 2, $
		tfun (igap+1:*)]
      interp_cps:  xlct_draw_cps, -1		;Redraw new
	xlct_transfer
	xlct_psave				;Restore old points
	IF (N_ELEMENTS (reset_all)) THEN GOTO, reset_all
	ENDCASE
ENDCASE

END


;-------------------------------------------------------------------------------
;+
; NAME:
;       XLOADCT
; PURPOSE:
;       A graphical interface to the LOADCT user library procedure.
;       XLOADCT displays the current color map and provides
;       an array of buttons, one per availible predefined color
;       table. Using the mouse to press these buttons causes
;       the corresponding color map to be loaded.
; CATEGORY:
;       Widgets
; CALLING SEQUENCE:
;       XLOADCT
; INPUTS:
;       None.
; KEYWORDS:
;	FILE:	If this keyword is set, the file by the given name is used
;		instead of the file colors1.tbl in the IDL directory.  This
;		allows multiple IDL users to have their own color table file.
;       GROUP = The widget ID of the widget that calls XLoadct.  When 
;               this ID is specified, a death of the caller results in a 
;               death of XLoadct
;	NCOLORS = number of colors to use.  Use color indices from BOTTOM
;		to the smaller of !D.TABLE_SIZE-1 and NCOLORS-1.
;		Default = !D.TABLE_SIZE = all available colors.
;	BOTTOM = first color index to use. Use color indices from BOTTOM to
;		BOTTOM+NCOLORS-1.  Default = 0.
;       PICK_ONE - Normally, XLOADCT remains running until the user
;               presses the "QUIT" button. If PICK_ONE is present and 
;               non-zero, the "QUIT" button is not displayed, and
;               XLOADCT quits after a single selection.
;       SILENT - Normally, no informational message is printed when
;               a color map is loaded. If this keyword is present and
;               zero, this message is printed.
;	USE_CURRENT: If set, use the current color tables, regardless of
;		the contents of the COMMON block COLORS.
; OUTPUTS:
;       None.
; COMMON BLOCKS:
;       None.
; SIDE EFFECTS:
;       One of the predefined color maps may be loaded.
; RESTRICTIONS:
;       This routine uses the LOADCT user library procedure to
;       do the actual work.
; MODIFICATION HISTORY:
;       24, August, 1990, Written by AB, RSI.
;       March 1, 1992  Mark Rivers added Reverse Table to options menu.
;	7/92, DMS, Added new color tables (allows more than 16).
;	9/92, ACY, Add FILE keyword.
;-
;-------------------------------------------------------------------------------

PRO XLoadct, PICK_ONE=PICK_ONE, SILENT=silent_f, GROUP = GROUP, FILE=file, $
	USE_CURRENT = use_current, NCOLORS = nc, BOTTOM=bottom

COMMON colors, r_orig, g_orig, b_orig, r_curr, g_curr, b_curr
COMMON xloadct_com, r0, g0, b0, tfun, state, filename, cps, psave, pnt, $
	top, bot, silent, chop, lock, g_lbl, vbot, vtop, g_slider, $
	gamma, color, use_values, ncolors, cbot


IF (XRegistered ("xloadct") NE 0) THEN return

values_button = LONARR (2)

IF (KEYWORD_SET (SILENT_f)) THEN silent = SILENT_F ELSE silent = 1

IF (N_ELEMENTS (file) GT 0) THEN filename = file

siz = 256				;Basic width of tool
names = 0
LOADCT, GET_NAMES = names, FILE = file	;Get table names

w_height = 50				;Height of ramp
cur_win = !D.WINDOW
lock = 0
chop = 0
vbot = 0
vtop = 100
gamma = 1.0
use_values = 0

; Bases:
;  0 = slider base  (stretch bottom, stretch top, gamma)
;  1 = transfer function drawable + buttons
;  2 = color table list
;  3 = options base  (sliders. top, stretch)

state = { bases: LONARR(4), draw: 0L, name_list: 0L }

base = WIDGET_BASE(TITLE="XLoadct", /COLUMN)


show = WIDGET_DRAW (base, YSIZE=w_height, XSIZE=siz, /FRAME, RETAIN = 2)
IF (NOT (KEYWORD_SET (pick_one))) THEN BEGIN
  junk = WIDGET_BASE (base, /ROW)
  done = WIDGET_BUTTON (junk, VALUE=' Done ', UVALUE = "DONE")
  junk1 = WIDGET_BUTTON (junk, VALUE=' Help ', UVALUE = "HELP")

  junk = CW_BGROUP (base, /ROW, /EXCLUSIVE, /NO_REL, $
		    ['Tables', 'Options', 'Function'], $
		    UVALUE='NEWBASE', SET_VALUE=0)

  junk = widget_base (base)
  FOR i = 0, 1 DO state.bases (i) = WIDGET_BASE (junk, /COLUMN)

  sbase = WIDGET_BASE (state.bases(0), /COLUMN)
  bot = WIDGET_SLIDER (sbase, TITLE = "Stretch Bottom", MINIMUM = 0, $
		MAXIMUM = 100, VALUE = 0, /DRAG, UVALUE = "BOTTOM", xsize=siz)
  top = WIDGET_SLIDER (sbase, TITLE = "Stretch Top", MINIMUM = 0, $
		MAXIMUM = 100, VALUE = 100, /DRAG, UVALUE = "TOP", xsize=siz)
  g_lbl = WIDGET_LABEL (sbase, VALUE = STRING(1.0))
  g_slider = WIDGET_slider (sbase, TITLE = "Gamma Correction", $
		MINIMUM = 0, MAXIMUM = 100, VALUE = 50, UVALUE = "GAMMA", $
		/SUPPRESS_VALUE, /DRAG, xsize=siz)
ENDIF ELSE BEGIN
  done = 0
ENDELSE

junk = WIDGET_BASE (sbase)
FOR i = 2, 3 DO state.bases (i) = WIDGET_BASE(junk, /COLUMN)
DEVICE, GET_SCREEN = junk
IF (junk (1) LE 768) THEN junk = 8 ELSE junk = 16
state.name_list = WIDGET_LIST (state.bases (2), VALUE = names, ysize = junk)


;		Drawable for transfer function

junk = WIDGET_BASE (state.bases(1), /COLUMN, /FRAME)
junk1 = WIDGET_BUTTON (junk, VALUE = 'Reset Transfer Function', UVALUE='TFUNR')
junk1 = WIDGET_BUTTON (junk, VALUE='Add Control Point', UVALUE='ADDCP')
junk1 = WIDGET_BUTTON (junk, VALUE='Remove Control Point', UVALUE='REMCP')

state.draw = WIDGET_DRAW (state.bases(1), xsize = siz, ysize = siz, $
			/BUTTON_EVENTS, /MOTION_EVENTS)


opt_id = state.bases (3)
junk = CW_BGROUP (opt_id, /ROW, LABEL_LEFT='Sliders:', /EXCLUSIVE, /NO_REL, $
		['Independent', 'Gang'], UVALUE='GANG', SET_VALUE=lock)
junk = CW_BGROUP (opt_id, /ROW, LABEL_LEFT = 'Top:',  /EXCLUSIVE, /NO_REL, $
		['Clip', 'Chop'], SET_VALUE=chop, UVALUE='CHOP')
junk = CW_BGROUP (opt_id, /ROW, LABEL_LEFT='Stretch:',  /EXCLUSIVE, /NO_REL, $
		['Indices', 'Intensity'], UVALUE='VALUES', $
		SET_VALUE=use_values)
junk = WIDGET_BUTTON (opt_id, VALUE='Reverse Table', $
                UVALUE="REVERSE", /NO_REL)
junk = WIDGET_BUTTON (opt_id, VALUE='REPLACE Original Table', $
		UVALUE = "OVERWRITE", /NO_REL)
junk = WIDGET_BUTTON (opt_id, VALUE='RESTORE Original Table', $
                UVALUE="RESTORE", /NO_REL)

WIDGET_CONTROL, state.bases (1), MAP=0		;Tfun is not visible
WIDGET_CONTROL, state.bases (3), MAP=0		;Options are not visible

WIDGET_CONTROL, base, /REALIZE
WIDGET_CONTROL, state.draw, GET_VALUE=tmp

IF (N_ELEMENTS (bottom) GT 0) THEN cbot = bottom ELSE cbot = 0
ncolors = !d.table_size - cbot
IF (N_ELEMENTS (nc) GT 0) THEN ncolors = ncolors < nc
IF (ncolors LE 0) THEN message, 'Number of colors is 0 or negative'

psave = { xlct_psave, win: tmp, x: !x.s, y: !y.s }	;Our initial state
WSET, tmp						;Initial graph
xlct_psave				;Save original scaling & window

PLOT, [0, ncolors-1], [0, ncolors-1], xstyle=3, ystyle=3, $
	xmargin = [1,1], ymargin=[1,1], ticklen = -0.03, /NODATA

xlct_psave				;Restore original scaling & window

					;If no common, use current colors
IF (KEYWORD_SET (use_current) OR N_ELEMENTS (r_orig) LE 0) THEN BEGIN
    TVLCT, r_orig, g_orig, b_orig, /GET
    r_curr = r_orig
    b_curr = b_orig
    g_curr = g_orig
ENDIF

r0 = r_curr				;Save original colors
g0 = g_curr
b0 = b_curr
color = ncolors + cbot -1
cps = [0, ncolors - 1]
tfun = cps
pnt = -1

WIDGET_CONTROL, show, GET_VALUE=show_win
WSET, show_win
TVSCL, BYTSCL (INDGEN (siz) # REPLICATE (1, w_height), TOP = ncolors-1)
IF (cur_win NE -1) THEN WSET, cur_win

XManager, "xloadct", base, GROUP_LEADER = GROUP

END
;-------------------------------------------------------------------------------
