;+
;       NAME: chist
;
;
;       PURPOSE: A simple cumulative histogram
;
;
;       METHOD: Use the shift function.
;
;
;       CALLING SEQUENCE: chst=chist(data,elem=em)
;
;
;       PARAMETERS:	data	input data
;
;
;       KEYWORDS:	elem	returns # of elements in chst
;
;
;       HISTORY: Drafted by A. McAllister November 24, 1993.
;		 Fixed up a bit, feb 21, 1994 AMcA.
;
;-
FUNCTION chist,data,elem=hstlen


type=data_type(data)

case type of

    0: return,-1
    1: hist=histogram(data)
    2: hist=histogram(data)
    3: hist=histogram(data)
    4: hist=histogram(data,binsize=.1)
    5: hist=histogram(data,binsize=.1)
    6: return,-1
    7: return,-1
    8: return,-1
    
endcase

hstlen=n_elements(hist)
chst=[replicate(0.,hstlen)]
dum=[chst,hist]

for i=0,hstlen-1 do chst = chst + shift(dum,i)

return,chst

end
