;+
;       NAME: despike
;
;
;       PURPOSE: to despike a cube of data
;
;
;       METHOD: simply loop through a call to SPIKES
;
;
;       CALLING SEQUENCE:  out=despike(in,cutoff,type='mmp')
;
;
;       PARAMETERS:	in		input cube
;			out		output cube (could be the same)
;			cutoff  	cutoff value, as absolute of as a percentage
;
;       KEYWORDS:	type            cutoff type, set to
;                                       "mmp", for percentage of total range,
;                                       "per", for percentage of local median,
;                                       "abs", for absolute value,
;                                              this is default.
;
;	CALLS:	SPIKES
;
;       HISTORY: Drafted by AMcA, following earlier version of Apr. 4 1994, Nov. 4 1994.
;
;
;-
FUNCTION despike,data,cut,type=type

datsz=size(data)

temp=data

if datsz(0) ne 3 then limit=0 else limit=datsz(3)-1

for i=0, limit do begin

   tmp=temp(*,*,i)
   repeat tss=spikes(tmp,cut,type=type,/remove) until tss(0) eq -1
   temp(*,*,i)=tmp	

endfor

return, temp

end
