;+
;       NAME: dskcntr
;
;
;       PURPOSE: Simple rough locater of an spectral image center
;
;
;       METHOD: Take moments of the intensity.
;
;
;       CALLING SEQUENCE:  center=dskcntr(image)
;
;       PARAMETERS:	image		input image
;			center		center of image in pixel coords.
;
;       KEYWORDS:
;
;       HISTORY: Drafted by A. McAllister Nov. 23, 1993.
;		 Based on V. Raben algorythm.
;
;-
FUNCTION dskcntr,image

imgsz=size(image)

M00=total(image)

indx=lindgen(imgsz(1),imgsz(2))

x = modd(indx,imgsz(1))
y = fix(indx/imgsz(1))

M01=total(image*x)/M00
M10=total(image*long(y))/M00		;need to convert y 

return,center=[M01,M10]

end
