;+
;       NAME: exp_file
;
;       PURPOSE: Handle a general input of file names, with twiddles 
;		 and wildcards.
;
;       METHOD: First check for twiddles, then use FINDFILE to expand 
;		each entry
;
;       CALLING SEQUENCE: files=exp_file(filestr)
;
;       NOTES: Probably needs to be modified for VMS systems.
;
;       PARAMETERS: 	filestr		input file string, can be a vector
;			files		expanded list of files, with paths
;
;       HISTORY: Drafted by A.McAllister, 2-jul-93.
;
;-
FUNCTION exp_file,filestr


  for i=0,n_elements(filestr)-1 do $			;check for twiddles
    if getenv('HOME') ne '' and strmid(filestr(i),0,1) eq '~' then $
         filestr(i)=concat_dir(getenv('HOME'),strmid(filestr(i),2,strlen(filestr(i))))

  files=findfile(filestr(0))
  for i=1,n_elements(filestr)-1 do files=[files,findfile(filestr(i))]

return,files

end