;+
;       NAME: go_hist
;
;
;       PURPOSE: Do sensible histogram plots
;
;
;       METHOD:  Do histogram and feed to PLOT, or OPLOT with a
;		 few keywords.
;
;       CALLING SEQUENCE:  go_hist,data[,over=over][,min=min][,max=max]
;				  [,linestyle=line][,yrange=yrange]
;
;       PARAMETERS:	data		input data
;
;
;       KEYWORDS:	over		Do overplot
;			max		Set max value for histogram
;			min		Set min value for histogram
;			linestyle	Choose linestyle
;			yrange		Two vector with vertical range
;
;       HISTORY: Drafted by A.McAllister mar-2-93.
;
;-
PRO go_hist,data,over=over,min=min,max=max,linestyle=line,yrange=yrange

if not keyword_set(min) then min=min(data)
if not keyword_set(max) then max=max(data)
if not keyword_set(line) then line=0

hist=histogram(data,min=min,max=max)

if not keyword_set(yrange) then yrange=[0,max(hist)]

if keyword_set(min) then minoff=min else minoff=min(data)

if keyword_set(over) then begin
	oplot,indgen(n_elements(hist))+minoff,hist,linestyle=line
endif else begin
	plot,indgen(n_elements(hist))+minoff,hist,linestyle=line,yrange=yrange
endelse



end
