;+
;       NAME: invrt
;
;
;       PURPOSE: to turn a matrix upside down using a simple pixel to 
;		 pixel mapping
;
;
;       METHOD: use indgen to make in index and invert that.
;
;
;       CALLING SEQUENCE:   outdata = invrt(indata)
;
;
;       PARAMETERS: indata   input data array
;
;
;       KEYWORDS:  x    when set it flips about the vertical axis
;		   y    when set it flips about the horizontal axis
;
;       HISTORY: drafted dec-19-92 AMcA.
;
;
;-
FUNCTION invrt,indata,x=x,y=y

datsz=size(indata)

if keyword_set(x) ne 0 then begin

   ind=indgen(datsz(1))
   indvrt=datsz(1)-ind-1
   outdata=indata([indvrt],*)

endif

if keyword_set(y) ne 0 then begin

   ind=indgen(datsz(2))
   indvrt=datsz(2)-ind-1
   outdata=indata(*,[indvrt])

endif

return, outdata

end