;+
; 	NAME: lnpnt
;
; 	PURPOSE: calculate a line of pixels
;
; 	CALLING SEQUENCE: out=lnpnt(x0,y0,x1,y1,arsz,[,XCOORDS=x,YCOORDS=y,VCOORDS=ss])
;
;	PARAMETERS:	x0,y0   	are the beginning point coordinates 
;            		x1,y1   	are the end point coordinates 
;	     		arsz 	 	is SIZE of the array being worked on
;	     		out		an array of zeros with the line as ones.
;
;	KEYWORDS:
;                      XCOORDS,YCOORDS    Ordered coordinates
;                      VCOORDS            A unified coordinate vector
;
;
; 	HISTORY: drafted nov. 1994, A. McAllister 
;
;-
FUNCTION lnpnt,x0,y0,x1,y1,arsz,XCOORDS=x,YCOORDS=y,VCOORDS=ss	

linlen=sqrt(abs(x1-x0)*abs(x1-x0) + abs(y1-y0)*abs(y1-y0))

n=fix(linlen)				;number of points

i=indgen(n+1)

x=i*(x1-x0)/n +x0
y=i*(y1-y0)/n +y0

linarr=intarr(arsz(1),arsz(2))

ss=x+long(y)*long(arsz(1))             	;unified coords vector

linarr(ss)=1                        	;circle image

return,linarr

end