;+
; NAME: match_type
;
;
; PURPOSE: to convert a variable type to match another
;
;
; METHOD: use size on the target variable, then a case statement
;	  for each type, and standard IDL conversion routines.
;
; CALLING SEQUENCE:  out=match_type(indat,tgrt)
;
;
; PARAMETERS:	indat	data to be converted
;		trgt	data whose type you want to match
;		out	a variable with type matching TRGT.       
;
; HISTORY: Drafted by A. McAllister, March 1993.
;-
FUNCTION match_type,indat,trgt

 sz=size(trgt)
 type=sz(n_elements(sz)-2)

 case type of

	1: out=bytscl(indat)
	2: out=fix(indat)
	3: out=long(indat)
	4: out=float(indat)
	5: out=double(indat)
	6: out=complex(indat)

	else: begin 
		    print,'MATCH_TYPE: Not a well defined number'
		    stop
	      end
 endcase

 return,out

 end