;+
;       NAME: my_exp_norm
;
;       PURPOSE:  a wrapper to customize the exposure normalizer
;
;       METHOD:
;
;       CALLING SEQUENCE: norm=my_exp_norm(data,index)
;
;       PARAMETERS:	data	input data cube, all one filter
;			index   index for input cube
;			norm    normalized cube
;
;	KEYWORDS:	scale	if set bytescale output
;
;       HISTORY: Drafted by A.McAllister mar-93
;		 Corrected call to EXP_NORM, AMcA, 10-jul-93.
;
;-
FUNCTION my_exp_norm,data,index,scale=scl

his_index,/enable

ndata=exp_norm(data,index,0,/orig)
ndata(0,0,*)=max(ndata)
ndata=alog(ndata>0.1)
if keyword_set(scl) then ndata=bytscl(ndata)

his_index,/disable

return,ndata

end

