;+
;       NAME: new_win
;
;
;       PURPOSE: make a new window with the next available #. Default
;		 positioning is 
;
;
;       METHOD: Find largest current number and add 1. The default passes
;		things to wdef. With the OFFSET keyword you can position
;		the new window relative to the old.
;
;
;       CALLING SEQUENCE: new_num=new_win(xs,ys)[,offset=ofst]
;
;
;       PARAMETERS:   	xs,ys		sizes of new window
;		      	new_num		number of new window
;
;	KEYWORDS: 	offset		offset the new window relative 
;					to the last one.
;
;       HISTORY: Drafted March 17, 1992, A. McAllister,
;		 [Code mostly copied from SXT_GRID]
;
;-
FUNCTION new_win,xs,ys,offset=ofst

 device,window=win_arr   			;get display info

 new_win = min(where(win_arr eq 0))		;next number

 if keyword_set(ofst) then begin		;offset from current window

   device,get_window=win_coords

   x0=(win_coords(0)-(ofst(0)+xs+30))>1
   y0=(win_coords(1)-(ofst(1)+ys+30))>1

   window,new_win,xpos=x0,ypos=y0,xs=xs,ys=ys

 endif else begin

 wdef,new_win,xs,ys   				;call wdef

 endelse




return,new_win

end