;+
;	NAME: oplin
;
; 	PURPOSE: draw a line on an image or cube
;
; 	CALLING SEQUENCE: ss=oplin(image,x0,y0,x1,y1,color)
;
;	PARAMETERS:	image  	is the image (or cube) to be drawn on
;  			x0,y0   	are the beginning point coordinates 
;  			x1,y1   	are the end point coordinates
;  			color	value to be given to the line pixels 
;
;  			ss		return the indices of the points on the line
;
;	CALLS: 	LNPNT,CUBE_DEPTH
;
; 	HISTORY: drafted nov. 1994, A. McAllister
;-
FUNCTION oplin,image,x0,y0,x1,y1,color

sz=size(image)

dum=lnpnt(x0,y0,x1,y1,sz,VCOORDS=ss)

for i=0,cube_depth(sz)-1 do begin

	temp=image(*,*,i) 

	temp(ss)=color

	image(*,*,i)=temp 

endfor


return,ss

end