;+
;       NAME: selpnt
;
;       PURPOSE:  To select a point from a displayed image, and mark the
;		  location if requested
;
;	METHOD: This will mark a series of points and return their coordinates.
;		Using the left button simply marks the points, using the middle
;		button marks and saves the point, and the right button exits. 		 		 
;
;       CALLING SEQUENCE: selpnt,x,y,/quiet,/mark
;
;       PARAMETERS:	xy		return the point locations (can be
;					a vector)
;
;	KEYWORDS:	quiet		when set don't print mouse intructions
;			mark		when set mark the location	
;
;       HISTORY: Drafted AMcA, Nov. 1994.
;		 Use DUM variable to buffer against XY being already 
;		 defined, AMcA, 11-17-94.
;		 
;-
PRO selpnt,xy,quiet=quiet,mark=mark

if not keyword_set(quiet) then begin

   print,'Use the left button to mark points.'
   print,'Use the middle button to select points for output,'
   print,'Use the right button to exit.'

endif

rtn=0

while rtn ne 4 do begin

      cursor,x,y,3,/device 
      rtn=!err
	
      if rtn ne 4 then begin

          if (rtn eq 2) then begin

            if n_elements(dum) eq 0 then begin

	      dum=[x,y]

     	    endif else begin

  	      dum=[[dum],[x,y]]

	    endelse

	  endif

	 if keyword_set(mark) then begin
   
		test=fix(total(tvrd(x-3,y-3,10,10))/100)
        	if test gt 120 then clr=0 else clr=255
        	xyouts,x-3,y-3,'+',/device,color=clr

	  endif
      endif

endwhile

if n_elements(dum) eq 0 then begin

   	if not keyword_set(quiet) then print,'returning empty'
	xy=-1

endif else xy=dum

end
