;+
;       NAME:  gt_stem_tag
;
;
;       PURPOSE: to get the file stems and extensions from a vector 
;	         of filenames
;
;       METHOD: Find last '/' and last '.', take what's between them
;		as the stem, and what's after the '.' as the extension.
;
;       CALLING SEQUENCE: gt_stem_tag,infil,stems,tags
;
;       PARAMETERS:	infil	string vector of full path/filenames
;			stems   a vector of filenames, no extensions
;			tags	a vector with the extensions
;
;       HISTORY: Drafted by A.McAllister, mar-93.
;		 [Code addapted from FILE_EXIST]
;-
PRO gt_stem_tag,infil,stems,tags

   filedelim=str_lastpos(infil,'/')
   tagdelim=str_lastpos(infil,'.')

   last=n_elements(infil)-1

   for i=0,last do begin

     if i ne 0 then begin

       stems=[stems,strmid(infil(i),filedelim(i)+1,tagdelim(i)-filedelim(i)-1)]
       tags=[tags,strmid(infil(i),tagdelim(i)+1,strlen(infil(i))-tagdelim(i))]

     endif else begin

       stems=strmid(infil(0),filedelim(0)+1,tagdelim(i)-filedelim(0)-1)
       tags=strmid(infil(0),tagdelim(0)+1,strlen(infil(0))-tagdelim(0))

     endelse

   endfor

end