;+
; NAME: target
;
; PURPOSE: formulate the target info (centroid and radius) for use
;	 with various routines.
;
; METHOD:  test for index and then call genloc
;
;
; CALLING SEQUENCE: trgt=target(image[,index][,/rough])
;
;
; PARAMETERS: 	image  	is the image you want the target variables for
;		index   Index in case its an SXT image
;
; KEYWORDS: 	rough 	for use with sxt images, makes it much
;			faster, only slightly less accurate
;
; RESTRICTIONS:   assumes the target is round. 
;
; CALLS: GENLOC
;
; RETURN TYPE:  FLOAT
;
; HISTORY: Drafted by A. McAllister Feb. 1993                            
;
;-
FUNCTION target,image,indx,rough=rough

  case n_params() of

	1:  gen_loc,image,CENTROID=cent,BFRAD=rad,/cir

	2:  gen_loc,image,indx,CENTROID=cent,BFRAD=rad,/SXT

  endcase

return,trgt=[cent,rad]

end
