;+
;       NAME:
;               time_dif
;
;       PURPOSE:
;               to produce time differenced data sets
;
;       METHOD:
;
;
;       CALLING SEQUENCE:
;
;
;       NOTES:
;
;
;       PARAMETERS:
;
;
;       KEYWORDS:
;
;
;       HISTORY:
;               drafted A.McA. mar,92
;
;-

Function time_dif,data,NORM=norm

;make sure we have long ints

; average of corners
;avg=(data(511,511,11)+data(511,0,11)+data(0,511,11)+data(0,0,11))/4

;loop to subtract boundary avergage

szdt=size(data)

answ=bytarr(szdt(1),szdt(2),szdt(3)-1)
answl=lonarr(szdt(1),szdt(2))
answb=bytarr(szdt(1),szdt(2))

;normalize the images, by removing average of background noise. This seems to
;give better results, eliminating bias in the differences

if keyword_set(NORM) ne 0 then begin

  for i=0,szdt(3)-1 do begin

;   four courner average
;   basez=(total(data(1:20,1:20,i))+total(data(1:20,szdt(2)-22:szdt(2)-2,i)) $
;          + total(data(szdt(1)-22:szdt(1)-2,1:20,i))                        $
;           + total(data(szdt(1)-22:szdt(1)-2,szdt(2)-22:szdt(2)-2,i)))/(1600)

;   southwest corner average

     basez=(total(data(szdt(1)-22:szdt(1)-2,szdt(2)-22:szdt(2)-2,i)))/(400)

 ;make the cut here, be careful about byte data

     data(*,*,i)=fix((data(*,*,i) - basez) > 0)

  endfor
endif

for i=0,szdt(3)-2 do begin

  answl = long(data(*,*,i+1)) - long(data(*,*,i))

  ;rescale top and bottom to fit in top and bottom of color table

  rnge=max(abs(answl))                 ;use this to keep scale of +/-

  print,rnge

ge0=where(answl ge 0)
lt0=where(answl lt 0)

szge0=size(ge0)
szlt0=size(lt0)

if szge0(0) then begin

  answb(ge0)=byte(114)+bytscl(answl(ge0),min=0.0,max=rnge,top=113)

endif

if szlt0(0) then begin

  answb(lt0)=bytscl((max(abs(answl(lt0))) + answl(lt0)),min=0.0,max=rnge,top=113)

endif

  answ(*,*,i)=answb

endfor

return,answ

end
