pro tvpr,window=window,landscape=lnd,lp=lp,filename=filename,$
  xsize=xsize,ysize=ysize,xoffset=xoffset,yoffset=yoffset,$
  image=image,realsize=realsize

; note pixel size limit may be encountered (eg. 980 x 980 is too big)
curr_window=!d.window
if n_elements(xsize) ne 0 then xsize=xsize else xsize=6.0
if n_elements(ysize) ne 0 then ysize=ysize else ysize=6.0
if n_elements(xoffset) ne 0 then xoffset=xoffset else xoffset=1.3
if n_elements(yoffset) ne 0 then yoffset=yoffset else yoffset=2.0
if n_elements(filename) ne 0 then filename=filename $
  			     else filename='/tmp/idl_plot'
if n_elements(lp) ne 0 then lp=lp else lp='ps3'
if keyword_set(window) then wset,window

image=tvrd(0,0,!d.x_size,!d.y_size)

if keyword_set(realsize) then begin

  xsize=!d.x_size*.008			;preserve aspect
  ysize=!d.y_size*.008

endif

if keyword_set(lnd) then begin

  print,"landscape"
  image=rotate(image,1)
  tmp=xsize
  xsize=ysize			
  ysize=tmp

endif

if (lp eq 'ps1' or lp eq 'ps6') then begin
  bpp=5
  color=0
endif else begin
  bpp=8
  color=1
endelse

print,xsize,ysize

set_plot,'ps'
device,filename=filename,color=color,bits_per_pixel=bpp,$
  xsize=xsize,ysize=ysize,xoffset=xoffset,yoffset=yoffset,/inches
tv,image, 0.,0., xsize=1., ysize=1., /normal

device,/close_file
set_plot,'x'
if (curr_window ne !d.window) then wset,curr_window

spawn,'( lp -d' + lp + ' ' + filename + '&& rm ' + filename + ' ) &'

end
