;+
; NAME:
;       xy_raster 
; PURPOSE:
;	To make a raster pattern of a time series of SXT images
;	to display time evolution of something or other.
;	The images start at upper left and go to lower right,
;	and the formatted time is written at the bottom of each
;	image.
; CALLING SEQUENCE:
; 	input data, index, rebin factor (e.g. 2 to double), and 
;       window number.
;	this routine opens IDL a window with the right size and 
;	writes to it.
; HISTORY:
;	drafted by H. Hudson, Jan. 1992
;       window argument added by A. McAllister, Feb. 1992
;-
pro xy_raster, data, index, factor, wnd
siz = size(data) & n_img = siz(3)
factor = factor * 64
wide = fix(sqrt(n_img))
deep = n_img/wide
xy = indgen(wide*deep)
x = xy mod wide
y = xy/wide & y = deep - y - 1
window,wnd,xs = wide*factor, ys = deep*factor
for i = 0, n_elements(x)-1 do begin
  tvscl,rebin(data(*,*,i),factor,factor,/sample), factor*x(i), factor*y(i)
  xyouts, factor*x(i), factor*y(i), fmt_tim(index(i)), /device
endfor
end
