;+
; NAME:
;       xy_raster 
; PURPOSE:
;	To make a raster pattern of a time series of SXT images
;	to display time evolution of something or other.
;	The images start at upper left and go to lower right,
;	and the formatted time is written at the bottom of each
;	image.
; CALLING SEQUENCE:
; 	input data, index, and rebin factor (e.g. 2 to double)
;	this routine opens IDL window 1 with the right size and 
;	writes to it.
;-
pro xy_raster, data, index, factor
siz = size(data) & n_img = siz(3)
factor = factor * 64
wide = fix(sqrt(n_img))
deep = n_img/wide + 1
xy = indgen(wide*deep)
x = xy mod wide
y = xy/wide & y = deep - y - 1
window,1,xs = wide*factor, ys = deep*factor
for i = 0, siz(3)-1 do begin
  tvscl,rebin(data(*,*,i),factor,factor,/sample), factor*x(i), factor*y(i)
  hhmm = strmid(fmt_tim(index(i)),10,9)
  xyouts, factor*x(i), factor*y(i), hhmm, /device
endfor
;tits = '   Dec. 2, 1991 Limb Flare, long exposures'
;xyouts,0,490,tits,/device,charsize=2
str = 'Yohkoh SXT'
xyouts, 280, 90, str, /device, charsize = 1.5
str = 'Exposure 78 msec, thin Al'
xyouts, 280, 65, str, /device, charsize=1.5
str = 'FOV 320 arc sec square'
xyouts, 280, 50, str, /device, charsize=1.5
end

