      subroutine cmpoly(x1,x2,idim1,idim2,m1,m2,ex,nex,
     &             mu,mxdim1,mxdim2,dsk,coef,dimcoef,fit)

c  Routine to evaluate the fit.

      integer idim1,idim2, m1,m2,nex, mxdim1,mxdim2, dimcoef
      integer ex(nex)
      real x1(idim1), x2(idim2), mu(mxdim1,mxdim2), coef(dimcoef)
      real dsk(mxdim1,mxdim2), fit(idim1,idim2)
      integer mx,mn,nr, mx_ord,iord,x1_ord,x2_ord
      integer i,j, i_coef,ncoef,ir,iex

      integer mx_x1
      parameter (mx_x1=2048)
      real x1pow(mx_x1),x2pow

c  Check dimensions.
      if (mx_x1.lt.idim1) then
C        write(6,'("cmpoly: x1pow needs dimension of",i)') idim1
         stop
      endif

c  Compute the number of coefficients in the bi-polynomial.
      mx=max(m1,m2)
      mn=min(m1,m2)
      nr=nex
      if (nr.eq.1) then
         if (ex(1).eq.0) nr=0
      endif
      ncoef = (mx+1)*(mx+2) - (mx+1)*(mx+2-(mn+1)) - mn*(mn+1)/2 + nr
      if (ncoef.gt.dimcoef) then
C        write(6,'("cmpoly: need more space, ncoef=",i," dimcoef=",i)')
C    &                        ncoef,dimcoef
         stop
      endif

c  Caluclate polynomial parameters.
      mx_ord = max(m1,m2)

c  Zero the fit array!
      do j=1,idim2
      do i=1,idim1
         fit(i,j) = 0.0
      enddo
      enddo

c  Evaluate the x,y part of the fit.
      i_coef = 0
      do iord=0,mx_ord
         do x2_ord=0,m2
            do x1_ord=0,m1
               if ((x1_ord+x2_ord) .eq. iord) then
                  i_coef = i_coef + 1

                  do i=1,idim1
                     x1pow(i) = x1(i)**x1_ord
                  enddo
                  do j=1,idim2
                     x2pow = x2(j)**x2_ord
                     do i=1,idim1
                        if (dsk(i,j).eq.1) fit(i,j) = fit(i,j) +
     &                       coef(i_coef) * x1pow(i) * x2pow
                     enddo
                  enddo

               endif
            enddo
         enddo
      enddo

c  Evaluate the radial part of the fit.
c     if (nex.eq.1) then
c        iex = ex(nex)
c        i_coef = i_coef + 1
c        do j=1,idim2
c        do i=1,idim1
c           if (dsk(i,j).eq.1) fit(i,j) = fit(i,j) +
c    &                        coef(i_coef) * mu(i,j)**iex
c        enddo
c        enddo
c     else
         do ir=1,nex
            i_coef = i_coef + 1
            iex = ex(ir)
            do j=1,idim2
            do i=1,idim1
               if (dsk(i,j).eq.1) fit(i,j) = fit(i,j) +
     &                               coef(i_coef) * mu(i,j)**iex
            enddo
            enddo
         enddo
c     endif

      return
      end
