      SUBROUTINE DIFF(WE, WH, WL, UE, UH, UL, VE, VH, VL, BH, BE, NUE,
     * NUH, NUL, NVE, NVH, NVL, NBH, NBE, M, N, NOUT, IRHS, MATU, MATV)
C
C     COMPUTES DIFFERENCE BETWEEN W, U, V AND B AS COMPUTED BY
C     EISPACK SVD AND MINFIT, HYBSVD, AND LINPACK SSVDC.
C
      REAL WE(1), WH(1), WL(1)
      REAL UE(NUE,1), UH(NUH,1), UL(NUL,1)
      REAL VE(NVE,1), VH(NVH,1), VL(NVL,1)
      REAL BE(NBE,1), BH(NBH,1)
      INTEGER NOUT, IRHS, M, N
      LOGICAL MATU, MATV
C
C     SORT SINGULAR VALUES AND EXCHANGE COLUMNS OF U AND V FOR EISPACK.
C     SELECTION SORT MINIMIZES SWAPPING OF U AND V.
C
      IF (N.LE.1) GO TO 40
      NM1 = N - 1
      DO 30 I=1,NM1
C...    FIND INDEX OF MAXIMUM SINGULAR VALUE
        ID = I
        IP1 = I + 1
        DO 10 J=IP1,N
          IF (WE(J).GT.WE(ID)) ID = J
   10   CONTINUE
        IF (ID.EQ.I) GO TO 30
C...    SWAP SINGULAR VALUES AND VECTORS
        T = WE(I)
        WE(I) = WE(ID)
        WE(ID) = T
        IF (MATV) CALL SSWAP(N, VE(1,I), 1, VE(1,ID), 1)
        IF (MATU) CALL SSWAP(M, UE(1,I), 1, UE(1,ID), 1)
        IF (IRHS.LT.1) GO TO 30
        DO 20 KRHS=1,IRHS
          T = BE(I,KRHS)
          BE(I,KRHS) = BE(ID,KRHS)
          BE(ID,KRHS) = T
   20   CONTINUE
   30 CONTINUE
C
   40 CONTINUE
      DWHE = 0.
      DWHL = 0.
      DWEL = 0.
      DUHE = 0.
      DUHL = 0.
      DUEL = 0.
      DVHE = 0.
      DVHL = 0.
      DVEL = 0.
      DBHE = 0.
      MINMN = MIN0(M,N)
C
      DO 50 I=1,MINMN
        DWHE = DWHE + (WH(I)-WE(I))**2
        DWHL = DWHL + (WH(I)-WL(I))**2
        DWEL = DWEL + (WE(I)-WL(I))**2
   50 CONTINUE
      DWHE = SQRT(DWHE)
      DWHL = SQRT(DWHL)
      DWEL = SQRT(DWEL)
      WRITE (NOUT,99999) DWHE, DWHL, DWEL
99999 FORMAT (/35H  2-NORM ( HYBSVD W - EISPAK W ) = , 1PE15.7/6H  2-NO,
     * 29HRM ( HYBSVD W - LINPAK W ) = , 1PE15.7/19H  2-NORM ( EISPAK W,
     * 16H - LINPAK W ) = , 1PE15.7/)
C
C     DIFFERENCE OF ABSOLUTE VALUES BECAUSE OF POSSIBLE SIGN DIFFERENCE.
C
      IF (.NOT.MATU) GO TO 80
      DO 70 J=1,MINMN
        DO 60 I=1,M
          DUHE = DUHE + (ABS(UH(I,J))-ABS(UE(I,J)))**2
          DUHL = DUHL + (ABS(UH(I,J))-ABS(UL(I,J)))**2
          DUEL = DUEL + (ABS(UE(I,J))-ABS(UL(I,J)))**2
   60   CONTINUE
   70 CONTINUE
      DUHE = SQRT(DUHE)
      DUHL = SQRT(DUHL)
      DUEL = SQRT(DUEL)
      WRITE (NOUT,99998) DUHE, DUHL, DUEL
99998 FORMAT (/35H  2-NORM ( HYBSVD U - EISPAK U ) = , 1PE15.7/6H  2-NO,
     * 29HRM ( HYBSVD U - LINPAK U ) = , 1PE15.7/19H  2-NORM ( EISPAK U,
     * 16H - LINPAK U ) = , 1PE15.7/)
C
   80 IF (.NOT.MATV) GO TO 110
      DO 100 J=1,MINMN
        DO 90 I=1,N
          DVHE = DVHE + (ABS(VH(I,J))-ABS(VE(I,J)))**2
          DVHL = DVHL + (ABS(VH(I,J))-ABS(VL(I,J)))**2
          DVEL = DVEL + (ABS(VE(I,J))-ABS(VL(I,J)))**2
   90   CONTINUE
  100 CONTINUE
      DVHE = SQRT(DVHE)
      DVHL = SQRT(DVHL)
      DVEL = SQRT(DVEL)
      WRITE (NOUT,99997) DVHE, DVHL, DVEL
99997 FORMAT (/35H  2-NORM ( HYBSVD V - EISPAK V ) = , 1PE15.7/6H  2-NO,
     * 29HRM ( HYBSVD V - LINPAK V ) = , 1PE15.7/19H  2-NORM ( EISPAK V,
     * 16H - LINPAK V ) = , 1PE15.7/)
C
  110 IF (M.LT.N .OR. IRHS.LT.1) GO TO 140
      DO 130 J=1,IRHS
        DO 120 I=1,MINMN
          DBHE = DBHE + (ABS(BE(I,J))-ABS(BH(I,J)))**2
  120   CONTINUE
  130 CONTINUE
      DBHE = SQRT(DBHE)
      WRITE (NOUT,99996) DBHE
99996 FORMAT (/35H  2-NORM ( HYBSVD B - MINFIT B ) = , 1PE15.7/)
C
  140 CONTINUE
      RETURN
      END
