      program flmb

c  Routine to compute a least squares fit to the limb darkening function
c  on solar data.  A svd routine is used.

      integer nx,ny, idimex, n_names, dimcoef
      parameter(idimex=2, nx=512, ny=512, n_names=200, dimcoef=8)
      character*80 names(n_names)
      integer i, n_files, m1,m2,ex(idimex)
      real x0,y0,rad_t,rad_lim
      real i1(nx,ny),i2(nx,ny), weight(nx,ny), fit(nx,ny)
      real coef(dimcoef)

c  Read list of file names of files to be processed.
      open(unit=10,file='/d/white/hi_l/list_930322')
      n_files=0
      do i=1,n_names
         read(10,'(a)',end=10) names(i)
         n_files=n_files+1
         write(6,'(i,a)') n_files,names(i)
      enddo
   10 continue
      write(6,'("number of files read=",i)') n_files
      close(unit=10)

c  Loop over the list of file names performing the fitting on each.
      do i=1,n_files

         call get_jh(names(i), i1,i2,nx,ny,x0,y0,rad_t)

c        Perform the fit!
         rad_lim = rad_t - 4.0
         m1 = 2
         m2 = 2
         ex(1) = 1
         ex(2) = 3
         call flmbiter(x0,y0,rad_t,rad_lim, i1,nx,ny, weight,
     &                 m1,m2,ex,idimex, fit, coef,dimcoef)

      enddo

c  Open output file to contain the fitting parameters and other interesting
c  information about the fit.

      stop
      end
