      subroutine get_jh( name, im1,im2, nx,ny, x0,y0,rad_t)

c  Routine to take care of the details of reading the input FITS files.

      integer dimar1,dimar2
      parameter (dimar1=1024, dimar2=1024)
      character*(*) name
      integer openio,rddat,rdvarr,fildes,mode,nx,ny,idim,i,j,i1,j1
      real im1(nx,ny),im2(nx,ny), x0,y0,rad_t
      real rx,ry
      integer idmgh,bytrev
      parameter (idmgh=10, bytrev=2)

      integer*4 ghdrar(idmgh)
      real*4 arrf(dimar1,dimar2,2)

c  Open input file.
      mode = 0
      if( openio(fildes,name,mode).ne.0 )then
         write(6,'("get_jh: error in opening file=",a)') name
         stop
      endif

c  Read the data!
      idim=dimar1*dimar2*2
      if (rddat(fildes,bytrev,idim,arrf,ghdrar,idmgh).ne.0) then
         write(6,'("get_jh: error reading input file=",a)') name
         stop
      endif

c  Compress the image to half size.
      do j=1,ny
      j1 = 2*j-1
      do i=1,nx
         i1 = 2*i-1
         im1(i,j) = (arrf(i1,j1,1) + arrf(i1+1,j1,1) + arrf(i1,j1+1,1) +
     &                         arrf(i1+1,j1+1,1))/4.
         im2(i,j) = (arrf(i1,j1,2) + arrf(i1+1,j1,2) + arrf(i1,j1+1,2) +
     &                         arrf(i1+1,j1+1,2))/4.
      enddo
      enddo
      do i=1,nx
         im2(i,1) = 0.0
      enddo

c  Get center and radius of image from header.
      if (rdvarr('E_XCEN  ', x0).ne.0) then
         write(6,'("get_jh: error reading E_XCEN")')
         stop
      endif
      x0 = x0/2.
      if (rdvarr('E_YCEN  ', y0).ne.0) then
         write(6,'("get_jh: error reading E_YCEN")')
         stop
      endif
      y0 = y0/2.
      if (rdvarr('E_XSMD  ', rx).ne.0) then
         write(6,'("get_jh: error reading E_XSMD")')
         stop
      endif
      rx = rx/2.
      if (rdvarr('E_YSMD  ', ry).ne.0) then
         write(6,'("get_jh: error reading E_YSMD")')
         stop
      endif
      ry = ry/2.
      rad_t = max(rx,ry)

      write(6,'("get_jh: x0,y0=",2f," rx,ry=",2f)') x0,y0,rx,ry

      return
      end
