;+
; NAME		ld3.pro
;
; PURPOSE	Compute limb darkening.
;
; AUTHOR	Andrew L. Stanger   HAO/NCAR
;
; HISTORY	Created 12 Oct 2000
;		28 Feb 2001: Add rms_l & rms_h to flmbiter.f arguments.
;
;-

PRO ld3, fits_name

img = readfits (fits_name, hdu)

xdim = fxpar (hdu, 'NAXIS1')
ydim = fxpar (hdu, 'NAXIS2')
xcen = fxpar (hdu, 'CRPIX1')
ycen = fxpar (hdu, 'CRPIX2')
rx   = fxpar (hdu, 'CRRADIUS')
ry   = rx

flmb3, fits_name, hdu, img, xcen, ycen, rx, ry, 20, resid

window, xsize=xdim, ysize=ydim
tvscl, congrid (resid, xdim, ydim)
wait, 3

tvscl, congrid (hist_equal (resid), xdim, ydim)
wait, 3

plot, resid [*, ycen]

END

