function juliandate,date
; adapted from J. Meeus, chpter 3, "Julian Day and Calender Date"
; given a vector date (UT only!), calculates the Julian Date
; each row of the array must be of the form
; [ Year, monthnumber, dayofmonth, GMT (in decimal hrs) ] 
; G. Ucker   27 April 1992

date=double(date)

itest = where(date(1,*) lt 3.0)
if itest(0) ge 0 then begin
	date(0,itest) = date(0,itest) - 1.0d
	date(1,itest) = date(1,itest) + 12.0d
endif

idate = date(0,*) + date(1,*)/100.0d + date(2,*)/10000.0d + date(3,*)/24000000.0d

itest = where(idate ge 1582.1015d)
jtest = where(idate lt 1582.1015d)

if (itest(0) ge 0) then begin
	a = long(date(0,itest)/100.0d)
	b = (2L - a) + long(a/4.0d)
	jd = long(365.25d*date(0,itest))+long(30.6001d*(date(1,itest)+1d))+ $
			date(2,itest)+date(3,itest)/24.0d + 1720994.5d + b
endif

if (jtest(0) ge 0) then begin

	ktest = where(date(0,*) ge 0d)
	ltest = where(date(0,*) lt 0d)
	
	if (ktest(0) ge 0) then begin
		jd = long(365.25d*date(0,ktest)) + $
		long(30.6001d*(date(1,ktest)+1.0d)) + $
		date(2,ktest)+date(3,ktest)/24.0d + 1720994.5d
	endif

	if (ltest(0) ge 0) then begin
		jd = long(365.25d*date(0,ltest)-0.75d)+ $
		long(30.6001d*(date(1,ltest)+1.0d))+ $
		date(2,ltest)+date(3,ltest)/24.0d + 1720994.5d
	endif
endif

return,jd
end
