PRO SPDECOM, fmt, ibuf, obuf, dbuf, first_sync
; engine that decommutates the input stream buffer by
;	1) search for preamble sync (in the SPARTAN case 5 bytes are common
;		to all the separate sync patterns)
;	2) determine which fmt(j) it is
;	3) use the corresponding dbuf(j).ind to pull out the desired data
;		and assign that to the correct obuf(j).dat row.
;	4) start a search for the next occurence of the preample (after
;		fmt(j).slen bytes are skipped)
;	Do this until either eof of the input stream file or one of obuf.dat
;		vectors is full.
;
;	Author:	Greg Ucker
;	Date:	20 October 1993
;
; MODIFICATIONS:
;
synclen = 6L
maxnfmt = max(fmt(*).flen)

; Start: ibuf has some data in it, find the sync pattern

spfindsync, fmt, ibuf, obuf

; was a sync found?
; yes sync found
if ( ((ibuf.syncfnd ge 0) and not(first_sync)) or $
	((ibuf.syncfnd eq 0L) and first_sync) ) then begin
	first_sync = 0b
	ibn = ibuf.ibvalid - ibuf.ibpos 
	
	; enough data to decommutate?
	if (ibn gt fmt(ibuf.syncfnd).flen-synclen) then begin ; yes enough data


		; split out the data based on the fmt & dbuf stuff
		; and store it in the output data buffers

obuf(ibuf.syncfnd).dat(0L:dbuf(ibuf.syncfnd).nind-1L, $
	obuf(ibuf.syncfnd).ndat) = $
ibuf.ib(ibuf.ibpos + dbuf(ibuf.syncfnd).ind(0L:dbuf(ibuf.syncfnd).nind-1L))


		obuf(ibuf.syncfnd).ndat = obuf(ibuf.syncfnd).ndat+1L
		
		; now ready to update the status parameters
		; for the next iteration
		ibuf.ibpos = ibuf.ibpos + fmt(ibuf.syncfnd).slen - synclen -1L
		ibuf.tbrd = 0L		; don't trigger the input read cycle
		ibuf.syncfnd = -1L
	endif else begin			; sync, but not enough data
		ibuf.ib(0L:ibn+synclen-1L) = $
			ibuf.ib(ibuf.ibpos-synclen:ibuf.ibvalid-1L)
		ibuf.ibvalid = ibn + synclen
		ibuf.ibpos = 0L
		ibuf.tbrd = ibuf.ibnmax - ibuf.ibvalid
	endelse

endif else begin
if (ibuf.syncfnd lt 0) then begin	; no sync found in the data
	ibuf.tbrd = ibuf.ibnmax
	ibuf.ibpos= 0L
	ibuf.ibvalid = 0L
endif
; note that the case where first_sync is 1b and a sync not equalling the 
; the 'favored first' sync, then the ibuf.ibpos is left alone, to be 
endelse

return
end

