/* mktab80.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Make SMM C/P CME table using file 'cme80.dat' as input.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   31 August 1994
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>

main (argc, argv)

int argc ;
char *argv [] ;

{
   static char dummy [84] ;
   static char line [84] ;

   static char d    [12] ;


   int i  = 0 ;
   int n  = 0 ;
   int q  = 0 ;
   int a  = 0 ;
   int l  = 0 ;
   int w  = 0 ;
   int s  = 0 ;
   int lat = 0 ;

   float m  = 0.0 ;
   float k  = 0.0 ;
   float p  = 0.0 ;
   float t  = 0.0 ;
   float mass = 0.0 ;

   FILE *ifd, *ofd ;

   ifd = fopen ("cme80.TAB", "r") ;
   ofd = fopen ("cme80.tab", "w") ;

   fgets (line, 80, ifd) ;		/* Read label line from input file. */

   fprintf (ofd, "num  DOY       mass[kg]  Q  PA   lat  wid  km/s  kinetic  potential  total[j]\n") ;

   i = -1 ;

   /* Line loop. */

   while (fscanf (ifd, "%3d  %9s  %e  %3d  %3d  %3d  %3d %4d  %e  %e  %e",
		  &n, d, &m, &q, &a, &l, &w, &s, &k, &p, &t) != EOF)
      {
      i = i + 1 ;
      mass = m * 0.001 ;			/* mass in kg. */

      /* Determine latitude. */

      if (a >=   0 && a <=  90)
         lat =  90 - a ;

      if (a >   90 && a <= 180)
         lat = 90 - a ;

      if (a >  180 && a <= 270)
	 lat = a - 270 ;

      if (a >  270 && a <= 360)
         lat = a - 270 ;

      if (lat != l)
	 {
	 fprintf (stderr, "error> PA: %d  l: %d  lat: %d\n", a, l, lat) ;
	 /*
	 exit (-1) ;
	  */
	 }

      /* Write output line. */

      fprintf (stdout,
	      "%3d  %-8s  %8.2e  %d  %3d  %3d  %3d  %4d %9.2e %9.2e %9.2e\n",
	       i, d, mass, q, a, lat, w, s, k, p, t) ;
      fprintf (ofd,
	      "%3d  %-8s  %8.2e  %d  %3d  %3d  %3d  %4d %9.2e %9.2e %9.2e\n",
	       i, d, mass, q, a, lat, w, s, k, p, t) ;
      }

   fclose (ifd) ;
   fclose (ofd) ;
   exit (0) ;
}
