
pro center, fits_list

fits_name = ' '				


openr, 1, fits_list			
openw, 2, 'center.dat'

format='(i4,i4,i4,f8.2,2x,2f8.2,1x,3f8.2,1x,3f8.2,1x,2f8.2 )'



; File processing loop.
i = 0

 while  (NOT EOF (1)) DO	$		
      begin 
      readf, 1, fits_name		
      image = readfits (fits_name, hdu)	

   
      xdim =  fxpar (hdu, 'NAXIS1')
      ydim =  fxpar (hdu, 'NAXIS2')
      xcen =  fxpar (hdu, 'CRPIX1')
      ycen =  fxpar (hdu, 'CRPIX2')
      radius =fxpar (hdu, 'CRRADIUS')
      time   =fxpar (hdu, 'TIME-OBS')

      hour= float( strmid(time,0,2) )
      min = float( strmid(time,3,2) )
      sec = float( strmid(time,6,2) )
      
      ft = hour*60.+ min+ sec/60.

      xshift = fix( (1534-xdim)*0.5 )
      yshift = fix( (1030-ydim)*0.5 )

     
     find_center, image, minint, xc, yc, r

printf, 2, hour, min, sec, ft, xc+xshift, yc+yshift, xc, yc, r , xcen, ycen, radius, $
xc-xcen, yc-ycen, format= format



endwhile


close,1
close,2

end
