;
; Routine to plot Mk4 corrector table values
;
; In your home directory, create a file called
; 'correctorlist'
; It contains four lines with the filenames
;	(see ~elmore/correctorlist)
; 
; channel 0 gain
; channel 1 gain
; channel 0 offset
; channel 1 offset
;
; Set the following variable to 'y' if you want to send the
; output to haow.
;

print,"\----------------------------------------"
print,"enter psplot='y' for printer output"
print,"enter psplot='n' for screen output"
print," then enter '.c'"
print,"----------------------------------------"

psplot = 'n'
if (psplot eq 'y') then begin ;{
        print,'The name of the ps file is: plot.ps'
        print,'It will be printed on haow when you are finished.'
        print,' '
        set_plot,'ps'
        device,/landscape,/inches,xsize=10.3,ysize=8.0,$
               xoffset=0.2,yoffset=10.5,filename='plot.ps'
    endif else begin;}{
        device,window_state=winst
        if(winst(0) eq 0)then window,xsize=900,ysize=800
    endelse ;}

offsetfile0 = 'fred'
offsetfile1 = 'fred'
gainfile0 = 'fred'
gainfile1 = 'fred'
offset0 = lonarr(384)
gain0 = lonarr(384)
offset1 = lonarr(384)
gain1 = lonarr(384)

close,13 & openr,13,'~/correctorlist'

readf,13,gainfile0
close,1 & openr,1,gainfile0 & readu,1,gain0
readf,13,gainfile1
close,1 & openr,1,gainfile1 & readu,1,gain1

!p.ticklen=1
!p.multi=[0,1,3]

gmn = 1.e4
gmx = 1.e7

plot_io,[0,384],[gmn,gmx],title=gainfile0,xtitle='pixel',ytitle='gain',/nodata,ystyle=1,charsize=1.5
oplot,gain0,psym=1

plot_io,[0,384],[gmn,gmx],title=gainfile1,xtitle='pixel',ytitle='gain',/nodata,ystyle=1,charsize=1.5
oplot,gain1,psym=1

stop

!p.multi=[0,1,3]

dmn = 0
dmx = 1000

readf,13,offsetfile0
close,1 & openr,1,offsetfile0 & readu,1,offset0
readf,13,offsetfile1
close,1 & openr,1,offsetfile1 & readu,1,offset1

plot,[0,384],[dmn,dmx],title=offsetfile0,xtitle='pixel',ytitle='offset',/nodata,ystyle=1,charsize=1.5
oplot,offset0,psym=1

plot,[0,384],[dmn,dmx],title=offsetfile1,xtitle='pixel',ytitle='offset',/nodata,ystyle=1,charsize=1.5
oplot,offset1,psym=1

close,13
close,1

if(psplot eq 'y')then begin;{
    device,/close
    set_plot,'x'
    spawn,'lp -d haow -o nobanner plot.ps'
    psplot='n'
endif;}

stop
end
