;
; Cytorec
; Convert to rectangular coordinates
; bin 2 by 2
; height = 0.894 + .00546 * pix
;
;
minrad = 1.08
lowsun = .894
scale = .00546
lowpix = 159		; lowsun/scale
solrad = 183		; 1./scale
minpix = 197		; minrad/scale
minpix = 194		; minrad/scale
lastgood = 360
; first good = minpix - lowpix

bindim = ( lastgood + lastgood + lowpix + lowpix )/2

filename = 'cylist'
close,2 & openr,2,'cylist'
readf,2,filename & close,2
head =0 & head =bytarr(1024) ;;
headib=0 & headib=lonarr(16)
headf =0 & headf =fltarr(24)
headie=0 & headie=lonarr(16)
pad = bytarr(800)

top =long(0)

close,1 & openr,1,filename+'.CalI' & point_lun,-1,top & readu,1,headib
                                                  readu,1,headf
                                                  readu,1,headie
                               point_lun, 1,top & readu,1,head
close,1

;;;;;;;;;;;;;;;;;;;;;;;;;
numaz = headib(9)
numpix = headib(10)
pangle = headf(0)
print,numaz,numpix,pangle
;;;;;;;;;;;;;;;;;;;;;;;;;
loadct,3
window,0,xsize=numaz,ysize=numpix-43,title='Cylindrical Q'
window,1,xsize=bindim,ysize=bindim,ypos=400,title='Rectangular Q'

img_q= fltarr(numpix,numaz)

;
close,2 & openr,2,'cylist'
while ( not eof(2) ) do begin
	readf,2,filename
	print,filename

	str = string(filename+'.SlitpB')
	close, 1 & openr,1,str &  readu,1,head & readu,1,img_q
	wset,0
	tv,bytscl(transpose(img_q(minpix-lowpix:lastgood,*)),-1,2.5)

	pb = img_q
	pb = shift(pb,0,180)
	r = findgen(lastgood+lowpix)
	pbpad = fltarr(lastgood+lowpix,numaz)
	pbpad(lowpix:lastgood-1+lowpix,*) = pb(0:lastgood-1,*)
	pbpad(0:solrad-1,*) = 1.
	pbpad(solrad:minpix,*)=0.
	theta = findgen(numaz)*!pi/360.
	rpb = polar_surface ( pbpad,r,theta,spacing=[2,2],/grid)
	wset,1
	tv,bytscl(rpb,-1,2.5)

	str = string(filename+'.rpBslit')
	rpbdim = size(rpb)
	headib(10) = rpbdim(2)
	headib(9) = rpbdim(1)
	close,1 & openw,1,str & writeu,1,headib $
		& writeu,1,headf & writeu,1,headie $
		& writeu,1,pad & writeu,1,rpb
;	close,1 & openw,1,str & writeu,1,head & writeu,1,rpb

	zzz = tvrd()
	write_gif,filename+'.rpBslit.gif',zzz

if ( dostop  eq 'y' ) then stop

endwhile

print,'done'

stop

end

