;
;  fixmk4
;
;  Open fixlist to get a list of filename roots to repair
;  Root is like c19_11
;  Files with .i, .q, and .u extensions to root are read.
;  The .sk file of that root is read.
;  I, Q, and U are normalized by sky transmission
;  Wraparounds are looked for and corrected.
;  Bias offset is corrected using first 10 pixels for error
;  and scaling all pixels using gain table.
;	Corrector table is used to correct bias from all scans
;	by first removing gain, correcting bias, then re-applying gain
;  For old camera data, a non linear correction is applied before
;  re-applying gain
;  Settings are read from the 'settings' file in the current directory
;
;  Non-inear version:
;  7/24/01 revision DFE
;  7/27/01 subscripts now az,height.  Bias from reference pixels 
;	applied to each height now the only bias removal in this scheme.  DFE
;

;
; Define variables and read the settings file
;
olddalsa = 'y'
dostreach = 'y'
correctfile0 = 'fred'
correctfile1 = 'fred'

close,15 & openr,15,'settings'
readf,15,olddalsa
olddalsa = strtrim(olddalsa)
readf,15,kappa
readf,15,phaseoffset
readf,15,correctfile0
readf,15,correctfile1
readf,15,dostreach
dostreach = strtrim(dostreach)
readf,15,linelow
readf,15,linehigh
readf,15,pixoff
readf,15,pixscale
readf,15,minrad
readf,15,maxrad
readf,15,iscale
readf,15,ioffset
readf,15,qscale
readf,15,qoffset
readf,15,uscale
readf,15,uoffset
readf,15,lowbias
readf,15,highbias

NUMPIX = 384
NUMANG = 720
CORONA = 1000
CAL0 = 0
CAL15 = 150
DARK = 9999

; CW/CCW offset in degrees
PSHIFT = 0.5

;
; Perhaps should be in settings file?
; this depends upon how rawt4 is coded
;
zerosky = 376.

temp = 0
corgain0=lonarr(NUMPIX)
corgain1=lonarr(NUMPIX)
close,2 & openr,2,correctfile0 & readu,2,corgain0
close,2 & openr,2,correctfile1 & readu,2,corgain1
;corgain0 = swap_endian(corgain0)
;corgain1 = swap_endian(corgain1)

filename='fred'
!y.range=[-32768,32767]
loadct,16

window,0,xsize=983,ysize=384
window,1,xsize=numang,ysize=384,ypos=400
;
; while there are still filenames to read from fixlist
; read and process them
;
headib=0 & headib=lonarr(16)  
headf =0 & headf =fltarr(32)
headie=0 & headie=lonarr(16)  
headpad=0 & headpad=bytarr(1024-4*16-4*32-4*16)

close,2
openr,2,'fixlist' 
readf,2,filename
print,filename
filei = string(filename+'.i')

close,1 & openr,1,filei
	readu,1,headib
	readu,1,headf
	readu,1,headie
	readu,1,headpad

;headib=swap_endian(headib)
;headf=swap_endian(headf)
;headie=swap_endian(headie)
;head=swap_endian(head)

close,2
openr,2,'fixlist' 
while ( not eof(2) ) do begin
	readf,2,filename
	print,filename
	filei = string(filename+'.i')
	close,1 & openr,1,filei
		readu,1,headib
		readu,1,headf
		readu,1,headie
		readu,1,headpad

;	headib=swap_endian(headib)
;	headf=swap_endian(headf)
;	headie=swap_endian(headie)
;	head=swap_endian(head)

	NUMPIX = headib(10)
	NUMAZ = headib(9)

	azpix = findgen(NUMAZ)
	datai = intarr(numaz)
	dataq = intarr(numaz)
	datau = intarr(numaz)

	imgi=intarr(NUMAZ,NUMPIX)
	imgq=intarr(NUMAZ,NUMPIX)
	imgu=intarr(NUMAZ,NUMPIX)
	skyarray=intarr(NUMAZ)
	starray=intarr(NUMAZ)
	angle=intarr(NUMAZ)
	biasarray=fltarr(NUMAZ)

	type = headie(0)
	if ( type eq CORONA )  then print,"corona"
	if ( type eq CAL0 )  then print,"cal0"
	if ( type eq CAL15 )  then print,"cal15"
	if ( type eq DARK )  then print,"dark"

	i=0
	while ( not eof(1) ) do begin
		readu,1,datai
;		datai=swap_endian(datai)
		imgi(*,i)=datai(*)
		i=i+1
	endwhile
	irays = i

	fileq = string(filename+'.q')
	close,1 &  openr,1,fileq
		readu,1,headib
		readu,1,headf
		readu,1,headie
		readu,1,headpad
	i = 0
	while ( not eof(1) ) do begin
		readu,1,dataq
;		dataq=swap_endian(dataq)
		imgq(*,i)= dataq(*)
		i=i+1
	endwhile

	fileu = string(filename+'.u')
	close,1 &  openr,1,fileu
		readu,1,headib
		readu,1,headf
		readu,1,headie
		readu,1,headpad
	i = 0
	while ( not eof (1) ) do begin
		readu,1,datau
;		datau=swap_endian(datau)
		imgu(*,i)= datau(*)
		i = i + 1
	endwhile

	fileang = string(filename+'.ba')
	close,1 &  openr,1,fileang
		readu,1,headib
		readu,1,headf
		readu,1,headie
		readu,1,headpad
	i = 0
	while ( not eof(1) ) do begin
		readu,1,temp
;		temp=swap_endian(temp)
		angle(i) = temp
		i=i+1
	endwhile
	angle = 360. * float(angle) / 16384.

;
; .sk not used: rawt4 puts value into header
; Would eventually like to have this restored with value
; for each ray used.  A/D for sky transmission needs to be fixed
; first.  DFE 7/01
;
	filesky = string(filename+'.sk')
	close,1
	openr,1,filesky
	readu,1,headib
		readu,1,headf
		readu,1,headie
		readu,1,headpad
	i = 0
	while ( not eof(1) ) do begin
		readu,1,temp
;;		temp=swap_endian(temp)
		skyarray(i) = temp
		i=i+1
	endwhile
	skydim = size(skyarray)

	filest = string(filename+'.st')
	close,1 &  openr,1,filest
		readu,1,headib
		readu,1,headf
		readu,1,headie
		readu,1,headpad
	i = 0
	while ( not eof(1) ) do begin
		readu,1,temp
;		temp=swap_endian(temp)
		starray(i) = temp
		i=i+1
	endwhile
	stdim = size(starray)
	;
	;
;
; rawt4 as of July 2001 does a good job computing sky transmission
;
if ( olddalsa eq 'n' ) then begin
	sky = skyis(skyarray,skydim(1))
	print,'Sky transmission',sky,'=',sky/zerosky
endif else begin
	print,'rawt4 transmission',headf(10),'=', headf(10)/zerosky
	sky = headf(10)
endelse
	numy = i

print,numy,' azimuths'

wset,0
tv,bytscl(imgi,-32768,32767)
tv,bytscl(imgu,-2000,2000)
tv,bytscl(imgq,-1000,5000)

; Float arrays

	imi = float(imgi)
	imq = float(imgq)
	imu = float(imgu)
;
; Check for and repair negative Q/U in old data
;
if ( type eq CORONA )  then begin
	for ii=0,numaz-1 do begin
		if ( imq(ii,linelow-40) lt 0. ) then begin
			imq(ii,*)= -1.*imq(ii,*)
			imu(ii,*)= -1.*imu(ii,*)
		endif
	endfor
tv,bytscl(imq,-1000,5000)
endif

; Fix digital wraps in intensity for all but dark.
; For corona fix digital wraps at low heights,
; attempting to correct more than one wrap around.
; This works well for new camera 5/01 onward.
;

if ( type ne DARK ) then begin
	fred = imi(*,35:365)
	a = where ( fred lt 0 )
	if ( a(0) ne -1 ) then fred(a)=fred(a)+65536.
	imi(*,35:365)=fred
	if ( type eq CORONA ) then begin
		for jj=0,numaz-1 do begin
			wrapq = 0.
			wrapi = 0.
			if ( olddalsa eq 'n' ) then begin
				for ii=34,20,-1 do begin
					imq(jj,ii)=imq(jj,ii) + wrapq
					imi(jj,ii)=imi(jj,ii) + wrapi
					if ( imi(jj,ii) lt 0 ) then begin
						wrapi = wrapi + 65536.
						imi(jj,ii) = imi(jj,ii) + 65536.
					endif
					if ( imq(jj,ii) lt 0 ) then begin
						wrapq = wrapq + 65536.
						imq(jj,ii) = imq(jj,ii) + 65536.
					endif
				endfor
			endif else begin
				for ii=34,20,-1 do begin
					if ( imi(jj,ii) lt 0 ) then begin
						imi(jj,ii) = imi(jj,ii) + 65536.
					endif
					if ( imq(jj,ii) lt 0 ) then begin
						imq(jj,ii) = imq(jj,ii) + 65536.
					endif
				endfor
			endelse
		endfor
	endif
endif

;
; Remove the corrector table gain from the image
;
; Correct bias error on a ray by ray basis
; using offset of specified range of low pixels
;
; if old Dalsa camera apply non linear gain
; Intensity corrected by kappa function
; Polarization corrected by derivative of intensity
;
; Re-apply corrector table gain
;

corfac = (corgain0+corgain1)/2.

fac = float(highbias-lowbias+1)

if ( olddalsa ne 'y' ) then begin
print,'Linear'
	for ii=0, NUMAZ-1 do begin
		imi(ii,*)=imi(ii,*)/corfac
		biasarray(ii) = total(imi(ii,lowbias:highbias))/fac
		imi(ii,*)=imi(ii,*)- biasarray(ii)
		imi(ii,*)=imi(ii,*)*corfac
	endfor
endif else begin
print,'Nonlinear'
	for ii=0, NUMAZ-1 do begin
		imi(ii,*)=imi(ii,*)/corfac
		imq(ii,*)=imq(ii,*)/corfac
		imu(ii,*)=imu(ii,*)/corfac

		biasarray(ii) = total(imi(ii,lowbias:highbias))/fac
		imi(ii,*)=imi(ii,*)- biasarray(ii)

		fred = kappa*(imi(ii,*)^(kappa-1))
		imq(ii,*)=imq(ii,*)*fred
		imu(ii,*)=imu(ii,*)*fred
		imi(ii,*)=imi(ii,*)^kappa

		imi(ii,*)=imi(ii,*)*corfac
		imq(ii,*)=imq(ii,*)*corfac
		imu(ii,*)=imu(ii,*)*corfac
	endfor
endelse


;
; Fix NaN problems
a = where ( finite(imi) eq 0 )
if ( a(0) ne -1 ) then begin
	print,'fixing NAN'
	help,a
	imi(a) = 1.
endif

a = where ( finite(imq) eq 0 )
if ( a(0) ne -1 ) then begin
	print,'fixing NAN'
	help,a
	imq(a) = 0.
endif
a = where ( finite(imu) eq 0 )
if ( a(0) ne -1 ) then begin
	print,'fixing NAN'
	help,a
	imu(a) = 0.
endif

;
; don't let intensity be 0 or negative
if ( type ne DARK ) then begin
	a = where ( imi le 0 )
	if ( a(0) ne -1 ) then begin
		print,'fixing negative'
		help,a
		imi(a) = 1.
	endif
endif

;
; Make scan go the proper direction
;
	ang = float(angle(0:numaz-1))
	newang = findgen(NUMANG)/(NUMANG/360.) - 180.
	rev = 0
	if ( starray(0) gt 8000 ) then rev = 1
	if ( rev eq 1 ) then begin
		print,'reverse'
		shiftpix = (180. - 30. + PSHIFT )*NUMANG/360.
	endif  else begin
		print,'forward'
		shiftpix = (180. - 30. - PSHIFT )*NUMANG/360.
	endelse

;
; Attempt to remove barrel angle problems
;
	absc = findgen(numaz)
	coef=poly_fit(absc,ang,1,angfit)
	a = where(abs(ang-angfit) gt 0.5 )
	if ( a(0) ne -1 ) then begin
		sofa = size(a)
		print,"Fixing ",sofa(1)," barrel problems"
		ang(a) = angfit(a)
		coef=poly_fit(absc,ang,1,angfit)
		a = where(abs(ang-angfit) gt 0.5 )
		if ( a(0) ne -1 ) then begin
			ang(a)=angfit(a)
		endif
	endif

;
; Normalize arrays for sky transmission
;
if ( type ne DARK ) then begin
	imi = imi*zerosky/sky
	imq = imq*zerosky/sky
	imu = imu*zerosky/sky
endif

;;;
;;; Spline fit to -180 to 180 degrees
;;;
	imis = fltarr(NUMANG,NUMPIX)
	imqs = fltarr(NUMANG,NUMPIX)
	imus = fltarr(NUMANG,NUMPIX)

	wset,1

	print,'spline I'
	before=systime(1)

	for ii=0,NUMPIX-1 do begin
		imis(*,ii) = spline(angfit,imi(*,ii),newang)
	endfor

	imis = shift(imis,shiftpix,0)
	tv,bytscl(imis,-1000,60000)

	print,'spline Q'
	for ii=0,NUMPIX-1 do begin
		imqs(*,ii) = spline(angfit,imq(*,ii),newang)
	endfor
	imqs = shift(imqs,shiftpix,0)
	tv,bytscl(imqs,-200,3000)

	print,'spline U'
	for ii=0,NUMPIX-1 do begin
		imus(*,ii) = spline(angfit,imu(*,ii),newang)
	endfor
	imus = shift(imus,shiftpix,0)
	tv,bytscl(imus,-1000,5000)

	after=systime(1)
	print,after-before

headib(9) = numang;
headib(10) = numpix;

	close,1
	filei = string(filename+'.Ci')
	close,1 & openw,1,filei & writeu,1,headib $
		& writeu,1,headf & writeu,1,headie $
		& writeu,1,headpad & writeu,1,imis
	close,1
	fileq = string(filename+'.Cq')
	close,1 & openw,1,fileq & writeu,1,headib $
		& writeu,1,headf & writeu,1,headie $
		& writeu,1,headpad & writeu,1,imqs
	close,1
	fileu = string(filename+'.Cu')
	close,1 & openw,1,fileu & writeu,1,headib $
		& writeu,1,headf & writeu,1,headie $
		& writeu,1,headpad & writeu,1,imus
	close,1

if ( dostop ne 'n' ) then stop
endwhile

stop

end
