;
;
;
;  Smooth MkIV X matrix and bias elements
;

NUMPIX = 384
NUMAZ = 720
SMOOTH = 31

x21 = fltarr(NUMPIX)
x22 = fltarr(NUMPIX)
x23 = fltarr(NUMPIX)
x31 = fltarr(NUMPIX)
x32 = fltarr(NUMPIX)
x33 = fltarr(NUMPIX)
bias= fltarr(NUMPIX)
gain= fltarr(NUMPIX,NUMAZ)

x21fit = fltarr(NUMPIX)
x22fit = fltarr(NUMPIX)
x23fit = fltarr(NUMPIX)
x31fit = fltarr(NUMPIX)
x32fit = fltarr(NUMPIX)
x33fit = fltarr(NUMPIX)
biasfit= fltarr(NUMPIX)
gainfit= fltarr(NUMPIX,NUMAZ)

close,1 & openr,1,'x21' & readu,1,x21 
close,1 & openr,1,'x22' & readu,1,x22 
close,1 & openr,1,'x23' & readu,1,x23 
close,1 & openr,1,'x31' & readu,1,x31 
close,1 & openr,1,'x32' & readu,1,x32 
close,1 & openr,1,'x33' & readu,1,x33 
close,1 & openr,1,'bias'& readu,1,bias
close,1 & openr,1,'gain'& readu,1,gain

; New lower heights after new camera installation 5/01
x21fit(0:29)=x21(30)

a = where ( abs(x22) gt 100 )
if ( a(0) ne -1 ) then x22(a) = 0

a = where ( abs(x23) gt 100 )
if ( a(0) ne -1 ) then x23(a) = 0

a = where ( x31 gt .02 )
if ( a(0) ne -1 ) then x31(a) = x31(a-1)

a = where ( abs(x32) gt 100 )
if ( a(0) ne -1 ) then x32(a) = 0

a = where ( abs(x33) gt 100 )
if ( a(0) ne -1 ) then x33(a) = 0

a = where ( abs(bias) gt 1000 )
if ( a(0) ne -1 ) then bias(a) = 0

x21fit(38:NUMPIX-1) = leefilt(median(x21(38:NUMPIX-1),SMOOTH))
; Smoothed data rounds off the sudden change to more X21 at low heights
x21fit(30:37)=x21(30:37)

x22fit = leefilt(median(x22,SMOOTH))
x23fit = leefilt(median(x23,SMOOTH))
x31fit = leefilt(median(x31,SMOOTH))
x32fit = leefilt(median(x32,SMOOTH))
x33fit = leefilt(median(x33,SMOOTH))
biasfit = leefilt(median(bias,SMOOTH))
gainfit=gain
for ii=0,NUMAZ-1 do begin
	temp = reform(gain(*,ii))
	temp = leefilt(median(temp,SMOOTH))
	gainfit(*,ii) = temp
endfor

close,1 & openw,1,'x21.fit' & writeu,1,x21fit 
close,1 & openw,1,'x22.fit' & writeu,1,x22fit 
close,1 & openw,1,'x23.fit' & writeu,1,x23fit 
close,1 & openw,1,'x31.fit' & writeu,1,x31fit 
close,1 & openw,1,'x32.fit' & writeu,1,x32fit 
close,1 & openw,1,'x33.fit' & writeu,1,x33fit 
close,1 & openw,1,'bias.fit'& writeu,1,biasfit
close,1 & openw,1,'gain.fit'& writeu,1,gainfit

print,'done'

end

