; disk.pro	IDL routine to create a disk of a desired radius in an array
;		of a desired size at a specified position in that array.
;
;		The disk has intensity of one throughout and the outside
;		area is set to zero.  The calling sequence in IDL is
;		'variable = circle (xdimension of array, ydimension, radius, 
;		                    xposition, yposition)'

function disk, idim1, idim2, rad, xc, yc

;--- Returns an idim1,idim2 array containing a circle of radius r,
;    centered on xc,yc.
;    The array is zero throughout and one on the circle's perimeter.

x = findgen (idim1) - xc
x = rebin (x, idim1, idim2)

y = findgen (idim2) - yc
y = transpose (y)
y = rebin (y, idim1, idim2)

buf = fix (sqrt (x^2 + y^2) + 0.5)
irad = fix (rad + 0.5)
indx = where (buf gt irad, cnt)

;print, 'count=', cnt

buf (indx) = 0
indx = where (buf ne 0,cnt)

;print,'count=',cnt

buf (indx) = 1

;tvscl, buf

return, buf

end
