PRO ftsrad, filename

;+
; Adds 'CRRADIUS' keyword & parameter to a FITS image header.
; Note: 'OBS-DATE' & 'OBS-TIME' keywords/parameters must exist in FITS header.
;
; Andrew L. Stanger   HAO/NCAR   19 June 1997
;-

odate   = ''
otime   = ''
oyear   = ''
omonth  = ''
oday    = ''
ohour   = ''
ominute = ''

img = READFITS (filename, hdu)


cdelt = FXPAR (hdu, 'CDELT1')
IF (!err EQ -1) THEN	$
   BEGIN
   cdelt = FXPAR (hdu, 'CDELT')
   IF (!err EQ -1) THEN	$
      BEGIN
      print, 'Need CDELT parameter.'
      EXIT
      END
   END

odate = FXPAR (hdu, 'OBS-DATE')
IF (!err EQ -1) THEN	$
   BEGIN
   print, 'Enter Obseration Year: '
   read,  oyear
   print, 'Enter Obseration Month: '
   read,  omonth
   print, 'Enter Obseration Day: '
   read,  oday
   odate = oyear + '/' + omonth + '/' + oday
   END

otime = FXPAR (hdu, 'OBS-TIME')
IF (!err EQ -1) THEN	$
   BEGIN
   print, 'Enter Obseration Hour: '
   read,  ohour
   print, 'Enter Obseration Minute: '
   read,  ominute
   otime = ohour + ':' + ominute
   END

print, 'odate: ', odate
print, 'otime: ', otime

otime = ohour + ':' + ominute
date_time = odate + ' ' + otime

ang = PB0R (date_time, /ARCSEC)

rsun = ang (2)
pixrs = rsun / cdelt			; pixels per solar radius.

FXADDPAR, hdu, 'CRRADIUS', pixrs,   ' SOLAR RADIUS [PIXELS]'
FXADDPAR, hdu, 'RSUN',     rsun, ' SOLAR RADIUS [ARCSEC]'

writefits,filename + '.new', img, hdu

END
