;+
; NAME		newct.pro
;
; PURPOSE	Create a new pre-defined color table in
;		/home/stanger/color/colors1.tbl'.
;
; SYNTAX	newct, 'bwy'
;
; METHOD	A new pre-defined color table is created
;		using the base name provided.  The color text file
;		'/home/stanger/color/bwy.lut' is read.
;		Then the color table is loaded, the RGB values read,
;		and a new pre-defined color table is created in
;		"/home/stanger/color/colors1.tbl".
;
; AUTHOR	Andrew L. Stanger   HAO/NCAR   19 July 2002
;-

PRO newct, lutname

lutdir  = '/home/stanger/color/'
lutfile = 'colors1.tbl'
lutpath = lutdir + lutfile

r = bytarr (256)
g = bytarr (256)
b = bytarr (256)

CLOSE, 11
OPENR, 11, lutpath
fs = FSTAT (11)				; Put file status in structure 'fs'.
CLOSE, 11

numct = (fs.size -1) / 800		; # pre-defined color tables.
lutnum = numct

lct, lutdir + lutname + '.lut'	; Read color table & load.

tvlct, r, g, b, /get

MODIFYCT, lutnum, lutname, r, g, b, FILE=lutpath

END
