;+
; NAME
;	read_chip
;
; PURPOSE
;	Read a MLSO/CHIP binary image.
;
; CALLING SEQUENCE
;	read_chipf, namefile, nxpix, nypix, nbypix
;
; HISTORY
;	created 9 August 1995, Andrew L. Stanger, HAO/NCAR
;-

function read_chip, namefile, nxpix, nypix, nbypix

;--- Define image array.

if (nbypix eq 1) then chip_buffer = bytarr (nxpix, nypix)
if (nbypix eq 2) then chip_buffer = intarr (nxpix, nypix)
if (nbypix eq 4) then chip_buffer = fltarr (nxpix, nypix)

;--- Open file and read image into array.

get_lun, lun
print, 'lun: ', lun, '   namefile: ', namefile

openr, lun, namefile
readu, lun, chip_buffer
close, lun
free_lun, lun

print, 'size (chip_buffer):',  size (chip_buffer)

return, chip_buffer
end
