;+
; suncirfits.pro   IDL procedure
;
; PURPOSE
;	Read a FITS image and draw a circle outlining the solar limb. 
;
; SYNTAX
;	suncirfits, 'fits_list'
;
; PROCEDURES USED
;	readfits
;	fxaddpar
;	writefits
;
; HISTORY
;	Author: Andrew L. Stanger   2 December 1997
;-

pro suncirfits, fits_list

fits_name = ''				; Define FITS file name variable.

CLOSE, 1
OPENR, 1, fits_list			; Open list file.

WHILE (NOT EOF (1)) DO	$		; File processing loop.
   BEGIN
      READF, 1, fits_name		; Read FITS file name from list file.
      img = readfits (fits_name, hdu)	; Read FITS image & header.

      ; -- Modify FITS header.

      fxaddpar, hdu, 'HISTORY', 'SOLAR LIMB DRAWN INTO IMAGE.'

      ; -- Write FITS image to disk.

      writefits, fits_name, img, hdu

   END
CLOSE, 1

END
