pro svtitle3
;
;+
;NAME:
;	svtitle3
;PURPOSE:
;	Create title for Yohkoh video.
;METHOD:
;	Use xyouts.
;CALLING SEQUENCE:
;	svtitle3
;INPUT:
;	none
;OPTIONAL KEYWORD INPUT:
;	none
;OUTPUT:
;	Creates sun rasterfile
;HISTORY:
;	Written  09-Jun-95 by Andrew L. Stanger (ALS), HAO/NCAR
;-
 
!P.font = 0					; Use X-window hardware font
device, $
   font='-misc-fixed-medium-r-normal--20-200-75-75-c-100-iso8859-1'

window, colors = 256, xsize = 640, ysize = 480, /pixmap	; Force private colormap

lct, '/usr/people/stanger/color/blue_white.2.lut'	; load color table.

; --- Color assignments.

c0 = 250				; yellow
c1 = 251				; grey
c2 = 252				; blue
c3 = 253				; green
c4 = 254				; red
c5 = 255				; white
c6 =   0				; black

; --- Storage for color LUT.

r = intarr (256)
g = intarr (256)
b = intarr (256)

; --- Background image.

imgbkg = bytarr (640, 480)

imgbkg (*, *) = c2			; Set background to a solid color.

tv, imgbkg				; Write image background to window.

   ; --- Draw box around border.

   plots,   0,   0,            /device, color=c1
   plots, 639,   0, /continue, /device, color=c1
   plots, 639, 479, /continue, /device, color=c1
   plots,   0, 479, /continue, /device, color=c1
   plots,   0,   0, /continue, /device, color=c1

   plots,   1,   1,            /device, color=c1
   plots, 638,   1, /continue, /device, color=c1
   plots, 638, 478, /continue, /device, color=c1
   plots,   1, 478, /continue, /device, color=c1
   plots,   1,   1, /continue, /device, color=c1

   ximg = 400
   yimg = 400
   xframe = 640
   yframe = 480
   yborder = (yframe - yimg) / 2		;  40 = (480 - 400) / 2
   xborder = yborder				;  40
   xannot  = xframe - ximg - xborder * 2	; 160 = 640 - 400 - 80
   yannot  = yframe        - yborder * 2	; 400 = 480       - 80

   xmin1 = xborder - 1
   xmin2 = xborder - 2
   xmax1 = xborder + xannot + ximg
   xmax2 = xborder + xannot + ximg + 1
   ymin1 = yborder - 1
   ymin2 = yborder - 2
   ymax1 = yborder + yannot
   ymax2 = yborder + yannot + 1

   plots, xmin1, ymin1,            /device, color=c1
   plots, xmax1, ymin1, /continue, /device, color=c1
   plots, xmax1, ymax1, /continue, /device, color=c1
   plots, xmin1, ymax1, /continue, /device, color=c1
   plots, xmin1, ymin1, /continue, /device, color=c1

   plots, xmin2, ymin2,            /device, color=c1
   plots, xmax2, ymin2, /continue, /device, color=c1
   plots, xmax2, ymax2, /continue, /device, color=c1
   plots, xmin2, ymax2, /continue, /device, color=c1
   plots, xmin2, ymin2, /continue, /device, color=c1

   xloc = 320
   yloc = 270

   DEVICE, $
      FONT='-*-utopia-bold-r-*-*-30-*-*-*-*-*-*-*'

   XYOUTS, xloc, yloc, 'Y o h k o h    S o f t - X r a y    I m a g e s', $
	   ALIGNMENT=0.5, /DEVICE, COLOR=c0

   xloc = 320
   yloc = 210

   XYOUTS, xloc, yloc, '7  November  1991',	$
	   ALIGNMENT=0.5, /DEVICE, COLOR=c5

   xloc = 320
   yloc = 150

   XYOUTS, xloc, yloc, '1  Frame / Sec',	$
	   ALIGNMENT=0.5, /DEVICE, COLOR=c5

   ; --- Read image from IDL window.

   fb = bytarr (640, 480)
   fbsiz = size (fb)
   fb_nx = fbsiz (1)
   fb_ny = fbsiz (2)
   fb = tvrd (0, 0, fb_nx, fb_ny)		; Read image from window.
   tvlct, r, g, b, /get				; Read color LUT.

   ; --- Write to disk as a Sun rasterfile.

   fbrev = reverse (fb, 2)			; Flip top to bottom.
   srfnam = 'svtitle3.sun'
   write_srf, srfnam, fbrev, r, g, b		; Write Sun rasterfile.
   print, 'svtitle3: output file ', srfnam

!P.font = 1

end
