pro sxtinfo, inpfile
;+
; NAME
;	sxtinfo
; PURPOSE
;	Create a text file of image summary information from an SXT file.
; CALLING SEQUENCE
;	sxtinfo, input_file
; INPUT
;	input_file :		input SXT file.
; ROUTINES CALLED
;	rd_sda
;	get_info2
; HISTORY
;	01-sep-95 : created by Andrew L. Stanger [ALS], HAO/NCAR
;-

rd_sda, inpfile, -1, index, /nodata		; Read index from file.

info = get_info2 (index)			; Decode index information.

outfile = inpfile + '.info'

get_lun,  unit
openw,    unit, outfile				; Open output file.
printf,   unit, info				; Write info to disc file.
free_lun, unit					; Close file & deallocate unit.

print, 'Output file: ', outfile

end
