;+
; chipscan.pro
;
; Do 3 horizontal scans across CHIP images.
;
; Andrew L. Stanger   HAO/NCAR   27 July 2000
; 2 Aug 2000 : Accomodate all 7 filters.
;-

PRO chipscan, fits_list

red = bindgen (256)
green = red
blue  = red
;lct, '/home/stanger/color/bwcp.lut'
lct, '/home/stanger/color/chip1.lut'
tvlct, red, green, blue, /get

filed = ''
filec = ''
fileb = ''
fileh = ''
filer = ''
files = ''
filet = ''

CLOSE, 11

OPENR, 11, fits_list
READF, 11, filed
PRINT, 'filed: ', filed
READF, 11, filec
PRINT, 'filec: ', filec
READF, 11, fileb
PRINT, 'fileb: ', fileb
READF, 11, fileh
PRINT, 'fileh: ', fileh
READF, 11, filer
PRINT, 'filer: ', filer
READF, 11, files
PRINT, 'files: ', files
READF, 11, filet
PRINT, 'filet: ', filet
CLOSE, 11

imgd = readfits (filed, hdud, /noscale)
imgc = readfits (filec, hduc, /noscale)
imgb = readfits (fileb, hdub, /noscale)
imgh = readfits (fileh, hduh, /noscale)
imgr = readfits (filer, hdur, /noscale)
imgs = readfits (files, hdus, /noscale)
imgt = readfits (filet, hdut, /noscale)

;imgb = readfits ('20000413_180413_chip_bsr.sq.fts', hdub, /noscale)
;imgh = readfits ('20000413_180312_chip_hsr.sq.fts', hduh, /noscale)
;imgr = readfits ('20000413_180440_chip_rsr.sq.fts', hdur, /noscale)

imgbd = bytscl (imgd, min = 1800, max = 3400, top = 249)
imgbc = bytscl (imgc, min = 1800, max = 3400, top = 249)
imgbb = bytscl (imgb, min = 1800, max = 3400, top = 249)
imgbh = bytscl (imgh, min = 1800, max = 3400, top = 249)
imgbr = bytscl (imgr, min = 1800, max = 3400, top = 249)
imgbs = bytscl (imgs, min = 1800, max = 3400, top = 249)
imgbt = bytscl (imgt, min = 1800, max = 3400, top = 249)

d1 = imgd [*,325]
d2 = imgd [*,640]
d3 = imgd [*,720]

c1 = imgc [*,325]
c2 = imgc [*,640]
c3 = imgc [*,720]

b1 = imgb [*,325]
b2 = imgb [*,640]
b3 = imgb [*,720]

h1 = imgh [*,325]
h2 = imgh [*,640] 
h3 = imgh [*,720]

r1 = imgr [*,325]
r2 = imgr [*,640]
r3 = imgr [*,720]

s1 = imgs [*,325]
s2 = imgs [*,640]
s3 = imgs [*,720]

t1 = imgt [*,325]
t2 = imgt [*,640]
t3 = imgt [*,720]

td1 = filed + ' FAR  BLUE line 325'
td2 = filed + ' FAR  BLUE line 640'
td3 = filed + ' FAR  BLUE line 720'

tc1 = filec + ' MID  BLUE line 325'
tc2 = filec + ' MID  BLUE line 640'
tc3 = filec + ' MID  BLUE line 720'

tb1 = fileb + ' NEAR BLUE line 325'
tb2 = fileb + ' NEAR BLUE line 640'
tb3 = fileb + ' NEAR BLUE line 720'

th1 = fileh + ' Helium-1 line 325'
th2 = fileh + ' Helium-1 line 640'
th3 = fileh + ' Helium-1 line 720'

tr1 = filer + ' NEAR RED line 325'
tr2 = filer + ' NEAR RED line 640'
tr3 = filer + ' NEAR RED line 720'

ts1 = files + ' MID  RED line 325'
ts2 = files + ' MID  RED line 640'
ts3 = files + ' MID  RED line 720'

tt1 = filet + ' FAR  RED line 325'
tt2 = filet + ' FAR  RED line 640'
tt3 = filet + ' FAR  RED line 720'

tx = 'Equatorial Pixels'
ty = 'Raw CCD Intensity'

set_plot, 'ps'
device, filename = 'chip.raw.ps'

plot, d1, title=td1, xtitle=tx, ytitle=ty, yrange=[2000,4000]
;plot, d2, title=td2, xtitle=tx, ytitle=ty, yrange=[2000,4000]
;plot, d3, title=td3, xtitle=tx, ytitle=ty, yrange=[2000,4000]

plot, c1, title=tc1, xtitle=tx, ytitle=ty, yrange=[2000,4000]
;plot, c2, title=tc2, xtitle=tx, ytitle=ty, yrange=[2000,4000]
;plot, c3, title=tc3, xtitle=tx, ytitle=ty, yrange=[2000,4000]

plot, b1, title=tb1, xtitle=tx, ytitle=ty, yrange=[2000,4000]
;plot, b2, title=tb2, xtitle=tx, ytitle=ty, yrange=[2000,4000]
;plot, b3, title=tb3, xtitle=tx, ytitle=ty, yrange=[2000,4000]

plot, h1, title=th1, xtitle=tx, ytitle=ty, yrange=[2000,4000]
;plot, h2, title=th2, xtitle=tx, ytitle=ty, yrange=[2000,4000]
;plot, h3, title=th3, xtitle=tx, ytitle=ty, yrange=[2000,4000]

plot, r1, title=tr1, xtitle=tx, ytitle=ty, yrange=[2000,4000]
;plot, r2, title=tr2, xtitle=tx, ytitle=ty, yrange=[2000,4000]
;plot, r3, title=tr3, xtitle=tx, ytitle=ty, yrange=[2000,4000]

plot, s1, title=ts1, xtitle=tx, ytitle=ty, yrange=[2000,4000]
;plot, s2, title=ts2, xtitle=tx, ytitle=ty, yrange=[2000,4000]
;plot, s3, title=ts3, xtitle=tx, ytitle=ty, yrange=[2000,4000]

plot, t1, title=tt1, xtitle=tx, ytitle=ty, yrange=[2000,4000]
;plot, t2, title=tt2, xtitle=tx, ytitle=ty, yrange=[2000,4000]
;plot, t3, title=tt3, xtitle=tx, ytitle=ty, yrange=[2000,4000]

device, /close
set_plot, 'x'

imgbd [*,325] = 252
imgbd [*,640] = 253
imgbd [*,720] = 254

imgbc [*,325] = 252
imgbc [*,640] = 253
imgbc [*,720] = 254

imgbb [*,325] = 252
imgbb [*,640] = 253
imgbb [*,720] = 254

imgbh [*,325] = 252
imgbh [*,640] = 253
imgbh [*,720] = 254

imgbr [*,325] = 252
imgbr [*,640] = 253
imgbr [*,720] = 254

imgbs [*,325] = 252
imgbs [*,640] = 253
imgbs [*,720] = 254

imgbt [*,325] = 252
imgbt [*,640] = 253
imgbt [*,720] = 254

fgd = 'dsr.gif'
fgc = 'csr.gif'
fgb = 'bsr.gif'
fgh = 'hsr.gif'
fgr = 'rsr.gif'
fgs = 'ssr.gif'
fgt = 'tsr.gif'

write_gif, fgd, imgbd, red, green, blue
write_gif, fgc, imgbc, red, green, blue
write_gif, fgb, imgbb, red, green, blue
write_gif, fgh, imgbh, red, green, blue
write_gif, fgr, imgbr, red, green, blue
write_gif, fgs, imgbs, red, green, blue
write_gif, fgt, imgbt, red, green, blue

fxaddpar, hdud, 'DISPMIN',   0
fxaddpar, hdud, 'DISPMAX', 255 
fxaddpar, hduc, 'DISPMIN',   0
fxaddpar, hduc, 'DISPMAX', 255 
fxaddpar, hdub, 'DISPMIN',   0
fxaddpar, hdub, 'DISPMAX', 255 
fxaddpar, hduh, 'DISPMIN',   0
fxaddpar, hduh, 'DISPMAX', 255 
fxaddpar, hdur, 'DISPMIN',   0
fxaddpar, hdur, 'DISPMAX', 255 
fxaddpar, hdus, 'DISPMIN',   0
fxaddpar, hdus, 'DISPMAX', 255 
fxaddpar, hdut, 'DISPMIN',   0
fxaddpar, hdut, 'DISPMAX', 255 

writefits, 'dsr.sq.byte.fts', imgbd, hdud
writefits, 'csr.sq.byte.fts', imgbc, hduc
writefits, 'bsr.sq.byte.fts', imgbb, hdub
writefits, 'hsr.sq.byte.fts', imgbh, hduh
writefits, 'rsr.sq.byte.fts', imgbr, hdur
writefits, 'ssr.sq.byte.fts', imgbs, hdus
writefits, 'tsr.sq.byte.fts', imgbt, hdut

END
