;+
; chipscan1.pro
;
; Do 3 horizontal scans across CHIP images.
;
; Andrew L. Stanger   HAO/NCAR   27 July 2000
; 2 Aug 2000 : Accomodate all 7 filters.
;-

PRO chipscan1, fits_list

red = BINDGEN (256)
green = red
blue  = red
;lct, '/home/stanger/color/bwcp.lut'
lct, '/home/stanger/color/chip1.lut'
TVLCT, red, green, blue, /get

WINDOW, xsize=936, ysize=936
cbar0 = BINDGEN (256)
cbar = BYTARR (256, 20)
FOR i = 0, 19 DO cbar [*, i] = cbar0

;line1 = 330
;line2 = 485
;line3 = 590

;line1 = 260
;line2 = 468
;line3 = 675

line1 = 417
line2 = 458
line3 = 580

sline1 = STRTRIM (STRING (line1), 2)
sline2 = STRTRIM (STRING (line2), 2)
sline3 = STRTRIM (STRING (line3), 2)
line1t = line1 + 2
line2t = line2 + 2
line3t = line3 + 2

filed = ''
filec = ''
fileb = ''
fileh = ''
filer = ''
files = ''
filet = ''

CLOSE, 11
OPENR, 11, fits_list
READF, 11, filed
PRINT, 'filed: ', filed
READF, 11, filec
PRINT, 'filec: ', filec
READF, 11, fileb
PRINT, 'fileb: ', fileb
READF, 11, fileh
PRINT, 'fileh: ', fileh
READF, 11, filer
PRINT, 'filer: ', filer
READF, 11, files
PRINT, 'files: ', files
READF, 11, filet
PRINT, 'filet: ', filet
CLOSE, 11

imgd = readfits (filed, hdud, /noscale)
imgc = readfits (filec, hduc, /noscale)
imgb = readfits (fileb, hdub, /noscale)
imgh = readfits (fileh, hduh, /noscale)
imgr = readfits (filer, hdur, /noscale)
imgs = readfits (files, hdus, /noscale)
imgt = readfits (filet, hdut, /noscale)

nimsum = fxpar (hduh, 'NIMSUM')
imin =  600 * nimsum
imax =  900 * nimsum
smin = STRTRIM (STRING (imin), 2)
smax = STRTRIM (STRING (imax), 2)

mind = MIN (imgd, max=maxd)
minc = MIN (imgc, max=maxc)
minb = MIN (imgb, max=maxb)
minh = MIN (imgh, max=maxh)
minr = MIN (imgr, max=maxr)
mins = MIN (imgs, max=maxs)
mint = MIN (imgt, max=maxt)

print, 'mind/maxd: ', mind, maxd
print, 'minc/maxc: ', minc, maxc
print, 'minb/maxb: ', minb, maxb
print, 'minh/maxh: ', minh, maxh
print, 'minr/maxr: ', minr, maxr
print, 'mins/maxs: ', mins, maxs
print, 'mint/maxt: ', mint, maxt

;imgb = readfits ('20000413_180413_chip_bsr.sq.fts', hdub, /noscale)
;imgh = readfits ('20000413_180312_chip_hsr.sq.fts', hduh, /noscale)
;imgr = readfits ('20000413_180440_chip_rsr.sq.fts', hdur, /noscale)

imgbd = BYTSCL (imgd, min = imin, max = imax, top = 249)
imgbc = BYTSCL (imgc, min = imin, max = imax, top = 249)
imgbb = BYTSCL (imgb, min = imin, max = imax, top = 249)
imgbh = BYTSCL (imgh, min = imin, max = imax, top = 249)
imgbr = BYTSCL (imgr, min = imin, max = imax, top = 249)
imgbs = BYTSCL (imgs, min = imin, max = imax, top = 249)
imgbt = BYTSCL (imgt, min = imin, max = imax, top = 249)

imgbd [*, line1] = 254
imgbd [*, line2] = 253
imgbd [*, line3] = 252

imgbc [*, line1] = 254
imgbc [*, line2] = 253
imgbc [*, line3] = 252

imgbb [*, line1] = 254
imgbb [*, line2] = 253
imgbb [*, line3] = 252

imgbh [*, line1] = 254
imgbh [*, line2] = 253
imgbh [*, line3] = 252

imgbr [*, line1] = 254
imgbr [*, line2] = 253
imgbr [*, line3] = 252

imgbs [*, line1] = 254
imgbs [*, line2] = 253
imgbs [*, line3] = 252

imgbt [*, line1] = 254
imgbt [*, line2] = 253
imgbt [*, line3] = 252

imgbd [340:595, 10:29] = cbar
imgbc [340:595, 10:29] = cbar
imgbb [340:595, 10:29] = cbar
imgbh [340:595, 10:29] = cbar
imgbr [340:595, 10:29] = cbar
imgbs [340:595, 10:29] = cbar
imgbt [340:595, 10:29] = cbar

TV, imgbd
XYOUTS,  5, 910, filed, /device
XYOUTS,  5, 50, 'Far  Blue', /device
XYOUTS,  5, 30, 'min = ' + smin, /device
XYOUTS,  5, 10, 'max = ' + smax, /device
XYOUTS,  5, line1t, sline1, /device
XYOUTS,  5, line2t, sline2, /device
XYOUTS,  5, line3t, sline3, /device
imgdd = TVRD ()
wait, 1

TV, imgbc
XYOUTS,  5, 910, filec, /device
XYOUTS,  5, 50, 'Mid  Blue', /device
XYOUTS,  5, 30, 'min = ' + smin, /device
XYOUTS,  5, 10, 'max = ' + smax, /device
XYOUTS,  5, line1t, sline1, /device
XYOUTS,  5, line2t, sline2, /device
XYOUTS,  5, line3t, sline3, /device
imgdc = TVRD ()
wait, 1

TV, imgbb
XYOUTS,  5, 910, fileb, /device
XYOUTS,  5, 50, 'Near Blue', /device
XYOUTS,  5, 30, 'min = ' + smin, /device
XYOUTS,  5, 10, 'max = ' + smax, /device
XYOUTS,  5, line1t, sline1, /device
XYOUTS,  5, line2t, sline2, /device
XYOUTS,  5, line3t, sline3, /device
imgdb = TVRD ()
wait, 1

TV, imgbh
XYOUTS,  5, 910, fileh, /device
XYOUTS,  5, 50, 'Helium-1', /device
XYOUTS,  5, 30, 'min = ' + smin, /device
XYOUTS,  5, 10, 'max = ' + smax, /device
XYOUTS,  5, line1t, sline1, /device
XYOUTS,  5, line2t, sline2, /device
XYOUTS,  5, line3t, sline3, /device
imgdh = TVRD ()
wait, 1

TV, imgbr
XYOUTS,  5, 910, filer, /device
XYOUTS,  5, 50, 'Near Red', /device
XYOUTS,  5, 30, 'min = ' + smin, /device
XYOUTS,  5, 10, 'max = ' + smax, /device
XYOUTS,  5, line1t, sline1, /device
XYOUTS,  5, line2t, sline2, /device
XYOUTS,  5, line3t, sline3, /device
imgdr = TVRD ()
wait, 1

TV, imgbs
XYOUTS,  5, 910, files, /device
XYOUTS,  5, 50, 'Mid  Red', /device
XYOUTS,  5, 30, 'min = ' + smin, /device
XYOUTS,  5, 10, 'max = ' + smax, /device
XYOUTS,  5, line1t, sline1, /device
XYOUTS,  5, line2t, sline2, /device
XYOUTS,  5, line3t, sline3, /device
imgds = TVRD ()
wait, 1

TV, imgbt
XYOUTS,  5, 910, filet, /device
XYOUTS,  5, 50, 'Far  Red', /device
XYOUTS,  5, 30, 'min = ' + smin, /device
XYOUTS,  5, 10, 'max = ' + smax, /device
XYOUTS,  5, line1t, sline1, /device
XYOUTS,  5, line2t, sline2, /device
XYOUTS,  5, line3t, sline3, /device
imgdt = TVRD ()
wait, 1

d1 = imgd [*, line1]
d2 = imgd [*, line2]
d3 = imgd [*, line3]

c1 = imgc [*, line1]
c2 = imgc [*, line2]
c3 = imgc [*, line3]

b1 = imgb [*, line1]
b2 = imgb [*, line2]
b3 = imgb [*, line3]

h1 = imgh [*, line1]
h2 = imgh [*, line2] 
h3 = imgh [*, line3]

r1 = imgr [*, line1]
r2 = imgr [*, line2]
r3 = imgr [*, line3]

s1 = imgs [*, line1]
s2 = imgs [*, line2]
s3 = imgs [*, line3]

t1 = imgt [*, line1]
t2 = imgt [*, line2]
t3 = imgt [*, line3]

td1 = filed + ' FAR  BLUE line ' + sline1
td2 = filed + ' FAR  BLUE line ' + sline2
td3 = filed + ' FAR  BLUE line ' + sline3

tc1 = filec + ' MID  BLUE line ' + sline1
tc2 = filec + ' MID  BLUE line ' + sline2
tc3 = filec + ' MID  BLUE line ' + sline3

tb1 = fileb + ' NEAR BLUE line ' + sline1
tb2 = fileb + ' NEAR BLUE line ' + sline2
tb3 = fileb + ' NEAR BLUE line ' + sline3

th1 = fileh + ' Helium-1 line ' + sline1
th2 = fileh + ' Helium-1 line ' + sline2
th3 = fileh + ' Helium-1 line ' + sline3

tr1 = filer + ' NEAR RED line ' + sline1
tr2 = filer + ' NEAR RED line ' + sline2
tr3 = filer + ' NEAR RED line ' + sline3

ts1 = files + ' MID  RED line ' + sline1
ts2 = files + ' MID  RED line ' + sline2
ts3 = files + ' MID  RED line ' + sline3

tt1 = filet + ' FAR  RED line ' + sline1
tt2 = filet + ' FAR  RED line ' + sline2
tt3 = filet + ' FAR  RED line ' + sline3

tx = 'Pixels [Horizontal Scans]'
ty = 'Normalized CCD Intensity'

SET_PLOT, 'ps'
DEVICE, filename = 'chip.norm.ps'

PLOT, d1, title=td1, xtitle=tx, ytitle=ty, yrange=[imin,imax]
PLOT, d2, title=td2, xtitle=tx, ytitle=ty, yrange=[imin,imax]
PLOT, d3, title=td3, xtitle=tx, ytitle=ty, yrange=[imin,imax]

PLOT, c1, title=tc1, xtitle=tx, ytitle=ty, yrange=[imin,imax]
PLOT, c2, title=tc2, xtitle=tx, ytitle=ty, yrange=[imin,imax]
PLOT, c3, title=tc3, xtitle=tx, ytitle=ty, yrange=[imin,imax]

PLOT, b1, title=tb1, xtitle=tx, ytitle=ty, yrange=[imin,imax]
PLOT, b2, title=tb2, xtitle=tx, ytitle=ty, yrange=[imin,imax]
PLOT, b3, title=tb3, xtitle=tx, ytitle=ty, yrange=[imin,imax]

PLOT, h1, title=th1, xtitle=tx, ytitle=ty, yrange=[imin,imax]
PLOT, h2, title=th2, xtitle=tx, ytitle=ty, yrange=[imin,imax]
PLOT, h3, title=th3, xtitle=tx, ytitle=ty, yrange=[imin,imax]

PLOT, r1, title=tr1, xtitle=tx, ytitle=ty, yrange=[imin,imax]
PLOT, r2, title=tr2, xtitle=tx, ytitle=ty, yrange=[imin,imax]
PLOT, r3, title=tr3, xtitle=tx, ytitle=ty, yrange=[imin,imax]

PLOT, s1, title=ts1, xtitle=tx, ytitle=ty, yrange=[imin,imax]
PLOT, s2, title=ts2, xtitle=tx, ytitle=ty, yrange=[imin,imax]
PLOT, s3, title=ts3, xtitle=tx, ytitle=ty, yrange=[imin,imax]

PLOT, t1, title=tt1, xtitle=tx, ytitle=ty, yrange=[imin,imax]
PLOT, t2, title=tt2, xtitle=tx, ytitle=ty, yrange=[imin,imax]
PLOT, t3, title=tt3, xtitle=tx, ytitle=ty, yrange=[imin,imax]

DEVICE, /close
SET_PLOT, 'x'

fgd = 'dsr.norm.gif'
fgc = 'csr.norm.gif'
fgb = 'bsr.norm.gif'
fgh = 'hsr.norm.gif'
fgr = 'rsr.norm.gif'
fgs = 'ssr.norm.gif'
fgt = 'tsr.norm.gif'

write_gif, fgd, imgdd, red, green, blue
write_gif, fgc, imgdc, red, green, blue
write_gif, fgb, imgdb, red, green, blue
write_gif, fgh, imgdh, red, green, blue
write_gif, fgr, imgdr, red, green, blue
write_gif, fgs, imgds, red, green, blue
write_gif, fgt, imgdt, red, green, blue

fxaddpar, hdud, 'DISPMIN',   0
fxaddpar, hdud, 'DISPMAX', 255 
fxaddpar, hduc, 'DISPMIN',   0
fxaddpar, hduc, 'DISPMAX', 255 
fxaddpar, hdub, 'DISPMIN',   0
fxaddpar, hdub, 'DISPMAX', 255 
fxaddpar, hduh, 'DISPMIN',   0
fxaddpar, hduh, 'DISPMAX', 255 
fxaddpar, hdur, 'DISPMIN',   0
fxaddpar, hdur, 'DISPMAX', 255 
fxaddpar, hdus, 'DISPMIN',   0
fxaddpar, hdus, 'DISPMAX', 255 
fxaddpar, hdut, 'DISPMIN',   0
fxaddpar, hdut, 'DISPMAX', 255 

writefits, 'dsr.norm.byte.fts', imgbd, hdud
writefits, 'csr.norm.byte.fts', imgbc, hduc
writefits, 'bsr.norm.byte.fts', imgbb, hdub
writefits, 'hsr.norm.byte.fts', imgbh, hduh
writefits, 'rsr.norm.byte.fts', imgbr, hdur
writefits, 'ssr.norm.byte.fts', imgbs, hdus
writefits, 'tsr.norm.byte.fts', imgbt, hdut

END
