;+
; chipscan3.pro
;
; Do 3 horizontal scans across CHIP images.
;
; Andrew L. Stanger   HAO/NCAR   27 July 2000
;  2 Aug 2000 : Accomodate all 7 filters.
; 27 Sep 2000 : Image differences
; 25 Oct 2000 : Also do velocity image.
;-

PRO chipscan3, fits_list

red   = bindgen (256)
green = red
blue  = red

;lct, '/home/stanger/color/bwcp.lut'
;lct, '/home/stanger/color/chip1.lut'

lct, '/home/stanger/color/dif.lut'
tvlct, red, green, blue, /get
window, xsize=936, ysize=936

;line1 = 330
;line2 = 485
;line3 = 590

line1 = 260
line2 = 468
line3 = 675

sline1 = strtrim (string (line1), 2)
sline2 = strtrim (string (line2), 2)
sline3 = strtrim (string (line3), 2)

line1t = line1 + 2
line2t = line2 + 2
line3t = line3 + 2

file0 = ''
file1 = ''
file2 = ''
file3 = ''
file4 = ''

CLOSE, 11
OPENR, 11, fits_list
READF, 11, file0
PRINT, 'file0: ', file0
READF, 11, file1
PRINT, 'file1: ', file1
READF, 11, file2
PRINT, 'file2: ', file2
READF, 11, file3
PRINT, 'file3: ', file3
READF, 11, file4
PRINT, 'file4: ', file4
CLOSE, 11

fg0 = 'dif0.scan.gif'
fg1 = 'dif1.scan.gif'
fg2 = 'dif2.scan.gif'
fg3 = 'dif3.scan.gif'
fg4 = 'vel.scan.gif'

img0 = readfits (file0, hdu0, /noscale)
img1 = readfits (file1, hdu1, /noscale)
img2 = readfits (file2, hdu2, /noscale)
img3 = readfits (file3, hdu3, /noscale)
img4 = readfits (file4, hdu4, /noscale)

tvscl, img0
xyouts,  5, 50, file0, /device
wait, 1
tvscl, img1
xyouts,  5, 50, file1, /device
wait, 1
tvscl, img2
xyouts,  5, 50, file2, /device
wait, 1
tvscl, img3
xyouts,  5, 50, file3, /device
wait, 1
tvscl, img4
xyouts,  5, 50, file4, /device
wait, 1

min0 = MIN (img0, max=max0)
min1 = MIN (img1, max=max1)
min2 = MIN (img2, max=max2)
min3 = MIN (img3, max=max3)
min4 = MIN (img4, max=max4)

print, 'min0/max0: ', min0, max0
print, 'min1/max1: ', min1, max1
print, 'min2/max2: ', min2, max2
print, 'min3/max3: ', min3, max3
print, 'min4/max4: ', min4, max4

imgb0 = bytscl (img0, min = -0.1, max = 0.1, top = 249)
imgb1 = bytscl (img1, min = -0.1, max = 0.1, top = 249)
imgb2 = bytscl (img2, min = -0.1, max = 0.1, top = 249)
imgb3 = bytscl (img3, min = -0.1, max = 0.1, top = 249)
imgb4 = bytscl (img4, min = -50.0, max = 50.0, top = 249)

if (abs (min0) LT abs (max0)) then min0 = -max0 else max0 = -min0
if (abs (min1) LT abs (max1)) then min1 = -max1 else max1 = -min1
if (abs (min2) LT abs (max2)) then min2 = -max2 else max2 = -min2
if (abs (min3) LT abs (max3)) then min3 = -max3 else max3 = -min3
if (abs (min4) LT abs (max4)) then min4 = -max4 else max4 = -min4

;imgb0 = bytscl (img0, min = min0, max = max0, top = 249)
;imgb1 = bytscl (img1, min = min1, max = max1, top = 249)
;imgb2 = bytscl (img2, min = min2, max = max2, top = 249)
;imgb3 = bytscl (img3, min = min3, max = max3, top = 249)

imgb0 [*, line1] = 254		; red
imgb0 [*, line2] = 253		; green
imgb0 [*, line3] = 252		; blue

imgb1 [*, line1] = 254
imgb1 [*, line2] = 253
imgb1 [*, line3] = 252

imgb2 [*, line1] = 254
imgb2 [*, line2] = 253
imgb2 [*, line3] = 252

imgb3 [*, line1] = 254
imgb3 [*, line2] = 253
imgb3 [*, line3] = 252

imgb4 [*, line1] = 254
imgb4 [*, line2] = 253
imgb4 [*, line3] = 252

tv, imgb0
xyouts,  5, 70, file0, /device, color=0
xyouts,  5, 50, '1.0 - Iave', /device, color=0
xyouts,  5, 30, 'min = -0.1', /device, color=0
xyouts,  5, 10, 'max =  0.1', /device, color=0
xyouts,  5, line1t, sline1, /device, color=0
xyouts,  5, line2t, sline2, /device, color=0
xyouts,  5, line3t, sline3, /device, color=0
imgd0 = tvrd ()
wait, 1
tv, imgb1
xyouts,  5, 70, file1, /device
xyouts,  5, 50, 'B1 - R1', /device
xyouts,  5, 30, 'min = -0.1', /device
xyouts,  5, 10, 'max =  0.1', /device
xyouts,  5, line1t, sline1, /device, color=255
xyouts,  5, line2t, sline2, /device, color=255
xyouts,  5, line3t, sline3, /device, color=255
imgd1 = tvrd ()
wait, 1
tv, imgb2
xyouts,  5, 70, file2, /device
xyouts,  5, 50, 'B2 - R2', /device
xyouts,  5, 30, 'min = -0.1', /device
xyouts,  5, 10, 'max =  0.1', /device
xyouts,  5, line1t, sline1, /device, color=255
xyouts,  5, line2t, sline2, /device, color=255
xyouts,  5, line3t, sline3, /device, color=255
imgd2 = tvrd ()
wait, 1
tv, imgb3
xyouts,  5, 70, file3, /device
xyouts,  5, 50, 'B3 - R3', /device
xyouts,  5, 30, 'min = -0.1', /device
xyouts,  5, 10, 'max =  0.1', /device
xyouts,  5, line1t, sline1, /device, color=255
xyouts,  5, line2t, sline2, /device, color=255
xyouts,  5, line3t, sline3, /device, color=255
imgd3 = tvrd ()
wait, 1
tv, imgb4
xyouts,  5, 70, file4, /device
xyouts,  5, 50, 'Velocity', /device
xyouts,  5, 30, 'min = -50.0', /device
xyouts,  5, 10, 'max =  50.0', /device
xyouts,  5, line1t, sline1, /device, color=255
xyouts,  5, line2t, sline2, /device, color=255
xyouts,  5, line3t, sline3, /device, color=255
imgd3 = tvrd ()
wait, 1

s0a = img0 [*, line1] 
s0b = img0 [*, line2]
s0c = img0 [*, line3]

s1a = img1 [*, line1]
s1b = img1 [*, line2]
s1c = img1 [*, line3]

s2a = img2 [*, line1]
s2b = img2 [*, line2]
s2c = img2 [*, line3]

s3a = img3 [*, line1]
s3b = img3 [*, line2]
s3c = img3 [*, line3]

s4a = img4 [*, line1] 
s4b = img4 [*, line2]
s4c = img4 [*, line3]

t0a = file0 + '  line ' + sline1
t0b = file0 + '  line ' + sline2
t0c = file0 + '  line ' + sline3

t1a = file1 + '  line ' + sline1
t1b = file1 + '  line ' + sline2
t1c = file1 + '  line ' + sline3

t2a = file2 + '  line ' + sline1
t2b = file2 + '  line ' + sline2
t2c = file2 + '  line ' + sline3

t3a = file3 + '  line ' + sline1
t3b = file3 + '  line ' + sline2
t3c = file3 + '  line ' + sline3

t4a = file4 + '  line ' + sline1
t4b = file4 + '  line ' + sline2
t4c = file4 + '  line ' + sline3

tx = 'Pixel [Horizontal Scan]'
ty = 'Normalized CCD Intensity'
tyvel = 'Velocity [km/sec]'

set_plot, 'ps'
device, filename = 'chip.dif.ps'

plot, s0a, title=t0a, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]
plot, s0b, title=t0b, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]
plot, s0c, title=t0c, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]

plot, s1a, title=t1a, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]
plot, s1b, title=t1b, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]
plot, s1c, title=t1c, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]

plot, s2a, title=t2a, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]
plot, s2b, title=t2b, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]
plot, s2c, title=t2c, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]

plot, s3a, title=t3a, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]
plot, s3b, title=t3b, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]
plot, s3c, title=t3c, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]

plot, s4a, title=t4a, xtitle=tx, ytitle=tyvel, yrange=[-50.0, 50.0]
plot, s4b, title=t4b, xtitle=tx, ytitle=tyvel, yrange=[-50.0, 50.0]
plot, s4c, title=t4c, xtitle=tx, ytitle=tyvel, yrange=[-50.0, 50.0]

device, /close
set_plot, 'x'

write_gif, fg0, imgd0, red, green, blue
write_gif, fg1, imgd1, red, green, blue
write_gif, fg2, imgd2, red, green, blue
write_gif, fg3, imgd3, red, green, blue
write_gif, fg4, imgd4, red, green, blue

fxaddpar, hdu0, 'DISPMIN',   0
fxaddpar, hdu0, 'DISPMAX', 255 
fxaddpar, hdu1, 'DISPMIN',   0
fxaddpar, hdu1, 'DISPMAX', 255 
fxaddpar, hdu2, 'DISPMIN',   0
fxaddpar, hdu2, 'DISPMAX', 255 
fxaddpar, hdu3, 'DISPMIN',   0
fxaddpar, hdu3, 'DISPMAX', 255 
fxaddpar, hdu4, 'DISPMIN',   0
fxaddpar, hdu4, 'DISPMAX', 255 

writefits, 'dif0.norm.byte.fts', imgb0, hdu0
writefits, 'dif1.norm.byte.fts', imgb1, hdu1
writefits, 'dif2.norm.byte.fts', imgb2, hdu2
writefits, 'dif3.norm.byte.fts', imgb3, hdu3
writefits, 'dif4.norm.byte.fts', imgb4, hdu4

END
