;+
; chipscan3.pro
;
; Do 3 horizontal scans across CHIP images.
;
; Andrew L. Stanger   HAO/NCAR   27 July 2000
;  2 Aug 2000 : Accomodate all 7 filters.
; 27 Sep 2000 : Image differences
; 25 Oct 2000 : Also do velocity image.
; 25 May 2001 : Replace dif.lut with  difrev.lut.
;-

PRO chipscan3, fits_list

red   = bindgen (256)
green = red
blue  = red
cbar  = BYTARR (256, 20)
FOR i = 0, 19 DO  cbar [*, i] = red

;lct, '/home/stanger/color/bwcp.lut'
;lct, '/home/stanger/color/chip1.lut'

lct, '/home/stanger/color/difrev.lut'
tvlct, red, green, blue, /get
window, xsize=936, ysize=936

;line1 = 330
;line2 = 485
;line3 = 590

;line1 = 260
;line2 = 468
;line3 = 675

line1 = 414
line2 = 458
line3 = 580

sline1 = strtrim (string (line1), 2)
sline2 = strtrim (string (line2), 2)
sline3 = strtrim (string (line3), 2)

line1t = line1 + 2
line2t = line2 + 2
line3t = line3 + 2

file0 = ''
file1 = ''
file2 = ''
file3 = ''
file4 = ''

CLOSE, 11

OPENR, 11, fits_list
READF, 11, file0
PRINT, 'file0: ', file0
READF, 11, file1
PRINT, 'file1: ', file1
READF, 11, file2
PRINT, 'file2: ', file2
READF, 11, file3
PRINT, 'file3: ', file3
READF, 11, file4
PRINT, 'file4: ', file4
CLOSE, 11

fg0 = 'dif0.scan.gif'
fg1 = 'dif1.scan.gif'
fg2 = 'dif2.scan.gif'
fg3 = 'dif3.scan.gif'
fg4 = 'vel.scan.gif'

img0 = readfits (file0, hdu0)
img1 = readfits (file1, hdu1)
img2 = readfits (file2, hdu2)
img3 = readfits (file3, hdu3)
img4 = readfits (file4, hdu4)

date0 = fxpar (hdu0, 'DATE-OBS')
date1 = fxpar (hdu1, 'DATE-OBS')
date2 = fxpar (hdu2, 'DATE-OBS')
date3 = fxpar (hdu3, 'DATE-OBS')
date4 = fxpar (hdu4, 'DATE-OBS')
time0 = fxpar (hdu0, 'TIME-OBS')
time1 = fxpar (hdu1, 'TIME-OBS')
time2 = fxpar (hdu2, 'TIME-OBS')
time3 = fxpar (hdu3, 'TIME-OBS')
time4 = fxpar (hdu4, 'TIME-OBS')

;tvscl, img0
tv, bytscl (img0, min=-0.1, max=0.1, top=249, /nan)
xyouts,   5,  70, file0, /device
xyouts,   5,  50, date0, /device
xyouts,   5,  30, time0, /device
wait, 1

;tvscl, img1
tv, bytscl (img1, min=- 50.0, max= 50.0, top=249, /nan)
xyouts,   5,  70, file1, /device
xyouts,   5,  50, date1, /device
xyouts,   5,  30, time1, /device
wait, 1

;tvscl, img2
tv, bytscl (img2, min=- 50.0, max= 50.0, top=249, /nan)
xyouts,   5,  70, file2, /device
xyouts,   5,  50, date2, /device
xyouts,   5,  30, time2, /device
wait, 1

;tvscl, img3
tv, bytscl (img3, min=- 50.0, max= 50.0, top=249, /nan)
xyouts,   5,  70, file3, /device
xyouts,   5,  50, date3, /device
xyouts,   5,  30, time3, /device
wait, 1

;tvscl, img4
tv, bytscl (img4, min=- 25.0, max= 25.0, top=249, /nan)
xyouts,   5,  70, file4, /device
xyouts,   5,  50, date4, /device
xyouts,   5,  30, time4, /device
wait, 1

min0 = MIN (img0, max=max0)
min1 = MIN (img1, max=max1)
min2 = MIN (img2, max=max2)
min3 = MIN (img3, max=max3)
min4 = MIN (img4, max=max4)

print, 'min0/max0: ', min0, max0
print, 'min1/max1: ', min1, max1
print, 'min2/max2: ', min2, max2
print, 'min3/max3: ', min3, max3
print, 'min4/max4: ', min4, max4

imgb0 = bytscl (img0, min = -  0.1, max =   0.1, top = 249, /nan)
imgb1 = bytscl (img1, min = - 50.0, max =  50.0, top = 249, /nan)
imgb2 = bytscl (img2, min = - 50.0, max =  50.0, top = 249, /nan)
imgb3 = bytscl (img3, min = - 50.0, max =  50.0, top = 249, /nan)
imgb4 = bytscl (img4, min = - 25.0, max =  25.0, top = 249, /nan)

if (abs (min0) LT abs (max0)) then min0 = -max0 else max0 = -min0
if (abs (min1) LT abs (max1)) then min1 = -max1 else max1 = -min1
if (abs (min2) LT abs (max2)) then min2 = -max2 else max2 = -min2
if (abs (min3) LT abs (max3)) then min3 = -max3 else max3 = -min3
if (abs (min4) LT abs (max4)) then min4 = -max4 else max4 = -min4

;imgb0 = bytscl (img0, min = min0, max = max0, top = 249, /nan)
;imgb1 = bytscl (img1, min = min1, max = max1, top = 249, /nan)
;imgb2 = bytscl (img2, min = min2, max = max2, top = 249, /nan)
;imgb3 = bytscl (img3, min = min3, max = max3, top = 249, /nan)

imgb0 [*, line1] = 254		; red
imgb0 [*, line2] = 253		; green
imgb0 [*, line3] = 252		; blue

imgb1 [*, line1] = 254
imgb1 [*, line2] = 253
imgb1 [*, line3] = 252

imgb2 [*, line1] = 254
imgb2 [*, line2] = 253
imgb2 [*, line3] = 252

imgb3 [*, line1] = 254
imgb3 [*, line2] = 253
imgb3 [*, line3] = 252

imgb4 [*, line1] = 254
imgb4 [*, line2] = 253
imgb4 [*, line3] = 252

tv, imgb0
xyouts,   5, 910, file0 + ':  1.0 - Iave', /device, color=253
xyouts,   5, 890, date0, /device, color=253
xyouts,   5, 870, time0 + ' UT', /device, color=253
xyouts,   5,  70, file0 + ':  1.0 - Iave', /device, color=0
xyouts,   5,  50, 'min = -0.1', /device, color=0
xyouts,   5,  30, 'max =  0.1', /device, color=0
xyouts,   5, line1t, sline1, /device, color=0
xyouts,   5, line2t, sline2, /device, color=0
xyouts,   5, line3t, sline3, /device, color=0
tv, cbar
imgd0 = tvrd ()
wait, 1
tv, imgb1
xyouts,   5, 910, file1 + ':  B1 - R1', /device, color=253
xyouts,   5, 890, date1, /device, color=253
xyouts,   5, 870, time1 + ' UT', /device, color=253
xyouts,   5,  70, file1 + ':  B1 - R1', /device, color=255
xyouts,   5,  50, 'min = - 50.0', /device, color=255
xyouts,   5,  30, 'max =   50.0', /device, color=255
xyouts,   5, line1t, sline1, /device, color=255
xyouts,   5, line2t, sline2, /device, color=255
xyouts,   5, line3t, sline3, /device, color=255
tv, cbar
imgd1 = tvrd ()
wait, 1
tv, imgb2
xyouts,   5, 910, file2 + ':  B2 - R2', /device, color=253
xyouts,   5, 890, date2, /device, color=253
xyouts,   5, 870, time2 + ' UT', /device, color=253
xyouts,   5,  70, file2 + ':  B2 - R2', /device, color=255
xyouts,   5,  50, 'min = - 50.0', /device, color=255
xyouts,   5,  30, 'max =   50.0', /device, color=255
xyouts,   5, line1t, sline1, /device, color=255
xyouts,   5, line2t, sline2, /device, color=255
xyouts,   5, line3t, sline3, /device, color=255
tv, cbar
imgd2 = tvrd ()
wait, 1
tv, imgb3
xyouts,   5, 910, file3 + ':  B3 - R3', /device, color=253
xyouts,   5, 890, date3, /device, color=253
xyouts,   5, 870, time3 + ' UT', /device, color=253
xyouts,   5,  70, file3 + ':  B3 - R3', /device, color=  0
xyouts,   5,  50, 'min = - 50.0', /device, color=0
xyouts,   5,  30, 'max =   50.0', /device, color=0
xyouts,   5, line1t, sline1, /device, color=  0
xyouts,   5, line2t, sline2, /device, color=  0
xyouts,   5, line3t, sline3, /device, color=  0
tv, cbar
imgd3 = tvrd ()
wait, 1
tv, imgb4
xyouts,   5, 910, file4 + ':  Veloctiy', /device, color=253
xyouts,   5, 890, date4, /device, color=253
xyouts,   5, 870, time4 + ' UT', /device, color=253
xyouts,   5,  70, file4 + ':  Veloctiy', /device, color=255
xyouts,   5,  50, 'min = -25.0', /device, color=255
xyouts,   5,  30, 'max =  25.0', /device, color=255
xyouts,   5, line1t, sline1, /device, color=255
xyouts,   5, line2t, sline2, /device, color=255
xyouts,   5, line3t, sline3, /device, color=255
tv, cbar
imgd4 = tvrd ()
wait, 1

s0a = img0 [*, line1] 
s0b = img0 [*, line2]
s0c = img0 [*, line3]

s1a = img1 [*, line1]
s1b = img1 [*, line2]
s1c = img1 [*, line3]

s2a = img2 [*, line1]
s2b = img2 [*, line2]
s2c = img2 [*, line3]

s3a = img3 [*, line1]
s3b = img3 [*, line2]
s3c = img3 [*, line3]

s4a = img4 [*, line1] 
s4b = img4 [*, line2]
s4c = img4 [*, line3]

t0a = file0 + '  ' + date0 + '  ' + time0 + 'UT' + '  line ' + sline1
t0b = file0 + '  ' + date0 + '  ' + time0 + 'UT' + '  line ' + sline2
t0c = file0 + '  ' + date0 + '  ' + time0 + 'UT' + '  line ' + sline3

t1a = file1 + '  ' + date1 + '  ' + time1 + 'UT' + '  line ' + sline1
t1b = file1 + '  ' + date1 + '  ' + time1 + 'UT' + '  line ' + sline2
t1c = file1 + '  ' + date1 + '  ' + time1 + 'UT' + '  line ' + sline3

t2a = file2 + '  ' + date2 + '  ' + time2 + 'UT' + '  line ' + sline1
t2b = file2 + '  ' + date2 + '  ' + time2 + 'UT' + '  line ' + sline2
t2c = file2 + '  ' + date2 + '  ' + time2 + 'UT' + '  line ' + sline3

t3a = file3 + '  ' + date3 + '  ' + time3 + 'UT' + '  line ' + sline1
t3b = file3 + '  ' + date3 + '  ' + time3 + 'UT' + '  line ' + sline2
t3c = file3 + '  ' + date3 + '  ' + time3 + 'UT' + '  line ' + sline3

t4a = file4 + '  ' + date4 + '  ' + time4 + 'UT' + '  line ' + sline1
t4b = file4 + '  ' + date4 + '  ' + time4 + 'UT' + '  line ' + sline2
t4c = file4 + '  ' + date4 + '  ' + time4 + 'UT' + '  line ' + sline3

tx = 'Pixel [Horizontal Scan]'
ty = 'Normalized CCD Intensity'
tyvel = 'Velocity [km/sec]'

set_plot, 'ps'
device, filename = 'chip.dif.ps'

plot, s0a, title=t0a, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]
plot, s0b, title=t0b, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]
plot, s0c, title=t0c, xtitle=tx, ytitle=ty, yrange=[-0.2, 0.2]

plot, s1a, title=t1a, xtitle=tx, ytitle=ty, yrange=[-100.0, 100.0]
plot, s1b, title=t1b, xtitle=tx, ytitle=ty, yrange=[-100.0, 100.0]
plot, s1c, title=t1c, xtitle=tx, ytitle=ty, yrange=[-100.0, 100.0]

plot, s2a, title=t2a, xtitle=tx, ytitle=ty, yrange=[-100.0, 100.0]
plot, s2b, title=t2b, xtitle=tx, ytitle=ty, yrange=[-100.0, 100.0]
plot, s2c, title=t2c, xtitle=tx, ytitle=ty, yrange=[-100.0, 100.0]

plot, s3a, title=t3a, xtitle=tx, ytitle=ty, yrange=[-100.0, 100.0]
plot, s3b, title=t3b, xtitle=tx, ytitle=ty, yrange=[-100.0, 100.0]
plot, s3c, title=t3c, xtitle=tx, ytitle=ty, yrange=[-100.0, 100.0]

plot, s4a, title=t4a, xtitle=tx, ytitle=tyvel, yrange=[-50.0, 50.0]
plot, s4b, title=t4b, xtitle=tx, ytitle=tyvel, yrange=[-50.0, 50.0]
plot, s4c, title=t4c, xtitle=tx, ytitle=tyvel, yrange=[-50.0, 50.0]

device, /close
set_plot, 'x'

write_gif, fg0, imgd0, red, green, blue
write_gif, fg1, imgd1, red, green, blue
write_gif, fg2, imgd2, red, green, blue
write_gif, fg3, imgd3, red, green, blue
write_gif, fg4, imgd4, red, green, blue

fxaddpar, hdu0, 'DISPMIN',   0
fxaddpar, hdu0, 'DISPMAX', 255 
fxaddpar, hdu1, 'DISPMIN',   0
fxaddpar, hdu1, 'DISPMAX', 255 
fxaddpar, hdu2, 'DISPMIN',   0
fxaddpar, hdu2, 'DISPMAX', 255 
fxaddpar, hdu3, 'DISPMIN',   0
fxaddpar, hdu3, 'DISPMAX', 255 
fxaddpar, hdu4, 'DISPMIN',   0
fxaddpar, hdu4, 'DISPMAX', 255 

writefits, 'dif0.norm.byte.fts', imgb0, hdu0
writefits, 'dif1.norm.byte.fts', imgb1, hdu1
writefits, 'dif2.norm.byte.fts', imgb2, hdu2
writefits, 'dif3.norm.byte.fts', imgb3, hdu3
writefits, 'dif4.norm.byte.fts', imgb4, hdu4

END
