;+
; chipscan7.pro
;
; Do 3 horizontal scans across CHIP images.
;
; Andrew L. Stanger   HAO/NCAR   27 July 2000
;  2 Aug 2000 : Accomodate all 7 filters.
; 27 Sep 2000 : Image differences
; 25 Oct 2000 : Also do velocity image.
; 25 May 2001 : Replace dif.lut with  difrev.lut.
; 22 Feb 2002 : Adapt for 5 LSD images each day.
; 28 Feb 2002 : Adapt for 7 images.
;-

PRO chipscan7, fits_list

red   = bindgen (256)
green = red
blue  = red
cbar  = BYTARR (256, 20)
FOR i = 0, 19 DO  cbar [*, i] = red

;lct, '/home/stanger/color/bwcp.lut'
lct, '/home/stanger/color/chip1.lut'

;lct, '/home/stanger/color/difrev.lut'
tvlct, red, green, blue, /get
;window, xsize=936, ysize=936, retain=2

row1 = 468
row1s = row1 / 2

col1 = 468
col1s = col1 / 2

srow1 = strtrim (string (row1), 2)
;srow2 = strtrim (string (row2), 2)
;srow3 = strtrim (string (row3), 2)

scol1 = strtrim (string (col1), 2)

row1t = row1s + 2
;row2t = row2 + 2
;row3t = row3 + 2

col1t = col1s + 2

file0 = ''
file1 = ''
file2 = ''
file3 = ''
file4 = ''
file5 = ''
file6 = ''

CLOSE, 11

OPENR, 11, fits_list
READF, 11, file0
PRINT, 'file0: ', file0
READF, 11, file1
PRINT, 'file1: ', file1
READF, 11, file2
PRINT, 'file2: ', file2
READF, 11, file3
PRINT, 'file3: ', file3
READF, 11, file4
PRINT, 'file4: ', file4
READF, 11, file5
PRINT, 'file5: ', file5
READF, 11, file6
PRINT, 'file6: ', file6
CLOSE, 11

gifpos = STRPOS (file0, '.gif')
file0r = STRMID (file0, 0, gifpos)
gifpos = STRPOS (file1, '.gif')
file1r = STRMID (file1, 0, gifpos)
gifpos = STRPOS (file2, '.gif')
file2r = STRMID (file2, 0, gifpos)
gifpos = STRPOS (file3, '.gif')
file3r = STRMID (file3, 0, gifpos)
gifpos = STRPOS (file4, '.gif')
file4r = STRMID (file4, 0, gifpos)
gifpos = STRPOS (file5, '.gif')
file5r = STRMID (file5, 0, gifpos)
gifpos = STRPOS (file6, '.gif')
file6r = STRMID (file6, 0, gifpos)

fg0 = file0r + '.scan.gif'
fg1 = file1r + '.scan.gif'
fg2 = file2r + '.scan.gif'
fg3 = file3r + '.scan.gif'
fg4 = file4r + '.scan.gif'
fg5 = file5r + '.scan.gif'
fg6 = file6r + '.scan.gif'

img0 = readfits (file0, hdu0)
img1 = readfits (file1, hdu1)
img2 = readfits (file2, hdu2)
img3 = readfits (file3, hdu3)
img4 = readfits (file4, hdu4)
img5 = readfits (file5, hdu5)
img6 = readfits (file6, hdu6)

xdim = fxpar (hdu0, 'NAXIS1')
ydim = fxpar (hdu0, 'NAXIS2')

date0 = fxpar (hdu0, 'DATE-OBS')
date1 = fxpar (hdu1, 'DATE-OBS')
date2 = fxpar (hdu2, 'DATE-OBS')
date3 = fxpar (hdu3, 'DATE-OBS')
date4 = fxpar (hdu4, 'DATE-OBS')
date5 = fxpar (hdu5, 'DATE-OBS')
date6 = fxpar (hdu6, 'DATE-OBS')
time0 = fxpar (hdu0, 'TIME-OBS')
time1 = fxpar (hdu1, 'TIME-OBS')
time2 = fxpar (hdu2, 'TIME-OBS')
time3 = fxpar (hdu3, 'TIME-OBS')
time4 = fxpar (hdu4, 'TIME-OBS')
time5 = fxpar (hdu5, 'TIME-OBS')
time6 = fxpar (hdu6, 'TIME-OBS')

xdim2 = xdim / 2
ydim2 = ydim / 2
window, xs=xdim2, ys=ydim2, retain=2

img0s = rebin (img0, xdim2, ydim2)
img1s = rebin (img1, xdim2, ydim2)
img2s = rebin (img2, xdim2, ydim2)
img3s = rebin (img3, xdim2, ydim2)
img4s = rebin (img4, xdim2, ydim2)
img5s = rebin (img5, xdim2, ydim2)
img6s = rebin (img6, xdim2, ydim2)

;tvscl, img0
;tv, bytscl (img0s, min=0.0, max=3000.0, top=249, /nan)
;xyouts,   5,  70, file0, /device
;xyouts,   5,  50, date0, /device
;xyouts,   5,  30, time0, /device
;wait, 1

;tvscl, img1
;tv, bytscl (img1s, min=0.0, max=3000.0, top=249, /nan)
;xyouts,   5,  70, file1, /device
;xyouts,   5,  50, date1, /device
;xyouts,   5,  30, time1, /device
;wait, 1

;tvscl, img2
;tv, bytscl (img2s, min=0.0, max=3000.0, top=249, /nan)
;xyouts,   5,  70, file2, /device
;xyouts,   5,  50, date2, /device
;xyouts,   5,  30, time2, /device
;wait, 1

;tvscl, img3
;tv, bytscl (img3s, min=0.0, max=3000.0, top=249, /nan)
;xyouts,   5,  70, file3, /device
;xyouts,   5,  50, date3, /device
;xyouts,   5,  30, time3, /device
;wait, 1

;tvscl, img4
;tv, bytscl (img4s, min=0.0, max=3000.0, top=249, /nan)
;xyouts,   5,  70, file4, /device
;xyouts,   5,  50, date4, /device
;xyouts,   5,  30, time4, /device
;wait, 1

min0 = MIN (img0, max=max0)
min1 = MIN (img1, max=max1)
min2 = MIN (img2, max=max2)
min3 = MIN (img3, max=max3)
min4 = MIN (img4, max=max4)
min5 = MIN (img5, max=max5)
min6 = MIN (img6, max=max6)

print, 'min0/max0: ', min0, max0
print, 'min1/max1: ', min1, max1
print, 'min2/max2: ', min2, max2
print, 'min3/max3: ', min3, max3
print, 'min4/max4: ', min4, max4
print, 'min5/max5: ', min5, max5
print, 'min6/max6: ', min6, max6

imgb0 = bytscl (img0s, min =    0.0, max = 3300.0, top = 249, /nan)
imgb1 = bytscl (img1s, min =    0.0, max = 3300.0, top = 249, /nan)
imgb2 = bytscl (img2s, min =    0.0, max = 3300.0, top = 249, /nan)
imgb3 = bytscl (img3s, min =    0.0, max = 3300.0, top = 249, /nan)
imgb4 = bytscl (img4s, min =    0.0, max = 3300.0, top = 249, /nan)
imgb5 = bytscl (img5s, min =    0.0, max = 3300.0, top = 249, /nan)
imgb6 = bytscl (img6s, min =    0.0, max = 3300.0, top = 249, /nan)

;if (abs (min0) LT abs (max0)) then min0 = -max0 else max0 = -min0
;if (abs (min1) LT abs (max1)) then min1 = -max1 else max1 = -min1
;if (abs (min2) LT abs (max2)) then min2 = -max2 else max2 = -min2
;if (abs (min3) LT abs (max3)) then min3 = -max3 else max3 = -min3
;if (abs (min4) LT abs (max4)) then min4 = -max4 else max4 = -min4

;imgb0 = bytscl (img0, min = min0, max = max0, top = 249, /nan)
;imgb1 = bytscl (img1, min = min1, max = max1, top = 249, /nan)
;imgb2 = bytscl (img2, min = min2, max = max2, top = 249, /nan)
;imgb3 = bytscl (img3, min = min3, max = max3, top = 249, /nan)

imgb0 [*, row1s] = 253		; green
imgb1 [*, row1s] = 253
imgb2 [*, row1s] = 253
imgb3 [*, row1s] = 253
imgb4 [*, row1s] = 253
imgb5 [*, row1s] = 253
imgb6 [*, row1s] = 253

imgb0 [col1s, *] = 252		; blue
imgb1 [col1s, *] = 252
imgb2 [col1s, *] = 252
imgb3 [col1s, *] = 252
imgb4 [col1s, *] = 252
imgb5 [col1s, *] = 252
imgb6 [col1s, *] = 252

tv, imgb0
xyouts,   5,  ydim2 - 20, file0, /device, color=255
xyouts,   5, row1t + 2, srow1, /device, color=253
xyouts,   col1t + 2, 5, scol1, /device, color=252
;tv, cbar
imgd0 = tvrd ()
wait, 1

tv, imgb1
xyouts,   5,  ydim2 - 20, file1, /device, color=255
xyouts,   5, row1t + 2, srow1, /device, color=253
xyouts,   col1t + 2, 5, scol1, /device, color=252
;tv, cbar
imgd1 = tvrd ()
wait, 1

tv, imgb2
xyouts,   5,  ydim2 - 20, file2, /device, color=255
xyouts,   5, row1t + 2, srow1, /device, color=253
xyouts,   col1t + 2, 5, scol1, /device, color=252
;tv, cbar
imgd2 = tvrd ()
wait, 1

tv, imgb3
xyouts,   5,  ydim2 - 20, file3, /device, color=255
xyouts,   5, row1t + 2, srow1, /device, color=253
xyouts,   col1t + 2, 5, scol1, /device, color=252
;tv, cbar
imgd3 = tvrd ()
wait, 1

tv, imgb4
xyouts,   5,  ydim2 - 20, file4, /device, color=255
xyouts,   5, row1t + 2, srow1, /device, color=253
xyouts,   col1t + 2, 5, scol1, /device, color=252
;tv, cbar
imgd4 = tvrd ()
wait, 1

tv, imgb5
xyouts,   5,  ydim2 - 20, file4, /device, color=255
xyouts,   5, row1t + 2, srow1, /device, color=253
xyouts,   col1t + 2, 5, scol1, /device, color=252
;tv, cbar
imgd5 = tvrd ()
wait, 1

tv, imgb6
xyouts,   5,  ydim2 - 20, file4, /device, color=255
xyouts,   5, row1t + 2, srow1, /device, color=253
xyouts,   col1t + 2, 5, scol1, /device, color=252
;tv, cbar
imgd6 = tvrd ()
wait, 1

r0a = img0 [*, row1] 
r1a = img1 [*, row1]
r2a = img2 [*, row1]
r3a = img3 [*, row1]
r4a = img4 [*, row1] 
r5a = img5 [*, row1] 
r6a = img6 [*, row1] 

c0a = img0 [col1, *] 
c1a = img1 [col1, *] 
c2a = img2 [col1, *] 
c3a = img3 [col1, *] 
c4a = img4 [col1, *] 
c5a = img5 [col1, *] 
c6a = img6 [col1, *] 

tr0a = file0 + '  ' + date0 + '  ' + time0 + 'UT' + '  row ' + srow1
tr1a = file1 + '  ' + date1 + '  ' + time1 + 'UT' + '  row ' + srow1
tr2a = file2 + '  ' + date2 + '  ' + time2 + 'UT' + '  row ' + srow1
tr3a = file3 + '  ' + date3 + '  ' + time3 + 'UT' + '  row ' + srow1
tr4a = file4 + '  ' + date4 + '  ' + time4 + 'UT' + '  row ' + srow1
tr5a = file5 + '  ' + date5 + '  ' + time5 + 'UT' + '  row ' + srow1
tr6a = file6 + '  ' + date6 + '  ' + time6 + 'UT' + '  row ' + srow1

trx = 'Pixel [Horizontal Scan]'
try = 'CCD Intensity'

tc0a = file0 + '  ' + date0 + '  ' + time0 + 'UT' + '  col ' + scol1
tc1a = file1 + '  ' + date1 + '  ' + time1 + 'UT' + '  col ' + scol1
tc2a = file2 + '  ' + date2 + '  ' + time2 + 'UT' + '  col ' + scol1
tc3a = file3 + '  ' + date3 + '  ' + time3 + 'UT' + '  col ' + scol1
tc4a = file4 + '  ' + date4 + '  ' + time4 + 'UT' + '  col ' + scol1
tc5a = file5 + '  ' + date5 + '  ' + time5 + 'UT' + '  col ' + scol1
tc6a = file6 + '  ' + date6 + '  ' + time6 + 'UT' + '  col ' + scol1

tcx = 'Pixel [Vertical Scan]'
tcy = 'CCD Intensity'

set_plot, 'ps'
device, filename = STRMID (file0, 0, 8) + '.chip.scan.ps'

plot, r0a, title=tr0a, xtitle=trx, ytitle=try, yrange=[   0.0, 3300.0]
plot, r1a, title=tr1a, xtitle=trx, ytitle=try, yrange=[   0.0, 3300.0]
plot, r2a, title=tr2a, xtitle=trx, ytitle=try, yrange=[   0.0, 3300.0]
plot, r3a, title=tr3a, xtitle=trx, ytitle=try, yrange=[   0.0, 3300.0]
plot, r4a, title=tr4a, xtitle=trx, ytitle=try, yrange=[   0.0, 3300.0]
plot, r5a, title=tr5a, xtitle=trx, ytitle=try, yrange=[   0.0, 3300.0]
plot, r6a, title=tr6a, xtitle=trx, ytitle=try, yrange=[   0.0, 3300.0]

plot, c0a, title=tc0a, xtitle=tcx, ytitle=tcy, yrange=[   0.0, 3300.0]
plot, c1a, title=tc1a, xtitle=tcx, ytitle=tcy, yrange=[   0.0, 3300.0]
plot, c2a, title=tc2a, xtitle=tcx, ytitle=tcy, yrange=[   0.0, 3300.0]
plot, c3a, title=tc3a, xtitle=tcx, ytitle=tcy, yrange=[   0.0, 3300.0]
plot, c4a, title=tc4a, xtitle=tcx, ytitle=tcy, yrange=[   0.0, 3300.0]
plot, c5a, title=tc5a, xtitle=tcx, ytitle=tcy, yrange=[   0.0, 3300.0]
plot, c6a, title=tc6a, xtitle=tcx, ytitle=tcy, yrange=[   0.0, 3300.0]

device, /close
set_plot, 'x'

write_gif, fg0, imgd0, red, green, blue
write_gif, fg1, imgd1, red, green, blue
write_gif, fg2, imgd2, red, green, blue
write_gif, fg3, imgd3, red, green, blue
write_gif, fg4, imgd4, red, green, blue
write_gif, fg5, imgd4, red, green, blue
write_gif, fg6, imgd4, red, green, blue

fxaddpar, hdu0, 'DISPMIN',   0
fxaddpar, hdu0, 'DISPMAX', 255 
fxaddpar, hdu1, 'DISPMIN',   0
fxaddpar, hdu1, 'DISPMAX', 255 
fxaddpar, hdu2, 'DISPMIN',   0
fxaddpar, hdu2, 'DISPMAX', 255 
fxaddpar, hdu3, 'DISPMIN',   0
fxaddpar, hdu3, 'DISPMAX', 255 
fxaddpar, hdu4, 'DISPMIN',   0
fxaddpar, hdu4, 'DISPMAX', 255 
fxaddpar, hdu5, 'DISPMIN',   0
fxaddpar, hdu5, 'DISPMAX', 255 
fxaddpar, hdu6, 'DISPMIN',   0
fxaddpar, hdu6, 'DISPMAX', 255 

;writefits, 'dif0.norm.byte.fts', imgb0, hdu0
;writefits, 'dif1.norm.byte.fts', imgb1, hdu1
;writefits, 'dif2.norm.byte.fts', imgb2, hdu2
;writefits, 'dif3.norm.byte.fts', imgb3, hdu3
;writefits, 'dif4.norm.byte.fts', imgb4, hdu4

END
