;+
; drawcir.pro
;
; PURPOSE	Draw a 1.0 Rsun circle on an image.
;
; SYNTAX	drawcir, xc, yc, rc
;		xc	x-axis center
;		yc	y-axis center
;		rc	radius (pixels)
;
; AUTHOR	Andrew L. Stanger   HAO/NCAR   13 Apr 2001
;-

PRO drawcir, xc, yc, rc

lct, '/home/stanger/color/chip1.lut'

degrad = 180.0 / ACOS (-1.0) 
raddeg = 1.0 / degrad

FOR it = 0, 361, 1 DO	$
    BEGIN
    theta = FLOAT (it)
    angle = raddeg * theta ;
    x = xc + rc * COS (angle) ;
    y = yc + rc * SIN (angle) ;
    ix = FIX (x + 0.5)
    iy = FIX (y + 0.5)
    IF (it EQ 0) THEN plots, ix, iy, /device, color=253		$
    ELSE plots, ix, iy, /device, color=253, /continue
    END

END
