;+
; NAME		eqplot.pro
;
; PURPOSE	Plot equatorial scan of CHIP image (936x936 shorts).
;
; SYNTAX	eqplot, fts_name
;
; AUTHOR	Andrew L. Stanger
;
; HISTORY	25 Sep 2000
;-


PRO eqplot, fts_name

;imgs = intarr (936, 936)

;CLOSE, 11
;OPENR, 11, fts_name
;READU, 11, imgs
;CLOSE, 11

imgs = readfits (fts_name, hdu)

set_plot, 'PS'
device, filename = fts_name + '.eq.ps'
ptitle = fts_name + '  Equatorial Scan'
plot, imgs [*, 936/2],				$
      title = ptitle,				$
      xtitle = 'Horizontal Pixel',		$
      ytitle = 'Intensity'

device, /close
set_plot, 'X'

END
