;+
; imgshift.pro
;
; PURPOSE	Image translation.
;
; SYNTAX	imgreg = imgshift (img, xdim, ydim, xshift, yshift)
;
;		img		2D image array
;		xdim		X-axis dimension
;		ydim		Y-axis dimension
;		xshift		X-axis shift
;		yshift		Y-axis shift
;		missval		Value assigned to missing pixels (due to shift).
;
; AUTHOR	Andrew L. Stanger   HAO/NCAR   21 March 2001
;-

FUNCTION imgshift, img, xdim, ydim, xshift, yshift, missval

mv = missval
imgs = img
imgs [*,*] = 0

    FOR iy = 0, ydim - 1 DO        $
    BEGIN ;{
        FOR ix = 0, xdim - 1 DO     $
        BEGIN ;{
            imgs [ix, iy] = INTERPOLATE (img, ix-xshift, iy-yshift, MISSING=mv)
        ENDFOR ;}
    ENDFOR ;}

    RETURN, imgs
END
