;+
; NAME	ld_func5
;
; PURPOSE	Limb darkening equation
;
; SYNTAX	ld_func5, t, a, b, pd
;
; AUTHOR	Andrew L. Stanger   31 August 2000
;
; HISTORY	Sine function.
;-

PRO ld_func5, t, a, b, pd

; B = A0 + A1 * sin (t) 

raddeg = 3.14159265 / 180.0		; radians / degree.

tr = t * raddeg				; convert angle to radians.

pd = FLTARR (N_ELEMENTS (tr), N_ELEMENTS (a))

b = a [0] + a [1] * sin (tr)

pd [*, 0] = 1.0

pd [*, 1] = sin (tr)

END

