;+ lsdadj.pro
;
; Apply LSD correction to a raw CHIP image.
;
; Andrew L. Stanger   HAO/NCAR   6 March 2001
;-

PRO lsdadj, fits_file

    img = readfits (fits_file, hdu)

    lsd = readfits ('hdr.lsc.fts', hdulsd)
    dmin = MIN (lsd, max=dmax)
    PRINT, 'dmin/dmax: ', dmin, dmax

    xdim = fxpar (hdu, 'NAXIS1')
    ydim = fxpar (hdu, 'NAXIS2')
    xdim2 = xdim / 2
    ydim2 = ydim / 2

    ;--- Over-write the 3 pixels along the perimeter to avoid "shift" junk.

;    img [*, 0] = img [*, 3]
;    img [*, 1] = img [*, 3]
;    img [*, 2] = img [*, 3]

;    img [*, ydim-1] = img [*, ydim-4]
;    img [*, ydim-2] = img [*, ydim-4]
;    img [*, ydim-3] = img [*, ydim-4]

;    img [0, *] = img [3, *]
;    img [1, *] = img [3, *]
;    img [2, *] = img [3, *]

;    img [xdim-1, *] = img [xdim-4, *]
;    img [xdim-2, *] = img [xdim-4, *]
;    img [xdim-3, *] = img [xdim-4, *]

    img [*, 0] = 1.0
    img [*, 1] = 1.0
    img [*, 2] = 1.0

    img [*, ydim-1] = 1.0
    img [*, ydim-2] = 1.0
    img [*, ydim-3] = 1.0

    img [0, *] = 1.0 
    img [1, *] = 1.0
    img [2, *] = 1.0

    img [xdim-1, *] = 1.0
    img [xdim-2, *] = 1.0
    img [xdim-3, *] = 1.0

    imin = MIN (img, max=imax)
    PRINT, 'imin/imax: ', imin, imax

    img2 = REBIN (img, xdim2, ydim2)
    TVSCL, img2
    XYOUTS, 5, 5, 'ORIGINAL', /device
    WAIT, 3

    imgc = img * lsd

    cmin = MIN (imgc, max=cmax)
    PRINT, 'cmin/cmax: ', cmin, cmax

    imgc2 = REBIN (imgc, xdim2, ydim2)

    window, xsize=xdim2, ysize=ydim2
    TVSCL, imgc2
    XYOUTS, 5, 5, 'CORRECTED', /device

END

