;+ rawchipview.pro
;
; Display raw CHIP images.
;
; Andrew L. Stanger   HAO/NCAR   6 March 2001
;-

PRO rawchipview, file_name

!order = 1			; Display image top to bottom.

xdim = 1534
ydim = 1030
xdim2 = xdim / 2
ydim2 = ydim / 2
img  = INTARR (xdim, ydim)
limg = LONARR (xdim, ydim)

WINDOW, xsize = xdim2, ysize=ydim2

CLOSE, 11

OPENR, 11, file_name
READU, 11, img
CLOSE, 11

imin = MIN (img, max=imax)
print, 'imin/imax: ', imin, imax

    ;--- Over-write the 3 pixels along the perimeter to avoid "shift" junk.

    img [*, 0] = img [*, 3]
    img [*, 1] = img [*, 3]
    img [*, 2] = img [*, 3]

    img [*, ydim-1] = img [*, ydim-4]
    img [*, ydim-2] = img [*, ydim-4]
    img [*, ydim-3] = img [*, ydim-4]

    img [0, *] = img [3, *]
    img [1, *] = img [3, *]
    img [2, *] = img [3, *]

    img [xdim-1, *] = img [xdim-4, *]
    img [xdim-2, *] = img [xdim-4, *]
    img [xdim-3, *] = img [xdim-4, *]

imin = MIN (img, max=imax)
print, 'imin/imax: ', imin, imax

limg = LONG (img)
lmin = MIN (limg, max=lmax)
print, 'lmin/lmax: ', lmin, lmax


img2 = rebin (img, xdim2, ydim2)
window, xsize = xdim2, ysize = ydim2
;tvscl, img2
tv, bytscl (img2, min=0, max=3500)
wait, 3

;plot, img2 [*, ydim2/2]
;wait, 3

;--- Find pixels where magnitude is negative.

negloc = WHERE (img2 LT 0)
siznegloc = size (negloc)
print, 'size (negloc): ', siznegloc
print, size (negloc)

;--- Create a 2D array where all pixels are zero,
;    except for the negative-valued pixels, which are set to 255.

nneg = LONG (siznegloc [1])
print, 'nneg: ', nneg
nloc = LONARR (nneg, 2)
imgneg = 0
imgneg = FLTARR (xdim2, ydim2)

i = 0L
IF (nneg GE 0) THEN	$
FOR i = 0L, nneg - 1 DO	$
    BEGIN
    ix = negloc [i]
    iy = ix / xdim2
    IF (iy GT 0) THEN ix = ix - iy * xdim2
    nloc [i, 0] = ix
    nloc [i, 1] = iy
;    imgneg [ix, iy] = 255
    imgneg [ix, iy] = -FLOAT (img2 [ix, iy])
    IF (ix EQ 32) THEN	$
        print, 'ix/iy: ', ix, iy, ' intensity: ', img2 [ix, iy]
    END			$
ELSE			$
   BEGIN
   print, 'No negative values in image.'
   END

;--- Display image.

tvscl, imgneg
wait, 2
plot, imgneg [32, *]

END
