;+
;-

PRO smmcp_overlay, hdu, hdu_hk, xdim, ydim, xb, yb, wmin=dmin, wmax=dmax

  ;--- Color assignments for annotation.

  white  = 255
  red    = 254
  green  = 253
  blue   = 252
  grey   = 251
  yellow = 250
  black  =   0

  ;--- Get information from FITS header.

  xcen      = fxpar (hdu, 'CRPIX1')
  ycen      = fxpar (hdu, 'CRPIX2')
  crradius  = fxpar (hdu, 'CRRADIUS')
  pixrs     = crradius
  scroll    = fxpar (hdu, 'SCROLL')

  ; --- Draw sun circle.

  gMINCOL = xb
  gMAXCOL = xb + xdim - 1
  gMINROW = yb
  gMAXROW = yb + ydim - 1

  radius =   1.0
  angmin =   0.0
  angmax = 360.0
  anginc =  10.0

  suncir_cp, radius, angmin, angmax, anginc, yellow,  		$
	     xcen, ycen, pixrs, scroll,				$
	     gMINCOL, gMAXCOL, gMINROW, gMAXROW

  radius = 1.6
  suncir_cp, radius, angmin, angmax, anginc, red,    		$
	     xcen, ycen, pixrs, scroll,				$
	     gMINCOL, gMAXCOL, gMINROW, gMAXROW

  ; --- Draw radial lines.

  rmin    =  1.2
  rmax    =  1.7
  rinc    =  0.2
  anginc  = 30.0
  dotsize =  3

  sunray, rmin, rmax, rinc, anginc, dotsize,	$
	  xcen, ycen, pixrs, scroll, red,  	$
	  gMINCOL, gMAXCOL, gMINROW, gMAXROW

  rmin    =  0.2
  rmax    =  1.7
  rinc    =  0.2
  anginc  = 90.0
  dotsize =  3

  sunray, rmin, rmax, rinc, anginc, dotsize,	$
	  xcen, ycen, pixrs, scroll, red,    	$
	  gMINCOL, gMAXCOL, gMINROW, gMAXROW

  ;--- Draw north pointer.

  cirrad = 1.0
  tiprad = 0.4

  cp_north,  xcen, ycen, pixrs, scroll, cirrad, tiprad, yellow,	$
             gMINCOL, gMAXCOL, gMINROW, gMAXROW

  cirrad = 1.0
  tiprad = 0.1
  cp_north,  xcen, ycen, pixrs, scroll, cirrad, tiprad, yellow,	$
             gMINCOL, gMAXCOL, gMINROW, gMAXROW

  RETURN
END
