;+
; NAME	mk3synlong3.pro
;
; PURPOSE	Longitude scan of Mk3 synoptic map.
;
; SYNTAX	mk3synlong3, mk3_synoptic_file latitude_index
;
;		mk3_synoptic_file	binary file 360x181 shorts, e or w
;
;		mk3synlong3, '1943e1.25'
;		
; AUTHOR	Andrew L. Stanger   HAO/NCAR    4 Nov 2002
;-

PRO mk3synlong3, mapfile

map = INTARR (360, 181)

CLOSE, 1
OPENR, 1, mapfile
READU, 1, map
CLOSE, 1

map = map * 1.e-10			; Convert to pB Bsun units.

plotfile = mapfile + '.plot.ps'
xlab   = 'Longitude'
ylab   = 'pB [Bsun]'

SET_PLOT, 'PS'
DEVICE, file=plotfile

lat = -30
ilat = lat + 90
slat = STRING (lat, FORMAT='(i3)')
ptitle = 'Mk3 C.R.' + mapfile + ' Latitude ' + slat

PLOT, map [*, ilat],		$
      title=ptitle,		$
      xtitle=xlab,		$
      ytitle=ylab

lat = 0
ilat = lat + 90
slat = STRING (lat, FORMAT='(i3)')
ptitle = 'Mk3 C.R.' + mapfile + ' Latitude ' + slat

PLOT, map [*, ilat],		$
      title=ptitle,		$
      xtitle=xlab,		$
      ytitle=ylab

lat = 30
ilat = lat + 90
slat = STRING (lat, FORMAT='(i3)')
ptitle = 'Mk3 C.R.' + mapfile + ' Latitude ' + slat

PLOT, map [*, ilat],		$
      title=ptitle,		$
      xtitle=xlab,		$
      ytitle=ylab

DEVICE, /CLOSE
SET_PLOT, 'X'
END
