; avgmk4.pro
;
; Routine to average a list of images
;
; David Elmore   13 Nov 2001

;
; Set up display values
;
!y.title='Daily Average pB'
!x.title='Height (R-Sun)'
!p.title = 'Average pB vs. Height'
!p.font=1
!p.thick=1.6
!p.ticklen=1
!p.charsize=1.6
!x.style=1
!y.style=1
!x.ticks=10
!x.range=[1.10,2.8]
!y.range=[1.e-10,1.e-6]

is_cal_avg = 18
azplace=220

;
; read settings file
;
olddalsa='n'
dostreach='n'
correctfile0='fred'
correctfile1='fred'
close,15 & openr,15,'settings'
readf,15,olddalsa
olddalsa = strtrim(olddalsa)
readf,15,kappa
readf,15,phaseoffset
readf,15,correctfile0
readf,15,correctfile1
readf,15,dostreach
dostreach = strtrim(dostreach)
readf,15,linelow
readf,15,linehigh
readf,15,pixoff
readf,15,pixscale
readf,15,minrad
readf,15,maxrad
readf,15,iscale
readf,15,ioffset
readf,15,qscale
readf,15,qoffset
readf,15,uscale
readf,15,uoffset
readf,15,lowbias
readf,15,highbias

;
; List of files to average is in avglist
;
listname = 'avglist'
filename = 'fred'

;
; Read a header to set some variables
;
headib=0 & headib=lonarr(16)  
headf =0 & headf =fltarr(32)
headie=0 & headie=lonarr(16)  
headpad=0 & headpad=bytarr(1024-4*16-4*32-4*16)

close,2
openr,2,'avglist' 
readf,2,filename
close,2

close,1 & openr,1,filename
	readu,1,headib
	readu,1,headf
	readu,1,headie
	readu,1,headpad
close,1
print,headib
print,headf
print,headie
;
numaz = headib(9)
numpix = headib(10)
pixoff = headf(23)
pixscale = headf(24)
print,numaz,numpix,pixscale,pixoff

;
; Heights from header of first file
;
height=findgen(numpix)*pixscale + pixoff

inimg = intarr(NUMAZ,NUMPIX)
avgimg = fltarr(NUMAZ,NUMPIX)

close,2 & openr,2,listname & readf,2,filename
numimg = 0
while ( not eof(2) ) do begin
	numimg=numimg+1
	readf,2,filename
endwhile
rays = fltarr(numimg,NUMPIX)

close,2 & openr,2,listname & readf,2,filename

window,0,xs=numaz,ys=numpix
window,1,xs=numaz,ys=numpix
imgnum = 0
while ( not eof(2) ) do begin
	print,filename
	close,1 & openr,1,filename 
		readu,1,headib 
		readu,1,headf 
		readu,1,headie 
		readu,1,headpad
		readu,1,inimg
	scale = headf(13)
	offset = headf(14)
	img = (float(inimg)-offset)/scale 
	avgimg = avgimg + img
	rays(imgnum,*)=img(azplace,*) 
	imgnum = imgnum + 1
	wset,0
	tv,bytscl(alog10(img+2.e-9),-9,-5)
	wset,1
	tv,bytscl(alog10((avgimg/imgnum)+2.e-9),-9,-5)
	readf,2,filename
endwhile

avgimg = avgimg/numimg 
tv,bytscl(alog10(avgimg+2.e-9),-9,-5)

close,1 & openw,1,strmid(filename,0,6)+'_avg.CalpB'
headie(2) = is_cal_avg

writeu,1,headib
writeu,1,headf
writeu,1,headie
writeu,1,headpad
writeu,1,fix(avgimg*scale + offset)
close,1


window,2,xs=512,ys=512
;
;   Joan, this is all you really need
;	feed these lines of code with the average
;	image of the day.
; What is mean and std dev for each height?
;   an indicator of coronal structure
;
avgheight=fltarr(numaz)
avgheightplus=fltarr(numaz)
avgheightminus=fltarr(numaz)
avgheightmax=fltarr(numaz)
avgheightmin=fltarr(numaz)
for ii=0,numpix-1 do begin
	res=moment(avgimg(*,ii),sdev=derf)
	avgheight(ii) = res(0)
	avgheightplus(ii)=res(0)+derf
	avgheightminus(ii)=res(0)-derf
	avgheightmax(ii)=max(avgimg(*,ii))
	avgheightmin(ii)=min(avgimg(*,ii))
endfor

close,1 & openw,1,'corona_model' & writeu,1,avgheight & close,1

;
; create azimuthally binned data
;  again this will work on average image of the day
;
binsize = 20
binimg=fltarr(numaz/binsize,numpix)
for jj=0,numaz-1 do begin
	kk = jj/binsize
	binimg(kk,*) = binimg(kk,*)+img(jj,*)
endfor
for kk=0,numaz/binsize - 1 do binimg(kk,*)=binimg(kk,*)/binsize
	
print,"Set plot device"
stop
plot_oo,height,avgheight
oplot,height,avgheightplus,psym=3
oplot,height,avgheightminus,psym=3
;oplot,height,avgheightmax,psym=3
;oplot,height,avgheightmin,psym=3

stop
;
; What is the stdev for each height over the day?
;	This requires all the images going into the average
;	image of the day to get RMS at each height
;	over the day.
;
daystdev=fltarr(NUMPIX)
daymean=fltarr(NUMPIX)
polystdev=fltarr(NUMPIX)
imgnum = findgen(numimg)
for jj=0,numpix-1 do begin
	res=moment(rays(*,jj),sdev=derf)
	coef = poly_fit(imgnum,rays(*,jj),2,yfit,yband,sigma)
	daystdev(jj)=derf
	daymean(jj)=res(0)
	polystdev(jj)=sigma
endfor

!p.title='Mean and Standard Deviation at One Azimuth'
!y.title='pB'
plot_oo,height,daymean
oplot,height,daystdev,psym=3
oplot,height,polystdev,psym=1
stop

!p.title='pB:  10 degree binned azimuths'
plot_oo,height,binimg(0,*),psym=3
for kk = 1,binsize-1 do begin
	oplot,height,binimg(kk,*),psym=3
endfor
end

