;+
; fixmk4rpbfits.pro   IDL procedure
;
; PURPOSE
;	Read a Mk4 FITS file and fix variou parameter values.
;	Designed to repair FITS headers for rpB images produced
;	by David Elmore's IDL mk4 calibration software.
;
; SYNTAX
;	fixmk4rpbfits, 'fits_list'
;
; PROCEDURES USED
;	readfits
;	writefits
;	fxaddpar
;
; HISTORY
;	Author: Andrew L. Stanger   HAO/NCAR   19 July 2001
;-

pro fixmk4rpbfits, fits_list

fits_name = ''				; Define FITS file name variable.
comment = ''

CLOSE, 1

print, 'fits_list: ', fits_list

OPENR, 1, fits_list			; Open list file.

WHILE (NOT EOF (1)) DO	$		; File processing loop.
   BEGIN
      READF, 1, fits_name		; Read FITS file name from list file.

      print, fits_name

      fxhmodify, fits_name, 'EXTEND', 'T'		; Add extend parameter.
      fxhmodify, fits_name, 'BITPIX',  8, EXTENSION=1	; Change bitpix to 8.
   END
CLOSE, 1

 END
