;+
; NAME	mk4flt2short.pro
;
; PURPOSE	Read Mk4 Floating Point images & rewrite as short integers.
;
; SYNTAX	mk4flt2short, mk4_list
;
; HISTORY	Andrew L. Stanger   HAO/NCAR   21 September 2001
;-

pro mk4flt2short, mk4_list

;--- Mk4 Geometric scale factors from height mask test 28 April 2001 :

r0 = 0.00526475
dr = 0.938592

mk4_name = ''
comment_dr = ''
comment_r0 = ''
comment_rmin = ''
comment_rmax = ''
comment_rsun = ''
comment_cdelt1 = ''
comment_cdelt2 = ''
hd = bytarr (1024)
hdi = lonarr (256)
hdf = fltarr (256)

CLOSE, 11
fits_name = ''

;--- File list loop.

OPENR, 11, mk4_list
WHILE (NOT EOF (11)) DO	$
BEGIN	;{

   ;--- Read FITS image header & pixel data.

   READF, 11, mk4_name				; Get file name.
   print, 'Input name:  ', mk4_name
   ftspos = STRPOS (mk4_name, '.fts')

   out_name = mk4_name + '.short'
   print, 'Output name: ', out_name

   OPENR, 12, mk4_name
   READU, 12, hdi			; Read header into integer array
;   POINT_LUN, 12, 0			; Rewind to beginning.
;   READU, 12, hdf			; Read header into float array.
;   print, 'hdi: '
;   print, hdi

   ;--- Extract information from header.

   xdim = hdi [ 9]
   ydim = hdi [10]

   fimg = FLTARR (xdim, ydim)

   READU, 12, fimg

   CLOSE, 12

   fmin = MIN (fimg, max=fmax)
   print, 'fmin/fmax: ', fmin, fmax

   ;--- Write modified Mk4 file to disk.

   OPENW,  12, out_name
   WRITEU, 12, hdi
   WRITEU, 12, FIX (fimg)
   CLOSE,  12

END	;}

CLOSE, 11

END
