;+
; mk4opal.pro
;
; Compare intensity levels of raw Mk4 calibration images.
;
; Andrew L. Stanger   HAO/NCAR   29 Oct 2001
;
;-

;PRO mk4opal, file1, file2, file3

PRO mk4opal, list

file1 = ''
file2 = ''
file3 = ''

lct, '/home/cordyn/color/bwcp.lut'

CLOSE, 11
OPENR, 11, list
READF, 11, file1
READF, 11, file2
READF, 11, file3
CLOSE, 11

img1 = readfits (file1, hdu1, /noscale)
img2 = readfits (file2, hdu2, /noscale)
img3 = readfits (file3, hdu3, /noscale)

set_plot, 'PS'
device, filename="mk4opal.ps", /color

lct, '/home/cordyn/color/bwcp.lut'

;window, xs=1000, ys=800
;window, 0, xs=982, ys=384, retain=2

FOR i = 0, 960, 240 DO		$
BEGIN
    si = STRING (i, FORMAT='(I3)')
    plot,  img1 [i, 30:379], color=0, $
	   title = 'Radial Scan ' + file1 + ' barrel pos: ' + si, charsize=0.8
;	   yrange = [0.0, 10000.0]
    oplot, img2 [i, 30:379], color=254
    oplot, img3 [i, 30:379], color=252
;stop
END
;stop

FOR i = 30, 360, 30 DO		$
BEGIN
    ave1 = TOTAL (img1 [0:981, i]) / 982.0
    ylo  = 0.92 * ave1
    yhi  = 1.08 * ave1
    si = STRING (i, FORMAT='(I3)')
    plot,  img1 [0:981, i], color=0, $
	   title = 'Azimuthal Scan ' + file1 + ' Pixel: ' + si, charsize=0.8, $
	   yrange = [ylo, yhi]
    oplot, img2 [0:981, i], color=254
    oplot, img3 [0:981, i], color=252
;stop
END

;window, 1, xs=982, ys=384, retain=2
;plot, img2 [0, 30:379]
;stop

;window, 2, xs=982, ys=384, retain=2
;plot, img3 [0, 30:379]
;stop

img1c = img1 [0:981, 30:379]
img2c = img2 [0:981, 30:379]
img3c = img3 [0:981, 30:379]

sum1row = TOTAL (img1c, 1)
sum2row = TOTAL (img2c, 1)
sum3row = TOTAL (img3c, 1)
print, 'size (sum1row): ', size (sum1row)
;print, 'sum1row: ', sum1row
;print, 'sum2row: ', sum2row
;print, 'sum3row: ', sum3row

sum1col = TOTAL (img1c, 2)
sum2col = TOTAL (img2c, 2)
sum3col = TOTAL (img3c, 2)
print, 'size (sum1col): ', size (sum1col)
;print, 'sum1col: ', sum1col
;print, 'sum2col: ', sum2col
;print, 'sum3col: ', sum3col

ave1row = sum1row / 380.0
ave2row = sum2row / 380.0
ave3row = sum3row / 380.0
print, 'size (ave1row): ', size (ave1row)
;print, 'ave1row: ', ave1row
;print, 'ave2row: ', ave2row
;print, 'ave3row: ', ave3row

ave1col = sum1col / 982.0
ave2col = sum2col / 982.0
ave3col = sum3col / 982.0
print, 'size (ave1col): ', size (ave1col)
;print, 'ave1col: ', ave1col
;print, 'ave2col: ', ave2col
;print, 'ave3col: ', ave3col

device, /close
set_plot, 'X'

END
