;;
;; This is a quicky idl procedure to look at
;; mk4 2-d tscp files.
;; Alice Lecinski,  Sept 21, 2001
;;
; Set gain range to [0, 1200].

red   = bytarr (256)
green = bytarr (256)
blue  = bytarr (256)

doplot = 1
NAZ = 720
NPX = 384
close, 1
head   = 0 & head   = bytarr (1024) ;;
headib = 0 & headib = lonarr (16)  
headf  = 0 & headf  = fltarr (32)
headie = 0 & headie = lonarr (16)  

buff = 0     &    buff     = intarr (2)
TiltPhs = 0  &    TiltPhs  = fltarr (2)

		Bopal = 0.
		ang1  = 0.
		fp1   = 0.;    /* 0.0 */
		ang0  = 0.;   /* -9999.0 */
		fp0   = 0.;    /* 0.0 */
		trt   = 0.;    /* 0.84738906 */
		fpt   = 0.;
		x11   = 0.;  /* 1.0 */
		x12   = 0.;  /* 0.0 */
		x13   = 0.;  /* 0.0 */
		x21   = fltarr (NPX)
		x22   = fltarr (NPX)
		x23   = fltarr (NPX)
		x31   = fltarr (NPX)
		x32   = fltarr (NPX)
		x33   = fltarr (NPX)

		vgain = fltarr (NPX)

		Gain = fltarr (NAZ, NPX)
		x21a = fltarr (NAZ, NPX)
		x31a = fltarr (NAZ, NPX)

scl = 1
pixx = NAZ & pixy = 600
xcen = NAZ/2  & ycen = NPX/2
xsz = (pixx/scl)
ysz = (pixy/scl)

mywin = 0
filenm = ' '
top  = long (0)
fpos = 0
fpos = lonarr (5000)   &  ftmp = long (0)   &   ii = 0
                  
mn = -100 & mx = 100
mn = 0 & mx =  5

    clist = 'tlist'

print, ' '
print, 'The tscp files listed in file: ', clist, ' will now be displayed.'
print, ' '
print, 'You can use the mouse to move backwards and forwards in your image list.'
print, 'Place the mouse in the image window, and then:'
print, '     To move forwards, use the left most mouse button.'
print, '     To move backwards, use the middle   mouse button.'
print, ' '
print, ' '

if ( doplot eq 1 ) then begin ;{

; --- Open a window.

device, window_state = winst
if (winst (mywin) eq 0) then begin ;{
    window, mywin, xsize = xsz, ysize = ysz, xpos = 400, ypos = 270, retain = 2

    ; --- Load color table

    dome = 1
    if (dome) then begin ;{
	loadct, 3
    endif;}
endif

endif ;}

lct, '/home/stanger/idl/color/bwinv.lut'
tvlct, red, green, blue, /get           ; Read color table into arrays.

close, 13 & openr, 13, clist
                  
while ( not eof (13) ) do begin ;{
    point_lun, -13, ftmp  & fpos (ii) = ftmp
    readf, 13, filenm
    close, 1 & openr, 1, filenm & point_lun, -1, top & readu, 1, headib
			                          readu, 1, headf
			                          readu, 1, headie
    print, filenm
    print, 'cal0I header'
    print, headib
    print, headf
    print, headie

                               point_lun, 1, top & readu, 1, head
						  readu, 1, head
						  readu, 1, head

						  readu, 1, head
						  readu, 1, head
						  readu, 1, head

						  readu, 1, head
						  readu, 1, head
						  readu, 1, head

						  readu, 1, buff
						  readu, 1, TiltPhs
						  readu, 1, Bopal
						  readu, 1, ang1
						  readu, 1, fp1
						  readu, 1, ang0
						  readu, 1, fp0
						  readu, 1, trt
						  readu, 1, fpt

						  readu, 1, x11
						  readu, 1, x12
						  readu, 1, x13
						  readu, 1, x21
						  readu, 1, x22
						  readu, 1, x23
						  readu, 1, x31
						  readu, 1, x32
						  readu, 1, x33

						  readu, 1, vgain
						  readu, 1, Gain
						  readu, 1, x21a
						  readu, 1, x31a
						  close, 1

    mni = min (Gain (200, 0:NPX-1))
    mxi = max (Gain (200, 0:NPX-1))

    if (doplot eq 1) then wset, mywin

    print, 'calCI header'
    print, headib
    print, headf
    print, headie
    print, ' '
    print, ' Gain (xcen, ycen)', Gain (xcen, ycen) , mni, mxi
    print, ' TiltPhs (degrees)', tiltphs
    print, ' Date created (juld)', long (buff(0)) + long (65535)

    !P.MULTI = [ 0, 3 , 3 ]
;    !P.MULTI = [ 0, 3 , 5 ]
 
mysz = 2.5

if (doplot eq 1 ) then begin ;{

;;name_end = strmid (filenm, 0, 4, /reverse_offset) ;; doesn't work.
slen = strlen (filenm)
name_end = strmid (filenm, slen-4, 4)
match = strcmp (name_end, 'tscp')
if ( match eq 1 ) then begin ;{
    ms123   = 0.15
    ms23    = 15.0
    mx22_lo =  0.
    mx22_hi = 40.
    vg_lo   = 0.
    vg_hi   = 1000.
endif else begin ;}{
    ms123   = 0.01
    ms23    = 0.05
    mx22_lo = -0.0 
    mx22_hi =  0.05
    vg_lo   = 0.
    vg_hi   = 0.01
endelse ;}
 
plot, [0, 400], [-1.*ms123, ms123], title = 'x21', /ynoz, $
      xstyle = 1, ystyle = 1, /nodata, charsize = mysz
oplot, X21(*), thick = 1
 
 
plot, [0, 400], [mx22_lo, mx22_hi], title = 'x22', /ynoz, $
      xstyle = 1, ystyle = 1, /nodata, charsize = mysz
oplot, X22(*), thick = 1
 
plot, [0, 400], [-1.*ms23, ms23], title = 'x23', /ynoz, $
      xstyle = 1, ystyle = 1, /nodata, charsize = mysz
oplot, X23(*), thick = 1
 
 
plot, [0, 400], [-1.*ms123, ms123], title = 'x31', /ynoz, $
      xstyle = 1, ystyle = 1, /nodata, charsize = mysz
oplot, X31(*), thick = 1
 
plot, [0, 400], [-1.*ms23, ms23], title = 'x32', /ynoz, $
      xstyle = 1, ystyle = 1, /nodata, charsize = mysz
oplot, X32(*), thick = 1

plot, [0, 400], [mx22_lo, mx22_hi], title = 'x33', /ynoz, $
      xstyle = 1, ystyle = 1, /nodata, charsize = mysz
oplot, X33(*), thick = 1

vg_hi = 4000.0

plot, [0, 400], [vg_lo, vg_hi], title = 'Vgain', /ynoz, $
      xstyle = 1, ystyle = 1, /nodata, charsize = mysz
oplot, Vgain(*), thick = 1

plot, [0.0, 10.0], [0.0, 10.0], title = filenm, /ynoz, $
      xstyle = 1, ystyle = 1, /nodata, charsize = mysz

;XYOUTS, 10, 10, filenm, color = 200
;PLOTS, 150, 10, filenm, color = 255

; --- Write GIF file.

print, 'tvrd in progress.'

img = tvrd ()

print, 'writing gif file.'

WRITE_GIF, filenm + '.gif', img, red, green, blue

print, 'ready for next file.'

;    wait = 3
  ;;cursor, x, y, wait, /NORMAL
;    tv, bytscl(Gain, vg_lo, vg_hi)

;    cursor, x, y, wait, /NORMAL
;    tv, bytscl(x21a, -1.*ms123, ms123)
    
;    cursor, x, y, wait, /NORMAL
;    tv, bytscl(x31a, -1.*ms123, ms123)
    
    
    ; --- Logic to move forwards or backwards in the list of tscpfiles.

    wait, 1
;    wait = 3
;    cursor, x, y, wait, /NORMAL
    if ( !ERR eq 2 ) then begin ;{
	ii = ii-1  & if (ii le 0) then ii = 0
	point_lun, 13, fpos (ii)
    endif else begin ;}{
	ii = ii+1
    endelse ;}

endif;}

endwhile ;}
                  
close, 13

!P.MULTI = [ 0, 1 , 1 ]

end

