;+
; NAME	tvan.pro
;
; PURPOSE	Animate a sequence of images using the TV command.
;
; AUTHOR	Atle Borsholm   Technical Support Engineer RSI   8 Sep 2003
;		
;-

PRO tvan_event, ev

  WIDGET_CONTROL, ev.top, get_uvalue=s
  WIDGET_CONTROL, ev.top, timer=1d0/(*s.fps)
  WSET, s.win
  TV, (*s.img3d) [*, *, *s.n]
  *s.n = (*s.n + 1) mod s.dim [2]

END

; ------------------------------------------------------------------------------

PRO ct_event, ev

;  LOADCT, ev.index, /silent

  XCOLORS, Group=ev.top, Title='xcolors', NotifyID=[ev.id, ev.top], /drag

END

; ------------------------------------------------------------------------------

PRO speed_event, ev

  WIDGET_CONTROL, ev.top, get_uvalue=s
  *s.fps = ev.value

END

; ------------------------------------------------------------------------------

PRO tvan_cleanup, tlb

  WIDGET_CONTROL, tlb, get_uvalue=s
  HEAP_FREE, s

END

; ------------------------------------------------------------------------------

PRO tvan, img3d, no_copy=no_copy

  compile_opt idl2
  DEVICE, decomposed=0
  LOADCT, 0, get_names=ct

  IF (N_ELEMENTS (img3d) eq 0) THEN $
  BEGIN
    PRINT, '3D data cube must be supplied to tvan.'
    RETURN
  END

  dim    = SIZE (img3d, /dim)

  tlb    = WIDGET_BASE   (column=2, title='tvan')
  bbase  = WIDGET_BASE   (tlb, ROW=2)
  ibase  = WIDGET_BASE   (tlb)

  colors = WIDGET_BUTTON (bbase, value='Modify Color Table',	$
				 event_pro='ct_event')
  slider = WIDGET_SLIDER (bbase, min=1, max=100, value=50, $
			         event_pro='speed_event')   ; frames per second
  draw   = WIDGET_DRAW   (ibase, xsize=dim [0], ysize=dim [1])

  WIDGET_CONTROL, tlb,   /realize
  WIDGET_CONTROL, draw,  get_value=win
  WIDGET_CONTROL, tlb,   timer=0.1
  WIDGET_CONTROL, tlb,   set_uvalue= $
                         {img3d:ptr_new (img3d,no_copy=no_copy), $
			  n:ptr_new (0), $
                          time:systime (1), $
			  win:win, $
			  dim:dim, $
			  fps:ptr_new (50)}

  XMANAGER, 'tvan', tlb, /no_block, cleanup='tvan_cleanup'

END

; ------------------------------------------------------------------------------

