;+
; NAME	tv_animation.pro
;
; PURPOSE	Animate a sequence of images using the TV command.
;
; AUTHOR	Atle Borsholm   Technical Support Engineer RSI   8 Sep 2003
;		
;-

PRO tv_animation_event, ev
  WIDGET_CONTROL, ev.top, get_uvalue=s
  WIDGET_CONTROL, ev.top, timer=1d0/(*s.fps)
  WSET, s.win
  TV, (*s.slices)[*,*,*s.n]
  *s.n=(*s.n+1) mod s.dim[2]
END

; ------------------------------------------------------------------------------

PRO ct_event,ev
  LOADCT, ev.index, /silent
END

; ------------------------------------------------------------------------------

PRO speed_event, ev
  WIDGET_CONTROL, ev.top, get_uvalue=s
  *s.fps=ev.value
END

; ------------------------------------------------------------------------------

PRO tv_animation_cleanup, tlb
  WIDGET_CONTROL, tlb, get_uvalue=s
  HEAP_FREE, s
END

; ------------------------------------------------------------------------------

PRO tv_animation, slices, no_copy=no_copy
  compile_opt idl2
  DEVICE, decomposed=0
  LOADCT, 0, get_names=ct
  IF (N_ELEMENTS (slices) eq 0) THEN $
  slices = READ_BINARY (FILEPATH ('examples/data/head.dat'), data_dims=[80,100,57])
  tlb = WIDGET_BASE (/column)
  dim = SIZE (slices, /dim)
  draw = WIDGET_DRAW (tlb,xsize=dim[0],ysize=dim[1])
  list = WIDGET_DROPLIST (tlb, value=ct, event_pro='ct_event')
  slider = WIDGET_SLIDER (tlb, min=5, max=50, value=30, $
			       event_pro='speed_event')	; frames per second
  WIDGET_CONTROL, tlb, /realize
  WIDGET_CONTROL, draw, get_value=win
  WIDGET_CONTROL, tlb, set_uvalue= $
                       {slices:ptr_new(slices,no_copy=no_copy), n:ptr_new(0), $
			time:systime(1), win:win, dim:dim, fps:ptr_new(30)}
  WIDGET_CONTROL, tlb, timer=0.1
  XMANAGER, 'tv_animation', tlb, /no_block, cleanup='tv_animation_cleanup'
END

; ------------------------------------------------------------------------------

