function getspartan,fn,c,nocon=nocon

;+
; Gets the data associated with the mneumonic.
;
;	Author: G. Ucker
;	Date:	15 Nov 1993
;
; MODIFICATIONS:
;	Add directory location for SP201-05  6-Nov-98 GLC
;	Change directory location for SP201-5	30 Nov 1998 ALS
;-

;fmtloc = '/home/ig_proj/Spartan/programs/'
fmtloc = '/home/stanger/idl/lib/spartan/'

dat=0.0
c=0.0

on_ioerror, NOT_FOUND

if n_params(0) eq 0 then begin
	if 0 then begin
		NOT_FOUND:
		print,' '
		print,'	GETSPARTAN: File not found, please try again... '
		print,' '
	endif
	fn = ' '
	read,'Enter file mneumonic (no extension): ',fn
endif

fn = strupcase(strtrim(fn,2))
spyr = strmid(fn,1,2)

case spyr of
	'93': dloc = '/riker/e/spartan/sp201-1/dbase/'
	'94': dloc = '/riker/e/spartan/sp201-2/dbase/'
	'95': dloc = '/riker/e/spartan/sp201-3/dbase/'
	'97': dloc = '/riker/e/spartan/sp201-4/dbase/'
	'98': dloc = '/riker/e/spartan/sp201-5/dbase/'

	else: begin
		print,'Not finding the database... exiting...'
		return,-1L
		end
endcase

fmt_defs = [fmtloc+'sptmfmt'+spyr+'.lis',fmtloc+'spimfmt'+spyr+'.lis', $
	fmtloc+'spmsfmt'+spyr+'.lis']

spgetfmt,fmt_defs,fmt

get_lun,lun
openr,lun,dloc+fn+'.dat'

on_ioerror,NULL

st = fstat(lun)
it = where(fmt(*).spyr eq strmid(fn,0,3))
i = it(0)

if i ge 0 then begin
	jt = where(fmt(i).iname eq strmid(fn,4,100))
	j = jt(0)
endif else begin
	print,'	GETSPARTAN: spartan_yr not found... exiting...'
	return,dat
endelse

if j ge 0 then begin
case fmt(i).ilen(j) of

	1:	begin
		a=assoc(lun,bytarr(st.size))
		dat = a(0)
		c = fmt(i).conv(*,j)
		end

	2:	begin
		a=assoc(lun,intarr(st.size/fmt(i).ilen(j)))
		dat=a(0)
		c = fmt(i).conv(*,j)
		if not(keyword_set(nocon)) then $
			dat = float(dat)*c(0)/c(1) + c(2)
		end

	4:	begin
		a=assoc(lun,lonarr(st.size/fmt(i).ilen(j)))
		dat=a(0)
		c = fmt(i).conv(*,j)
		if not(keyword_set(nocon)) then $
			dat = double(dat)*c(0)/c(1) + c(2)
		end

	else:	begin
		a=assoc(lun,bytarr(st.size))
		dat=a(0)
		c = fmt(i).conv(*,j)
		end

endcase

endif else begin
	print,'	GETSPARTAN: Item mneumonic not found in fmt, exiting...'
	return,dat
endelse

close,lun
free_lun,lun

return,dat
end
