pro sp5eng

; Generate plots of Engineering data for sp201-05
; Data directory: /riker/d/spartan/sp201-5/dbase
; Date:  9 Nov 1998

m = getspartan ('T98_MET')
m = m/3600.0

;--- Print MET start/stop times.

sizmet = size (m)
print, 'size(MET): ', size (m)
metmin = m [0]
metmax = m [sizmet [1] - 1]
print, 'MET min/max: ', metmin, metmax

set_plot, 'ps'

!fancy = 2
!p.title = 'SP201-05 WLC,  3-5 Nov 1998'
!x.title = 'MET, hours'

!y.title = 'ORBIT NUMBER'
a = getspartan ('T98_ORB')
device, filename = 'orbno.ps'
plot, m, a, yrange = [0, 30], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'LISS COMMON SUN PRESENCE, ADU'
a = getspartan ('T98_CSP')
device, filename = 'csp.ps'
plot, m, a, yrange = [0, 2500], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'PITCH TRIG RATE, arcmin/sec'
a = getspartan ('T98_TRG')
device, filename = 'trg1.ps'
plot, m, a, yrange = [-10, 10], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'PITCH TRIG RATE, arcmin/sec'
device, filename = 'trg2.ps'
plot, m, a, yrange = [-10, 10], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'FINE MODE II, ADU'
a = getspartan ('T98_FMII')
device, filename = 'fm2.ps'
plot, m, a, yrange = [0, 2500], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'LISS 2 (WLC) FLAG'
a = getspartan ('T98_LWLC')
device, filename = 'lwlc.ps'
plot, m, a, yrange = [0, 300], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'WLC CALIBRATION FLAG'
a = getspartan ('T98_WLCCAL')
device, filename = 'wlccal.ps'
plot, m, a, yrange = [0, 300], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'UVCS RASTER FLAG'
a = getspartan ('T98_UVRAST')
device, filename = 'uvrast.ps'
plot, m, a, yrange = [0, 300], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'Yaw Fine Position, arcsec'
a = getspartan ('T98_YFP')
device, filename = 'yaw_plot.ps'
plot, m, a, yrange = [-100, 100], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'Roll Fine Position, arcsec'
a = getspartan ('T98_RFP')
device, filename = 'roll_plot.ps'
plot, m, a, yrange = [-100, 100], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'PES YAW, Volts'
a = getspartan ('T98_PESY')
device, filename = 'pes_yaw.ps'
plot, m, a, yrange = [3.0, 3.1], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'PES PITCH, Volts'
a = getspartan ('T98_PESP')
device, filename = 'pes_pitch.ps'
plot, m, a, yrange = [3.0, 3.1], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = '6V BATTERY FOR CCD COOLING & TED FET VOLTAGE'
b = getspartan ('T98_CCD_BAT')
c = getspartan ('T98_TED_V')
device, filename = 'ccd-ted_volt.ps'
plot, m, b, yrange = [1, 9], ysty = 1, xrange = [0, 45], xsty = 1
oplot, m, c
device, /close

!y.title = 'Voltage across TED'
a = b-c
device, filename = 'ted_volt.ps'
plot, m, a, yrange = [-1, 7], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = '28V BATTERY'
a = getspartan ('T98_V28')
device, filename = 'v28.ps'
plot, m, a, yrange = [25, 30], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'CCD ELECTRONICS VOLTAGES, +/-15 & +5'
a = getspartan ('T98_CCD_5')
b = getspartan ('T98_CCD_M15')
b = -1.*b
c = getspartan ('T98_CCD_P15')
device, filename = 'voltages_ccd.ps'
plot, m, a, yrange = [-20, 20], ysty = 1, xrange = [0, 45], xsty = 1
oplot, m, b
oplot, m, c
device, /close

!y.title = 'COMPUTER +5V'
a = getspartan ('T98_V5')
device, filename = 'voltages_comp.ps'
plot, m, a, yrange = [5.0, 5.1], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'TED TEMPERATURES, C'
a = getspartan ('T98_TED')
b = getspartan ('T98_DET')
device, filename = 'ted_temp.ps'
plot, m, a, yrange = [-20, 40], ysty = 1, xrange = [0, 45], xsty = 1
oplot, m, b
device, /close

!y.title = 'CORRECTED SPAR FRONT BULKHEAD TEMP, C'
a = getspartan ('T98_FBLK')
a = a + 2.
device, filename = 'corrected_fblk.ps'
plot, m, a, yrange = [10, 30], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'CORRECTED SPAR FILTER WHEEL TEMP, C'
a = getspartan ('T98_FIL')
a = a - 9.
device, filename = 'corrected_fil.ps'
plot, m, a, yrange = [0, 40], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'CORRECTED SPAR O1 TEMP, C'
a = getspartan ('T98_O1')
a = a - 6.
device, filename = 'corrected_o1.ps'
plot, m, a, yrange = [0, 40], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'CCD ELECTRONICS PKG TEMP, C'
a = getspartan ('T98_ELC')
device, filename = 'elc.ps'
plot, m, a, yrange = [0, 40], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = 'ELECTRONICS PKG 2 TEMP, C'
a = getspartan ('T98_EP2')
device, filename = 'ep2.ps'
plot, m, a, yrange = [0, 40], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = '68000 TEMP, C'
a = getspartan ('T98_K68')
device, filename = 'k68.ps'
plot, m, a, yrange = [0, 40], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

!y.title = '5 VOLT POWER SUPPLY TEMP, C'
a = getspartan ('T98_P5V')
device, filename = 'p5v.ps'
plot, m, a, yrange = [0, 50], ysty = 1, xrange = [0, 45], xsty = 1
device, /close

set_plot, 'x'
end
