pro sp5img

; Generate plots of Engineering data for sp201-05.
; Data Directory: /riker/d/spartan/sp201-5/dbase
; Date:  9 Nov 1998

m = getspartan('I98_MET')
m = m/3600.

;--- Print MET start/stop times.

sizmet = size (m)
print, 'size(MET): ', size (m)
metmin = m [0]
metmax = m [sizmet [1] - 1]
print, 'MET min/max: ', metmin, metmax

set_plot, 'ps'

!fancy = 2
!p.title = 'SP201-05 WLC,  1 Nov 1998'
!x.title = 'MET, hours'

!y.title = 'ORBIT NUMBER'
a = getspartan('I98_ORB')
device, filename = 'iorbno.ps'
plot, m, a, yrange = [0, 30], ysty = 1, xrange = [0, 1], xsty = 1
device, /close

!y.title = 'IMAGE NUMBER'
a = getspartan('I98_IMG')
device, filename = 'img.ps'
plot, m, a, yrange = [0, 50], ysty = 1, xrange = [0, 1], xsty = 1
device, /close

!y.title = 'PES YAW MEAN, Volts'
a = getspartan('I98_PYMEAN')
device, filename = 'pymean.ps'
plot, m, a, yrange = [0, 5], ysty = 1, xrange = [0, 1], xsty = 1
device, /close

!y.title = 'PES PITCH MEAN, Volts'
a = getspartan('I98_PPMEAN')
device, filename = 'ppmean.ps'
plot, m, a, yrange = [0, 5], ysty = 1, xrange = [0, 1], xsty = 1
device, /close

!y.title = 'Folding Mirror Position (PIA1A)'
a = getspartan('I98_PIA1AR10')
b = ((a or 'fe'xb) - 'fe'xb)
device, filename = 'fmbit.ps'
plot, m, b, yrange = [-1, 2], ysty = 1, xrange = [0, 1], xsty = 1
device, /close

!y.title = 'Heat Dump Shutter Position (PIA1A)'
c = ((a or 'fd'xb) - 'fd'xb) * 0.5
device, filename = 'hdsbit.ps'
plot, m, c, yrange = [-1, 2], ysty = 1, xrange = [0, 1], xsty = 1
device, /close

set_plot, 'x'
end
