pro sts95tp
; Looksee at Spartan 201-05 Telemetry Frame Data
; Working directory: puck:/local/pcnfs/Spartan/programs
; Data Directory: puck:/local/pcnfs/tmp/Spartan/sp201-5/dbase
; Date: 6-NOV-98

m=getspartan('T98_MET')
m=m/3600.

set_plot,'ps'

!fancy=2
!p.title='SP201-05 WLC, November 1-3, 1998'
!x.title='MET, hours'

!y.title='ORBIT NUMBER'
a=getspartan('T98_ORB')
device,filename='orbno.ps'
plot,m,a,yrange=[0,30],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='LISS COMMON SUN PRESENCE, ADU'
a=getspartan('T98_CSP')
device,filename='csp.ps'
plot,m,a,yrange=[0,2500],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='PITCH TRIG RATE, arcmin/sec'
a=getspartan('T98_TRG')
device,filename='trg1.ps'
plot,m,a,yrange=[-30,30],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='PITCH TRIG RATE, arcmin/sec'
device,filename='trg2.ps'
plot,m,a,yrange=[-2,2],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='FINE MODE II, ADU'
a=getspartan('T98_FMII')
device,filename='fm2.ps'
plot,m,a,yrange=[0,2500],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='LISS 2 (WLC) FLAG'
a=getspartan('T98_LWLC')
device,filename='lwlc.ps'
plot,m,a,yrange=[0,300],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='WLC CALIBRATION FLAG'
a=getspartan('T98_WLCCAL')
device,filename='wlccal.ps'
plot,m,a,yrange=[0,300],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='UVCS RASTER FLAG'
a=getspartan('T98_UVRAST')
device,filename='uvrast.ps'
plot,m,a,yrange=[0,300],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='Yaw Fine Position, arcsec'
a=getspartan('T98_YFP')
device,filename='yaw_plot.ps'
plot,m,a,yrange=[-100,100],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='Roll Fine Position, arcsec'
a=getspartan('T98_RFP')
device,filename='roll_plot.ps'
plot,m,a,yrange=[-100,100],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='PES YAW, Volts'
a=getspartan('T98_PESY')
device,filename='pes_yaw.ps'
plot,m,a,yrange=[0,5],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='PES PITCH, Volts'
a=getspartan('T98_PESP')
device,filename='pes_pitch.ps'
plot,m,a,yrange=[0,5],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='6V BATTERY FOR CCD COOLING & TED FET VOLTAGE'
b=getspartan('T98_CCD_BAT')
c=getspartan('T98_TED_V')
device,filename='ccd-ted_volt.ps'
plot,m,b,yrange=[0,10],ysty=1,xrange=[0,45],xsty=1
oplot,m,c
device,/close

!y.title='Voltage across TED'
a=b-c
device,filename='ted_volt.ps'
plot,m,a,yrange=[0,8],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='28V BATTERY'
a=getspartan('T98_V28')
device,filename='v28.ps'
plot,m,a,yrange=[0,35],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='CCD ELECTRONICS VOLTAGES, +/-15 & +5'
a=getspartan('T98_CCD_5')
b=getspartan('T98_CCD_M15')
b=-1.*b
c=getspartan('T98_CCD_P15')
device,filename='voltages_ccd.ps'
plot,m,a,yrange=[-20,20],ysty=1,xrange=[0,45],xsty=1
oplot,m,b
oplot,m,c
device,/close

!y.title='COMPUTER +5V, +12V'
a=getspartan('T98_V5')
b=getspartan('T98_V12')
device,filename='voltages_comp.ps'
plot,m,a,yrange=[0,15],ysty=1,xrange=[0,45],xsty=1
oplot,m,b
device,/close

!y.title='TED TEMPERATURES, C'
a=getspartan('T98_TED')
b=getspartan('T98_DET')
device,filename='ted_temp.ps'
plot,m,a,yrange=[-45,25],ysty=1,xrange=[0,45],xsty=1
oplot,m,b
device,/close

!y.title='CORRECTED SPAR FRONT BULKHEAD TEMP, C'
a=getspartan('T98_FBLK')
a=a + 2.
device,filename='corrected_fblk.ps'
plot,m,a,yrange=[0,20],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='CORRECTED SPAR FILTER WHEEL TEMP, C'
a=getspartan('T98_FIL')
a=a - 9.
device,filename='corrected_fil.ps'
plot,m,a,yrange=[0,40],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='CORRECTED SPAR O1 TEMP, C'
a=getspartan('T98_O1')
a=a - 6.
device,filename='corrected_o1.ps'
plot,m,a,yrange=[0,40],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='CCD ELECTRONICS PKG TEMP, C'
a=getspartan('T98_ELC')
device,filename='elc.ps'
plot,m,a,yrange=[0,40],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='ELECTRONICS PKG 2 TEMP, C'
a=getspartan('T98_EP2')
device,filename='ep2.ps'
plot,m,a,yrange=[0,40],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='68000 TEMP, C'
a=getspartan('T98_K68')
device,filename='k68.ps'
plot,m,a,yrange=[0,40],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='5 VOLT POWER SUPPLY TEMP, C'
a=getspartan('T98_P5V')
device,filename='p5V.ps'
plot,m,a,yrange=[0,50],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='LISS1 YFP MEAN'
a=getspartan('T98_LISS1_YFP')
device,filename='liss1_yfp.ps'
plot,m,a,yrange=[-100,100],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='LISS1 RFP MEAN'
a=getspartan('T98_LISS1_RFP') 
device,filename='liss1_rfp.ps' 
plot,m,a,yrange=[-100,100],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='LISS1 on LISS2 YFP MEAN'
a=getspartan('T98_LISS2_YFP')
device,filename='liss2_yfp.ps'
plot,m,a,yrange=[-100,100],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='LISS1 on LISS2 RFP MEAN'
a=getspartan('T98_LISS2_RFP') 
device,filename='liss2_rfp.ps' 
plot,m,a,yrange=[-100,100],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='TEXAS - YAW OFFSET'
a=getspartan('T98_YAW_OFF') 
device,filename='yaw_off.ps' 
plot,m,a,yrange=[-60,60],ysty=1,xrange=[0,45],xsty=1
device,/close

!y.title='TEXAS - ROLL OFFSET'
a=getspartan('T98_ROLL_OFF') 
device,filename='roll_off.ps' 
plot,m,a,yrange=[-60,60],ysty=1,xrange=[0,45],xsty=1
device,/close

;use mask to extract bit 5 from PIA0A
!y.title='TEXAS TX_START BIT (PIA0A)'
a=getspartan('T98_PIA0AR')
b=((a or 'df'xb) - 'df'xb)
device,filename='tx_start.ps'
plot,m,b,yrange=[-1,2],ysty=1,xrange=[0,45],xsty=1
device,/close

;use mask to extract bit 6 from PIA0A
!y.title='TEXAS TX_DONE BIT (PIA0A)'
c=((a or 'bf'xb) - 'bf'xb)
device,filename='tx_done.ps' 
plot,m,c,yrange=[-1,2],ysty=1,xrange=[0,45],xsty=1
device,/close

;use mask to extract bit 7 from PIA0A
!y.title='PIA EOM BIT (PIA0A)'
d=((a or 'ef'xb) - 'ef'xb)
device,filename='pia_eom.ps' 
plot,m,c,yrange=[-1,2],ysty=1,xrange=[0,45],xsty=1
device,/close

;use mask to extract bit 6 from PIA0B
!y.title='WLC SUN PRESENCE (PIA0B)'
a=getspartan('T98_PIA0BR')
b=((a or 'bf'xb) - 'bf'xb)
device,filename='wlc_sun.ps'
plot,m,b,yrange=[-1,2],ysty=1,xrange=[0,45],xsty=1
device,/close

;use mask to extract bit 7 from PIA0B
!y.title='PES OK (PIA0B)'
c=((a or 'ef'xb) - 'ef'xb)
device,filename='pes_ok.ps' 
plot,m,c,yrange=[-1,2],ysty=1,xrange=[0,45],xsty=1
device,/close

;use mask to extract bit 6 from PIA1B
!y.title='TEXAS WLC MODE BIT (PIA1B)' 
a=getspartan('T98_PIA1BR')
b=((a or 'bf'xb) - 'bf'xb) 
device,filename='wlc_mode.ps'
plot,m,b,yrange=[-1,2],ysty=1,xrange=[0,45],xsty=1 
device,/close

set_plot,'x'
end
