PRO carr_jd, ca,lon

;Convert from Carrington Longitude and Latitude to (Julian Date -2440000)
;Modified Nov. 20 2002

carrot = 0.0D0
lonmax = 0.0D0

JD_low = 0.0D0

carrot = double(ca)
lonmax = double(lon)

if (lonmax eq 0.0D0) then begin
  lonmax = 360.0D0
  carrot = carrot + 1.0D0
endif

incl = 7.25D0

JD_DD = 0.0D0
Lo = 0.0D0

JD_orig = 0.0D0

JD_DD = carrot+(360.0D0-lonmax)/360.0D0
JD_DD = JD_DD - 1750.0D0
JD_DD = JD_DD*27.27530D0
JD_DD = JD_DD + 5871.91D0

JD_orig = JD_DD

JD_low = JD_DD + 3.0D0
JD_DD = JD_DD - 3.0D0

; for each of the dates labeling the bottom x-axis of the 1st plot.

incr = double(0.1)

for MM = long(0), 10000 do begin
   
  JD_DD = JD_DD + incr

  ;nn = JD_DD - 2451545.0
  ; 2440000 - 2451545 = 11545
  nn = JD_DD - double(11545.0)
  LL = 280.472D0 + 0.9856474D0*nn
  gg = 357.528D0 + 0.9856003D0*nn
  sun = LL + 1.915D0*sin(gg*!dpi/180.0D0) $
	+ 0.020D0*sin(2.0D0*gg*!dpi/180.0D0)

; Explains where the number 43243.25 comes from
; omega = 73.0 + 40.0/60.0+ 50.25*((JD_DD+2440000.0 - $
; 2396756.75)/365.25)/3600.0

  omega = 73.0D0 + 40.0D0/60.0D0+$
          50.25D0*((JD_DD + 43243.25D0)/365.25D0)/3600.0D0

; Explains where the number 41780.0 comes from
; ww = 360.0/25.38*(JD_DD+2440000.0 - 2398220.0)

  ww = 360.0D0/25.38D0*(JD_DD+41780.0D0)
  ww = (ww/360.0D0 - long(ww/360.0D0))*360.0D0

  Bosin = sin((sun-omega)*!dpi/180.0D0)*sin(incl*!dpi/180.0D0)
  Bocos = sqrt(1.0D0 - Bosin^2)

  Bo = atan(Bosin,Bocos)*180.0D0/!dpi

  ;print,Bo

  LoWsin = cos(incl*!dpi/180.0D0)*sin((omega-sun)*!dpi/180.0D0)/cos(Bo*!dpi/180.0D0)
  LoWcos = -cos((omega-sun)*!dpi/180.0D0)/cos(Bo*!dpi/180.0D0)
  LoW = atan(LoWsin,LoWcos)*180.0D0/!dpi

  if LoW lt 0.0D0 then LoW = LoW + 360.0D0
     Lo = LoW - ww

  if Lo lt 0.0D0 then Lo = Lo + 360.0D0

  long_diff = Lo - lonmax

  ;print,incr,JD_DD,Lo,lonmax

  if ( (long_diff lt 0.0D0) and (abs(long_diff) lt 100.0D0)) then begin 

      JD_DD = JD_DD - incr
      incr = incr/10.0D0
      if (incr lt 1.0D-6) then goto,DONE

  endif

  if ( (long_diff gt 0.0D0) and (abs(long_diff) gt 100.0D0)) then begin

      JD_DD = JD_DD - incr
      incr = incr/10.0D0
      if (incr lt 1.0D-6) then goto,DONE

  endif

endfor

DONE:

caldat,(JD_DD+2440000.0D0),mmm,ddd,yyy
;print,'------------------'
dayfr = JD_DD-long(JD_DD) + 0.5D0
if (dayfr ge 1.0D0) then dayfr = dayfr - 1.0D0

print,JD_DD,JD_DD+2440000.0D0,mmm,ddd,yyy,dayfr,format='(f14.7,1x,f14.5,1x,i2,1x,i2,1x,i4,1x,f10.3)'
print,'------------------'


end
