   pro  hgw2,  listfile,  soho=soho

   ; PROGRAM ASSUMES THAT THE IMAGES ARE ALREADY ROTATED FOR P ANGLE
   ; PROGRAM ASSUMES THAT HEADER COORDINATES ARE CORRECT, DOES NOT CHECK THEM 


   ; find if soho or not


    if not keyword_set(soho) then soho = 0

   ; find number of images in file list

  file = ' '
  newfile = ' '
  ii = 0

  openr, lun, listfile, /get_lun
    while (not eof (lun))  do begin 
      readf, lun, file
      ii = ii + 1
    endwhile                       
    num = ii
  close, lun
  free_lun, lun
    
   ; define new arrays in 0.2 degree step = 1x181

   newsize=901.
   new_image=dblarr(901,901)
   ; this is in equal steps of 0.2 degress in longitude
   ; in !D it would be findgen(901)/5. -90

   newlon= findgen(901,901)mod(901)/5. - 90

   ; this is in equal steps of 0.2 degress in latitude

   newlat= transpose(findgen(901,901)mod(901)/5. ) -90

   ; this is in equal steps in sin(latitude)
   ; in 1D would be l=(findgen(901)-450.)/450.

   l=transpose(findgen(901,901)mod(901) - 450)/450. 
   newlat=asin(l)
   newlat=newlat*!radeg
   



   ; reopen file list 

    openr, lun, listfile, /get_lun
    file= ' '


  ; read images and convert to heliographic coordinates


    FOR i = 0, num-1 do begin 

     readf, lun, file

     print, 'file: ', file

     image = readfits (file, hdu)
     if soho eq 0 then temp  = readfits (file, exten,/exten)
   
     xsize = (size(image))[1]
     ysize = (size(image))[2]

     if xsize ne ysize then print, '!!!!!!!! WARNING: IMAGE NOT SQUARE  !!!!!!!!!' 
 
 
   ; read header information

     if soho eq 1 then date_str= fxpar(hdu, 'DATE') else $
     date_str = fxpar(hdu, 'DATE-OBS')
     time_str = fxpar(hdu, 'TIME-OBS')
     date = date_str + ' ' + time_str 
     t_ave = date_str + '_' +  time_str +  '_TAI'

     year   = strmid(date_str,0,4)	   
     month  = strmid(date_str,5,2)         
     day    = strmid(date_str,8,2)         
    
     t_ave = year +'.' + month + '.' + day + '_' +  time_str +  '_TAI'

     year=float(year)   & month=float(month) & day=float(day)
    

     hour = strmid(time_str,0,2)         & hour=float(hour)
     min  = strmid(time_str,3,2)         & min=float(min)
     sec  = strmid(time_str,6,2)         & sec=float(sec)
 
     time = hour + min/60. + sec/3600.     ; time in hours

     xcen   =  fxpar (hdu, 'CRPIX1')      ; x center in pixel 
     ycen   =  fxpar (hdu, 'CRPIX2')      ; y center in pixel 
     dx     =  fxpar (hdu, 'CDELT1')      ; arcsec/pixel
     dy     =  fxpar (hdu, 'CDELT2')      ; arcsec/pixel
  
   
   ; find time of observations

     obs_time = utc2tai(anytim2utc(date))
     

   ; find solar p,b angles and radius at time of the image using pb0r 
   ; pb0r is more reliable than the values in the header for MLSO !! 

     angles = pb0r(obs_time, soho=soho)
     
     p_ang = angles(0)
     b_ang = angles(1)
   ; r0  = 1./tan(angles(2)/(60.*!radeg))
     radius_pix = angles(2)*60./dx
     
   ; compute b angle in radiants
     b0= angles(1)/!radeg

    
   
     print, ' p, b, and radius :  ' , p_ang, b_ang, radius_pix

 
     IF soho eq 0 then begin 

     coords  = fxpar (hdu, 'COORDNAM')
     sol_p  =  fxpar (hdu, 'SOLAR_P0')
     sol_b  =  fxpar (hdu, 'SOLAR_B0')

     solar_l0 = fxpar (hdu, 'SOLAR_L0')
     if solar_l0 lt 0 then solar_l0 = solar_l0 + 360.

     datamin = fxpar (hdu, 'DATAMIN')
     datamax = fxpar (hdu, 'DATAMAX')
  
 
     hour = strmid(time_str,0,2)         & hour=float(hour)
     min  = strmid(time_str,3,2)         & min=float(min)
     sec  = strmid(time_str,6,2)         & sec=float(sec)
 
     time = hour + min/60. + sec/3600.     ; time in hours

     xcen   =  fxpar (hdu, 'CRPIX1')      ; x center in pixel 
     ycen   =  fxpar (hdu, 'CRPIX2')      ; y center in pixel 
     dx     =  fxpar (hdu, 'CDELT1')      ; arcsec/pixel
     dy     =  fxpar (hdu, 'CDELT2')      ; arcsec/pixel
  
  
     ENDIF

   print, 'date: ', date
 
   ; find carrington number and longitude for central meridian 
    
     carrlong, date, cr, clong, cmp=1
    


 
   ; define coordinates for interpolartion on the disk =
   ; regular array centered at image center in unit of radius 

   
     xx = findgen(xsize,ysize)mod(xsize) - xcen   
     yy = transpose(findgen(ysize,xsize)mod(ysize) ) - ycen 

     xx = reform(temporary(xx), xsize*ysize)
     yy = reform(temporary(yy), xsize*ysize)
    
     xx = xx/radius_pix
     yy = yy/radius_pix
 
    

   ; find pixels within and outside the solar disk

     r_2D = sqrt( xx^2. + yy^2. )
     on_disk = where(r_2D lt 1.0)
   ; off_disk= where(r_2D gt 1.0)
   ; there are bad values around edge of the Sun 
     off_disk= where(r_2D gt 0.975)



   ; transform sin(latitude0 and longitude = newlat and newlon in 
   ; new x and y coord on the disk.


   ; first find 3D cartesian coordinates 
     
     newlat=newlat/!radeg
     newlon=newlon/!radeg
 

     newzz  = sin(newlat)
     newyy  = cos(newlat)*sin(newlon)
     newxx  = cos(newlat)*cos(newlon)
     
     newxx = reform(temporary(newxx), newsize*newsize)
     newyy = reform(temporary(newyy), newsize*newsize)
     newzz = reform(temporary(newzz), newsize*newsize)
  
     xyz = transpose([ [newxx], [newyy], [newzz] ])

   ; rotate for -b0 to simulate disk 
   
     rotmx = [[COS(-b0), 0.0, SIN(-b0)], [0.0, 1.0, 0.0], [-SIN(-b0), 0.0, COS(-b0)]]
     xyz = rotmx # temporary(xyz)

   ; find coordinates in 2D

      newx = xyz(1,*)
      newy = xyz(2,*)

   ; latitude in 2D is = arc_tangent of z/y 
   ; latitude= atan (xyz(2,*), xyz(1,*))
   ; radius in 2D is  
   ; rad_2d = sqrt(xyz(2,*)^2 +  xyz(1,*)^2)
      
   
   ; interpolate original image on the new coordinate grid
   ; equally spaced in latitude and longitude in 0.2 degree increments

 
 
    xx = reform(temporary(xx), xsize, ysize)
    yy = reform(temporary(yy), xsize, ysize)
   
    newx = reform(temporary(newx), newsize, newsize)
    newy = reform(temporary(newy), newsize, newsize)
     
    image(off_disk)=0


;    new_image= int2d (image, xx, yy, newx, newy)  

    ;--- Transform interpolation coordinates to pixel units.

    xslope = (MAX (xx) - MIN (xx)) / (xsize - 1)
    yslope = (MAX (yy) - MIN (yy)) / (ysize - 1)
    xint = (newx - MIN (xx)) / xslope
    yint = (newy - MIN (yy)) / yslope

    print, 'xslope/yslope: ', xslope, yslope
;    print, 'xint [*, newsize / 2]: '
;    print, xint [*, newsize / 2] 
    print, 'size (image):     ', size (image)
    print, 'size (xint):      ', size (xint)
    print, 'size (yint):      ', size (yint)

    new_image = interpolate (image, xint, yint)

    print, 'size (new_image): ', size (new_image)

  ; add keywords about carrington totations and time of observation
  ; find carrington number and longitude for central meridian 
    
    carrlong, date, cr, clong, cmp=1

  ; test carr rot 

    if year eq 2002 and month eq 4 and day ge 27 then cr = 1989

    
  
      fxaddpar, hdu, 'COORDNAM', 'HELIOCENTRIC', ' SOLAR NORTH ALIGNED WITH +Y AXIS'
      fxaddpar, hdu, 'OBS_L0',  solar_l0, ' SOLAR LONGITUDE L0' 
      fxaddpar, hdu, 'OBS_CR',  cr, ' CARRINGTON ROTATION'
      fxaddpar, hdu, 'T_REC', t_ave, 'AVERAGE TIME OF IMAGE'
      if soho eq 0 then $
      fxaddpar, hdu, 'SOLAR_L0', solar_l0, ' SOLAR L-ANGLE [DEGREES]; CARRINGTON LONGITUDE'


 
 ; write new square images in files 

   flen=strlen(file)-3
   newfile= strmid(file, 0,flen) +'hgw2.fts'

   writefits, newfile, new_image, hdu
   if soho eq 0 then writefits, newfile, temp , exten,/append


  ENDFOR

  close, lun
  free_lun, lun
  close,/all


END

