;+
; create_acos_hdr.pro
;
; PURPOSE
;	ACOS binary header structure
;-

FUNCTION create_acos_hdr

header = CREATE_STRUCT			$
{ACOSHD,				$
Version: 0L,				$
Year: 0L, Month: 0L, Day: 0L,		$
Hour: 0L, Minute: 0L, Sec: 0L,		$
Xdim: 0L, Ydim: 0L, Nsum: 0L,		$
Exposure: 0L, Gain: 0L,			$
Odisk: 0L,				$
Type: 0L,				$
Wave: 0.0,				$
Pangle: 0.0, Bangle: 0.0, Langle: 0.0,	$
RA: 0.0, Dec: 0.0,			$
Elevation: 0.0,	Azimuth: 0.0,		$
Amass: 0.0				$
Radius: 0.0				$
Xshift: fltarr (16),			$
Yshift: fltarr (16),			$
Diam: fltarr (16),			$
Pos: intarr (32),			$
Drive: intarr (32),			$
Analog: fltarr (16),			$
Lcvr: fltarr (8),			$
Mic: fltarr (6),			$
Buffer: 0L}

RETURN, header
END
