; fitscen.pro
;-------------------------------------------------------------------------------
; PURPOSE
;	Find sun center.
; SYNTAX
;	fitscen, fits_file
; INPUT
;	fits_file	name of FITS file
; AUTHOR
;	Andrew L. Stanger   HAO/NCAR   11 January 2001
;-------------------------------------------------------------------------------

PRO fitscen, fits_file

img = readfits (fits_file, hdu)

nx = fxpar (hdu, 'NAXIS1')
ny = fxpar (hdu, 'NAXIS2')

;minint = img [nx/2, ny/2] / 10.0
;thresh = minint / 2.0

minint = find_minint (img)
thresh = 20

print, 'minint: ', minint

solargeom, img, minint, thresh, cx, cy, rx, ry

print, 'cx, cy: ', cx, cy, '   rx, ry: ', rx, ry

END
