;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Document name: limb_int.pro
; Created by:    Randy Meisner, HAO/NCAR, Boulder, CO, October 1, 1998
;
; Last Modified: Thu Oct  1 13:13:28 1998 by meisner (Randy Meisner) on hoth
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
FUNCTION limb_int, im, help=help
;+
;
; PROJECT:
;       SunRISE/PSPT
;
; NAME:
;       
;
; PURPOSE:
;       
;
; CALLING SEQUENCE:
;
;       
;
; INPUTS:
;       
;
; OPTIONAL INPUTS: 
;       None.
;
; OUTPUTS:
;       None.
;
; OPTIONAL OUTPUTS:
;       None.
;
; KEYWORD PARAMETERS: 
;       /help.  Will call doc_library and list header, and return
;
; CALLS:
;       None.
;
; COMMON BLOCKS:
;       None.
;
; RESTRICTIONS: 
;       None.
;
; SIDE EFFECTS:
;       None.
;
; CATEGORY:
;       
;
; PREVIOUS HISTORY:
;       Written October 1, 1998, by Randy Meisner, HAO/NCAR, Boulder, CO
;
; MODIFICATION HISTORY:
;       
;
; VERSION:
;       Version 1, October 1, 1998
;-
;
ON_ERROR, 2

IF(N_ELEMENTS(help) GT 0) THEN BEGIN
  doc_library,'limb_int'
  RETURN, -999
ENDIF

IF(N_PARAMS() NE 1) THEN BEGIN
  PRINT, ''
  PRINT, 'Usage:  result = limb_int(im [,help=help])'
  PRINT, ''
  RETURN, -999
ENDIF

mt0 = -1. & mt1 = -1. & mt2 = -1.

sz = size(im) & nx = sz(1) & ny = sz(2)

nx2 = nx/2 & ny2 = ny/2

dx = fix(0.01*nx) & dy = fix(0.01*ny)

sim = sobel(im)/(im > 1.0)

sim(0:dx, *) = 0
sim(*, 0:dy) = 0

sim(nx-dx:nx-1, *) = 0
sim(*, ny-dy:ny-1) = 0

sim = round(sim) ge 1

row = sim(0:nx2, ny2)

idx = where(row EQ 1)

IF(idx(0) NE -1) THEN mt0 = im(idx(0)+2, ny2)


ny4 = fix(.25*ny2)

row = sim(0:nx2, ny2-ny4)

idx = where(row EQ 1)

IF(idx(0) NE -1) THEN mt1 = im(idx(0)+2, ny2-ny4)


row = sim(0:nx2, ny2+ny4)

idx = where(row EQ 1)

IF(idx(0) NE -1) THEN mt2 = im(idx(0)+2, ny2+ny4)

mt = [mt0, mt1, mt2]

print, mt

lmb = total(mt)/3

RETURN, lmb

END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; End of 'limb_int.pro'.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
