pro movie_srf2c,filenamelist,delay
;+
; NAME:
;	MOVIE_SRF2C
; PURPOSE:
;	To display the contents of a sequence of Sun rasterfiles
;       in an existing window.  
; CALLING SEQUENCE:
;	movie_srf2c,filenamelist
; INPUTS:
;       filenamelist = Scalar string giving the name of the file containing
;	sun rasterfile image names.
;	delay = # seconds delay between images.
; OUTPUTS:
;       Image is written into an existing window.
; COMMON BLOCKS:
;	None.
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
;	This procedure sets the !order system variable to 1, reads the
;       Sun Rasterfile, writes the image and colortables from the Sun
;       Rasterfile to the window.
; MODIFICATION HISTORY:
;       3 July 1990: adapted from Rose Reynolds' srf2w procedure (April 1990).
;	31 Dec 1990: adapted from Rose Reynolds' srf2c procedure (3 Jul 90).
;                    modified by Andrew L. Stanger
;-
   filename = "string"
   on_error, 2
   if n_params() ne 2 then begin
      print, "usage: movie_srf2c,filenamelist,delay"
      return
   endif
   oldorder = !order
   !order = 1
   openr, lunlst, filenamelist, /GET_LUN
   while (not EOF(lunlst)) do begin
      readf, lunlst, filename
      read_srf, filename, img, r, g, b
      imgsize = size(img)
      tv, img
      tvlct, r, g, b
      wait, delay
   end
   close, /ALL
   !order = oldorder
   return
end
