pro srf2c,filename
;+
; NAME:
;	SRF2C
; PURPOSE:
;	To display the contents of the Sun
;       rasterfile in an existing window.  
; CALLING SEQUENCE:
;	srf2c,filename
; INPUTS:
;       filename = Scalar string giving the name of the rasterfile to read.
; OUTPUTS:
;       Image is written into an existing window.
; COMMON BLOCKS:
;	None.
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
;	This procedure sets the !order system variable to 1, reads the
;       Sun Rasterfile, writes the image and colortables from the Sun
;       Rasterfile to the window.
; MODIFICATION HISTORY:
;       3 July 1990: adapted from Rose Reynolds' srf2w procedure (April 1990).
;-
   on_error,2
   if n_params() ne 1 then begin
      print,"usage: srf2c,filename"
      return
   endif
   oldorder = !order
   !order = 1
   read_srf,filename,img,r,g,b
   imgsize = size(img)
   tv,img
   tvlct,r,g,b
   !order = oldorder
   return
end
