pro srf2w,filename
;+
; NAME:
;	SRF2W
; PURPOSE:
;	To make a new window and display the contents of the Sun
;       rasterfile in that window.  
; CALLING SEQUENCE:
;	srf2w,filename
; INPUTS:
;       filename = Scalar string giving the name of the rasterfile to read.
; OUTPUTS:
;       A new window is created.
; COMMON BLOCKS:
;	None.
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
;	This procedure sets the !order system variable to 1, reads the
;       Sun Rasterfile, creates a new window with the size set to match
;       the size of the image read from the file and then writes the
;       image and colortables from the Sun Rasterfile to the window.
; MODIFICATION HISTORY:
;	April,1990, Written by Rose Reynolds, HAO.
;-
   on_error,2
   if n_params() ne 1 then begin
      print,"usage: srf2w,filename"
      return
   endif
   oldorder = !order
   !order = 1
   read_srf,filename,img,r,g,b
   imgsize = size(img)
   window,/free,xsize=imgsize(1),ysize=imgsize(2)
   tv,img
   tvlct,r,g,b
   !order = oldorder
   return
end
