pro w2srf,filename
;+
; NAME:
;	W2SRF
; PURPOSE:
;	To make a Sun rasterfile which contains exactly what is
;	in the current graphics window, including the color tables.
;	The image is read from the top to the bottom of the window.
; CALLING SEQUENCE:
;	w2srf,filename
; INPUTS:
;       filename = Scalar string giving the name of the rasterfile to write.
; OUTPUTS:
;	A Sun rasterfile is created (using write_srf) containing the
;	pixels and color tables of IDL's current graphics window.
; COMMON BLOCKS:
;	None.
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
;	This procedure sets the !order system variable to 1, reads the
;	image (using tvrd) and color tables (using tvlct,/get) from the 
;	current graphics window, writes these to a Sun rasterfile
;	named with the 'filename' parameter (using write_srf) and then
;	resets the !order system variable back to its original value.
; MODIFICATION HISTORY:
;	31 Jan,1990, Written by Rose Reynolds, HAO.
;-
   on_error,2
   if n_params() ne 1 then begin
      print,"usage: w2srf,filename"
      return
   endif
   oldorder = !order
   !order = 1
   image=tvrd(0,0,!d.x_size,!d.y_size)
   tvlct,r,g,b,/get
   write_srf,filename,image,r,g,b
   !order = oldorder
   return
end
