pro dpb

;+
; Delta pB / pB
;
; (pB[cme] - pB[bkg]) / pB[bkg]
;
; IDL procedure
; Andrew L. Stanger   HAO/NCAR   12 Sep 94
;-

; Define background and CME image arrays.

bkg = intarr (512, 512)
cme = intarr (512, 512)
fdif = fltarr (512, 512)
dpb = fltarr (512, 512)

; Read bkg and cme images into IDL arrays.

openr, 1, 'bkgs'
readu, 1, bkg
close, 1

openr, 1, 'cmes'
readu, 1, cme
close, 1

; Compute difference and fractional difference.

fdif = float (cme) - float (bkg)
dpb = dpb * 0.0

tvscl, fdif > 0.0

nx = 512
ny = 512

;for iy = 0, ny - 1 do $
;   for ix = 0, nx - 1 do $
;      if (bkg (ix, iy) NE 0.0) then $
;         dpb = fdif / bkg

dpb = fdif / float (bkg > 1)

; Find min/max intensity values.

fmin = min (dpb)
fmax = max (dpb)
print, 'fmin/fmax: ', fmin, fmax

; Scale float image into 8-bits for display.

bytimg = bytscl (dpb, min = 0, max = 4.0)

; Display image on screen.

tv, bytimg

end
