;
; Routine to plot output from Xmk4.pro
;
; These are the MkIV gain and elements of its X matrix
;
; Original by ARL, modifications by DFE
;

LOWPIX = 32
HIGHPIX = 370

psplot='n'
mysz=1.8
wait=3  ; Cursor transition down wait...

    print,'Do you want to make a postscript plot? (y or n) '
read,psplot


!x.range = 0
!y.range = 0
!x.ticklen = 1
!y.ticklen = 1

X21fit=fltarr(384)
X22fit=fltarr(384)
X23fit=fltarr(384)
X31fit=fltarr(384)
X32fit=fltarr(384)
X33fit=fltarr(384)
biasfit=fltarr(384)
X21=fltarr(384)
X22=fltarr(384)
X23=fltarr(384)
X31=fltarr(384)
X32=fltarr(384)
X33=fltarr(384)
bias=fltarr(384)
gain=fltarr(384)
close,1
filenm='gain'  &  openr,1,filenm & readu,1,gain  & close,1
filenm='bias.fit'  &  openr,1,filenm & readu,1,biasfit  & close,1
filenm='x21.fit'  &  openr,1,filenm & readu,1,x21fit  & close,1
filenm='x22.fit'  &  openr,1,filenm & readu,1,x22fit  & close,1
filenm='x23.fit'  &  openr,1,filenm & readu,1,x23fit  & close,1
filenm='x31.fit'  &  openr,1,filenm & readu,1,x31fit  & close,1
filenm='x32.fit'  &  openr,1,filenm & readu,1,x32fit  & close,1
filenm='x33.fit'  &  openr,1,filenm & readu,1,x33fit  & close,1
filenm='bias'  &  openr,1,filenm & readu,1,bias  & close,1
filenm='x21'  &  openr,1,filenm & readu,1,x21  & close,1
filenm='x22'  &  openr,1,filenm & readu,1,x22  & close,1
filenm='x23'  &  openr,1,filenm & readu,1,x23  & close,1
filenm='x31'  &  openr,1,filenm & readu,1,x31  & close,1
filenm='x32'  &  openr,1,filenm & readu,1,x32  & close,1
filenm='x33'  &  openr,1,filenm & readu,1,x33  & close,1

if (psplot eq 'y') then begin ;{
    set_plot,'ps'
    device,/landscape,/inches,xsize=10.3,ysize=8.0,$
	   xoffset=0.2,yoffset=10.5
    device,/portrait,/inches,xsize=7.5,ysize=9.0,$
	   xoffset=0.2,yoffset=0.5
    mysz=1.4
endif else begin;}{
    device,window_state=winst
    if(winst(5) eq 0)then window,5,xsize=900,ysize=700,xpos=140,ypos=200
    mysz=1.8
    wset,5
endelse ;}

!P.MULTI = [ 0, 3 , 3 ]
!p.title='Fred'

mn = -16
mx = 32

plot,[LOWPIX,HIGHPIX],[mn/200.,mx/100.],title='x21',/ynoz,xstyle=1,ystyle=1,/nodata,$
   charsize=mysz
    oplot,X21(*),thick=3,psym=3
    oplot,x21fit(*)

plot,[LOWPIX,HIGHPIX],[mn,mx],title='x22',/ynoz,xstyle=1,ystyle=1,/nodata,$
   charsize=mysz
    oplot,X22(*),thick=3,psym=3
    oplot,x22fit(*)

plot,[LOWPIX,HIGHPIX],[mn,mx],title='x23',/ynoz,xstyle=1,ystyle=1,/nodata,$
   charsize=mysz
    oplot,X23(*),thick=3,psym=3
    oplot,x23fit(*)


plot,[LOWPIX,HIGHPIX],[mn/200.,mx/400.],title='x31',/ynoz,xstyle=1,ystyle=1,/nodata,$
   charsize=mysz
    oplot,X31(*),thick=3,psym=3
    oplot,x31fit(*)

plot,[LOWPIX,HIGHPIX],[mn,mx],title='x32',/ynoz,xstyle=1,ystyle=1,/nodata,$
   charsize=mysz
    oplot,X32(*),thick=3,psym=3
    oplot,x32fit(*)

plot,[LOWPIX,HIGHPIX],[mn,mx],title='x33',/ynoz,xstyle=1,ystyle=1,/nodata,$
   charsize=mysz
    oplot,X33(*),thick=3,psym=3
    oplot,x33fit(*)

mn=min(gain(LOWPIX:HIGHPIX))
mx=max(gain(LOWPIX:HIGHPIX))
plot,[LOWPIX,HIGHPIX],[mn,mx],title='gain',/ynoz,xstyle=1,ystyle=1,/nodata,$
   charsize=mysz
    oplot,gain(*),thick=3,psym=3

mn=min(bias(50:HIGHPIX))
mx=max(bias(50:HIGHPIX))
plot,[LOWPIX,HIGHPIX],[mn,mx],title='bias',/ynoz,xstyle=1,ystyle=1,/nodata,$
   charsize=mysz
    oplot,bias(*),thick=3,psym=3
    oplot,biasfit(*)

!P.MULTI = [ 0, 1 , 1 ]

if(psplot eq 'y')then begin;{
    device,/close
    spawn,'lp -d haow idl.ps'
    set_plot,'x'
    psplot='n'
endif;}


end
