;
;  seeGBU4.pro
;  This program shows raw mk4 i,q,u,st,sk,and ba files.
;    Modified by Tony Darnell from seeGBU.pro written by Alice Lecinski.
;

close,13
close,1

;--- These arrays were taken from Alice's seemk4.pro code

headib=0 & headib=lonarr(16) ;contains date/time, xdim and ydim 
headf =0 & headf =fltarr(24) ;contains ephemeris info, pangle, etc.
headie=0 & headie=lonarr(16) ;contains image type (iqu,st,ba) and related info
head =0 & head =bytarr(1024)  ;looks like a spacer to get readu to right spot

xsz=1160 & ysz=1100
scale=0.75
new_xsz=xsz*scale
new_ysz=ysz*scale
mywin=0
pltwin=1
ifilenm=' '
qfilenm=' '
ufilenm=' '
skfilenm=' '
stfilenm=' '
bafilenm=' '
clist='mylist'
top=LONG(0)
fpos=LONARR(5000) & ftmp=LONG(0) & i=0
ofpos=lonarr(300) & oftmp=long(0)   &   ofp=0

SPAWN,'pwd',path
path=path[0]
yrddoy = strmid(path,strlen(path)-6,6)
ofilenm=strcompress(yrddoy+'.gbu',/remove_all)
print,'The Good Bad Ugly list file is: ',ofilenm
print,''

; Open a window
device,window_state=winst
if(winst(mywin) eq 0)then begin ;{
    window,mywin,xsize=xsz*scale,ysize=ysz*scale;,xpos=50,ypos=270
    ; Load color table
    dome=0
    if (dome) then begin ;{
        loadct,3
    endif;}
endif

IF(winst(pltwin) EQ 0) THEN BEGIN
    !P.MULTI=[0,1,3]
    window,pltwin,ysize=ysz*scale,xpos=0,ypos=450
ENDIF


close,13 & openr,13,clist
close,23 & openw,23,ofilenm

WHILE (NOT EOF(13)) DO BEGIN
  point_lun,-13,ftmp  & fpos(i)=ftmp
  readf,13,ifilenm
  qfilenm=STRMID(ifilenm,0,STRLEN(ifilenm)-1)+'q'
  ufilenm=STRMID(ifilenm,0,STRLEN(ifilenm)-1)+'u'
  skfilenm=STRMID(ifilenm,0,STRLEN(ifilenm)-1)+'sk'
  stfilenm=STRMID(ifilenm,0,STRLEN(ifilenm)-1)+'st'
  bafilenm=STRMID(ifilenm,0,STRLEN(ifilenm)-1)+'ba'

  ;--- Load in i image
  close,1 & openr,1,ifilenm & point_lun,-1,top & readu,1,headib
                                                readu,1,headf
                                                readu,1,headie
                             point_lun, 1,top & readu,1,head
  ixsz=headib(9)
  iysz=headib(10)
  ihr=headib(3)
  imn=headib(4)

  new_xsz=ixsz*scale  ;For use in resizing the images
  new_ysz=iysz*scale

  iimg=0 & iimg=INTARR(ixsz,iysz)
  ixcen=ixsz/2 & iycen=iysz/2
  readu,1,iimg & close,1

  ;--- Load in q image
  close,1 & openr,1,qfilenm & point_lun,-1,top & readu,1,headib
                                                readu,1,headf
                                                readu,1,headie
                             point_lun, 1,top & readu,1,head
  qxsz=headib(9)
  qysz=headib(10)
  qhr=headib(3)
  qmn=headib(4)

  qimg=0 & qimg=INTARR(qxsz,qysz)
  qxcen=qxsz/2 & qycen=qysz/2
  readu,1,qimg & close,1

  ;--- Load in u image
  close,1 & openr,1,ufilenm & point_lun,-1,top & readu,1,headib
                                                readu,1,headf
                                                readu,1,headie
                             point_lun, 1,top & readu,1,head
  uxsz=headib(9)
  uysz=headib(10)
  uhr=headib(3)
  umn=headib(4)

  uimg=0 & uimg=INTARR(uxsz,uysz)
  uxcen=uxsz/2 & uycen=uysz/2
  readu,1,uimg & close,1

  ;--- Load in sk image
  close,1 & openr,1,skfilenm & point_lun,-1,top & readu,1,headib
                                                readu,1,headf
                                                readu,1,headie
                             point_lun, 1,top & readu,1,head
  kxsz=headib(9)
  kysz=headib(10)
  khr=headib(3)
  kmn=headib(4)

  kimg=0 & kimg=INTARR(kxsz,kysz)
  kxcen=kxsz/2 & kycen=kysz/2
  readu,1,kimg & close,1

  ;--- Load in st image
  close,1 & openr,1,stfilenm & point_lun,-1,top & readu,1,headib
                                                readu,1,headf
                                                readu,1,headie
                             point_lun, 1,top & readu,1,head
  txsz=headib(9)
  tysz=headib(10)
  thr=headib(3)
  tmn=headib(4)

  timg=0 & timg=INTARR(kxsz,kysz)
  txcen=txsz/2 & tycen=tysz/2
  readu,1,timg & close,1

  ;--- Load in ba image
  close,1 & openr,1,bafilenm & point_lun,-1,top & readu,1,headib
                                                readu,1,headf
                                                readu,1,headie
                             point_lun, 1,top & readu,1,head
  bxsz=headib(9)
  bysz=headib(10)
  bhr=headib(3)
  bmn=headib(4)

  bimg=0 & bimg=INTARR(kxsz,kysz)
  bxcen=bxsz/2 & bycen=bysz/2
  readu,1,bimg & close,1

  wset,mywin

    mni = min(iimg(ixcen-50:ixcen+50,iycen-200:iycen+200))
    mxi = max(iimg(ixcen-50:ixcen+50,iycen-200:iycen+200))
    mnq = min(qimg(qxcen-50:qxcen+50,qycen-200:qycen+200))
    mxq = max(qimg(qxcen-50:qxcen+50,qycen-200:qycen+200))
    mnu = min(uimg(uxcen-50:uxcen+50,uycen-200:uycen+200))
    mxu = max(uimg(uxcen-50:uxcen+50,uycen-200:uycen+200))
    mnq=-171 & mxq = 700
    mnu=-171 & mxu = 700
    mni=0 & mxi = 900

    ;  Resize the images.  I realize REBIN is faster but I wanted more
    ;  flexibility.   Besides, this will be run on a Sun Ultra workstation.
    smlimg=CONGRID(iimg,new_xsz,new_ysz)
    smlqimg=CONGRID(qimg,new_xsz,new_ysz)
    smluimg=CONGRID(uimg,new_xsz,new_ysz)
    erase,0
    TV,BYTSCL(smlimg,MIN=mni, MAX=mxi)
    TV,BYTSCL(smlqimg,MIN=mnq, MAX=mxq),new_xsz,0
    TV,BYTSCL(smluimg,MIN=mnu, MAX=mxu),new_xsz*2,0

    xyouts,50,new_ysz+2,ifilenm,size=2,/DEVICE
    xyouts,new_xsz+50,new_ysz+2,qfilenm,size=2,/DEVICE
    xyouts,(new_xsz*2)+50,new_ysz+2,ufilenm,size=2,/DEVICE
    print,ifilenm
    print,qfilenm
    print,ufilenm

    wset,pltwin
    plot,kimg(0,*),title=skfilenm,charsize=2.
    plot,timg(0,*),title=stfilenm,charsize=2.
    plot,bimg(0,*),title=bafilenm,charsize=2.

    wset,mywin
   print,'Click mouse in window 0  for Good, bkwds, or (Calibration/Bad/Ugly)'
  ;logic to move forwards or backwards in the list of images.
    wait=3
    cursor,x,y,wait,/NORMAL
    IF ( !ERR eq 2 ) THEN BEGIN ;{
        i=i-1  & if (i le 0) THEN i=0
        point_lun,13,fpos(i)
        ofp=ofp-1  & if (ofp le 0) then ofp=0
        point_lun,23,ofpos(ofp)
        print,'Is supposed to be:',ofpos(ofp)
    endif else begin ;}{
        i=i+1
	ofp=ofp+1
	quality=    'Good                  '
	IF (!ERR EQ 4) THEN BEGIN
	  quality=  '    Bad               '
	  print,'	Click mouse in window for Calibration, Bad, or Ugly'
	  CURSOR,x,y,wait,/NORMAL
	  IF (!ERR EQ 1) THEN BEGIN
	    quality='Good       CALIBRATION'
	  ENDIF
	  IF (!ERR EQ 4) THEN BEGIN
	    quality='       Ugly           '
	  ENDIF
	ENDIF

	print,'		',ifilenm,' is ',quality
	print,' '
	printf,23,qfilenm,' ',quality
	flush,23
    endelse ;}

ENDWHILE

CLOSE,13
CLOSE,23
END
