;
;
;
;  Smooth MkIV X matrix and bias elements
;

NUMPIX = 384
NUMAZ = 720

MINFIT = 50
MAXFIT = 320

x21 = fltarr(NUMPIX)
x22 = fltarr(NUMPIX)
x23 = fltarr(NUMPIX)
x31 = fltarr(NUMPIX)
x32 = fltarr(NUMPIX)
x33 = fltarr(NUMPIX)
bias= fltarr(NUMPIX)
gain= fltarr(NUMPIX,NUMAZ)

close,1 & openr,1,'x21' & readu,1,x21 
close,1 & openr,1,'x22' & readu,1,x22 
close,1 & openr,1,'x23' & readu,1,x23 
close,1 & openr,1,'x31' & readu,1,x31 
close,1 & openr,1,'x32' & readu,1,x32 
close,1 & openr,1,'x33' & readu,1,x33 
close,1 & openr,1,'bias'& readu,1,bias
close,1 & openr,1,'gain'& readu,1,gain

a = where ( abs(x21) gt .1 )
if ( a(0) ne -1 ) then x21(a) = 0

a = where ( abs(x22) gt 100 )
if ( a(0) ne -1 ) then x22(a) = 0

a = where ( abs(x23) gt 100 )
if ( a(0) ne -1 ) then x23(a) = 0

a = where ( abs(x31) gt .1 )
if ( a(0) ne -1 ) then x31(a) = 0

a = where ( abs(x32) gt 100 )
if ( a(0) ne -1 ) then x32(a) = 0

a = where ( abs(x33) gt 100 )
if ( a(0) ne -1 ) then x33(a) = 0

a = where ( abs(bias) gt 1000 )
if ( a(0) ne -1 ) then bias(a) = 0

x21fit = smooth(x21,29,/NAN,/EDGE_TRUNCATE)
a = where ( abs(x21-x21fit) > .01 )
if ( a(0) ne -1 ) then x21(a)=x21fit(a)
x21fit = smooth(x21,29,/NAN,/EDGE_TRUNCATE)

x22fit = smooth(x22,29,/NAN,/EDGE_TRUNCATE)
a = where ( abs(x22-x22fit) > 3 )
if ( a(0) ne -1 ) then x22(a)=x22fit(a)
x22fit = smooth(x22,29,/NAN,/EDGE_TRUNCATE)

x23fit = smooth(x23,29,/NAN,/EDGE_TRUNCATE)
a = where ( abs(x23-x23fit) > 3 )
if ( a(0) ne -1 ) then x23(a)=x23fit(a)
x23fit = smooth(x23,29,/NAN,/EDGE_TRUNCATE)

x31fit = smooth(x31,29,/NAN,/EDGE_TRUNCATE)
a = where ( abs(x31-x31fit) > .01 )
if ( a(0) ne -1 ) then x31(a)=x31fit(a)
x31fit = smooth(x31,29,/NAN,/EDGE_TRUNCATE)

x32fit = smooth(x32,29,/NAN,/EDGE_TRUNCATE)
a = where ( abs(x32-x32fit) > 3 )
if ( a(0) ne -1 ) then x32(a)=x32fit(a)
x32fit = smooth(x32,29,/NAN,/EDGE_TRUNCATE)

x33fit = smooth(x33,29,/NAN,/EDGE_TRUNCATE)
a = where ( abs(x33-x33fit) > 3 )
if ( a(0) ne -1 ) then x33(a)=x33fit(a)
x33fit = smooth(x33,29,/NAN,/EDGE_TRUNCATE)

biasfit = smooth(bias,29,/NAN,/EDGE_TRUNCATE)
a = where ( abs(bias-biasfit) > 10 )
if ( a(0) ne -1 ) then bias(a)=biasfit(a)
biasfit = smooth(bias,29,/NAN,/EDGE_TRUNCATE)

gainfit=gain
for ii=0,NUMPIX-1 do begin
	gainfit(ii,*) = smooth(gain(ii,*),29,/NAN,/EDGE_TRUNCATE)
endfor
a = where ( abs(gain-gainfit) > 100 )
if ( a(0) ne -1 ) then gain(a)=gainfit(a)
for ii=0,NUMPIX-1 do begin
	gainfit(ii,*) = smooth(gain(ii,*),29,/NAN,/EDGE_TRUNCATE)
endfor

close,1 & openw,1,'x21.fit' & writeu,1,x21 
close,1 & openw,1,'x22.fit' & writeu,1,x22 
close,1 & openw,1,'x23.fit' & writeu,1,x23 
close,1 & openw,1,'x31.fit' & writeu,1,x31 
close,1 & openw,1,'x32.fit' & writeu,1,x32 
close,1 & openw,1,'x33.fit' & writeu,1,x33 
close,1 & openw,1,'bias.fit'& writeu,1,bias
close,1 & openw,1,'gain.fit'& writeu,1,gain

end

