pro input,img1,q,img2,u

dir='/mo0/data/ftobs/sample/'
file='fb920414.a20'
;file='fb920406.g4'	; limb
nkrget,dir+file+'.q',hq,q,img_no=1
nkrget,dir+file+'.q',h1,img1,img_no=2
nkrget,dir+file+'.u',hu,u,img_no=1
nkrget,dir+file+'.u',h2,img2,img_no=2

end



;********************************************************************
;NAME       : coalign (procedure)
;FUNCTION   : coalign an image with another one
;						K.I. '92/04/25
;====================================================================

;input,img1,q,img2,u
s=size(img1)
nx=s(1)	&	ny=s(2)

; ------- find reference spot in img's ----------
wx=256	&	wy=256	; area for serching spot 
dd=30	; distance for taking 2-nd derivative
xs=nx/2-wx/2	&	xe=xs+wx-1
ys=ny/2-wy/2	&	ye=ys+wy-1
img=img1(xs:xe,ys:ye)/2
deriv = shift(img,dd,0)+shift(img,-dd,0)-2*img	$
	+shift(img,0,dd)+shift(img,0,-dd)-2*img
max1=max(deriv(dd:wx-dd-1,dd:wy-dd-1),ii)
yp1=ii/(wx-2*dd)+dd
xp1=ii-(yp1-dd)*(wx-2*dd)+dd
img=img2(xs:xe,ys:ye)/2
deriv = shift(img,dd,0)+shift(img,-dd,0)-2*img	$
	+shift(img,0,dd)+shift(img,0,-dd)-2*img
max2=max(deriv(dd:wx-dd-1,dd:wy-dd-1),ii)
yp2=ii/(wx-2*dd)+dd
xp2=ii-(yp2-dd)*(wx-2*dd)+dd

; ------- get gravitational center of the spot ---------
wxf=32	&	wyf=32	; area for calculating FFT 
xsf1=xs+xp1-wxf/2
ysf1=ys+yp1-wyf/2
part1=float(img1(xsf1:xsf1+wxf-1,ysf1:ysf1+wyf-1))
cx1=rebin(part1,wxf,1)
gx1=total((max(cx1)-cx1)*lindgen(wxf))/total((max(cx1)-cx1))
cy1=transpose(rebin(part1,1,wyf))
gy1=total((max(cy1)-cy1)*lindgen(wyf))/total((max(cy1)-cy1))

xsf2=xs+xp2-wxf/2
ysf2=ys+yp2-wyf/2
part2=float(img2(xsf2:xsf2+wxf-1,ysf2:ysf2+wyf-1))
cx2=rebin(part2,wxf,1)
gx2=total((max(cx2)-cx2)*lindgen(wxf))/total((max(cx2)-cx2))
cy2=transpose(rebin(part2,1,wyf))
gy2=total((max(cy2)-cy2)*lindgen(wyf))/total((max(cy2)-cy2))

dx=xp1-xp2+gx1-gx2
dy=yp1-yp2+gy1-gy2
print,'dx,dy=',dx,dy
img=shift(img2,dx,dy)

end
