;********************************************************************
;NAME       : fdisp (main)
;FUNCTION   : display flare telescope data
;						K.I. '92/04/04
;====================================================================
; filename is assumed to be as follow
;   F1 data:    'f1***.v,q,u' or 'fb***.v,q,u'
;   F4 data:    'f4***.v,q,u 'or 'fv***.v,q,u'

ver=1
dir0='/data2/ftobs'
;dir0='/mo0/data/ftobs/sample'
sample_dir='/data/ftobs/sample/'
;sample_dir='/mo0/data/ftobs/sample/'
catalog_dir='/solar/flare/'
dir=''
print,forma='("enter directory (default=",A," <ret>) ",$)',dir0
read,dir
if dir eq '' then dir=dir0
if (dir ne '') and (strmid(dir,strlen(dir)-1,1) ne '/') then dir=dir+'/'
cd,dir
dir=''
window,0
mode=1	; 0-magcont, 1-magtv1, 2-magtv2 
menu_mode=0	; 0-only filename,  1-use datalog

lsstr=''
fnam0=''
while 1 do begin
	case mode of
	   0:	ret=['<red-blue>','<spot+cont>','<printout>']
	   1:	ret=['<contour>','<spot+cont>']
	   2:	ret=['<contour>','<red-blue>']
	endcase
	if fnam0 ne '' then ret=[ret,'[catalog]']
	ret=[ret,'[menu-mode]','[exit]']
	if menu_mode eq 0 then $
		fnam=ftlsmenu(dir,ret=ret,op='-tr',lsstr=lsstr)
	if menu_mode eq 1 then $
		fnam=ftlsmenu(dir,ret=ret,datalog=date)
	print,fnam

	;  ---------  exit  ------------
	if fnam eq '[exit]' then stop

	;  ---------  menu  ------------
	if fnam eq '[menu-mode]' then begin
		case menu_mode of
		   0:	begin
			date=strmid(dir,strlen(dir)-7,6)
			m_mode=1
			end
		   1:	begin
			m_mode=0
			end
		endcase
		menu_mode=m_mode
	endif

	;  ---------  F1 data  ---------
	if strmid(fnam,0,2) eq 'f1' or strmid(fnam,0,2) eq 'fb' then begin
		f1data,fnam,h,img,q,u,v,dir=dir,ver=ver
		wset,0
		case mode of
		   0:	magcont,img,q,u,v,h=h
		   1:	magtv1,img,q,u,v,h=h
		   2:	magtv2,img,q,u,v,h=h
		endcase
		fnam0=fnam
	endif

	;  ---------  F4 data  ---------
	if strmid(fnam,0,2) eq 'f4' or strmid(fnam,0,2) eq 'fv' then begin
		f4data,fnam,h,img,s,v,dir=dir
		wset,0
		veltv1,img,s,h=h
		fnam0=fnam
	endif

	;  ---------  sample  ----------
	if fnam eq '[sample]' then begin
	    ; save 'f1' and 'f4' data to sample_dir
	    ; with a filename of fbyymmdd.a##.p   (f1)
	    ;                 or fvyymmdd.a##.p   (f4) 
	    kind=strmid(fnam0,0,2)
	    if (kind eq 'f1') or (kind eq 'f4') then begin
	    	if dir eq '' then begin
		    print,'unable to sample the data'
		    cd,'..'
		endif
		yymmdd=strmid(dir,strlen(dir)-7,6)
		seq=strmid(fnam0,2,strlen(fnam0)-2)
		case kind of
		    'f1': outfnam=sample_dir+'fb'+yymmdd+'.'+seq
		    'f4': outfnam=sample_dir+'fv'+yymmdd+'.'+seq
		    endcase
	    endif else begin
		outfnam=sample_dir+fnam0
	    endelse
	    print,'save "',fnam0,'" to "',outfnam,'.p"'
	    if (kind eq 'f1') or (kind eq 'fb') then begin
	    	nkrsave,outfnam+'.p',h(0),img,/nocheck
	    	nkrsave,outfnam+'.p',h(1),q,/append
	   	nkrsave,outfnam+'.p',h(2),u,/append
	    	nkrsave,outfnam+'.p',h(3),v,/append
	    endif
	    if (kind eq 'f4') or (kind eq 'fv') then begin
	    	nkrsave,outfnam+'.p',h(0),img,/nocheck
	    	nkrsave,outfnam+'.p',h(1),s,/append
	   	nkrsave,outfnam+'.p',h(2),v,/append
	    endif
	endif

	;  ---------  catalog  ----------
	if fnam eq '[catalog]' then begin
	    ; save 'f1' and 'f4' data to catalog_dir
	    ; with a filename of fbyymmdd.hhmm.p   (f1)
	    ;                 or fvyymmdd.hhmm.p   (f4) 
	    kind=strmid(fnam0,0,2)
	    if (kind eq 'f1') or (kind eq 'f4') then begin
	    	if dir eq '' then begin
		    print,'unable to sample the data'
		    cd,'..'
		endif
		yymmdd=strmid(dir,strlen(dir)-7,6)
		seq=strmid(fnam0,2,strlen(fnam0)-2)
		case kind of

 'f1': begin
			  samplename=sample_dir+'fb'+yymmdd+'.'+seq+'.p'
	    		  print,'save "',fnam0,'" to "',samplename,'"'
	    		  nkrsave,samplename,h(0),img,/nocheck
	    		  nkrsave,samplename,h(1),q,/append
	   	  	  nkrsave,samplename,h(2),u,/append
	    		  nkrsave,samplename,h(3),v,/append
			  end
		    'f4': begin
			  samplename=sample_dir+'fv'+yymmdd+'.'+seq
	    		  print,'save "',fnam0,'" to "',samplename,'.p"'
	    		  nkrsave,samplename,h(0),img,/nocheck
	    		  nkrsave,samplename,h(1),s,/append
	   		  nkrsave,samplename,h(2),v,/append
			  end
		    endcase
	    endif else begin
		samplename=sample_dir+fnam0
	    endelse
	    catalog,samplename
	endif

	;  ---------  change display mode  ----------
	if fnam eq '<contour>' then begin
		magcont,img,q,u,v,h=h
		mode=0
	endif
	if fnam eq '<red-blue>' then begin
		magtv1,img,q,u,v,h=h
		mode=1
	endif
	if fnam eq '<spot+cont>' then begin
		magtv2,img,q,u,v,h=h
		mode=2
	endif
	if fnam eq '<printout>' then begin
		magcont,img,q,u,v,h=h,/printout
	endif

endwhile

end
