;**************************************************************************
; NAME       : fdispm (main)
; PURPOSE    : display multi images of T1
; CALLING SEQUENCE :
;	.run fdispm
; INPUTS :
;     none
; KEYWORD PARAMETERS :
;     none
; OUTPUTS :
;     none
; SIDE EFFECTS : 
; 
; MODIFICATION HISTORY :
;	K.Ichimoto, 1992/10
;==========================================================================
;
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bin=2		; binning factor
pause='y'
;--------------------  files  -------------------------------
dir='/data2/ftobs/921123/'
;dir='/solar/flare/'
fnam='f1a'
spawn,'pwd',olddir	&	olddir=olddir(0)
cd,dir
spawn,'ls -tr  '+fnam+'*',files
cd,olddir
;for i=0,10 do files=[files,nextfile(files(i),next=1)]
;files=['fb920904.0133','fb920905.0421','fb920906.0054','fb920906.0739',	$
;	'fb920907.0216']
fact=1
;+++++++++++++++++++++++++++++++++++++++++++++++++++++

; --------------- open window ---------------- 
wx0=1 	;x-origin of basic window
wy0=120 ;y-origin of basic window
wx=800 ;x-width of basic window
wy=600	;y-width of basic window
dx=5	;x-interval bitween images
dy=40	;y-interval bitween images
title='fdispm:'

;fullwindow
wx=!d.x_size
wy=!d.y_size
erase

nn=n_elements(files)
print,nn,' files will be displayed'

nkrgeth,dir+files(0),h
nx=fix(fact*h(0).nx)	&	ny=fix(fact*h(0).ny)
kx=wx/(nx+dx)
ky=wy/(ny+dy)
print,kx,'*',ky,' images displayed'

ans=''
for i=0, nn-1 do begin
	f1data,files(i),h,img,bx,by,bl,dir=dir
	x0 = dx + (nx+dx) * ( i-i/kx*kx ) 
	y0 = wy-(ny+dy) - (ny+dy) * ( i/kx - (i/kx)/ky*ky )
	magtv1,img,bx,by,bl,h=h,x0=x0,y0=y0,/notitle,mag=fact
	;bt=sqrt(float(bx)^2+float(by)^2)		; for Bt display
	;magtv1,img,alog(bt+1000),h=h,x0=x0,y0=y0,/notitle,/bw,/nocont,mag=fact	
	;xyouts,x0+10,y0+10,files(i),/dev,charsize=1
	date=h(0).date1	&	time=h(0).time1
	;jst2ut,date,time
	xyouts,x0,y0+ny+5,date+'  '+strmid(time,0,8),/dev,charsize=2,color=230
	if(i+1-(i+1)/(kx*ky)*(kx*ky) eq 0) and (pause eq 'y') then begin
		ret=''
		read,'pause;  hit <RET> to continue (e <RET> to escape) : ',ret
		if( ret eq 'e' ) then goto,endl
		erase
	endif
endfor

endl:
end
