;**************************************************************************
; NAME       : ftcal (main)
; PURPOSE    : magnetic field calibration of T1
; CALLING SEQUENCE :
;	.run ftcalib
; INPUTS :
;     none
; KEYWORD PARAMETERS :
;     none
; OUTPUTS :
;     none
; SIDE EFFECTS : 
;	new file is created which containes the calibrated data img,Bl,Bx,By
; 
; MODIFICATION HISTORY :
;	K.Ichimoto, 1992/10
;==========================================================================
;

pix1=pix_size('ft1')	; arc sec. for 1 pixel
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;scatter=0	; scattered light level
;kdpfact=1.05	; correction factor for KDP error from 1/4
;dwl=-80		; wavelength position (mA)
bin=2		; binning factor
;dir='/solar/flare/'
dir=''
;rawfiles=['fb920521.0009.p']
spawn,'ls /solar/flare/fb9211*.p',rawfiles
outfiles=rawfiles
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

nn=n_elements(rawfiles)
print,nn,' files will be calibrated'

ans=''
for i=0,nn-1 do begin
	f1calibf,rawfiles(i),dir=dir,bin=bin,/ver
	read,'Will you delete '+rawfiles(i)+' ? (y/n(ret)) : ',ans
	if ans eq 'y' then spawn,'rm '+rawfiles(i)
endfor

end
