;********************************************************************
;NAME       : ftdatalog (procedure)
;FUNCTION   : create datalog file for Flare Telescope
;DATE       : 1992/09/20
;PROGRAMMER : k.i.
;MODIFICATION HISTORY :
;	K.Ichimoto, 92/10/25   include f1*.p, f4*.p
;====================================================================
pro ftdatalog,date
; sel : file selection wild card
; op  : option of ls command  (for ex. -tr   -- time sequence)

dir='/data2/ftobs/'+date
spawn,'pwd',dir_old	&	dir_old=dir_old(0)
cd,dir
outfile='/data/ftobs/datalog/'+date+'.log'
ff=findfile(outfile,count=count)
if count ne 0 then begin
	ans=''
	read,outfile+' exist. Will you make again ? (y<ret>/n) : ',ans
	if ans eq 'n' then return
endif

print,'creating datalog file => ',outfile
openw,1,outfile

com='/usr/bin/ls -F -tr f1*.p f1*.v ff1*.v'
spawn,com,files
nn=n_elements(files)
for i=0,nn-1 do begin
	nkrgeth,dir+'/'+files(i),h,nkr=nkr
	file1=strmid(files(i),0,strpos(files(i),'.'))+'        '
	printf,1,format='(A7,A9,A18,I6)',	$
		file1,strmid(h.time1,0,8),	$
		str_gpos(h.g_x,h.g_y),h.l0
endfor
com='/usr/bin/ls -F -tr f4*.p f4*.v  ff4*.v'
spawn,com,files
nn=n_elements(files)
for i=0,nn-1 do begin
	nkrgeth,dir+'/'+files(i),h,nkr=nkr
	file1=strmid(files(i),0,strpos(files(i),'.'))+'        '
	printf,1,format='(A7,A9,A18,I6)',	$
		file1,strmid(h.time1,0,8),	$
		str_gpos(h.g_x,h.g_y),h.l0
endfor

close,1

cd,dir_old

end
