;********************************************************************
;NAME       : ftgetas (procedure)
;FUNCTION   : get sum and subtraction images from F.T. raw file
;						K.I. '91/10/31
;====================================================================
pro ftgetas,file,h,add,sbt,dark=dark,flat=flat	

;input:
;   file : input (raw) file
;   dark : dark file name 
;   flat : flat file name 
;output:
;   h	: header structure
;   add	: summension of 2-images
;   sbt : subtraction of  "

nkrget,file,h1,a1,img_no=1
nkrget,file,h2,a2,img_no=2
if ( h1.nx ne h2.nx ) or $
   ( h1.ny ne h2.ny ) or $
   ( h1.nbyt ne h2.nbyt) or $
   ( h1.integ ne h2.integ ) then begin
	print,'data type not compatible between img1 & img2'
	stop
endif
h=h1

if keyword_set(dark) and (h2.correct eq 1) then begin
	nkrget,dark,hd,drk,img_no=1
	drk0=fix(drk*float(h.integ)/float(hd.integ))
	if h1.correct eq 1 then a1=a1-drk0
	a2=a2-drk0
endif

if keyword_set(flat) then begin
	nkrget,flat,hf,flt1,img_no=1
	nkrget,flat,hf,flt2,img_no=2
	if hf.correct eq 1 then begin
		if not keyword_set(dark) then begin
			print,'flat needs dark data !!'
			return
		endif
		drk0=fix(drk*float(hf.integ)/float(hd.integ))
		flt1=flt1-drk0
		flt2=flt2-drk0
	endif
	fact1=total(flt1)/float(hf.nx)/float(hf.ny)
	fact2=total(flt2)/float(hf.nx)/float(hf.ny)
	fact=(fact1+fact2)/2.
	a1=fix(float(a1)/float(flt1>1)*fact1)
	a2=fix(float(a2)/float(flt2>1)*fact2)
endif

add=fix( (long(a1)+long(a2))/2 )
sbt=a1-a2

end
