;********************************************************************
;NAME       : ftlsmenu (function)
;FUNCTION   : select a file in a directory with mouse menu 
;DATE       : 1991/09/30, 1992/04/04, '92/09/20
;PROGRAMMER : k.i.
;********************************************************************
function ftlsmenu,dir,select=sel,option=op,return=ret,init=init,x=x,y=y, $
	lsstr=lsstr,datalog=datalog
; sel : file selection wild card
; op  : option of ls command 
; ret : include return selection which return '.'
; init: initial position of selection
; x,y : position of menue on screen
; ex. file=lsmenu(dir,sel='*.hed',op=' -tr',/ret)
; datalog : if exist, use /data/ftobs/datalog/yymmdd.log file

; display directories and files whose name are
;      f1*.v, f4*.v, fb*.v, fv*.v
loglist=0

if keyword_set(lsstr) then goto,menubeg
if keyword_set(datalog) then begin
	lsstr='fnam   time     EW   NS   l0'
	line=''
	openr,1,'/data/ftobs/datalog/'+datalog+'.log'
	while(not eof(1)) do begin
		readf,1,line
		if strmid(line,0,2) eq 'f1' or strmid(line,0,3) eq 'ff1' then $
			lsstr=[lsstr,line+'  ']
	endwhile
	close,1
	loglist=1
	goto,menubeg
endif
start:
dir1=''
if(strmid(dir,strlen(dir)-1,1) eq '/') then dir1=strmid(dir,0,strlen(dir)-1) $
else dir1=dir
lsstr=[dir1,'..']
com='/usr/bin/ls -F '
if keyword_set(op) then com=com+op+' '
com=com+dir1

if keyword_set(sel) then begin
	if  dir eq ''  then com=com+sel	$
	else com=com+'/'+sel
endif

rep:
if n_elements(com) eq 2 then com1=com(0) else com1=com	; for multi sel
spawn,com1,files
nn=n_elements(files)
if (nn eq 1) and (files(0) eq '') then  return,''

if keyword_set(sel) and dir ne '' then begin	; remove directory string
	ld=strlen(dir1)
	for i=0,nn-1 do begin
		files(i)=strmid(files(i),ld+1,strlen(files(i))-ld-1)
	endfor
endif
;if(nn eq 1) then return,files(0)	; find only 1 file

for i=0,nn-1 do begin
	if strmid(files(i),strlen(files(i))-1,1) eq '/' then begin
		lsstr=[lsstr,files(i)]
	endif else if strmid(files(i),strlen(files(i))-1,1) eq '@' then  begin
		lsstr=[lsstr,strmid(files(i),0,strlen(files(i))-1)+'/']
	endif
endfor
for i=0,nn-1 do begin
		fhed=strmid(files(i),0,2)
		if (fhed eq 'f1') or (fhed eq 'fb') then begin
		    fext=strmid(files(i),strlen(files(i))-2,2)
		    if fext eq '.v' then $
		        lsstr=[lsstr,strmid(files(i),0,strlen(files(i))-2)] $
		    ;if fext eq '.p' then $
		    else   lsstr=[lsstr,files(i)]
		endif
endfor
for i=0,nn-1 do begin
		fhed=strmid(files(i),0,2)
		if (fhed eq 'f4') or (fhed eq 'fv') then begin
		    fext=strmid(files(i),strlen(files(i))-2,2)
		    if fext eq '.s' then $
		        lsstr=[lsstr,strmid(files(i),0,strlen(files(i))-2)] $
		    ;if fext eq '.p' then $
		    else    lsstr=[lsstr,files(i)]
		endif
endfor

if n_elements(com) eq 2 then begin
	com=com(1)
	goto,rep
endif

menubeg:
if keyword_set(ret) then menustr=[lsstr,ret] else menustr=lsstr

nn=n_elements(menustr)

; -----------------------  display menu  ------------------------
ii=n_elements(init)
ix=n_elements(x)
iy=n_elements(y)
if (ii eq 1)  then begin		; initial selection is given
	if( ix eq 1 ) then begin	; x position is given
		if( iy eq 1 ) then k=wmenu(menustr,title=0,init=init,x=x,y=y) $
		else		   k=wmenu(menustr,title=0,init=init,x=x)
	endif else begin		; x position is default
		if( iy eq 1 ) then k=wmenu(menustr,title=0,init=init,y=y) $
		else		   k=wmenu(menustr,title=0,init=init)
	endelse
	init=k
endif else begin
	if( ix eq 1 ) then begin
		if( iy eq 1 ) then k=wmenu(menustr,title=0,x=x,y=y) $
		else		   k=wmenu(menustr,title=0,x=x)
	endif else begin
		if( iy eq 1 ) then k=wmenu(menustr,title=0,y=y) $
		else		   k=wmenu(menustr,title=0)
	endelse
endelse

;if(k gt nn) then retstr=ret(k-nn-1) else retstr=files(k-1)
if(k gt nn) then k=nn
retstr=menustr(k)
if (loglist eq 1) and (strpos(retstr,' ') ne -1) then 	$
		retstr=strmid(retstr,0,strpos(retstr,' '))
lastch=strmid(retstr,strlen(retstr)-1,1)
case lastch of
    '/': begin			; change to sub directory
	if(dir1 eq '') then dir=dir1+retstr	$
	else  dir=dir1+'/'+retstr
	goto,start
	end
    '*': begin
	retstr=strmid(retstr,0,strlen(retstr)-1)
	end
    else:
endcase
if retstr eq '..' then begin	; change to upper directory
	if dir1 eq '' then begin
		cd,'..'
	endif else begin
		pp=strpos(dir1,'/',0)
		pp1=pp
		while pp ne -1  do begin
			pp1=pp
			pp=strpos(dir1,'/',pp+1)
		end
		if pp1 eq -1 then  dir='' else dir=strmid(dir1,0,pp1)
	endelse
	goto,start
endif

return,retstr
end
