;+
;
;NAME       : ftql (pro)
; PURPOSE :
;	quick look of flare tel. mini images
; CATEGORY :
;	idl/lib/flare
; CALLING SEQUENCE :
;	.run ftql
; INPUTS :
;	data    : data(*,*,*)
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
; OUTPUTS :
;	none
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	none
; RESTRICTIONS :	none
; PROCEDURE :
;	The newest directory in /data2/ftobs is the target.
;	If data ('yymmdd') is previously defined, then use this.
; MODIFICATION HISTORY :
;	K.I. '93/01/29	; 
;-
;----------------------------------------------------------------------

dir0='/data2/ftobs/'

; -------------  obtain 'date' and filenames  ---------------
;if n_elements(date) eq 0 or strmid(date,0,1) ne '9' then begin
if n_elements(date) eq 0 then date=gt_newdate(dir=dir0)
title1=''
if n_elements(title) eq 0 then begin
	title1=date 
endif else begin
	;if title ne date then title1=date
	title1=date
endelse
if title1 ne '' then title=title1
dir=dir0+date+'/minisave/'
spawn,'pwd',olddir
cd,dir
spawn,'ls -tr f1*.p',file1
spawn,'ls -tr f4*.p',file4
cd,olddir(0)
nn1=n_elements(file1)
nn4=n_elements(file4)
print,'date: ',date
print,'# of T1 data = ',fix(nn1),'       # of T4 data',fix(nn4)

fullwindow,1,title=title1
mode=1	; mode   1-multi dispaly, 	0-movie
menutitle='ftql option (mode: multi)'
step=1
rdagain=0

LOOP:
case mode of
    0: begin
	menutitle='ftql: mode=[MOVIE]  step='+string(step,form="(i2)")+''
	window,0,xsize=150,ysize=150
	wset,0	& wshow
	conti=1
	end
    1: begin
	menutitle='ftql: (mode=[MULTI]  step='+string(step,form="(i2)")+')'
	wset,1	& wshow
	conti=0
	end
endcase
menustr=[menutitle,	$
	'T1 image',	$
	'T1 V',		$
	'T1 magtv1',	$
	'T4 image',	$
	'T4 Dop',	$
	'T4 V',		$
	'total V-signal',	$
	'change mode',	$
	'change step',	$
	'read again',	$
	'exit']
sel=wmenu(menustr,title=0)

case  menustr(sel) of
    'T1 image': begin
	loadct,0
	if n_elements(img) eq 0 or rdagain eq 1 then begin
	    mtv,dir+file1,info=file1,/get,image=img,h=hi,order=1,conti=conti, $
		step=step
	    print,'T1 images and header are saved in "img" & "hi"'
	    rdagain=0
	endif else begin
	    mtv,img,info=strmid(hi.time1,0,8),order=1,conti=conti,step=step
	endelse
	end
    'T1 V': begin
	if n_elements(v) eq 0 or rdagain eq 1 then begin
	    mtv,dir+file1,info=file1,img_no=4,/get,image=v,h=hv,order=1, $
		conti=conti,scale=4,step=step
	    print,'T1 V and header are saved in "v" & "hv"'
	    rdagain=0
	endif else begin
	    mtv,v,info=strmid(hv.time1,0,8),order=1,conti=conti,scale=4, $
		step=step
	endelse
	end
    'T1 magtv1': begin
	print,'cannot show movie !!'
	wset,1
	magtv1m,dir+file1,info=file1
	end
    'T4 image': begin
	loadct,0
	if n_elements(img4) eq 0 or rdagain eq 1 then begin
	    mtv,dir+file4,info=file4,/get,image=img4,h=hi4,order=1,	$
		conti=conti,step=step
	    print,'T4 images and header are saved in "img4" & "hi4"'
	    rdagain=0
	endif else begin
	    mtv,img4,info=strmid(hi4.time1,0,8),order=1,conti=conti,step=step
	endelse
	end
    'T4 V': begin
	loadct,0
	if n_elements(v4) eq 0 or rdagain eq 1 then begin
	    mtv,dir+file4,info=file4,img_no=3,/get,image=v4,h=hv4,order=1, $
		conti=conti,step=step
	    print,'T4 V and header are saved in "v4" & "hv4"'
	    rdagain=0
	endif else begin
	    mtv,v4,info=strmid(hv4.time1,0,8),order=1,conti=conti,step=step
	endelse
	end
    'T4 Dop': begin
	loadct,0
	if n_elements(s) eq 0 or rdagain eq 1 then begin
	    mtv,dir+file4,info=file4,img_no=2,/get,image=s,h=hs,order=1, $
		conti=conti,step=step
	    print,'T4 Dop. and header are saved in "s" & "hs"'
	    rdagain=0
	endif else begin
	    mtv,s,info=strmid(hs.time1,0,8),order=1,conti=conti,step=step
	endelse
	end
    'change mode': begin
	oldm=mode
	if oldm eq 0 then mode=1 else mode=0
	end
    'change step': begin
	stpstr=['current step:'+string(step),'1','2','4','8','16']
	step=fix(stpstr(wmenu(stpstr,title=0)))
	end
    'read again': begin
	rdagain=1
	cd,dir
	spawn,'ls -tr f1*.p',file1
	spawn,'ls -tr f4*.p',file4
	cd,olddir(0)
	nn1=n_elements(file1)
	nn4=n_elements(file4)
	print,'# of T1 data = ',fix(nn1),'       # of T4 data',fix(nn4)
	end
    'exit': begin
	stop
	end

endcase
goto,LOOP

end
