;=======================================================================
;NAME       : newtral (pro)
; PURPOSE :
;	obtain newtral line position
; CATEGORY :
;	idl/lib/flare
; CALLING SEQUENCE :
;	newtral,bl,x,y
; INPUTS :
;	bl    : longitudinal field map
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
; OUTPUTS :
;	x,y	: position array
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	none
; RESTRICTIONS :	none
; PROCEDURE :
; MODIFICATION HISTORY :
;	K.I. '93/01/10	
;----------------------------------------------------------------------
pro newtral,bl,x,y,dummy=dummy

bl0=150		;  critical value to identify "zero-Bl" region
grad0=300.	;             "               "strong-grad." region

s=size(bl)
nx=s(1)	&	ny=s(2)
bs=smooth(bl,5)
grad_b= float(bs-shift(bs,1,0))^2 + float(bl-shift(bs,0,1))^2
grad_b(0,*)=0.	&	grad_b(nx-1,*)=0.
grad_b(*,0)=0.	&	grad_b(*,ny-1)=0.
nl=where(abs(bs) lt bl0 and grad_b gt grad0^2, count)
if count eq 0 then begin
	print,'No newtral line was detected!!'
	x=-1
	return
endif
nl=nl+nx+1
y=nl/nx
x=nl-y*nx

;---------- for test ----------
zero=where(abs(bs) lt bl0)
lgrad=where(grad_b gt grad0^2)
dummy=intarr(nx,ny)
dummy(nl)=10000

;return
end
