;+
; NAME       : quvcal (procedure)
; PURPOSE    : calibration of QUV cross-talk for T1
; CALLING SEQUENCE :
;	quvcal,q,u,v
; INPUTS :
;     q,u,v     -- pol. degree *10000 (q,u,v already devided by img)
; KEYWORD PARAMETERS :
; OUTPUTS :
; 
; MODIFICATION HISTORY :
;	K.Ichimoto, 1993/02/07
;-
;==========================================================================
;pro quvcal,q,u,v,calmat=calmat

if n_elements(calmat) lt 9 then begin
	calfile='/data/ftobs/calib/quvcal.930203'
	nkrget,calfile,hcal,calmat
endif
s=size(calmat)	&	nxm=s(1)	&	nym=s(2)
s=size(q)	&	nx=s(1) 	&	ny=s(2)
if nx ne nxm or ny ne nym then calmat=rebin(calmat,nx,ny,9)
if 0 then begin
	qq=calmat(*,*,0) & qu=calmat(*,*,1) & qv=calmat(*,*,2)
	uq=calmat(*,*,3) & uu=calmat(*,*,4) & uv=calmat(*,*,5)
	vq=calmat(*,*,6) & vu=calmat(*,*,7) & vv=calmat(*,*,8)
endif

qc = fix( calmat(*,*,0)*q + calmat(*,*,1)*u + calmat(*,*,2)*v )
uc = fix( calmat(*,*,3)*q + calmat(*,*,4)*u + calmat(*,*,5)*v )
vc = fix( calmat(*,*,6)*q + calmat(*,*,7)*u + calmat(*,*,8)*v )

end
