;+
;
; NAME       : circle (procedure)
; PURPOSE    :
;	draw circle
; CATEGORY :
;	idl/lib/nkr
; CALLING SEQUENCE :
;  	circle,ox,oy,r,nn=nn,angle=angle,linestyle=linestyle
; INPUTS :
; 	ox, oy   -- center position
;	r	 -- radius
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
; 	nn       -- No. of points
;	angle    -- angle array for arc (degree)
;	linestyle 
; OUTPUTS :
;	none
; COMMON BLOCKS : 	none
; SIDE EFFECTS :
;	if /ver is set, fitting curve is displayed
; RESTRICTIONS :	none
; PROCEDURE :
; MODIFICATION HISTORY :
;	K.I. 1993/01/22	
;-

pro circle,ox,oy,r,nn=nn,angle=angle,linestyle=linestyle

if not keyword_set(linestyle) then linestyle=0

if n_elements(angle) le 0 then begin
	if not keyword_set(nn) then nn=360
	i=indgen(nn+1)
	th=2*!pi/nn * i
endif else begin
	th=2*!pi/360. * angle
endelse
x=ox+r*cos(th)
y=oy+r*sin(th)
plot,x,y,/noerase,pos=[0,0,!d.x_size-1,!d.y_size-1],/dev,	$
	xstyle=1+4,xrange=[0.,!d.x_size-1],	$
	ystyle=1+4,yrange=[0.,!d.y_size-1],linestyle=linestyle
end

