;+
;
;NAME       : fullwindow (pro)
; PURPOSE :
;	open a full screen window
; CATEGORY :
;	idl/lib/nkr
; CALLING SEQUENCE :
;	fullwindow,[wno],title=title,wsize=wsize
; INPUTS :
;
; OPTIONAL INPUT PARAMETERS : 
;	wno   -- window no.
;		 if wno=999, return screen size in wsize
; KEYWORD PARAMETERS :
;	title	: title of new window 
; OUTPUTS :
;	none
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	
;	window 0 is destroyed if it exist.
; RESTRICTIONS :	none
; PROCEDURE :
; MODIFICATION HISTORY :
;	K.I. '93/01/31	; new
;	K.I. '93/04/29	; wsize
;-
pro fullwindow,wno,title=title,wsize=wsize

if n_params() eq 0 then wno=!d.window
if wno eq -1 then wno=0
if not keyword_set(title) then title='IDL'+string(fix(wno))

if wno ne 999 then begin
	wx0=1 	;x-origin of basic window
	wy0=80 ;y-origin of basic window
	window,0,xsize=17,ysize=56
	device,get_window_pos=pw
	if wno ne 0 then wdelete,0
	wx=pw(0)	&	wy=pw(1)
	window,wno,xpos=wx0,ypos=wy0,xsize=wx,ysize=wy,title=title
endif else begin
	window,124,xsize=10,ysize=10
	device,get_window_pos=wsize
	wdelete,124
endelse

end
