;+
;
; NAME       : hswab (procedure)
; PURPOSE :
;	convert integer of nkrhead h  PC98 <-> SUN
; CATEGORY :
;	idl/lib/nkr
; CALLING SEQUENCE :
;	hswab,h
; INPUTS :
;	h    : norikura type header structure
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
; OUTPUTS :
;	none
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	none
; RESTRICTIONS :	none
; PROCEDURE :
; MODIFICATION HISTORY :
;	K.I. '91/07/17
;-
;====================================================================
pro hswab,h

	one=h.one
	offset=h.offset
	nset=h.nset
	nbyt=h.nbyt
	data_type=h.data_type 
	nx=h.nx
	ny=h.ny
	nf=h.nf
	icam=h.icam
	obs_mode=h.obs_mode
	seqno=h.seqno
	exp=h.exp
	integ=h.integ
	integ1=h.integ1
	correct=h.correct
	pix_x1=h.pix_x1
	pix_y1=h.pix_y1
	d_parm=h.d_parm
	hangle=h.hangle
	delta=h.delta
	l0=h.l0
	g_on=h.g_on
	g_balx=h.g_balx
	g_baly=h.g_baly
	g_x=h.g_x
	g_y=h.g_y
	t_parm=h.t_parm
	fs_parm=h.fs_parm

	byteorder,one,offset,nset,nbyt,data_type,nx,ny,nf
	byteorder,icam,obs_mode
	byteorder,seqno,exp,integ,integ1,correct
	byteorder,pix_x1,pix_y1
	byteorder,d_parm
	byteorder,hangle,delta
	byteorder,l0,g_on,g_balx,g_baly,g_x,g_y
	byteorder,t_parm,fs_parm
	hangle=ishft(hangle,16)+ishft(hangle,-16)
	delta=ishft(delta,16)+ishft(delta,-16)

	h.one=one
	h.offset=offset
	h.nset=nset
	h.nbyt=nbyt
	h.data_type=data_type
	h.nx=nx
	h.ny=ny
	h.nf=nf
	h.icam=icam
	h.obs_mode=obs_mode
	h.seqno=seqno
	h.exp=exp
	h.integ=integ
	h.integ1=integ1
	h.correct=correct
	h.pix_x1=pix_x1
	h.pix_y1=pix_y1
	h.d_parm=d_parm
	h.hangle=hangle
	h.delta=delta
	h.l0=l0
	h.g_on=g_on
	h.g_balx=g_balx
	h.g_baly=g_baly
	h.g_x=g_x
	h.g_y=g_y
	h.t_parm=t_parm
	h.fs_parm=fs_parm
end
