;********************************************************************
;NAME       : lct_rb (pro)
;FUNCTION   ; set color table for red-blue display, white back
;====================================================================
pro lct_rb,icmin=icmin,icmax=icmax
;	icmin,icmat --  min. and max. position of color table

if n_elements(icmin) eq 0 then	icmin=1
if n_elements(icmax) eq 0 then	icmax=!d.table_size-3
ctlength=icmax-icmin+1
middle=(icmax-icmin)/2
base=255.
ctprof=alog10(indgen(middle)+1)
;ctprof=sqrt(indgen(middle)+1)-1
blue=	[replicate(base,ctlength-middle),base-base/ctprof(middle-1)*ctprof]
red=	replicate(base,ctlength)
green=	replicate(base,ctlength)
for i=0,middle-1 do begin
	red(i)=blue(ctlength-1-i)
	green(i)=red(i)
	green(ctlength-1-i)=blue(ctlength-1-i)
endfor
ctside_w=middle/2-30
ctside_max=150
for i=0,ctside_w do begin
;	blue(i)			= base-ctside_max*(ctside_w-i)/ctside_w
;	red(ctlength-i-1)	= base-ctside_max*(ctside_w-i)/ctside_w
;	green(i)		= green(ctside_w-1)+	$
;					100*(ctside_w-i)/ctside_w
;	green(ctlength-i-1)	= green(ctlength-ctside_w) +	$
;					100*(ctside_w-i)/ctside_w
endfor
tvlct,red,green,blue,icmin

end

;********************************************************************
;NAME       : lct_rbr (pro)
;FUNCTION   ; set color table for red-blue display, dark back
;====================================================================
pro lct_rbr,icmin=icmin,icmax=icmax
;	icmin,icmat --  min. and max. position of color table

if n_elements(icmin) eq 0 then	icmin=1
if n_elements(icmax) eq 0 then	icmax=!d.table_size-3
middle=(icmax-icmin)/2
ctlength=middle*2
base=0.
ctprof=alog10(indgen(middle)+1)
red=	[replicate(base,middle),base+(255.-base)/ctprof(middle-1)*ctprof]
blue=	replicate(base,middle*2)
for i=0,middle*2-1 do blue(i)=red(middle*2-1-i)
green=	replicate(base,middle*2)
ctside_w=middle/2+30
ctside_max=255-base
;ctside_p=base+ctside_max	$
;	*(sqrt(ctside_w-1)-sqrt(indgen(ctside_w)))/sqrt(ctside_w)
ctside_p=base+ctside_max	$
	*(ctside_w-1-indgen(ctside_w))/ctside_w
for i=0,ctside_w-1 do begin
;	red(i)			= ctside_p(i)
;	blue(ctlength-i-1)	= ctside_p(i)
;	green(i)		= ctside_p(i)*1.5
	green(i)		= ctside_p(i)
	green(ctlength-i-1)	= ctside_p(i)
endfor
tvlct,red,green,blue,icmin

end

