;********************************************************************
;NAME       : lsmenu_nkr (function)
;FUNCTION   : select a file in a directory with mouse menu 
;DATE       : 1991/09/30, 1992/04/04
;PROGRAMMER : k.i.
;	'93/04/10  K.I.  nnmax keyword,
;	'93/04/29  K.I.  nnmax automatic determination
;********************************************************************
function lsmenu_nkr, dir, select = sel, option = op, return = ret, init = init,$
		    x = x, y = y, dirret = dirret, nnmax = nnmax
; sel    : file selection wild card
; op     : option of ls command 
; ret    : include return selection which return '.'
; init   : initial position of selection
; x, y   : position of menu on screen
; dirret : return name even if it is a directory
; nnmax  : max number of files
; ex. file = lsmenu (dir, sel='*.hed', op=' -tr', /ret)

start:

dir1 = ''
if (strmid (dir, strlen (dir) - 1, 1) eq '/') then $
   dir1 = strmid (dir, 0, strlen (dir) - 1) $
else dir1 = dir

com = '/bin/ls -F '
if (keyword_set (op)) then com = com + op + ' '
com = com + dir1

if (keyword_set (sel)) then begin
   if (dir eq '') then $
      com = com + sel	$
   else $
      com = com + '/' + sel
endif

; print, com
spawn, com, files

nfile = n_elements (files)
if (nfile eq 1) and (files (0) eq '') then  return, ''

if (n_elements (nnmax) eq 0) then begin
   fullwindow, 999, wsize = fullsize
   strmaxl = max (strlen (files))
   if (n_elements (x) eq 0) then x00 = 0 else x00 = x
   if (n_elements (y) eq 0) then y00 = 0 else y00 = y

   ;print, fullsize (0) - x00, fullsize (1) - y00
   ;nnmax = fix ( ( (fullsize (0) - x00) / (780. / 53) - (strmaxl + 2) ) $

   nnmax = fix ( ( (fullsize (0) - x00) / (35) - (strmaxl + 2) ) $
           * (fullsize (1) - y00) / 35 ) - 1 - n_elements (ret)
							; to be adjusted !
endif
	
npage = (nfile - 1) / nnmax + 1

if (keyword_set (sel) and dir ne '') then begin	; remove directory string
   ld = strlen (dir1)
   for i = 0, nfile-1 do begin
      files (i) = strmid (files (i), ld+1, strlen (files (i)) - ld - 1)
   endfor
endif

for i = 0, nfile-1 do begin		 	; remove simblic link @
   ll = strlen (files (i))			; assume it to be directory
   if ( strmid (files (i), ll-1, 1) eq '@' ) then $ 
      files (i) = strmid (files (i), 0, ll-1) + '/'
endfor

if (nfile eq 1) then return, files (0)		; found only 1 file

page = 1
lab1:
if (npage eq 1) then begin
   menustr = [dir1, '..', files]
endif else begin
   n1 = nnmax * (page - 1)
   n2 = min ([nnmax * page - 1, nfile - 1])
   menustr = [dir1 + '   page ' + string (page, format = '(i2)'), '..']
   if (n1 gt 0)       then menustr = [menustr, 'last page']
   if (n2 lt nfile-1) then menustr = [menustr, 'next page']
   menustr = [menustr, files (n1:n2)]
endelse
if (keyword_set (ret)) then menustr = [menustr, ret]
nn = n_elements (menustr)

; -----------------------  display menu  ------------------------
ii = n_elements (init)
ix = n_elements (x)
iy = n_elements (y)
if (ii eq 1)  then begin		; initial selection is given
   if ( ix eq 1 ) then begin		; x position is given
      if( iy eq 1 ) then k = wmenu (menustr, title = 0, init = init, $
				    x = x, y = y) $
      else		 k = wmenu (menustr, title = 0, init = init, x = x)
      endif else begin			; x position is default
         if ( iy eq 1 ) then k = wmenu (menustr, title = 0, init = init, y = y)$
         else		     k = wmenu (menustr, title = 0, init = init)
      endelse
      init = k
   endif else begin
      if ( ix eq 1 ) then begin
         if ( iy eq 1 ) then k = wmenu (menustr, title = 0, x = x, y = y) $
         else                k = wmenu (menustr, title = 0, x = x)
      endif else begin
         if ( iy eq 1 ) then k = wmenu (menustr, title = 0, y = y) $
         else                k = wmenu (menustr, title = 0)
      endelse
   endelse

;if (k gt nn) then retstr = ret (k - nn - 1) else retstr = files (k - 1)

if (k gt nn) then k = nn
retstr = menustr (k)
lastch = strmid (retstr, strlen (retstr) - 1, 1)
case lastch of
   '/': begin			; change to sub directory
      if (keyword_set (dirret)) then begin
         retstr = strmid (retstr, 0, strlen (retstr) - 1)
         return, retstr
      endif
      if (dir1 eq '') then dir = dir1 + retstr	$
      else  dir = dir1 + '/' + retstr
      goto, start
      end

   '*': begin
      retstr = strmid (retstr, 0, strlen (retstr) - 1)
      end

   else:
endcase

if (retstr eq '..') then begin		; change to upper directory
   if (dir1 eq '') then begin
      cd, '..'
   endif else begin
      pp = strpos (dir1, '/', 0)
      pp1 = pp
      while (pp ne -1)  do begin
         pp1 = pp
         pp = strpos (dir1, '/', pp+1)
      end
      if (pp1 eq -1) then  dir = '' else dir = strmid (dir1, 0, pp1)
   endelse
   goto, start
endif

if (retstr eq 'next page') then begin
   page = page + 1
   goto, lab1
endif

if (retstr eq 'last page') then begin
   page = page - 1
   goto, lab1
endif

return, retstr

end
