;********************************************************************
;NAME       : ndisp (procedure)
;FUNCTION   : display image in Norikura format 
;DATE       : 1991/09/30
;		93/01/07
;PROGRAMMER : k.i.
;********************************************************************
;pro ndisp

on_ioerror,lab3
wh=20		; space for time display on window
ymax=800	; max y-size of image display
f1=1		; first frame no. to display if nf>1
i=1		; initial menu no.
ino=0		; initial image no. in file
dispmin=0	; display minimum
dispmax=0	; display max (min=max -> tvscl)
skip=0
dir=''
fname=''
file = ''
wwx=512
wwy=500
window,xsize=wwx,ysize=wwy,title='ndisp'

lab0:	;----------------- get first file name  --------------------
read,'enter directory : ',dir
	if (dir ne '') and (strmid(dir,strlen(dir)-1,1) ne '/') then dir=dir+'/'
read,'enter filename ( wild character can be used ) : ',fname
file1=lsmenu(dir,sel=fname,op=' -tr')
if(file1 eq '') then begin
	print,'file not found !'
	goto,lab0
endif
if(strpos(fname,'*') eq -1) then fname=''
file=dir+file1

lab1:	;------------------   display image   ----------------------
nkrget,file,h,a,img_no=ino
ysize=h.ny*h.nf
print,'nx=',h.nx,'     ny=',h.ny,'     nf=',h.nf,'     nbyt=',h.nbyt
wy=min([ysize,ymax])
if (h.nx gt wwx) or (wy+wh gt wwy) then begin
	window,xsize=h.nx,ysize=wy+wh,title='ndisp'
	wwx=h.nx
	wwy=wy+wh
endif

lab2:
if ysize gt ymax then begin
	read,'ysize too large, enter start frame no. (1-',h.nf,') : ',f1 
	ys=h.ny*(f1-1)
	ye=min([ys+wy,ysize-1])
	if ye lt ys+wy then elase
endif else begin
	ys=0
	ye=ysize-1
	erase
endelse
if (dispmin eq 0) and (dispmax eq 0) then  tvscl,a(0:h.nx-1,ys:ye) $
else tvscl,a(0:h.nx-1,ys:ye)>dispmin<dispmax
if h.observatory eq 'NSO' then h.observatory='NKR'
date1=h.date1	&	time1=h.time1
if strpos(h.time_sys,'JST') ne -1 then  jst2ut,date1,time1
date2=h.date2	&	time2=h.time2
if strpos(h.time_sys,'JST') ne -1 then  jst2ut,date2,time2

xyouts,10,wy+wh-17,'!8' + h.observatory + '!6:  ' + date1 + '  '	$
	+ strmid(time1,0,8) + '-' +  strmid(time2,0,8)+'  '+file, $
	size=1.5,/device
if skip eq 1 then goto,menu

main:	;------------------   main manue  ----------------------
cfact=1.0
repeat begin
    i=wmenu(['ndisp: menu',		$
	'another file',			$
	'change color table',		$
	'change parameters',		$
	'utilities',			$
	'exit     '],			$
	title=0,init=i)

    case i of

    1: begin
	skip=1
menu:	file1=lsmenu(dir,op=' -tr',sel=fname,return=['return','filename', $
		'exit'])
	case file1 of
	    'return': begin
		skip=0
		goto,main
		end
	    'exit': begin
		stop
		end
	    'filename': begin
		file=nextfile(file)
		goto,lab1
		end
	    else: begin
		file=dir+file1
		goto,lab1
		end
	endcase
	end

    2: begin
    	j=wmenu(['color table: menu',		$
	'loadct       : load color table',	$
	'adjct        : change scale',		$
	'hist_equal_ct: enhance contrast',	$
	'multi        : replicate color tabl',	$
	'return     '],				$
	title=0,init=i)

	case j of
	    1:	loadct
	    2:	adjct
	    3:	hist_equal_ct
	    4:	begin
		read,'enter factor : ',cfact
		multi,cfact
		end
	    5:	begin
		end
	endcase
	end

    3: begin
    	j=wmenu(['set parameters: menu',	$
	'display scale',	$
	'!order (up-down direction)',		$
	'image no. in file',	$
	'return     '],				$
	title=0,init=1)

	case j of
	    1:	begin
		print,'current min & max = ',dispmin,',  ',dispmax
		read,'enter new min & max ( 0, 0 for only tvscl ) : ', $
			dispmin,dispmax
		goto,lab2
		end
	    2:	begin
		if !order eq 0 then neworder=1	$
		else neworder=0
		!order=neworder
		goto,lab2
		end
	    3:	begin
		print,'current image no. = ',ino
		read,'enter image no. : ',ino
		goto,lab1
		end
	    4:  begin
		end
	endcase
	end

    4: begin
    	j=wmenu(['utility: menu',		$
	'prifiles     : show cross section',	$
	'zoom         : ',			$
	'rdpix2       : read pixel value',	$
	'smooth       : smoothing of image',	$
	'image_cont   : overlay contour',	$
	'show3        : 3-d display',		$
	're-draw  ',				$
	'return     '],				$
	title=0,init=1)

	case j of
	    1:	profiles,a
	    2:	zoom
	    3:	rdpix2,a
	    4:	begin
		read,'enter smoothing width : ',swidth
		tvscl,smooth(a,swidth)
		end
	    5:	begin
		image_cont,alog(smooth(a,3))
		;contour,alog(smooth(a,3)),pos=[0,0,h.nx,h.ny],/noerase,/dev
		end
	    6:	begin
		window,1
		show3,a
		tvrdc,x,y,3,/dev
		wdelete,1
		end
	    7:	goto,lab2
	    8:	begin
		end
	endcase
	end

    5: begin
	print,'last image is saved in array "a"'
	end
    endcase

endrep until i eq 5
stop

lab3:	close,1
	print,!err_string
	file=nextfile(file)
	goto,lab1

end
