;********************************************************************
;NAME       : ngetas (procedure)
;FUNCTION   : get sum and subtraction images from two norikura formatted file
;						K.I. '91/10/15
;====================================================================
pro ngetas,file1,file2,h,add,sbt,dark=dark	

;input:
;   file1,file2  : filename
;   dark : dark file name 
;output:
;   h	: header structure
;   add	: summension of 2-images
;   sbt : subtraction of  "

;if file1 eq '' then gegin
;	print,'ngetas: get sum and subtraction images from two norikura ;formatted file'
;	print,'  USAGE: ngetas,file1,file2,h,add,sbt,dark=dark'
;	return
;endif

nsoget,file1,h1,a1
nsoget,file2,h2,a2
if ( h1.nx ne h2.nx ) or $
   ( h1.ny ne h2.ny ) or $
   ( h1.nbyt ne h2.nbyt) or $
   ( h1.integ ne h2.integ ) then begin
	print,'data type not compatible between ',file1,' & ',file2
	stop
endif
h=h1

if keyword_set(dark) then begin
	nsoget,dark,hd,drk
	drk=fix(drk*float(h.integ)/float(hd.integ))
	a1=a1-drk
	a2=a2-drk
endif
add=fix( (long(a1)+long(a2))/2 )
sbt=a1-a2

end
