;+
;
; NAME       : nkrhd_info (function)
; PURPOSE    :
;	get nkrhead for SXT data from info_array(i) of test_rd  as nkrhead
; CATEGORY :
;	idl/lib/nkr
; CALLING SEQUENCE :
;	h = nkrhd_info(info_array)
; INPUTS :
; 	info_array     -- test_rd info_array
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
; OUTPUTS :
;	none
; COMMON BLOCKS : 	none
; SIDE EFFECTS :	none
; RESTRICTIONS :	none
; PROCEDURE :
; MODIFICATION HISTORY :
;	23 Jan.93  K.I.
;-
;----------------------------------------------------------------------
function nkrhd_info,info

nn=n_elements(info)

h1=nkrhead()
h=replicate(h1,nn)
h.hdr_id='HDR:0100'
for i=0,nn-1 do begin
    case strmid(info(i),8,3) of
	'JAN':	mon='01'
	'FEB':	mon='02'
	'MAR':	mon='03'
	'APR':	mon='04'
	'MAY':	mon='05'
	'JUN':	mon='06'
	'JUL':	mon='07'
	'AUG':	mon='08'
	'SEP':	mon='09'
	'OCT':	mon='10'	
	'NOV':	mon='11'	
	'DEC':	mon='12'	
    endcase
    if strmid(info(i),5,1) eq ' '  then day='0'+strmid(info(i),6,1) else $
	day=strmid(info(i),5,2)
    h(i).date1=strmid(info(i),12,2)+'/'+mon+'/'+day
    case strmid(info(i),32,5) of
	'Open ':	h(i).d_parm(0) = 1
	'NaBan':	h(i).d_parm(0) = 2
	'??   ':	h(i).d_parm(0) = 3
	'Diffu':	h(i).d_parm(0) = 4
	'WiBan':	h(i).d_parm(0) = 5
	'NuDen':	h(i).d_parm(0) = 6
    endcase
    case strmid(info(i),38,5) of
	'Open ':	h(i).d_parm(1) = 1
	'Al.1 ':	h(i).d_parm(1) = 2
	'AlMg ':	h(i).d_parm(1) = 3
	'Be119':	h(i).d_parm(1) = 4
	'Al12 ':	h(i).d_parm(1) = 5
	'Mg3  ':	h(i).d_parm(1) = 6
    endcase
endfor
h.date2=h.date1
h.time1=strmid(info,16,8)
h.time2=h.time1
h.nx=fix(strmid(info,68,4))
h.ny=fix(strmid(info,73,3))
h.exp=fix(strmid(info,57,2))
h.seqno=fix(strmid(info,0,5))
h.com=strmid(info,32,22)+strmid(info,60,7)
;h.com=info
h.nbyt=1
h.nf=1
h.nset=1
h.telescope='sxt'
h.observatory='YOKO'
h.time_sys='UT'
h.eoh='EOH:'
return,h
end

