;********************************************************************
;NAME       : nkrsavem (procedure)
;FUNCTION   : save header and image as norikura formatted file
;						K.I. '92/09/23
;						K.I. '93/01/05
;						K.I. '93/02/03
;====================================================================
pro nkrsavem,file,h,img1,img2,img3,img4
; file     -- filename
; h0	   -- header structure
; img	   -- image array
; /nocheck -- skip check of file existence
; giveup   -- return the result. 0.ok  1.writing error
; hdmod    -- check h.nx, h.ny, h.nbyt consistence with img array

nn=n_elements(h)
if nn eq 1 then begin
	nkrsave,file,h,img1
	return
endif
s=size(img1)
if n_params() eq 3 then begin
    if s(3) eq nn then begin
	print,nn,'  images are saved'
	nkrsave,file,h(0),img1(*,*,0)
	for i=1,nn-1 do nkrsave,file,h(i),img1(*,*,i),/append
    endif else begin
	print,'# of h not eq. # of img!!'
    endelse
    return
endif

nkrsave,file,h(0),img1
nkrsave,file,h(1),img2,/append
if nn eq 2 then return
nkrsave,file,h(2),img3,/append
if nn eq 3 then return
nkrsave,file,h(3),img4,/append
if nn eq 4 then return
nkrsave,file,h(4),img4,/append

return
end
