;**************************************************************************
;NAME       : sbtdrk (procedure)
;FUNCTION   : dark subtraction
;MODIFICATION : K.I. '92/11/14
;		k.i. '93/08/14
;==========================================================================
pro sbtdrk,h,img,hd,drk,error=error

error=0
resize=0

if h.correct eq 2 then begin
	print,'dark is already corrected!'
	return
endif
if h.ny ne hd.ny then begin
	drk=drk(0:hd.nx-1,h.pix_y1:h.pix_y1+h.ny-1)
	hd.pix_y1=h.pix_y1
	hd.ny=h.ny
endif
if arrcmp(img,drk) eq -1 then begin
	drk0=drk
	x1=h.pix_X1-hd.pix_x1
	y1=h.pix_y1-hd.pix_y1
	s=size(img)	&	nx=s(1)	&	ny=s(2)
	if (x1 lt 0) or (x1+nx-1 ge hd.nx) or $
	   (y1 lt 0) or (y1+ny-1 ge hd.ny) then begin
		error=1
		print,'incorrect dark in "sbtdrk" !!'
		return
	endif
	resize=1
	drk=drk0(x1:x1+nx-1,y1:y1+ny-1)
endif

if h.integ ne hd.integ then begin 
	drk=fix(drk*float(h.integ)/float(hd.integ))
	hd.integ=h.integ
endif

s=size(img) &	nx=s(1) &	ny=s(2)
if s(0) eq 3 then nf=s(3) else nf=1

if h.nbyt eq 1 then begin
	for i=0,nf-1 do img(*,*,i)=byte((img(*,*,i)-drk)>0)
endif else begin
	for i=0,nf-1 do img(*,*,i)=img(*,*,i)-drk
endelse

h.correct=2
if resize eq 1 then drk=drk0
if hd.integ eq 1 and hd.nbyt eq 1 then drk=byte(drk)

end
