; NAME :	defspecs
; PURPOSE :
;	define data specification strings
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	specs = defspecs( nspec )
; INPUTS :
;	none
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
;	none
; OUTPUTS :
;	specs (array of strings)
;	nspec = number of strings in specs
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	none
; RESTRICTIONS :	none
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1992
;
;------------------------------------------------------------------------
;
function defspecs, nspec
;
        specs=[ 'I',  '*',   '*',   $
                'V',  'Q',   'U',   $
                'V/I','Q/I', 'U/I', $
                'W',  '*',   '*',   $
                'W/I','*',   '*',   $
                'BLP','BXP', 'BYP', $
                'BNP','BHXP','BHYP',$
                'BRP','BFP', 'BTP', $
                'BL', 'BX',  'BY',  $
                'BN', 'BHX', 'BHY', $
                'BR', 'BF',  'BT',  $
                'VL', 'VX',  'VY',  $
                'VN', 'VHX', 'VHY', $
                'VR', 'VF',  'VT',  $
                'JL', '*',   '*',   $
                'JN', '*',   '*',   $
                'JR', '*',   '*',   $
                'FL', '*',   '*',   $
                'FN', '*',   '*',   $
                'FR', '*',   '*'  ]
        size_specs = size(specs)
        nspec = fix(size_specs(1))
	return, specs
end
