; NAME :	defstats
; PURPOSE :
;	define magnetogram status stored in rdata
;	if data BL exist in rdata(*,*,k), status.bl = k
;	if data BL are not in rdata, status.bl = -1
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	status = defstats
; INPUTS :
;	none
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
;	none
; OUTPUTS :
;	status (structure)
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	none
; RESTRICTIONS :	none	
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1992
;
;------------------------------------------------------------------------
;
function defstats
;
	status = { status1, $
        	i:-1,   ixdum:-1, iydum:-1, $
		v:-1,   q:-1,     u:-1,     $
		vi:-1,  qi:-1,    ui:-1,    $
		w:-1,   wxdum:-1, wydum:-1, $
		wi:-1,  wixdum:-1,wiydum:-1,$
		blp:-1, bxp:-1,   byp:-1,   $
		bnp:-1, bhxp:-1,  bhyp:-1,  $
		brp:-1, bfp:-1,   btp:-1,   $
		bl:-1,  bx:-1,    by:-1,    $
		bn:-1,  bhx:-1,   bhy:-1,   $
		br:-1,  bf:-1,    bt:-1,    $
		vl:-1,  vx:-1,    vy:-1,    $
		vn:-1,  vhx:-1,   vhy:-1,   $
		vr:-1,  vf:-1,    vt:-1,    $
		jl:-1,  jxdum:-1, jydum:-1, $
		jn:-1,  jhxdum:-1,jhydum:-1,$
		jr:-1,  jfdum:-1, jtdum:-1, $
		fl:-1,  fxdum:-1, fydum:-1, $
		fn:-1,  fhxdum:-1,fhydum:-1,$
		fr:-1,  ffdum:-1, ftdum:-1 }

	return, status
end
