; NAME :	jnft1
; PURPOSE :
;	show electric current distribution based on 
;	vector magnetograms of the Solar Flare Telescope
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	.run jnft1
; INPUTS :
;	following data should be on the memory
;	h = norikura header
;	img = intensity image
;	q, u, v = Stokes polarization parameters
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
; OUTPUTS :
;	electric currents (Jn) will be displayed
; COMMON BLOCKS : 	none
; SIDE EFFECTS :	arrays mparam and rdata will be created
; RESTRICTIONS :	X-window environment is assumed
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1992
;
;------------------------------------------------------------------------
;
@transc
print,'It will take a minute or so.'
convft1, h,img,q,u,v, mparam, rdata
pol2b, mparam, rdata
curlb1, mparam, rdata, /keep_bp
magplot, mparam, rdata, /nomenu
end

