; ------------------------------------------------------------------------------
; mjday.pro
; ------------------------------------------------------------------------------
; Get month, day & year from MLSO Mark-III "julian" date (i.e., since 1900).
; IDL procedure
; ------------------------------------------------------------------------------
; Andrew L. Stanger
; 18 March 1993
; ------------------------------------------------------------------------------

PRO mjday, hkday, month, day, year

   ; hkday = FIX (hkday)			; "julian" date in MK3 `filehd'.

   month = FIX (0)				; month of year.
   day   = FIX (0)				; day of month.
   year  = FIX (0)				; year.
   imask = '177777'O
   lmask = '37777777777'OL

   joff = 2415021L				; Julian date for 1 Jan 1900.

   jday = (LONG (hkday AND imask) + joff) AND lmask

   jdate, jday, month, day, year		; Call Julian date procedure.

RETURN
END
