; ------------------------------------------------------------------------------
; mk3time.pro
; ------------------------------------------------------------------------------
; Compute hour, minute, & second from MLSO Mark-III time (millisecond units).
; ------------------------------------------------------------------------------
; Andrew L. Stanger   HAO/NCAR
; 18 March 1993
; ------------------------------------------------------------------------------

PRO mk3time, hktime, hour, minute, second

   time = LONG (hktime) AND '37777777777'OL
   hour   = FIX (0)
   minute = FIX (0)
   second = FIX (0)

   ftime  = FLOAT (time) * 0.01			; Convert from millisec to sec.

   hour   = FIX  (ftime / 3600.0)				; hours.
   minute = FIX ((ftime - hour * 3600.0) / 60.0)		; Minutes.
   second = FIX ((ftime - hour * 3600.0 - minute * 60.0))	; Seconds.

RETURN
END
