pro mkmassdb1

;+ mkmassdb
;
; Create SMM C/P Mass database.
;
; IDL procedure
;
; Andrew L. Stanger   HAO/NCAR   25 Oct 1994
;-

@cpmassa.common

; --- Read SMM C/P mass measurement data.

rdcpmass1

sizedoy = size (doy)
ncme = sizedoy (1)

dateid  = strarr (ncme)
cmedate = fltarr (ncme)
odoy = '000'
ihour = 0
fhour = 0.0
hinc = 0.00001
doyhour = indgen (24)

; --- Create CME date field.

FOR i = 0, ncme-1 do $
BEGIN
   sdoy = strmid (doy (i), 0, 3)
   if (sdoy eq odoy)  then ihour = ihour + 1  else ihour = 0
   if (sdoy eq odoy)  then fhour = fhour + hinc  else fhour = 0.0
   dateid (i) = year (i) + '/' + sdoy + ':' + $
	      string (doyhour (ihour), FORMAT='(I1)')
   fyear = float (year (i))
   if (fyear eq 80.0 or fyear eq 84.0 or fyear eq 88.0)  then $
      numdoy = 366  else  numdoy = 365
   fdoy = float (sdoy) / float (numdoy)
   cmedate (i) = float (year (i)) + fdoy + fhour
   odoy = sdoy
END

; --- Create new IDL database.

!PRIV = 2				; Create or modify IDL database.

dbcreate, 'cpmass', 1, 1		; Need new index & data files.

dbopen, 'cpmass', 1			; Open database for update.

; --- Load data into database files.

dbbuild, dateid, cmedate, xmass, err, posang, lat, width, speed, ke, pe, te

!PRIV = 0 

end

