pro eh33

;+
; Energy Histogram Plots
; SMM C/P CMEs.
;
; IDL procedure
; Andrew L. Stanger   HAO/NCAR   7 September 1994
; Revised 28 June 1995: Use rdcpmass2.  Add 1989 measurements.
;-

@cpmassa.common

rdcpmass2

; --- Convert joules to ergs.

ke = ke * 1.e+7
pe = pe * 1.e+7
te = te * 1.e+7

ke80 = ke80 * 1.e+7
ke84 = ke84 * 1.e+7
ke85 = ke85 * 1.e+7
ke86 = ke86 * 1.e+7
ke87 = ke87 * 1.e+7
ke88 = ke88 * 1.e+7
ke89 = ke89 * 1.e+7

pe80 = pe80 * 1.e+7
pe84 = pe84 * 1.e+7
pe85 = pe85 * 1.e+7
pe86 = pe86 * 1.e+7
pe87 = pe87 * 1.e+7
pe88 = pe88 * 1.e+7
pe89 = pe89 * 1.e+7

te80 = te80 * 1.e+7
te84 = te84 * 1.e+7
te85 = te85 * 1.e+7
te86 = te86 * 1.e+7
te87 = te87 * 1.e+7
te88 = te88 * 1.e+7
te89 = te89 * 1.e+7

; --- Get size of arrays.

sizvec = size (lat)
nlat   = sizvec (1)

sizvec = size (ke)
nke    = sizvec (1)
sizvec = size (pe)
npe    = sizvec (1)
sizvec = size (te)
nte    = sizvec (1)
nval   = nke

sizvec = size (ke80)
nke80  = sizvec (1)
sizvec = size (ke84)
nke84  = sizvec (1)
sizvec = size (ke85)
nke85  = sizvec (1)
sizvec = size (ke86)
nke86  = sizvec (1)
sizvec = size (ke87)
nke87  = sizvec (1)
sizvec = size (ke88)
nke88  = sizvec (1)
sizvec = size (ke89)
nke89  = sizvec (1)

sizvec = size (pe80)
npe80  = sizvec (1)
sizvec = size (pe84)
npe84  = sizvec (1)
sizvec = size (pe85)
npe85  = sizvec (1)
sizvec = size (pe86)
npe86  = sizvec (1)
sizvec = size (pe87)
npe87  = sizvec (1)
sizvec = size (pe88)
npe88  = sizvec (1)
sizvec = size (pe89)
npe89  = sizvec (1)

sizvec = size (te80)
nte80  = sizvec (1)
sizvec = size (ke84)
nke84  = sizvec (1)
sizvec = size (ke85)
nke85  = sizvec (1)
sizvec = size (ke86)
nke86  = sizvec (1)
sizvec = size (ke87)
nke87  = sizvec (1)
sizvec = size (ke88)
nke88  = sizvec (1)
sizvec = size (ke89)
nke89  = sizvec (1)

;print, 'nxmass: ', nxmass, '   nlat: ', nlat
print, 'nlat: ', nlat

;for i = 0, nxmass - 1  do $
;   print, 'i: ', i, '   xmass: ', xmass (i), '   lat: ', lat (i)

; --- Create new arrays containing non-zero elements of energy arrays.

ki = WHERE (ke, npke)
pi = WHERE (pe, nppe)
ti = WHERE (te, npte)

poske = ke (ki)
pospe = pe (pi)
poste = te (ti)

ki80 = WHERE (ke80, npke80)
ki84 = WHERE (ke84, npke84)
ki85 = WHERE (ke85, npke85)
ki86 = WHERE (ke86, npke86)
ki87 = WHERE (ke87, npke87)
ki88 = WHERE (ke88, npke88)
ki89 = WHERE (ke89, npke89)

pi80 = WHERE (pe80, nppe80)
pi84 = WHERE (pe84, nppe84)
pi85 = WHERE (pe85, nppe85)
pi86 = WHERE (pe86, nppe86)
pi87 = WHERE (pe87, nppe87)
pi88 = WHERE (pe88, nppe8)
pi89 = WHERE (pe89, nppe8)

ti80 = WHERE (te80, npte80)
ti84 = WHERE (te84, npte84)
ti85 = WHERE (te85, npte85)
ti86 = WHERE (te86, npte86)
ti87 = WHERE (te87, npte87)
ti88 = WHERE (te88, npte88)
ti89 = WHERE (te89, npte89)

pke80 = ke80 (ki80)
pke84 = ke84 (ki84)
pke85 = ke85 (ki85)
pke86 = ke86 (ki86)
pke87 = ke87 (ki87)
pke88 = ke88 (ki88)
pke89 = ke89 (ki89)

ppe80 = pe80 (pi80)
ppe84 = pe84 (pi84)
ppe85 = pe85 (pi85)
ppe86 = pe86 (pi86)
ppe87 = pe87 (pi87)
ppe88 = pe88 (pi88)
ppe89 = pe89 (pi89)

pte80 = te80 (ti80)
pte84 = te84 (ti84)
pte85 = te85 (ti85)
pte86 = te86 (ti86)
pte87 = te87 (ti87)
pte88 = te88 (ti88)
pte89 = te89 (ti89)

; --- Create subset arrays for measurements in which both K.E. and P.E. are > 0.

ip  = 0
poske  = fltarr (nval)
pospe  = fltarr (nval)
poslat = intarr (nval)

for i = 0, nval - 1  do $
begin
   if (ke (i) gt 0.0 and pe (i) gt 0.0) then $
   begin
      poske (ip) = ke (i)
      pospe (ip) = pe (i)
      poslat (ip) = abs (lat (i))
      ip = ip + 1
   endif
endfor

np = ip
print, 'np: ', np

pke = poske (0: np - 1)
ppe = pospe (0: np - 1)
pte = pke + ppe
plat = poslat (0: np - 1)

; --- Log (ke), log (pe), log (te)

lke = alog10 (pke)			; log (K.E.) [ergs].
lpe = alog10 (ppe)			; log (P.E.) [ergs].
lte = alog10 (pte)			; log (T.E.) [ergs].

ske1 = 0			; Sum of kinetic energy with  0 < lat < 20
ske2 = 0			; Sum of kinetic energy with 20 < lat < 40
ske3 = 0			; Sum of kinetic energy with 20 < lat < 90

spe1 = 0			; Sum of potential energy with  0 < lat < 20
spe2 = 0			; Sum of potential energy with 20 < lat < 40
spe3 = 0			; Sum of potential energy with 20 < lat < 90

ste1 = 0			; Sum of total energy with  0 < lat < 20
ste2 = 0			; Sum of total energy with 20 < lat < 40
ste3 = 0			; Sum of total energy with 20 < lat < 90

nke1 = 0			; Number of ke measurements  0 < lat < 20
nke2 = 0			; Number of ke measurements 20 < lat < 40
nke3 = 0			; Number of ke measurements 40 < lat < 90

npe1 = 0			; Number of pe measurements  0 < lat < 20
npe2 = 0			; Number of pe measurements 20 < lat < 40
npe3 = 0			; Number of pe measurements 40 < lat < 90

nte1 = 0			; Number of te measurements  0 < lat < 20
nte2 = 0			; Number of te measurements 20 < lat < 40
nte3 = 0			; Number of te measurements 40 < lat < 90

ke1 = fltarr (nval)		; Kinetic Energy values with  0 < lat < 20
ke2 = fltarr (nval)		; Kinetic Energy values with 20 < lat < 40
ke3 = fltarr (nval)		; Kinetic Energy values with 40 < lat < 90

pe1 = fltarr (nval)		; Potential Energy values with  0 < lat < 20
pe2 = fltarr (nval)		; Potential Energy values with 20 < lat < 40
pe3 = fltarr (nval)		; Potential Energy values with 40 < lat < 90

te1 = fltarr (nval)		; Total Energy values with  0 < lat < 20
te2 = fltarr (nval)		; Total Energy values with 20 < lat < 40
te3 = fltarr (nval)		; Total Energy values with 40 < lat < 90

i1 = 0
i2 = 0
i3 = 0

for i = 0, np - 1 do $
begin
   if (plat (i) le 20) then $
   begin
      nke1 = nke1 + 1
      ske1 = ske1 + pke (i) 
      spe1 = spe1 + ppe (i) 
      ste1 = ste1 + pte (i) 
      ke1 (i1) = pke (i)
      pe1 (i1) = ppe (i)
      te1 (i1) = pte (i)
      i1 = i1 + 1
   endif

   if (plat (i) gt 20) and plat (i) le 40 then $
   begin
      nke2 = nke2 + 1
      ske2 = ske2 + pke (i)
      spe2 = spe2 + ppe (i)
      ste2 = ste2 + pte (i)
      ke2 (i2) = pke (i)
      pe2 (i2) = ppe (i)
      te2 (i2) = pte (i)
      i2 = i2 + 1
   endif

   if (plat (i) gt 40) then $
   begin
      nke3 = nke3 + 1
      ske3 = ske3 + pke (i)
      spe3 = spe3 + ppe (i)
      ste3 = ste3 + pte (i)
      ke3 (i3) = pke (i)
      pe3 (i3) = ppe (i)
      te3 (i3) = pte (i)
      i3 = i3 + 1
   endif
endfor

npe1 = nke1
npe2 = nke2
npe3 = nke3

nte1 = nke1
nte2 = nke2
nte3 = nke3

k1 = ke1 (0: nke1 - 1)
k2 = ke2 (0: nke2 - 1)
k3 = ke3 (0: nke3 - 1)

p1 = pe1 (0: npe1 - 1)
p2 = pe2 (0: npe2 - 1)
p3 = pe3 (0: npe3 - 1)

t1 = te1 (0: nte1 - 1)
t2 = te2 (0: nte2 - 1)
t3 = te3 (0: nte3 - 1)

nke = nke1 + nke2 + nke3
ake1 = ske1 / nke1
ake2 = ske2 / nke2 
ake3 = ske3 / nke3
ake = (ske1 + ske2 + ske3) / nke

npe = npe1 + npe2 + npe3
ape1 = spe1 / npe1
ape2 = spe2 / npe2 
ape3 = spe3 / npe3
ape = (spe1 + spe2 + spe3) / npe

nte = nke1 + nke2 + nke3
ate1 = ste1 / nte1
ate2 = ste2 / nte2 
ate3 = ste3 / nte3
ate = (ste1 + ste2 + ste3) / nte

print, '<K.E.> ( 0 < lat < 20) = ', ake1
print, '<K.E.> (20 < lat < 40) = ', ake2
print, '<K.E.> (40 < lat < 90) = ', ake3   
print, '<K.E.>                 = ', ake

print, '<P.E.> ( 0 < lat < 20) = ', ape1
print, '<P.E.> (20 < lat < 40) = ', ape2
print, '<P.E.> (40 < lat < 90) = ', ape3   
print, '<P.E.>                 = ', ape

print, '<T.E.> ( 0 < lat < 20) = ', ate1
print, '<T.E.> (20 < lat < 40) = ', ate2
print, '<T.E.> (40 < lat < 90) = ', ate3   
print, '<T.E.>                 = ', ate

syearlab = '1980, 1984-1989'			; year label.
xtype = 1					; log   : energy.
ytype = 0					; linear: # in bin.
plab = 'Histogram'
kelab = 'Kinetic Energy'			; K.E. label.
pelab = 'Potential Energy'			; P.E. label.
telab = 'Mechanical Energy'			; M.E. label.
elab = 'Energy'
pkelab = plab + ':   ' + kelab + '          ' + syearlab
ppelab = plab + ':   ' + pelab + '          ' + syearlab
ptelab = plab + ':   ' + telab + '          ' + syearlab
eunits = 'ergs'					; Energy units.

; --- Plot to postscript file.

SET_PLOT, 'PS'
!P.FONT = 0
;DEVICE, /TIMES, /BOLD, /COLOR, FONT_SIZE = 18, FILENAME = 'eh33.ps'
;DEVICE, /HELVETICA, /BOLD, FONT_SIZE = 18, FILENAME = 'eh33.ps'
;DEVICE, /HELVETICA, /BOLD, FONT_SIZE = 18, FILENAME = 'eh33.ps', $
;	YOFFSET = 12.70, YSIZE = 12.70		; 5" bottom margin, 5" height
;	YOFFSET = 2.54, YSIZE = 17.78		; 1" bottom margin, 7" height

DEVICE, /HELVETICA, /BOLD, FONT_SIZE = 18, FILENAME = 'eh33.ps', $
        XOFFSET = 2.54, XSIZE = 16.51, $	; 1" left margin,   6.5" wide
	YOFFSET = 2.54, YSIZE = 22.86		; 1" bottom margin, 9" high

;loadct, 0			; B-W
;loadct, 1			; BLUE-WHITE
;loadct, 2			; GRN-RED-BLU-WHT
;loadct, 3			; RED TEMPERATURE
;loadct, 4			; BLUE/GREEN/RED/YELLOW
;loadct, 5			; STD GAMMA-II
;loadct, 6			; PRISM
;loadct, 7			; RED-PURPLE
;loadct, 8			; GREEN/WHITE LINEAR
;loadct, 9			; GRN?WHT EXPONENTIAL
;loadct, 10 			; GREEN-PINK
;loadct, 11			; BLUE-RED
;loadct, 12			; 16 LEVEL
;loadct, 13			; RAINBOW


; --- Histograms for Kinetic, Potential & Mechanical Energy; All measurements.

!P.MULTI = [0, 0, 3, 0, 0]		; 3 plots vertically.

xmin = 27.0
xmax = 33.0
pyearlab = ''
cmehp3, pke, elab, eunits, pkelab, pyearlab, xtype, ytype, xmin, xmax
cmehp3, ppe, elab, eunits, ppelab, pyearlab, xtype, ytype, xmin, xmax
cmehp3, pte, elab, eunits, ptelab, pyearlab, xtype, ytype, xmin, xmax

; --- Histograms for Kinetic, Potential & Mechanical Energy: by latitude range.

;cmehp, k1, elab, eunits, pkelab, syearlab, xtype, ytype
;xyouts, 0.21, 0.7, ' 0 < lat < 20 deg.', /NORMAL, CHARSIZE = 0.8
;cmehp, k2, elab, eunits, pkelab, syearlab, xtype, ytype
;xyouts, 0.21, 0.7, '20 < lat < 40 deg.', /NORMAL, CHARSIZE = 0.8
;cmehp, k3, elab, eunits, pkelab, syearlab, xtype, ytype
;xyouts, 0.21, 0.7, '40 < lat < 90 deg.', /NORMAL, CHARSIZE = 0.8

;cmehp, p1, elab, eunits, ppelab, syearlab, xtype, ytype
;xyouts, 0.21, 0.7, ' 0 < lat < 20 deg.', /NORMAL, CHARSIZE = 0.8
;cmehp, p2, elab, eunits, ppelab, syearlab, xtype, ytype
;xyouts, 0.21, 0.7, '20 < lat < 40 deg.', /NORMAL, CHARSIZE = 0.8
;cmehp, p3, elab, eunits, ppelab, syearlab, xtype, ytype
;xyouts, 0.21, 0.7, '40 < lat < 90 deg.', /NORMAL, CHARSIZE = 0.8

ptelab1 = plab + ':   ' + telab + '           0 < lat < 20 [deg]'
ptelab2 = plab + ':   ' + telab + '          20 < lat < 40 [deg]'
ptelab3 = plab + ':   ' + telab + '          40 < lat < 90 [deg]'

xmin = 29.0
xmax = 33.0

cmehp3, t1, elab, eunits, ptelab1, pyearlab, xtype, ytype, xmin, xmax
;xyouts, 0.21, 0.7, ' 0 < lat < 20 deg.', /NORMAL, CHARSIZE = 0.8
cmehp3, t2, elab, eunits, ptelab2, pyearlab, xtype, ytype, xmin, xmax
;xyouts, 0.21, 0.7, '20 < lat < 40 deg.', /NORMAL, CHARSIZE = 0.8
cmehp3, t3, elab, eunits, ptelab3, pyearlab, xtype, ytype, xmin, xmax
;xyouts, 0.21, 0.7, '40 < lat < 90 deg.', /NORMAL, CHARSIZE = 0.8

DEVICE, /CLOSE

DEVICE, /HELVETICA, /BOLD, FONT_SIZE = 18, FILENAME = 'eh33s.ps', $
XSIZE = 16.51, XOFFSET = 2.54, $	; 6.5"W, 1" left margin
YSIZE = 12.70, YOFFSET = 12.70		; 5.0"H, 5" bottom margin


!P.MULTI = [0, 0, 0, 0, 0]		; 1 plot vertically.

; --- Scatter Plot: latitude vs. total energy

ymin = 29.0
ymax = 33.0

PLOT, plat, lte, /YNOZ, PSYM = 2, $
     YRANGE = [ymin, ymax], $
     TITLE='Latitude vs Mechanical Energy', $
     XTITLE='Latitude [degrees]', $
     YTITLE = 'Log (Energy)   [ergs]', $
     XTHICK = 5.0, YTHICK = 5.0, $
     XTICKLEN = -0.02, YTICKLEN = -0.02

r = CORRELATE (plat, lte)

print, 'correlation (plat, lte): ', r

sr = string (r, FORMAT = '(F6.3)')
sate1 = string (ate1, FORMAT = '(E8.2)')
sate2 = string (ate2, FORMAT = '(E8.2)')
sate3 = string (ate3, FORMAT = '(E8.2)')

;xyouts, 0.20, 0.86, '1980, 1984-1987', /NORM, CHARSIZE = 1.0
;xyouts, 0.20, 0.82, 'corr. coeff = ' + sr, /NORM, CHARSIZE = 0.8
;xyouts, 0.50, 0.86, '<T.E.> ( 0<lat<20) = ' + sate1, /NORM, CHARSIZE = 0.8
;xyouts, 0.50, 0.82, '<T.E.> (20<lat<40) = ' + sate2, /NORM, CHARSIZE = 0.8
;xyouts, 0.50, 0.78, '<T.E.> (40<lat<90) = ' + sate3, /NORM, CHARSIZE = 0.8

nspot = [ 15.5,  12.6,  27.5,  92.5, 155.4,	$	; Annual ave. Sunspot #
	 154.6, 140.4, 115.9,  66.6,  45.9,	$
	  17.9,  13.4,  29.4, 100.2, 157.6,	$
	  142.6, 145.7, 94.5]				; 1975-1992
yspot = indgen (18) + 1975

ake80 = avg (pke80)
ake84 = avg (pke84)
ake85 = avg (pke85)
ake86 = avg (pke86)
ake87 = avg (pke87)
ake88 = avg (pke88)
ake89 = avg (pke89)

ape80 = avg (ppe80)
ape84 = avg (ppe84)
ape85 = avg (ppe85)
ape86 = avg (ppe86)
ape87 = avg (ppe87)
ape88 = avg (ppe88)
ape89 = avg (ppe89)

print, '1984 positive K.E. :'
print, pke84
print, '1984 positive P.E. :'
print, ppe84
print, '1984 positive T.E. :'
print, pte84

ate80 = avg (pte80)
ate84 = avg (pte84)
ate85 = avg (pte85)
ate86 = avg (pte86)
ate87 = avg (pte87)
ate88 = avg (pte88)
ate89 = avg (pte89)

lake80 = alog10 (ake80)
lake84 = alog10 (ake84)
lake85 = alog10 (ake85)
lake86 = alog10 (ake86)
lake87 = alog10 (ake87)
lake88 = alog10 (ake88)
lake89 = alog10 (ake89)

lape80 = alog10 (ape80)
lape84 = alog10 (ape84)
lape85 = alog10 (ape85)
lape86 = alog10 (ape86)
lape87 = alog10 (ape87)
lape88 = alog10 (ape88)
lape89 = alog10 (ape89)

late80 = alog10 (ate80)
late84 = alog10 (ate84)
late85 = alog10 (ate85)
late86 = alog10 (ate86)
late87 = alog10 (ate87)
late88 = alog10 (ate88)
late89 = alog10 (ate89)

ycme  = [1980, 1984, 1985, 1986, 1987, 1988, 1989]
syear = size (ycme)
nyear = syear (1)

ayke  = [ ake80,  ake84,  ake85,  ake86,  ake87,  ake88,  ake89]
aype  = [ ape80,  ape84,  ape85,  ape86,  ape87,  ape88,  ape89]
ayte  = [ ate80,  ate84,  ate85,  ate86,  ate87,  ate88,  ate89]

layke = [lake80, lake84, lake85, lake86, lake87, lake88, lake89]
laype = [lape80, lape84, lape85, lape86, lape87, lape88, lape89]
layte = [late80, late84, late85, late86, late87, late88, late89]

print, 'ycme :'
print, ycme 
print, 'ayke :'
print, ayke
print, 'aype :'
print, aype
print, 'ayte :'
print, ayte
print, 'layte :'
print, layte

; --- Define circle symbol for plotting.

a = FINDGEN (16) * (!PI * 2 / 16.0)
USERSYM, COS (a), SIN (a), /FILL

; --- Sunspot number versus time.

PLOT, yspot, nspot, $
      PSYM = 8,					$	; filled circle
      XTHICK = 5.0, YTHICK = 5.0,		$
      XTICKLEN = -0.02, YTICKLEN = -0.02,	$
      XRANGE = [1980, 1992],			$
      TITLE = "Sunspot Number vs. Time",	$
      XTITLE = "YEAR",				$
      YTITLE = "Average Monthly Sunspot Number"
OPLOT, yspot, nspot, LINESTYLE = 0			; solid line

; --- Energy versus time.

PLOT, ycme,  ayte,				$
      PSYM = 6,					$	; square
      XTHICK = 5.0, YTHICK = 5.0,		$
      XTICKLEN = -0.02, YTICKLEN = -0.02,	$
      XRANGE = [1980, 1992],			$
;      YRANGE = [2.0E+23, 8.0E+23],		$
      YRANGE = [0, 3.0E+31],			$
      TITLE = "Energy vs. Time",		$
      XTITLE = "YEAR",				$
      YTITLE = "Average CME Energy [ergs]"

OPLOT, ycme, ayte, LINESTYLE = 0			; solid line
OPLOT, ycme, ayke, PSYM = 2				; asterisk
OPLOT, ycme, ayke, LINESTYLE = 1			; dotted line
OPLOT, ycme, aype, PSYM = 5				; triangle
OPLOT, ycme, aype, LINESTYLE = 2			; dashed line
xyouts, 1989.25, ayke (nyear-1), 'KINETIC',    CHARSIZE = 0.5
xyouts, 1989.25, aype (nyear-1), 'POTENTIAL',  CHARSIZE = 0.5
xyouts, 1989.25, ayte (nyear-1), 'MECHANICAL', CHARSIZE = 0.5

; --- Log (Energy) versus time.

PLOT, ycme,  layte,				$
      PSYM = 6,					$	; square
      XTHICK = 5.0, YTHICK = 5.0,		$
      XTICKLEN = -0.02, YTICKLEN = -0.02,	$
      XRANGE = [1980, 1992],			$
      YRANGE = [29.0, 31.5],			$
      TITLE = "Log (Energy) vs. Time",		$
      XTITLE = "YEAR",				$
      YTITLE = "Log (Average CME Energy) [ergs]"

OPLOT, ycme, layte, LINESTYLE = 0			; solid line
OPLOT, ycme, layke, PSYM = 2				; asterisk
OPLOT, ycme, layke, LINESTYLE = 1			; dotted line
OPLOT, ycme, laype, PSYM = 5				; triangle
OPLOT, ycme, laype, LINESTYLE = 2			; dashed line
xyouts, 1989.25, layke (nyear-1), 'KINETIC',    CHARSIZE = 0.5
xyouts, 1989.25, laype (nyear-1), 'POTENTIAL',  CHARSIZE = 0.5
xyouts, 1989.25, layte (nyear-1), 'MECHANICAL', CHARSIZE = 0.5

DEVICE, /CLOSE
SET_PLOT, 'X'

end
