pro mh1

;+
; Generate SMM C/P Excess Mass histograms for period 1980, 1984-1988.
;
; IDL procedure
; Andrew L. Stanger   HAO/NCAR   29 August 1994
;-

SET_PLOT, 'PS'
!P.FONT = 0
DEVICE, /HELVETICA, FONT_SIZE = 18, FILENAME = 'mh1.ps', $
	YSIZE = 9.0

label = ''
d = ''
maxcme = 500
doy  = strarr (maxcme)
xmass = fltarr (maxcme)
qual = intarr (maxcme)
posang = intarr (maxcme)
lat = intarr (maxcme)
width = intarr (maxcme)
speed = intarr (maxcme)
ke = fltarr (maxcme)
pe = fltarr (maxcme)
te = fltarr (maxcme)

i = -1

n80 = 0
openr, 1, 'cme80.tab'
readf, 1, label, FORMAT = '(A3)'
;print, label
while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2)', $
      n, d, m, q, a, l, w, s, k, p, t
   i = i + 1
   n80 = n80 + 1
   doy (i) = d
   xmass (i) = m
   qual (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   te (i) = t
endwhile
close, 1

n84 = 0
openr, 1, 'cme84.tab'
readf, 1, label
while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2)', $
      n, d, m, q, a, l, w, s, k, p, t
   i = i + 1
   n84 = n84 + 1
   doy (i) = d
   xmass (i) = m
   qual (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   te (i) = t
endwhile
close, 1

n85 = 0
openr, 1, 'cme85.tab'
readf, 1, label
while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2)', $
      n, d, m, q, a, l, w, s, k, p, t
   i = i + 1
   n85 = n85 + 1
   doy (i) = d
   xmass (i) = m
   qual (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   te (i) = t
endwhile
close, 1

n86 = 0
openr, 1, 'cme86.tab'
readf, 1, label
while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2)', $
      n, d, m, q, a, l, w, s, k, p, t
   i = i + 1
   n86 = n86 + 1
   doy (i) = d
   xmass (i) = m
   qual (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   te (i) = t
endwhile
close, 1

n87 = 0
openr, 1, 'cme87.tab'
readf, 1, label
while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2)', $
      n, d, m, q, a, l, w, s, k, p, t
   i = i + 1
   n87 = n87 + 1
   doy (i) = d
   xmass (i) = m
   qual (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   te (i) = t
endwhile
close, 1

n88 = 0
openr, 1, 'cme88.tab'
readf, 1, label
while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2)', $
      n, d, m, q, a, l, w, s, k, p, t
   i = i + 1
   n88 = n88 + 1
   doy (i) = d
   xmass (i) = m
   qual (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   te (i) = t
endwhile
close, 1

ntot = i + 1

; Create a single array of mass values for years 1980, 1984-1988.

xmass = xmass (0 : ntot - 1) * 1000.0		; convert to grams.
n = 0
xm80 = xmass (  n : n + n80 - 1)
n = n + n80
xm84 = xmass (  n : n + n84 - 1)
n = n + n84
xm85 = xmass (  n : n + n85 - 1)
n = n + n85
xm86 = xmass (  n : n + n86 - 1)
n = n + n86
xm87 = xmass (  n : n + n87 - 1)
n = n + n87
xm88 = xmass (  n : n + n88 - 1)
n = n + n88

nmeas = n80 + n84 + n85 + n86 + n87 + n88

;print, 'n80/84/85/86/87/88: ', n80, n84, n85, n86, n87, n88
;print, 'nmeas: ', nmeas

;for i = 0, ntot - 1, 1 do $
;print, 'i: ', i, '   xmass: ', xmass (i)

xmmin = min (xmass)
xmmax = max (xmass)
xmdif = xmmax - xmmin
binsiz = xmdif / 20.0

;print, 'min (xmass): ', xmmin, '   max (xmass): ', xmmax
;print, 'xmdif: ', xmdif, '   binsiz: ', binsiz

; Define year variables

year80 = 1980
year84 = 1984
year85 = 1985
year86 = 1986
year87 = 1987
year88 = 1988

syear80 = string (year80, FORMAT = '(I4)')
syear84 = string (year84, FORMAT = '(I4)')
syear85 = string (year85, FORMAT = '(I4)')
syear86 = string (year86, FORMAT = '(I4)')
syear87 = string (year87, FORMAT = '(I4)')
syear88 = string (year88, FORMAT = '(I4)')

; Plot mass histograms.

 syearlab = '1980, 1984-1988'

 !P.MULTI = [0, 0, 6, 0, 0]
 mhp1, xm80,  syear80,  0, 0
 mhp1, xm84,  syear84,  0, 0
 mhp1, xm85,  syear85,  0, 0
 mhp1, xm86,  syear86,  0, 0
 mhp1, xm87,  syear87,  0, 0
 mhp1, xm88,  syear88,  0, 0

 !P.MULTI = [0, 0, 6, 0, 0]
 mhp1, xm80,  syear80,  1, 0
 mhp1, xm84,  syear84,  1, 0
 mhp1, xm85,  syear85,  1, 0
 mhp1, xm86,  syear86,  1, 0
 mhp1, xm87,  syear87,  1, 0
 mhp1, xm88,  syear88,  1, 0

 !P.MULTI = [0, 0, 6, 0, 0]
 mhp1, xm80,  syear80,  1, 1
 mhp1, xm84,  syear84,  1, 1
 mhp1, xm85,  syear85,  1, 1
 mhp1, xm86,  syear86,  1, 1
 mhp1, xm87,  syear87,  1, 1
 mhp1, xm88,  syear88,  1, 1

 !P.MULTI = [0, 0, 3, 0, 0]
 mhp1, xmass, syearlab, 1, 1
 mhp1, xmass, syearlab, 0, 0
 mhp1, xmass, syearlab, 1, 0

 print, '!P.POSITION: ', !P.POSITION
 print, '!P.REGION:   ', !P.REGION
 print, '!P.THICK:    ', !P.THICK
 print, '!P.XTICKLEN: ', !P.TICKLEN

 print, '!X.WINDOW:   ', !X.WINDOW
 print, '!Y.WINDOW:   ', !Y.WINDOW
 print, '!X.REGION:   ', !X.WINDOW
 print, '!Y.REGION:   ', !Y.WINDOW

 print, '!D.X_SIZE:   ', !D.X_SIZE
 print, '!D.Y_SIZE:   ', !D.Y_SIZE
 print, '!D.X_VSIZE:  ', !D.X_VSIZE
 print, '!D.Y_VSIZE:  ', !D.Y_VSIZE

DEVICE, /CLOSE					; flush buffer to PS file.
SET_PLOT, 'X'					; reset output to X windows.

end
