pro mkmassdb

;+ mkmassdb
;
; Create SMM C/P Mass database.
;
; IDL procedure
;
; Andrew L. Stanger   HAO/NCAR   25 Oct 1994
;-

@cpmassa.common

; Read SMM C/P mass measurement data.

rdcpmass1

sizedoy = size (doy)
;print, sizedoy
ncme = sizedoy (1)
;print, ncme

cmedate  = strarr (ncme)
;print, 'size (cmedate): ', size (cmedate)
odoy = '000'
ihour = 0
doyhour = indgen (24)

FOR i = 0, ncme-1 do $
BEGIN
   sdoy = strmid (doy (i), 0, 3)
   if (sdoy eq odoy)  then ihour = ihour + 1  else ihour = 0
   cmedate (i) = year (i) + '/' + sdoy + ':' + $
	      string (doyhour (ihour), FORMAT='(I2)')
   odoy = sdoy
;   print, 'i: ', i, ' doy: ', doy(i), ' sdoy: ', sdoy, $
;	  ' cmedate: ',  cmedate (i)
END

; Create new IDL database.

!PRIV = 2				; Create or modify IDL database.

dbcreate, 'cpmass', 1, 1		; Need new index & data files.

dbopen, 'cpmass', 1			; Open database for update.

; Load data into database files.

dbbuild, cmedate, xmass, err, posang, lat, width, speed, ke, pe, te

!PRIV = 0 

end

