pro mktab88

;+ Make SMM C/P CME table using file 'cme88.tab' as input.
;
; Andrew L. Stanger   HAO/NCAR   31 Aug 94
;-

dummy = ''
n  = 0
d  = ''
m  = 0.0
q  = ''
a = 0
w  = 0
s  = 0
qv = 0

doy   = strarr (117)
mass  = fltarr (117)
qual  = strarr (117)
pa    = intarr (117)
width = intarr (117)
speed = intarr (117)
lat   = intarr (117)

openr, 1, 'cme88.tab'
openw, 2, 'cme88.dat'

readf, 1, dummy
readf, 1, dummy

i = -1

while (NOT EOF (1)) do $
   begin
      i = i + 1
      readf, 1, n, d, m, q, a, w, s, FORMAT = '(I3, 5X, A8, 4X, E8.1, 4X, A2, 2X, I3, 1X, I3, 1X, I4)'
;      print, n, d, m, q, a, w, s
      doy (i)   = d
      mass (i)  = m
      qual (i)  = q
      pa (i)    = a
      width (i) = w
      speed (i) = s

      if (q eq 'P')   then qv = 100
      if (q eq 'VP')  then qv = 50
      if (q eq 'F')   then qv = 40
      if (q eq 'G')   then qv = 30
      if (q eq 'VG')  then qv = 20

      if (a ge   0 and a le  90) then $
	 begin
            lat (i) =  90 - a
	 end

      if (a gt  90 and a le 180) then $
	 begin
	    lat (i) = a -  90
	 end

      if (a gt 180 and a le 270) then $
	 begin
	    lat (i) = abs (270 - a)
	 end

      if (a gt 270 and a le 360) then $
	 begin
	    lat (i) = a - 270
	 end
      printf, 2, d, m, qv, lat (i), w, s
;      print, d, m, qv, lat (i), w, s
      print, d
   end

close, 1
close, 2

end
