pro rdcpmass

;+
; Read SMM C/P mass tables.
;
; IDL procedure
; Andrew L. Stanger   HAO/NCAR   6 September 1994
;-

@cpmass.common

label = ''
d = ''
maxcme = 500

doy    = strarr (maxcme)
xmass  = fltarr (maxcme)
err    = intarr (maxcme)
posang = intarr (maxcme)
lat    = intarr (maxcme)
width  = intarr (maxcme)
speed  = intarr (maxcme)
ke     = fltarr (maxcme)
pe     = fltarr (maxcme)
te     = fltarr (maxcme)

i = -1

; Read 1980 SMM C/P mass table.

n80 = 0
openr, 1, 'cme80.tab'
readf, 1, label, FORMAT = '(A3)'

while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2)', $
      n, d, m, q, a, l, w, s, k, p, t
   i = i + 1
   n80 = n80 + 1
   doy (i) = d
   xmass (i) = m
   err  (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   te (i) = t
endwhile
close, 1

; Read 1984 SMM C/P mass table.

n84 = 0
openr, 1, 'cme84.tab'
readf, 1, label

while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2)', $
      n, d, m, q, a, l, w, s, k, p, t
   i = i + 1
   n84 = n84 + 1
   doy (i) = d
   xmass (i) = m
   err (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   te (i) = t
endwhile
close, 1

; Read 1985 SMM C/P mass table.

n85 = 0
openr, 1, 'cme85.tab'
readf, 1, label

while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2)', $
      n, d, m, q, a, l, w, s, k, p, t
   i = i + 1
   n85 = n85 + 1
   doy (i) = d
   xmass (i) = m
   err  (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   te (i) = t
endwhile
close, 1

; Read 1986 SMM C/P mass table.

n86 = 0
openr, 1, 'cme86.tab'
readf, 1, label

while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2)', $
      n, d, m, q, a, l, w, s, k, p, t
   i = i + 1
   n86 = n86 + 1
   doy (i) = d
   xmass (i) = m
   err  (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   te (i) = t
endwhile
close, 1

; Read 1987 SMM C/P mass table.

n87 = 0
openr, 1, 'cme87.tab'
readf, 1, label

while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2)', $
      n, d, m, q, a, l, w, s, k, p, t
   i = i + 1
   n87 = n87 + 1
   doy (i) = d
   xmass (i) = m
   err  (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   te (i) = t
endwhile
close, 1

; Read 1988 SMM C/P mass table.

n88 = 0
openr, 1, 'cme88.tab'
readf, 1, label

while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2)', $
      n, d, m, q, a, l, w, s, k, p, t
   i = i + 1
   n88 = n88 + 1
   doy (i) = d
   xmass (i) = m
   err  (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   te (i) = t
endwhile
close, 1

n89 = 0

ntot = i + 1

; Create a single array of mass values for years 1980, 1984-1988.

xmass  = xmass  (0 : ntot - 1)		; resize xmass array.
doy    = doy    (0 : ntot - 1)
err    = err    (0 : ntot - 1)
posang = posang (0 : ntot - 1)
lat    = lat    (0 : ntot - 1)
width  = width  (0 : ntot - 1)
speed  = speed  (0 : ntot - 1)
ke     = ke     (0 : ntot - 1)
pe     = pe     (0 : ntot - 1)
te     = te     (0 : ntot - 1)

n = 0
doy80 = doy    (  n : n + n80 - 1)
xm80  = xmass  (  n : n + n80 - 1)
err80 = err    (  n : n + n80 - 1)
pa80  = posang (  n : n + n80 - 1)
lat80 = lat    (  n : n + n80 - 1)
wid80 = width  (  n : n + n80 - 1)
spd80 = speed  (  n : n + n80 - 1)
ke80  = ke     (  n : n + n80 - 1)
pe80  = pe     (  n : n + n80 - 1)
te80  = te     (  n : n + n80 - 1)

n = n + n80
doy84 = doy    (  n : n + n84 - 1)
xm84  = xmass  (  n : n + n84 - 1)
err84 = err    (  n : n + n84 - 1)
pa84  = posang (  n : n + n84 - 1)
lat84 = lat    (  n : n + n84 - 1)
wid84 = width  (  n : n + n84 - 1)
spd84 = speed  (  n : n + n84 - 1)
ke84  = ke     (  n : n + n84 - 1)
pe84  = pe     (  n : n + n84 - 1)
te84  = te     (  n : n + n84 - 1)

n = n + n84
doy85 = doy    (  n : n + n85 - 1)
xm85  = xmass  (  n : n + n85 - 1)
err85 = err    (  n : n + n85 - 1)
pa85  = posang (  n : n + n85 - 1)
lat85 = lat    (  n : n + n85 - 1)
wid85 = width  (  n : n + n85 - 1)
spd85 = speed  (  n : n + n85 - 1)
ke85  = ke     (  n : n + n85 - 1)
pe85  = pe     (  n : n + n85 - 1)
te85  = te     (  n : n + n85 - 1)

n = n + n85
xm86 = xmass (  n : n + n86 - 1)
doy86 = doy    (  n : n + n86 - 1)
xm86  = xmass  (  n : n + n86 - 1)
err86 = err    (  n : n + n86 - 1)
pa86  = posang (  n : n + n86 - 1)
lat86 = lat    (  n : n + n86 - 1)
wid86 = width  (  n : n + n86 - 1)
spd86 = speed  (  n : n + n86 - 1)
ke86  = ke     (  n : n + n86 - 1)
pe86  = pe     (  n : n + n86 - 1)
te86  = te     (  n : n + n86 - 1)

n = n + n86
doy87 = doy    (  n : n + n87 - 1)
xm87  = xmass  (  n : n + n87 - 1)
err87 = err    (  n : n + n87 - 1)
pa87  = posang (  n : n + n87 - 1)
lat87 = lat    (  n : n + n87 - 1)
wid87 = width  (  n : n + n87 - 1)
spd87 = speed  (  n : n + n87 - 1)
ke87  = ke     (  n : n + n87 - 1)
pe87  = pe     (  n : n + n87 - 1)
te87  = te     (  n : n + n87 - 1)

n = n + n87
xm88 = xmass (  n : n + n88 - 1)
doy88 = doy    (  n : n + n88 - 1)
xm88  = xmass  (  n : n + n88 - 1)
err88 = err    (  n : n + n88 - 1)
pa88  = posang (  n : n + n88 - 1)
lat88 = lat    (  n : n + n88 - 1)
wid88 = width  (  n : n + n88 - 1)
spd88 = speed  (  n : n + n88 - 1)
ke88  = ke     (  n : n + n88 - 1)
pe88  = pe     (  n : n + n88 - 1)
te88  = te     (  n : n + n88 - 1)

n = n + n88
;doy89 = doy    (  n : n + n89 - 1)
;xm89  = xmass  (  n : n + n89 - 1)
;err89 = err    (  n : n + n89 - 1)
;pa89  = posang (  n : n + n89 - 1)
;lat89 = lat    (  n : n + n89 - 1)
;wid89 = width  (  n : n + n89 - 1)
;spd89 = speed  (  n : n + n89 - 1)
;ke89  = ke     (  n : n + n89 - 1)
;pe89  = pe     (  n : n + n89 - 1)
;te89  = te     (  n : n + n89 - 1)

nmeas = n80 + n84 + n85 + n86 + n87 + n88 + n89

;print, 'n80/84/85/86/87/88: ', n80, n84, n85, n86, n87, n88
;print, 'nmeas: ', nmeas

end
