pro rdcpmass3

;+
; Read SMM C/P mass tables.
;
; IDL procedure
; Andrew L. Stanger   HAO/NCAR   24 April 1996
;-

@cpmassc.common

label = ''
d = ''
b = ''
maxcme = 2000

year   = strarr (maxcme)
doy    = strarr (maxcme)
xmass  = fltarr (maxcme)
err    = intarr (maxcme)
posang = intarr (maxcme)
lat    = intarr (maxcme)
width  = intarr (maxcme)
speed  = intarr (maxcme)
ke     = fltarr (maxcme)
pe     = fltarr (maxcme)
me     = fltarr (maxcme)
gb     = strarr (maxcme)
gx     = fltarr (maxcme)
hf     = fltarr (maxcme)

i = -1

;--- Read 1980 SMM C/P mass table.

n80 = 0
openr, 1, 'cme80x.tab'
readf, 1, label, FORMAT = '(A3)'
readf, 1, label, FORMAT = '(A3)'

while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2,2x,a2,2x,e6.1,2x,i1)', $
      n, d, m, q, a, l, w, s, k, p, t, b, g, h
   i = i + 1
   n80 = n80 + 1
   year (i) = '80'
   doy (i) = d
   xmass (i) = m
   err  (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   me (i) = t
   gb (i) = '=' 
   gx (i) = 0.0 
   hf (i) = 0
endwhile
close, 1

;--- Read 1984 SMM C/P mass table.

n84 = 0
openr, 1, 'cme84x.tab'
readf, 1, label
readf, 1, label

while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3, 2x, a8, 2x, e8.2, 2x, i1, 2x, i3, 2x, i3, 2x, i3, 2x, i4, 2x, e8.2, 2x, e8.2, 2x, e8.2, 2x, a2, 2x, e6.1, 2x, i1)',  $
      n, d, m, q, a, l, w, s, k, p, t, b, g, h
;   print, FORMAT = $
;'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2,2x,a2,2x,e6.1,2x,i1)', $
;        n, d, m, q, a, l, w, s, k, p, t, b, g, h
   i = i + 1
   n84 = n84 + 1
   year (i) = '84'
   doy (i) = d
   xmass (i) = m
   err (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   me (i) = t
   gb (i) = b
   gx (i) = g
   hf (i) = h
endwhile
close, 1

;--- Read 1985 SMM C/P mass table.

n85 = 0
openr, 1, 'cme85x.tab'
readf, 1, label
readf, 1, label

while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2,2x,a2,2x,e6.1,2x,i1)', $
      n, d, m, q, a, l, w, s, k, p, t, b, g, h
   i = i + 1
   n85 = n85 + 1
   year (i) = '85'
   doy (i) = d
   xmass (i) = m
   err  (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   me (i) = t
   gb (i) = b
   gx (i) = g
   hf (i) = h
endwhile
close, 1

;--- Read 1986 SMM C/P mass table.

n86 = 0
openr, 1, 'cme86x.tab'
readf, 1, label
readf, 1, label

while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2,2x,a2,2x,e6.1,2x,i1)', $
      n, d, m, q, a, l, w, s, k, p, t, b, g, h
   i = i + 1
   n86 = n86 + 1
   year (i) = '86'
   doy (i) = d
   xmass (i) = m
   err  (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   me (i) = t
   gb (i) = b
   gx (i) = g
   hf (i) = h
endwhile
close, 1

;--- Read 1987 SMM C/P mass table.

n87 = 0
openr, 1, 'cme87x.tab'
readf, 1, label
readf, 1, label

while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2,2x,a2,2x,e6.1,2x,i1)', $
      n, d, m, q, a, l, w, s, k, p, t, b, g, h
   i = i + 1
   n87 = n87 + 1
   year (i) = '87'
   doy (i) = d
   xmass (i) = m
   err  (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   me (i) = t
   gb (i) = b
   gx (i) = g
   hf (i) = h
endwhile
close, 1

;--- Read 1988 SMM C/P mass table.

n88 = 0
openr, 1, 'cme88x.tab'
readf, 1, label
readf, 1, label

while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2,2x,a2,2x,e6.1,2x,i1)', $
      n, d, m, q, a, l, w, s, k, p, t, b, g, h
   i = i + 1
   n88 = n88 + 1
   year (i) = '88'
   doy (i) = d
   xmass (i) = m
   err  (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   me (i) = t
   gb (i) = b
   gx (i) = g
   hf (i) = h
endwhile
close, 1

;--- Read 1989 SMM C/P mass table.

n89 = 0
openr, 1, 'cme89x.tab'
readf, 1, label
readf, 1, label

while (NOT EOF (1)) do $
begin
   readf, 1, FORMAT = $
'(i3,2x,a8,2x,e8.2,2x,i1,2x,i3,2x,i3,2x,i3,2x,i4,2x,e8.2,2x,e8.2,2x,e8.2,2x,a2,2x,e6.1,2x,i1)', $
      n, d, m, q, a, l, w, s, k, p, t, b, g, h
   i = i + 1
   n89 = n89 + 1
   year (i) = '89'
   doy (i) = d
   xmass (i) = m
   err  (i) = q
   posang (i) = a
   lat (i) = l
   width (i) = w
   speed (i) = s
   ke (i) = k
   pe (i) = p
   me (i) = t
   gb (i) = b
   gx (i) = g
   hf (i) = h
endwhile
close, 1

ntot = i + 1

; Create a single array of mass values for years 1980, 1984-1989.

xmass  = xmass  (0 : ntot - 1)		; resize xmass array.
year   = year   (0 : ntot - 1)
doy    = doy    (0 : ntot - 1)
err    = err    (0 : ntot - 1)
posang = posang (0 : ntot - 1)
lat    = lat    (0 : ntot - 1)
width  = width  (0 : ntot - 1)
speed  = speed  (0 : ntot - 1)
ke     = ke     (0 : ntot - 1)
pe     = pe     (0 : ntot - 1)
me     = me     (0 : ntot - 1)
gb     = gb     (0 : ntot - 1)
gx     = gx     (0 : ntot - 1)
hf     = hf     (0 : ntot - 1)

n = 0
doy80 = doy    (  n : n + n80 - 1)
xm80  = xmass  (  n : n + n80 - 1)
err80 = err    (  n : n + n80 - 1)
pa80  = posang (  n : n + n80 - 1)
lat80 = lat    (  n : n + n80 - 1)
wid80 = width  (  n : n + n80 - 1)
spd80 = speed  (  n : n + n80 - 1)
ke80  = ke     (  n : n + n80 - 1)
pe80  = pe     (  n : n + n80 - 1)
me80  = me     (  n : n + n80 - 1)
gb80  = gb     (  n : n + n80 - 1)
gx80  = gx     (  n : n + n80 - 1)
hf80  = hf     (  n : n + n80 - 1)

n = n + n80
doy84 = doy    (  n : n + n84 - 1)
xm84  = xmass  (  n : n + n84 - 1)
err84 = err    (  n : n + n84 - 1)
pa84  = posang (  n : n + n84 - 1)
lat84 = lat    (  n : n + n84 - 1)
wid84 = width  (  n : n + n84 - 1)
spd84 = speed  (  n : n + n84 - 1)
ke84  = ke     (  n : n + n84 - 1)
pe84  = pe     (  n : n + n84 - 1)
me84  = me     (  n : n + n84 - 1)
gb84  = gb     (  n : n + n80 - 1)
gx84  = gx     (  n : n + n80 - 1)
hf84  = hf     (  n : n + n80 - 1)

n = n + n84
doy85 = doy    (  n : n + n85 - 1)
xm85  = xmass  (  n : n + n85 - 1)
err85 = err    (  n : n + n85 - 1)
pa85  = posang (  n : n + n85 - 1)
lat85 = lat    (  n : n + n85 - 1)
wid85 = width  (  n : n + n85 - 1)
spd85 = speed  (  n : n + n85 - 1)
ke85  = ke     (  n : n + n85 - 1)
pe85  = pe     (  n : n + n85 - 1)
me85  = me     (  n : n + n85 - 1)
gb85  = gb     (  n : n + n80 - 1)
gx85  = gx     (  n : n + n80 - 1)
hf85  = hf     (  n : n + n80 - 1)

n = n + n85
xm86 = xmass (  n : n + n86 - 1)
doy86 = doy    (  n : n + n86 - 1)
xm86  = xmass  (  n : n + n86 - 1)
err86 = err    (  n : n + n86 - 1)
pa86  = posang (  n : n + n86 - 1)
lat86 = lat    (  n : n + n86 - 1)
wid86 = width  (  n : n + n86 - 1)
spd86 = speed  (  n : n + n86 - 1)
ke86  = ke     (  n : n + n86 - 1)
pe86  = pe     (  n : n + n86 - 1)
me86  = me     (  n : n + n86 - 1)
gb86  = gb     (  n : n + n80 - 1)
gx86  = gx     (  n : n + n80 - 1)
hf86  = hf     (  n : n + n80 - 1)

n = n + n86
doy87 = doy    (  n : n + n87 - 1)
xm87  = xmass  (  n : n + n87 - 1)
err87 = err    (  n : n + n87 - 1)
pa87  = posang (  n : n + n87 - 1)
lat87 = lat    (  n : n + n87 - 1)
wid87 = width  (  n : n + n87 - 1)
spd87 = speed  (  n : n + n87 - 1)
ke87  = ke     (  n : n + n87 - 1)
pe87  = pe     (  n : n + n87 - 1)
me87  = me     (  n : n + n87 - 1)
gb87  = gb     (  n : n + n80 - 1)
gx87  = gx     (  n : n + n80 - 1)
hf87  = hf     (  n : n + n80 - 1)

n = n + n87
xm88 = xmass (  n : n + n88 - 1)
doy88 = doy    (  n : n + n88 - 1)
xm88  = xmass  (  n : n + n88 - 1)
err88 = err    (  n : n + n88 - 1)
pa88  = posang (  n : n + n88 - 1)
lat88 = lat    (  n : n + n88 - 1)
wid88 = width  (  n : n + n88 - 1)
spd88 = speed  (  n : n + n88 - 1)
ke88  = ke     (  n : n + n88 - 1)
pe88  = pe     (  n : n + n88 - 1)
me88  = me     (  n : n + n88 - 1)
gb88  = gb     (  n : n + n80 - 1)
gx88  = gx     (  n : n + n80 - 1)
hf88  = hf     (  n : n + n80 - 1)

n = n + n88
doy89 = doy    (  n : n + n89 - 1)
xm89  = xmass  (  n : n + n89 - 1)
err89 = err    (  n : n + n89 - 1)
pa89  = posang (  n : n + n89 - 1)
lat89 = lat    (  n : n + n89 - 1)
wid89 = width  (  n : n + n89 - 1)
spd89 = speed  (  n : n + n89 - 1)
ke89  = ke     (  n : n + n89 - 1)
pe89  = pe     (  n : n + n89 - 1)
me89  = me     (  n : n + n89 - 1)
gb89  = gb     (  n : n + n80 - 1)
gx89  = gx     (  n : n + n80 - 1)
hf89  = hf     (  n : n + n80 - 1)

n = n + n89

nmeas = n80 + n84 + n85 + n86 + n87 + n88 + n89

;print, 'n80/84/85/86/87/88/89: ', n80, n84, n85, n86, n87, n88, n89
;print, 'nmeas: ', nmeas

end
