PRO df_annotate, filename1, filename2, no_minus=no_minus,  $
		img=img, hdr1=hdr1, hdr2=hdr2

  ; Need to get the right operating system so that output looks
  ; OK.  Seems that we get two different looks depending on whether
  ; we are on a SUN or SGI workstation.

  spawn, 'uname -s',  opsys
  IF (opsys[0] EQ 'IRIX') THEN BEGIN
    ch_size=.8
    title_size=1.0
  ENDIF ELSE BEGIN
    title_sz=2.0
    ch_size=1.5
  ENDELSE

  months=['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct' $
        , 'Nov', 'Dec']

  IF (NOT KEYWORD_SET(img)) THEN BEGIN
   time1 = STRMID (filename2, 7, 2) + ':' + STRMID (filename2, 10, 2)
   time2 = STRMID (filename1, 7, 2) + ':' + STRMID (filename1, 10, 2)
   doy   = STRMID (filename1, 3, 3)
   year  = STRMID (filename1, 0, 2)

   IF (STRMID (filename1, 0, 4) EQ 'mlso') THEN BEGIN
     doy  = FIX (STRMID (filename1, 17, 3))
     year = FIX (STRMID (filename1, 14, 2))
     doy2date, FIX (doy), FIX (year), month, day
     print, month, day
   ENDIF ELSE $
      doy2date, FIX (doy), FIX (year), month, day

   date_str = STRING (day) + '-' + months (month-1) + '-' + STRING (year)
   XYOUTS, 0, 490, 'HAO MK3 K-Coronameter', CHARSIZE=title_sz, /DEVICE
   XYOUTS, 0, 475, STRCOMPRESS (date_str, /REMOVE_ALL), CHARSIZE=ch_size, $
				/DEVICE
   IF (KEYWORD_SET (no_minus)) THEN $
     XYOUTS, 430, 490, time2+'_UT', CHARSIZE=ch_size, /DEVICE $
   ELSE $
     XYOUTS, 350, 490, time2+' minus '+time1, CHARSIZE=ch_size, /DEVICE
   XYOUTS, 0, 3, 'North is straight up', CHARSIZE=ch_size, /DEVICE
 ENDIF

 IF (KEYWORD_SET (img)) THEN BEGIN
   sz    = SIZE (img)
   xsz   = sz (1)
   ysz   = sz (2)
   time1 = fxpar (hdr1, 'TIME-OBS')
   time2 = fxpar (hdr2, 'TIME-OBS')
   date1 = fxpar (hdr1, 'DATE-OBS')
   date2 = fxpar (hdr2, 'DATE-OBS')
   tele  = fxpar (hdr2, 'TELESCOP')
   inst  = fxpar (hdr2, 'INSTRUME')
   det   = fxpar (hdr2, 'DETECTOR')

   time1 = STRMID (time1, 0, 5)
   time2 = STRMID (time2, 0, 5)

   IF (tele EQ 'MK3     ') THEN BEGIN
    date2 = STR_SEP (date2, '-')
    tmp_str = STRING (date2(0)) + '-' + months (date2(1)-1) + '-' + $
	      STRING (date2(2))
    date2 = tmp_str
   ENDIF

   IF (det NE '') THEN $
     XYOUTS, 0, ysz-15, tele+inst+det, CHARSIZE = ch_size, /DEVICE ELSE $
       XYOUTS, 0, ysz-15, tele+inst, CHARSIZE = ch_size, /DEVICE 
   XYOUTS, 0, ysz-35, date2, CHARSIZE = ch_size, /DEVICE
   ;XYOUTS, 0, ysz-55, time2+' minus '+time1, CHARSIZE=ch_size, /DEVICE
   XYOUTS, xsz-162, ysz-15, time2+' minus '+time1, CHARSIZE=ch_size, /DEVICE
   XYOUTS, 0, 10, 'North is straight up', CHARSIZE=ch_size, /DEVICE
 ENDIF

END
