;
;	CALLING SEQUENCE: mn=it_getmin(image,header)
;
;	PARAMETERS:	  image is the image array to read min and max from.
;			  header is the associated .fts header
;
;	NOTES:	 	  This function was written to extract an appropriate min and max
;			  value to use in scaling DPMON images.  It turns out that prior 
;			  to 1996, the DATAMIN and DATAMAX keywords had inaccurate values
;			  and the scaling of the images was difficult using these values.
;			  This procedure returns the min value for use with the proper
;			  time period.
;
;	HISTORY:	  Drafted by Tony Darnell, 10-APR-97
;
;
FUNCTION it_getmin,image,header

  date=fxpar(header,'DATE-OBS')
  year=FIX(STRMID(date,6,2))
  month=FIX(STRMID(date,3,2))
  print,year,month
  IF (year LT 96) THEN BEGIN
    curr_min=MIN(image)
    nimsum=fxpar(header,'NIMSUM')
    mn=curr_min/nimsum
  ENDIF  $
  ELSE   $
    mn = fxpar(header,'DATAMIN')
RETURN,mn
END
