;
;	CALLING SEQUENCE:  mx=it_getmax(image,hdu)
;
;PARAMETERS:	  image is the image array to read min and max from.
;		  header is the associated .fts header
;
;NOTES:	  This function was written to extract an appropriate min and max
;	  value to use in scaling DPMON images.  It turns out that prior 
;	  to 1996, the DATAMIN and DATAMAX keywords had inaccurate values
;	  and the scaling of the images was difficult using these values.
;	  This procedure extracts a max value from a swath in the center of
;	  the data.
;
;HISTORY:	  Drafted by Tony Darnell, 10-APR-97
;
FUNCTION it_getmax,image,multiplier

  sz=SIZE(image)
  image(*,0)=0
  image(*,1)=0
  ycen=sz(2)/2
  xcen=sz(1)/2
  temp_min=MAX(image(0:sz(1)-1,ycen))*multiplier
  mx=temp_min

RETURN,mx
END
