/*
 *	dev_defs.h
 *
 *	Defines needed to access PMon devices on QBus
 *
 *	David Elmore
 *
 *	Wed Oct 20 20:52:33 GMT 1993
 */

#include	"/opt/dPMon/include/dpmon.h"

/***** structure used internally to dpmon code *********/
struct	device
	{
	unsigned	short	*com_addr;
	unsigned	short	com_lsb;
	unsigned	short	com_mask;
	unsigned	short	*stat_addr;
	unsigned	short	stat_bit;
	unsigned	short	position;
	unsigned	short	lock;
	};

#define	NUM_DEV		8
#define DEV_BUSY	-1
#define	DIR		0x100

/* QBus addresses for command and status registers */
#define	COMADDR0	0xeff2		/* 0xe01c */
#define	COMADDR1	0xeff2		/* 0xe01e */
#define	STATADDR	0xeff4		/* 0xe010 */

/******* Definitions from here down used for dpmon_header.Optics[dev] ******/
/* where dev is one of the next 8 entries */

/* Device names */
#define	BANDPASS	0	/*Bandpass filter, unused */
#define	FOUR		1	/*Aperture wheel */
#define	HALLE		2	/*Halle Lyot birefringent filter */
#define	EIGHT		3	/*Filter wheel */
#define	SIX		4	/*Occulting wheel */
#define	PICTURE		5	/*Take a picture, unused */
#define	STEPS		6	/*Acme aperture steps, unused */
#define	FLIP		7	/*Flip mirror position, unused */

/***** Legal values for an Optics entry are as follows *****/

/* Halle filter positions */
#define	IN		1
#define	OUT		0

/* 4 position aperture wheel positions */
#define APERTURE_CLEAR	0	/*clear aperture*/
#define DIFFUSER	1	/*flat field diffuser */
#define OPAL		2	/* maybe an opal someday */
#define POLARIZER	3	/* maybe some polarizer too */

/* 8 position filter wheel positions */
#define	FAR_RED		0	/*658.1nm */
#define	FAR_BLUE	1	/*654.0nm */
#define	BLOCKED		2	/* light blocked*/
#define	BLOCKED3	3	/* light blocked*/
#define	BLOCKED4	4	/* light blocked*/
#define	NEAR_BLUE	5	/*655.5nm */
#define	HALPHA		6	/*656.3nm */
#define	NEAR_RED	7	/*657.1nm */

/* 6 position occulting wheel positions */
#define	WEDGE		0	/* calibration wedge */
#define	OCCULT_2_0	1	/* 2 R0 offset occulter */
#define	CLEAR		2	/* clear */
#define	OCCULT_1_25	3	/* 1.25 R0 offset occulter */
#define	OCCULT		4	/* Centered occulter for limb images*/
#define	RETICLE		5	/* Calibration reticle */

#define	DEV_TIMEOUT	10	/* if this position reported 
				the device timed out before arriving
				at any known position */


