;
;  This function makes some changes to the header in LASCO images so that
;  dt.pro can compost the image with other datasets.
;  Many parameters are 'hard wired' because the LASCO team uses huge orbital
;  tables to look up things like pixels per solar radius, x, y, centers etc.
;

FUNCTION it_lasco,header

; ---Insert CRRADIUS, pixels per solar radius

  platescl = fxpar(header,'PLATESCL')
  ;radius = 960/platescl
  radius = 975.3/platescl
  fxaddpar,header,'CRRADIUS',radius

; ---Insert x and y centers (only works for 1024x1024 images)

   xsz=fxpar(header,'NAXIS1')
   ysz=fxpar(header,'NAXIS2')
   xsz=STRING(xsz)
   ysz=STRING(ysz)
   IF (xsz NE ysz) THEN BEGIN
      img_err=WIDGET_MESSAGE('Image size of '+xsz+' by '+ysz+' is invalid', $
         /ERROR,TITLE='Bummer')
      RETURN,header
   ENDIF
   xcen=512.6
   ycen=505.3

  fxaddpar,header,'CRPIX1',xcen
  fxaddpar,header,'CRPIX2',ycen

  RETURN,header
END
