;
;  CALLING SEQUENCE:	image=it_yoh512(img,hdu)
;
;  PARAMETERS:		img is the 256 x 256 YOHKOH image array, hdu is the
;			associated header.
;
;  NOTES:		This function will resize the 256x256 image array
;			in the YOHKOH dataset to a 512x512 image array
;			and make the appropriate changes in the header
;			associated with that image.  This function was
;			designed to be used primarily with composite 
;			imaging.
;
;  RETURN TYPE:		INTARR
;
;  CALLS:		fxaddpar,congrid
;
;  HISTORY:		Drafted by Tony Darnell, 2-JUN-97
;

FUNCTION it_yoh512,image,header

  ;print, SIZE(image)
  fxaddpar,header,'RADIUS',194.83951
  old_xcen=fxpar(header,'CRPIX1')
  old_ycen=fxpar(header,'CRPIX2')
  fxaddpar,header,'CRPIX1',old_xcen*2
  fxaddpar,header,'CRPIX2',old_ycen*2
  image=CONGRID(image,512,512)
  RETURN,image
END
