/* iproc.h
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Structure definitions for `scan.c' program.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * Yoda Sun-4/280
 * 16 February 1990
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#define gMAXROW  511
#define gMINROW  0
#define gMAXCOL  511
#define gMINCOL  0
#define gMAXCHAN 3
#define gMINCHAN 0
#define gMAXOVL  11
#define gMINOVL  8
#ifndef NULL
#define NULL	'\0' 
#endif

/* The structure GRINNELL defines a window on the image display device.	*/
/* _GD is the currently active window on the display device.		*/

typedef struct GRINNELL
   {
   int device;	/* image display device number	*/
   int channel;	/* image channel number  	*/
   int overlay;	/* overlay channel number      	*/
   int x;	/* initial column (x axis)     	*/
   int y;	/* initial row (y axis)		*/
   int dx;	/* window size in x pixels   	*/
   int dy;	/* window size in y pixels	*/
   };
struct GRINNELL _GD, *gnewwin();

/* The structure IMAGE defines a two dimensional displayable array   	*/

typedef struct IMAGE 
   { 
   char	*name;	/* the image name				*/
   char	*type;	/* the image type .. {SMM,ATM,MARK3....}	*/
   unsigned 
   char *addr;	/* address of first pixel in the image		*/
   int	dx;	/* the size in x pixels				*/
   int	dy;	/* the size in y pixels				*/
   int	bppx;	/* bytes per pixel				*/
   int	bytord;	/* byte order: 0 -> Sun-4, 1 -> DEC		*/
   float pixsr;	/* pixels per solar radius			*/
   float scale;	/* Brightness scale factor			*/
   float degnor;/* position of north polar axis relative to	*/
  		/* the display screen vertical (tilt of axis)	*/
   int	ip,lp;	/* initial/final horizontal pixel display area	*/
   int  ir,lr;	/* initial/final vertical pixel display area	*/
   int	year;	/* DATE: year (e.g. '1984')			*/
   int	doy;	/* DATE: day of the year			*/
   int	hour;	/* TIME: hours					*/
   int	minute;	/* TIME: minute					*/
   int	sec;	/* TIME: seconds				*/
   int	frameno;/* Frame number					*/ 
   int	ires;	/* Image resolution				*/
   int	quan;	/* Image quantity				*/
   int	roll;	/* Roll.					*/
   int	exp;	/* Image exposure				*/
   int	ism;	/* Sector mirror position			*/
   int	ifw;	/* Filter wheel position.			*/
   int	ipw;	/* Polaroid wheel position.			*/
   int	icm;	/* Calibration mirror position.			*/
   int	iglpos;	/* 5303 filter position.			*/
   int	iglstw;	/* 5303 stow flag.				*/
   int	dtype;	/* image data type.				*/
		/* 1:DN, 2:equiv.sec, 3:cal, 4:den, 5:deltaB/B	*/
		/* 6:pol, 7:pB, 8:Bradial, 9:Btangential.	*/
   int	str;	/* Stray Light flag (=1 => removed).		*/
   int	vig;	/* Vignetting flag (=1 => removed).		*/
   int	fc;	/* F-corona flag (=1 => removed).		*/
   int	dsk;	/* Disk registration flag (=1 => corrected).	*/
   float xcen;	/* Image center position in horizontal pixels.	*/ 
   float ycen;	/* Image center position in vertical pixels.	*/
   };
struct IMAGE  *make(),  *makesmm();
