/* ----------------------------------------------------------------------------
 * B I T S . C		- This file contains several bit operator routines.
 *
 * functions included here, 
 *   getbits  () - get n bits from position p in unsigned short int x.
 *   putbits  () - turn bit at position p on (=1) in unsigned short int x.
 *   rembits  () - turn off bit (=0) at position p in unsigned short int x.
 *   bitcount () - returns the number of bits = 1 in a word.
 *   lastbit  () - returns the position of the highest order 1 bit in a word.
 * ----------------------------------------------------------------------------
 */

unsigned short int
getbits (x, p, n)			/* get n bits from position p */

unsigned short int x, p, n;
{
    return (( x >> (p+1-n)) & ~(~0 << n));
}

unsigned short int
putbits (x, p)			/* put bit at position p   */

unsigned short int x, p;
{
    unsigned short int mask;

    mask = (1 << p);
    x |= mask;
    return ( x );
}


unsigned short int
rembits (x, p)			/* put 0 bit at position p  */

unsigned short int x, p;
{
    unsigned short int putbits (), mask;
    mask = 0;

    mask = putbits (mask, p);
    mask = ~mask;
    x &= mask;
    return ( x );
}

/* ----------------------------------------------------------------------------
 * B I T C O U N T ()	- Returns the number of bits equal to 1 in the 
 *			  unsigned int N.
 * ----------------------------------------------------------------------------
 */

bitcount (n)

unsigned n;
{
    int b;
	
    for (b = 0; n != 0; n >>= 1)
	if (n & 01)
	    b++;
    return (b);
}


/* ---------------------------------------------------------------------------
 * L A S T B I T ()	- Returns the position (1 to sizeof (unsigned short))
 *			  of the highest order 1 bit in unsigned int N.
 * ---------------------------------------------------------------------------
 */

lastbit (n)

unsigned int n;
{
    int b, bit;
	
    for (b = 0; b < sizeof (int); b++)
	{
	bit = n << 1;
	if (bit & 01)
	return (b);
	}
    return (-1) ;
}

