/*
 *	message.h
 *
 *	Define the message queues used by the dPMon routines
 *
 *	David Elmore
 *
 *	Mon Dec 13 21:04:38 GMT 1993
 */

#include        <stdio.h>
#include        <sys/types.h>
#include        <sys/ipc.h>
#include        <sys/msg.h>

#define	MSG_NBYTES		25
#define NUM_QUEUE		30

#define	DISPLAY_COMMAND		1
#define	TAPE_COMMAND		2
#define	DISK_COMMAND		3
#define	OPTICS_COMMAND		4
#define	PROGRAM_COMMAND		5
#define	ABORT_COMMAND		6
#define	CAL_COMMAND		7
#define	CAMERA_COMMAND		8

#define	CAMERA_STATUS		10
#define	DISPLAY_STATUS		11
#define	TAPE_STATUS		12
#define	DISK_STATUS		13
#define	OPTICS_STATUS		14
#define	PROGRAM_STATUS		15
#define	ABORT_STATUS		16
#define	CAL_STATUS		17

#define LIGHT_PATH		20
#define IMAGE_MEMORY		21
#define WAIT_DISPLAY		22
#define WAIT_CAMERA		23
#define WAIT_TAPE		24
#define WAIT_DISK		25
#define WAIT_OPTICS		26

#ifdef	MESSAGE
int	msgqid[NUM_QUEUE] = {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
			     -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
			     -1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
struct	msgbuf	*msgp;
#else
extern	int	msgqid[NUM_QUEUE];
extern	struct	msgbuf	*msgp;
#endif
