/*
 *  dpmobs.h
 *
 *  General defs DPM
 *
 *  David Elmore
 *
 * Thu Nov  2 08:08:37 MST 1995
 *
 */

/**** Items used for acos_header.Version *****/
#define    IS_DPMON    0
#define    IS_LOWK      1
#define    IS_CHIP      2

/* acos_header.Type */
/* WSR File Types Wavelength, Source, Reduction */
/* Reduction field, occupies 1's position of acos_header.Type*/

#define    REDUCTION_x    0    /*  Undefined reduction, see header */
#define    REDUCTION_r    1    /*  Raw data */
#define    REDUCTION_c    2    /*  Calibrated data, bias and gain corrected */
#define    REDUCTION_l    3    /*  Limb darkening corrected (and cal) */
#define    REDUCTION_d    4    /*  Ratio (divided) image */
#define    REDUCTION_m    5    /*  Contrast (minus) image */
#define    REDUCTION_t    6    /*  Rotational trends removed image. */
#define    REDUCTION_h    7    /*  rotated to heliocentric coordinates. */

/* Source field , occupies 10's position of acos_header.Type*/

#define    SOURCE_x    0    /*  Undefined source, see header */
#define    SOURCE_s    1    /*  Sun, full-disk thereof */
#define    SOURCE_l    2    /*  Limb, occulted Sun */
#define    SOURCE_o    3    /*  Opal */
#define    SOURCE_d    4    /*  Diffuser */
#define    SOURCE_b    5    /*  Bias (dark) */
#define    SOURCE_c    6    /*  Calibration optics, see header */
#define    SOURCE_f    7    /*  Flat field image */

/* Wavelength field , occupies 100's position of acos_header.Type*/

#define    WAVELENGTH_x  0    /*  Undefined wavelength, see header */
#define    WAVELENGTH_h  1    /*  Helium I, 1083.03nm */
#define    WAVELENGTH_c  2    /*  Continuum near Helium I */
#define    WAVELENGTH_m  3    /*  Helium I, 1082.91 minor componenet */
#define    WAVELENGTH_w  4    /*  Water vapor near Helium I */
#define    WAVELENGTH_a  5    /*  Hydrogen-alpha 656.2808 nm */
#define    WAVELENGTH_b  6    /*  Blue wing of H-alpha */
#define    WAVELENGTH_r  7    /*  Red wing of H-alpha */
#define    WAVELENGTH_k  8    /*  K-corona wavelength 657.4nm */
#define    WAVELENGTH_s  9    /*  Other spectral region, see header */

