/* optics_names.h
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * DPM definitions needed for device names and positons.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   14 Feb 1994
 * 10 Sep 1997: Add wcode_str, scode_str, rcode_str.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#define		NUM_TYPE	 9
#define		NUM_WCODE	10
#define		NUM_SCODE	 8
#define		NUM_RCODE	 6
#define		NUM_DEVICES	 8
#define		NUM_POSITIONS	11

#ifdef DPM
char	*type_str [NUM_TYPE] = {
			"Other",
			"Disc",
			"Limb",
			"Reference",
			"Diffuser",
			"Disc dark",
			"Limb dark",
			"Diffuser dark",
			"Reference dark" };

char	*wcode_str [NUM_WCODE] =
			{ "x", "h", "c", "m", "w", "a", "b", "r", "k", "s" } ;

char	*scode_str [NUM_SCODE] =
			{ "x", "s", "l", "o", "d", "b", "c", "f" } ;

char	*rcode_str [NUM_RCODE] =
			{ "x", "r", "c", "l", "d", "m" } ;

char	*device_str[NUM_DEVICES] = {
			"Bandpass",
			"Aperture Wheel",
			"Halle Filter",
			"Filter Wheel",
			"Occulting Wheel",
			"Picture",
			"Steps",
			"Flip"};

char	*device_position_str [NUM_DEVICES][NUM_POSITIONS] = {
"unk","unk","unk","unk","unk","unk","unk","unk",
	"unk","unk","timeout",
"clear","diffuser","opal","polarizer","unk","unk","unk","unk",
	"unk","unk","timeout",
"in","out","unk","unk","unk","unk","unk","unk",
	"unk","unk","timeout",
"658.1","654.0","blocked","blocked","blocked","655.5","656.3","657.1",
	"unk","unk","timeout",
"wedge","2.0R0_occult","clear","1.25R0_occult","limb","reticle", "unk","unk",
	"unk","unk","timeout",
"unk","unk","unk","unk","unk","unk","unk","unk",
	"unk","unk","timeout",
"unk","unk","unk","unk","unk","unk","unk","unk",
	"unk","unk","timeout",
"unk","unk","unk","unk","unk","unk","unk","unk",
	"unk","unk","timeout"};

#else
extern	char	*type_str   [NUM_TYPE] ;
extern	char	*wcode_str  [NUM_WCODE] ;
extern	char	*scode_str  [NUM_SCODE] ;
extern	char	*rcode_str  [NUM_RCODE] ;
extern	char	*device_str [NUM_DEVICES] ;
extern	char	*device_position_str [NUM_DEVICES][NUM_POSITIONS] ;
#endif
