/* hdu_clear.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Set FITS header parameters back to default values.
 * 22 Dec 1997: Initialize naxis1=naxis2=naxis3=naxis4=1 (instead of zero).
 * 13 November 1998: calmir, colorfil, glfilter, polaroid & sector
 *                   changed from sparam to cparam.
 *                   optdev1 -> optdev8 changed to optdev01 -> optdev08.
 *                   optpos1 -> optpos8 changed to optpos01 -> optpos08.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include "/home/stanger/lib/include/fitslib.ext"

hdu_clear ()

{
simple   = 0 ;  /* SIMPLE ? = 1, T; = 0, F; = -1, not defined. */
extend   = 0 ;  /* EXTEND ? = 1, T, = 0, F; = -1, not defined. */
blocked  = 0 ;  /* =0, NO; =1, YES. */
end_fts  = 0 ;  /* END encountered ? =0, NO; =1, YES. */

bitpix   = 0 ;  /* # bitx/pixel: 8,16,32: int; -16,-32: float. */
naxis    = 0 ;          /* # axes. */
naxis1   = 1 ;          /* # elements along axis 1. */
naxis2   = 1 ;          /* # elements along axis 2. */
naxis3   = 1 ;          /* # elements along axis 3. */
naxis4   = 1 ;          /* # elements along axis 4. */

pcount   = 0 ;          /* pcount. */
gcount   = 0 ;          /* gcount. */

strcpy (xtension, "");         /* Extension name. */

strcpy (date    , "") ;    /* DD/MM/YY : file created */
strcpy (date_obs, "") ;    /* DD/MM/YY : observation */
strcpy (date_cal, "") ;    /* DD/MM/YY : calibration */
strcpy (date_opc, "") ;    /* DD/MM/YY : MK3 cal 0 */

strcpy (time_fts, "") ;    /* HH/MM/SS : file created */
strcpy (time_obs, "") ;    /* HH/MM/SS : observation */
strcpy (time_cal, "") ;    /* HH/MM/SS : calibration */
strcpy (time_opc, "") ;    /* HH/MM/SS : MK3 cal 0 */

strcpy (origin  , "") ;    /* Institution name. */
strcpy (author  , "") ;    /* Compilation author's name. */
strcpy (referenc, "") ;    /* Reference where assoc. data are published. */
strcpy (telescop, "") ;    /* Telescope   name. */
strcpy (instrume, "") ;    /* Instrument  name. */
strcpy (observer, "") ;    /* Observer's  name. */
strcpy (object  , "") ;    /* Object      name. */

equinox  = 0.0 ;  /* Equinox (year) for celestial coord system. */
epoch    = 0.0 ;  /* Epoch   (year) for celestial coord system. */

strcpy (extname, "") ;    /* Extension name.      */
extver   = 0 ;          /* Extension version.   */
extlevel = 0 ;          /* Extension level.     */

blank    = 0 ;          /* Blank value. */

b_scale  = 1.0 ;        /* Multiplicative scaling value. */
b_zero   = 0.0 ;        /* Additive scaling value. */

strcpy (bunit , "") ;    /* Name of brightness (magnitude) units. */

strcpy (ctype1, "") ;    /* Name of coordinate axis 1. */
strcpy (ctype2, "") ;    /* Name of coordinate axis 2. */
strcpy (ctype3, "") ;    /* Name of coordinate axis 3. */
strcpy (ctype4, "") ;    /* Name of coordinate axis 4. */

crpix1   = 0.0 ;	/* Location of reference point axis 1 [index]. */
crpix2   = 0.0 ;	/* Location of reference point axis 2 [index]. */
crpix3   = 0.0 ;	/* Location of reference point axis 3 [index]. */
crpix4   = 0.0 ;	/* Location of reference point axis 4 [index]. */

crradius = 0.0 ;	/* Rsun [pixels]. */

crval1   = 0.0 ;	/* Location of reference point axis 1 [coord 1]. */
crval2   = 0.0 ;	/* Location of reference point axis 2 [coord 2]. */
crval3   = 0.0 ;	/* Location of reference point axis 3 [coord 3]. */
crval4   = 0.0 ;	/* Location of reference point axis 4 [coord 4]. */

cdelt1   = 0.0 ;	/* Increment between pixels axis 1 [coord 1]. */
cdelt2   = 0.0 ;	/* Increment between pixels axis 2 [coord 2]. */
cdelt3   = 0.0 ;	/* Increment between pixels axis 3 [coord 3]. */
cdelt4   = 0.0 ;	/* Increment between pixels axis 4 [coord 4]. */

crota1   = 0.0 ;	/* Rotation angle of axis 1 [coord 1]. */
crota2   = 0.0 ;	/* Rotation angle of axis 2 [coord 2]. */
crota3   = 0.0 ;	/* Rotation angle of axis 3 [coord 3]. */
crota4   = 0.0 ;	/* Rotation angle of axis 4 [coord 4]. */

datamin  = 0.0 ;	/* Minimum physical value in data array. */
datamax  = 0.0 ;	/* Maximum physical value in data array. */

dispmin  = 0.0 ;	/* Minimum display value in data array. */
dispmax  = 0.0 ;	/* Maximum display value in data array. */

strcpy (disp_dir, "" );	/* Display direction: R/L U/D O/I */

strcpy (diraxis1, "") ;	/* Scan direction axis 1: "left" or "right". */
strcpy (diraxis2, "") ;	/* Scan direction axis 2: "up"   or "down".  */
strcpy (diraxis3, "") ;	/* Scan direction axis 3. "in"   or "out"    */
strcpy (diraxis4, "") ;	/* Scan direction axis 4. "plus" or "minus"  */

strcpy (dataform, "") ;	/* Data type description. */

code_cp  = 0 ;          /* SMM C/P data code. */
code_dpm = 0 ;          /* MLSO DPM data code. */
code_mk3 = 0 ;          /* MLSO MK3 data code. */
code_obs = 0 ;          /* observation code. */

strcpy (type_cp , "") ;/* SMM C/P data type. */
strcpy (type_dpm, "") ;	/* MLSO DPM data type. */
strcpy (type_mk3, "") ;	/* MLSO MK3 data type. */
strcpy (type_obs, "") ;	/* Type of observation. */
strcpy (type1,    "") ;	/* Type 1. */
strcpy (type2,    "") ;	/* Type 2. */
strcpy (type3,    "") ;	/* Type 3. */
strcpy (type4,    "") ;	/* Type 4. */
strcpy (type5,    "") ;	/* Type 5. */
strcpy (type6,    "") ;	/* Type 6. */
strcpy (type7,    "") ;	/* Type 7. */
strcpy (type8,    "") ;	/* Type 8. */

nimavg   = 0 ;          /* # images averaged. */
expdur   = 0 ;          /* Exposure duration. */
strcpy (expunits, "") ;	/* Exposure duration units. */

rmin     = 0.0 ;        /* Minimum radius. */
rmax     = 0.0 ;        /* Maximum radius. */
rsun     = 0.0 ;        /* pixels per solar radius. */

tmin     = 0.0 ;        /* Minimum angle. */
tmax     = 0.0 ;        /* Maximum angle. */

scan_dur   = 0.0 ;      /* MLSO MK3 scan duration. */
strcpy (scan_dir, "") ;     /* MLSO MK3 scan direction: CW,CCW. */

northang = 0.0 ;        /* Angle of solar north w.r.t. +X axis. */
angle    = 0.0 ;        /* Angle. */

bias     = 0.0 ;        /* Bias. */
gain     = 0.0 ;        /* Gain. */
deltat   = 0.0 ;        /* Delta Time. */
phi      = 0.0 ;        /* Phi angle. */
theta    = 0.0 ;        /* Theta angle. */
radius   = 0.0 ;        /* Radius. */
rangvalu = 0.0 ;        /* Range value. */
zerovalu = 0.0 ;        /* Zero value. */
tilt     = 0.0 ;        /* Tilt angle. */
wave     = 0.0 ;        /* Wavelength. */
wavelen  = 0.0 ;        /* Wavelength. */
wavelnth = 0.0 ;        /* Wavelength. */

strcpy (calibrat, "") ;    /* Calibrated. */
strcpy (camera  , "") ;    /* Camera name. */
strcpy (filter  , "") ;    /* Filter name. */
strcpy (int_mode, "") ;    /* Integration mode. */
strcpy (runit   , "") ;    /* Radius units. */
strcpy (punit   , "") ;    /* Phi angle units. */
strcpy (tunit   , "") ;    /* Theta angle units. */
strcpy (seeing  , "") ;    /* Seeing.  */
strcpy (quality , "") ;    /* Quality. */
strcpy (sky     , "") ;    /* Sky.     */
strcpy (utstart , "") ;    /* UT start time. */
strcpy (utstop  , "") ;    /* UT stop  time. */
strcpy (version , "") ;    /* Version name.  */

frames   = 0 ;          /* # frames. */

occ_disc = 0.0 ;        /* occulting disk diameter [arcsec]. */

solar_b0 = 0.0 ;        /* B-angle. */
solar_l0 = 0.0 ;        /* L-angle. */
solar_p0 = 0.0 ;        /* P-angle. */
hour_ang = 0.0 ;        /* H-angle. */

elev     = 0.0 ;        /* Elevation (degrees). */
azimuth  = 0.0 ;        /* Azimuth   (degrees). */
airmass  = 0.0 ;        /* Airmass. */

strcpy (optdev01 , "") ;     /* MLSO DPM optical device #1 */
strcpy (optdev02 , "") ;     /* MLSO DPM optical device #2 */
strcpy (optdev03 , "") ;     /* MLSO DPM optical device #3 */
strcpy (optdev04 , "") ;     /* MLSO DPM optical device #4 */
strcpy (optdev05 , "") ;     /* MLSO DPM optical device #5 */
strcpy (optdev06 , "") ;     /* MLSO DPM optical device #6 */
strcpy (optdev07 , "") ;     /* MLSO DPM optical device #7 */
strcpy (optdev08 , "") ;     /* MLSO DPM optical device #8 */

strcpy (optpos01 , "") ;     /* MLSO DPM optical position #1 */
strcpy (optpos02 , "") ;     /* MLSO DPM optical position #2 */
strcpy (optpos03 , "") ;     /* MLSO DPM optical position #3 */
strcpy (optpos04 , "") ;     /* MLSO DPM optical position #4 */
strcpy (optpos05 , "") ;     /* MLSO DPM optical position #5 */
strcpy (optpos06 , "") ;     /* MLSO DPM optical position #6 */
strcpy (optpos07 , "") ;     /* MLSO DPM optical position #7 */
strcpy (optpos08 , "") ;     /* MLSO DPM optical position #8 */

strcpy (calmir,   "") ;		/* SMM C/P calibration mirror position. */
strcpy (colorfil, "") ;		/* SMM C/P color filter position.       */
strcpy (glfilter, "") ;		/* SMM C/P Green Line filter position.  */
strcpy (polaroid, "") ;		/* SMM C/P polaroid filter position.    */
strcpy (sector,   "") ;		/* SMM C/P sector mirror position.      */

frame   = 0 ;			/* SMM C/P frame number.                */
sc_roll = 0 ;			/* SMM C/P spacecraft roll (degrees).   */

return (0) ;
}
