/* glcp_arc.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Draw theta Arc in SGI IRIS GL window.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   Solar Maximum Mission   Coronagraph/Polarimeter
 * 11 April 1991
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include <gl/gl.h>
#include "/home/stanger/lib/include/cplib.ext"
#include "/home/stanger/lib/include/img_scale.ext"

/* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

glcp_arc (thmin, thmax, radius, cindex)

float	thmin, thmax;	/* Solar position angle limits for theta arc. */
float	radius;		/* Radius (R/Rsun units). */
int	cindex;		/* Color map index value. */

{
extern int rcoord ();	/* Coordinate transformation: polar <--> cartesian. */

int	ir;		/* radius in pixel units. */
int	xc, yc;		/* Center of disk in window coordinates. */
short	angbeg, angend;	/* Beginning/Ending angles for arc (degrees * 10). */
/* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

   xc = (int) (xcen/gres) + gMINCOL;
   yc = gMAXROW - (int) (ycen/gres);

   angbeg = (int) ((thmin + degnor) * 10.0);
   angend = (int) ((thmax + degnor) * 10.0);

   ir = (int) (radius * pixrs + 0.5);
 
   color (cindex);				/* Set color. */

   arci (xc, yc, ir, angbeg, angend);		/* Draw arc. */

   return (0);
}
