#include <stdio.h>
#include "iproc.ext"

/*------------------------------------------------------------------------------
 * G D I F F ()		- Forms the difference image.
 *------------------------------------------------------------------------------
 */

struct IMAGE *
gdiff(image1,image2)
struct IMAGE *image1, *image2;
{
    extern struct IMAGE *gdup();
    static struct IMAGE *subtr;
    register unsigned char *bl, *bl1, *rbim;
    register short int  *il, *il1, *rim;
    int dim, i,j,temp;


    /* there are several conditions which will prevent us from creating the
      * difference image. 
      */
    /* 1) image must be of the same type     */
    if(strcmp(image1->type, image2->type) != 0) 
	return(NULL);
    /* 2) file sizes must be equivalent      */
    if((image1->dx != image2->dx)||(image1->dy != image2->dy)) 
	return(NULL);
    /* 3) bytes per pixel must be equivalent */
    if(image1->bppx != image2->bppx)
	return(NULL);
    /* 4) resolution must be equivalent      */
    if(image1->ires != image2->ires)
	return(NULL);

    /* duplicate the image file control block 
     */
    subtr = gdup(image1);
    dim = image1->dx;

    if(image1->bppx == 1 )			/* 1 byte per pixel */
    {
	bl = image1->addr;
	rbim = image1->addr;
	for(i=0; i<dim; i+=2)
	{
	    for(j=0; j<dim; j+=2)
	    {
	        sub1 = (short int) *(image1 + i + j);
		sub2 = (short int) *(image2 + i + j);
		sub3 = sub1 - sub2;
		*(subtr + i + j) = (unsigned short int) sub3;
	    }
	}
    }
}
