#include "iproc.ext"


/*------------------------------------------------------------------------------
 * G D U P ()		- Duplicate an image file control block.
 *			  This routine will allocate space for the image, but
 *			  will not copy the old image to the new image space.
 *------------------------------------------------------------------------------
 */

struct IMAGE *
gdup(ifcb)
struct IMAGE *ifcb;
{

    static struct IMAGE *newifcb;

    /* Allocate space for the image file control block
     */
    newifcb = (struct IMAGE *) malloc(sizeof(struct IMAGE));
    newifcb->name = (char *) malloc(strlen(filename) + 1);
    newifcb->type = (char *) malloc(strlen(itype) + 1);
    newifcb->addr = NULL;

    strcpy(newifcb->name, ifcb->name);
    strcpy(newifcb->type, ifcb->type);

    /* allocate space for the image 
     */
    if((newifcb->addr = (unsigned char *) malloc(ifcb->dx*ifcb->dy*ifcb->bppx)))
		 == NULL)
    { 
	fprintf(stderr,"gdup(): memory allocation error.");
	return(NULL);
    }
    newifcb->dx = ifcb->dx;	       /* Image extent in x (horizontal) pix. */
    newifcb->dy = ifcb->dy;	       /* Image extent in y (vertical) pixels */
    newifcb->bppx = ifcb->bppx;	       /* Bytes per pixel		      */
    newifcb->bytord = ifcb->bytord     /* Byte order: 0 -> Sun-4, 1 -> DEC    */
    newifcb->ires = ifcb->ires;	       /* Image resolution		      */
    newifcb->degnor = ifcb->degnor;    /* North pole relative to horizontal   */
    newifcb->pixsr = ifcb->pixsr;      /* pixels per solar radius	      */
    newifcb->scale = ifcb->scale;      /* Brightness scale factor	      */
    newifcb->ip = ifcb->ip;	       /* initial horizontal pixel disp. area */
    newifcb->lp = ifcb->lp;	       /* final horizontal pixel disp. area   */
    newifcb->ir = ifcb->ir;	       /* initial vertical pixel display area */
    newifcb->lr = ifcb->lr;	       /* final vertical pixel display area   */
    newifcb->year = ifcb->year;	       /* DATE: year as in '1984'             */
    newifcb->doy = ifcb->doy;	       /* DATE: day of year                   */
    newifcb->hour = ifcb->hour;	       /* TIME: hours                         */
    newifcb->minute = ifcb->minute;    /* TIME: minutes                       */
    newifcb->sec = ifcb->sec;          /* TIME: seconds                       */
    newifcb->frameno = ifcb->frameno;  /* Frame number                        */
    newifcb->quan = ifcb->quan;        /* Image quantity                      */
    newifcb->exp = ifcb->exp;          /* Image exposure                      */
    newifcb->ism = ifcb->ism;          /* Sector mirror position              */
    newifcb->ifw = ifcb->ifw;          /* Filter wheel position               */
    newifcb->ipw = ifcb->ipw;          /* Polaroid wheel position             */
    newifcb->icm = ifcb->icm;          /* Calibration mirror position         */
    newifcb->iglpos = ifcb->iglpos;
    newifcb->iglstw = ifcb->iglstw;
    newifcb->dtype = ifcb->dtype;      /* Image data type		      */
    newifcb->xcen = ifcb->xcen;        /* Image center position 	      */
    newifcb->ycen = ifcb->ycen;        /* Image center position 	      */

    return(newifcb);
}

