/* ginit.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Image display routines.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 6 June 1991: version for SGI/IRIS GL window.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include "iproc.ext"
#include <gl/gl.h>
#include <fmclient.h>
#include "/local/home/stanger/lib/include/gl_color.h"

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * G I N I T S C R : Initialize IRIS GL window.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
ginitscr (dev, chan, ovl, nampgm)

int dev, chan, ovl;
char nampgm [];
{
   _GD.device  = dev;
   _GD.channel = chan;
   _GD.overlay = ovl;

   /*** Initialize GL software. ***/

   foreground ();
/*   prefposition (266, 1279,   0, 1023);*//*1024x1024 window: upper right corner.*/
   prefposition (760, 1271, 500, 1011);/*1024x1024 window: upper right corner.*/
   fminit ();				/* Initialize SGI font manager. */

   winopen (nampgm);			/* Create window. */
   drawmode (NORMALDRAW);
   gl_clear (BLACK);			/* Clear window to black. */
   onemap ();				/* Set single map mode. */
   gconfig ();				/* Make it so. */
   pixmode (PM_ADD24, 512);		/* i.e., effectively use color map #2.*/

   return (0);
}


/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * G N E W W I N : create a new display structure.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
struct DISPLAY *
gnewwin (dev,chan,x,y,dx,dy)

int chan, dev;
int x, y, dx, dy;
{
   struct DISPLAY *_gwin;

   _gwin = (struct DISPLAY *) malloc(sizeof (struct DISPLAY));
   _gwin->device = dev;
   _gwin->channel = chan;
   _gwin->x  = x;
   _gwin->y  = y;
   _gwin->dx = dx;
   _gwin->dy = dy;

   return ( (struct DISPLAY *) _gwin );
}


/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * G S E T D E F : reset definititions for display structure.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
gsetdef (dev, chan, ovl, x, y, dx, dy)

int dev, chan, ovl, x, y, dx, dy;
{
   _GD.device = dev;
   _GD.channel = chan;
   _GD.overlay = ovl;
   _GD.x = x;
   _GD.y = y;
   _GD.dx = dx;
   _GD.dy = dy;
}


/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * G I N I T X : returns the initial x coordinate of the image display area.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
ginitx ()
{
   return (_GD.x);
}

/* returns the initial y coordinate of the image display area */
ginity ()
{
   return (_GD.y);
}


/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * G G E T D X : returns the x-extent of the image display area.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
ggetdx ()
{
   return (_GD.dx);
}


/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * G G E T D Y : returns the y-extent of the image display area.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
ggetdy ()
{
   return(_GD.dy);
}


/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * G E R A S E : erase the default channel.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
gerase ()

{
   gl_clear (BLACK);
}
