#include <stdio.h>
#include "iproc.ext"

/* simigp()	- Simple display program. This routine will display images
 *		  from a filelist in multiple windows on the grinnell screen
 */

simigp(nframes, border, filenames)
int nframes, border;
char *filenames;
{
	FILE *fd, *fopen();
	struct IMAGE *icb;
	struct GRINNELL *win;
	char nextfile[64];
	int x, y, nx, ny, bx, by, dx, dy, i, j;
	int test;

	if((fd = fopen(filenames, "r")) == NULL)  
	{
		printf("Unable to open %s\n", filenames);
		exit(-1);
	}
	nx = nframes + 1;
	bx = by = border;
	dy = dx = (int) (512 - nx*bx)/nframes;
	for(i = 0; i < nframes; i++)
	{
		y = (i+1)*by + i*dy;
		for(j = 0; j < nframes; j++)
		{
		  	x = (j+1)*bx + j*dx;
			if(!(test = fscanf(fd, "%s", nextfile)))
			{
				printf("fscanf returned test = %d\n",test);	
				printf("nextfile = %s", nextfile);
			}
			if(nextfile == NULL)  return; 
			icb = makesmm(nextfile); 
			if(icb->addr == NULL)   /* the image array address */
			{
				printf("\nNULL IMAGE\n");
				exit(-1);
			}
			win = gnewwin(0, x, 511-y, dx, dy);
	printf("Working on image: %s    -    position(%d,%d)\n", nextfile,i,j);
	printf("   input image size... dx = %d, dy = %d \n", icb->dx,icb->dy);
	printf("   disk center........ x = %f, y = %f \n",
			 icb->xcen, icb->ycen);
	printf("   upper left corner.. x = %d  y = %d \n", x,y);
	printf("   screen image size.. dx = %d, dy = %d \n", dx,dy);
			wgrnimg(win, icb); 
			gdelwin(win);      /* delete this window */
			gdelimg(icb); 	   /* delete this image  */
		}
	}
}

