/* smm_avg.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Convert a high resolution SMM C/P image to low resolution by performing a
 * 2x2 average.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include "iproc.ext"

smm_avg(image)

struct IMAGE *image;
{
	register unsigned char *bl, *bl1, *rbim;
	register short int  *il, *il1, *rim;
	int smm_dim, i, j, temp;

	/* If this is not a high resolution image, return.  */

	if(image->ires != 0) return;  

	smm_dim = image->dx;

	if( image->bppx == 1 )			/* 1 byte per pixel */
	{
		bl = image->addr;
		rbim = image->addr;
		for(i=0; i<smm_dim; i+=2)
		{
			bl1 = bl + smm_dim;
			for(j=0; j<smm_dim; j+=2)
			{
				temp = ((*bl++)&0377) + ((*bl1++)&0377) +
					((*bl++)&0377) + ((*bl1++)&0377);
					*rbim++ =  temp/4 ;
			}
			bl = bl1;
		}
		return( 0 );
	}
	else 				/* 2 bytes per pixel */
	{
		il  = (short int *) image->addr;
		rim = (short int *) image->addr;
		for(i=0; i<smm_dim; i+=2)
		{
			il1 = il + smm_dim;
			for(j=0; j<smm_dim; j+=2)
				*rim++ = (*il++ + *il++ + *il1++ + *il1++)/4;
			il = il1;
		}
		return( 0 );
	}
}
