/* This program will obtain a footer from a .rq image and stick on the end
   of a "un-footer-ed" .dsp image that has the same name.

*/

#include <stdio.h>
#include <ctype.h>

typedef unsigned short u_short;
#include "imageftr.h"
#include "filehd.h"
#include "pic_hdr.h"

#define RSIZE (512*512*2)	/* size of rectangular array ints */
#define SRSIZE (512*512)	/* size of rectangular array chars */


char *filenm ;

long aspot ;

char rqfilenm[256] ;
int bflag, cflag, rflag, srflag, tflag ;
int bbflag , btflag ;


main(an, av) int an; char *av[];
{

    char *w , *p , *q;		/* pointer to command line arguments */
    char ss[40] ;
    char tailor[BKWDS] , oldfoot[2000] ;
    char datatype[4];
    char *pdt , dtime[20];
    char cmnd[80] ;
    long footloc , asciiloc , eofloc ;
    int ii ;
    register FH filehd = &head;
    register IF iftr = &footer;
    register PH phdr = &pic_header;
    FILE *fid , *rqfid ;

    pdt = dtime ;

    if ( an < 2 ) { prsum() ; exit(-4) ; }
    while (--an) {
	if (*(w = *++av) == '-')	/* Check for flag arguments */
	    switch (w[1]) {
		default:   fprintf (stderr," unknown flag %s\n",*av);
			   prsum(); exit(-1);
	    }

	else {			/* Get the image filename. */

	    if (*w == '?') { prsum(); exit(-2); }

	    filenm = w;
	    if (! (fid = fopen (filenm,"r+")) ) {
		fprintf (stderr,"%s does not exist.\n",filenm);
		exit (-5);
	    }
	    fprintf(stdout,"\n\n%s has been opened.\n",filenm) ;

	    p = filenm ;   q = rqfilenm ;
	    for(ii=0;ii<strlen(filenm)-4;ii++) *q++ = *p++ ;
	    *q='\0' ;
	    if (! (rqfid = fopen (rqfilenm,"r")) ) {
		fprintf (stderr,"%s does not exist.\n",rqfilenm);
		exit (-5);
	    }
	    fprintf(stdout,"\n\n%s has been opened.\n",rqfilenm) ;
	}

	fseek (rqfid, 0, 2);  /* Skip to end of file. */
	eofloc = ftell(rqfid) ;
	fseek (rqfid, -(BKWDS+1), 2);  /* Skip to near end of file. */

	fscanf(rqfid,"%s",ss);
	while( strcmp(ss, "type") != 0 )   fscanf(rqfid,"%s",ss);
	fscanf(rqfid,"%s",datatype) ;

	switch (datatype[0]) {
	    case 'b':  bbflag++ ;
	    case 'i':  
	    case 'q':  
	    case 'u':  
	    case 'p':  cflag++ ; break;
	    case 'r':  rflag++ ; break;
	    case 's':  switch(datatype[1]) {
			   case 'r':  srflag++ ; break;
			   case 't':  cflag++ ; btflag++ ; break;
			   default:   fprintf (stderr,
				      " unknown datatype  %s\n",datatype);
				       exit(-11);
		       }
		       break;
	    case 'a':  switch(datatype[1]) {
			   case 'b':  bflag++ ; break;
			   case 't':  tflag++ ; break;
			   default:   fprintf (stderr,
				      " unknown datatype  %s\n",datatype);
				       exit(-12);
		       }
		       break;
	    default:   fprintf (stderr," unknown datatype  %s\n",datatype);
		       exit(-10);
	}


	fscanf(rqfid,"%s",ss);
	while( strcmp(ss, "entire") != 0 )   fscanf(rqfid,"%s",ss);
	fscanf(rqfid,"%*s%ld",&footloc); fprintf(stderr,"footloc %d\n",footloc);

	fscanf(rqfid,"%s",ss);
	while( strcmp(ss, "ascii") != 0 )   fscanf(rqfid,"%s",ss);
	fscanf(rqfid,"%*s%ld",&asciiloc) ;

	fseek (rqfid, footloc, 0);  /* Skip to the footer. */

	fread(filehd, 1,  sizeof(struct filehd ), rqfid);
	fread(phdr,   1,  sizeof(struct pic_hdr), rqfid);
	fread(iftr,   1,  eofloc-asciiloc+1     , rqfid);
	fclose(rqfid);


	fseek (fid, footloc, 0);  /* Skip to the footer of the dsp file. */

	fwrite  (filehd, 1, sizeof (struct filehd), fid);
	fwrite  (phdr,   1, sizeof(struct pic_hdr), fid);
	fprintf (fid , "%s" , iftr->afoot ) ;
	fclose  (fid);



    }

    exit(0);

}

prsum() {
    static char help[] = "\
dspfoot filename1 filename2 filename3 ...\n\
\n\
Example:              dspfoot 16_20.dsp 92D027.19_01.rq.dsp \n\
\n\
This program appends footer information from an original, non-.dsp file. \n\
It assumes that the file names are the same, and that the original file\n\
exits.\n\
";

       fputs (help,stderr);
}
