/* jgdate.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Compute Gregorian calendar year, month, & day from the Julian date.
 * Inverse of "jday", except that it only works for dates after 4 Oct 1582.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   10 February 1994
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

jgdate (jday, gyear, gmonth, gday)

int jday ;
int *gyear ;
int *gmonth ;
int *gday ;

{
   int year, month, day ;
   int l, n ;

   year  = 0 ;
   month = 0 ;
   day   = 0 ;
   
   l = 0 ;
   n = 0 ;

   l = jday + 68569 ;
   n = (4 * l) / 146097 ;
   year = 100 * (n - 49) ;

   l -= ((146097 * n  + 3) / 4) ;
   n = (4000 * (l + 1)) / 1461001 ;
   l -= ((1461 * n) / 4 - 31) ;
   year += n ;

   n = 80 * l / 2447 ;
   day = l - (2447 * n) / 80 ;

   l = n / 11 ;
   month = n + 2 - (12 * l) ;

   year += l ;

   *gyear  = year ;
   *gmonth = month ;
   *gday   = day ;

   return (0);
}
