/* crunch.h */

#define MAXSZ (4096)
#define NV      (24)

/*
c	--<Set parameter number order.
c	--<1 is reserved for residual errors.
c	--<Parameters are ordered so that the ones that are held constant
c	--<ocuur last ; this reduces matrix size for inversion.
*/

/*      --<Index of last parameter. (In fortran counting, 1 is first...) */

#define LASTP (NV)
#define NX11   (8)

#ifdef START 
    int   march  = 0 ;
    int   maxsz  = MAXSZ, nv=NV ;
    int   lastp  = LASTP ;

    int   neye   = LASTP ;	/* 24 */
    int   nque   = LASTP-1 ;	/* 23 */
    int   nyou   = LASTP-2 ;	/* 22 */

    int   nang1  = 2 ;		/*  2 */
    int   nfp1   = 3 ;		/*  3 */

    int   nang0  = 4 ;		/*  4 */
    int   nfp0   = 5 ;		/*  5 */

    int   ntrt   = 6 ;		/*  6 */
    int   nfpt   = 7 ;		/*  7 */
    int   nx11   = NX11 ;	/*  8 */
    int   nx21   = NX11+1 ;	/*  9 */
    int   nx31   = NX11+2 ;	/* 10 */
    int   nx12   = NX11+3 ;	/* 11 */
    int   nx22   = NX11+4 ;	/* 12 */
    int   nx32   = NX11+5 ;	/* 13 */
    int   nx13   = NX11+6 ;	/* 14 */
    int   nx23   = NX11+7 ;	/* 15 */
    int   nx33   = NX11+8 ;	/* 16 */

    int   nphase = 17 ;		/* 17 */
    int   ngain  = 18 ;		/* 18 */
    int   nbiasi = LASTP-3 ;	/* 21 */
    int   nbiasq = LASTP-4 ;	/* 20 */
    int   nbiasu = LASTP-5 ;	/* 19 */
#else
    extern int   march ;
    extern int   maxsz , nv ;
    extern int   lastp ;
    extern int   neye ;
    extern int   nque ;
    extern int   nyou ;
    extern int   nang1 ;
    extern int   nfp1 ;
    extern int   nang0 ;
    extern int   nfp0 ;
    extern int   ntrt ;
    extern int   nfpt ;
    extern int   nx11 ;
    extern int   nx21 ;
    extern int   nx31 ;
    extern int   nx12 ;
    extern int   nx22 ;
    extern int   nx32 ;
    extern int   nx13 ;
    extern int   nx23 ;
    extern int   nx33 ;
    extern int   nphase ;
    extern int   ngain ;
    extern int   nbiasi ;
    extern int   nbiasq ;
    extern int   nbiasu ;
#endif
