#define  NAZ         (1080)
#define  NDS         (384)
#define  CY_IMG      (NAZ*NDS)
#define  VECTOR      (NAZ)

/* Can go up to SQ==700 , with TRY==2 , and not suffer any "pixelation" */
/* With TRY==2, it takes  8 sec to do an image. */
/* With TRY==3, it takes 12 sec to do an image. */
#define SQ (512)
#define TRY  (2)               /* Expansion factor */

#define RSIZE (SQ*SQ*2)        /* byte size of rectangular array */
#define SIZE  (SQ*SQ)          /* size of rect array as shorts */
#define XSIZE (SQ)             /* x size of rect array */

#define        LOWPIX         (70)
#define        HIGHPIX       (360)

/*  Bottom and top good diodes.. */
#define        GDS           (NDS-24)    /* Chop out the top 24 */
#define        BOTGDI        (24)    
#define        TOPGDI        (NDS-24)

#define        BACKLASH      (0.5) /* In degrees */

#define        SKYOFF        (0)
#define        SKYBRI        (387)
#define        DEFSKY        (340)
/*
#define        SKYOFF        (313)
#define        SKYBRI        (409)
*/
#define        MAXSKY        SKYBRI
#define        MINSKY        (200)

/* Observation Type == mk4h->ObsType */
#define  IS_cal0          0
#define  IS_cal15         150
#define  IS_dark          9999
#define  IS_coronal       1000

/* Data Type (who) mk4h->DataType  */
#define  IS_i                  0
#define  IS_q                  1
#define  IS_u                  2
#define  IS_ba                 3
#define  IS_sk                 4
#define  IS_st                 5
#define  IS_tscp               6

/* Processing steps (howfar) mk4h->ProcSteps */
#define  IS_raw               10
#define  IS_raw_spln          11
#define  IS_raw_rect          12
#define  IS_cal               13
#define  IS_cal_rect          14
#define  IS_cal_rect_slit     15
#define  IS_cal_rect_byte     16  /* rpB image scaled from 0-255 for display. */
#define  IS_cal_avg           17
#define  IS_cal_avg_rect      18
#define  IS_cal_avg_rect_slit 19

#define  IS_raw_avg           24
#define  IS_raw_avg_spln      25
#define  IS_raw_avg_rect      26

#define  IS_UNKNOWN           99

#ifdef START
    double twopi  =  3.14159265358979 *2.;
    double pi     =  3.14159265358979;
    double r2d    = 57.29577951308232;
    double d2r    =  0.01745329251994;
    double piov2  = 1.57079632679490;
    double piov4  = 0.78539816339745;
    double ba2rad = 0.000383495196971410;     /* 2 pi / 16384 */
    double ba2deg = 0.02197265625;            /* 360. / 16384 */

    char *prtime();

    char picnm[64] , *piceos ;
    int mon, day, year, doy ;
    int dayflag, timeflag;
    int Secflag ;
    int nameflag;
    int doyflag ;
    unsigned int tim;

#else
    extern double twopi ;
    extern double    pi ;
    extern double r2d ;
    extern double d2r ;
    extern double piov2  ;
    extern double piov4  ;
    extern double ba2rad ;
    extern double ba2deg ;

    extern char *prday();
    extern char *prtime();
    extern int  get_hrminsec();
    extern double pangle();
    extern double phi();
    extern int    idoy() ;
    extern int    get_doy() ;
    extern int    jday() ;
    extern int    jdate() ;
    extern int    idate() ;
    extern int    isleap() ;

    extern char picnm[64] , *piceos ;
    extern int mon, day, year, doy ;
    extern int dayflag, timeflag;
    extern int Secflag ;
    extern int nameflag;
    extern int doyflag ;
    extern unsigned int tim;

#endif
