/* mk4head.h */

struct   TimeDate
    {
    int    Year;
    int    Month;
    int    Day;
    int    Hour;
    int    Minute;
    int    CentiSec;  
    int    Juld;	/* Julian day - 2415021 */
    int    Doy;
    int    Time;	/* Time in Hz */
    };


struct   mk4_header
    {
    struct TimeDate    Image;
    int    Xdim;
    int    Ydim;
    int    Duration;   /* Duration of entire scan, in Hz. */
    int    Fill1 [4];

    /* 16 */

    float  Pangle;     /* P angle in degrees */
    float  Bangle;     /* B angle in degrees */
    float  Langle;     /* L angle in degrees */
    float  RA;         /* Solar Right Ascension */
    float  Dec;        /* Solar Declination */
    float  HA;         /* Hour angle in degrees */
    float  Elevation;  /* Solar elevation in degrees */
    float  Azimuth;    /* Solar azimuth in degrees */
    float  Amass;      /* Airmass */
    float  Radius;     /* Solar radius in arc-seconds. */
    float  SkyTx;      /* Max. reasonable sky transmission from "sk" file. */
    float  InstrPhs;   /* Instrument coordinate frame phase offset. (degrees)*/
    float  Xcen;       /* Center  of the image if in rect. coordinates. */
    float  Ycen;       /* Center  of the image if in rect. coordinates. */
    float  pixscl;     /* Scaling of the image if in rect. coordinates. */
    float  r0;         /* In present image. */
    float  dr;         /* In present image. */
    float  rmax;       /* In present image. */
    float  theta_min;  /* In present image. */
    float  theta_max;  /* In present image. */
    float  raw_theta_min;  /* In original raw data image. Uncorrected for */
    float  raw_theta_max;  /*             direction and Pangle and phase. */
    float  backlash;   /* Backlash correction applied, in degrees. */
    float  Phase   ;   /* Phase offset, in degrees. */

    /* 16+24=40 */

    int    ObsType;    /* IS_cal0, IS_cal15, IS_dark, IS_coronal */
    int    DataType;   /* IS_i , IS_q , IS_u, IS_ba, IS_sk, IS_st.  */
    int    ProcSteps;  /* Process steps, IS_raw through IS_cal_avg_rect_slit */
    int    Direction;  /* "direction" of original raw data 
                          -1==reverse, +1 forward.*/
    int    Diodes;     /* Number of diodes in original raw data. */
    int    Nray;       /* Number of barrel angle positions (rays)
                          in original raw data. */
    int    Fill2 [1];

    struct TimeDate Date_calibrated;
    char            tscpfile [64];	/* filename of tscp file. */

    char            AvgTimes [160];	/* If avg img, these are the img times
					 * used to make the avg.
					 */
    char            space [1024-448];	/* Even up to 1024. */
    };


typedef struct mk4_header * (FH);


#ifdef START
    int   naz       = NAZ ;
    float ovNAZ     = 1.0   / NAZ ;
    float az2deg    = 360.0 / NAZ ;
    double AngSep   = 360.0 / NAZ ;
    double ovAngSep = NAZ   / 360.0 ;
    struct mk4_header mk4head;
    struct mk4_header *mk4h = &mk4head;
#else
    extern int     naz ;
    extern float   ovNAZ ;
    extern float   az2dec ;
    extern double  AngSep ;
    extern double  ovAngSep ;
    extern struct  mk4_header  mk4head, *mk4h ;
#endif
