/* mk3vigmask.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Create a "vignetting" image mask for MLSO/MK3 images.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Alice Lecinski   9 June 1998   "mkslitplate.c"
 * renamed by Andrew L. Stanger
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include <math.h>

#define SIZE   262144   /* 512*512 */

double  dr=0.0104244,
        r0 = 1.1224,
	rmx = 2.44 ,
        mk3rad = 104.443497  , xcen = 255.5 , ycen = 255.5 ;
double  pi=3.14159265358979323846 ;

double  x , y , xdis , ydis , xdissq , ydissq , radius , diode ;
double  slope,ycept;

float stemplate[SIZE]   ;
char filenm[]="mk3vig.template" ;

main (an, av) char *av[]; {
    register int i, j , ii ;
    register float *q ;
    double fac , mypower, theta, sin_th ;
    double sqrt() , pow(), sin() , atan2() , fabs();
    FILE *fid ;

    mypower = 5.;

    slope=(13.-3.)/128.;
    ycept=1.;
    q = stemplate;
    x = y = 0 ;
    for (i=0;i<512*512; i++ ) {
	
	x = (double) (i%512) ;     y = (double) (i/512) ;

	xdis = xcen - x ;     xdissq = xdis*xdis  ;
	ydis = ycen - y ;     ydissq = ydis*ydis  ;

	radius = sqrt ( xdissq + ydissq)  / mk3rad  ;

	diode = ( (radius-r0)/dr )  ;
	diode = diode < 128   ? diode : 0  ;
	diode = diode >= 0.00 ? diode : 0  ;

	theta  = atan2 ( ydis , xdis ) ;
	sin_th = sin   (theta)   ;

	fac  = pow ( radius , mypower );
	fac *= (1. + sin_th*sin_th*sin_th*sin_th )  ;
	fac *= 0.5 ;

	fac = ( radius >= r0 && radius <= rmx ) ? fac : -1000. ;

	*q++ =   (float) (fac);

	/*
	*q++ =   (float) (diode * slope + ycept );
	*/



    }
    fid = fopen(filenm,"w"); fwrite (stemplate,sizeof(float),SIZE,fid);
    fclose(fid);

}
