/* mk4vigmask.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Create a "vignetting" image mask for MLSO/MK3 images.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Alice Lecinski   8 July 1999   "mkslitplate4.c"
 * renamed by Andrew L. Stanger
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include <math.h>

#define BIGSCALE
#include "/home/cordyn/mk4/src/mk4.h"

double  dr = RDELT ;
double  r0 = RZERO ;

double  x , y , xdis , ydis , xdissq , ydissq , radius , diode ;

float stemplate [SIZE]  ;
char filenm [] = "mk4vig.template" ;

main (an, av)

int   an ;
char *av [] ;
{
    register int i, j , ii ;
    register float *q ;
    double rbot, rtop, rmn , rmx, pixscl, xcen, ycen;
    double fac, mypower, theta, sin_th ;
    double sqrt (), pow (), sin (), atan2 (), fabs ();
    FILE *fid ;
    int GDS ;

    GDS = TOPPIX - BOTPIX + 1 ;
    mypower = 5.0 ;

    rmn  = r0 ; 
    rbot = r0 + (BOTPIX + 4) * dr ; 
    rtop = r0 + TOPPIX * dr ; 
    rmx  = r0 + NPX    * dr ; 
    pixscl = (double)(SQ / ( 2.0 * (r0 + dr * (GDS - 1) ))) ;
    xcen = ycen = (SQ - 1.0) * 0.5 ;

    q = stemplate ;
    x = y = 0 ;

    for (i = 0 ; i < SQ * SQ; i++ )
	{
	x = (double) (i % SQ) ;     y = (double) (i / SQ) ;

	xdis = xcen - x ;     xdissq = xdis * xdis  ;
	ydis = ycen - y ;     ydissq = ydis * ydis  ;

	radius = sqrt ( xdissq + ydissq)  / pixscl  ;

	theta  = atan2 ( ydis , xdis ) ;
	sin_th = sin   (theta)   ;

	fac  = pow ( radius , mypower ) ;
	fac *= (1.0 + sin_th * sin_th * sin_th * sin_th )  ;
	fac *= 0.5 ;

	fac = ( radius >= rmn  && radius <= rmx  ) ? fac : -1000.0 ;
	fac = ( radius >= rmn  && radius <= rbot ) ? 0.0 :     fac ;
	fac = ( radius >= rtop && radius <= rmx  ) ? 0.0 :     fac ;

	*q++ =   (float) (fac) ;
        }

    fid = fopen (filenm, "w") ;
    fwrite (stemplate, sizeof (float), SIZE, fid);
    fclose (fid) ;

    exit (0) ;
}
