/* smmcpvigmask.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Create a "vignetting" image mask for SMM C/P images.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Alice Lecinski   9 June 1998   "mkslitplate.c"
 * Adapted by Andrew L. Stanger for SMM C/P
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include <math.h>

#define NX 448
#define NY 448

double	rmin = 1.5 ;				/* Occulting disk radius. */
double	pixrs = 960.0 / (5.933 * 2.0) ;	/* # Pixels / Rsun */
double	xcen  = NX / 2.0 - 0.5 ;
double	ycen  = NY / 2.0 - 0.5 ;
double  pi    = 3.14159265358979323846 ;

double  x , y , xdis , ydis , xdissq , ydissq , radius , diode ;

float stemplate [NY][NX] ;
char filename [] = "smmcpvig.template" ;


main (an, av) char *av[] ;
{
   register int ix, iy ;
   double fac, radpower, theta, sin_th ;
   double sqrt (), pow (), sin (), atan2 (), fabs () ;
   FILE *fid ;

   x = y = 0 ;

   for (iy = 0 ; iy < NY ; iy++)
      {
      y      = (double) iy ;
      ydis   = ycen - y ;
      ydissq = ydis * ydis  ;

      for (ix = 0 ; ix < NX ; ix++)
         {
         x      = (double) ix ;
         xdis   = xcen - x ;
	 xdissq = xdis * xdis  ;

         radius = sqrt ( xdissq + ydissq) / pixrs ;

         fac = vignet (radius) ;

         fac = ( radius >= rmin ) ? fac : 1.0 ;

         stemplate [iy][ix] = (float) (fac) ;
         }
      }
   fid = fopen (filename, "w") ;
   fwrite (stemplate, sizeof (float), NX * NY, fid) ;
   fclose (fid) ;

}
