/* orb.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Earth's orbit about the sun.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 12 February 1993
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <math.h> 

main (argc, argv)

int argc;
char *argv [];

{
   float lumadj ();
   int idoy;
   int iyear = 80;
   int ihour =  0;
   int lentit;
   int nval = 365;

   double degrad = 1.0 ;
   double period = 365.2596;
   double pdoy  = 0;
   double pi    = 3.14159265;

   static float doy    [404];
   static float c2     [404];
   static float theta1 [404];
   static char  title  [40] = "Earth Orbit";
   static char  labx   [40] = "X";
   static char  laby   [40] = "Y";

   degrad = 180.0 / pi ;

   opngks_ ();

   idoy = 185 ;
   for (idoy = 0; idoy < 366; idoy++)
      {
      doy [idoy] = idoy;
      theta1 [idoy] = (double) ((idoy - pdoy) * 2.0 * pi)  / period;
      theta1 [idoy] *= degrad ;
      c2 [idoy] = (float) lumadj (iyear, idoy, ihour);
/*
      printf ("year: %4d   doy: %3d   hour: %2d   theta1: %6.2f   c2: %6.2f\n",
	       iyear, idoy, ihour, theta1 [idoy], c2 [idoy]) ;
 */
      }

   lentit = strlen (title);

   strcpy (title, "Earth Orbit Radius Squared");

   ezxy_ (theta1, c2, &nval, title, &lentit);

   clsgks_ ();

   exit (0);
}
