/* orbit.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Earth's orbit about the sun.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 12 February 1993
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <math.h> 

main (argc, argv)

int argc;
char *argv [];

{
   int idoy;
   int i;
   int lentit;
   int nval = 365;
   int nval2 = 180;

   double period = 365.2596;
   double pi     = 3.14159265;
/*   double e      = 0.01675; */
   double e      = 0.01675;
   double a      = 1.0;
   double pdoy   = 0.0;			/* Perihelion DOY. */
   double t1, t2;
   double r1, r2;
   double x, y, r;
   double xinc;

   static float doy [404];
   static float c2  [404];
   static float d2  [404];
   static float radius1 [404];
   static float radius2 [404];
   static float theta1  [404];
   static float theta2  [404];
   static float xloc [404], yloc [404];
   static char title [40] = "Earth Orbit";
   static char labx  [40] = "X";
   static char laby  [40] = "Y";

   opngks_ ();

   for (idoy = 0; idoy < 366; idoy++)
      {
      doy [idoy] = idoy;
      t1 = ((idoy - pdoy) * 2.0 * pi)  / period;
      t2 = 2.0 * e * sin (t1);
      r1 = (a * (1.0 - e*e)) / (1.0 + e * cos (t1));
      r2 = (a * (1.0 - e*e)) / (1.0 + e * cos (2.0 * t2));
      d2 [idoy] = (float) (r1 * r1);
      c2 [idoy] = (float) (1.0 / (r1 * r1));
      radius1 [idoy] = (float) r1;
      radius2 [idoy] = (float) r2;
      theta1 [idoy] = (float) t1;
      theta2 [idoy] = (float) t2;
      x = cos (t1);
      xloc [idoy] = (float) x;
      yloc [idoy] = (float) sqrt (r*r - x*x);
      }

/*
   r = 1.0;
   x = r;
   xinc = 1.0 / (double) nval;
   for (i = 0; i < nval; i++)
      {
      xloc [i] = (float) x;
      yloc [i] = (float) sqrt (r*r - x*x);
      printf ("i:%3d  r:%5.3f  x:%5.3f  y:%5.3f\n", i, r, x, yloc [i]);
      x -= xinc;
      }
 */

   lentit = strlen (title);

   strcpy (title, "Earth Orbit Radius");
   ezxy_ (theta1, radius1, &nval, title, &lentit);

   strcpy (title, "Earth Orbit Radius Squared");
   ezxy_ (theta1, d2, &nval, title, &lentit);

   strcpy (title, "Earth Orbit 1.0 / (Radius Squared)");
   ezxy_ (theta1, c2, &nval, title, &lentit);

/*
   ezxy_ (xloc, yloc, &nval2, title, &lentit);
 */

   clsgks_ ();

   exit (0);
}
