/* mjdate.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Compute year, month & day from MLSO Mark-III "julian" date (since 1900).
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   6 January 1994
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

mjdate (hdrday, year, month, day)

int hdrday ;
int *year ;
int *month ;
int *day ;

{
   int smask =      0177777 ;		/* Short integer mask.		*/
   int lmask = 037777777777 ;		/* Long integer mask.		*/
   int joff  = 2415021 ;		/* Julian date for 1 Jan 1900.	*/
   int jday ;

   /*** Add 1 Jan 1900 offset. ***/

   jday = ( (int) (hdrday & smask) + joff ) & lmask ;

   /*** Call Julian date routine. ***/

   jgdate (jday, year, month, day) ;

   return (0);
}
