; ------------------------------------------------------------------------------
; jgdate.pro : IDL procedure
; ------------------------------------------------------------------------------
; Compute Gregorian calendar month, day, & year from the Julian date.
; The inverse of jday but it only works for dates after Oct 4, 1582
; ------------------------------------------------------------------------------
; Andrew L. Stanger   HAO/NCAR
; 19 March 1993
; ------------------------------------------------------------------------------
 
pro jgdate, jday, month, day, year

   ; jday = LONG (jday)

   month = 0
   day   = 0
   year  = 0

   l = LONG (0)
   n = LONG (0)
	
   l = jday + 68569L
   n = (4 * l) / 146097L
   year = 100 * (n - 49) 

   l = l - ((146097 * n + 3) / 4)
   n = (4000 * (l + 1)) / 1461001L
   l = l - ((1461 * n) / 4 - 31)
   year = year + n

   n = 80 * l / 2447
   day = l - (2447 * n) / 80

   l = n / 11
   month = n + 2 - 12 * l

   year = year + l

   ; Convert output variables to short integers

   month = FIX (month)
   day   = FIX (day)
   year  = FIX (year)

RETURN
END
