; ------------------------------------------------------------------------------
; mk3flags.pro : IDL procedure
; ------------------------------------------------------------------------------
; Set flags by decoding information in filehd.flagch bits 3-15.
; ------------------------------------------------------------------------------
; Andrew L. Stanger   HAO/NCAR
; 18 March 1993
; ------------------------------------------------------------------------------

PRO mk3flags, hkflags, $
              quickflag, pBflag, qdflag, udflag, idflag, posflag, negflag

   COMPRESS_FLAG	= 1
   CALIB0_FLAG		= 2
   CALIB15_FLAG		= 4
   SPEED_FLAG		= 8
   CLEAN_FLAG		= 16
   TIDY_FLAG		= 32
   QUICK_FLAG		= 64		; The transformation to rectangular
					; coordinates ; was done quickly
					; and in-elegantly.

   PB_FLAG		= 128		; pB data.
   Q_FLAG		= 256		; Q  data.
   U_FLAG		= 512		; U  data.
   I_FLAG		= 1024		; I  data.
   DIR_FLAG		= 2048		;0 is negative direction (CW) scan, 
					;1 is positive direction (CCW) scan.

   ; Initialize flags to zero.

   quickflag 	= 0
   pBflag	= 0
   qdflag	= 0
   udflag	= 0
   idflag	= 0
   posflag	= 0
   negflag	= 0

   if ((hkflags AND QUICK_FLAG)	GT 0)	then quickflag = 1 
   if ((hkflags AND PB_FLAG)	GT 0)	then pBflag    = 1 
   if ((hkflags AND Q_FLAG)	GT 0)	then qdflag    = 1 
   if ((hkflags AND U_FLAG)	GT 0)	then udflag    = 1 
   if ((hkflags AND I_FLAG)	GT 0)	then idflag    = 1 
   if ((hkflags AND DIR_FLAG)	GT 0)	then posflag   = 1
   if (NOT (hkflags AND DIR_FLAG) EQ 0)	then negflag   = 1

RETURN
END
