/* mk3time.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Compute hour, minute & second from MLSO Mark-III time (msec).
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   6 January 1994
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

mk3time (hktime, hour, minute, second)

int hktime ;			/* Mark-III header time (msec).	*/
int *hour ;			/* hour				*/
int *minute ;			/* minute			*/
int *second ;			/* second			*/

{
   int ihour, iminute, isecond ;
   int lmask = 037777777777 ;		/* Long integer mask.		*/
   float ftime ;

   ftime = (float) (hktime & lmask)  * 0.01 ;	/* msec -> sec */

   ihour   = (int)  (ftime / 3600.0) ;
   iminute = (int) ((ftime - ihour * 3600.0) / 60.0) ;
   isecond = (int) ((ftime - ihour * 3600.0 - iminute * 60.0)) ;

   *hour   = ihour ;
   *minute = iminute ;
   *second = isecond ;

   return (0);
}
