/* fts2jpg.c
 * -----------------------------------------------------------------------------
 * Crop FITS images to any desired size
 * -----------------------------------------------------------------------------
 * Requires cfitsio and libacos libraries.
 * -----------------------------------------------------------------------------
 * Tony Darnell   HAO/NCAR   31 Jan 2003
 * -----------------------------------------------------------------------------
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <getopt.h>
#include <sys/types.h>

#include "fitsio.h"
#include "libacos.h"

int main (int argc, char *argv[]) {

  fitsfile *fileptr, *outfptr;
  int      *image;
  float *fimg;

  static char filename [80];
  static char outname [80];

  int c, i, indx, status = 0, ii = 1,  iy, ix, fpixel = 1, nelements, xsz, ysz;
  int xpos, ypos, newxsz, newysz,newnelements;
  float crradius, xcen, ycen, xshft, yshft, newxcen, newycen;

  /*** Parse command line ***/

  opterr = 0;
  while ((c = getopt (argc, argv, "x:y:")) != -1)
    switch (c) {
      case 'x':
	newxsz = atoi(optarg);
	newxcen = newxsz / 2;
	break;
      case 'y':
	newysz = atoi(optarg);
	newycen = newysz / 2;
	break;
      default:
	abort();
    }

/*** File Loop. ***/
for (indx = optind; indx < argc; indx++) {

  /*** Open fits file and get image info ***/

  strcpy (filename, argv[indx]);

  printf ("Filename:  %s\n",filename);
  fits_open_file (&fileptr, filename, READONLY, &status);
  fits_create_file(&outfptr, "test.fts", &status);

  while( !fits_movabs_hdu(fileptr, i++, NULL, &status) )
    fits_copy_hdu(fileptr, outfptr, 0, &status);

  if (status == END_OF_FILE) status = 0;
    fits_close_file(outfptr,  &status);

  fits_close_file(fileptr, &status);

  /*
  fits_read_key  (fileptr, TINT,"NAXIS1", &xsz, NULL, &status);
  fits_read_key  (fileptr, TINT,"NAXIS2", &ysz, NULL, &status);
  fits_read_key  (fileptr, TFLOAT, "CRRADIUS", &crradius, NULL, &status);
  fits_read_key  (fileptr, TFLOAT, "CRPIX1",  &xcen, NULL, &status);
  fits_read_key  (fileptr, TFLOAT, "CRPIX2",  &ycen, NULL, &status);

  xshft = xcen - newxcen;
  yshft = ycen - newycen;
  nelements = xsz*ysz;
  newnelements = newxsz * newysz;
  image = (int *) malloc (nelements * sizeof (int));
  fimg = (float *) malloc (nelements * sizeof (float));

  if (fits_read_img (fileptr, TINT, fpixel, nelements, &nullval, image, 
		&anynull, &status)) fits_report_error (stderr, status);

  fits_close_file (fileptr, &status);

  acos_shift(image, fimg, xsz, ysz, xshft, yshft);
  */

  }  /* File Loop */
}  /* Main */
