/********************** doshift ***********************/

/*   Code to "center" any "disk" type image.  This code applies the x and y
     shifts found by routine "findshift()". */

/*   Pass this code --> img     -- your short image.
                       numx        the x-dimension of your "img"
                       numy        the y-dimension of your "img"
                       xshi        the x shift in fractional pixels 
                                       found by findshift()
                       yshi        the y shift in fractional pixels 
                                       found by findshift()
*/

#include <stdio.h>

void doshift(img,numx,numy,xshi,yshi)
    short *img;
    float xshi,yshi;
    int numx,numy;
{

    long imsz;
    float xx,xxm1,yy,yym1;
    float *timg;
    int shift, off;
    float xshift,yshift;
    register short *iq;
    register float *tt,*t1,*t2,*t3,*t4;
	register float	xy1,xy2,xy3,xy4,ftmp;
    register int	ii,jj,kk,strt;

    imsz=numx*numy;
    /* Copy the short image to a another */
    timg = (float *) malloc ( imsz*sizeof ( float )) ; 
    tt= timg; iq=img; ii = imsz>>2;
	while ( ii-- > 0 )
		{*tt++ = *iq++; *tt++ = *iq++; *tt++ = *iq++; *tt++ = *iq++;}

    /* Get the fractional and integer portions of the x and y shift. */
    xshift = xshi ;
    yshift = yshi ;
    if(xshift < 0.0) {
        xx = 1. + (xshift - (int)xshift); xxm1=1.-xx;
        xshift -= 1.0;
    }
    else {
        xx = xshift-(int)xshift; xxm1=1.-xx;
    }
    if(yshift < 0.0) {
        yy = 1. + (yshift - (int)yshift); yym1=1.-yy;
        yshift -= 1.0;
    }
    else {
        yy = yshift-(int)yshift; yym1=1.-yy;
    }
    shift = (int)yshift*numx+(int)xshift;  /* This is how much to shift
                                              the entire array in whole
                                              integer dimensions, looking
                                              at the array as if it was 1-d. */

    /*   Position to the integer portion of the shift. */

    if(shift>=0) { off=shift;        iq=img+off; tt=timg;     }
    else         { off = shift * -1; iq=img;     tt=timg+off; }

    tt += numx; iq += numx;
    t1=tt-1;
    t2=tt;
    t3=tt-1-numx;
    t4=tt  -numx;

	xy1 = xx*yym1;
	xy2 = xxm1*yym1;
	xy3 = xx*yy;
	xy4 = xxm1*yy;
    strt = imsz-off-numx;                  /* Apply the fractional portion  */
	ii = strt;
	while ( ii-- > 0 )
		{
		*iq++ = (short)(xy1 * *t1++ + 
					xy2 * *t2++ + 
					xy3 * *t3++ + 
					xy4 * *t4++ +
					0.5);
		}

    free( (char *) timg );
}
