/* fli.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Find FITS limb intensity.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   4 Jan 2001
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include "/opt/share/PUBLIC/include/fitsio.h"

main (argc, argv)

int argc ;
char *argv [] ;

{
   extern float *rd_fits () ;
   extern float limb_inten () ;
   extern float **matrix () ;
   static char namimg [80] ;
   float *imgbuf ;
   float **imbuf ;
   float lval ;
   float xcen, ycen ;
   float rx, ry ;
   int nx, ny ;
   int i, j ;

   strcpy (namimg, argv [1]) ;

   imgbuf = rd_fits (namimg, &nx, &ny) ;

   imbuf = matrix (1, nx, 1, ny) ;

  /* copy imbuf into imuf */

  for (i = 1; i <= nx; i++)
    for (j = 1; j <= ny; j++)
      {
      imbuf [i][j] = *(imgbuf + (i-1) + (j-1) * nx);
      }

   lval = limb_inten (imbuf, (long) nx, (long) ny) ;
   printf ("lval: %f\n", lval) ;
/*
 *   lval = *(imgbuf + nx/2 + ny/2 * nx) / 10.0 ;
 */

   SolarGeom (imbuf, lval, nx, ny, &xcen, &ycen, &rx, &ry) ;

   printf ("xcen/ycen: %8.2f  %8.2f\n", xcen, ycen) ;
   printf ("rx/ry: %8.2f  %8.2f\n", rx, ry) ;

   exit (0) ;
}

