#include "reduction.h"

float limb_inten(float **im, long xdim, long ydim){

  float **sim, v1 = 300.0, v2 = 300.0, v3 = 300.0, vavg, savg, nelements;

  long i, j, n2, n4, dx, cv1, cv2, cv3;


  /* allocate sobel image array */

  sim = matrix(1, xdim, 1, ydim);


  /* copy im into sim */

  for(i = 1; i <= xdim; i++)
    for(j = 1; j <= ydim; j++)
      sim[i][j] = im[i][j];


  /* calculate sobel image */

  sobel(sim, xdim, ydim);


  /* calculate average of sobel image */

  savg = 0.0;

  for(i = 1; i <= xdim; i++)
    for(j = 1; j <= ydim; j++)
      savg += sim[i][j];

  nelements = (float) xdim * (float) ydim;

  savg = savg/nelements;

  /* check 3 rows for limb intensity value */

  n2 = ydim/2;
  n4 = ydim/4;

  dx = (long) (0.01*xdim);

  j = 0;
  i = dx;
  cv1 = 0;
  cv2 = 0;
  cv3 = 0;

  while(j == 0 && i < xdim-dx){

    if(cv1 == 0){
      if(sim[i+1][n2] < sim[i][n2]){
	if(sim[i][n2] > savg){
	  cv1 = 1;
	  v1 = im[i][n2];
	}
      }
    }

    if(cv2 == 0){
      if(sim[i+1][n2+n4] < sim[i][n2+n4]){
	if(sim[i][n2+n4] > savg){
	  cv2 = 1;
	  v2 = im[i][n2+n4];
	}
      }
    }

    if(cv3 == 0){
      if(sim[i+1][n2-n4] < sim[i][n2-n4]){
	if(sim[i][n2-n4] > savg){
	  cv3 = 1;
	  v3 = im[i][n2-n4];
	}
      }
    }

    i++;

    if(cv1 == 1 && cv2 == 1 && cv3 == 1) j = 1;
  }

  printf("%f  %f  %f\n",v1,v2,v3);

  vavg = (v1+v2+v3)/3.0;

  return vavg;

}
