#include "reduction.h"

float local_amp(float *vec, long dim, long idx){

  float left, right, *x;
  
  long i, j, rf, lf;


  x = vector(1, dim);


  for(i = 1; i <= dim; i++) x[i] = fabs(vec[i]);

  rf = 0;
  lf = 0;

  /* Search for maxima on both sides of x */

  i = idx;
  j = idx;

  while( (rf == 0) || (lf == 0) ){

    /* check for edges */

    if(i == 1) lf = 1;
    if(j == dim) rf = 1;

    if((i > 1) && (lf == 0)){
      if(x[i-1] < x[i]){
	lf = 1;
	left = vec[i];
      }
      i--;
    }


    if((j < dim) && (rf == 0)){
      if(x[j+1] < x[j]){
	rf = 1;
	right = vec[j];
      }
      j++;
    }

  }/*endwhile*/

  free_vector(x, 1, dim);

  return(fabs(right-left));

}
