#include <math.h>

void nrerror(char error_text[]);

float rtbis(float (*func)(float), float x1, float x2, float xacc){

  long j, JMAX = 100;
  float dx, f, fmid, xmid, rtb;

  if(fabs(x1) <= xacc) return x1;
  if(fabs(x2) <= xacc) return x2;

  f = (*func)(x1);
  fmid = (*func)(x2);

  if(f*fmid >= 0.0){

    if(f*fmid == 0.0){

      if(f == 0.0) return x1;
      if(fmid == 0.0) return x2;

    }else{
      printf("[%f, %f], [%f, %f]\n", x1, x2, f, fmid);
      nrerror("Root must be bracketed for bisection in rtbis");
    }
  }

  rtb = f < 0.0 ? (dx = x2-x1, x1) : (dx = x1-x2, x2);

  for(j = 1; j <= JMAX; j++){

    fmid = (*func)(xmid = rtb+(dx *= 0.5));
    if(fmid <= 0.0) rtb = xmid;
    if(fabs(dx) < xacc || fmid == 0.0) return rtb;

  }

  nrerror("Too many bisections in rtbis");
  return 0.0;

}
