/* translate_img.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Translate image.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   6 April 2001
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

unsigned char *
translate_img (imginp, xdim, ydim, nbypix, xshift, yshift)

unsigned char *imginp ;
int xdim, ydim ;
float xshift, yshift ;

{
    extern float blint () ;
    unsigned char *imgout ;   

    unsigned char *cibuf ;
    unsigned char *cobuf ;
    short *sibuf ;
    short *sobuf ;
    float *fibuf ;
    float *fobuf ;

    int ix, iy ;
    float fval ;
    float xx, yy ;

    imgout = (unsigned char *) malloc (xdim * ydim * nbypix) ;

    /*** Perform translation using bilinear interpolation. ***/

    if (nbypix == 1)
	{
	cibuf = (unsigned char *) imginp ;
	cobuf = (unsigned char *) imgout ;
        for (iy = 0 ; iy < ydim ; iy++)
	    {
            yy = (float) iy + yshift ;
	    for (ix = 0 ; ix < xdim ; ix++)
	        {
	        xx = (float) ix + xshift ;
	        fval = blint (cibuf, nbypix, xdim, ydim, xx, yy) ;
	        if (fval < 0)
	            *(cobuf + ix + iy*xdim) = 0 ;
                else
	            *(cobuf + ix + iy*xdim) = (unsigned char) fval ;
	        }
	    }
	}
    else
    if (nbypix == 2)
	{
	sibuf = (short *) imginp ;
	sobuf = (short *) imgout ;
        for (iy = 0 ; iy < ydim ; iy++)
	    {
            yy = (float) iy + yshift ;
	    for (ix = 0 ; ix < xdim ; ix++)
	        {
	        xx = (float) ix + xshift ;
	        fval = blint (sibuf, nbypix, xdim, ydim, xx, yy) ;
	        if (fval < 0)
	            *(sobuf + ix + iy*xdim) = 0.0 ;
                else
	            *(sobuf + ix + iy*xdim) = (short) fval ;
	        }
	    }
	}
    else
    if (nbypix == 4)
	{
	fibuf = (float *) imginp ;
	fobuf = (float *) imgout ;
        for (iy = 0 ; iy < ydim ; iy++)
	    {
            yy = (float) iy + yshift ;
	    for (ix = 0 ; ix < xdim ; ix++)
	        {
	        xx = (float) ix + xshift ;
	        fval = blint (fibuf, nbypix, xdim, ydim, xx, yy) ;
	        if (fval < 0)
	            *(fobuf + ix + iy*xdim) = 0.0 ;
                else
	            *(fobuf + ix + iy*xdim) = (short) fval ;
	        }
	    }
	}
    else
	{
	fprintf (stderr, "Invalid data type . . . nbypix = %d\n", nbypix) ;
	return (NULL) ;
	}

    return (imgout) ;
}
