/* analog11.c
 *
 * Examine ANALOG11 in CHIP header.
 *
 * Andrew L. Stanger   HAO/NCAR   21 March 2001
 */
#include <stdio.h>
#define ACOS
#include "acos.h"
#include "acoslib.h"

main (argc, argv)

int argc ;
char *argv [] ;

{
   static char listname [80] ;
   static char filename [80] ;
   float dometemp ;
   FILE *FDLIST, *FD ;
   int pmode = 0 ;
   int i ;

   strcpy (listname, argv[1]) ;

   FDLIST = fopen (listname, "r") ;
   while (fscanf (FDLIST, "%s", filename) != EOF)
      {
      FD = fopen (filename, "r") ;
      if (fread ((char *) &ACOSHS, sizeof (ACOSHS), 1, FD) == NULL)
	 {
         fprintf (stderr, "Unable to read header structure in file %s\n",
		  filename) ;
         return (-1) ;
         }

      /*** Print header. ***/

      if (pmode)
         {
         fprintf (stdout, "ACOSH->Version:		%10d\n",	ACOSH->Version) ;
         fprintf (stdout, "ACOSH->Year   :		%10d\n",	ACOSH->Year   ) ;
         fprintf (stdout, "ACOSH->Month  :		%10d\n",	ACOSH->Month  ) ;
         fprintf (stdout, "ACOSH->Day    :		%10d\n",	ACOSH->Day    ) ;
         fprintf (stdout, "ACOSH->Hour   :		%10d\n",	ACOSH->Hour   ) ;
         fprintf (stdout, "ACOSH->Minute :		%10d\n",	ACOSH->Minute ) ;
         fprintf (stdout, "ACOSH->Sec    :		%10d\n",	ACOSH->Sec    ) ;
         fprintf (stdout, "ACOSH->Xdim   :		%10d\n",	ACOSH->Xdim   ) ;
         fprintf (stdout, "ACOSH->Ydim   :		%10d\n",	ACOSH->Ydim   ) ;
         fprintf (stdout, "ACOSH->Nsum   :		%10d\n",	ACOSH->Nsum   ) ;
         fprintf (stdout, "ACOSH->Exposure:	%10d\n",	ACOSH->Exposure) ;
         fprintf (stdout, "ACOSH->Gain   :		%10d\n",	ACOSH->Gain   ) ;
         fprintf (stdout, "ACOSH->Odisk  :		%10d\n",	ACOSH->Odisk  ) ;
         fprintf (stdout, "ACOSH->Type   :		%10d\n",	ACOSH->Type   ) ;
         fprintf (stdout, "ACOSH->Wave   :		%10.4f\n",	ACOSH->Wave   ) ;
         fprintf (stdout, "ACOSH->Pangle :		%10.4f\n",	ACOSH->Pangle ) ;
         fprintf (stdout, "ACOSH->Bangle :		%10.4f\n",	ACOSH->Bangle ) ;
         fprintf (stdout, "ACOSH->Langle :		%10.4f\n",	ACOSH->Langle ) ;
         fprintf (stdout, "ACOSH->RA     :		%10.4f\n",	ACOSH->RA     ) ;
         fprintf (stdout, "ACOSH->Dec    :		%10.4f\n",	ACOSH->Dec    ) ;
         fprintf (stdout, "ACOSH->HA     :		%10.4f\n",	ACOSH->HA     ) ;
         fprintf (stdout, "ACOSH->Elevation:	%10.4f\n",	ACOSH->Elevation) ;
         fprintf (stdout, "ACOSH->Azimuth:		%10.4f\n",	ACOSH->Azimuth) ;
         fprintf (stdout, "ACOSH->Amass  :		%10.4f\n",	ACOSH->Amass  ) ;
         fprintf (stdout, "ACOSH->Radius :		%10.4f\n",	ACOSH->Radius ) ;
         for (i = 0; i < 16; i++)
            fprintf (stdout, "ACOSH->Xshift [%d]:	%10.3f\n",
                              i, ACOSH->Xshift [i]) ;
         for (i = 0; i < 16; i++)
            fprintf (stdout, "ACOSH->Yshift [%d]:	%10.3f\n",
                              i, ACOSH->Yshift [i]) ;
         for (i = 0; i < 16; i++)
            fprintf (stdout, "ACOSH->Diam [%d]:	%10.3f\n",
                              i, ACOSH->Diam [i]) ;
         for (i = 0; i < 32; i++)
            fprintf (stdout, "ACOSH->Pos [%d]:	%10d\n",
                              i, ACOSH->Pos [i]) ;
         for (i = 0; i < 32; i++)
            fprintf (stdout, "ACOSH->Drive [%d]:	%10d\n",
                              i, ACOSH->Drive [i]) ;
         for (i = 0; i < 16; i++)
            fprintf (stdout, "ACOSH->Analog [%d]:	%10.3f\n",
                              i, ACOSH->Analog [i]) ;
         for (i = 0; i <  8; i++)
            fprintf (stdout, "ACOSH->Lcvr [%d]:	%10.3f\n",
                              i, ACOSH->Lcvr [i]) ;
         for (i = 0; i <  6; i++)
            fprintf (stdout, "ACOSH->Mic [%d]:	%10.3f\n",
                              i, ACOSH->Mic [i]) ;
         fprintf (stdout, "\n") ;
         }
      fprintf (stdout, "%s   Analog11: %10.3f\n",
	       filename, ACOSH->Analog [11]) ;  
      fclose (FD) ;
      }
   
   fclose (FDLIST) ;
   
}
   
