/* fixchiptime.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Modify time in binary header of CHIP image(s) [native format].
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR    23 April 2001
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#define ACOS
#include "acoslib.h"
#define MAXFILES 250

main (argc, argv)

int argc ;
char *argv [] ;

{
   extern unsigned char *malloc () ;
   extern unsigned char *rdacos () ;    /* Function to read ACOS image. */

   unsigned char *acosbuf ;             /* MLSO ACOS file  array pointer. */
   unsigned char *padbuf ;
   char imgbuf ;
   static char flist [MAXFILES][80] ;
   static char linbuf [84] ;
   static char name [80] ;
   static char namext1 [80] = "\0" ;
   static char namext2 [80] = "\0" ;
   static char namext3 [80] = "\0" ;
   static char namimg [80] ;
   static char namout [80] ;
   static char namlst [80] ;
   static char time_obs [12] = "\0" ;

   FILE *LIST, *FDOUT ;

   int argp = 1 ;
   int findex = 0 ;		/* File index. */
   int hour, minute, second ;
   int i ;
   int nbypix = 2 ;
   int nelwr ;
   int nx, ny, npximg, npximgs ;
   int nf = 0 ;
   int numfil = 0 ;
   int pmode = 0 ;		/* Print mode: 0=silent, 1=verbose. */
   int sizehd = 0 ;
   int sizepad = 0 ;

 if (argc == 1)			/* No arguments. */
       {
      fprintf (stderr, "usage: %s -t hh:mm:ss image_file[s]  | @image_file_list\n",
	       argv [0]) ;
      exit (-1) ;
      }
   else
      {
      nf  = 0 ;
      while (argp < argc)	/* Copy filenames into flist array. */
	 {
         strcpy (name, argv [argp]) ;

	 if (name [0] == '-')
	    {
	    argp++ ;
	    strcpy (time_obs, argv [argp]) ;
	    sscanf (time_obs, "%2d:%2d:%2d\n", &hour, &minute, &second) ;
	    argp++ ;
            continue ;
	    }

         if (name [0] == '@')	/* List of filenames. */
            {
            strcpy (namlst, &name [1]) ;
	    printf ("namlst: %s\n", namlst) ;
            if ((LIST = fopen (namlst, "r")) == NULL)
               {
               fprintf (stderr, "Unable to open list file %s\n", namlst) ;
               exit (-2) ;
               }
            while (fscanf (LIST, "%s", name) != EOF)
               {
               strcpy (&flist [nf++][0], name) ;  /* Copy filenames to flist. */
               }
            fclose (LIST) ;
            }
         else
            strcpy (&flist [nf++][0], argv [argp]) ;

	 argp++ ;
	 }
      numfil = nf ;
      }

loop:

   strcpy (namimg, &flist [findex++][0]) ;
   printf ("namimg: %s\n", namimg) ;

   acosbuf = rdacos (namimg, pmode) ;/* Read ACOS dataset into memory. */

   nx = ACOSI->xdim ;			/* X dimension. */
   ny = ACOSI->ydim ;			/* Y dimension. */
   npximg = nx * ny ;			/* # pixels in image. */
   npximgs = npximg - nx ;		/* # pixels in image. */
   nbypix = sizeof (short) ;		/* # bytes per pixel. */

   sizehd = sizeof (ACOSHS) ;
   sizepad = nx * nbypix - sizehd ;
   padbuf = malloc (sizepad) ;
   for (i = 0 ; i < sizepad ; i++)  *(padbuf + i) = 0 ;

/*
   hour   = 25 ;
   minute = 48 ;
   second =  2 ;
 */
   printf ("time_obs: %s\n", time_obs) ;

   if (strlen (time_obs) > 0)
      {
      ACOSH->Hour   = hour ;
      ACOSH->Minute = minute ;
      ACOSH->Sec    = second ;

      sprintf (namout, "%s.time", namimg) ;
      printf ("namout: %s\n", namout) ;
      FDOUT = fopen (namout, "w") ;
      nelwr = fwrite ((char *) &ACOSHS, sizeof (ACOSHS),   1,       FDOUT) ;
      nelwr = fwrite (padbuf,                1,            sizepad, FDOUT) ;
      nelwr = fwrite (acosbuf + nx * nbypix, ACOSI->nbypx, npximgs,  FDOUT) ;
      fclose (FDOUT) ;
      }

/*   strcpy (time_obs, "") ; */		/*** Set time_obs to NULL. ***/

   if (findex < numfil) goto loop ;

   exit (0) ;
}
