/* ldfunc2.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Limb darkening function #2   [acquired from Randy Meisner]
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   16 August 2000
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include <math.h>

float
ldfunc2 (r, coef, ncoef)

float r ;				/* Must be in Rsun units. */
float *coef ;
int ncoef ;
{
   float mag ;
   float u ;

   u = sqrt (1.0 - r * r) ;

   mag = coef [0] + coef [1] * u * coef [2] * (1.0 - u * logf (1.0 + 1.0 / u)) ;

/*
 *   printf ("ldfunc2> r: %7.2f   coef: %8.2e   %8.2e   %8.2e   mag: %8.2e\n",
 *	   r, coef [0], coef [1], coef [2], mag) ;
 *   fflush (stdout) ;
 */

   return (mag) ;
}
