/******************************************************************************
    Name:		analog.h

    Purpose:	Scale factors and names for analog devices

    Author:		David Elmore

    Date:		Mon Aug 21 14:44:21 MDT 1995

******************************************************************************/

#define		NUM_A2D		16

struct		a2d	{
			float	gain;
			float	min;
			float	max;
			float	minok;
			float	maxok;
			short	offset;
			char	*name;
			};

#ifdef START

struct	a2d	analog [NUM_A2D] =
	{
	 0.0195, 	-20.0,	60.,	22.5,	24.5,	-1024,	"dPmon/LowK Plate Temp",
	 0.0195, 	-20.0,	60.,	22.5,	24.5,	-1024,	"dPmon/LowK Air Temp",
	 0.0195, 	-20.0,	60.,	22.5,	24.5,	-1024,	"dPmon/LowK Filter Temp",
	 0.0195, 	-20.0,	60.0,	 22.5,	24.5,	-1024,	"dPmon/LowK Spare Temp",
	-0.0122, 	+5.0,	55.0,	 22.5,	24.5,	 2458,	"LowK PBS Temp",
	-0.0122, 	+5.0,	55.0,	 22.5,	24.5,	 2458,	"LowK Modulator Temp",
	-0.004883, 	-10.0,	10.0,	  3.0,	4.5,	    0,	"Sky Transmission",
	-0.004883, 	-10.0,	10.0,	-10.0,	10.0,	    0,	"Spare Voltage",
	-0.0122, 	+5.0,	55.0,	 34.7,	34.9,	 2458,	"CHIP Filter Temp",
	 0.0195, 	-20.0,	60.0,	 22.5,	24.5,	-1024,	"CHIP Plate Temp",
	 0.0195, 	-20.0,	60.0,	 22.5,	24.5,	-1024,	"CHIP Air Temp",
	 0.0195, 	-20.0,	60.0,	 22.5,	24.5,	-1024,	"CHIP Spare Temp",
	-0.004883, 	-10.0,	10.0,	-10.0,	10.0,	    0, 	"Guider X Error",
	-0.004883, 	-10.0,	10.0,	-10.0,	10.0,	    0, 	"Guider Y Error",
	-0.004883, 	-10.0,	10.0,	-10.0,	10.0,	    0, 	"O1 X Error",
	-0.004883, 	-10.0,	10.0,	-10.0,	10.0,	    0,	"O1 Y Error" 
	};
			
#else

extern	struct	a2d	analog [NUM_A2D];

#endif

