/******************************************************************************
    Name:       lcvr.h

    Purpose:    Scale factors and names for filter and modulator 

    Author:     David Elmore

    Date:       Mon Aug 21 14:44:21 MDT 1995

******************************************************************************/


#define     NUM_LCVR		8
#define     MIN_WAVE		1074.
#define     MAX_WAVE		1086.
#define     DEL_WAVE		0.01
#define     NUM_WAVE		(int)((MAX_WAVE-MIN_WAVE)/DEL_WAVE + 1)
#define     MIN_RETARD		0.
#define     MAX_RETARD		1.
#define     NUM_WAVESTATE	4
#define     NUM_ELEMENT		4
#define     NUM_MODSTATE	4

#ifdef START

char	*lcvr_name [NUM_LCVR] =
	{
    "CHIP Filter Stage 4",
    "CHIP Filter Stage 3",
    "CHIP Filter Stage 2",
    "CHIP Filter Stage 1",
    "Spare LCVR 3",
    "Spare LCVR 2",
    "Spare LCVR 1",
    "Lowk Modulator Stage 1"
    };
			
float	filter_state [NUM_WAVESTATE] = {1083.0, 1083.0, 1083.0, 1083.0};
float	mod_state = 0.707;
int 	filter_volts [NUM_WAVESTATE][NUM_ELEMENT] = 
			{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
int 	mod_volts [NUM_MODSTATE] = {0.875, 0.635, 0.375, 0.125};
int		filter_index = 0;
int		mod_index = 0;
int		filter_init = 0;
int		mod_init = 0;
#else 

extern	char	*lcvr_name [NUM_LCVR];

extern	float	filter_state [NUM_WAVESTATE];
extern	float	mod_state;
extern	int 	filter_volts [NUM_WAVESTATE][NUM_ELEMENT];
extern	int 	mod_volts [NUM_MODSTATE];
extern	int		filter_index;
extern	int		mod_index;
extern	int		filter_init;
extern	int		mod_init;

#endif

