pro chipi2fts

;+
;--- Convert MLSO/CHIP short integer image to FITS format.
;
; Andrew L. Stanger   HAO/NCAR   23 Aug 1995
;-

xdim = 767
ydim = 516
imgbuf = intarr (xdim, ydim) 
chipmin = 9000 & chipmax = 10500
 
filename = 'chip.img'
fileout  = 'chip.img.fts'
listfile = 'chipi.l'
   loadct, 0
   window
 
   close, 10 & openr, 10, listfile
 
   while ( not eof (10) ) do begin ;{
      readf, 10, filename
      fileout = filename + '.fts'
      close, 11 & openr, 11, filename
      readu, 11, imgbuf & close, 11 
      bytbuf = bytscl (imgbuf, min=chipmin, max=chipmax)
      tv, bytbuf

      fxhmake,  hdu, bytbuf			; Make basic FITS header.
      fxaddpar, hdu, 'ORIGIN', 'MLSO'
      fxaddpar, hdu, 'TELESCOP', 'ACOS'
      fxaddpar, hdu, 'INSTRUME', 'CHIP'
      fxaddpar, hdu, 'OBJECT', 'SUN'
      fxaddpar, hdu, 'TYPE-OBS', 'HE-1083 NM'
      fxaddpar, hdu, 'DATE-OBS', '26/06/95'
      hour   = strmid (filename, 11, 2)
      ihour  = fix (hour)
      ihour = ihour + 6
      hour = string (ihour, FORMAT = "(I2)")
      minute = strmid (filename, 13, 2)
      time_obs = hour + ':' + minute + ':00'
      fxaddpar, hdu, 'TIME-OBS', time_obs
      fxaddpar, hdu, 'COMMENT', '  FINAL SHIFT IMAGES'
      fileout = 'chip.950626.' + hour + minute + '.shift.fts'
      print, 'CHIP name: ', filename, '   FITS name: ', fileout
      writefits, fileout, bytbuf, hdu		; Write image as FITS file.
   endwhile ;} 
 
   close, 10

end 
