/* chip_rename.c
 *------------------------------------------------------------------------------
 * Rename CHIP files.
 *------------------------------------------------------------------------------
 * Andrew L. Stanger   HAO/NCAR   18 Dec 2002
 *------------------------------------------------------------------------------
 */

#include <stdio.h>

main (argc, argv)

int argc ;
char *argv [] ;

{
    extern int month_day () ;
    static char list1   [80] ;
    static char list2   [80] = "dochipcopy" ;
    static char oldfile [80] ;
    static char newfile [80] ;
    static char ext     [24] ;
    static char month_name [12][4] = {"jan", "feb", "mar", "apr", "may", "jun",
				      "jul", "aug", "sep", "oct", "nov", "dec"
				      } ;

    int year ;
    int doy  ;
    int month ;
    int day ;
    int time ;

    FILE *FD1, *FD2 ;

    sscanf (argv [1], "%s", list1) ;

    FD1 = fopen (list1, "r") ;
    FD2 = fopen (list2, "w") ;

    while (fscanf (FD1, "%s", oldfile) != EOF)
        {
	sscanf (oldfile, "%02dd%03d.%06d.%s", &year, &doy, &time, ext) ;

	if (year < 50)  year += 2000 ;
	if (year > 50 && year < 100)  year += 1900 ;
	month_day (year, doy, &month, &day) ;

	sprintf (newfile, "%04d%02d%02d.%06d.chp.%s.fts.gz",
		year, month, day, time, ext) ;
	printf ("%s --> %s\n", oldfile, newfile) ;
	fprintf (FD2, "cp /toshi/ftp/%04d/%02d_%s/%s .\n",
		 year, month, &month_name [month-1][0], newfile) ;
	}

    fclose (FD1) ;
    fclose (FD2) ;
    exit (0) ;
}

