/* strsub.c
 * -----------------------------------------------------------------------------
 * Subsitute string fragment f2 for f1 in the string array s1.
 * -----------------------------------------------------------------------------
 * Andrew L. Stanger   HAO/NCAR   17 Apr 2002
 * -----------------------------------------------------------------------------
 */

#include <stdio.h>

char *
strsub (s1, f1, f2)

char *s1 ;			/* Input string. */
char *f1 ;			/* String fragment 1 */
char *f2 ;			/* String fragment 2 */

{
    char *f3 ;
    char *f4 ;
    char *s2 ;

    int i, j ;
    int pmode = 0 ;		/* =0 silent, =1 verbose. */
    int s1len ;
    int s1ext ;
    int s2len ;

    int f1len ;
    int f2len ;
    int f1beg ;
    int f1end ;
    int f2end ;
    int f3len ;
    int f4len ;

    s1len = strlen (s1) ;
    f1len = strlen (f1) ;
    f2len = strlen (f2) ;

    if (pmode)
	{
        fprintf (stdout, "s1: %s   s1len: %d\n", s1, s1len) ;
        fprintf (stdout, "f1: %s   f1len: %d\n", f1, f1len) ;
        fprintf (stdout, "f2: %s   f2len: %d\n", f2, f2len) ;
        fflush (stdout) ;
	}

    for (i = 0; i < s1len; i++)
        {
        if (*(s1 + i) == *(f1 + 0))
	    {
	    f1beg = i ;
	    f1end = f1beg + f1len - 1 ;	  /* projected end of f1 */
	    s1ext = s1len - 1 - f1end ;   /* # characters after f1 in s1 */

	    f3 = s1 + f1beg ;
	    f4 = s1 + f1end + 1 ;
	    f3len = strlen (f3) ;
	    f4len = strlen (f4) ;

	    if (pmode)
		{
	        fprintf (stdout, "f3: %s  f3len: %d\n", f3, f3len) ;
	        fprintf (stdout, "f4: %s  f4len: %d\n", f4, f4len) ;
	        fprintf (stdout, "f1beg: %d  f1end: %d\n", f1beg, f1end) ;
	        fprintf (stdout, "s1ext: %d\n", s1ext) ;
	        fflush (stdout) ;
		}

	    if (f1end > s1len)
	        {
	        fprintf (stdout, "%s not found in %s\n", f1, s1) ;
	        return (NULL) ;
	        }

            if (strncmp (f1, f3, f1len) != NULL)
		i++;
	    else
    	        {
    	        f2end = f1beg + f2len - 1 ;
    	        s2len = f2end + f4len + 1 ;
    	        s2 = (char *) malloc (s2len + 1) ; 

		if (pmode)
		    {
		    fprintf (stdout, "f2end: %d\n", f2end) ;
		    fprintf (stdout, "s2len: %d\n", s2len) ;
		    }
    
    	        for (j = 0; j < f1beg; j++)
    		    {
    		    *(s2 + j) = *(s1 + j) ;
    		    }
    	        for (j = 0; j < f2len; j++)
    		    {
    		    *(s2 + f1beg + j) = *(f2 + j) ;
    		    }
                for (j = 0; j < s1ext; j++)
    		    {
    		    *(s2 + f1beg + f2len + j) = *(f4 + j) ;
    		    }
                *(s2 + s2len) = '\0' ;
                }
	    }
        }

    if (pmode)
	{
        fprintf (stdout, "s2: %s\n", s2) ;
        fflush (stdout) ;
	}

    return (s2) ;
}
