/******************************************************************************
  Name:  analog.h

  Purpose:  Scale factors and names for analog devices

  Author:  David Elmore

  Date:  Mon Aug 21 14:44:21 MDT 1995

******************************************************************************/

#define  NUM_A2D  16

struct  a2d  {
    float  gain;
    float  min;
    float  max;
    float  minok;
    float  maxok;
    short  offset;
    char  *name;
    };

#ifdef START

/* Gain, minimum, maximum, minimum_OK, maximum_OK, offset, name */
struct  a2d  analog[NUM_A2D]  =  {
    0.0195,   -20.,  60.,  -20.,  60.0,  -1024,  "dPmon/LowK Plate Temp",
    0.0195,   -20.,  60.,  -20.,  60.0,  -1024,  "dPmon/LowK Air Temp",
    0.0195,   -20.,  60.,  -20.,  60.0,  -1024,  "dPmon/LowK Filter Temp",
    0.0195,   -20.,  60.,  -20.,  60.0,  -1024,  "dPmon/LowK Spare Temp",
    -.0122,   +5.,  55.,  5.00,  55.0,   2458,  "LowK PBS Temp",
    -.0122,   +5.,  55.,  5.00,  55.0,   2458,  "LowK Modulator Temp",
    -.004883,   -10.,  10.,  -10.,  -3.0,  0,  "Sky Transmission",
    -.004883,   -10.,  10.,  -10.,  10.,  0,   "Spare Voltage",
    -.0122,   +5.,  55.,  34.3,  34.5,   2458,   "CHIP Filter Temp",
    0.0195,   -20.,  60.,  20.0,  25.0,  -1024,   "CHIP Plate Temp",
    0.0195,   -20.,  60.,  20.0,  25.0,  -1024,   "CHIP Air Temp",
    0.0195,   -20.,  60.,  0.00,  25.0,  -1024,   "CHIP Dome Temp",
    -.004883,   -10.,  10.,  -10.,  10.,  0,   "Guider X Error",
    -.004883,   -10.,  10.,  -10.,  10.,  0,   "Guider Y Error",
    -.004883,   -10.,  10.,  -10.,  10.,  0,   "O1 X Error",
    -.004883,   -10.,  10.,  -10.,  10.,  0,   "O1 Y Error" 
    };
    
#else

extern  struct  a2d  analog[NUM_A2D];

#endif

