/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <stdio.h>
#define MAXLIN 180
#include "/home/cordyn/mlsofits/lib/acos/acos.h"
#include "/home/stanger/lib/src/dpmnew/dpmlib.h"
#include "/home/stanger/lib/src/dpmnew/dpm_optdev.h"

int
dpmext (FF, object, type_obs, date_obs, time_obs, pmode)

FILE *FF ;
char object [] ;
char type_obs [] ;
char date_obs [] ;
char time_obs [] ;
int pmode ;
{
   extern char *malloc () ;             /* Function to allocate memory. */

   static char fitbuf [MAXLIN][80] ;    /* FITS header buffer. */
   unsigned char dpmhdr [120] ;
   int   *ibuf ;
   float *fbuf ;
   static char kamass    [12] = "AMASS   " ;
   static char kazimuth  [12] = "AZIMUTH " ;
   static char kbitpix   [12] = "BITPIX  " ;
   static char kbangle   [12] = "BANGLE  " ;
   static char kdate_obs [12] = "DATE-OBS" ;
   static char kday      [12] = "DAY     " ;
   static char kexposure [12] = "EXPOSURE" ;
   static char kelev     [12] = "ELEV    " ;
   static char kgain     [12] = "GAIN    " ;
   static char kgcount   [12] = "GCOUNT  " ;
   static char kha       [12] = "HA      " ;
   static char khour     [12] = "HOUR    " ;
   static char klangle   [12] = "LANGLE  " ;
   static char kminute   [12] = "MINUTE  " ;
   static char kmonth    [12] = "MONTH   " ;
   static char knaxis    [12] = "NAXIS   " ;
   static char knaxis1   [12] = "NAXIS1  " ;
   static char knsum     [12] = "NSUM    " ;
   static char kobject   [12] = "OBJECT  " ;
   static char kodisk    [12] = "ODISK   " ;
   static char koptics00 [12] = "OPTICS00" ;
   static char koptics01 [12] = "OPTICS01" ;
   static char koptics02 [12] = "OPTICS02" ;
   static char koptics03 [12] = "OPTICS03" ;
   static char koptics04 [12] = "OPTICS04" ;
   static char koptics05 [12] = "OPTICS05" ;
   static char koptics06 [12] = "OPTICS06" ;
   static char koptics07 [12] = "OPTICS07" ;
   static char koptdev00 [12] = "OPTDEV00" ;
   static char koptdev01 [12] = "OPTDEV01" ;
   static char koptdev02 [12] = "OPTDEV02" ;
   static char koptdev03 [12] = "OPTDEV03" ;
   static char koptdev04 [12] = "OPTDEV04" ;
   static char koptdev05 [12] = "OPTDEV05" ;
   static char koptdev06 [12] = "OPTDEV06" ;
   static char koptdev07 [12] = "OPTDEV07" ;
   static char koptpos00 [12] = "OPTPOS00" ;
   static char koptpos01 [12] = "OPTPOS01" ;
   static char koptpos02 [12] = "OPTPOS02" ;
   static char koptpos03 [12] = "OPTPOS03" ;
   static char koptpos04 [12] = "OPTPOS04" ;
   static char koptpos05 [12] = "OPTPOS05" ;
   static char koptpos06 [12] = "OPTPOS06" ;
   static char koptpos07 [12] = "OPTPOS07" ;
   static char korigin   [12] = "ORIGIN  " ;
   static char kpangle   [12] = "PANGLE  " ;
   static char kpcount   [12] = "PCOUNT  " ;
   static char kradius   [12] = "RADIUS  " ;
   static char ksec      [12] = "SEC     " ;
   static char ktelescop [12] = "TELESCOP" ;
   static char ktime_obs [12] = "TIME-OBS" ;
   static char ktype     [12] = "TYPE    " ;
   static char ktype_obs [12] = "TYPE-OBS" ;
   static char kversion  [12] = "VERSION " ;
   static char kxdim     [12] = "XDIM    " ;
   static char kydim     [12] = "YDIM    " ;
   static char kyear     [12] = "YEAR    " ;

   static char extname   [12] = "DPM_HDR1" ;
   static char origin    [12] = "MLSO" ;
   static char origincom [32] = "MAUNA LOA SOLAR OBSERVATORY" ;
   static char outbuf    [84] ;
   static char pixcom    [48] ;                        /* Data type comment. */
   static char telescop  [12] = "DPM" ;          /* Telescope name. */
   static char tscopcom  [44] = "DIGITAL PROMINENCE MONITOR" ;
   static char eq        [4]  = "= " ;
   unsigned char *fillbuf, *qq ;

   int gcount	= 1 ;			/* gcount. */
   int pcount	= 0 ;			/* pcount. */
   int i ;
   int ix	= 0 ;
   int iy	= 0 ;
   int iyear ;
   int ival	= 0 ;
   int bitpix	= 8 ;
   int nbyhdr	= 120 ;
   int nbyfits	= 2880 ;                 /* # bytes per FITS logical record. */
   int naxis	= 1 ;
   int nelwr	= 0 ;
   int nfill ;
   int nhdu	= 0 ;			/* # FITS header blocks. */
   int nrec ;                           /* # FITS records for binary data. */
   int year_obs ;
   int doy_obs ;
   int znum	= 0 ;
   int zz	= 0 ;

   /*** Determine day-of-year. ***/

   iyear = DPMI->year ;
   if (DPMI->year > 1900)  iyear = DPMI->year - 1900 ;
   year_obs = iyear + 1900 ;
   doy_obs  = day_of_year (iyear, DPMH->Month, DPMH->Day) ;

   strcpy (pixcom,   "1-BYTE UNSIGNED BYTES") ;

   /*** Fill FITS buffer with ASCII blanks.***/

   for (iy = 0 ; iy < MAXLIN ; iy++)
      for (ix = 0 ; ix < 80 ; ix++)
         fitbuf [iy][ix] = ' ' ;

   zz = 0 ;

   sprintf (&fitbuf [zz  ][ 0], "XTENSION= '%-8s'", extname) ;
   sprintf (&fitbuf [zz++][31], "/ MLSO/DPM HOUSEKEEPING EXTENSION") ;

   sprintf (&fitbuf [zz++][ 0], "%-8s%2s%20d / %s", kbitpix, eq, bitpix, pixcom) ;
   sprintf (&fitbuf [zz++][ 0], "%-8s%2s%20d / NUMBER OF DIMENSIONS",
                                knaxis, eq, naxis) ;

   sprintf (&fitbuf [zz++][ 0], "%8s%2s%20d / SIZE OF FIRST DIMENSION",
	                        knaxis1, eq, nbyhdr) ;

   sprintf (&fitbuf [zz++][ 0], "%-8s%2s%20d / EXTENSION PCOUNT",
                                kpcount, eq, pcount) ;

   sprintf (&fitbuf [zz++][ 0], "%-8s%2s%20d / EXTENSION GCOUNT",
                                kgcount, eq, gcount) ;

/*
 *   sprintf (&fitbuf [zz++][ 0], "          ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^") ;
 */

   sprintf (&fitbuf [zz  ][ 0], "%-8s%2s'%-8s'",     korigin,   eq, origin) ;
   sprintf (&fitbuf [zz++][31], "/ %s", origincom) ;
   sprintf (&fitbuf [zz  ][ 0], "%-8s%2s'%-8s'",     ktelescop, eq, telescop) ;
   sprintf (&fitbuf [zz++][31], "/ %s", tscopcom) ;

   sprintf (&fitbuf [zz  ][ 0], "%-8s%2s'%-8s'",     kobject,   eq, object) ;
   sprintf (&fitbuf [zz++][31], "/ SOURCE OBJECT") ;

   sprintf (&fitbuf [zz  ][ 0], "%-8s%2s'%-8s'", ktype_obs, eq, type_obs) ;
   sprintf (&fitbuf [zz++][31], "/ TYPE OF OBSERVATION [DESCRIPTION]") ;

   sprintf (&fitbuf [zz  ][ 0], "%-8s%2s'%-8s'",     kdate_obs, eq, date_obs) ;
   sprintf (&fitbuf [zz++][31], "/ OBSERVATION DATE: DD/MM/YY [UT] DOY %03d %d",
                                doy_obs, year_obs) ;

   sprintf (&fitbuf [zz  ][ 0], "%-8s%2s'%-8s'",     ktime_obs, eq, time_obs) ;
   sprintf (&fitbuf [zz++][31], "/ OBSERVATION TIME: HH:MM:SS [UT]") ;

/*
 *   sprintf (&fitbuf [zz++][ 0], "          ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^") ;
 */

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptdev00, eq, &DPMI->optdev [0][0]) ;
   sprintf (&fitbuf [zz++][31],"/ NAME:     OPTICAL DEVICE 0 [NOT USED]") ;
   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptpos00, eq, &DPMI->optpos [0][0]) ;
   sprintf (&fitbuf [zz++][31],"/ POSITION: OPTICAL DEVICE 0") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptdev01, eq, &DPMI->optdev [1][0]) ;
   sprintf (&fitbuf [zz++][31], "/ NAME:     OPTICAL DEVICE 1") ;
   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptpos01, eq, &DPMI->optpos [1][0]) ;
   sprintf (&fitbuf [zz++][31], "/ POSITION: OPTICAL DEVICE 1") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptdev02, eq, &DPMI->optdev [2][0]) ;
   sprintf (&fitbuf [zz++][31], "/ NAME:     OPTICAL DEVICE 2") ;
   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptpos02, eq, &DPMI->optpos [2][0]) ;
   sprintf (&fitbuf [zz++][31], "/ POSITION: OPTICAL DEVICE 2") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptdev03, eq, &DPMI->optdev [3][0]) ;
   sprintf (&fitbuf [zz++][31], "/ NAME:     OPTICAL DEVICE 3") ;
   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptpos03, eq, &DPMI->optpos [3][0]) ;
   sprintf (&fitbuf [zz++][31], "/ POSITION: OPTICAL DEVICE 3") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptdev04, eq, &DPMI->optdev [4][0]) ;
   sprintf (&fitbuf [zz++][31], "/ NAME:     OPTICAL DEVICE 4") ;
   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptpos04, eq, &DPMI->optpos [4][0]) ;
   sprintf (&fitbuf [zz++][31], "/ POSITION: OPTICAL DEVICE 4") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptdev05, eq, &DPMI->optdev [5][0]) ;
   sprintf (&fitbuf [zz++][31], "/ NAME:     OPTICAL DEVICE 5 [NOT USED]") ;
   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptpos05, eq, &DPMI->optpos [5][0]) ;
   sprintf (&fitbuf [zz++][31], "/ POSITION: OPTICAL DEVICE 5") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptdev06, eq, &DPMI->optdev [6][0]) ;
   sprintf (&fitbuf [zz++][31], "/ NAME:     OPTICAL DEVICE 6 [NOT USED]") ;
   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptpos06, eq, &DPMI->optpos [6][0]) ;
   sprintf (&fitbuf [zz++][31], "/ POSITION: OPTICAL DEVICE 6") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptdev07, eq, &DPMI->optdev [7][0]) ;
   sprintf (&fitbuf [zz++][31], "/ NAME:     OPTICAL DEVICE 7 [NOT USED]") ;
   sprintf (&fitbuf [zz  ][ 0], "%8s%2s'%-8s'",
			        koptpos07, eq, &DPMI->optpos [7][0]) ;
   sprintf (&fitbuf [zz++][31], "/ POSITION: OPTICAL DEVICE 7") ;


   sprintf (&fitbuf [zz++][ 0], "          ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^") ;


   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", kversion,  eq, DPMH->Version) ;
   sprintf (&fitbuf [zz++][31], "/ PROGRAM VERSION NUMBER       [INT BYTE#  0-  3]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", kyear,     eq, DPMH->Year) ;
   sprintf (&fitbuf [zz++][31], "/ YEAR                         [INT BYTE#  4-  7]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", kmonth,    eq, DPMH->Month) ;
   sprintf (&fitbuf [zz++][31], "/ MONTH                        [INT BYTE#  8- 11]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", kday,      eq, DPMH->Day) ;
   sprintf (&fitbuf [zz++][31], "/ DAY                          [INT BYTE# 12- 15]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", khour,     eq, DPMH->Hour) ;
   sprintf (&fitbuf [zz++][31], "/ HOUR                         [INT BYTE# 16- 19]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", kminute,   eq, DPMH->Minute) ;
   sprintf (&fitbuf [zz++][31], "/ MINUTE                       [INT BYTE# 20- 23]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", ksec,      eq, DPMH->Sec) ;
   sprintf (&fitbuf [zz++][31], "/ SECOND                       [INT BYTE# 24- 27]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", kxdim,     eq, DPMH->Xdim) ;
   sprintf (&fitbuf [zz++][31], "/ X-DIMENSION                  [INT BYTE# 28- 31]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", kydim,     eq, DPMH->Ydim) ;
   sprintf (&fitbuf [zz++][31], "/ Y-DIMENSION                  [INT BYTE# 32- 35]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", knsum,     eq, DPMH->Nsum) ;
   sprintf (&fitbuf [zz++][31], "/ # IMAGES SUMMED              [INT BYTE# 36- 39]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", kexposure, eq, DPMH->Exposure) ;
   sprintf (&fitbuf [zz++][31], "/ EXPOSURE [SEC*100]           [INT BYTE# 40- 43]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", kgain,     eq, DPMH->Gain) ;
   sprintf (&fitbuf [zz++][31], "/ CAMERA GAIN FACTOR           [INT BYTE# 44- 47]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", kodisk,    eq, DPMH->Odisk) ;
   sprintf (&fitbuf [zz++][31], "/ OCCULT DISK DIAM [ARCSEC]    [INT BYTE# 48- 51]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", ktype,     eq, DPMH->Type) ;
   sprintf (&fitbuf [zz++][31], "/ IMAGE TYPE [%-14s]  [INT BYTE# 52- 55]",
				&imgnam [DPMH->Type][0]) ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", koptics00, eq, DPMH->Optics [0]) ;
   sprintf (&fitbuf [zz++][31], "/ %-15.15s %-13.13s[INT BYTE# 56- 59]",
				 &DPMI->optdev [0][0], &DPMI->optpos [0][0]) ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", koptics01, eq, DPMH->Optics [1]);
   sprintf (&fitbuf [zz++][31], "/ %-15.15s %-13.13s[INT BYTE# 60- 63]",
				 &DPMI->optdev [1][0], &DPMI->optpos [1][0]) ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", koptics02, eq, DPMH->Optics [2]);
   sprintf (&fitbuf [zz++][31], "/ %-15.15s %-13.13s[INT BYTE# 64- 67]",
				 &DPMI->optdev [2][0], &DPMI->optpos [2][0]) ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", koptics03, eq, DPMH->Optics [3]);
   sprintf (&fitbuf [zz++][31], "/ %-15.15s %-7.7s [NM] [INT BYTE# 68- 71]",
				 &DPMI->optdev [3][0], &DPMI->optpos [3][0]) ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", koptics04, eq, DPMH->Optics [4]);
   sprintf (&fitbuf [zz++][31], "/ %-15.15s %-13.13s[INT BYTE# 72- 75]",
				 &DPMI->optdev [4][0], &DPMI->optpos [4][0]) ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", koptics05, eq, DPMH->Optics [5]);
   sprintf (&fitbuf [zz++][31], "/ %-15.15s %-13.13s[INT BYTE# 76- 79]",
				 &DPMI->optdev [5][0], &DPMI->optpos [5][0]) ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", koptics06, eq, DPMH->Optics [6]);
   sprintf (&fitbuf [zz++][31], "/ %-15.15s %-13.13s[INT BYTE# 80- 83]",
				 &DPMI->optdev [6][0], &DPMI->optpos [6][0]) ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20d", koptics07, eq, DPMH->Optics [7]);
   sprintf (&fitbuf [zz++][31], "/ %-15.15s %-13.13s[INT BYTE# 84- 87]",
				 &DPMI->optdev [7][0], &DPMI->optpos [7][0]) ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20.2f", kpangle,   eq, DPMH->Pangle) ;
   sprintf (&fitbuf [zz++][31], "/ SOLAR P-ANGLE    [DEG]     [FLOAT BYTE# 88- 91]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20.2f", kbangle,   eq, DPMH->Bangle) ;
   sprintf (&fitbuf [zz++][31], "/ SOLAR B-ANGLE    [DEG]     [FLOAT BYTE# 92- 95]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20.2f", klangle,   eq, DPMH->Langle) ;
   sprintf (&fitbuf [zz++][31], "/ SOLAR L-ANGLE    [DEG]     [FLOAT BYTE# 96- 99]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20.2f", kha,       eq, DPMH->HA) ;
   sprintf (&fitbuf [zz++][31], "/ SOLAR HOUR-ANGLE [DEG]     [FLOAT BYTE#100-103]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20.2f", kelev,   eq, DPMH->Elevation) ;
   sprintf (&fitbuf [zz++][31], "/ SOLAR ELEVATION  [DEG]     [FLOAT BYTE#104-107]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20.2f", kazimuth,  eq, DPMH->Azimuth) ;
   sprintf (&fitbuf [zz++][31], "/ SOLAR AZIMUTH    [DEG]     [FLOAT BYTE#108-111]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20.2f", kamass,    eq, DPMH->Amass) ;
   sprintf (&fitbuf [zz++][31], "/ AIR MASS [ATMOSPHERES]     [FLOAT BYTE#112-115]") ;

   sprintf (&fitbuf [zz  ][ 0], "%8s%2s%20.2f", kradius,   eq, DPMH->Radius) ;
   sprintf (&fitbuf [zz++][31], "/ SOLAR RADIUS  [ARCSEC]     [FLOAT BYTE#116-119]") ;

   sprintf (&fitbuf [zz++][ 0], "          ----------------------------------------------------------------------") ;
   sprintf (&fitbuf [zz++][ 0], "COMMENT   %s EXTENSION CONTAINS THE DPM BINARY HEADER (SIZE: 120 BYTES),", extname) ;
   sprintf (&fitbuf [zz++][ 0], "COMMENT   WHOSE CONTENTS ARE DESCRIBED ABOVE.  NOTE: FILL BYTES ELIMINATED.") ;
   sprintf (&fitbuf [zz++][ 0], "COMMENT   THE FIRST 22 ITEMS ARE 4-BYTE INTEGERS.") ;
   sprintf (&fitbuf [zz++][ 0], "COMMENT   THE NEXT   8 ITEMS ARE 4-BYTE FLOATING POINT VALUES.") ;
   sprintf (&fitbuf [zz++][ 0], "          ----------------------------------------------------------------------") ;

   /*** Terminate FITS HDU. ***/

   sprintf (&fitbuf [zz++][ 0], "END") ;

   /*** Set string's null terminator to blank. ***/
   /*** Convert all characters to upper case. ***/

   znum = zz ;
   nhdu = znum / 36 ;
   if (nhdu * 36 != znum) nhdu++ ;
   for (iy = 0 ; iy < nhdu*36 ; iy++)
      for (ix = 0 ; ix < 80 ; ix++)
         {
         if (fitbuf [iy][ix] == '\0')  fitbuf [iy][ix] = ' ' ;
         ival = (int) fitbuf [iy][ix] ;
         fitbuf [iy][ix] = (char) toupper (ival) ;
         }

   if (pmode)
      fprintf (stdout, "dpmext> znum: %d  nhdu: %d\n", znum, nhdu) ;

   if (pmode)
      for (i = 0 ; i < nhdu*36 ; i++)
         {
         strncpy (outbuf, &fitbuf [i][0], 80) ;
         outbuf [80] = '\0' ;
	 fprintf (stdout, "dpmext> outbuf:\n") ;
         fprintf (stdout, "%s\n", outbuf) ;
         }

   /*** Write PRIMARY FITS header to disk file. ***/

   nelwr = fwrite (fitbuf, sizeof (char), nhdu*2880, FF) ;

   if (pmode)
      fprintf (stdout, "dpmext> fitbuf nelwr: %d\n", nelwr) ;

   /*** Write pixel data. ***/

   /*** Copy only the non-zero portion of the DPM header. ***/
   /*** In other words, eliminate the 2948 fill bytes. ***/

   bcopy (&DPMHS, dpmhdr, 120) ;

   ibuf = (int   *) dpmhdr ;
   fbuf = (float *) (dpmhdr + 88) ;

   if (pmode)
      {
      fprintf (stdout, "dpmhdr:\n") ;
      for (ix = 0; ix < 22; ix++)
         fprintf (stdout, "%d\n", *(ibuf + ix)) ;
      for (ix = 0; ix <  8; ix++)
         fprintf (stdout, "%f\n", *(fbuf + ix)) ;
      }

/*
   fprintf (stdout, "dpmext> sizeof (DPMHS): %d\n", sizeof (DPMHS)) ;

   nelwr = fwrite (&DPMHS, sizeof (DPMHS), 1, FF) ;
   fprintf (stdout, "dpmext> DPMHS  nelwr: %d\n", nelwr) ;
 */

   nelwr = fwrite (dpmhdr, 1, nbyhdr, FF) ;

   if (pmode)
      fprintf (stdout, "dpmext> dpmhdr nelwr: %d\n", nelwr) ;

   /*** If buffer size is not an integer multiple of 2880 bytes,
    *** pad FITS file with zeroes.
    ***/

   nrec = nbyhdr / nbyfits ;
   if ((nrec * nbyfits) < nbyhdr)
      {
      nrec++ ;
      nfill = (nrec * nbyfits) - nbyhdr ;
      fillbuf = (unsigned char *) malloc ((size_t) nfill) ;
      qq=fillbuf ;
      for (i = 0 ; i < nfill ; i++)  *qq++ = '\0' ;
      nelwr = fwrite (fillbuf, 1, nfill, FF) ;

      if (pmode)
         fprintf (stdout, "dpmext> fillbuf nelwr: %d\n", nelwr) ;
      free (fillbuf) ;
      }

   if (pmode)
      fprintf (stdout, "nrec:%4d  nfill:%6d  nbyhdr:%6d\n",
	       nrec, nfill, nbyhdr) ;
   return (0) ;
}
