/* begend.c
 * -----------------------------------------------------------------------------
 * Find start/stop times for Mk4 images in MLSO observer log file.
 * -----------------------------------------------------------------------------
 * Andrew L. Stanger   HAO/NCAR   22 Jan 2003
 * -----------------------------------------------------------------------------
 */

#include <stdio.h>

main (argc, argv)

int argc ;
char *argv [] ;

{
    static char filename [80] ;
    int i ;
    int hour ;
    int minute ;
    int prevhour ;
    int prevminute ;
    int year ;
    int doy ;
    int beghour, begminute ;
    int endhour, endminute ;
    FILE *FD ;

    if (argc < 2)
	{
	fprintf (stderr, "usage: %s file_name\n", argv [0]) ;
	exit (0) ;
	}
    else
	{
	strcpy (filename, argv [1]) ;
	}

   if ((FD = fopen (filename, "r")) == NULL)
       {
       fprintf (stderr, "Unable to open file: %s\n", filename) ;
       exit (-1) ;
       }

    /*** Note: 10 hours UT = midnight Hawaii Standard Time. ***/

    /*** Look for a time entry with hour > 10, and prevous hour < 10. ***/

    prevhour   = 25 ;
    prevminute = 61 ;
    i = -1 ;
    while (fscanf (FD, "%d_%d", &hour, &minute) != EOF)
	{
	i++ ;
	if (hour > 10 && prevhour < 10)
	    {
	    beghour   = hour ;
	    begminute = minute ;
	    endhour   = prevhour ;
	    endminute = prevminute ;
	    break ;
	    }
	prevhour   = hour ;
	prevminute = minute ;

	if (i == 0)
	   {
	   beghour   = hour ;
	   begminute = minute ;
	   }

	endhour   = hour ;
	endminute = minute ;
	}

    fclose (FD) ;

/*
 *    fprintf (stdout, "begin time : %02d:%02d\n", beghour, begminute) ;
 *    fprintf (stdout, "end   time : %02d:%02d\n", endhour, endminute) ;
 */

    fprintf (stdout, "%02d:%02d %02d:%02d\n",
	     beghour, begminute, endhour, endminute) ;

    exit (0) ;
}
