/* wlvec.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Write linked vector in current FB using WHIP functions fb_move & fb_line.
 * Assumes fb_open () has been called and a frame buffer is selected.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 *  9 April 1991
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

gl_wlvec (xbuf, ybuf, nbuf, grey)

int *xbuf;
int *ybuf;
int nbuf;
int grey;		/* Color level. */

{
   int i, j;
   int xbeg, ybeg;		/* Pixel location for start of vector. */
   int xend, yend;		/* Pixel location for start of vector. */

   for (i = 0; i < nbuf; i++)
      {
      xbeg = *(xbuf + i);
      ybeg = *(ybuf + i);
      if ((i+1) < nbuf)
         j = i + 1;
      else
         j = 0;
      xend = *(xbuf + j);
      yend = *(ybuf + j);
/*
 *      printf ("---xbeg: %3d   ybeg: %3d   xend: %3d   yend: %d\n",
 *              xbeg, ybeg, xend, yend);
 */
      gl_wvec (xbeg, ybeg, xend, yend, grey);
      }

   return (0);
}
