/* mk3syn_save.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copy synoptic map from GL window to disk file in Sun rasterfile format.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   7 December 1993
 * 29 Dec 1993: output format changed from raw to sun rasterfile.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#define NX 512
#define NY 512

mk3syn_save (namout)

char namout [];			/* Name of output file. */

{
   FILE *FD;

   static unsigned char red [256], green [256], blue [256];
   static unsigned char  cbuf [NY][NX];
   static unsigned short sbuf [NY][NX];

   unsigned short *sptr;
   unsigned short soff = 512;			/* Colormap offset. */

   int ix, iy;
   int npximg;
   int nx = NX, ny = NY;
   int xll, yll, xur, yur;

   xll = yll = 0;
   xur = nx - 1;
   yur = ny - 1;
   npximg = nx * ny;

   sptr = (unsigned short *) sbuf;

   /*** Read image from GL window. ***/

   rectread (xll, yll, xur, yur, sptr);

   /*** Convert image from short integer to unsigned char. ***/

   for (iy = 0; iy < ny; iy++)
      for (ix = 0; ix < nx; ix++)
         cbuf [iy][ix] = (unsigned char) ((sbuf [ny-iy-1][ix] - soff) & 0377);
   
   /*** Read current colormap. ***/

   get_scmap (512, 256, red, green, blue);

   /*** Write image to file in sun rasterfile format. ***/

   bytsrf (namout, cbuf, nx, ny, red, green, blue);

   return (0);
}
