/* mk3syn_save.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copy synoptic map from GL window to disk file.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   7 December 1993
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#define NX 512
#define NY 512

mk3syn_save (namout)

char namout [];			/* Name of output file. */

{
   FILE *FD;

   unsigned char  cbuf [NY][NX];
   unsigned short sbuf [NY][NX];
   unsigned short *sptr;
   unsigned short soff = 512;			/* Colormap offset. */

   int ix, iy;
   int npximg;
   int nx = NX, ny = NY;
   int xll, yll, xur, yur;

   xll = yll = 0;
   xur = nx - 1;
   yur = ny - 1;
   npximg = nx * ny;

   sptr = (unsigned short *) sbuf;

   rectread (xll, yll, xur, yur, sptr);

   for (iy = 0; iy < ny; iy++)
      for (ix = 0; ix < nx; ix++)
         cbuf [iy][ix] = (unsigned char) ((sbuf [ny-iy-1][ix] - soff) & 0377);
   
   if ((FD = fopen (namout, "w")) == NULL)
      {
      fprintf (stderr, "Unable to open output file: %s\n", namout);
      return (-1);
      }
   fwrite (cbuf, sizeof (char), npximg, FD);
   fclose (FD);

   return (0);
}
