/* to_byte.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Convert a file containing 16 bit data to an 8 bit data file
 * High order bits are lost.
 * Use 'right' before 'to_byte' to get proper significance
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Author: Alice Lecinski   HAO/NCAR
 * 7 May 2001 [ALS]: cosmetic changes only.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include <errno.h>
#include "dim.h"

char outbuf [NCOL];

main (argc, argv)

char		**argv;
int		argc;
{
    int		i, j, code, read (), write ();
    register	unsigned short	*fp;
    register	char		*op;

    for ( i=0; i<NROW ; i++ )
	{
	if ( ( code = read ( 0, fsbuf, RECORD ) ) != RECORD )
	    {
	    if ( code == -1 )
		{
		fprintf ( stderr, " read error %d\n", code );
		exit ( 1 );
		}
	    else 
		exit ( 1 );
	    }

	fp = fsbuf;
	op = outbuf;
	for ( j=0 ; j<NCOL ; j++ )
	    {
	    *op++ = *fp++;
	    }
	if ( ( code = write ( 1, outbuf, RECORD/2 ) ) != RECORD/2 )
	    {
	    fprintf ( stderr, " write error %d\n", code );
	    exit ( 1 );
	    }
	}
}


