#define EPOCH        (2000)
#define JD_EPOCH    (2451545L)
#define sin_I    ((double)0.126198969)
#define cos_I    ((double)0.992004950)
#define J1854    (2398220L)

#define TICKS_PER_SECOND    1L
#define ONE_DAY             (86400L * TICKS_PER_SECOND)

#define TWOPI               ((double)(3.14159265358979*2.))

#define frem(a,b)           (fmod(a,b))
#define slope(x, y)         (frem(((x)-(y)),TWOPI))

#ifdef START

    double to_sidereal = 0.00273790934 * 2. * 3.14159265358979 ;
    double s2a =  7.272205216643e-5;

    int Eph_year, Eph_month, Eph_day, Eph_hour, Eph_minute, Eph_second;         

    double ephRA, ephDEC, ephSRadius, ephPangle, ephBangle, ephLangle ;
    double ephST, ephHA,  ephAz,      ephElev,   ephAmass;
    double siteLongitude=155.575833, siteLatitude=19.536389;
    double cos_Lat;
    double sin_Lat;
#else
    extern double to_sidereal ;
    extern double s2a ;

    extern int Eph_year, Eph_month, Eph_day, Eph_hour, Eph_minute, Eph_second;         
    extern double ephRA, ephDEC, ephSRadius, ephPangle, ephBangle, ephLangle ;
    extern double ephST, ephHA,  ephAz,      ephElev,   ephAmass;
    extern double siteLongitude, siteLatitude;
    extern double cos_Lat;
    extern double sin_Lat;
#endif
