#include <math.h>


fexpcon(a,dxa,dya,b,dxb,dyb,fx,fy,oax,oay,obx,oby)
float *a,*b;
int dxa,dya,dxb,dyb;   /* Image sizes */
float fx,fy;           /* Expansion factors */
float oax,oay,obx,oby; /* Centers of images. */
{
	int bi,bj,Ai,Aj;
	register float *rb,*aj0,*aj1;
	float ai,aj,fdxa,fdya,factorx,factory,P1,P2,P3,P4,P5,P6,P7;
	float ovfx,ovfy;

	fdxa = (float)dxa; 
	fdya = (float)dya;
	if( fx<0.0 ) fx = (float)dxb/fdxa;
	if( fy<0.0 ) fy = (float)dyb/fdya;

	ovfx=1.0/fx; ovfy=1./fy;

	rb=b;
	factorx = oax - obx*ovfx;  factory = oay - oby*ovfy;
	for( bj=0; bj<dyb; bj++ ){
		aj = (float)bj*ovfy + factory;
		if( aj<0.0 ) aj = 0.0;
		else if( aj>(fdya-1.0) ) aj = (fdya-1.0);
		Aj = (int)aj;
		aj0 = a + dxa * Aj;
		aj1 = aj0 + dxa;
		for( bi=0; bi<dxb; bi++ ){
			ai = (float)bi*ovfx + factorx;
			if( ai<0.0 ) ai = 0.0;
			else if( ai>(fdxa-1.0) ) ai = (fdxa-1.0);
			Ai = (int)ai;
			P1 = (float)(*(aj0+Ai));
			P2 = (float)(*(aj0+Ai+1));
			P3 = (float)(*(aj1+Ai));
			P4 = (float)(*(aj1+Ai+1));
			P5 = (ai-(float)Ai) * (P2-P1) + P1;
			P6 = (ai-(float)Ai) * (P4-P3) + P3;
			P7 = (aj-(float)Aj) * (P6-P5) + P5;
			*rb++ = P7;
		} /* end-for bi=0 to dxb */
	} /* end-for bj=0 to dyb */
	return(0);
}

/* This quick and dirty one must have the centers in the center,
   and one must be an exact multiple of the other.
*/

fexpconFAST(a,dxa,dya,b,dxb,dyb,fx,fy)
float *a,*b;
int dxa,dya,dxb,dyb;
float fx,fy;
{
	int bi,bj,Ai,Aj;
	register float *rb,*aj0,*aj1;
	float ai,aj,fdxa,fdya,factorx,factory,P1,P2,P3,P4,P5,P6,P7;
	float ovfx,ovfy;

	fdxa = (float)dxa; fdya = (float)dya;
	if( fx<0.0 ) fx = (float)dxb/fdxa;
	if( fy<0.0 ) fy = (float)dyb/fdya;

	ovfx=1.0/fx; ovfy=1./fy;

	rb=b;
	for( bj=0; bj<dyb-(int)fy; bj++ ){
		aj = (float)bj*ovfy;
		Aj = (int)aj;
		aj0 = a + dxa * Aj;
		aj1 = aj0 + dxa;
		for( bi=0; bi<dxb-(int)fx; bi++ ){
			ai = (float)bi*ovfx;
			Ai = (int)ai;
			P1 = (float)(*(aj0+Ai));
			P2 = (float)(*(aj0+Ai+1));
			P3 = (float)(*(aj1+Ai));
			P4 = (float)(*(aj1+Ai+1));
			P5 = (ai-(float)Ai) * (P2-P1) + P1;
			P6 = (ai-(float)Ai) * (P4-P3) + P3;
			P7 = (aj-(float)Aj) * (P6-P5) + P5;
			*rb++ = P7 ;
		} /* end-for bi=0 to dxb-fx */
		aj0=rb-1;
		for( bi=dxb-(int)fx; bi<dxb; bi++ )  *rb++ = *aj0;
	} /* end-for bj=0 to dyb-fy */

	aj1=rb-dxb;
	for( bj=dyb-(int)fy; bj<dyb; bj++ ){
		aj0=aj1;
		for( bi=0; bi<dxb; bi++ ){ *rb++ = *aj0++; }
	}

	return(0);
}
fexpconVec(a,dxa,b,dxb,fx,oax,obx)
    float *a,*b;
    int dxa,dxb;   /* Vector sizes */
    float fx;      /* Expansion factor */
    float oax,obx; /* Centers of vectors. */
{
    int bi,Ai;
    register float *rb;
    float ai,aj,fdxa,factorx,P1,P2,P5;
    float ovfx;

    fdxa = (float)dxa;
    if( fx<0.0 ) fx = (float)dxb/fdxa;

    ovfx=1.0/fx;


    rb=b;
    factorx = oax - obx*ovfx;
    for( bi=0; bi<dxb; bi++ ){
	ai = (float)bi*ovfx + factorx;
	if     ( ai<0.0 )        ai = 0.0;
	else if( ai>(fdxa-1.0) ) ai = (fdxa-1.0);
	Ai = (int)ai;
	P1 = (float)(*(a+Ai));
	P2 = (float)(*(a+Ai+1));
	P5 = (ai-(float)Ai) * (P2-P1) + P1;
	*rb++ = P5;
    }
}
