/* ff.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Test libcfitsio.a
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   23 October 2001
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
/* #include "/opt/share/PUBLIC/include/fitsio.h" */
#include "fitsio.h"

main (argc, argv)

int argc ;
char *argv [] ;

{
    static char filename [80] = "20000331.180645.mk4.cpb.fts" ;
/*
    static char filename [80] =
	"/riker/d/img/mk4/00d091/20000331.180645.mk4.cpb.fts" ;
 */ 
    static char cnaxis1 [80] ;
    static char cnaxis2 [80] ;
    static char comment [80] ;
    static char chd [1024] ;

    short *simg ;

    int hdunum ;
    int hdutype ;
    int status ;
    int xdim, ydim ;
    int bitpix ;

    fitsfile *fp ;

    if (argc == 2)
	{
	sscanf (argv [1], "%s", filename);
	}

    status = 0 ;

    /*** Open input FITS file. ***/

    if ( fits_open_file (&fp, filename, READONLY, &status) )
	printerror ( status );
    printf ("fits_open_file [%s]   status: %d\n", filename, status) ;

    if (fits_get_num_hdus (fp, &hdunum, &status)) printerror (status) ;
	printf ("#hdus: %d\n", hdunum) ;

    if (fits_get_hdu_num (fp, &hdunum))   printerror (status) ;

    if (fits_get_hdu_type (fp, &hdutype, &status)) printerror (status) ;

    printf ("hdunum: %d  hdutype: %d\n", hdunum, hdutype) ;

    /*** Read keyword parameters in primary HDU. ***/

    if (fits_read_key (fp, TINT, "NAXIS1", &xdim, cnaxis1, &status))
	printerror (status) ;

    if (fits_read_key (fp, TINT, "NAXIS2", &ydim, cnaxis2, &status))
	printerror (status) ;

    if (fits_read_key (fp, TINT, "BITPIX", &bitpix, comment, &status))
	printerror (status) ;

    fprintf (stdout, "[1] xdim/ydim/bitpix: %d %d %d\n", xdim, ydim, bitpix) ;

    /*** Move to FITS extension HDU. ***/

    hdunum = 2 ;
    if (fits_movabs_hdu (fp, hdunum, &hdutype, &status))
	printerror (status) ;

    printf ("fits_movabs_hdu [2] . . . status: %d\n", status) ;

    if (fits_get_hdu_num  (fp, &hdunum))  printerror (status) ;

    if (fits_get_hdu_type (fp, &hdutype, &status)) printerror (status) ;

    printf ("hdunum: %d  hdutype: %d\n", hdunum, hdutype) ;

    if (fits_read_key (fp, TINT, "NAXIS1", &xdim, cnaxis1, &status))
	printerror (status) ;

    if (fits_read_key (fp, TINT, "BITPIX", &bitpix, comment, &status))
	printerror (status) ;

    fprintf (stdout, "[2] xdim/bitpix: %d %d\n", xdim, bitpix) ;

    if (fits_close_file (fp, &status))  printerror (status) ;

    exit (0) ;
}
