#include <stdio.h>
#include <math.h>

#define  NTERMS  (6)
/*
#define  VLEN    ( 41)
*/
#define  VLEN    (100)


int
gaussfit( X, Y , Yfit , A ,  npts ) 
    float *X, *Y, *Yfit;
    float *A;
    int npts;
{
    int ii;
    int nt = NTERMS;
    float  ycept,slope,R;
    float  *pf, *pA, *px , *py , *pyd, yd[VLEN];
    float  xmax, xmin, ymax, ymin;
    float  xval,yval,ydif,yfit;
    double dy,del;
    double dtmp1,dtmp2;
    int    i0,imax,imin;

    do_lst ( &ycept,&slope,&R,X,Y,npts,1);
    pyd=yd;
    py =Y;
    px =X;
    pf =Yfit;
    imin= imax= xmin= xmax= -1.;
    ymax= -15000.;
    ymin=  15000.;
    for(ii=0;ii<npts;ii++){ 
	xval = *px;
	yval = *py;
	yfit = (xval*slope+ycept); 
	ydif = yval-yfit;
	*pf  = yfit;
	*pyd = ydif;
	if ( ydif > ymax ) { ymax = ydif ; xmax = xval ; imax = ii; }
	if ( ydif < ymin ) { ymin = ydif ; xmin = xval ; imin = ii; }

	/*
	fprintf(stderr,"\t\t\tii %d ydif %.2e ymax %.2e ymin %.2e \n",
	    ii,ydif,ymax,ymin);
	*/

	pf++;
	pyd++; 
	py++; 
	px++;
    }
    i0=imax;
    dtmp1 = (double)ymax;
    dtmp2 = (double)ymin;
    dtmp1 = fabs(dtmp1) ;
    dtmp2 = fabs(dtmp2) ;
    if ( dtmp1 > dtmp2 ) i0=imax;
    else                 i0=imin;
    /*
    fprintf(stderr,"i0 is %d \n",i0);
    */

    /*  Should not be at an edge */
    if ( (i0 <= 1) || (i0 >= npts-2))
	fprintf(stderr,"Yipes, gaussfit got an edge!\n");

    dy  = (double)(yd[i0]);
    del = dy / exp (1.);

    ii=0;
    dtmp1=(double)(yd[i0+ii]);
    dtmp2=(double)(yd[i0-ii]);
    while ((( (i0+ii+1) < npts ) && ((i0-ii) > 0) )
	       && 
	   ((fabs(dtmp1) > fabs(del)) && (fabs(dtmp2) > fabs(del))  ) ) {
	ii+=1;
	dtmp1=(double)(yd[i0+ii]);
	dtmp2=(double)(yd[i0-ii]);
    }

    pA=A;
    *pA     = yd[i0];
    *(pA+1) =  X[i0];
			    dtmp1=(double)(X[i0]-X[i0+ii]);
    *(pA+2) =  (float)fabs(dtmp1);
    *(pA+3) =  ycept;
    *(pA+4) =  slope;
    *(pA+5) =  0.;

    /*
    fprintf(stderr,"HI   %f %d \n",*(A+1),npts);
    */
    ii=curvefit(X , Y , Yfit,  A ,  npts);

    if(ii<0) fprintf(stderr,"curvefit gave lousy results\n");
}

int gauss_func ( X,A,F,partialD,npts )
    float *X,*A,*F,*partialD;
    int npts;
{
    int ii;

    float *px , *pF,  *pd;
    double z , ez, fred;
    double myX, Magni, Meani, Sigi, Consti, Lini, Quadi ;
    double dtmp;

    Magni  = *(A+0);
    Meani  = *(A+1);
    Sigi   = *(A+2);
    Consti = *(A+3);
    Lini   = *(A+4);
    Quadi  = *(A+5);
    /*
    fprintf(stderr,"%.2f %.2f %.2f %.2f %.2f %.2f \n",
	Magni,Meani,Sigi,Consti,Lini,Quadi);
    */

    px  = X;
    pF  = F;
    pd  = partialD;
    for(ii=0;ii<npts;ii++){
	myX = (double)(*px);
	if(Sigi != 0.) {
	    z    = (myX - Meani) / Sigi ;
	    dtmp = -0.5 * z * z ;
	    ez   = exp ( dtmp ) ;
	    fred = Magni * ez * z / Sigi ;
	}
	else {
	    z    = 100.;
	    ez   =   0.;
	    fred =   0.;
	    fprintf(stderr,"gauss_func zeros!\n");
	}

	*pF = (float)(
	      Magni   * ez 
	      +  Consti
	      +  Lini   * myX
	      +  Quadi  * myX * myX );

	/* Compute the partial derrivatives. */
	*pd = (float)(ez      );      pd++;
	*pd = (float)(fred    );      pd++;
	*pd = (float)(fred * z);      pd++;
	*pd = 1.;                     pd++;
	*pd = (float)(myX);           pd++;
	*pd = (float)(myX * myX);     pd++;

	px++;
	pF++;
    }
}

int
curvefit(X,Y,Yfit,A,npts)
       float *X,*Y,*Yfit,*A;
       int npts;
{
    int ii,iter,term;
    int itmax,nterms,nfree,done_early;
    int lambdaCount;
    float tol,flambda, augment;
    float ovnfree;
    float ftemp;
    float *pf , *pV , *pY , *pYfit;
    float YfitSave[VLEN], Ydiff[VLEN] ;
    float pder[NTERMS*VLEN],    tpder[VLEN*NTERMS];
    float beta [NTERMS] ,        alpha[NTERMS*NTERMS] , C[NTERMS*NTERMS];
    float array[NTERMS*NTERMS] , invarray[NTERMS*NTERMS] ;
    float Sigma[NTERMS] ,        SigmaSave[NTERMS];
    float Vtmp1[NTERMS] ,        Vtmp2[NTERMS];
    float B[NTERMS] ;
    float chisq , chisqSave;
    float sum;

    /*
    fprintf(stderr,"HI   %f %d \n",*(A+1),npts);
    */


    tol    = 0.001;
    itmax  = 20;
    itmax  = 40;
    nterms = NTERMS;
    nfree   = npts - nterms;
    ovnfree = 1./(float)nfree;
    flambda = 0.001;

    done_early=0;

    pf=array; for(ii=0;ii<nterms*nterms;ii++) { *pf = 1.; pf++; }

    for(iter=0;iter<itmax;iter++){
	gauss_func(X,A,Yfit,pder,npts);
	/*
	fprintf(stderr,"Iteration %d Inflection %.2f\n",iter,*(A+1));
	*/
	VVminus(Y,Yfit,Ydiff,npts);

	MMmult (Ydiff,npts,1,pder,nterms,npts,beta,nterms,1);
	transpose(pder,tpder,nterms,npts);
	MMmult (tpder,npts,nterms,pder,nterms,npts,alpha,nterms,nterms);

	GetSigma(Sigma,array,alpha,nterms);
	pf=Sigma; pV=SigmaSave; for(ii=0;ii<nterms;ii++){ *pV++ = *pf++; }

	GetChiSq(&chisq,Ydiff,npts,ovnfree);
	chisqSave = chisq;

	pf=Yfit ; pV=YfitSave;  for(ii=0;ii<npts;  ii++){ *pV++ = *pf++; }

	AbsTotal(Y,npts,&sum);
	sum *= (1.e-7 * ovnfree) ; 

	if(chisqSave < sum ) {
	    fprintf(stderr,"done_early %f %f\n",chisqSave , sum );
	    done_early = 1 ;
	    iter--;
	    goto Done;
	}

	GetC(Vtmp1,Vtmp2,C,alpha,nterms);

	lambdaCount = 0;
	chisq++; /* Up chisq so the loop below iterates at least once.*/
	while(chisq > chisqSave) {
	    lambdaCount++;
	    VVdivide(alpha,C,array,nterms*nterms);   
	    augment=flambda+1.0; AugmentDiag(array,augment,nterms);
	    InvMatrix(array,invarray,nterms,nterms);

	    VVcopy  (invarray,array,nterms*nterms);
	    VVdivide(array,C,invarray,nterms*nterms);
	    MMmult(invarray,nterms,nterms,beta,1,nterms,Vtmp1,1,nterms);
	    VVplus(A,Vtmp1,B,nterms);
	    gauss_func(X,B,Yfit,pder,npts);

	    VVminus(Y,Yfit,Ydiff,npts);

	    GetSigma(Sigma,array,alpha,nterms);
	    GetChiSq(&chisq,Ydiff,npts,ovnfree);
	    /*
	    fprintf(stderr,"Inside chisq %.1f %.1f\n",chisq,chisqSave);
	    */

	    if((chisq >= chisqSave) && (lambdaCount > 30)) {

		chisq = chisqSave;
		pV=Sigma; pf=SigmaSave; 
		    for(ii=0;ii<nterms;ii++){ *pV++ = *pf++; }
		pV=Yfit ; pf=YfitSave;  
		    for(ii=0;ii<npts;  ii++){ *pV++ = *pf++; }
		fprintf(stderr,"Failed to converge\n");
		goto Done;
		
	    }
	    flambda *= 10.;
	}
	flambda *= 0.01;
	pV=A; pf=B; for(ii=0;ii<nterms;ii++){ *pV++ = *pf++; }

	/*
	fprintf(stderr,"chisq %.0f %.0f\n",chisq,chisqSave);
	*/
	if( ((chisqSave-chisq)/chisqSave) <= tol ) goto Done;

    }
    fprintf(stderr,"Failed to converge\n");
    return(-1);
Done:
    fprintf(stderr,"\t\t    Converged with %.2f\n",*(A+1));

    return(0);
}



int GetSigma(Sigma,array,alpha,nterms)
    float *Sigma, *array, *alpha;
    int nterms;
{
    int ii;
    float *pV;
    double dtmp1, dtmp2;

    pV = Sigma;
    for(ii=0;ii<nterms;ii++){
	dtmp1 = (double)(*(array + ii + ii * nterms));
	dtmp2 = (double)(*(alpha + ii + ii * nterms));
	dtmp1 = dtmp1/dtmp2;
	*pV   = (float)(sqrt(dtmp1));
	pV++;
    }
}
int GetChiSq(chisq,ydiff,npts,ovnfree)
    float *chisq,*ydiff;
    int   npts;
    float ovnfree;
{
    int ii;
    float *pV, sum, fval;

    sum=0.;
    pV   =ydiff;
    for(ii=0;ii<npts;ii++){
	fval = *pV ;
	sum += fval*fval;
	pV++;
    }
    sum    = sum * ovnfree ;
    *chisq = sum;
}

int
GetC(C1,C2,C,alpha,nterms)
    float *C1 , *C2, *C;
    int nterms;
{
    int ii;
    float *pf, *pV;

    GetDiagV(C1,alpha,nterms);
    pf=C1; pV=C2; for(ii=0;ii<nterms;ii++){ *pV++ = *pf++; }
    MMmult (C1,1,nterms,C2,nterms,1,C,nterms,nterms);

}
