/*

    This code creates the mk4 X matrix from iqu darks, cal0's and cal15's.

    It is based on David Elmore's xmk4.pro code of June 2001.

    In this version, X21 and X31 are two-dimensional.

    This code was written by Alice Lecinski, June 2001.

    I strongly suggest *not* editting this code at all, unless
    you are absolutely sure you've found an error that
    needs fixing.

    If you edit it, you risk destroying the integrity of the
    code.  So if you do edit it, insure results pre and post
    actually match.

*/
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <math.h>

#define START

#include "mk4v2.h"
#include "mk4headv2.h"
#include "telscp4v2.h"

char *filenm;


short MyIm[CY_IMG];
short MyBA[VECTOR];
float fba[VECTOR];
float          I0im [CY_IMG], Q0im [CY_IMG], U0im [CY_IMG], 
               I15im[CY_IMG], Q15im[CY_IMG], U15im[CY_IMG], 
               ICim [CY_IMG], QCim [CY_IMG], UCim [CY_IMG];

float XimA[CY_IMG];
float XimB[CY_IMG];
float XimC[CY_IMG];
float Xspace[VECTOR];
float Avg [VECTOR];
float StdD[VECTOR];

float  tmpV[VECTOR];
float  costh[VECTOR*2], sinth[VECTOR*2];



main (an, av) char *av[]; {
    register char *w;
    register FH  hdb , hdi , hdq , hdu ;
    struct mk4_header *hd;
    long begtime, endtime;
    int ii, dd;
    int hdsz;
    int got0,got15,gotC;
    int dotest;
    int doInverse;
    int FixBA;
    float  hairLo,hairHi;
    float *ba , *cyi, *cyq, *cyu;
    float *pf;
    double myang,dtmp;
    double pslp,pycpt,p2,p3;
    double shift_angle;

    char *ctime_r(), buf[30];
    struct tm *T, *localtime();
    char *ctime();

    dotest=0;
    doInverse = 0;

    got0=got15=gotC=0;
    hdsz = sizeof(mk4head);
    hdb  = (FH) malloc (hdsz);
    timeflag=1;




    (void) time(&begtime);
    T = (struct tm *)malloc(sizeof(struct tm));
    T = localtime(&begtime);
    T->tm_mon += 1 ;
    thd->tdysdate = jday(T->tm_mon,T->tm_mday,T->tm_year+1900) - JULD_REF;

    (void) ctime_r(&begtime,&buf,30);
    fprintf(stderr,"Started getcal4:      %s\n",buf);

    iniSolution(thd);    

    pf=costh;
    for(ii=0;ii<NAZ*2;ii++){ 
        myang  = (double)ii*AngSep*d2r ;
        myang *= 2.; 
        dtmp   = cos(myang);
        *pf    = (float)dtmp;
        pf++;
    }
    pf=sinth;
    for(ii=0;ii<NAZ*2;ii++){ 
        myang  = (double)ii*AngSep*d2r ;
        myang *= 2.; 
        dtmp   = sin(myang);
        *pf    = (float)dtmp;
        pf++;
    }

    
    if ( an <  3 ) { prsum() ; exit(3) ; }

    while (--an) {  
        w = *++av ;
        if (*w == '?') { prsum(); exit(2); }
        if (*w == '-') {
            switch (w[1]) {
		case 'I': fprintf(stderr,"Produce an inverse tscp file.\n");
			  doInverse=1;
			  break;
                default:
                          fprintf (stderr," unknown flag %s\n",*av);
                          prsum(); exit(1);
            }
            continue;
        }

        filenm = w;
        /* Check on the file naming convention used on the .q file */
        if ((*w=='0') || (*w >= '8' && *w <= '9') || *(w+2)=='d' ) {
            if ( *(w+3) >='0' && *(w+3) <='9' )  doyflag++ ;
            else                                 nameflag++ ;
        }
        if (nameflag || doyflag) { dayflag++ ; timeflag=1; }
 
        (void) time(&begtime);
        readmk4head(filenm,mk4h,1);
        switch ( mk4h->ObsType ) {
            case IS_cal0  : cyi=I0im;  cyq=Q0im;  cyu=U0im;  ba=fba;
                            hdi = &(thd->hd0i);
                            hdq = &(thd->hd0q);
                            hdu = &(thd->hd0u);
                            got0 =1;
                            fprintf(stderr,"\t    IS_cal0\n");
                            break;
            case IS_cal15 : cyi=I15im; cyq=Q15im; cyu=U15im; ba=fba;
                            hdi = &(thd->hd15i);
                            hdq = &(thd->hd15q);
                            hdu = &(thd->hd15u);
                            fprintf(stderr,"\t    IS_cal15\n");
                            got15=1;
                            break;
            case IS_coronal : cyi=ICim;  cyq=QCim;  cyu=UCim;  ba=fba; 
                            hdi = &(thd->hdCi);
                            hdq = &(thd->hdCq);
                            hdu = &(thd->hdCu);
                            fprintf(stderr,"\t    IS_coronal\n");
                            gotC =1;
                            break;
            default:        fprintf(stderr,
                            "Image %s inappropriate for this code,\n\
                            exitting\n",filenm); exit(-5);
        }


        /* Get the i q u data. */
        dopicnm (mk4h); 
        dofnm (IS_i,mk4h->ProcSteps); readmk4(picnm,hdi,MyIm,0);
                                      Short2Float(MyIm,cyi,hdi->Xdim,hdi->Ydim);
        dofnm (IS_q,mk4h->ProcSteps); readmk4(picnm,hdq,MyIm,0);
                                      Short2Float(MyIm,cyq,hdq->Xdim,hdq->Ydim);
        dofnm (IS_u,mk4h->ProcSteps); readmk4(picnm,hdu,MyIm,0);
                                      Short2Float(MyIm,cyu,hdu->Xdim,hdu->Ydim);
        dofnm (IS_ba,IS_raw);         readmk4(picnm,hdb,MyBA,0);
                                      Short2Float(MyBA,ba,hdb->Xdim,hdb->Ydim);


        /* fixmk4  --  does fixes for:
		negative Q and U, (occured in old camera only, pre 1may01)
		digital wraps,
                non-linear gain   (old camera only)
		bias              (from the bottom NN pixels)
		any negative intensity data
		sky transmission
	*/
	dotest=0;
	if(dotest==0){
	    fprintf(stderr,"\t    Doing \"fixmk4\".\n");
	    fixmk4(cyi,hdi,cyq,hdq,cyu,hdu,ba,hdb,0);
	}
        dotest=0;

        /* Spline it, save it as a theta by R array. */
        if(dotest==0){
            fprintf(stderr,"\t    Doing \"fcyspline\".\n");
            FixBA=1;
            fcyspline(mk4h,cyi,ba,FixBA);  FixBA=0;
            fcyspline(mk4h,cyq,ba,FixBA);
            fcyspline(mk4h,cyu,ba,FixBA);
        }


        if (mk4h->ObsType == IS_cal15 ) {
	    /* TiltPhi200 and TiltPhi300 are not used
	       for anything, except information in the header.
	    */
            dotest=0;
            if(dotest==0){
                fprintf(stderr,"\t\tGetting TILT phase\n");
                dd=200; ckphase(dd,Q15im+dd*NAZ,&p2);
                dd=300; ckphase(dd,Q15im+dd*NAZ,&p3);
                pslp=(p3-p2)/(300.-200.);
                pycpt=p3-pslp*300.;
                fprintf(stderr,"\t\t    pslp %.4f pycpt %.2f\n",
                    pslp*r2d,pycpt*r2d);
                thd->TiltPhi200 = (float)(p2 * r2d);
                thd->TiltPhi300 = (float)(p3 * r2d);
            }
            else{
                pslp =  0.;
                pycpt=  0.;  /* 11.8 */
            }
            dotest=0;
        }

        /* Shift the arrays to the proper reference frame. */
        dotest=0;
        if(dotest==0){
        /*  David has 180. -(30. +0.5) for + direction scan
                      180. -(30. -0.5) for - direction scan */
            shift_angle = (double)(hdq->Phase     
                                 + hdq->backlash 
				 );
            fshiftimg(cyi,shift_angle);
            fshiftimg(cyq,shift_angle);
            fshiftimg(cyu,shift_angle);
        }
        else {
            shift_angle = 0.;
        }
        dotest=0;


    }
    if ( (got0!=1) || (got15!=1) || (gotC!=1)) {
        fprintf(stderr,"One of the calibration files is missing\n");
        if(got0 !=1) fprintf(stderr,"The cal0     file is missing.\n");
        if(got15!=1) fprintf(stderr,"The cal15    file is missing.\n");
        if(gotC !=1) fprintf(stderr,"The coronal  file is missing.\n");
        exit(-10);
    }


    /* Get and save the hair line positions. */

    getHair(I0im,NAZ,&hairLo,&hairHi);
    hd = &(thd->hd0i);
    for(ii=0;ii<9;ii++){
	hd->orig_hairspot[0] = hairLo;
	hd->orig_hairspot[1] = hairHi;
	hd++;
    }

    fprintf(stderr,"\n\tComputing Gain and X matrix\n");

    if(dotest==0){
	/* Get the Gain and X matrix ... */
	doanalytical(I0im ,  Q0im,  U0im,
                     I15im, Q15im, U15im,
                     ICim ,  QCim,  UCim,   thd);
    }


    /* Write out the tscp file. */
    dopicnm (&(thd->hd0i)); 
    dofnm(IS_tscp,IS_cal);
    writetscp(picnm,thd,1);

    if(doInverse==1) {
	/* Compute the inverse X matrix and inverse Gain.
	*/
	ComputeInverse(thd);

	/* Save this to a file.
	*/
	dopicnm (&(thd->hd0i)); 
	dofnm(IS_tscp_inv,IS_cal);
	writetscp(picnm,thd,1);
    }

    (void) time(&endtime);
    fprintf(stderr,"\nTime used:    %ld seconds\n",endtime-begtime);

    exit (0);
}

prsum() {
    static char help[] = "\
getcal4 qcal0 qcal15 qcorona\n\
\n\
getcal4v2 17_30.q 17_36.q 17_33.q \n\
\n\
This program gets the X matrix for the mk4 coronameter from the \n\
cal0, cal 15, and coronal images, and uses\n\
this information to create a\n\
   \".4tscp\" \n\
file which can then be used to convert coronal \".i\" \".q\" \".u\"    to \".pB\".\n\
\n\
Flags              Description\n\
-----              -----------\n\
 -I                get the invserse X matrix and inverse Gain too.\n\
";
       fputs (help,stderr);
}

iniSolution(Thd)
    struct telhd *Thd; 
{
    int isz;

    Thd->Bopal = 10.11      ;

    Thd->ang1  = -9999.     ;
    Thd->fp1   =  0.0       ;

    Thd->ang0  = -9999.     ;
    Thd->fp0   =  0.0       ;

    Thd->trt   = 0.84738906 ;
    Thd->fpt   = 0.01641    ; /* New as of 1 Sept 2001.
				 Old value was Thd->fpt = 0.01543
				 The old was computed for just
				 a single ray of light coming down
				 the center line and wavelength of 820nm.
				 The new accounts for all rays
				 and appropriate wavelength of 775nm.
			      */

    Thd->x11   = 1.00000000 ;
    Thd->x12   = 0.0        ;
    Thd->x13   = 0.0        ;

    Vinitialize(Thd->x21,  0.0,NPX);
    Vinitialize(Thd->x22,  0.0,NPX);
    Vinitialize(Thd->x23,  0.0,NPX);

    Vinitialize(Thd->x31,  0.0,NPX);
    Vinitialize(Thd->x32,  0.0,NPX);
    Vinitialize(Thd->x33,  0.0,NPX);

    Vinitialize(Thd->vgain,1.0,NPX);

    isz = NPX*NAZ;
    Vinitialize(Thd->x21a, 0.0,isz);
    Vinitialize(Thd->x31a, 0.0,isz);
    Vinitialize(Thd->Gain, 1.0,isz);

}


int
doanalytical(opalI,opalQ,opalU,
	     tiltI,tiltQ,tiltU,
             cornI,cornQ,cornU,
             Thd) 

float *opalI, *opalQ, *opalU, *tiltI, *tiltQ, *tiltU;
float *cornI, *cornQ, *cornU;
struct telhd *Thd; 
{
    int    ii;
    int    is_x321;
    int    isz;
    float  IPhs;
    float  ovBopal,  ovtrt, ovfpt,  ovVenus;
    float  *px22, *px23, *px33, *px32;
    float  *ovopalI, *ovcornI, *ovtiltI, *pQ, *pU;
    float  qAmpli, uAmpli, Ampli, s2Phi, c2Phi;
    double qPhi,uPhi,Phi, dsin2Phi, dcos2Phi;
    double PhiZero;
    double Two;
    float  mone;
    struct mk4_header *hd;


    mone  = -1.0 ;
    Two   =  2.  ;
    isz   = NAZ*NPX;

    ovfpt   = 1./(Thd->fpt);
    ovtrt   = 1./(Thd->trt);
    ovBopal = 1./(Thd->Bopal);
    ovVenus = 1./(Thd->hd0i.ID.VenusCalFac);

    /* x11, x12 and x13 are set in iniSolution */

    /* Get the Gain image. */
	VVcopy (opalI,    Thd->Gain,isz);
	Vmult  (Thd->Gain,ovBopal,  isz);
	Vmult  (Thd->Gain,ovVenus,  isz);

    /* Get the vector Gain. */
	Im2AvgRadVect ( Thd->Gain, Thd->vgain,  NAZ, NPX);

    /* very tricky -- get x21 and x31 */
    /* First, replace opalI and cornI with their inverse. */

	Vover(opalI,isz);     ovopalI = opalI;
	Vover(cornI,isz);     ovcornI = cornI;


	is_x321 = 21;    x321 (ovopalI,opalQ,opalU,
			       ovcornI,cornQ,cornU,
			       Thd,    is_x321);

	is_x321 = 31;    x321 (ovopalI,opalQ,opalU,
			       ovcornI,cornQ,cornU,
			       Thd,    is_x321);

	Im2AvgRadVect ( Thd->x21a, Thd->x21,  NAZ, NPX);
	Im2AvgRadVect ( Thd->x31a, Thd->x31,  NAZ, NPX);


    /* Now work on the tilt data to find X22,X23  and X32,X33
	;
	; Find amplitude and phase of cal 15
	; at position angle of channel 4
	;
	; Compute X22 and X33
	; Use fractional polarization normalizaton
	;
	; Remove fractional polarization due to opal alone
	; from fractional polarization of cal 15
    */

    /* Make an inverse tiltI image */
	ovtiltI = XimA;
	VVcopy(  tiltI, ovtiltI, isz);
	Vover (ovtiltI,          isz);
       
    /*  fred = cal15_q/cal15_i - cal0_q/cal0_i
	mary = cal15_u/cal15_i - cal0_u/cal0_i
    */
	VVmult (opalQ,ovopalI,  opalQ,isz);
	VVmult (tiltQ,ovtiltI,  tiltQ,isz);
	VVminus(tiltQ,opalQ  ,  tiltQ,isz);

	VVmult (opalU,ovopalI,  opalU,isz);
	VVmult (tiltU,ovtiltI,  tiltU,isz);
	VVminus(tiltU,opalU  ,  tiltU,isz);


    /*  fred = fred*cal15_i/(trt*cal0_i)
	mary = mary*cal15_i/(trt*cal0_i)
    */

	VVmult (tiltQ,  tiltI,    tiltQ,isz);
	VVmult (tiltQ,  ovopalI,  tiltQ,isz);
	Vmult  (tiltQ,  ovtrt,          isz);  

	VVmult (tiltU,  tiltI,    tiltU,isz);
	VVmult (tiltU,  ovopalI,  tiltU,isz);
	Vmult  (tiltU,  ovtrt,          isz);  

    /*  for ii = 0,NUMPIX-1 do begin
	    sprod(ii) = total(sang*fred(*,ii))/numaz
	    cprod(ii) = total(cang*fred(*,ii))/numaz
	endfor
	qphi = atan(sprod,cprod)
	qamp = 2.*sqrt(sprod*sprod+cprod*cprod)
	 
	for ii = 0,NUMPIX-1 do begin
		sprod(ii) = total(sang*mary(*,ii))/numaz
		cprod(ii) = total(cang*mary(*,ii))/numaz
	endfor   
	uphi = atan(sprod,cprod)
	uamp = 2.*sqrt(sprod*sprod+cprod*cprod)

	amp = (qamp+uamp)/2.
	phi = (qphi + (uphi + !pi/2.))/ 2.
	InstrPhs = -0.5*(180.*phi(192)/!pi)
	phi = phi - phi(192)
	sx22 =  amp * cos(2.*phi)/fpt
	sX23 =  -amp * sin(2.*phi)/fpt
	sx32 = amp * sin(2.*phi)/fpt
	sx33 = amp * cos(2.*phi)/fpt
    */
	ii =        Thd->hd0i.ID.PhiPix     ;
	pQ = tiltQ +  ii*NAZ;
	pU = tiltU +  ii*NAZ;
	    getPHInA_new(pQ,&qAmpli,&qPhi);
	    getPHInA_new(pU,&uAmpli,&uPhi);
	    Ampli         = (qAmpli + uAmpli)        *0.5;
	    Phi           = (qPhi   +(uPhi + piov2)) *0.5;
	    PhiZero       = Phi;
	    IPhs          = (float)((-0.5) * r2d*PhiZero);

	    hd = &(Thd->hd0i);
	    for(ii=0;ii<9;ii++){
		hd->InstrPhs = IPhs;
		hd++;
	    }
	    fprintf(stderr,"\t    Instrument Phase (degrees) %.3f\n",IPhs);


	pQ = tiltQ;
	pU = tiltU;
        px22 = Thd->x22;
	px23 = Thd->x23;
	px33 = Thd->x33;
	px32 = Thd->x32;
	for(ii=0;ii<NPX;ii++){
	    getPHInA_new(pQ,&qAmpli,&qPhi);
	    getPHInA_new(pU,&uAmpli,&uPhi);
	    Ampli = (qAmpli + uAmpli)        *0.5;
	    Phi   = (qPhi   +(uPhi + piov2)) *0.5;
	    Phi  -= PhiZero;
	    Phi  *= Two;
	    dsin2Phi = sin(Phi);
	    dcos2Phi = cos(Phi);
	    s2Phi    = ovfpt * (float)dsin2Phi;
	    c2Phi    = ovfpt * (float)dcos2Phi;
	    *px22 =  Ampli * c2Phi ;
	    *px33 =  Ampli * c2Phi ;
	    *px23 =  Ampli * s2Phi * mone;
	    *px32 =  Ampli * s2Phi ;
	    px22++;
	    px23++;
	    px33++;
	    px32++;
	    pQ += NAZ;
	    pU += NAZ;
	}

}


int
getPHInA_new(Data,Amp,Phi)
    float  *Data;
    float  *Amp;
    double *Phi;
{
    float  *pD , *pV, *pW;
    float sprod,cprod;
    double Smean, Cmean, SumSq;
    double atan2(), sqrt();

    pD = Data;
    pW = sinth;
    pV = tmpV;
    VVmult(pD,pW,pV,NAZ);
    get_mean_fast(pV,NAZ,&sprod);

    pD = Data;
    pW = costh;
    pV = tmpV;
    VVmult(pD,pW,pV,NAZ);
    get_mean_fast(pV,NAZ,&cprod);

    Smean = (double)sprod;
    Cmean = (double)cprod;

    SumSq = Smean*Smean + Cmean*Cmean;

    *Phi = atan2(Smean,Cmean);
    *Amp = (float)(2. * sqrt(SumSq));

}

int
ckphase(dd,P,phserr)
    int    dd;
    float  *P;
    double *phserr;
{

    float  Ampli;
    double Phi;

    getPHInA_new(P,&Ampli,&Phi);

    fprintf(stderr,
        "\t\t\tAt pixel %d phase of %.2f deg found.\n", dd, Phi*r2d );

    if ( Phi > piov2+piov4 ) Phi -= pi;
    if ( Phi > piov2+piov4 ) Phi -= pi;

    *phserr = Phi;
}


