/* mk4hkv2.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Test mk4hdp.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR    9 October 2001
 *  3 Feb 2004: Add quXformAngle, depolAmp, depolPhi, depolscanAMP, depolscanPhi
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

#define START
#include "mk4v2.h"
#include "mk4headv2.h"

main (argc, argv)

int argc ;
char *argv [] ;

{
    extern int rdmk4head () ;
    extern int mk4hdp () ;

    static char namimg [80] ;
    int pmode = 1 ;
    struct mk4_header *hd; 

    if (argc == 2)
        strcpy (namimg, argv [1]) ;
    else
        {
        fprintf (stderr, "usage: %s mk4_filename\n", argv [0]) ;
        exit (0) ;
        }

    rdmk4head (namimg, mk4h, pmode) ;

    mk4hkv2p (mk4h) ;

    exit (0) ;
}

/* -------------------------------------------------------------------------- */

int
rdmk4head (namimg, hd, doprint) 

    char *namimg; 
    struct mk4_header *hd; 
    int doprint;
{
    int ii, hdsz;
    FILE *fid;

    if (doprint > 0) fprintf (stderr, "\tReading header from: %s \n", namimg);

    /*** Open file. ***/

    if ( ( fid = fopen (namimg, "r") ) == NULL  )
	{
	fprintf (stderr, "Error opening %s for reading.\n", namimg);
	exit (-90);
        }

    /*** Read header. ***/

    hdsz = sizeof (mk4head);

    if ( ( ii = fread (hd, 1, hdsz, fid)) != hdsz )
	{
	fprintf (stderr, "Header read error:\n\
	    Only read %d bytes from %s\nExpected %d", ii, namimg, hdsz);
	fclose (fid);
	exit (-92);
        }

    /*** Fill FITS information structure. ***/

/*
 *    mk4hdu (hd, doprint) ;
 */

    fclose (fid);
    return (0) ;
}

