/* esyndur.c
 *------------------------------------------------------------------------------
 * Find synoptic rotation duration.
 *------------------------------------------------------------------------------
 * Andrew L. Stanger   HAO/NCAR   13 Mar 2002
 *------------------------------------------------------------------------------
 */

#include "ephemeris.h"

float
esyndur (crot)

int   crot ;			/* Carrington Rotation. */

{
    int isleap () ;

    int i ;
    float fdoy1, fdoy2 ;
    float iyear1, iyear2 ;
    float duration ;

    i = 0  ;
    while ( crot > (int) CRtable [i][0] ) i++ ;

    fdoy1  =       CRtable [i]  [1] ;
    fdoy2  =       CRtable [i+1][1] ;
    iyear1 = (int) CRtable [i]  [2] ;
    iyear2 = (int) CRtable [i+1][2] ;

    if (iyear1 < iyear2)
        {
	fdoy2 += 365.0 ;
	if (isleap (iyear1)) fdoy2 += 1.0 ;
	}

    duration = fdoy2 - fdoy1 ;

    return (duration) ;
}

/* -------------------------------------------------------------------------- */

int
isleap (iyear)

int iyear ;

{
    int leap ;

    if (iyear%4 == 0 && iyear%100 != 0 || iyear%400 == 0 ) 
	leap = 1 ;
    else
	leap = 0 ;

    return (leap) ;
}
