/* I've got --tons- of comments for this program.
   Please see the file /home/cordyn/mk3S/readme.h
*/
#include "/home/cordyn/mk3S/readme.h"

#include <stdio.h>
#include <ctype.h>
#include "/home/cordyn/mk3S/EWmap.h"
#include "/home/cordyn/mk3/src/filehd.h"
#include "/home/cordyn/mk3/src/pic_hdr.h"
#include "/home/cordyn/mk3/src/misc.h"

#define CYSIZE (128*750)	/* size of cylindrcal array */
#define BASIZE (750)		/* size of bangle array */
#define BKWDS  (1200)            /* Bytes to skip backwards from the EOF */

int  isavg;
char atime[300];

char picnm[100], *piceos;

short  *qq, pBim[CYSIZE];
short *pba, ba[BASIZE] ;
float *pfba, fba[BASIZE];

char (*filenm)[300] ;
char (*filenmba)[300] ;

char ims_avail[10000] ;
char explanation[] = "\
\n\
Date      Doy     hr_min_sec   East long  West long  CentM long  used?(y or n)\n";
int  num_ims_avail , num_lines ;
int  useyn=1 ;


int offset = 60 ;
short *sy , sbuf[360] , Bmap [MLATS][BLONGS] , imap[MLATS][LONGS] ;
short                   BCmap[ PA  ][BLONGS] , cmap[ PA  ][LONGS] ;
float pB[DAYS][LATS] ;

int local ;
int east , west , map , EWmap , CMmap ;
int     iCR , bdoy , edoy  , byr , eyr , leap ;
int     Fbdoy , Fedoy  , Fbyr , Feyr , Fleap ;
long    iFbegEj , iFendEj , iFbegWj , iFendWj ;
long    ibegEj ,  iendEj ,  ibegWj ,  iendWj , ibegCj , iendCj ;
double  begEj , endEj , begWj , endWj , begCj , endCj ;
double  slopeE , slopeW , slopeC ;
float   Elong[100]  , Wlong[100] , Clong[100] ;  /* <-- This is where the 
					     program can easily bomb, if the 
					     dimension is not large enough. */
int    Crot , numSfiles ;
float  height ;
float  flbdoy,fledoy;
int    ibdoy,iedoy,ibyr,ieyr;

char    EWmapnm[80] , mapnm[80] , EWpath[80] ;
float   INTERPDAY;

int     idflag , udflag , qdflag , pBflag , posflag , negflag ;
int     chanflag , channel;
int     Rngflag,dayflag,quickflag,nameflag,doyflag,Neflag,cal0flag,timeflag,
	Secflag,cal15flag,chnme;
int     sclmin,sclmax;
int     mon, day, year,doy;
float   thetamin, thetamax;
float   pixscl, r0=1.1224,dr=0.0104244;        /* 12/12/90 ch0 test values */
double  thoff, twopi;
long    aspot;
int     orignray;

main (an, av) char *av[]; {
    register long ii;
    register char *w;
    register float *fp;
    register FH filehd = &head;
    register PH phdr = &pic_header;
    char ss[100] , name[100][300] ;
    long footloc , asciiloc , eofloc ;
    char oldfoot[2000];
    float elong , wlong  , clong ;
    int ie , iw , ic ;
    int eday , wday  ;
    int filecnt , diode ;
    int ask;
    double f_juld ;
    int yrfix,isleap() ;
    FILE *infid, *fid;

    int  do_ask() ;
    void prsum() ;
    void get_slopes() , ck_get_day() , ck_get_long() ,
         do_EWmapnm() , do_mapnm() ,
	 fillEmap() , fillWmap() ,
	 fillEfile() , fillWfile() ,
         do_mapout() , do_fileout() , do_usedout() ,
	 fill_ims_avail() ;
    int nmdates() ;

    INTERPDAY = 1.5; 
    ask = 0 ;  map = 0 ; 
    EWmap = 1 ;  /* History maps are the default. */
    west = east = 0 ;
    num_ims_avail = 0 ;
    num_lines = 1 ;
    twopi = pi+pi;

    sprintf(ims_avail,explanation);
    filenm = name ;

    fp = &pB[0][0] ;
    for( ii=0 ; ii<DAYS*LATS ; ii++ ) *fp++ = -9999.000000 ;

    if ( an <= 1 ) { prsum() ; exit(3) ; }
    while (--an) {
	if (*(w = *++av) == '-')	/* Check for flag arguments */
	    switch (w[1]) {
	    case 'a':   ask++; /* ask whether or no to use a longitude. */
			break ;
	    case 'i':   sprintf( ss,"%s",*(++av) );  
			sscanf ( ss,"%f", &INTERPDAY );
			an -= 1 ;
			break ;
	    case 'e':   east++; /* east limb map */
			break ;
	    case 'w':   west++; /* west limb map */
			break ;
	    case 'c':   CMmap++; /*Make a file of pB data, 
				  LONGSxPA  (360x360) beginning at central
				  meridian passage. */
			break ;
	    case 'm':   map++; /* Make a file containing a synoptic map of
				  the pB data, LONGSxMLATS short ints 
				  suitable for the Grinnell */
			break ;
	    case 'h':   sprintf( ss,"%s",*(++av) );  
			sscanf ( ss,"%f", &height );
			an -= 1 ;
			break ;
	    case 'l':   local++; /* Make the map in the present directory
				    instead of in the map library.
				    This only works when "map" is requested. */
			break ;
	    case 'r':   /* Get the rotation to create. */
			sprintf( ss,"%s",*(++av) );  
			sscanf ( ss,"%d", &Crot );
			an -= 1 ;
			break ;
	    default:    fprintf (stderr," unknown flag %s\n",*av);
		        prsum(); exit(1);
	    }

	else {
	    if (*w == '?') { prsum(); exit(2); }
	    sprintf((char *)filenm++,"%s",w);
	    break;
	}
    }

    /* Set defaults. */

    if (east + west == 0)  east++ ;
    if ( map )                           EWmap = 0 ;
    if (CMmap) {           east = west = EWmap = map = 0 ; }

    if (height <= 0) { height = 1.3 ; fprintf(stderr,"\nUsing 1.3Rsun\n"); }
    diode = (int) ( 0.5 + (( height-r0 ) / dr )) ;
    fprintf(stderr,"height %.3f is diode %d (0th diode is at %.4fRsun)\n",
    height,diode,r0);

    /* Determine what dates and pB images are needed to make the desired maps 
       for this rotation.  */

    filenm = name ;
    if ( !nmdates(Crot,av,an) ) { /* nmdates fills up the files in filenm
				  and, gets numSfiles */
	fprintf(stderr,
	"Couldn\'t load the images for the synoptic map.\n"); 
	exit (-3) ;
    }

    fprintf(stderr,
	"\nFor rotation %d the following images will be read.\n",Crot);
    for ( filenm = name, filecnt=1; filecnt<=numSfiles; filecnt++ ) {
	fprintf(stderr,"\t%s\n",*filenm++) ;
    }

    fprintf(stderr,
    "\nFor fake \"history data\", the file beginning and ending days are:\n\
    Fbdoy -> %d, %d  Fedoy %d, %d \n",Fbdoy , Fbyr , Fedoy , Feyr ) ;

    fprintf(stderr,
    "\nFor map data, the map beginning and ending days are:\n\
    bdoy -> %d, %d   edoy %d,  %d\n\n",bdoy , byr , edoy , eyr ) ;
    ibyr=(int)byr;
    ieyr=(int)eyr;
    if(ieyr>ibyr) yrfix=365+isleap(ibyr);
    else          yrfix=0;
    ibdoy=(int)( flbdoy*100);
    iedoy=(int)((fledoy-(float)yrfix)*100);


    if(EWmap) do_EWmapnm (Crot,height);  /* Define the output map name. */
    if(map||CMmap) do_mapnm(Crot,height) ;

    get_slopes () ;  /* Get the slopes for the conversion to longitude. */


    for ( filenm = name, filecnt=1; filecnt<=numSfiles; filecnt++ ) {
        
	if (! (infid = fopen ((char *)filenm,"r")) ) {
	    fprintf (stderr,"%s does not exist.\n",filenm);
	    exit (1);
	}
	fseek (infid, 0, 2);  /* Skip to end of file. */
	eofloc = ftell(infid) ;
	fseek (infid, -(BKWDS+1), 2);

	fscanf(infid,"%s",ss);
	while( strcmp(ss, "entire") != 0 )   fscanf(infid,"%s",ss);
	fscanf(infid,"%*s%ld",&footloc) ; 
     
	fscanf(infid,"%s",ss);
	while( strcmp(ss, "ascii") != 0 )   fscanf(infid,"%s",ss);
	fscanf(infid,"%*s%ld",&asciiloc) ;
     
	fseek (infid, footloc, 0);  /* Skip to the footer. */
     
	fread(filehd, 1,  sizeof(struct filehd ), infid);
	fread(phdr,   1,  sizeof(struct pic_hdr), infid);
	fread(oldfoot,1,  eofloc-asciiloc+1     , infid);


	/* Print out the sumry info. */
	printf ("\n\nFile: %s\n",filenm);
	printf ("    %s %s chan = %d \"%s\"\n",       prday(filehd->juld), 
					              prtime(filehd->time),
					              filehd->chan, 
						      prflags(filehd->flags));
	if ( !pBflag ) 	{ fprintf(stderr,"    This image is NOT pB data.\n") ;
			  exit(-5); }
        
	pixscl = (filehd->ipixscl) / 10000.0 ;
	r0 = (filehd->ir0) / 10000.0 ;
	dr = (filehd->idr) / 10000000.0 ;

	qq=pBim;
	fseek(infid,0,0); fread(qq,1,footloc,infid);  fclose(infid);

	if(filehd->nray != 720){
	    if ( head.chan==0 ) thoff= 30.*d2r - pangle(filehd->Pangle);
	    if ( head.chan==1 ) thoff=  0.*d2r - pangle(filehd->Pangle);
	    chanflag=0;
	    dopicnm (&head); 		/* Fill up the .ba filename. */
	    dofnm (16); 
	    if (! (infid = fopen (picnm,"r")) ) {
		sprintf(ss,"/puu/mk3/mk3_best/%s",picnm);
		sprintf(picnm,"%s",ss);
		if (! (infid = fopen (picnm,"r")) ) {
		    fprintf (stderr,"Can\'t find %s for the b-angles.\n",picnm);
		    exit (1); }
	    }
	    printf ("\t\tOpening: %s\n",picnm);
	    fseek(infid,0,0); fread(ba,1,(head.nray)*2,infid);  fclose(infid);
	    pba=ba; pfba=fba;
	    for(ii=0;ii<(long)(head.nray);ii++){  /* Convert to PA */
		*pfba = (float)(ba2rad*((double) *pba) + thoff +twopi);
		if( *pfba > (float)(twopi) ) *pfba -= (float)(twopi);
		*pfba *= rtd;  /* Convert to degrees. */
		pfba++; pba++;
	    }
	}
	else{
	    pfba=fba;
	    for(ii=0;ii<(long)(head.nray);ii++){ 
		*pfba = (float)(ii) * 0.5 ; pfba++; }
	}



	/* Is this a time we need for the east or west map ?  */
	/* If so, return the appropriate longitude for the right map.*/

	ck_get_day (head.juld,head.time,
				     &eday,&wday,&f_juld) ;
	ck_get_long(head.juld,head.time,
				     &elong,&wlong,&clong,&f_juld) ;

	if( (elong >= -999) || (wlong >= -999) || (clong >= -999)
	    ||
	    (eday >= -999) || (wday >= -999) ) {

	    sy = sbuf ;
	    fillsyarry(sbuf,pBim,fba,filehd->nray,diode);

	    if ( !ask || 
		     (ask 
		     && 
		     (useyn=do_ask ( &head,eday,wday,
				     elong,wlong,clong,f_juld )
		      ))  
		)  {

		/* Put this in the correct part of the correct map. */
		sy = sbuf ;
		if (map||CMmap) {

		    if( east && elong >= -999 ) { 
					    fillEmap(Bmap,sy,elong,f_juld);
					    Elong[ie++] = elong ; }
		    if( west && wlong >= -999 ) { 
					    fillWmap(Bmap,sy,wlong,f_juld);
					    Wlong[iw++] = wlong ; }
		    if( CMmap && clong >= -999) {
					    fillCmap(BCmap,sy,clong,f_juld);
					    Clong[ic++] = clong ; }
		}
		sy = sbuf ;
		if (EWmap) { 
		    if( east && eday >= -999 ) fillEfile( pB , sy , eday ) ;
		    if( west && wday >= -999 ) fillWfile( pB , sy , wday ) ;
		}
	    }

	    if ((eday + wday > -2*9990 ) 
		  || 
		(elong + wlong + clong > -3.0*9990.0 )) 
		fill_ims_avail(&head,elong,wlong,clong,f_juld);

	}
	filenm++;
    }

    /*  Now that all the data for the rotation has been accumulated,
	write it out. */
    if (EWmap) do_fileout(EWmapnm,EWpath) ;
    if (map||CMmap)   {
	/* First interpolate the map. */
	if  ( east||west ) {
	    if(east) terpimap(Elong,ie,imap,Bmap,MLATS) ;
	    else     terpimap(Wlong,iw,imap,Bmap,MLATS) ;
	    do_mapout(mapnm,imap,MLATS) ;
	}
	else /* CMmap */ {
	    terpimap(Clong,ic,cmap,BCmap,PA) ;
	    do_mapout(mapnm,cmap,PA) ;
	}
	if ((fid = fopen(mapnm,"a+")) == NULL ) {
	    fprintf(stderr,"\nError in opening the file - %s \n",mapnm) ;
	    exit(-1) ;
	}
	fwrite (&ibdoy,1,sizeof(int), fid);
	fwrite (&ibyr,1,sizeof(int), fid);
	fwrite (&iedoy,1,sizeof(int), fid);
	fwrite (&ieyr,1,sizeof(int), fid); fclose (fid);
	do_availout(mapnm,ims_avail,num_ims_avail,num_lines);
    }
}
void get_slopes () {
    slopeE = 360.0  / ( endEj - begEj )  ;
    slopeW = 360.0  / ( endWj - begWj )  ;
    slopeC = 360.0  / ( endCj - begCj )  ;
}




pruse() { static char usage[] = "\
\n\
Standard usage is: \n\
    mkamap [-a] [-cm] [-m] [-l] [-e] [-w] [-h height] [Crotation]\n\n" ;
    fputs (usage,stderr);
}

void prsum() { static char help1[] = "\
\n\
mkamap [-a] [-i nday] [-cm] [-m] [-l] [-e] [-w] [-h height] [-r Crotation] [image1 ... imageN]\n\
\n\
Example:              cat imlist | mkamap -e -h 1.3 -r 1776 \n\
\n" ;
static char help2[] = "\
Flags	Description\n\
-----	-----------\n\
-[a]         have the program ask whether or not to use a longitude\n\
-[i nday]    is the number of day to interpolate over, (default, 1.5 days).\n\
-[cm]        make an array of shorts pB[360][360] (pB[PA][longs] longs goes \n\
	     fastest) that begins at Central Meridian passage \n\
-[m]         make a map of short pB[181][360] , suitable for the Grinnell\n\
-[l]         if -m is specified, -l will make the map locally in the \n\
		 present working directory. \n\
-[e]         makes an east limb map (default).\n\
-[w]	     makes a west limb map.\n\
-[h height]  is the height in Rsun of the map (default, 1.3 Rsun).\n\
-[r Crot]    is the Carrington rotation of the map to create.\n\
\n" ;

       fputs (help1,stderr);
       fputs (help2,stderr);
}




char query[] = "\
East longitude is %.1f\nWest longitude is %.1f\nCent Meridian long is %.1f\n\
	Do you want to use this data? (y or n) --> \
" ;


do_ask (filehd, eday, wday, elong,wlong,clong,juld) 
	register FH filehd;  
	int eday , wday ;
	float elong , wlong , clong ;  double juld ; 
{
    char   ans[8] ;
    extern int   jdate() , iday()  ;

    if( (eday + wday > -2*9990 ) 
	||
        ( elong + wlong + clong > -3.0*9990.0 ) )
	{
	jdate ( (long)juld , &mon , &day , &year ) ;  
	doy = iday ( mon , day , year ) ;
	fprintf (stderr,"\n%s  Doy --> %d;  %s \n",
		prday(filehd->juld), doy , prtime(filehd->time) ) ;

	fprintf(stderr, query , elong,wlong,clong ) ;
	scanf("%s",ans) ;
	if ( ans[0] == 'y' )  return (1) ;
	else                  return (0) ;
    }
    else                      return (0) ;
}
