/* EWmap4.h
 *------------------------------------------------------------------------------
 * Mk4 synoptic map information & definitions.
 *------------------------------------------------------------------------------
 * Author:  Alice Lecinski   HAO/NCAR    1 Nov 1993   EWmap.h
 * Updates: Andrew Stanger   HAO/NCAR   14 Mar 2002   EWmap4.h
 * 14 Mar 2002: Adapt for Mk4.
 *------------------------------------------------------------------------------
 */

/* #include <sys/types.h> */

#define RSMAX  3000.0
#define RSMIN  -100.0

#define BANGLES 700

#define HDR  264                /* 256+4+4 */
#define SYSIZE (360*2)          /* size of synoptic data in ints */
#define SYITEMS (360)           /* number of synoptic items == 360 */
#define PA      (360)           /* Position angle */
#define BLONGS  (360+60+60)     /* x Size of the Bmap */
#define LONGS   360             /* x Size of the imap */
#define MLATS   181             /* y Size of the imap */
#define OVLAP     2             /* Days of overlap for imap. */
#define DAYDEGR  14             /* Approximately the num of degrees per day */
#define ONEDAY   (24*60*60*100) /* The length of one day in 100ths of seconds.*/
#define DAYS     34
#define LATS     37
#define EAST 1.0
#define WEST 2.0
#define SHIFTE  (-10.32)   /* -6.82-1.5-2.0 */
#define SHIFTW  (  3.32)   /* +6.82-1.5-2.0 */

