#include <stdio.h>
typedef unsigned short u_short ;

extern char picnm[] , *piceos ;
extern int idflag , udflag , qdflag , pBflag , Neflag ;
extern int cal0flag, cal15flag;
extern int dayflag, timeflag, chanflag;
extern int Secflag ;
extern int doyflag ;

extern int mon, day, year, doy ;

extern int isavg;

extern struct filehd {
    int flags:13;
    int chan:3;
    u_short juld;
    unsigned time;      /* In milliseconds!  */
    short phase;
    u_short bright;
    short Pangle;
    u_short nray;
    short qmax, qmin, didxx, didxn;
    u_short exdate , scndur ;        /* scndur is in Hertz (60=1second)! */
    int ipixscl , ir0 , idr ; } ;

typedef struct filehd * (FH);


dofnm (which) int which; {
    register char *p = piceos;

    switch (which) {

    case 0:	/* c  cylindrical */
	    if      ( udflag ) 		*p++ = 'u' ;
	    else if ( idflag ) 		*p++ = 'i' ;
	    else if ( qdflag )          *p++ = 'q';    
	    else if ( pBflag )       {  *p++ = 'p';    *p++ = 'B';    }
	    else                        *p++ = '_';
	    break ;

    case 1:	/* r rectangluar */
	    *p++ = 'r'; 
	    if      ( udflag ) 		*p++ = 'u' ;
	    else if ( idflag ) 		*p++ = 'i' ;
	    else if ( qdflag )          *p++ = 'q';    
	    else if ( pBflag )       {  *p++ = 'p';    *p++ = 'B';    }
	    else if ( Neflag )       {  *p++ = 'N';    *p++ = 'e';    }
	    else                        *p++ = '_';
	    break ;

    case 2:	/* sr scaled rectangular */
	    *p++ = 's';    *p++ = 'r';    
	    if      ( udflag ) 		*p++ = 'u' ;
	    else if ( idflag ) 		*p++ = 'i' ;
	    else if ( qdflag )          *p++ = 'q';    
	    else if ( pBflag )       {  *p++ = 'p';    *p++ = 'B';    }
	    else                        *p++ = '_';
	    break;

    case 3:	/* C cylindrical, 720 "rays"  */
	    *p++ = 'C'; 
	    if      ( udflag ) 		*p++ = 'u' ;
	    else if ( idflag ) 		*p++ = 'i' ;
	    else if ( qdflag )          *p++ = 'q';    
	    else                        *p++ = '_';
	    break;

    case 15:	/* ascii b-angles */
	    *p++ = 'a';    *p++ = 'b';    *p++ = 'a';    break;

    case 16:	/* b-angles */
	    *p++ = 'b';    *p++ = 'a';    break;

    case 17:	/* ascii scan times */
	    *p++ = 'a';    *p++ = 's';    *p++ = 't';    break;

    case 18:	/* scan times */
	    *p++ = 's';    *p++ = 't';    break;

    case 19:	/* calibration */
	    *p++ = 'c';    *p++ = 'a'; *p++ = 'l';    *p++ = 'i'; *p++ = 'b';
	    break;

    case 20:	/* telescope parameter calibration file */
	    *p++ = 't'; *p++ = 's'; *p++ = 'c'; *p++ = 'p';
	    break;
    case 21:	/* calibrated I data. */
	    *p++ = 'I';
	    break;
    case 22:	/* calibrated U data. */
	    *p++ = 'U';
	    break;
    case 23:	/* residual polarization removed calibrated pB data. */
	    *p++ = 'P';
	    *p++ = 'B';
	    break;
    case 24:	/* Sky transmission data. */
	    *p++ = 's'; *p++ = 'k';
	    break;
    }
    *p = '\0';
}


dopicnm (filehd) register FH filehd; {
    register char *p = picnm;
    static char months[] = "janfebmaraprmayjunjulaugsepoctnovdec";
    int hr;

    hr = filehd->time / (60 * 60 * 100) ;
    if (dayflag) {
	jdate (filehd->juld + 2415021, &mon, &day, &year);
	if (!doyflag) {
	    sprintf (p,"%2d%3.3s%02d.",year-1900,months+(mon-1)*3,day);
	    p += 8; 
	}
	else {
	    doy = get_doy (mon, day, year);
	    /* fprintf(stderr,"hr is %d doy is %d\n",hr,doy); */
	    if( hr < 5  && isavg==1 ) doy--;
	    if(year==1986 && doy==229) {
		doy=230; /*ERROR at MLSO*/
		filehd->juld += 1;
	    }
	    sprintf (p,"%2dd%03d.", (year > 2000) ? year-2000
						  : year-1900,doy);
	    p += 7; 
	}
    }

    if (timeflag && !Secflag ) {
	sprintf (p,"%5.5s.", prtime(filehd->time));
	p += 6; }
    if (timeflag && Secflag ) {
	sprintf (p,"%8.8s.", prtime(filehd->time));
	p += 9; }
    if (chanflag) { 
	*p++ = 'c'; *p++ = 'h'; *p++ = filehd->chan + '0'; *p++ = '.'; }
    *p = '\0';
    piceos = p;
}
