/* I've got --tons- of comments for this program.
   Please see the file /home/cordyn/mk3S/readme.h
*/
#include "/home/cordyn/mk3S/readme.h"

#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include "/home/cordyn/mk3S/EWmap.h"

#define  ADSZ  80

char (*filenm)[100] ;
char longname[255] ;

char ims_avail[10000] ;
char explanation[] = "\
\n\
Date      Doy     hr_min_sec   East long  West long  CentM long  used?(y or n)\n";
int  num_ims_avail , num_lines ;
int  useyn ;

int idflag , udflag , qdflag , pBflag , posflag , negflag ;
int cal0flag, quickflag, cal15flag, year,Neflag;
int chanflag , channel;

int offset = 60 ;
short *sy , sbuf[360] , Bmap [MLATS][BLONGS] , imap[MLATS][LONGS] ;
short                   BCmap[ PA  ][BLONGS] , cmap[ PA  ][LONGS] ;
float pB[DAYS][LATS] ;

int local ;
int east , west , map , EWmap , CMmap ;
int     iCR , dispyr , bdoy , edoy  , byr , eyr , leap ;
int     Fbdoy , Fedoy  , Fbyr , Feyr , Fleap ;
long    iFbegEj , iFendEj , iFbegWj , iFendWj ;
long    ibegEj ,  iendEj ,  ibegWj ,  iendWj , ibegCj , iendCj ;
double  begEj , endEj , begWj , endWj , begCj , endCj ;
double  slopeE , slopeW , slopeC ;
float   Elong[100]  , Wlong[100] , Clong[100] ;  /* <-- This is where the 
					     program can easily bomb, if the 
					     dimension is not large enough. */
int    Crot , numSfiles ;
float  height ;

char   EWmapnm[80] , mapnm[80] , EWpath[80] ;

float INTERPDAY;

main (an, av) char *av[]; {
    register long ii, jj , kk ;
    register char *w;
    register float *fp;
    register LS list , first_list ;
    LS list_addr[ADSZ]  ;
    register SFH syfilhd = &listhd.head;
    char ss[100] , name[20][100] ;
    long ui, reclen , file_size , file_pos=0 ;
    float elong , wlong  , clong ;
    int ie , iw , ic ;
    int eday , wday  ;
    int imgcnt , filecnt , diode ;
    int ask ;
    float      r0 =  1.1224     ;        /* 12/12/90 test value */
    float      dr =  0.0104244  ;        /* 12/12/90 test value */
    double f_juld ;
    FILE *fid;

    int  do_ask() ;
    void prsum() ;
    void get_slopes() , ck_get_day() , ck_get_long() ,
         do_EWmapnm() , do_mapnm() ,
	 fillEmap() , fillWmap() ,
	 fillEfile() , fillWfile() ,
         do_mapout() , do_fileout() , do_usedout() ,
	 fill_ims_avail() ;
    int nmSYNfiles() ;

    INTERPDAY = 3.0;
    ask = 0 ;  map = 0 ; 
    EWmap = 1 ;
    west = east = 0 ;
    num_ims_avail = 0 ;
    num_lines = 1 ;

    sprintf(ims_avail,explanation);

    fp = &pB[0][0] ;
    for( ii=0 ; ii<DAYS*LATS ; ii++ ) *fp++ = -9999.000000 ;
    for( ii=0 ; ii<ADSZ ; ii++ ) list_addr[ii] = 0 ;

    if ( an <= 1 ) { prsum() ; exit(3) ; }
    while (--an) {
	if (*(w = *++av) == '-')	/* Check for flag arguments */
	    switch (w[1]) {
	    case 'C':   chanflag++; /* The SYN??? file is channel 1 data */
			r0=1.592;
			break ;
	    case 'a':   ask++; /* ask whether or no to use a longitude. */
			break ;
	    case 'e':   east++; /* east limb map */
			break ;
	    case 'w':   west++; /* west limb map */
			break ;
	    case 'c':   CMmap++; /*Make a file of pB data, 
				  LONGSxPA  (360x360) beginning at central
				  meridian passage. */
			break ;
	    case 'm':   map++; /* Make a file containing a synoptic map of
				  the pB data, LONGSxMLATS short ints 
				  suitable for the Grinnell */
			break ;
	    case 'h':   sprintf( ss,"%s",*(++av) );  
			sscanf ( ss,"%f", &height );
			an -= 1 ;
			break ;
	    case 'l':   local++; /* Make the map in the present directory
				    instead of in the map library.
				    This only works when "map" is requested. */
			break ;
	    default:    fprintf (stderr," unknown flag %s\n",*av);
		        prsum(); exit(1);
	    }

	else {
	    if (*w == '?') { prsum(); exit(2); }
	    Crot = atoi ( w ) ;		/* Get the rotation to create. */
	}
    }

    /* Set defaults. */

    if (east + west == 0)  east++ ;
    if ( map )                           EWmap = 0 ;
    if (CMmap) {           east = west = EWmap = map = 0 ; }

    if (height <= 0) { height = 1.3 ; fprintf(stderr,"\nUsing 1.3Rsun\n"); }
    diode = (int) ( 0.5 + (( height-r0 ) / dr )) ;
    fprintf(stderr,"height %.3f is diode %d (0th diode is at %.4fRsun)\n",
    height,diode,r0);




    /* Determine what data files we need to make the desired maps 
       for this rotation.  In most cases there will be at least three.  */

    filenm = name ;
    if ( !nmSYNfiles(Crot) ) { /* nmSYNfiles fills up the files in filenm
				  and, gets numSfiles */
	fprintf(stderr,
	"Couldn\'t figure out the names for the synoptic files.\n"); 
	exit (-3) ;
    }

    fprintf(stderr,
	"\nFor rotation %d the following files are required.\n",Crot);
    for ( filenm = name, filecnt=1; filecnt<=numSfiles; filecnt++ ) {
	fprintf(stderr,"\t%s\n",*filenm++) ;
    }

    fprintf(stderr,
    "\nFor fake \"history data\", the file beginning and ending days are:\n\
    Fbdoy -> %d, %d  Fedoy %d, %d \n",Fbdoy , Fbyr , Fedoy , Feyr ) ;

    fprintf(stderr,
    "\nFor map data, the map beginning and ending days are:\n\
    bdoy -> %d, %d   edoy %d,  %d\n\n",bdoy , byr , edoy , eyr ) ;


    if(EWmap) do_EWmapnm (Crot,height);  /* Define the output map name. */
    if(map||CMmap) do_mapnm(Crot,height) ;

    get_slopes () ;  /* Get the slopes for the conversion to longitude. */


    first_list = &listhd ;
    list_addr[0] = first_list ;

    for ( filenm = name, filecnt=1; filecnt<=numSfiles; filecnt++ ) {
        
	file_pos = 0 ;
	list = first_list ;
	list->syoff = 0 ;
	syfilhd = &(list->head);

	sprintf(ss,"%s",*filenm++) ;
	fprintf(stderr,"Opening file --> %s\n",ss) ;

	fid = fopen (ss,"r" ) ;
	if ( fid == NULL) {
	    fprintf(stderr,
	    "%s does not exist locally.\n Trying on puu..\n",ss);
	    sprintf(longname,"/puu/d/cordyn/Synoptc/%s",ss) ;
	    fprintf(stderr,"Opening--> %s\n",longname) ;
	    if (( fid=fopen (longname,"r") ) == NULL) {
		fprintf (stderr,"\n\007 %s does not exist either.\n",longname);
		fprintf (stderr,
		"To create the map for Carrington rotation %d, the synoptic\n\
		file %s is required.  \n\
		Unfortunately, it does not yet exist.\n\
		Create the file by running program \"synoptc\" on puu.\n\
		Then bring the file to puu with program \"sy_fetch\".\n\
		And then, try running this program again.\n", Crot, ss ) ;
		exit (1);
	    }
	}
	fseek ( fid, 0 , 2 ) ;
	file_size = ftell(fid) ;  
	rewind(fid) ;



	for (imgcnt=0;;imgcnt++) {	/* Begin the loop to fill the lst 
		                         structure for each of the images. */

	    /*  Read in the next 4 bytes checking that we're not at the end 
	        of the file.  These 4 bytes are the record length. */
	    jj = fread (&ui,4,1,fid); reclen = ui;

	    if (jj <= 0 ) { printf("All done with file %s\n",ss); break; }
	    if (ui == 0 ) { printf("\tFinished reading file %s\n",ss); break;}
	    if ( feof(fid)   ) { printf("\nEOF was found.\n") ; break; }
	    if ( ferror(fid) ) { printf("\nferror on fid found.\n") ; break; }


	    fread (&ui,4,1,fid);  /* These 4 bytes are the record offset. */
	    if ( ui != HDR  ) {
		printf( "\nThe record offset was !=264, indicating a\n\
		    corrupted synoptic file at image %d.\n",imgcnt);
		printf( "The program will try to make do, but you may want to\n\
		    recreate --> %s \n",ss) ;
		break;
	    }

	    fseek (fid,256,1);    /* Skip the ascii header. */

	    if (list->syoff != 0) {
		/*  Allocate space for 2nd, etc, images lst structure, set
		    pointers for syfilhd too. */
		list->next = (LS) malloc (sizeof (struct lst));
		list = list->next;
		syfilhd = &(list->head);
		list_addr[imgcnt] = list ;
	    }


	    /* Fill up the syfilhd structure. */
	    if ((jj = fread (syfilhd,1,sizeof (struct syfilhd),fid))
		!= sizeof (struct syfilhd)) {
		    fprintf(stderr,"Can\'t read header for image %d.\n",imgcnt);
		    exit (4);
	    }


	    /*  Determine and fill up specifics in the lst structure. */
	    ii = syfilhd->nray;
	    list->baoff = ftell(fid);
	    list->syoff = list->baoff + (jj = ((ii + 3) & ~3) * 2);


	    /* Skip past the image data, we'll get it if we need it, later. */
	    fseek (fid,reclen-HDR-sizeof(struct syfilhd),1);

	    /* Make sure we are where we think we are. */
	    ii = ftell(fid) ;
	    file_pos += reclen ;
	    if ( ii != file_pos ) fprintf(stderr,
		" Position %ld file_pos %ld reclen %ld \n",ii,file_pos,reclen) ;

	    /* See if we are near the end of the file. */
	    if ( ii >= file_size-(reclen/2) )  break ;


	}
	list->next = 0 ;  /*Set the last one =0, so we know there are no more.*/

	for (ii=0, list = first_list ; list ; list = list->next , ii++ ) {

	    if ((list->head.chan ==1) &&  (list->head.chan != chanflag)) {
		fprintf(stderr,
		"Your synoptic data in file %s is from channel %d, but you\n\
		did not specify the -C flag.  Please rerun, specifing the\n\
		-C flag.\n",ss,list->head.chan);
		exit(-22);
	    }

	    /* Is this a time we need for the east or west map ?  */
	    /* If so, return the appropriate longitude for the right map.*/

	    ck_get_day (list->head.juld,list->head.time,
					 &eday,&wday,&f_juld) ;
	    ck_get_long(list->head.juld,list->head.time,
					 &elong,&wlong,&clong,&f_juld) ;

	    if( (elong >= -999) || (wlong >= -999) || (clong >= -999)
		||
		(eday >= -999) || (wday >= -999) ) {

		sy = sbuf ;
		fseek (fid,list->syoff,0); 
		fseek (fid,diode*360*2,1);
		fread (sy,2,SYITEMS,fid);

		if ( !ask || 
			 (ask 
			 && 
			 (useyn=do_ask ( &list->head,eday,wday,
				         elong,wlong,clong,f_juld )
			  ))  
		    )  {

		    /* Put this in the correct part of the correct map. */
		    sy = sbuf ;
		    if (map||CMmap) {

			if( east && elong >= -999 ) { 
						fillEmap(Bmap,sy,elong,f_juld);
						Elong[ie++] = elong ; }
			if( west && wlong >= -999 ) { 
						fillWmap(Bmap,sy,wlong,f_juld);
						Wlong[iw++] = wlong ; }
			if( CMmap && clong >= -999) {
						fillCmap(BCmap,sy,clong,f_juld);
						Clong[ic++] = clong ; }
		    }
		    sy = sbuf ;
		    if (EWmap) { 
			if( east && eday >= -999 ) fillEfile( pB , sy , eday ) ;
			if( west && wday >= -999 ) fillWfile( pB , sy , wday ) ;
		    }
		}

		if ((eday + wday > -2*9990 ) 
		      || 
		    (elong + wlong + clong > -3.0*9990.0 )) 
		    fill_ims_avail(&list->head,elong,wlong,clong,f_juld);

	    }
	}
	for (ii=1; ii<=imgcnt ; ii++ ) {    free( (char *) list_addr[ii] ) ;
					    list_addr[ii] = 0 ;   }
	fclose(fid) ;
    }

    /*  Now that all the data for the rotation has been accumulated,
	write it out. */
    if (EWmap) do_fileout(EWmapnm,EWpath) ;
    if (map||CMmap)   {
	/* First interpolate the map. */
	if  ( east||west ) {
	    if(east) terpimap(Elong,ie,imap,Bmap,MLATS) ;
	    else     terpimap(Wlong,iw,imap,Bmap,MLATS) ;
	    do_mapout(mapnm,imap,MLATS) ;
	}
	else /* CMmap */ {
	    terpimap(Clong,ic,cmap,BCmap,PA) ;
	    do_mapout(mapnm,cmap,PA) ;
	}
	do_availout(mapnm,ims_avail,num_ims_avail,num_lines);
    }
}
void get_slopes () {
    slopeE = 360.0  / ( endEj - begEj )  ;
    slopeW = 360.0  / ( endWj - begWj )  ;
    slopeC = 360.0  / ( endCj - begCj )  ;
}




pruse() { static char usage[] = "\
\n\
Standard usage is: \n\
    mkMKfile [-C] [-a] [-cm] [-m] [-l] [-e] [-w] [-h height] [Crotation]\n\n" ;
    fputs (usage,stderr);
}

void prsum() { static char help1[] = "\
\n\
mkMKfile [-C] [-a] [-cm] [-m] [-l] [-e] [-w] [-h height] [Crotation]\n\
\n\
Example:              mkMKfile -e -h 1.3 1776 \n\
\n" ;
static char help2[] = "\
Flags	Description\n\
-----	-----------\n\
-[C]         the SYN??? file contains channel 1 data...\n\
-[a]         have the program ask whether or not to use a longitude\n\
-[cm]        make an array of shorts pB[360][360] (pB[PA][longs] longs goes \n\
	     fastest) that begins at Central Meridian passage \n\
-[m]         make a map of short pB[181][360] , suitable for the Grinnell\n\
-[l]         if -m is specified, -l will make the map locally in the \n\
		 present working directory. \n\
-[e]         makes an east limb map (default).\n\
-[w]	     makes a west limb map.\n\
-[h height]  is the height in Rsun of the map (default, 1.3 Rsun).\n\
\n" ;

       fputs (help1,stderr);
       fputs (help2,stderr);
}




char query[] = "\
East longitude is %.1f\nWest longitude is %.1f\nCent Meridian long is %.1f\n\
	Do you want to use this data? (y or n) --> \
" ;


do_ask (syfilhd, eday, wday, elong,wlong,clong,juld) 
	register SFH syfilhd;  
	int eday , wday ;
	float elong , wlong , clong ;  double juld ; 
{
    char   ans[8] ;
    int    mon , day , yr , doy ;
    extern int   jdate() , iday()  ;

    if( (eday + wday > -2*9990 ) 
	||
        ( elong + wlong + clong > -3.0*9990.0 ) )
	{
	jdate ( (long)juld , &mon , &day , &yr ) ;  
	doy = iday ( mon , day , yr ) ;
	fprintf (stderr,"\n%s  Doy --> %d;  %s \n",
		prday(syfilhd->juld), doy , prtime(syfilhd->time) ) ;

	fprintf(stderr, query , elong,wlong,clong ) ;
	scanf("%s",ans) ;
	if ( ans[0] == 'y' )  return (1) ;
	else                  return (0) ;
    }
    else                      return (0) ;
}
