/* nmnfill.c
 ******************************************************************************
 * nmdates
 * isleap
 * fillsyarry
 * mon_day
 ******************************************************************************
 * Author:  Alice Lecinski   HAO/NCAR    3 Nov 1997   Mk3
 * Updates: Andrew Stanger   HAO/NCAR   12 Mar 2002
 * 14 Mar 2002: adapt for Mk4.
 ******************************************************************************
 */
#include <stdio.h>
#include <ctype.h>
#include "/home/cordyn/mk4/syn/ephemeris.h"
#include "/home/cordyn/mk4/syn/EWmap4.h"

/*
 * #include "/home/cordyn/mk4/src/filehd.h"
 * #include "/home/cordyn/mk4/src/misc.h"
 *
 * int ch1r0 = CH1R0;
 */

extern int    iCR ;
extern int    east, west, CMmap ;
extern int    numSfiles ;
extern int    leap, Fleap ;
extern long   iFbegEj, iFendEj, iFbegWj, iFendWj ;
extern long   ibegEj, iendEj, ibegWj, iendWj, ibegCj, iendCj ;
extern double begEj,  endEj,  begWj,  endWj,  begCj,  endCj ;
extern char   (*filenm)[300], (*filenmba)[300];
extern int    dispyr, bdoy, edoy, byr, eyr ;
extern float  flbdoy, fledoy;
extern int    Fbdoy, Fedoy, Fbyr, Feyr ;

extern int    doyflag, nameflag, doyflag, dayflag, timeflag, chnme;

extern int   jday  ()  ;
extern int   jdate () ;
extern int   iday  ()  ;

double juld_last, juld_this, juld_next , juld_future, frac_day ;
int    mon, day, yr, doy, last_doy, file_doy, file_yr, flp ;

/* -------------------------------------------------------------------------- */

int
nmdates (Crot, av, an)

int Crot, an;
char *av [] ; 
{
    int   isleap () ;
    int   ii;
    int   islash;
    char  *w;
    float bfrac, efrac;

    numSfiles = 0 ;

    printf ("Crot: %d\n", Crot) ;
    printf ("CRtable range: %d %d\n",
	    (int) CRtable [0][0], (int) CRtable [ep_sz-1][0]);

    /*** Verify that Carrington Rotation is within C.R. table bounds. ***/

    ii = 0 ;
    if ( Crot < (int) CRtable [0][0] || Crot > (int) CRtable [ep_sz-1][0] )
	{
	fprintf (stderr, "\
        Sorry !  There is no ephemeris entry for your rotation %d.\n\
	Someone will have to update the file \n\
	/home/cordyn/mk4/syn/ephemeris.h\n\n", Crot  ) ;
	exit (12) ;
        }
      
    /*** Verify that Carrington Rotation matches an entry in the table. ***/

    while ( Crot > (int) CRtable [ii][0] ) ii++ ;

    if ( Crot != (int) CRtable [ii][0] )
	{  
	fprintf (stderr, "\tProblems in indexing Crot %d\n") ;
	exit (13) ;
	}
    
    iCR = ii ;

    /*** Determine the beginning and ending days of the E and W limb maps. ***/

    doy = (int) ( CRtable [ii-1][1] ) ; yr = (int) CRtable [ii-1][2] ;
    frac_day =  CRtable [ii-1][1] - (double) doy ;
    mon_day ( doy, yr, &mon, &day );
    juld_last = (double) jday ( mon, day, yr ) +frac_day ;  

printf ("doy: %3d  mon: %2d   day: %2d\n", doy, mon, day) ;

    doy = (int) ( CRtable [ii][1] ) ; yr = CRtable [ii][2] ;
    frac_day =  CRtable [ii][1] - (double) doy ;
    mon_day ( doy, yr, &mon, &day );
    juld_this = (double) jday ( mon, day, yr ) + frac_day ;  

printf ("doy: %3d  mon: %2d   day: %2d\n", doy, mon, day) ;

    doy = (int) ( CRtable [ii+1][1] ) ; yr = CRtable [ii+1][2] ;
    frac_day =  CRtable [ii+1][1] - (double) doy ;
    mon_day ( doy, yr, &mon, &day );
    juld_next = (double) jday ( mon, day, yr ) + frac_day ;  

printf ("doy: %3d  mon: %2d   day: %2d\n", doy, mon, day) ;

    doy = (int) ( CRtable [ii+2][1] ) ; yr = CRtable [ii+2][2] ;
    frac_day =  CRtable [ii+2][1] - (double) doy ;
    mon_day ( doy, yr, &mon, &day );
    juld_future = (double) jday ( mon, day, yr ) + frac_day ;  

printf ("doy: %3d  mon: %2d   day: %2d\n", doy, mon, day) ;

    begEj  = juld_this - ( juld_this - juld_last ) / 4.0 ;
    ibegEj = (long) begEj ;
    endEj  = juld_next - (juld_next - juld_this) / 4.0 ;
    iendEj = (long) endEj ;

printf ("ibegEj:  %6d   iendEj:  %6d\n", ibegEj, iendEj) ;

    begWj  = juld_this + (juld_next - juld_this) / 4.0 ;
    ibegWj = (long) begWj ;
    endWj  = juld_next + (juld_future - juld_next) / 4.0 ;
    iendWj = (long) endWj ;

printf ("ibegWj:  %6d   iendWj:  %6d\n", ibegWj, iendWj) ;

    begCj = juld_this ;
    ibegCj = (long) begCj ;
    endCj = juld_next ;
    iendCj =(long) endCj ;

printf ("ibegCj:  %6d   iendCj:  %6d\n", ibegCj, iendCj) ;

    iFbegEj = (long) (juld_this + SHIFTE) ;
    iFendEj = iFbegEj + 33 ;
    iFbegWj = (long) (juld_this + SHIFTW ) ;
    iFendWj = iFbegEj + 33;

printf ("iFbegEj: %6d   iFendEj: %6d\n", iFbegEj, iFendEj) ;

    if ( east )
	{
	jdate ( ibegEj, &mon, &day, &yr ) ;  
	byr   = yr ;
	bdoy  = iday ( mon, day, yr ) ;
	bfrac = begEj - ibegEj;
	jdate ( iendEj, &mon, &day, &yr ) ;  
	eyr   = yr ;
	edoy  = iday ( mon, day, yr ) ;
	efrac = endEj - iendEj;

	jdate ( iFbegEj, &mon, &day, &yr ) ;  
	Fbyr  = yr ;
	Fbdoy = iday ( mon, day, yr ) ;
	jdate ( iFendEj, &mon, &day, &yr ) ;  
	Feyr  = yr ;
	Fedoy = iday ( mon, day, yr ) ;
        }
    else
    if (west)
	{
	jdate ( ibegWj, &mon, &day, &yr ) ;  
	byr   = yr ;
	bdoy  = iday ( mon, day, yr ) ;
	bfrac = begWj - ibegWj;
	jdate ( iendWj, &mon, &day, &yr ) ;  
	eyr   = yr ;
	edoy  = iday ( mon, day, yr ) ;
	efrac = endWj-iendWj;

	jdate ( iFbegWj, &mon, &day, &yr ) ;  
	Fbyr  = yr ;
	Fbdoy = iday ( mon, day, yr ) ;
	jdate ( iFendWj, &mon, &day, &yr ) ;  
	Feyr  = yr ;
	Fedoy = iday ( mon, day, yr ) ;
        }
    else
	{ /* Must be CMmap */

	jdate ( ibegCj, &mon, &day, &yr ) ;  
	byr   = yr ;
	bdoy  = iday ( mon, day, yr ) ;
	bfrac = begCj - ibegCj;
	jdate ( iendCj, &mon, &day, &yr ) ;  
	eyr   = yr ;
	edoy  = iday ( mon, day, yr ) ;
	efrac = endCj - iendCj;

	Fbyr  = yr ;
	Fbdoy = bdoy ;
	Feyr  = yr ;
	Fedoy = edoy ;
        }

printf ("byr: %4d  bdoy: %3d  eyr: %4d  edoy: %3d\n", byr, bdoy, eyr, edoy) ;

    leap = isleap (byr) ;
    if ( byr != eyr )  edoy += 365 + leap ;
    Fleap = isleap (Fbyr) ;
    if ( Fbyr != Feyr )  Fedoy += 365 + Fleap ;

    if ( Fbyr <  byr )
	{
	file_yr = Fbyr ;
	flp = Fleap ; 
        bdoy += 365 + flp ;
        edoy += 365 + flp ;
        }
    else if ( Fbyr ==  byr )
	{
	file_yr = Fbyr ;
	flp = Fleap ;
	}
    else  /*  Fbyr >   byr */
	{
	file_yr = byr ;
	flp = leap  ; 
        Fbdoy += 365 + flp ;
        Fedoy += 365 + flp ;
        }

    last_doy = Fedoy > edoy ?  Fedoy : edoy ;

    flbdoy = bdoy + bfrac;
    fledoy = edoy + efrac;

printf ("flbdoy:  %f   fledoy: %f\n", flbdoy, fledoy) ;

    /*** Fill in the files names, checking naming convention. ***/

    while (--an)
	{
	sprintf ((char *) filenm, "%s", *(++av));

	w  = *filenm;		/* "w" points to beginning of the pathname. */
/*
 *	printf ("nmdates> w: %s\n", w) ;
 */
	/*** Locate the beginning of the filename within the pathname. ***/
	/*** [Find the last "/" character in pathname.] ***/

	islash = -1 ;
	for (ii = 0; ii < strlen (w); ii++)
	    {
	    if (*(w + ii) == '/') islash = ii ;
	    }

	w  += islash + 1 ;	/* "w" points to beginning of the filename. */

	printf ("nmdates> w: %s\n", w) ;

	/*** Check on the file naming convention used on the file ***/

	if ((*w == '0') || (*w >= '8' && *w <= '9'))	/* 2-digit year. */
	    {
	    if ( *(w + 3) >='0' && *(w + 3) <='9' )  doyflag++ ;
	    else                                     nameflag++ ;
	    }

	if (nameflag || doyflag) { dayflag++ ; timeflag = 1; }

	printf ("nameflag: %d  doyflag: %d  dayflag: %d  timeflag: %d\n",
	        nameflag, doyflag, dayflag, timeflag) ;

	chnme = 0;			/* channel number [N/A for Mk4]. */

	filenm++ ;
	numSfiles++ ;
        }

    return (numSfiles) ;
}

/* -------------------------------------------------------------------------- */

/*** isleap: true [1] if leap year, false [0] otherwise. ***/

/*
 * int
 * isleap ( i_year )
 *
 * int i_year ;
 * {
 *     return ( i_year%4 == 0 && i_year%100 != 0 || i_year%400 == 0 )  ;
 * }
 */

/* -------------------------------------------------------------------------- */

/*** Azimuthal scan using cylindrical pB image. ***/

int
fillsyarry (sbuf, pBim, fba, nn, rpix)

    short *sbuf;			/* Output azimuth array. */
    short *pBim;			/* Input image array. */
    float *fba;				/* Barrel Angle array pointer. */
    int nn;				/* X-axis dimension [pB image]. */
    int rpix;				/* radius index. */
{
    float *pfba;
    double tstang, PosA, fabs ();
    short *sy;
    int ii, jj;

    pfba = fba;
    sy = sbuf;

    for (ii = 0; ii < 360; ii++)	/* Azimuth Loop. */
	{
	PosA = (double) ii;
	pfba = fba;

	/*** Find barrel angle that matches desired angle within 0.5 deg. ***/
	/*** Copy pixel intensity into output array. ***/

	for (jj = 0; jj < nn; jj++)
	    {
	    tstang = (double) (*pfba) - PosA; /* Barrel Angle - Output Angle. */
	    pfba++;
	    if ( fabs (tstang) < 0.5 )		/* Angle within 0.5 degrees? */
		{
		*(sy + ii) = *(pBim + jj + nn * rpix);	/* pixel intensity. */
		break;
	        }
	    }
        }

    return (0) ;
}

/* -------------------------------------------------------------------------- */

/*** Return month & day, given the DOY & year. ***/

static int day_tab [2][13] =
    { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31,
      0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
    } ;

int
mon_day (doy, year, pmon, pday )

int doy, year, *pmon, *pday ;
{
    int ii, leap ;

    leap = year%4 == 0 && year%100 != 0 || year%400 == 0 ;

    for ( ii = 1 ; doy > day_tab [leap][ii] ; ii++ )
	doy -= day_tab [leap][ii] ;

    *pmon = ii ;
    *pday = doy ;
    return (0) ;
}

/* -------------------------------------------------------------------------- */

