/*  Compute the inverse X matrix and inverse Gain

    This code was written by Alice Lecinski, June 2001.

    I strongly suggest *not* editting this code at all, unless
    you are absolutely sure you've found an error that
    needs fixing.

    If you edit it, you risk destroying the integrity of the
    code.  So if you do edit it, insure results pre and post
    actually match.

*/
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <math.h>


#include "mk4v2.h"
#include "mk4headv2.h"
#include "telscp4v2.h"



int
ComputeInverse(Thd)     struct telhd *Thd; 
{
    int ii,jj;
    int isz;
    float mone;
    float Det, ovDet;
    float *pG;
    float *px21, *px22, *px23;
    float *px31, *px32, *px33;
    float  v21,   v22,   v23;
    float  v31,   v32,   v33;

    mone = -1.0;
    isz  = NAZ*NPX;

    fprintf(stderr,"\t\tComputing Inverse X matrix.\n");

    /*  These do not change for the inverse...
	Thd->x11 = 1.0;
	Thd->x12 = 0.0;
	Thd->x13 = 0.0;
    */

    px21 = Thd->x21a;    px22 = Thd->x22;    px23 = Thd->x23;
    px31 = Thd->x31a;    px32 = Thd->x32;    px33 = Thd->x33;


    for(jj=0;jj<NPX;jj++){
	ovDet = 0.;
	v22   = *px22;
	v23   = *px23;
	v32   = *px32;
	v33   = *px33;
	Det   = (v22*v33 - v23*v32);
	if(Det != 0.) ovDet = 1./Det;

	for(ii=0;ii<NAZ;ii++){
	    v21 = *px21;
	    v31 = *px31;
	    *px21 = ovDet*(v23*v31 - v21*v33);
	    *px31 = ovDet*(v21*v32 - v31*v22);
	    px21++;
	    px31++;
	}
	*px22 = ovDet*(v33);
	*px23 = ovDet*(v23)*mone;
	*px32 = ovDet*(v32)*mone;
	*px33 = ovDet*(v22);
	px22++;
	px23++;
	px32++;
	px33++;
    }



    Vover (Thd->Gain, isz);

    Im2AvgRadVect ( Thd->Gain, Thd->vgain,  NAZ, NPX);
    Im2AvgRadVect ( Thd->x21a, Thd->x21,    NAZ, NPX);
    Im2AvgRadVect ( Thd->x31a, Thd->x31,    NAZ, NPX);


}
