/* picsum.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Compute the sum of all of the pixels in a PICS image.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   14 December 1998
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "/home/stanger/lib/include/fitslib.h"

main (argc, argv)

int argc ;
char *argv [] ;

{
   extern char *rdfits () ;
   float imgsum ;
   short *img ;
   int ix, iy ;
   int nxbeg, nxend ;
   int nybeg, nyend ;
   int nx, ny ;
   int nbypix ;
   int pixcnt ;
   static char namimg [80] ;
   static char namlst [80] ;
   FILE *FD ;

   if (argc < 2)
      {
      fprintf (stdout, "usage: picsum fits_image_list\n") ;
      exit (0) ;
      }
   else
      strcpy (namlst, argv [1]) ;

   FD = fopen (namlst, "r") ;

   while (fscanf (FD, "%s", namimg) != EOF)
      {

      /*** Read FITS image. ***/

      img = (short *) rdfits (namimg) ;

      nx = naxis1 ;
      ny = naxis2 ;
      nbypix = bitpix / 8 ;
      nxbeg = 10 ;
      nxend = nx - 10 ;
      nybeg = 10 ;
      nyend = ny - 10 ;

      imgsum = 0.0 ;
      pixcnt = 0 ;
      for (iy = nybeg ; iy < nyend ; iy++) /* skip 1st line [binary header]. */
         for (ix = nxbeg ; ix < nxend ; ix++)
            {
            imgsum += *(img + ix + iy * nx) ;
	    pixcnt += 1 ;
            }

         fprintf (stdout, "%s   %10.4e   %8d\n", namimg, imgsum, pixcnt) ;
      free (img) ;
      }

   fclose (FD) ;
   exit (0) ;
}
