;+
; xcenfits.pro   IDL procedure
;
; PURPOSE
;	Read a FITS image and change the X center. 
;
; SYNTAX
;	xcenfits, 'fits_list', xcen
;
; PROCEDURES USED
;	readfits
;	writefits
;	fxaddpar
;
; HISTORY
;	Author: Andrew L. Stanger   16 October 1997
;-

pro xcenfits, fits_name, xcen

CLOSE, 1
OPENR, 1, fits_name

      img = readfits (fits_name, hdu)	; Read FITS image & header.

      ; -- Modify FITS header.

      fxaddpar, hdu, 'CRPIX1', xcen

      ; -- Write FITS image to disk.

      writefits, fits_name, img, hdu

CLOSE, 1

END
