/* pmhead.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Read prominence monitor header produced by Eikon digitizer.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

pmhead (namimg, hdrlen, xdim, ydim, xcenter, ycenter,
        year, doy, hrs, mins, secs, rad, ang)

char namimg []; 
int *hdrlen;
int *xdim, *ydim, *xcenter, *ycenter;
int *year, *doy, *hrs, *mins, *secs;
float *ang, *rad;

{
   extern char *malloc ();
   char *header;

   int hdrsiz = 1280;
   int imgfd;
   int n;
   int nread;

   /*** Open disk file and read image into memory. ***/

   if ((imgfd = open (namimg, 0)) <= 0)
      {
      fprintf (stderr, "***pmhead> Unable to open Pmon image: %s\n", namimg);
      exit (-1);
      }

   header = malloc (hdrsiz + 4);
   nread = read (imgfd, header, hdrsiz);
   close (imgfd);

   *(header + *hdrlen) = '\0';
   fprintf (stdout, "   pm header:\n   %s\n", header);

   /*** Extract information from Prominence monitor header. ***/

   sscanf (header + 15, "%3d", hdrlen);
   sscanf (header + 24, "%2d", year);
   sscanf (header + 31, "%3d", doy);
   sscanf (header + 38, "%2d", hrs);
   sscanf (header + 45, "%2d", mins);
   sscanf (header + 52, "%2d", secs);
   sscanf (header + 60, "%3d", xdim);
   sscanf (header + 69, "%3d", ydim);
   sscanf (header + 81, "%3d", xcenter);
   sscanf (header + 93, "%3d", ycenter);
   sscanf (header + 104, "%f", rad);
   sscanf (header + 116, "%f", ang);

   fprintf (stdout, "hdrlen: %d\n", *hdrlen);
   fprintf (stdout, "GMT: 19%02d %03d %02d:%02d:%02d\n",
            *year, *doy, *hrs, *mins, *secs);
   fprintf (stdout, "xdim: %d   ydim: %d   ", *xdim, *ydim);
   fprintf (stdout, "xcenter = %d   ", *xcenter);
   fprintf (stdout, "ycenter = %d\n", *ycenter);
   fprintf (stdout, "radius = %g   ", *rad);
   fprintf (stdout, "offang = %g\n", *ang);

   free (header);
   return (0);
}
