/* pmw.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Display Prominence Monitor image in SGI GL window.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 14 February 1992
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include <gl/gl.h>
#include <device.h>
#include <fmclient.h>

main (argc, argv)

int argc ;
char *argv [] ;
{
   int pmhead () ;

   static char nampgm [80] ;
   static char namepm [80] ;
   static char pmontime [12] ;
   static char dir2 [4] = "ru" ;

   int ierr ;
   int hdrsiz = 0 ;
   int mapoff = 512 ;				/* Color map offset. */
   int pmcx, pmcy ;
   int pmdx, pmdy ;
   int pmyr, pmdoy ;
   int pmhr, pmmin, pmsec ;
   int nbypx = 1 ;
   int xll, xur, yll, yur ;

   float pmang ;
   float pmrad ;
   float pmpxrs ;

   strcpy (nampgm, argv [0]) ;
   if (argc == 2)
      strcpy (namepm, argv [1]) ;
   else
      {
      fprintf (stderr, "usage: %s pmon_image\n", argv [0]) ;
      exit (0) ;
      }

   fprintf (stdout, "<--Read Pmon image.\n") ;
   pmhead (namepm, &hdrsiz, &pmdx, &pmdy, &pmcx, &pmcy,
           &pmyr, &pmdoy, &pmhr, &pmmin, &pmsec, &pmrad, &pmang) ;

   if (pmdx <= 1270)  xur = 1270 ; else xur = 1279 ;
   if (pmdy <=  995)  yur =  995 ; else yur = 1023 ;
   xll = xur - pmdx + 1 ;
   yll = yur - pmdy + 1 ;

   foreground () ;
   fminit () ;			/* Initialize SGI font manager. */
   prefposition (xll, xur, yll, yur) ;
   winopen (nampgm) ;

   gl_wclear (BLACK) ;

   /*** Invoke function to transfer image into GL window. ***/

   fprintf (stdout, "Displaying image: %s\n", namepm) ;
   if ((ierr = glimg_view (namepm, hdrsiz, nbypx, pmdx, pmdy, dir2, mapoff)) < 0)
      {
      fprintf (stderr, "glimg_view error: %d\n", ierr) ;
      exit (-1) ;
      }

   /*** Window remains on screen until terminated by mouse. ***/

   qdevice (ESCKEY) ;
   qdevice (WINCLOSE) ;
   qdevice (WINQUIT) ;
   for ( ; ; )
      {
      short val ;
      switch (qread (&val))
         {
         case REDRAW:
            glimg_view (namepm, hdrsiz, nbypx, pmdx, pmdy, dir2, mapoff) ;
            break ;
         case ESCKEY:
         case WINCLOSE:
         case WINQUIT:
            gexit () ;
            exit (0) ;
         }
      }
}
