#!/opt/local/bin/perl

use strict;
use DBI;
use Time::JulianDay;
use mlso_navbar;
use mlso;

my $images = "http://download.hao.ucar.edu/d5/www/images";
my $styles = "http://download.hao.ucar.edu/d5/www/styles";
my $rootdir = $ENV{DOCUMENT_ROOT};

my $me = "mlso_data.cgi";
my $href = "mlso_datasum.cgi";

my $tmp = $ENV{QUERY_STRING};
my @query = split(/&/,$tmp);
my $year = $query[0];
my $inst = $query[1];
my $month;
my $logdir = "http://download.hao.ucar.edu/d5/mlso/log/observer/$year";
my @filestats = stat "mlso_data.cgi";
my @gm_arr = localtime($filestats[9]);
my $create_str = sprintf("%02d/%02d/%02d %02d:%02d:%02d",
        $gm_arr[4]+1,$gm_arr[3],$gm_arr[5]-100,$gm_arr[2],$gm_arr[1],$gm_arr[0]);

my $dbh = DBI->connect("DBI:mysql:ACOS:hao",'acos','generic');
sub getcolor;

#================================================================================
# The following segment redirects the user to the old webpage
# when requesting MKIII and MKIII synoptic maps.  I'll have
# to incorporate this data to our site later.
#================================================================================
#if ($inst eq "MKIII"){
#print <<END_OF_PAGE;
#Content-Type: text/html

#<html>
#<head>
#<meta HTTP-EQUIV="refresh"
#content="0;URL=http://mlso.hao.ucar.edu/mk3ftptree.html">
#</head>
#</html>
#END_OF_PAGE
#exit();
#}

if ($inst eq "SYNOPTIC"){
print <<END_OF_PAGE;
Content-Type: text/html

<html>
<head>
<meta HTTP-EQUIV="refresh"
content="0;URL=http://mlso.hao.ucar.edu/data_archive.html">
</head>
</html>
END_OF_PAGE
exit();
}
#================================================================================ 
# End of segment redirecting user to old site.
#================================================================================

print <<END_OF_PAGE;
Content-type: text/html

<html>
<head>
<title>Available $inst Data for $year</title> 

<link rel="stylesheet" type="text/css"
href="$styles/mlsohome.css" />

END_OF_PAGE

PrintJavaScript();
PrintACOSbar("mlso_banner3.sml.gif");

my %yrselected = ('2006',"",'2005',"",'2004',"",'2003',"", 
'2002',"",'2001',"",'2000',"",'1999',"",'1998',"",'1997',"",
'1996',"",'1995',"",'1994',"", '1993',"",'1992',"",'1991',"",
'1990',"",'1989',"",'1988',"",'1987',"",'1986',"",'1985',"", 
'1984',"",'1983',"",'1982',"",'1981',"",'1980',"");
$yrselected{$year} = "selected";
my %instselected = ('ACOS',"",'PICS',"",'CHIP',"",'MKIV',"",'MKIII',"",'MK3SynopticMaps',"");
$instselected{$inst} = "selected";

print <<END_OF_PAGE;

<div align="center">
<img src='$images/caltext.gif'>
</div>
<form name="myform">
<select name= "myyear" onChange='location = "$me?"+document.myform.myyear.options[document.myform.myyear.selectedIndex].value+"&"+document.myform.myinst.options[document.myform.myinst.selectedIndex].value'>
  <option value="2006" $yrselected{2006}>2006
  <option value="2005" $yrselected{2005}>2005
  <option value="2004" $yrselected{2004}>2004
  <option value="2003" $yrselected{2003}>2003
  <option value="2002" $yrselected{2002}>2002
  <option value="2001" $yrselected{2001}>2001
  <option value="2000" $yrselected{2000}>2000
  <option value="1999" $yrselected{1999}>1999
  <option value="1998" $yrselected{1998}>1998
  <option value="1997" $yrselected{1997}>1997
  <option value="1996" $yrselected{1996}>1996
  <option value="1995" $yrselected{1995}>1995
  <option value="1994" $yrselected{1994}>1994
  <option value="1993" $yrselected{1993}>1993
  <option value="1992" $yrselected{1992}>1992
  <option value="1991" $yrselected{1991}>1991
  <option value="1990" $yrselected{1990}>1990
  <option value="1989" $yrselected{1989}>1989
  <option value="1988" $yrselected{1988}>1988
  <option value="1987" $yrselected{1987}>1987
  <option value="1986" $yrselected{1986}>1986
  <option value="1985" $yrselected{1985}>1985
  <option value="1984" $yrselected{1984}>1984
  <option value="1983" $yrselected{1983}>1983
  <option value="1982" $yrselected{1982}>1982
  <option value="1981" $yrselected{1981}>1981
  <option value="1980" $yrselected{1980}>1980
</select>

<select name="myinst" onChange='location = "$me?"+document.myform.myyear.options[document.myform.myyear.selectedIndex].value+"&"+document.myform.myinst.options[document.myform.myinst.selectedIndex].value'>
  <option value="ACOS" $instselected{ACOS}>ALL
  <option value="PICS" $instselected{PICS}>PICS (H-Alpha)
  <option value="CHIP" $instselected{CHIP}>Chip (He 10830nm)
  <option value="MKIV" $instselected{MKIV}>MK4  (White Light)
  <option value="MKIII" $instselected{MKIII}>MK3 (White Light)
  <option value="SYNOPTIC" $instselected{MK3SynopticMaps}>MK3 Synoptic Maps
</select>

</form>

<H1 class="datatitle">Available $inst Data for $year</H1>

<table class="calendar" border=4 align="center">
END_OF_PAGE

  print "<TH colspan = 7 bgcolor=\"\#33ff33\">All datasets available</TH>
  <TD></TD>
  <TH colspan = 7 BGCOLOR=\"yellow\">Some instruments offline</TH>
  <TD></TD>
  <TH colspan = 7 bgcolor=\"red\">No data available</TH>";

#
# Run unix cal command on one year and parse the
#	output.  Need to turn each day into
#	a link that points to available
#	data.
# If cal ever changes it's output, this code
#	will break.
#
my $weekline = 1;
open(CAL, "/usr/bin/cal $year |");
while (<CAL>){
    my $tag;
    my $endtag;
    my $bgcolor;
    my @data = ();
    my $i;

    if (($. == 1) || ($. == 2) || ($. == 3)) { print ""; next; } #Ignore first three lines

    print "<TR>";
    # Grab the 
    if (/^Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec$/) {
      s/^\s*(.*?)\s*$/$1/;            ## trim whitespace
      $tag= "TH colspan=8"; $endtag="TH";
      @data = split(/\s+/, $_);
      #$bgcolor = "teal";
      $bgcolor = "#ccccff";
    } elsif (/$year/) {		      # Deal with year title
      s/^\s*(.*?)\s*$/$1/;            ## trim whitespace
      $tag= "TH colspan=23"; $endtag="TH";
      @data = split(/\s+/, $_);
      #$bgcolor = "teal";
    } elsif (/^S|M|Tu|W|Th|F|S$/) {   # Deal with week headers
      $weekline = $.;
      s/^\s*(.*?)\s*$/$1/;            ## trim whitespace
      $tag = "TD"; $endtag="TD";
      #$bgcolor = "teal";
      @data = split(/\s+/, $_);
    } elsif (($. % 8) == 0){         # This is the first row of each month
     @data = split(/\s{2,3}/, $_);
     $tag = "TD"; $endtag="TD";
     foreach (@data){
        s/^\s*(.*?)\s*$/$1/;            ## trim whitespace
     }
     #$bgcolor=getcolor($year,7,11);
    } else { 
      if ($. == ($weekline+2)){  # This is the second row of each month
        s/^\s*(.*?)\s*$/$1/;            ## trim whitespace
        $tag = "TD"; $endtag="TD";
        @data = split(/\s+/, $_);
      } elsif ($. == ($weekline+3)){ # Third row
        s/^\s*(.*?)\s*$/$1/;	     # trim whitespace
        $tag = "TD"; $endtag="TD";
        @data = split(/\s+/, $_);
      } elsif ($. == ($weekline+6)){ #Last row of each month.
        @data = split(/\s{1,3}/, $_); #Trim whitespace and cut down line
					#size by 1/3
	splice(@data, 4,1);		# Cut out one space in first month
	splice(@data, 10,1);		# Cut out one space in second month
        $tag = "TD"; $endtag="TD";	# All done
      } else { 				# Everything else
	@data=split(/\s{1,3}/,$_);
      }
      $tag = "TD"; $endtag="TD"; 
      #$bgcolor=getcolor($year,7,11);
    } 

    #
    # Print out the @data gathered above
    #
      #print "<pre>@data</pre>";
      #print "<pre>$data[0]</pre>";
      if ($. <= 13){  # Jan Feb Mar
	$month = 1;
      } elsif (($. > 13) && ($. < 22)){ # Apr May Jun
	$month = 4;
      } elsif (($. > 22) && ($. < 30)){  # Jul Aug Sep
	$month = 7;
      } else { # Oct Nov Dec
	$month = 10;
      }
    for $i (0 .. $#data) { 
      if ((($i % 7) == 0) && ($i > 0)){ #print space between months and
	$month++; 			#increment $month
	print "<TD></TD>";
      }  
      $bgcolor=getcolor($year,$month,$data[$i],$inst);
      print "<$tag BGCOLOR=\"$bgcolor\")><a href=$href?$year&$month&$data[$i]&$inst>$data[$i]</a></$endtag>";
    }
    print "</TR>\n";

}
close(CAL);
$dbh->disconnect;

print <<END_OF_PAGE;
</table>

<div align="center">
<img src='$images/ncartext.gif'>
</div>

<address>
<p>Webpage written and maintained by: <br>
<a href="mailto:tdarnell\@ucar.edu">Tony Darnell</a> <br>
Last modified:  $create_str
</p>
</address>

</body> 
</html>

END_OF_PAGE

sub getcolor{

  my $year = $_[0];
  my $month = $_[1];
  my $day = $_[2];
  my $inst = $_[3];
  my $bgcolor = "white";
  my $doy;
  my $tdoy;

  my $julday = julian_day($year,$month,$day);
  my $today =julian_day((localtime)[5]+1900,(localtime)[4]+1,(localtime)[3]);
  my $timediff = $today - $julday;

  if ($day =~ /^Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec$/){
    #return $bgcolor = "teal";
    return $bgcolor = "#ccccff";
  } elsif ($day == $year) {
    #return $bgcolor = "teal";
    return $bgcolor = "#ccccff";
  } elsif ($day =~ /^S|M|Tu|W|Th|F|S$/){
    #return $bgcolor = "teal";
    return $bgcolor = "#ccccff";
  } else {
    $doy = julian_day($year,$month,$day)-julian_day($year-1,12,31);
    $tdoy = julian_day((localtime)[5]+1900,(localtime)[4]+1,(localtime)[3]) -
	    julian_day($year-1,12,31);
  }

  return if (! $day);

  my $yrddoy = sprintf("%dd%03d",$year,$doy);
  my $date_str = "$year-$month-$day";

  if ($doy >= $tdoy){return $bgcolor="white";}

  # Now sort them out
  if ($inst eq "ACOS"){
    #my $query = "select * from tbl_numfiles where NUM_ID='$date_str'";
    my $query = "select num_chip_int,NUM_PICS_DISK,NUM_PICS_ASC,NUM_MK4_CPB,NUM_MK4_RPB,NUM_MK4_RPB_VIG,NUM_MK3_CPB,NUM_MK3_RPB,NUM_MK3_RPB_VIG from tbl_numfiles where NUM_ID='$date_str'";
    my $sth = $dbh->prepare($query);
    $sth ->execute();
    my ($numchiptimes,$numpicstimes,$numasc,$numcpb,$numrpb,$numvig,$nummk3c,$nummk3r,$nummk3rv) = $sth->fetchrow_array();
      if ($numchiptimes && ($numpicstimes || $numasc) && (($nummk3c || $nummk3r || $nummk3rv) || ($numcpb || $numrpb || $numvig))){
        #$bgcolor = "green";
        $bgcolor = "#33ff33";
      } elsif ($numchiptimes || $numpicstimes || $numasc || $numcpb || $numrpb || $numvig || $nummk3r || $nummk3rv || $nummk3c){
        $bgcolor = "yellow";
      } else {$bgcolor = "red";}
  } elsif ($inst eq "CHIP") {
    my $query = "select NUM_CHIP_INT from tbl_numfiles where NUM_ID='$date_str'";
    my $sth = $dbh->prepare($query);
    $sth ->execute();
    my $numchiptimes = $sth->fetchrow();
    if ($numchiptimes){ $bgcolor = "#33ff33";} else {$bgcolor = "red";}
  } elsif ($inst eq "PICS") {
    my $query = "select NUM_PICS_DISK from tbl_numfiles where NUM_ID='$date_str'";
    my $sth = $dbh->prepare($query);
    $sth ->execute();
    my $numpicstimes = $sth->fetchrow();
    if ($numpicstimes){ $bgcolor = "#33ff33";} else {$bgcolor = "red";}
  } elsif ($inst eq "MKIV") {
    my $query = "select NUM_MK4_CPB from tbl_numfiles where NUM_ID='$date_str'";
    my $sth = $dbh->prepare($query);
    $sth ->execute();
    my $nummk4 = $sth->fetchrow();
    if ($nummk4){ $bgcolor = "#33ff33";} else {$bgcolor = "red";}
  } elsif ($inst eq "MKIII") {
    my $query = "select NUM_MK3_CPB from tbl_numfiles where NUM_ID='$date_str'";
    my $sth = $dbh->prepare($query);
    $sth ->execute();
    my $nummk3 = $sth->fetchrow();
    if ($nummk3){ $bgcolor = "#33ff33";} else {$bgcolor = "red";}
  }


  return $bgcolor;

}

