#!/opt/local/bin/perl

use strict;
use CGI;
use DBI;
use Cwd;
use Date::EzDate;
$|=1;

my ($year,$mon,$day,$inst,$wavelength,$type,$quality,$cal,$processing,
	$date_str,$sth,$query);
my ($nextyear,$nextmon,$nextday,$nextdy,$nextdaystr,$todaystr);
my ($basedir,$basedirp1,@files,$f,@fileholder);
my (@temp,@tmp);
my $q = new CGI;

my %instruments = ('CHIP',"chp",'PICS',"dpm",'MKIV',"mk4");
my %qualities = ('BEST',"A",'GOOD',"G",'AVG',"G",'BAD',"B",'UGLY',"U");

$year = $q->param('year');
$mon =	sprintf("%02d",$q->param('mon'));
$day =	sprintf("%02d",$q->param('day'));
$todaystr = "$year$mon$day";
$date_str = "$year-$mon-$day";
$inst = $q->param('inst');
$wavelength = $q->param('wavelength');
$quality = $q->param('quality');
$processing = $q->param('processing');
$query = $q->param('query');
$type = $q->param('download_but');
$type = (split(/ /, $type))[1];

# Calculate the next calendar day.
my $nextday = Date::EzDate->new();
$nextday->{'month number base 1'} = $mon;
$nextday->{'year'} = $year;
$nextday->{'day of month'} = $day;
$nextday->{'epochday'}++;
$nextyear = sprintf("%02d",$nextday->{'year'});
$nextmon = sprintf("%02d",$nextday->{'month number base 1'});
$nextdy = sprintf("%02d",$nextday->{'day of month'});
$nextdaystr = sprintf("%d%02d%02d",$nextyear,$nextmon,$nextdy);

if ($type eq 'jpegs'){
  $type = 'jpg';
  chdir ("/toshi/ftp/$year/$mon/$day");
  $basedir = cwd();
  chdir ("/toshi/ftp/$nextyear/$nextmon/$nextdy");
  $basedirp1 = cwd();
} else {
  $type = 'fts';
  $basedir = 
	"/var/spool/http/projects/mlso/htdocs/archive/acos/$year/$mon/$day";
  $basedirp1 =
	"/var/spool/http/projects/mlso/htdocs/archive/acos/$nextyear/$nextmon/$nextdy";
}

# Parse the $wavelength variable more completely
$cal = 'cal';
if ($inst eq "MKIV"){
  if ($wavelength eq "cpb"){
    if ($quality eq 'AVG'){$cal = 'avg';}
  } elsif ($wavelength eq "rpb"){
    $cal = 'vig';
    if ($quality eq 'AVG'){$cal = 'avg';}
  }
} elsif ($inst eq "PICS"){
  if ($wavelength eq "alr"){
    $cal = 'raw';
  } elsif ($wavelength eq 'asl'){
    $cal = 'ldc';
  }
}

$inst = $instruments{$inst};

#
# Connect to database
#
my %attr = (RaiseError => 1);
my $dbh = DBI->connect("DBI:mysql:ACOS:hao",'acos','generic');

   $sth = $dbh->prepare($query);
   $sth ->execute();
   while (my @tmp = $sth->fetchrow_array()){
     push @files, @tmp;
   }

$dbh->disconnect;

#print "Content-Type:text/html\n\n";
#
#  This foreach loop determines calendar day of image and
#  sets the correct flags to the tar command.  -C tells
#  tar to go to that directory.  It needs to preceed every 
#  filename on a Sun system, this isn't necessary on a Linux
#  box.
#  for Linux:
#  tar cf - -C $basedir @todaysfiles -C $basedirp1 @tomorrow
#  for Sun:
#  tar cf - -C $basedir file1 -C $basedir file2 ... -C $basedirp1 filennn
#
#print "$query";
my $numfiles = @files;
chdir ($basedir);
my $size = (stat($files[0]))[7];
my $filesize = $size * $numfiles;
#print "$filesize $size $numfiles\n";
foreach (@files){
  if (grep {/$nextdaystr/} $_){
    s?^?-C $basedirp1 ?;
  } else {
    s?^?-C $basedir ?;
  }
}
my @todaysfiles = grep {/$todaystr/} @files;
my @tomorrow    = grep {/$nextdaystr/} @files;

print "Content-Type:application/x-download\n";
print "Content-Disposition:attachment;filename=$year$mon$day.$inst.$wavelength.$processing.$type.tar;size=$filesize;\n\n";
open (TAR, "tar cf - @todaysfiles @tomorrow |");
while (<TAR>){
  print $_;
}
close(TAR);
