#!/opt/local/bin/perl

#
# This cgi script will search the data on
#   toshi and return the requested filenames
#   along with their full pathname.
#

use strict;
use CGI;
use DBI;
use Cwd;
use Time::JulianDay;
use Date::EzDate;
use mlso_navbar;
use mlso;

my $images = "http://download.hao.ucar.edu/d5/www/images";
my $styles = "http://download.hao.ucar.edu/d5/www/styles";
my $q = new CGI;
my ($year,$mon,$day,$inst,$wavelength,$image_type,$doy,$yrddoy,$YRDDOY,
	$quality,$cal,$cal2,$date_str,$nextyear,$nextday,$nextmon,$nextdy,
	$todaystr,$nextdaystr, $sth,$query,$there,@tmp,$todaysdir);
my ($filestr,$numfiles);
my @filestats = stat "mlso_getdata.cgi";
my @gm_arr = localtime($filestats[9]);
my $create_str = sprintf("%02d/%02d/%02d %02d:%02d:%02d",
      $gm_arr[4]+1,$gm_arr[3],$gm_arr[5]-100,$gm_arr[2],$gm_arr[1],$gm_arr[0]);

my %instruments = ('CHIP',"chp",'PICS',"dpm",'MKIV',"mk4",'MK3','mk3');

$year = $q->param('year');
$mon =  sprintf("%02d",$q->param('mon'));
$day =  sprintf("%02d",$q->param('day'));
my $tempstr = $q->param('search_str');
my @temp = split(/ /,$tempstr);
$quality = uc($temp[0]);
$inst = $temp[1];
$wavelength = $temp[2];
my $movie = lc($temp[3]);
$date_str = "$year-$mon-$day";
$todaystr = sprintf("%d%02d%02d",$year,$mon,$day);

# Calculate the next calendar day.
my $nextday = Date::EzDate->new();
$nextday->{'month number base 1'} = $mon;
$nextday->{'year'} = $year;
$nextday->{'day of month'} = $day;
$nextday->{'epochday'}++;
$nextyear = sprintf("%02d",$nextday->{'year'});
$nextmon = sprintf("%02d",$nextday->{'month number base 1'});
$nextdy = sprintf("%02d",$nextday->{'day of month'});
$nextdaystr = sprintf("%d%02d%02d",$nextyear,$nextmon,$nextdy);

# Parse the $wavelength variable more completely
$cal = 'cal'; 
if (($inst eq "MKIV") | ($inst eq "MK3")){
  if ($wavelength eq "Polar"){
    $wavelength = 'cpb';
    $cal2 = 'avg';
    if ($quality eq 'AVG'){$cal = 'avg';}
  } elsif ($wavelength eq "Rectangular"){
    $wavelength = 'rpb';
    $cal2 = 'avg';
    if ($quality eq 'AVG'){$cal = 'avg';}
  } elsif ($wavelength eq 'Vignetted') {
    $wavelength = 'rpb';
    $cal = 'vig';
    $cal2 = 'vav';
    if ($quality eq 'AVG'){$cal = 'vav';}
  }
} elsif ($inst eq "PICS"){
  if ($wavelength eq "Disk"){
    $wavelength = 'asl';
    $cal = 'ldc';
  } elsif ($wavelength eq 'Corrected'){
    $wavelength = 'asc';
  } elsif ($wavelength eq 'Limb'){
    $wavelength = 'alr';
    $cal = 'raw';
  }
} elsif ($inst eq "CHIP"){
  if ($wavelength eq "Intensity"){
    $wavelength = 'hsh';
  } elsif ($wavelength eq 'Velocity'){
    $wavelength = 'bsh';
  }
}

my $logdir = "/puu/f/cordyn/DATA_BASE";
my $basedir = "/toshi/ftp";

my %qualities = ('BEST',"A",'GOOD',"G",'BAD',"B",'UGLY',"U",'AVG',"G");
my %logs = ('CHIP',"chiasLogs",'PICS',"pciasLogs",'MKIV',"midx");
my (@files,@nextdayfiles,$here,$month,$logpath, @bestname);

if ($movie eq "movie"){ 

  $quality = $wavelength eq 'alr' ? 'GOOD' : 'ALL';

print <<DONE;
Content-type: text/html


<html>
<head>
<meta HTTP-EQUIV="refresh"
content="0;URL=http://mlso.hao.ucar.edu/cgi-bin/mlso_animate.cgi?year=$year&mon=$mon&day=$day&inst=$inst&wavelength=$wavelength&quality=$quality">
</head>
</html>
DONE
exit();
}

#
# Connect to database
#
my %attr = (RaiseError => 1);
my $dbh = DBI->connect("DBI:mysql:ACOS:hao",'acos','generic');

# if quality = "ALL" then we return all data for that day

if ($quality eq "ALL"){
  if ($inst eq "MKIV"){
   $query = "select FILE_NAME from tbl_$year where DATETIME_OBS BETWEEN '$date_str 12:00:00' AND DATE_ADD('$date_str 12:00:00', INTERVAL 1 day) AND INSTRUMENT = '$instruments{$inst}' AND WAVE_LENGTH='$wavelength' AND (PROCESSING='$cal' OR PROCESSING='$cal2')";
  } else {
   $query = "select FILE_NAME from tbl_$year where DATETIME_OBS BETWEEN '$date_str 12:00:00' AND DATE_ADD('$date_str 12:00:00', INTERVAL 1 day) AND INSTRUMENT = '$instruments{$inst}' AND WAVE_LENGTH='$wavelength' AND PROCESSING='$cal'";
  }
} else {
   $query = "select FILE_NAME from tbl_$year where DATETIME_OBS BETWEEN '$date_str 12:00:00' AND DATE_ADD('$date_str 12:00:00', INTERVAL 1 day) AND INSTRUMENT = '$instruments{$inst}' AND WAVE_LENGTH='$wavelength' AND QUALITY='$qualities{$quality}' AND PROCESSING='$cal'";
}
   $sth = $dbh->prepare($query);
   $sth ->execute();
   while (my @tmp = $sth->fetchrow_array()){
     push @files, @tmp;
   }

   chdir "/toshi/ftp/$year/$mon/$day";
   $here = cwd();
   @tmp = split("/",$here);
   $todaysdir = join("/",@tmp[3..6]);

   # put in pathname info for href tag
   foreach my $t (@files){
     if ($t =~ m/$nextdaystr/){
       @tmp = split("/",$todaysdir);
       $tmp[1]= $nextyear;
       $tmp[2]= $nextmon;
       $tmp[3]= $nextdy;
       $there = join("/",@tmp[0..3]);
     } else {
	 $there = $todaysdir;
     }
     if ($t =~ m/jpg/){
       $here = "http://download.hao.ucar.edu/" . $there;
     } else {
       if ($quality eq 'BEST'){
         $here = "http://download.hao.ucar.edu/" . $there;
       } else {
         if ($t =~ m/$nextdaystr/){
           $here = "http://mlso.hao.ucar.edu/archive/acos/$nextyear/$nextmon/$nextdy";
         } else {
           $here = "http://mlso.hao.ucar.edu/archive/acos/$year/$mon/$day";
         }
       }
     }
     $t =~  s/^/$here\//;
   }

$numfiles = @files;
my @jpegs = sort(grep(/jpg/, @files));
my @fits = sort(grep(/fts/, @files));
#sort(rindex(@jpegs,"/")+1);
#sort(rindex(@fits,"/")+1);
my $numjpegs = @jpegs;
my $numfits = @fits;
my $jpegstr = join '&',@jpegs;
my $fitsstr = join '&',@fits;

#
#  Create the HTML page with file listing.
#
print <<END_OF_PAGE;
Content-type: text/html

<html>
<head>
<title>$inst Data Search Results</title>

<link rel="stylesheet" type="text/css"
href="$styles/mlsohome.css" />


END_OF_PAGE

PrintJavaScript();
PrintACOSbar("mlso_banner3.sml.gif");
print "<H1 class = \"datatitle\">$inst Data Search Results</h1>";

print <<END_OF_PAGE;
<br>
<form name="myform" method="GET" action="mlso_animate.cgi">
<input type="hidden" name="year" value = "$year">
<input type="hidden" name="mon"  value = "$mon">
<input type="hidden" name="day"  value = "$day">
<input type="hidden" name="inst"  value = "$inst">
<input type="hidden" name="wavelength"  value = "$wavelength">
<input type="hidden" name="quality"  value = "$quality">
<input type="submit" name="animate_but" value="Animate jpegs">
</form>
<form name="myform" method="GET" action="mlso_download.cgi">
<input type="hidden" name="year" value = "$year">
<input type="hidden" name="mon"  value = "$mon">
<input type="hidden" name="day"  value = "$day">
<input type="hidden" name="inst"  value = "$inst">
<input type="hidden" name="wavelength"  value = "$wavelength">
<input type="hidden" name="quality"  value = "$quality">
<input type="hidden" name="processing"  value = "$cal">
<input type="hidden" name="query"  value = "$query">
<input type="submit" name="download_but" value="Download jpegs">
<input type="submit" name="download_but" value="Download fits">
</form>

<br>
<li>There were $numfits fits files and $numjpegs jpg files returned for this search.</li>
<li>Please click on the filename to view or shift-click to download individual images.</li>
<liUse the buttons above to download or animate all images listed below.</li>
<li>Pressing the download buttons will tar all listed files and send them to you.  </li>
<li>Depending on your browser, you may need to enter a new filename in the 
browser's download dialog box. </li>
<br>
<i class="red">Note to PC users:  WINZIP will handle tarred and gzip compressed files.</i>
<br>
<br>

END_OF_PAGE

if (($numfits == 0) && ($numjpegs ==0)){
print <<DONE

<br>
<p>
<b>
This data could not be found on our ftp server.  If the data calendar indicated that
there was data, <br>then please email <a href=mailto:mlso_data_requests.ucar.edu> Data Requests
</a> to request that the data be put on.  It is also possible that the data <br>taken today was
not good due to weather or instrument problems.  You can verify this by looking at <br>
<a href=http://download.hao.ucar.edu/d5/mlso/log/observer/$year/mlso.$YRDDOY.olog>Today's
Observer Log</a>.
<br><br>
</b>
</p>
<br>

DONE

}

my ($i,$f,$t);

$i = 0;
foreach $f ($#fits >= $#jpegs ? @fits : @jpegs){
  my $j = ($#fits < $#jpegs ? $fits[$i] : $jpegs[$i]);
  my $l = substr($f, rindex($f,"/")+1);  #extract the filename from full path.
  my $m = substr($j, rindex($j,"/")+1);  #extract the filename from full path.
  #print "<a href=$f><tt>$l</tt></a>&nbsp&nbsp&nbsp&nbsp";
  print "<a href=$f><tt>$l</tt></a>&nbsp&nbsp&nbsp&nbsp";
  print "<a href=$j><tt>$m</tt></a><br>";
  $i++;
}

print <<DONE;
<address>
<p>Webpage written and maintained by: <br>
<a href="mailto:tdarnell\@ucar.edu">Tony Darnell</a> <br>
Last modified:  $create_str
</p>
</address>
DONE

print "</body>\n";
print "</html>\n";
$dbh->disconnect;

