#!/opt/local/bin/perl

#
# This cgi script will search the data on
#   toshi and return the requested filenames
#   along with their full pathname.
#

use strict;
use Cwd;
use Time::JulianDay;
use Date::EzDate;
use mlso_navbar;

#my $base = "http://hao.ucar.edu/internal/cgi-bin";
my $base = "http://mlso.hao.ucar.edu/cgi-bin";
my $images = "http://download.hao.ucar.edu/d5/www/images";
my $styles = "http://download.hao.ucar.edu/d5/www/styles";
my $query = $ENV{QUERY_STRING};
my @query = split(/&/,$query);
my $numargs = @query;
my $getdata_cmnd="$base/mlso_getdata.cgi";
my ($year,$mon,$day,$inst,$wavelength,$image_type,$doy,$yrddoy);
#my ($yearsearch, $monthsearch, $daysearch,$filestr,$searchstr);
my ($yearsearch, $monthsearch, $daysearch,$filestr,$numfiles);
my @filestats = stat "mlso_getmovie.cgi";
my @gm_arr = localtime($filestats[9]);
my $create_str = sprintf("%02d/%02d/%02d %02d:%02d:%02d",
        $gm_arr[4]+1,$gm_arr[3],$gm_arr[5]-100,$gm_arr[2],$gm_arr[1],$gm_arr[0]);

sub getimgs;

  $year       = $query[0];
  $mon        = $query[1];
  $day        = $query[2];
  $inst       = $query[3];
  $wavelength = $query[4];
  $image_type = $query[5];
  $doy	= julian_day($year,$mon,$day) - julian_day($year-1,12,31);
  $yrddoy = sprintf("%02dd%03d",substr($year,2,2),$doy);

# Calculate the next calendar day.
my $nextday = Date::EzDate->new();
$nextday->{'month number base 1'} = $mon;
$nextday->{'year'} = $year;
$nextday->{'day of month'} = $day;
$nextday->{'epochday'}++;

my $logdir = "/puu/f/cordyn/DATA_BASE";
my $basedir = "/toshi/ftp";

my @months =("01_jan","02_feb","03_mar","04_apr","05_may",
	     "06_jun","07_jul","08_aug","09_sep","10_oct","11_nov","12_dec");

my @mons = ("Jan","Feb","Mar","Apr","May","Jun",
		"Jul","Aug","Sep","Oct","Nov","Dec");

my %instruments = ('CHIP',"chp",'PICS',"dpm",'MKIV',"mk4");
my %logs = ('CHIP',"chiasLogs",'PICS',"pciasLogs",'MKIV',"midx");
my (@files,@nextdayfiles,$here,$month,$logpath,@bestname,$processed);

if ($inst ne "MKIV"){
  $logpath = "$logdir/$logs{$inst}";
  $processed = open(LOGFILE,"< $logpath/$yrddoy.log");
  close (LOGFILE);
} else {
  $logpath = "/puu/f/cordyn/mk4_best/$year";
  $processed = open(LOGFILE,"< $logpath/$yrddoy.gbu");
  close (LOGFILE);
}

#
#  I'm getting a list of the latest animated gifs made in Hawaii to
#	show people if data hasn't been processed yet.
#
my @mk4movies = </toshi/ftp/d5/mk4/raw_daily_image/*mov.gif>;
my @chipmovies = </toshi/ftp/d5/chip/raw_daily_image/*mov.gif>;
my @picsmovies = </toshi/ftp/d5/dpm/raw_daily_image/*mov.gif>;

my @tmp;
my @chipmovienames=("","","");
@tmp = split("/",$chipmovies[$# - 2]);
$chipmovienames[0] = $tmp[$# - 1];
@tmp = split("/",$chipmovies[$# - 3]);
$chipmovienames[1] = $tmp[$# - 1];
@tmp = split("/",$chipmovies[$# - 4]);
$chipmovienames[2] = $tmp[$# - 1];

my @mk4movienames=("","","");
@tmp = split("/",$mk4movies[$# - 2]);
$mk4movienames[0] = $tmp[$# - 1];
@tmp = split("/",$mk4movies[$# - 3]);
$mk4movienames[1] = $tmp[$# - 1];
@tmp = split("/",$mk4movies[$# - 4]);
$mk4movienames[2] = $tmp[$# - 1];

my @picsmovienames=("","","");
@tmp = split("/",$picsmovies[$# - 4]);
$picsmovienames[0] = $tmp[$# - 1];
@tmp = split("/",$picsmovies[$# - 6]);
$picsmovienames[1] = $tmp[$# - 1];
@tmp = split("/",$picsmovies[$# - 8]);
$picsmovienames[2] = $tmp[$# - 1];

#
#  This part of the code looks to see if the day requested was
#  processed or not.  If not, redirect to raw daily movies.
#
if (($day >=1 ) && ($day <=31)){
if ($processed == 0) {
  if ($inst eq "CHIP"){
    $instruments{$inst} = "chip";
  }

print <<DONE;
Content-Type: text/html


<html>
<head>
<title>$inst Data not yet processed</title>
<link rel="stylesheet" type="text/css"
href="$styles/mlsohome.css" />
DONE
PrintJavaScript();
PrintACOSbar("mlso_banner3.sml.gif");
print <<DONE;
<h1 class="datatitle">The $inst data for $mons[$mon-1] $day, $year has
not yet been processed</h1>
<h1 class="datatitle">Only raw data currently available.</h1>
<p class="text">The data for this day has not yet been processed.
There is generally a 3 to 4 day delay between the time when the data
are collected in Hawai'i and when they are processed at HAO in
Boulder.  Please follow the links below to view the raw,
unprocessed data taken at MLSO.	 These data are qualitative gif
images.</p>

<p align="center">
<table align = "center">
<th>CHIP</th><th>PICS</th><th>MKIV</th>
<tr>
<td><a href=http://download.hao.ucar.edu/d5/chip/raw_daily_image/$chipmovienames[0]>$chipmovienames[0]</a></td>
<td><a href=http://download.hao.ucar.edu/d5/dpm/raw_daily_image/$picsmovienames[0]>$picsmovienames[0]</a></td>
<td><a href=http://download.hao.ucar.edu/d5/mk4/raw_daily_image/$mk4movienames[0]>$mk4movienames[0]</a></td>
<tr>
<td><a href=http://download.hao.ucar.edu/d5/chip/raw_daily_image/$chipmovienames[1]>$chipmovienames[1]</a></td>
<td><a href=http://download.hao.ucar.edu/d5/dpm/raw_daily_image/$picsmovienames[1]>$picsmovienames[1]</a></td>
<td><a href=http://download.hao.ucar.edu/d5/mk4/raw_daily_image/$mk4movienames[1]>$mk4movienames[1]</a></td>
<tr>
<td><a href=http://download.hao.ucar.edu/d5/chip/raw_daily_image/$chipmovienames[2]>$chipmovienames[2]</a></td>
<td><a href=http://download.hao.ucar.edu/d5/dpm/raw_daily_image/$picsmovienames[2]>$picsmovienames[2]</a></td>
<td><a href=http://download.hao.ucar.edu/d5/mk4/raw_daily_image/$mk4movienames[2]>$mk4movienames[2]</a></td>
<tr>
</table>
</p>

<div align="center">
<img src='$images/ncartext.gif'>
</div>

<address>
<p>Webpage written and maintained by: <br>
<a href="mailto:tdarnell\@ucar.edu">Tony Darnell</a> <br>
Last modified:	$create_str
</p>
</address>

</body>
</html>
DONE

exit();
}
}

my $datestr   = sprintf("%d%02d%02d",$year,$mon,$day);
my $nextdaystr = sprintf("%d%02d%02d",$nextday->{'year'},
   $nextday->{'month number base 1'},$nextday->{'day of month'});

my %months = ("Jan",1,"Feb",2,"Mar",3,"Apr",4,"May",5,"Jun",6,
	      "Jul",7,"Aug",8,"Sep",9,"Oct",10,"Nov",11,"Dec",12);

if ($day =~ /^Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec$/){ #monthly search
  @files = ();
  my $mon = $months{$day};
  for (my $i = 1;$i <= 31; $i++){
    $day = $i;
    $doy = julian_day($year,$mon,$day) - julian_day($year-1,12,31);
    $yrddoy = sprintf("%02dd%03d",substr($year,2,2),$doy);
    push(@files,getimgs($year,$mon,$day,$yrddoy,"BEST"));
  }
} elsif ($day > 1000){  #yearly search
  my $mon = 0;
  for(my $index = 0; $index <=11; $index++){
   #my $mon += $index;
   $mon++;
   for (my $i = 1;$i <= 31; $i++){
     $day = $i;
     $doy = julian_day($year,$mon,$day) - julian_day($year-1,12,31);
     $yrddoy = sprintf("%02dd%03d",substr($year,2,2),$doy);
     push(@files,getimgs($year,$mon,$day,$yrddoy,"BEST"));
   }
  }
} else {
  chdir "$basedir/$year/$months[$mon-1]";
  $here = cwd();
  opendir DATA, $here;
  @files = grep /^$datestr\.[12](.*?)\.$instruments{$inst}(.*?)$wavelength(.*?)$image_type/, readdir DATA;
  seekdir DATA, 0;
  @nextdayfiles=grep /^$nextdaystr\.0(.*?)\.$instruments{$inst}(.*?)$image_type/,
	    readdir DATA;
  push(@files,@nextdayfiles);
  if ($inst eq "MKIV"){
    seekdir DATA, 0;
    my @avgimg = grep/^$datestr\.mk4.[cr]p[bB]\.avg(.*?)$image_type/,
       readdir DATA;
    push(@files,@avgimg);
  }
  closedir DATA;
  @files = grep /$wavelength/,@files;
  if ($inst eq "MKIV"){$wavelength = "[cr]p[bB]";}
  # put in pathname info for href tag
  foreach my $t (@files){
    $t =~  s/^/$here\//;
    my @tmp = split("/",$t);
    $t = join("/",@tmp[3..6]);
  }
}

$numfiles = @files;
#my @jpegs = sort(grep /jpg/, @files);
my @jpegs = grep(/jpg/, @files);
sort(rindex(@jpegs,"/")+1);
my $numjpegs = @jpegs;
my $jpegstr = join '&',@jpegs;

#exec "$base/mlso_animate.cgi?$jpegstr";
my @images = @jpegs;
#my $numimgs = @images;
my $numimgs = $#images;

foreach (@images){
  s?^?http://download.hao.ucar.edu/?;
}

$query = join '&',@images;

print <<END_OF_PAGE;
Content-type: text/html

<html>
<head>
<title>MLSO JPEG Animate Program</title>

<link rel="stylesheet" type="text/css"
href="$styles/mlsohome.css" />

<SCRIPT language="JavaScript">
<!-- hide the script from old browsers 

//============================================================
//                >> jsImagePlayer 1.0 << 
//            for Netscape3.0+, September 1996
//============================================================
//              by (c)Martin Holecko 1996-98
//           and et netera s.r.o. (www.etnetera.cz)
//             Praha, Czech Republic, Europe
//
// feel free to copy and use as long as the credits are given
//          by having this header in the code
//
//             contact: martin\@etnetera.cz
//          http://sgi.felk.cvut.cz/~xholecko
//
//============================================================
// Thanx to Karel & Martin for beta testing and suggestions!
//============================================================

// DESCRIPTION: preloads number of images named in format 
//   "imagename#.ext" (where "#" stands for number and "ext"
//   for file extension of given filetype (gif, jpg, ...))
//   into cache and then provides usual movie player controls 
//   for managing these images (i.e. frames). A picture 
//   (loading.gif) is displayed while loading the movie.
//   To make it work just set up the variables below.
//   An image "loading.gif" is expected in the directory
//   where this page is located (it asks user to wait while
//   the animation is being downloaded).
//   Enjoy! BASTaRT. (it's spelled with a "T" ! :) 
//  KNOWN BUG:  when page is located on a WWW Server that
//   cannot handle the POST form submit method, pressing Enter
//   after changing the frame number in the little input field
//   causes the page to reload and an alert window to appear.
//   This can be avoided by clicking with the mouse somewhere 
//   outside the input field rather than hitting the Enter to
//   jump to the desired frame.
//
//**************************************************************************
//********* SET UP THESE VARIABLES - MUST BE CORRECT!!!*********************
//image_name = "images/banan";  //the base "path/name" of the image set without the numbers
image_type = "jpg";                 //"gif" or "jpg" or whatever your browser can display

first_image = 0;                    //first image number
last_image = $numimgs;                    //last image number

   //!!! the size is very important - if incorrect, browser tries to 
   //!!! resize the images and slows down significantly
animation_height = 512;              //height of the images in the animation
animation_width = 512;               //width of the images in the animation
//**************************************************************************
//**************************************************************************

//=== THE CODE STARTS HERE - no need to change anything below ===
//=== global variables ====
theImages = new Array();
normal_delay = 30;  
delay = normal_delay;  //delay between frames in 1/100 seconds
delay_step = 10;
delay_max = 4000;
delay_min = 10; 
current_image = first_image;     //number of the current image
timeID = null;
status = 0;            // 0-stopped, 1-playing
play_mode = 0;         // 0-normal, 1-loop, 2-swing
size_valid = 0;
filenames = "$query";
files = filenames.split("&");

//===> makes sure the first image number is not bigger than the last image number
if (first_image > last_image) 
{
   var help = last_image;
   last_image = first_image;
   first_image = help;
};

//===> preload the images - gets executed first, while downloading the page
for (var i = first_image; i <= last_image; i++) 
{
   theImages[i] = new Image();
   theImages[i].src = files[i];
};

//===> displays image depending on the play mode in forward direction
function animate_fwd() 
{
   current_image++;
   if(current_image > last_image)
   { 
      if (play_mode == 0) 
      {
         current_image = last_image; 
         status=0;
         return;
      };                           //NORMAL
      if (play_mode == 1) 
      {
         current_image = first_image; //LOOP
      };
      if (play_mode == 2) 
      {
         current_image = last_image; 
         animate_rev();
         return; 
      };
   };                             
   document.animation.src = theImages[current_image].src;
   document.control_form.frame_nr.value = current_image;
   timeID = setTimeout("animate_fwd()", delay);
}

//===> displays image depending on the play mode in reverse direction
function animate_rev() 
{
   current_image--;
   if(current_image < first_image)
   { 
      if (play_mode == 0) 
      {
         current_image = first_image; 
         status=0;
         return;
      };                           //NORMAL
      if (play_mode == 1) 
      {
         current_image = last_image; //LOOP
      };
      if (play_mode == 2) 
      {
         current_image = first_image; 
         animate_fwd();
         return; 
      };
   };                             
   document.animation.src = theImages[current_image].src;
   document.control_form.frame_nr.value = current_image;
   timeID = setTimeout("animate_rev()", delay);
}

//===> changes playing speed by adding to or substracting from the delay between frames
function change_speed(dv) 
{
   delay+=dv;
   if(delay > delay_max) delay = delay_max;
   if(delay < delay_min) delay = delay_min;
}

//===> stop the movie
function stop() 
{
   if (status == 1) clearTimeout (timeID);
   status = 0;
}

//===> "play forward"
function fwd() 
{
   stop();
   status = 1;
   animate_fwd();
}

//===> jumps to a given image number
function go2image(number)
{
   stop();
   if (number > last_image) number = last_image;
   if (number < first_image) number = first_image;
   current_image = number;
   document.animation.src = theImages[current_image].src;
   document.control_form.frame_nr.value = current_image;
}

//===> "play reverse"
function rev() 
{
   stop();
   status = 1;
   animate_rev();
}

//===> changes play mode (normal, loop, swing)
function change_mode(mode) 
{
   play_mode = mode;
}

//===> sets everything once the whole page and the images are loaded (onLoad handler in <body>)
function launch() 
{
   stop();
   current_image = first_image;
   document.animation.src = theImages[current_image].src;
   document.control_form.frame_nr.value = current_image;
   // this is trying to set the text (Value property) on the START and END buttons 
   // to S(first_image number), E(last_image number). It's supposed (according to 
   // JavaScrtipt Authoring Guide) to be a read only value but for some reason
   // it works on win3.11 (on IRIX it doesn't).
   document.control_form.start_but.value = " S(" + first_image + ") ";
   document.control_form.end_but.value = " E(" + last_image + ") ";
   // this needs to be done to set the right mode when the page is manualy reloaded
   change_mode (document.control_form.play_mode_selection.selectedIndex);
}

//===> writes the interface into the code where you want it
function animation()
{
   document.write(' <P><IMG NAME=\"animation\" SRC=\"$images/loading.gif\" "HEIGHT=",animation_height, " WIDTH=", animation_width, " ALT=\"[jsMoviePlayer]\">"');
   document.write(' <FORM Method=\"POST\" Name=\"control_form\"> ');
   document.write('    <INPUT TYPE=\"button\" Name=\"start_but\" Value=\"  START  \" onClick=\"go2image(first_image)\"> ');
   document.write('    <INPUT TYPE=\"button\" Value=\" -1 \" onClick=\"go2image(--current_image)\"> ');
   document.write('    <INPUT TYPE=\"button\" Value=\" < \" onClick=\"rev()\"> ');
   document.write('    <INPUT TYPE=\"button\" Value=\" [ ] \" onClick=\"stop()\"> ');
   document.write('    <INPUT TYPE=\"button\" Value=\" > \" onClick=\"fwd()\"> ');
   document.write('    <INPUT TYPE=\"button\" Value=\" +1 \" onClick=\"go2image(++current_image)\"> ');
   document.write('    <INPUT TYPE=\"button\" Name=\"end_but\" Value=\"   END   \" onClick=\"go2image(last_image)\"> ');
   document.write(' <BR> ');
   document.write('    <SELECT NAME=\"play_mode_selection\" onChange=\"change_mode(this.selectedIndex)\"> ');
   document.write('       <OPTION SELECTED VALUE=0>play once ');
   document.write('       <OPTION VALUE=1>loop ');
   document.write('       <OPTION VALUE=2>swing ');
   document.write('    </SELECT> ');
   document.write('    <INPUT TYPE=\"text\" NAME=\"frame_nr\" VALUE=\"0\" SIZE=\"5\" ');
   document.write('     onFocus=\"this.select()\" onChange=\"go2image(this.value)\"> ');
   document.write('    &nbsp;<INPUT TYPE=\"button\" Value=\" - \" onClick=\"change_speed(delay_step)\"> speed ');
   document.write('    <INPUT TYPE=\"submit\" Value=\" + \" onClick=\"change_speed(-delay_step)\;return false\"> ');
   document.write(' </FORM> ');
   document.write(' </P> ');
};

//=== THE CODE ENDS HERE - no need to change anything above === -->
</SCRIPT>
END_OF_PAGE

PrintJavaScript();
PrintACOSbar("mlso_banner3.sml.gif");

print <<END_OF_PAGE;

<a href="$getdata_cmnd?$year&$mon&$day&$inst&$wavelength&(fts|jpg)&all">Download Movie Files</a>

<div align="center">
<P><IMG NAME="animation" SRC="$images/loading.gif" HEIGHT=512 WIDTH=512" ALT="[jsMoviePlayer]"> <FORM Method=POST Name="control_form">     <INPUT TYPE="button" Name="start_but" Value="  START  " onClick="go2image(first_image)">     <INPUT TYPE="button" Value=" -1 " onClick="go2image(--current_image)">     <INPUT TYPE="button" Value=" < " onClick="rev()">     <INPUT TYPE="button" Value=" [ ] " onClick="stop()">     <INPUT TYPE="button" Value=" > " onClick="fwd()">     <INPUT TYPE="button" Value=" +1 " onClick="go2image(++current_image)">     <INPUT TYPE="button" Name="end_but" Value="   END   " onClick="go2image(last_image)">  <BR>     <SELECT NAME="play_mode_selection" onChange="change_mode(this.selectedIndex)">        <OPTION SELECTED VALUE=0>play once        <OPTION VALUE=1>loop        <OPTION VALUE=2>swing     </SELECT>     <INPUT TYPE="text" NAME="frame_nr" VALUE="0" SIZE="5"      onFocus="this.select()" onChange="go2image(this.value)">      <INPUT TYPE="button" Value=" - " onClick="change_speed(delay_step)"> speed     <INPUT TYPE="submit" Value=" + " onClick="change_speed(-delay_step);return false">  </FORM>  </P> 
</CENTER>

</div>
<div align="center">
<img src='$images/ncartext.gif'>
</div>

</body> 
</html>

END_OF_PAGE

sub getimgs {
  my $year = $_[0];
  my $mon = $_[1];
  my $day = $_[2];
  my $yrddoy = $_[3];
  my $quality = $_[4];
  my @files;
  my $doy = sprintf("%d",substr($yrddoy,3,3));

  chdir "$basedir/$year/@months[$mon-1]";
  $here = cwd();
  $here =~ s/\/toshi\/ftp\///; #Get rid of the /toshi/ftp part of path
  if ($inst ne "MKIV"){
    my $newqual = $quality;
    if ($quality eq "BEST"){$newqual = "ARCHIVE";}
    open(LOGFILE, "< $logpath/$yrddoy.log");
    @bestname = grep /$newqual/, <LOGFILE>;
    close(LOGFILE);
    @bestname = grep /$wavelength/,@bestname;
    foreach (@bestname){
      my (@tmp,$time);
      s/$newqual//; #Get rid of quality keyword
      s/\s+$//;	#remove whitespace

      # The filename format changed for acosfits here
      if (($inst eq "PICS") && ($year <= 2000) && ($doy < 200)){ 
	@tmp = split /_/;
	$time = substr($tmp[4],0,8);
      } else {
        @tmp = split /\./;
        $time = $tmp[1]; 
      }
      my $hr = substr($time,0,2);
      my $mn = substr($time,2,2);
      my $sc = substr($time,4,2);

      #Rebuild filename with format of those on toshi.

      $here = cwd();
      my $datestr = sprintf("%d%02d%02d.%02d%02d%02d",$year,$mon,$day,$hr,$mn,$sc);
      opendir DATA, $here;
      my @temp = grep /^$datestr(.*?)$instruments{$inst}(.*?)$wavelength(.*?)$image_type/, readdir DATA;
      closedir(DATA);
      push @files,@temp;
      $here =~ s/\/toshi\/ftp\///; #Get rid of the /toshi/ftp part of path
      foreach (@files){
      	s/^/$here\//;
      }

    }
  } else { # Now deal with MKIV
      my $wavelength = "avg";
      my $datestr = sprintf("%d%02d%02d",$year,$mon,$day);
      chdir "$basedir/$year/@months[$mon-1]";
      $here = cwd();
      opendir DATA, $here;
      #@files = grep /^$datestr(.*?)$instruments{$inst}(.*?)$wavelength(.*?)$image_type/, readdir DATA;
      my @temp = grep /^$datestr(.*?)$instruments{$inst}(.*?)$wavelength(.*?)$image_type/, readdir DATA;
      closedir(DATA);
      push @files,@temp;
      #@files = @bestname;
      $here =~ s/\/toshi\/ftp\///; #Get rid of the /toshi/ftp part of path
      foreach (@files){
	s/^/$here\//;
      }
  }
  #return(sort(@files));
  return(@files);
}
