/* csplot.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * CHIP scan plot.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   7 Aug 2000
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

main (argc, argv)

int argc ;
char *argv [] ;

{
    int i ;
    static char gksout [80];
    static char namefile [80] ;
    static float mag  [1000] ;
    static float wave [1000] ;

    float magnitude, wavelength ;
    float fxmin = 1082.0 ;
    float fxmax = 1084.0 ;	
    float fymin =  400.0 ;
    float fymax =  600.0 ;
    int	nval;
    static char namemc [80] ;
    static char title [60] ;
    static char labx [40] ;
    static char laby [40];
    int	ixscale = 0 ;			/* X-axis scaling type: 0=linear. */
    int iyscale = 0 ;			/* Y-axis scaling type: 0=linear. */
    int	ibkg = 2;
    FILE *FD ;

    if (argc == 2)
       {
       strcpy (namefile, argv [1]) ;
       }

    sprintf (namemc, "chipspec.cgm") ;
    sprintf (title,  "CHIP spectrum scan: %s", namefile) ;
    sprintf (labx,   "Wavelengh [nm]") ;
    sprintf (laby,   "Magnitude") ;

    sprintf (gksout, "NCARG_GKS_OUTPUT=%s", namemc);
    putenv (gksout);
    opngks_ () ;

    FD = fopen (namefile, "r") ;

    i = 0 ;
    while (fscanf (FD, "%f %f", &wavelength, &magnitude) != EOF)
	{
	wave [i] = wavelength ;
	mag  [i] = magnitude  ;
	i++ ;
	}
    nval = i ;

    fclose (FD) ;

/*
    xyplot (wave, mag, nval, namemc, title, labx, laby, ixscale, iyscale, ibkg) ;
 */

    xysplot (wave, mag, fxmin, fxmax, fymin, fymax, nval, namemc, title, labx, laby,
             ixscale, iyscale, ibkg) ;


   clsgks_ () ;
}
