/* dpm_optdev.h
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Definitions needed for MLSO DPM device names and positons.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   1 March 1994
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#define		NUM_CHAR	16
#define		NUM_TYPE	9
#define		NUM_DEVICES	8
#define		NUM_POSITIONS	11

#ifdef DPMON
char	type_str [NUM_TYPE][NUM_CHAR] =
			{
			"Other",
			"Disc",
			"Limb",
			"Reference",
			"Diffuser",
			"Disc dark",
			"Limb dark",
			"Diffuser dark",
			"Reference dark"
			};

char	device_str [NUM_DEVICES][NUM_CHAR] =
			{
			"Bandpass",
			"Aperture Wheel",
			"DayStar Filter",
			"Filter Wheel",
			"Occulting Wheel",
			"Picture",
			"Steps",
			"Flip"
			};

char	device_position_str [NUM_DEVICES][NUM_POSITIONS][NUM_CHAR] =
	{
	"unk", "unk", "unk", "unk", "unk", "unk", 
	"unk", "unk",  "unk", "unk", "timeout", 

	"clear", "diffuser", "opal", "polarizer", "unk", "unk", 
	"unk", "unk",  "unk", "unk", "timeout", 

	"in", "out", "unk", "unk", "unk", "unk", 
	"unk", "unk",  "unk", "unk", "timeout", 

	"658.1", "654.0", "blocked", "blocked", "blocked", "655.5", 
	"656.3", "657.1",  "unk", "unk", "timeout", 

	"wedge", "2.0R0_occult", "clear", "1.25R0_occult", "limb", "reticle", 
	"unk", "unk", "unk", "unk", "timeout", 

	"unk", "unk", "unk", "unk", "unk", "unk", 
	"unk", "unk",  "unk", "unk", "timeout", 

	"unk", "unk", "unk", "unk", "unk", "unk", 
	"unk", "unk",  "unk", "unk", "timeout", 

	"unk", "unk", "unk", "unk", "unk", "unk", 
	"unk", "unk",  "unk", "unk", "timeout"
	};

#else
extern	char	type_str [NUM_TYPE][NUM_CHAR];
extern	char	device_str [NUM_DEVICES][NUM_CHAR];
extern	char	device_position_str [NUM_DEVICES][NUM_POSITIONS][NUM_CHAR];
#endif
