package    acos;
require    Exporter;
@ISA       =qw(Exporter);
@EXPORT    =qw(email getmss getFileChecksum printtime bytscl);
@EXPORT_OK =qw(email getmss getFileChecksum printtime bytscl);

use Net::SMTP;
use Digest::MD5;

#
# email
# This procedure sends an email to a person or group using the Net::SMTP
# module.  Sendmail or qmail are not required.
#
# The arguments to this function are references
#
sub email {

  my ($users, $subject, $message) = @_;
  my $server = "jabba.hao.ucar.edu";

  $smtp = Net::SMTP->new($server);
  die "Couldn't connect to server" unless $smtp ; 
  $smtp->mail($ENV{USER});
  $smtp->to(@$users);
  $smtp->data();
  $smtp->datasend("From: $ENV{USER}\n");
  $smtp->datasend("Subject: $subject\n");
  $smtp->datasend("\n");
  $smtp->datasend($message);
  $smtp->datasend("\n");
  $smtp->dataend();
  $smtp->quit();

}

#
# getmss
# This subroutine fetches a file from the MSS
# usage:  getmss ($mssfile, $dir, $f);
# $mssfile is full filename on mss, including path
# $dir is the directory to put the file in (must already exist)
# $filename is just $mssfile stripped of path
#
sub getmss ($$$)
  {
  #$mssfile = @_[0];
  #$dir = @_[1];
  #$filename = @_[2];

  ($mssfile,$dir,$filename) = @_;
  $starttime = time ();
  $mssid = (`msrcp -async mss:$mssfile $dir`)[0];

  if ($mssid) {
    print "Waiting for $filename to return from MSS...";
    $tmp = system("dcswait $mssid");
    print "\n$filename has returned from MSS.\n";
  }

  $endtime = time ();
  $elapsed_time = $endtime - $starttime;
  printtime ($elapsed_time);
  }


#
# getFileChecksum($filename)
# Returns an MD5 checksum of $filename
#
sub getFileChecksum {
  my $filename = shift;
  open (FILE, $filename) or die "Can't open '$filename': $!";
  binmode (FILE);
  my $md5 = Digest::MD5->new;
  while (<FILE>) {
    $md5->add($_);
  }
  close (FILE);
  return ($md5->b64digest);
}

sub printtime ($) {

  my $elapsed_time = $_[0];
  my $hours_elapsed = sprintf ("%02d", $elapsed_time / 3600);
  my $mins_elapsed  = sprintf ("%02d", ($elapsed_time - 3600 * $hours_elapsed) / 60);
  my $secs_elapsed  = sprintf ("%02d", ($elapsed_time % 60));
  print ("Time elapsed:  $hours_elapsed:$mins_elapsed:$secs_elapsed\n");

}

#
# bytscl works just like the one in IDL.  It applies a linear scaling function
# of the form: oldint = newint*bscale + offset
#	where: bscale = (imax - imin) / (omax - omin)
#	        0 < omax < 256
#		0 < omin < 256
#		imin = image min, imax = image max
#		offset usually equals imin, omin usually = zero
#
# $image is a reference to an array
#
sub bytscl ($$$$$$){

   my ($image, $xsz, $ysz, $imin, $imax, $top) = $@;
   my ($i, $bscale, $nelements);

   $nelements = $xsz * $ysz;
   $bscale - ($imax - $imin) / ($omax - $omin);

   for (0 .. $nelements){
      $$image[$_] = ($$image[$_] - $offset ) / $bscale; 
   }
}

1;
