/* rdmk3ba.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Read MLSO Mark-III barrel angles.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   9 February 1994
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "/home/stanger/lib/include/mk3lib.ext"

rdmk3ba (nameba)

char nameba [] ;

{
   static short sbuf [720];
   static float ba [720];
   FILE *FD;
   int i;
   float baraw  = 0.0 ;
   float baadj  = 0.0 ;
   float bacor  = 0.0 ;
   float phase  = 0.0 ;
   float pangle = 0.0 ;

   mk3hskp (nameba, 0) ;				/* Read MK3 tailer. */

   printf ("rdmk3ba> MK3I->phase:%10.4f   MK3I->pangle:%10.4f   MK3H->nray:%d\n",
	   MK3I->phase, MK3I->pangle, MK3H->nray) ;

   if ((FD = fopen (nameba, "r")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", nameba) ;
      exit (-1) ;
      }

   fread (sbuf, sizeof (short), MK3H->nray, FD) ;

   fclose (FD) ;

   phase = (float) MK3H->phase * (180.0 / 32768.0) ;
   pangle = (float) MK3I->pangle ;
   printf ("rdmk3ba> phase:%10.4f   pangle:%10.4f   nray:%d\n",
	   phase, pangle, MK3H->nray) ;

   fprintf (stdout, "Barrel Angles: index, short, raw[deg], adj[deg], cor[deg]\n");

   for (i = 0; i < MK3H->nray; i++)
      {
      baraw = ((float) sbuf [i] / 16384.0) * 360.0;
      baadj = baraw + phase - pangle ;
      bacor = baadj ;
      if (bacor < 0.0)  bacor += 360.0 ;
      ba [i] = bacor ;
      fprintf (stdout, "%3d   %5d   %8.4f   %8.4f   %8.4f\n",
	       i, sbuf [i], baraw, baadj, bacor);
      }

   return (0) ;
}
