/* rdmpos
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * Read mouse position.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 */
#include <gl/device.h>
#include "cp_mass.h"

rdmpos (xmaxscrn, ymaxscrn, xo, yo, xs, ys, xwin, ywin)

long xmaxscrn, ymaxscrn;     /* maximum size of screen in x and y       */
long *xo, *yo;                 /* x/y origin of current window */
long *xs, *ys;                 /* x/y size of current window   */
long *xwin, *ywin;

{
   Device mdev [XY];
   short mval [XY];
   short val;
   long dev;

   mdev [X] = MOUSEX;
   mdev [Y] = MOUSEY;

   qreset ();
   qdevice (ESCKEY);
   qdevice (LEFTMOUSE);
   qdevice (MIDDLEMOUSE);

   while (1)
      {
      while (qtest ())
         {
         dev = qread (&val);
         switch (dev)
            {
            case ESCKEY:
                 setvaluator (MOUSEX, (short)(*xs/2), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(*ys/2), 0, ymaxscrn);
                 gexit ();
                 exit (1);
                 break;
            case REDRAW:
                 reshapeviewport ();
                 getsize (xs, ys);
                 getorigin (xo, yo);
                 color (CYAN);
                 clear ();
                 break;
            case MIDDLEMOUSE:	/* Read winition of mouse. */
            case LEFTMOUSE:	/* Read winition of mouse. */
                 if (val == 1)
                    {
                    getdev (XY, mdev, mval);
                    *xwin = mval [X] - *xo;
                    *ywin = mval [Y] - *yo;
                    printf ("mval: %3d %3d   xo/yo: %3d %3d   xwin/ywin: %3d %3d\n",
                             mval [0], mval [1], *xo, *yo, *xwin, *ywin);
                    qreset ();
                    return (0);
                    }
                 break;
            default:
                 break;
            }
         }
      }
}
