From lika@sdac.gsfc.nasa.gov Thu Apr  6 14:27 MDT 1995
Received: from SDAC (sdac.gsfc.nasa.gov [128.183.57.156]) by hao.ucar.edu (8.6.11/8.6.6.Beta9) with SMTP id OAA10235 for <card@hao.ucar.edu>; Thu, 6 Apr 1995 14:27:49 -0600
From: lika@sdac.gsfc.nasa.gov
Date: Thu, 6 Apr 1995 16:27:33 -0400
Message-Id: <95040616273363@sdac.gsfc.nasa.gov>
To: card@hao.ucar.edu
Subject: Reformat, windowless
X-VMS-To: SMTP%"card@hao.ucar.edu"
Content-Type: text
Content-Length: 9987
Status: R

; REFORMAT_SPARTAN
; REFORMAT_SPARTAN reads SPARTAN 201 WLC tape records dumped to a disk file,
; in an attempt to reformat image data.
; D.M. fecit, 1993.
;
function spartan_int, byte_array
n_byte = n_elements(byte_array) & n_word = n_byte/2
b = bytarr(2,n_word) & b(0) = byte_array(0:2*n_word - 1)
a = reform(b(0,*)*256 + b(1,*))
return,a
end
   
function exp_time, time_bytes
c = 256l^(3 - indgen(4)) & t_sec = 0.008*total(c*time_bytes)
return, t_sec & end

function time_string, t_sec
h = fix(t_sec/3600.) & t_rem = t_sec - 3600.*h
m = fix(t_rem/60.) & s = t_rem - 60.*m
h = strtrim(h,2) & if strlen(h) eq 1 then h = '0' + h
m = strtrim(m,2) & if strlen(m) eq 1 then m = '0' + m
s = strtrim(string(s, format = '$(f6.3)'),2)
if strlen(s) eq 5 then s = '0' + s
met = h + ':' + m + ':' + s
return, met & end

pro decom_params, b, met, pitch, yaw, roll, exposure, pol, hwp, cal, n_sum, $
                  ccd_t
;
pol_pos = ['clear','    0','   30','   60'] & hwp_pos = 30*(3 - indgen(4))
ad25 = [36680.,4096.,-13570.] & cal_string = [' ','C']
;
start_time = exp_time(b(6:9))
met = time_string(start_time)		; mission elapsed time
pitch = 0.5*(b(10)*256 + b(11))		; relative pitch angle
yaw = 256*b(22) + b(23)			; mean PES yaw
roll = 256*b(28) + b(29)		; mean PES roll
exposure = 0.008*(256*b(14) + b(15))	; exp. time (s)
pol = pol_pos(ishft(b(12),-2) and 3)	; polarizer wheel position
hwp = hwp_pos(ishft(b(12),-4) and 3)	; half-wave plate position
cal = cal_string(ishft(b(13),-7))	; calibration mirror
n_sum = b(13) and 'f'xb			; number of summed exposures
ccd_t = spartan_int(b(18:21))		; CCD initial, final temps.
ccd_t = 0.01*(ccd_t*ad25(0)/ad25(1) + ad25(2))
;
return & end

;@sys$user:[gurman.spartan]find_image
@find_image

; device = !d.name & if strupcase(device) ne 'X' then set_plot,'x
;
journal_format = $
   '$(a11,2x,a5,1x,a12,1x,3(i6,1x),f7.3,2x,a5,3x,i2,5x,a1,3x,i3,2(2x,f5.1))'
;
;stop
file = '' & extension = '9404'
;
; NOTE: Change the extension for future flights.
;
while file eq '' do begin
;    read,'File name [SYS$SYSDEVICE:[spartan.sept94]]      ',file
    read,'File name     ',file
end
;
; Find out how big the sucker is.
;
;spawn,'directory /size = all /out = check.size sys$sysdevice:[spartan.sept94]' + file
spawn,'directory /size = all /out = check.size ' + file
openr, size_unit, 'check.size', /get_lun
s = '' & while strpos(s,'/') lt 0 do readf, size_unit, s
close, size_unit & free_lun, size_unit
spawn, 'delete check.size;'
ich = strpos(s,'/') & n_block = long(strmid(s, ich - 8, 8))
n_tape_block = (n_block/16) - 1
n_800 = n_tape_block/800 & n_extra = n_tape_block mod 800
n_VLA = n_800 + (n_extra ne 0)
if n_extra eq 0 then block_size = intarr(n_800) + 800 else begin
   if n_800 gt 0 then block_size = [intarr(n_800) + 800, n_extra] else $
      block_size = intarr(1) + n_extra
end
print,'%REFORMAT_SPARTAN-D-BLOCKS, block_size ='
print, block_size
;
;openr, in_unit, '$1$dia5:[spartan]' + file, /get_lun 
openr, in_unit,  file, /get_lun 
;
print,' '
print,'%SPARTAN-I-DOZE, setting up VLA to read in up to 6.4 Mbyte from'
print,'                 disk dump of tape.'
print,'%SPARTAN-I-TIME, time now is ' + !stime
vla_size = 8192l*800
a = bytarr(vla_size) & w = assoc(in_unit,a)
print,'%SPARTAN-I-ALLOC, initial memory allocation completed.'
print,'%SPARTAN-I-TIME, time now is ' + !stime & print,' '
;
;stop
journal_file = 'journal.dat'
ich = strpos(strupcase(file), 'TAPE_')
if ich ge 0 then journal_file = 'journal_' + strmid(file, 5, 2) + '.dat'
openw, journal_unit, journal_file, /get_lun
printf, journal_unit, 'Journal for file ' + file
printf, journal_unit, 'Run starting at ' + !stime
for i = 0, 1 do printf, journal_unit, ' '
printf, journal_unit, $
   '             Image                                             Pol.' + $
   '  Half  Cal.  Sum  T_CCD  T_CCD'
printf, journal_unit, $
   '   File       ID        MET      Pitch  <Yaw>  <Roll>  Exp.    pos.' + $
   '  wave  mirr  exp  first  last'
printf, journal_unit, ' '
;
; Get the next file number to use by checking for other SPARTAN files on
; this directory. (This could be replaced by checking a catalog.)
;
;s = findfile('$1$dia5:[spartan]S*.' + extension)
s = findfile('S*.' + extension)
n_file = n_elements(s)
if (n_elements(s) eq 1) and (s(0) eq '') then begin
   n_file = 0 & i_file = 1
endif else begin
   s = s(n_file - 1) & i_right_bracket = strpos(s,']')
   nch = strlen(s)
   i_file = fix(strmid(s, i_right_bracket + 2, 5)) + 1
end
;
file_string = strtrim(i_file,2)
while strlen(file_string) lt 5 do file_string = '0' + file_string
;
file_name = 'S' + file_string + '.' + extension
;openw, out_unit, 'sys$sysdevice:[spartan.sept94]' + file_name, 640, /get_lun
openw, out_unit, file_name, 640, /get_lun
w_out = assoc(out_unit, intarr(320)) & image = intarr(320,256) & first_line = 1
;
n_byte_remaining = 0 & mem_alloc = 0
for i_VLA = 0, n_VLA - 1 do begin
;
   print,'%SPARTAN-I-BEGIN_READ, time now is ' + !stime
   if block_size(i_VLA) eq 800 then begin
      a = w(i_VLA)
   endif else begin
      vla_size = 8192l*n_extra & w = assoc(in_unit, bytarr(8192))
      offset = n_800*800l
      for i_extra = 0, n_extra - 1 do a(8192l*i_extra) = w(offset + i_extra)
   end
   print,'%SPARTAN-I-END_READ, time now is ' + !stime
;
; If only part of an image line remained in the previous VLA, read the rest
; and write the complete image line to disk before proceding.
;
   if n_byte_remaining ne 0 then begin
      n_word_written = 320 - n_byte_remaining/2
      image(0, image_line) = [image(0:n_word_written - 1, image_line), $
         spartan_int(a(0:n_byte_remaining - 1))]
      w_out(image_line) = image(*, image_line)
      n_byte_remaining = 0
   end
;
   print,'%SPARTAN-I-INDICES, calling FIND_IMAGE to locate image data frames.'
   find_image, a(0:vla_size - 1), frame_index
   n_index = n_elements(frame_index)
;
   for i_index = 0, n_index - 1 do begin
;
; I know I'm going to regret using records of length 320 on a system
; with 512-byte disk blocks....
;
      index = frame_index(i_index)
;
; If there's even one word of image data, get it.
;
      n_max = vla_size - index
      if n_max ge 48 then begin
;
; Figure out how many data frames are needed from the next very large array's
; worth of data.
;
         if n_max lt 686 then n_byte_remaining = 686 - n_max else $
            n_byte_remaining = 0
         b = a(index:index + min([n_max - 1, 685]))
;
; Check to see if matching only the first two bytes of the synch pattern
; and the data frame descriptor byte was enough. If so, start turning the
; crank.
;
         if ((b(2) eq '66'xb) and (b(3) eq '55'xb) and (b(4) eq 0b)) then begin
            image_id = b(16:17) & image_line = 256*b(44) + b(45)
;
; If it's the very first image line we've read, decommutate some
; observing parameters.
;
            if first_line then begin
               last_id = image_id & first_line = 0 & n_line = 0
               decom_params, b, met, pitch, yaw, roll, exposure, pol, hwp, $
                  cal, n_sum, ccd_t
;
               print,'%SPARTAN-D-FRAME, beginning frame ', image_id
            endif else begin
               same_image = $
                  (image_id(0) eq last_id(0)) and (image_id(1) eq last_id(1))
;
; If a new image has started, close the image file, ....
;
               if not same_image then begin
                  print,'%SPARTAN-D-FILE, closing file ' + file_name + $
                     ' with ' + strtrim(n_line,2) + ' lines.'
                  close, out_unit
                  image_id_string = string(last_id(0),format='$(i2)') + '/' + $
                     string(last_id(1),format='$(i2)')
;
; display the image, ....
;
;                 window,0,xsize = 320,ysize = 256, $
;                    title = 'SPARTAN 201 image ' + image_id_string
;                 display_image = ((image/n_sum) > 0) < 4095
;                 color,10 & tvscl, sqrt(display_image) , order = 1
                  print,'Total (image) = ',long(total(image))
;
; initialize a new file and some variables, ....
;
                  i_file = i_file + 1 & file_string = strtrim(i_file,2)
                  while strlen(file_string) lt 5 do $
                     file_string = '0' + file_string
                  file_name = 'S' + file_string + '.' + extension
;                   openw, out_unit, 'sys$sysdevice:[spartan.sept94]' + file_name, 640
                   openw, out_unit,  file_name, 640
                  image = intarr(320,256) & last_id = image_id & n_line = 0
                  w_out(255) = temporary(intarr(320))
;
; write the catalog information, ....
;
                  print, format = journal_format, $
                     file_name, image_id_string, met, pitch, yaw, roll, $
                     exposure, pol, hwp, cal, n_sum, ccd_t
                  printf, journal_unit, format = journal_format, $
                     file_name, image_id_string, met, pitch, yaw, roll, $
                     exposure, pol, hwp, cal, n_sum, ccd_t
;
; and decommutate the new observing parameters.
;
                  decom_params, b, met, pitch, yaw, roll, exposure, pol, hwp, $
                     cal, n_sum, ccd_t
               end
            end
;
; In any case, write out an image line to disk.
;
            image(0, image_line) = spartan_int(b(46:*))
            w_out(image_line) = image(*, image_line) & n_line = n_line + 1
         end
      endif else begin
;
; If there's not enough data remaining to read in image data, close the last
; image file and write the catalog information.
;
         close, out_unit
         print, format = journal_format, $
            file_name, image_id_string, met, pitch, yaw, roll, exposure, $
            pol, hwp, cal, n_sum, ccd_t
         printf, journal_unit, format = journal_format, $
            file_name, image_id_string, met, pitch, yaw, roll, exposure, $
            pol, hwp, cal, n_sum, ccd_t
      end
   end
end
;
printf, journal_unit, '' & printf, journal_unit, 'Run finished at ' + !stime
close,/all
;
end

