/* fitskey.h
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * FITS key words.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   11 March 1994
 * 22 April 1994: add keywords: TYPE-OBS, etc., for disk images (BBSO, KPNO)
 * 2 June 1994: change:     BANGLE   -> SOLAR_B0, HANGLE   -> SOLAR_H0,
 *                          LANGLE   -> SOLAR_L0, PANGLE   -> SOLAR_P0
 * 18 August 1994: change : SOLAR_H0 -> HOUR-ANG                      
 *                          SCNDIR   -> SCAN-DIR, SCNDUR   -> SCAN-DUR
 *                          ANGNORTH -> NORTHANG, SCROLL   -> SC-ROLL
 *		   add    : CODE-OBS, CRRADIUS, DISP-DIR, OCC-DISC
 *                 remove : CPVER, DPMVER, MK3VER
 * 22 August 1994: add    : CODE-CP, CODE-DPM, CODE-MK3
 * 11 March 1998: Add keywords for Skylab ATM/WLCE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#define numkey 204

char fitskey [numkey][12] =
   {
   "",		/*   0 */

   "AIRMASS",	/*   1 */
   "ANGLE",	/*   2 */
   "AUTHOR",	/*   3 */
   "AZIMUTH",	/*   4 */

   "BIAS",	/*   5 */
   "BITPIX",	/*   6 */
   "BLANK",	/*   7 */
   "BLOCKED",	/*   8 */
   "BSCALE",	/*   9 */
   "BUNIT",	/*  10 */
   "BZERO",	/*  11 */

   "CALIBRAT",	/*  12 */
   "CALMIR",	/*  13 */
   "CAMERA",	/*  14 */
   "CD001001",	/*  15 */
   "CD001002",	/*  16 */
   "CD001003",	/*  17 */
   "CD002001",	/*  18 */
   "CD002002",	/*  19 */
   "CD002003",	/*  20 */
   "CD003001",	/*  21 */
   "CD003002",	/*  22 */
   "CD003003",	/*  23 */
   "CDELT1",	/*  24 */
   "CDELT2",	/*  25 */
   "CDELT3",	/*  26 */
   "CODE-CP",	/*  27 */
   "CODE-DPM",	/*  28 */
   "CODE-MK3",	/*  29 */
   "CODE-OBS",	/*  30 */
   "COLORFIL",	/*  31 */
   "COMMENT",	/*  32 */
   "CREATOR",	/*  33 */
   "CROTA1",	/*  34 */
   "CROTA2",	/*  35 */
   "CROTA3",	/*  36 */
   "CRPIX1",	/*  37 */
   "CRPIX2",	/*  38 */
   "CRPIX3",	/*  39 */
   "CRRADIUS",	/*  40 */
   "CRVAL1",	/*  41 */
   "CRVAL2",	/*  42 */
   "CRVAL3",	/*  43 */
   "CTYPE1",	/*  44 */
   "CTYPE2",	/*  45 */
   "CTYPE3",	/*  46 */

   "DATAFORM",	/*  47 */
   "DATAMAX",	/*  48 */
   "DATAMIN",	/*  49 */
   "DATE",	/*  50 */
   "DATE-CAL",	/*  51 */
   "DATE-OBS",	/*  52 */
   "DATE-OPC",	/*  53 */
   "DELTAT",	/*  54 */
   "DIRAXIS1",	/*  55 */
   "DIRAXIS2",	/*  56 */
   "DIRAXIS3",	/*  57 */
   "DISP-DIR",	/*  58 */
   "DISPMAX",	/*  59 */
   "DISPMIN",	/*  60 */
   "DOY-OBS",	/*  61 */

   "ELEV",	/*  62 */
   "END",	/*  63 */
   "EPOCH",	/*  64 */
   "EQUINOX",	/*  65 */
   "EXPDUR",	/*  66 */
   "EXPOSURE",	/*  67 */
   "EXPUNITS",	/*  68 */
   "EXTEND",	/*  69 */
   "EXTLEVEL",	/*  70 */
   "EXTNAME",	/*  71 */
   "EXTVER",	/*  72 */

   "FIDUM-LL",	/*  73 */
   "FIDUM-LR",	/*  74 */
   "FIDUM-UL",	/*  75 */
   "FIDUM-UR",	/*  76 */
   "FIDUP-LL",	/*  77 */
   "FIDUP-LR",	/*  78 */
   "FIDUP-UL",	/*  79 */
   "FIDUP-UR",	/*  80 */
   "FILMLOAD",	/*  81 */
   "FILM-SCL",	/*  82 */
   "FILTER",	/*  83 */
   "FRAME",	/*  84 */
   "FRAMES",	/*  85 */

   "GAIN",	/*  86 */
   "GCOUNT",	/*  87 */
   "GLFILTER",	/*  88 */

   "HISTORY",	/*  89 */
   "HOUR_ANG",	/*  90 */

   "IASLIM",	/*  91 */
   "IASRL",	/*  92 */
   "IASRLOK",	/*  93 */
   "IASUD",	/*  94 */
   "IASUDOK",	/*  95 */
   "INSTRUME",	/*  96 */
   "INT-MODE",	/*  97 */

   "LONGPOLE",	/*  98 */

   "MJD-OBS",	/*  99 */

   "NAXIS",	/* 100 */
   "NAXIS1",	/* 101 */
   "NAXIS2",	/* 102 */
   "NAXIS3",	/* 103 */
   "NIMAVG",	/* 104 */
   "NORTHANG",	/* 105 */

   "OBJECT",	/* 106 */
   "OBSERVER",	/* 107 */
   "OCC-DISC", 	/* 108 */
   "OPTDEV1",	/* 109 */
   "OPTDEV2",	/* 110 */
   "OPTDEV3",	/* 111 */
   "OPTDEV4",	/* 112 */
   "OPTDEV5",	/* 113 */
   "OPTDEV6",	/* 114 */
   "OPTDEV7",	/* 115 */
   "OPTDEV8",	/* 116 */
   "OPTPOS1",	/* 117 */
   "OPTPOS2",	/* 118 */
   "OPTPOS3",	/* 119 */
   "OPTPOS4",	/* 120 */
   "OPTPOS5",	/* 121 */
   "OPTPOS6",	/* 122 */
   "OPTPOS7",	/* 123 */
   "OPTPOS8",	/* 124 */
   "ORIGIN",	/* 125 */

   "PESLIM",	/* 126 */
   "PESRL",	/* 127 */
   "PESRLOK",	/* 128 */
   "PESUD",	/* 129 */
   "PESUDOK",	/* 130 */
   "PCOUNT",	/* 131 */
   "PHI",	/* 132 */
   "POLAROID",	/* 133 */
   "PRESUNX",	/* 134 */
   "PRESUNY",	/* 135 */
   "PREVIGX",	/* 136 */
   "PREVIGY",	/* 137 */
   "PROJP1",	/* 138 */
   "PROJP2",	/* 139 */
   "PUNIT",	/* 140 */

   "QUALITY",	/* 141 */

   "RADECSYS",	/* 142 */
   "RADIUS",	/* 143 */
   "RANGVALU",	/* 144 */
   "REFERENC",	/* 145 */
   "RMAX",	/* 146 */
   "RMIN",	/* 147 */
   "ROLL",	/* 148 */
   "RSUN",	/* 149 */
   "RSUN-ARC",	/* 150 */
   "RSUN-MIC",	/* 151 */
   "RSUN-PIX",	/* 152 */
   "RUNIT",	/* 153 */

   "SECTOR",	/* 154 */
   "SEEING",	/* 155 */
   "SCAN-DIR",	/* 156 */
   "SCAN-DUR",	/* 157 */
   "SC-ROLL",	/* 158 */
   "SIMPLE",	/* 159 */
   "SKY",	/* 160 */
   "SOLAR_B0",	/* 161 */
   "SOLAR_L0",	/* 162 */
   "SOLAR_P0",	/* 163 */
   "STRAYIN",	/* 164 */
   "STRYCENX",	/* 165 */
   "STRYCENY",	/* 166 */
   "SUNCENX",	/* 167 */
   "SUNCENY",	/* 168 */
   "SUNOFFDX",	/* 169 */
   "SUNOFFDY",	/* 170 */

   "TELESCOP",	/* 171 */
   "THETA",	/* 172 */
   "TIME",	/* 173 */
   "TIME-CAL",	/* 174 */
   "TIME-OBS",	/* 175 */
   "TIME-OPC",	/* 176 */
   "TILT",	/* 177 */
   "TMAX",	/* 178 */
   "TMIN",	/* 179 */
   "TUNIT",	/* 180 */
   "TYPE-CP",	/* 181 */
   "TYPE-DPM",	/* 182 */
   "TYPE-MK3",	/* 183 */
   "TYPE-OBS",	/* 184 */
   "TYPE1",	/* 185 */
   "TYPE2",	/* 186 */
   "TYPE3",	/* 187 */
   "TYPE4",	/* 188 */
   "TYPE5",	/* 189 */
   "TYPE6",	/* 190 */
   "TYPE7",	/* 191 */
   "TYPE8",	/* 192 */

   "UTSTART",	/* 193 */
   "UTSTOP",	/* 194 */

   "VERSION",	/* 195 */
   "VIGCENX",	/* 196 */
   "VIGCENY",	/* 197 */
   "VIGNETIN",	/* 198 */

   "WAVE   ",	/* 199 */
   "WAVELEN",	/* 200 */
   "WAVELNTH",	/* 201 */

   "XTENSION",	/* 202 */

   "ZEROVALU"	/* 203 */
   } ;
