/* lint.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Linear interpolation: lint will interpolate on tables.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * SMM C/P   HAO/NCAR
 * Fortran author: Kevin Cole
 * converted to C by Andrew L. Stanger
 * 1 March 1984
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

/* ------------------------------------------------------------------------- */

float
lint (x, xtable, ytable, ntab)

float x;
float xtable [], ytable [];
int ntab;

{
int i, k;
float y;

   for (i=1; i<ntab; i++)
      {
      k = i - 1;
      if (x < xtable [i])
         {
         y = ytable [k] + (ytable [k+1] - ytable [k]) * ((x - xtable [k])
             / (xtable [k+1] - xtable [k]));
         return (y);
         }
      else
      if (x == xtable [i])  return (ytable [i]);
      }

   return (-1.0);
}
