PRO wlcefixfts, fits_name
;
;+ wlcefixfts.pro
;
; Fix FITS header of a Skylab ATM/WLCE image.
;
;-

fits_outname = fits_name

img = READFITS (fits_name, hdu)
img = img * 1.0E-11
img = FIX (img)
datamin = MIN (img)
datamax = MAX (img)
dispmin = datamin
dispmax = datamax
print, 'dispmin/max: ', dispmin, dispmax

roll = FXPAR (hdu, 'ROLL')
scroll = - roll / 60.0
otime = FXPAR (hdu, 'TIME-OBS')
print, 'otime: ', otime
hour   = strmid (otime, 0, 2)
minute = strmid (otime, 3, 2)
second = strmid (otime, 6, 2)
otime = hour + ':' + minute + ':' + second
print, 'otime: ', otime
print, 'size (otime): ', size (otime)

FXADDPAR, hdu, 'ORIGIN',   'HAO', ' HIGH ALTITUDE OBSERVATORY'
FXADDPAR, hdu, 'INSTRUME', 'SKYLAB-ATM', ' APOLLO TELESCOPE MOUNT'
FXADDPAR, hdu, 'TELESCOP', 'WLCE', ' S-052 WHITE LIGHT CORONAGRAPH'
FXADDPAR, hdu, 'OBJECT',   'SOLAR CORONA', ' WHITE LIGHT: [300 - 700 NM]'
FXADDPAR, hdu, 'TIME-OBS', otime, ' OBSERVATION TIME: HH:MM:SS [UT]'
FXADDPAR, hdu, 'BSCALE',   1.0E-11, ' PHYSICAL VALUE = BZERO + BSCALE * (ARRAY VALUE)'
;FXADDPAR, hdu, 'VIGNETIN', 'Y',     " VIGNETTING FUNCTION IS STILL IN IF 'Y'"
FXADDPAR, hdu, 'CROTA1',   scroll,  ' [DEGREES]'
FXADDPAR, hdu, 'CROTA2',   scroll,  ' [DEGREES]'
FXADDPAR, hdu, 'DATAMIN',  datamin, ' DATA MINIMUM [BSUN]'
FXADDPAR, hdu, 'DATAMAX',  datamax, ' DATA MAXIMUM [BSUN]'
FXADDPAR, hdu, 'DISPMIN',  dispmin, ' DISPLAY MINIMUM [BSUN]'
FXADDPAR, hdu, 'DISPMAX',  dispmax, ' DISPLAY MAXIMUM [BSUN]'

WRITEFITS, fits_outname, img, hdu

END
