/* tanplot(x,y,yfit,nval,namfil,title,labx,laby,ixscale,iyscale,ibkg)
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *   Calls NCAR graphics routines to generate a 2-dimensional plot.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *   Andrew L. Stanger
 *   NCAR/HAO   SMM C/P
 *   15 March 1985
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *   x, y : real arrays to be plotted.
 *   yfit: array of curve values (fitted to y data points).
 *   nval : # values of x = # values of y.
 *   namfil : metacode file name.
 *   title : graph title.
 *   labx, laby : labels for x & y axes.
 *   ixscale, iyscale : integers specifying scale type (0=linear, 1=log).
 *   ibkg : integer specifying graph background 
 *          = 0  do not change default.
 *          = 1  tick marks only.
 *          = 2  full grid.
 *          = 3  half axis.
 *          = 4  no background.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 */
#include <math.h>
extern int pcount;

tanplot (x,y,yfit,nval,namfil,title,labx,laby,ixscale,iyscale,ibkg)
float	x[], y[];
float	yfit[];
int	nval;
char	namfil[];
char	title[40], labx[40], laby[40];
int	ixscale, iyscale;
int	ibkg;

{
extern char *malloc();
static int iset  = 0;
static int ndash = 0;
static int ldash = 0;
static int ichar = '*' ;
static int npar = 3;
int npts;
int ierr;
int i;
static float xmm[2],ymm[2] ;

   xmm[0] = 0.0 ;
   xmm[1] = 32.0 ;
   ymm[0] = 0.0 ;
   ymm[1] = 256.0 ;

   pcount ++;
   if(pcount == 1)  q8qini (namfil, 0);
   anotat (labx, laby, 1, -1, 0, 0.0);
   displa (2, 0, 1);
   ezxy (xmm, ymm, 2, title);
/*
 *  curve(x,y,nval) ;
 */
   points(x, y, nval, ichar, 0) ;

   curve (x, yfit, nval);
   
   frame() ;

   return(0);
}
