/* cpwgl.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Write C/P image into GL window.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 21 March 1991
 * 22 May 1992: scale polaroid images differently than clear images.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include <gl/gl.h>
#include "/local/home/stanger/lib/include/cplib.ext"

cpwgl (namimg)

char *namimg;

{
   extern char *malloc ();
   static unsigned short *imgbuf;
   static unsigned short *linbuf;

   unsigned short pixval1, pixval2;
   int ix, iy;
   int ny;
   int scale;
   int xllo =   63;
   int yblo =   63;
   int xrlo =  510;
   int ytlo =  510;
   int xlhi =  127;
   int ybhi =  127;
   int xrhi = 1022;
   int ythi = 1022;
   int yhalf;
   int ymax;

   /*** Read image from disk into memory. ***/

   imgbuf = (unsigned short *) rdimg (namimg);
   if (nbypix != 2)
      {
      fprintf (stderr, "*** cpwgl> Invalid image.  Must be calibrated C/P.\n");
      return (-1);
      }

   if (H.ipw == 0)  scale = 2;  else scale = 1;

   /*** Flip image top to bottom since C/P origin is upper left corner. ***/

   linbuf = (unsigned short *) malloc (npixl * nbypix);
   ymax = npixl - 1;
   yhalf = npixl / 2;

   for (iy=0; iy<yhalf; iy++)
      {
      ny = ymax - iy; 
      for (ix=0; ix<npixl; ix++)
         {
         pixval1 = *(imgbuf + ix + iy*npixl) / scale;
         pixval2 = *(imgbuf + ix + ny*npixl) / scale;
         if (pixval1 > 255)  pixval1 = 255;
         if (pixval2 > 255)  pixval2 = 255;
         *(imgbuf + ix + iy*npixl) = pixval2;
         *(imgbuf + ix + ny*npixl) = pixval1;
         }
      }

   if (H.ires == 0)
      rectwrite (xlhi, ybhi, xrhi, ythi, imgbuf);
   else
      rectwrite (xllo, yblo, xrlo, ytlo, imgbuf);
         
   return (0);
}
