/* cpdb.h
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Access to SMM C/P Informix data base structures and field lists.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger	HAO/NCAR   SMM C/P
 * 24 May 1989: Adapt for Informix ESQL/C on Yoda (Sun-4/280).
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

/*** Catalog Table ***/

char   cat_image_id[17];	/* File name: ydddhhmm.vxx */
int    cat_sequence;		/* Image frame counter [0-4095]. */
short  cat_quantity;		/* Image quantity [0-100%]. */
short  cat_status;		/* Bit-encoded status. */
short  cat_quality;		/* Image quality classification code. */
short  cat_corona;		/* Coronal activity code. */
short  cat_roll;		/* S/C roll [degrees]. */
short  cat_exposure; 		/* Exposure duration [*1.024 seconds]. */
char   cat_hvres[4];		/* horizontal/vertical parameter & resolution.*/
char   cat_polaroid[4];		/* polaroid filter: clr, +60, 0, -60 deg. */
char   cat_filter[3];		/* spectral filter: b,r,g,c,wb,Ha). */
char   cat_sector[3];		/* sector mirror: n,ne,e,se,s,sw,w,nw. */
char   cat_cal_mirror[2];	/* calibration mirror: i/o. */
char   cat_store1[7];		/* Archive storage identifier #1. */
char   cat_store2[7];		/* Archive storage identifier #2. */

short  ucat_quality;		/* Image quality classification code. */
short  ucat_corona;		/* Coronal activity code. */
short  tcat_quality;		/* Image quality classification code. */
short  tcat_corona;		/* Coronal activity code. */

/*** Notelog Table ***/

char   note_note_id[17];	/* Image file name: ydddhhmm.vxx */
char   note_notes[65];		/* Image comments. */

char   unote_note_id[17];	/* Image file name: ydddhhmm.vxx */
char   unote_notes[65];		/* Image comments. */
char   tnote_note_id[17];	/* Image file name: ydddhhmm.vxx */
char   tnote_notes[65];		/* Image comments. */

/*** Daylog Table ***/

char   day_doy_id[6];		/* Year+DOY */
char   day_medium1[7];		/* Storage #1 medium name. */
char   day_dataset1[7];		/* Storage #1 dataset name. */
char   day_medium2[7];		/* Storage #2 medium name. */
char   day_dataset2[7];		/* Storage #2 dataset name. */

char dbname [16];		/* C/P database name. */
char pathname[] = "/cp";
FILE *LOG;
