/* dgmtmod.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Recomputes GMT for C/P images, writes new image files.
 * Opens directory of images, gets housekeeping, and writes header on screen.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger	HAO/NCAR	SMM C/P
 * 11 April 1985
 *  5 June 1988: modify for Informix ESQL/C on Yoda (Sun-4/280).
 * 24 October 1989: Use fgets to read output from `ls' process.
 * 12 January 1990: Change maindir to "/cp".
 * 25 January 1991: ask user for main directory
 * 25 June 1996: update directory name for "cplib.h".
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "cpdb.h"
#include "/home/riker/stanger/lib/include/cplib.h"

/* Global definitions.  */

char lsdir [84];
char imdir [84];
char imgpath [84];

main (argc, argv)

int argc;
char *argv[];
{
static	char	logfile [80];
static	char	namfil [80], buff [80], syear [4];
static	char	maindir [4] = "/cp";
static	char	cpdir [80] = ".";
static	char	cdate [6];
char	imgtype;
int	idot;
int	i;
int	lenfile;
int	ii;
FILE	*DIR, *popen ();

/* Request directory name if not provided on command line. */

   if (argc == 1)
      {
      fprintf (stderr, "Usage: dgmtmod [imdir]]\n");
      fprintf (stderr, "Enter name of directory containing images : ");
      fscanf  (stdin,  "%s", imdir);
      }
   else
      {
      strcpy (imdir, argv [1]);
      }

   sprintf (logfile, "%s/dgmtmod.log", cpdir);
   if ((LOG = fopen (logfile, "w")) == NULL)
      {
      fprintf (stderr, "Unable to open file  %s\n", logfile);
      exit (-4);
      }

/*
   ii = -1;
   for (i = 0; i < strlen (imdir); i++)  if (imdir [i] == '/')  ii = i;
   strncpy (syear, &imdir [ii+1], 2);
   if (  (strcmp (syear,"80") != 0) && (strcmp (syear,"84") != 0)
      && (strcmp (syear,"85") != 0) && (strcmp (syear,"86") != 0)
      && (strcmp (syear,"87") != 0) && (strcmp (syear,"88") != 0)
      && (strcmp (syear,"89") != 0)  )
      {
      fprintf (LOG, "Invalid directory.\n");
      exit (-1);
      }
 */
   sprintf (lsdir, "ls %s", imdir);

/* Get directory. */

   DIR = popen (lsdir, "r");

   fprintf (LOG,"     G M T          Q(%%)  IMG  H-V RES  EXP FW PW  5303 SM CM --ROLL--\n");

/* Start going through data. */

   while (fscanf (DIR, "%s", namfil) != EOF)
      {
      lenfile = strlen (namfil);
      fprintf (stderr, "\nnamfil: %s   lenfile: %d\n", namfil, lenfile);

      for (i = 0; i < lenfile; i++) if (namfil [i] == '.')  idot = i;
      if (idot < 0 || (namfil [idot+1] != 'v' && namfil [idot+1] != 'c'))
         {
         fprintf (LOG, "Invalid file name: %s\n", namfil);
         exit (-2);
         }

      gmtmv (imdir, namfil);
      }
   while (fgets (buff, 80, DIR)) puts (buff); 
   pclose (DIR);
}
