/* wrimg(namimg, image)
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Write SMM C/P image from memory array to a disk file.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Solar Maximum Mission   Coronagraph/Polarimeter
 * Andrew L. Stanger
 * 6 August 1984
 * 25 June 1996: update directory name for "cplib.ext".
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <sys/types.h>
#include <stdio.h>
#include "/home/riker/stanger/lib/include/cplib.ext"

/* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

wrimg (namimg, image)

char *namimg;	/* Pointer to image disk file name. */
u_char *image;	/* Pointer to image array. */

{
register   int	imgfd;	/* File descriptor for image disk file. */
register   int	imgsiz; /* Image size (bytes) (excluding hskp & bitmap). */
register   long	nwrite;

/*** Open image file. ***/

   if ((imgfd = creat (namimg, 0644)) < 0)
      {
      fprintf (stderr, "wrimg> Can't create file %s\n", namimg);
      return (NULL);
      }
   close (imgfd);

   if ((imgfd = open (namimg, 1)) < 0)
      {
      fprintf (stderr,"wrimg> Can't open file %s\n", namimg);
      return (NULL);
      }

   if (nbypix == 2)
      {
      imgsiz = (npix * npix);
      srevbyt ((image + npix * nbypix * 2), nbypix, imgsiz);
      }

/*** Position I/O pointer to beginning of disk file. ***/

   imgsiz = ((npix+2) * npix * nbypix);

   if ((nwrite = write (imgfd, image, imgsiz)) <= 0)
      {
      fprintf (stderr,"wrimg> image write error.\n");
      return(NULL);
      }

/***   printf ("wrimg> nwrite: %d\n", nwrite); ***/

   if (close (imgfd) == -1)
      {
      fprintf (stderr,"wrimg> file close error.%s\n", namimg);
      return (NULL);
      }
  return (0);
}
