/* cpfits3.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Convert SMM C/P image(s) to FITS format.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   27 September 2002
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Extension now completely describes the C/P housekeeping "header".
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#define START
#include "/home/stanger/lib/include/smmcplib.h"

/* -------------------------------------------------------------------------- */

main (argc, argv)

int argc ;
char *argv [] ;

{
   char imgbuf ;
   static char linbuf [84] ;
   static char name [80] ;
   static char namimg [80] ;
   static char namlst [80] ;
   FILE *LIST, *IN, *OUT ;
   int pmode = 0 ;		/* Print mode: 0=silent, 1=verbose. */

   /*** Process command line arguments. ***/

   if (argc == 2)
      {
      strcpy (name, argv [1]) ;
      }
   else
      {
      fprintf (stderr, "usage: %s image_file | @image_file_list\n",
	       argv [0]) ;
      fprintf (stderr, "image_file_list:	file containing a list of raw SMM C/P filenames\n") ;
      exit (-1) ;
      }

   /*** If first argument begins with '@', it is a list file. ***/

   if (name [0] == '@')		/* Read list file. */
      {
      strcpy (namlst, &name [1]) ;
      if ((LIST = fopen (namlst, "r")) == NULL)
	 {
	 fprintf (stderr, "Unable to open file: %s\n", namlst) ;
	 exit (-2) ;
	 }

      while (fgets (linbuf, 80, LIST) != NULL)
	 {
	 sscanf (linbuf, "%s", namimg) ;
	 fprintf (stdout, "%s\n", namimg) ;

         if (strlen (namimg)  == 0)
	    break ;

         cptofits3 (namimg, pmode) ;

/*         strcpy (namimg,  NULL) ; */
	 namimg [0] = '\0' ;
	 }
      fclose (LIST) ;
      }

   else			/* Argument(s) are normal C/P image file(s). */

      {
      strcpy (namimg, name) ;

      cptofits3 (namimg, pmode) ;	/* hskp + bitmap ext. */

      }

   exit (0) ;
}
