/* sunos_time (ic)
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Fetches current date and time.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Uses current date and time to return decimal values for
 * Day-of-Year, day, month, and year-1900.
 * Also returns values for hours, minutes, and seconds.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * 12 January 1984
 * Andrew L. Stanger
 * SunOS 4.0.3  (UNIX 4.2 BSD)   C programming language
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 */

#include <sys/types.h>
#include <time.h>


struct blee { int iyear; int idoy; int iday; int imonth;
              int ihour; int imin; int isec; } ;

sunos_time (ic)

struct blee *ic;
{
   struct tm *localtime (), *lclt;
   long time (), t;

   t = time (0);
   lclt = localtime (&t);
   ic->iyear = lclt->tm_year;
   ic->idoy =  lclt->tm_yday + 1;
   ic->iday =  lclt->tm_mday;
   ic->imonth =  lclt->tm_mon + 1;
   ic->ihour = lclt->tm_hour;
   ic->imin =  lclt->tm_min;
   ic->isec =  lclt->tm_sec;

   return (0) ;
}
