/* quadin.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Routine to insert picture at llx,lly offset from 0,0 of big picture,
 * with center defined as cx,cy.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * nbypix: # bytes per pixel (=1 for raw images, =2 for calibrated images).
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Adapted & maintained by Andrew L. Stanger   HAO/NCAR   SMM C/P
 * 30 December 1986: set yoff = 0.
 * 10 September 1987: Adapt for use with both raw & calibrated images.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include	<stdio.h>

quadin (cx,cy)

   int	cx,cy;

{
	extern	FILE	*Image;
	extern	char 	pakraw[896][896];
	extern	short	pakcal[896][896];
	extern	int nbypix;

	int	l0, ln, p0, pn, ix, iy, llx, lly;
	int	yoff;
	short	line[448];
	char	*linbyt;

	linbyt = (char *) line;

/* Find limits of picture. */

	yoff = 0;
	l0 = (cy <224) ? (cy-yoff):0;	/*if cy<224 start at center-yoff  */
	ln = (cy <224) ? 447:(cy-yoff);	/*if cy<224 end at bottom-yoff    */
	p0 = (cx <224) ? cx:0;		/*if cx<224 start at center	*/
	pn = (cx <224) ? 447:cx;
	llx = (cx > 224) ? 448-cx-p0:448-p0;
	lly = (cy > 224) ? 448-cy-l0:448-l0-yoff;

	printf("cx, cy=  %d, %d\n", cx, cy);
	printf("l0, ln=  %d, %d\n", l0, ln);
	printf("p0, pn=  %d, %d\n", p0, pn);
	printf("llx, lly=  %d, %d\n", llx, lly);

/* Read and insert. */

	if (nbypix == 1)	/* Raw images. */
	   {
	   for (iy=0; iy<l0; iy++)
	      fread(linbyt, nbypix, 448, Image);   /* Skip to beginning ! */

	   for (iy=l0; iy<=ln; iy++)
	      {
	      if(fread(linbyt, nbypix, 448, Image) != 448)
	         {
	         if(feof(Image))
	            fprintf(stderr,"Unexpected EOF (file) iy:%d\n", iy);
	         else
	            perror("fread");
	         exit(1);
	         }

	      for (ix=p0; ix<pn; ix++) pakraw[lly+iy][llx+ix] = linbyt[ix]; 
	      }
	   }
	else
	   {			 /* nbypix = 2  (Calibrated images). */
	   for (iy=0; iy<l0; iy++)
	      fread(line, nbypix, 448, Image);   /* Skip to beginning ! */

	   for (iy=l0; iy<=ln; iy++)
	      {
	      if(fread(line, nbypix, 448, Image) != 448)
	         {
	         if(feof(Image))
	            fprintf(stderr,"Unexpected EOF (file) iy:%d\n", iy);
	         else
	            perror("fread");
	         exit(1);
	         }

	      for (ix=p0; ix<pn; ix++) pakcal[lly+iy][llx+ix] = line[ix]; 
	      }
	   }
	return;
}
