/* srevbyt.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Reverse byte order for a short integer image.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 21 March 1988
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

srevbyt (image, nbytpx, nelem)

char *image;		/* Image array. */
int nbytpx;		/* # bytes per pixel. */
int nelem;		/* # elements in array. */

{
   register char *cimage;
   register char ctemp;
   register int i;

   if (nbytpx != 2)
      {
      fprintf (stderr, "srevbyt> image pixels are NOT short integers.\n");
      return (-1);
      }

   cimage = (char *) image;

/*** Reverse odd & even bytes in image array. ***/

   for (i=0; i<nelem; i++)
      {
      ctemp = *(cimage + 2*i);
      *(cimage + 2*i)   = *(cimage + 2*i+1);
      *(cimage + 2*i+1) = ctemp;
      }
   return (0);
}
