; rs.pro
;*******************************************************************************
; Display image & perform radial scan from 1.5-5 Rsun @ theta = 0 degrees.
; For Low Resolution, north SMM C/P image only.
;*******************************************************************************
; namimg: string containing name of C/P image.
;*******************************************************************************
; Andrew L. Stanger
; 27 January 1993: IDL procedure
;*******************************************************************************
PRO rs, namimg

   !order = 1
;
;  Declare byte arrays.
;
   hk = bytarr (448)
   bm = bytarr (448)
   bbuf = bytarr (448, 448)
;
;  Read image into memory.
;
   rdcp, namimg, hk, bm, bbuf
;
;  Create window for image display.
;
   imgsize = size (bbuf)
   xll = 1270 - imgsize (1) 
   yll = 10
   window, 1, xsize = imgsize (1), ysize = imgsize (2), xpos = xll, ypos = yll
;
;  Display C/P image
;
   tv, bbuf
;
   r = findgen (256)
   g = findgen (256)
   b = findgen (256)
   tvlct, r, g, b
;
   rmin = 1.5
   rmax = 5.0
   rinc = 0.1
   theta = 0.0
   ns = 0
;
   irscan, namimg, bbuf, rmin, rmax, rinc, theta, scan, scandx, ns, ierr
;
   wset, 0
   plot, scandx, scan,  $
   TITLE="Radial Scan", $
   XTITLE="Radius (Rsun)", $
   YTITLE="Brightness (DN)"
   RETURN
END
