/* chres.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Change resolution in C/P housekeeping byte #.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   SMM C/P
 * 15 August 1990
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "/usr/people/smm/lib/include/cplib.h"

main (argc, argv)

int argc;
char *argv [];
{
   extern char *malloc ();
   char *img;
   static char namlst [80];
   static char namimg [80];
   static char namres [4];

   int fd;
   int ival;
   int nbyimg;
   int nread, nwrite, nclose;
   int seq = 0;				/* Sequence ? =0 no, =1 yes. */

   FILE *LIST;

   if (argc == 2)
      {
      strcpy (namimg, argv [1]);
      fprintf (stderr, "Enter resolution for output image: [l,h]: ");
      fscanf  (stdin,  "%s", namres);
      }
   else
   if (argc == 3)
      {
      sscanf (argv [1], "%s", namres);
      strcpy (namimg, argv [2]);
      }
   else
      {
      fprintf (stderr, "usage: %s [resolution] cp_image_name | @cp_filelist\n", argv [0]);
      exit (0);
      }

   if (namimg [0] == '@')
      {
      strcpy (namlst, &namimg [1]);
      LIST = fopen (namlst, "r");
      seq = 1;
      }
   else
      seq = 0;

next:
   if (seq)
      if (fscanf (LIST, "%s", namimg) == NULL)
	 exit (0);

   fprintf (stdout, "namimg: %s\n", namimg);
   cphskp (namimg);

   nbyimg = (npix + 2) * npix;
   img = malloc (nbyimg);

   fd = open (namimg, 2);
   nread = read (fd, img, nbyimg);

   ival = (int) *(img + 3) & 0377;
   if (namres [0] == 'l')
      ival = ival | 04;
   else
      ival = ival & 373;
   *(img + 3) = (char) ival;

   lseek (fd, 0L, 0);
   nwrite = write (fd, img, nbyimg);
   nclose = close (fd);
   free (img);

   if (seq)  goto next;

   exit (0);
}
