/* putroll.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Store roll (in degreesd) in housekeeping bytes #88 & #89.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   SMM C/P
 *  1 December 1989
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

putroll (cbuf, roll)

char cbuf [];
int roll;

{
   /*** If roll is negative, convert to positive value. ***/

      if (roll < 0)  roll += 360;

   printf ("putroll> roll [degrees]: %d [decimal]   %o [octal]\n", roll, roll);

   /*** Store roll [degree units] into bytes #88 & 89 of housekeeping. ***/

   cbuf [88] = (char) ((roll &0177400) >> 8);
   cbuf [89] = (char)  (roll &   0377);

   return (0);
}
