/* zerohk.c
 * -----------------------------------------------------------------------------
 * Write zeros in C/P image housekeeping.
 * -----------------------------------------------------------------------------
 */
#include <stdio.h>
#include "/usr/people/smm/lib/include/cplib.h"

main (argc, argv)

int argc;
char *argv [];

{
   extern char *malloc ();
   FILE *LIST ;

   char *hk;
   char *bm;
   char *imgbuf;
   static char namimg [80];
   static char namlst [80];

   int fd;
   int i;
   int begseg;
   int nseg;
   int begbyt = 128 ;
   int endbyt = 224 ;
   int nbyhk = 0 ;
   int seq = 0 ;

   if (argc == 2)
      {
      strcpy (namimg, argv [1]) ;
      }

   else
      {
      fprintf (stderr, "usage: %s cp_filename  | @cp_listfile\n", argv [0]) ;
      exit (0) ;
      }

   if (namimg [0] == '@')
      {
      seq = 1 ;
      strcpy (namlst, &namimg [1]) ;
      if ((LIST = fopen (namlst, "r")) == NULL)
	 {
	 fprintf (stderr, "Unable to open file: %s\n", namlst) ;
	 exit (-1) ;
	 }
      }

loop:

   if (seq)
      if (fscanf (LIST, "%s", namimg) == EOF)
	 goto end ;

   /*** Decode housekeeping of C/P image. ***/

   cphskp (namimg);
   nbyhk = npix ;
   hk = malloc (npix);
   bm = malloc (npix);
   imgbuf = malloc (npix*npix);

   /*** Open image disk file and read housekeeping, bitmap, and image data. ***/

   fd = open (namimg, 2);
   read (fd, hk, npix);			/* Read houskeeping. */
   read (fd, bm, npix);			/* Read bitmap. */
   read (fd, imgbuf, npix*npix);	/* Read image data. */

   /*** Modify housekeeping. ***/

   for (i = begbyt; i < nbyhk; i++)  *(hk + i) = 0;
   hk [221] = 1 ;				/* Indicates raw image.*/

   /*** Rewrite modified image to disk file. ***/

   lseek (fd, 0L, 0);			/* Reset file pointer at BOF. */

   write (fd, hk, npix);		/* Write housekeeping. */
   write (fd, bm, npix);		/* Write bitmap. */
   write (fd, imgbuf, npix*npix);	/* Write image data. */

   close (fd);
   free (hk);
   free (bm);
   free (imgbuf);

   if (seq)
      goto loop ;

end:

   exit (0);
}
