/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * divimg.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Divide a calibrated, low resolution C/P image by a second C/P image.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 19 January 1989
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include "/usr/people/smm/lib/src/cp/cplib.h"

main()
{
char *image;
static char namimg1[80];
static char namimg2[80];
static char namout[80];
static char hk[896];
static char bitmap[896];
static unsigned short ibuf1[448], ibuf2[448];
static unsigned short linbuf[448];

int bytord1, bytord2;
int fdin1, fdin2;
int fdout;
int i, line;
int nbypix1, nbypix2;

   fprintf (stdout, "divimg: divide one C/P image by another.\n\n");

   fprintf (stdout, "Enter name of numerator   image file: ");
   fscanf  (stdin,  "%s", namimg1);
   fprintf (stdout, "Enter name of denominator image file: ");
   fscanf  (stdin,  "%s", namimg2);
   strcpy (namout, namimg1);
   strcat (namout, ".b");
   if (strlen(namimg2) >= 8)  strncat (namout, &namimg2[4], 4);
      else strcat (namout, "db");

   /*** Open input & output image files. ***/

   cphskp (namimg2);
   bytord2 = bytord;
   nbypix2 = nbypix;

   cphskp (namimg1);
   bytord1 = bytord;
   nbypix1 = nbypix;
   fdin1 = open (namimg1, 0);
   fdin2 = open (namimg2, 0);
   fdout = creat (namout, 0644);

   /*** Copy housekeeping & bitmap records. ***/

   read (fdin1, hk, 896);
   read (fdin1, bitmap, 896);
   write (fdout, hk, 896);
   write (fdout, bitmap, 896);
   hk [52] = 0;				/* Sun byte order. */
   hk [220] = (char) (-3 & 0377);

   read (fdin2, hk, 896);
   read (fdin2, bitmap, 896);

   /*** Divide image #1 by image #2. ***/
   /*** Multiply result by 250 and store as a short integer. ***/

   for (line=0; line<448; line++)
      {
      read (fdin1, ibuf1, 896);
      read (fdin2, ibuf2, 896);
      if (nbypix1 == 2 && bytord1 == 1)
         srevbyt (ibuf1, nbypix, 448);
      if (nbypix2 == 2 && bytord2 == 2)
         srevbyt (ibuf2, nbypix, 448);

      for (i=0; i<448; i++)
	 {
         if (*(ibuf1 + i) > 0)
	    *(linbuf + i) =
	       (unsigned short) (((float) *(ibuf1 + i) / (float) *(ibuf2 + i)) * 250.0);
         else
	    *(linbuf + i) = 0;
         if (*(linbuf + i) > 250)  *(linbuf + i) = 250;
         }

      fprintf (stdout, "linbuf[%3d]: %d\n", line, *(linbuf + line));
      write (fdout, linbuf, 896);
      }

   close (fdin1);
   close (fdin2);
   close (fdout);
}
