/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * fmulpbk.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Multiply a low resolution C/P image [pB] by a constant factor [1/(pol frac)].
 * Output image is floating point, data type 6 [Bk].
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 2 May 1990
 * 6 November 1990: Output image is type 6 [Bk].
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include "/home/riker/stanger/lib/include/cplib.h"
#define maxhk 1792
#define maxmap 2688
#define maxpix 896

main()
{
char *image;
static char namimg [80];
static char namtmp [80];
static char namout [80];
static char hk [maxhk];
static char bitmap [maxmap];
static short linbuf [maxpix];
static float flinbuf [maxpix];
int fdin;
int fdout;
int i, line;
int idot;
int nbyhk, nbymap;
int nbylin;
int nfblin;
int polpct;
/* float factor = 1.666666;  Polarization = .6  */
/* float factor = 1.5;       Polarization = .67 */
/* float factor = 1.5873;    Polarization = .63 */ 
/* float factor =1.53846;    Polarization = .65 */
/* float factor = 1.0000;    Polarization = 1. */
 float factor = 2.000;   /*  Polarization = .50 */
/* float factor = 1.81818;   Polarization = .55 */

   fprintf (stdout, "Enter name of image file: ");
   fscanf  (stdin,  "%s", namimg);

   fprintf (stdout, "Enter polarization percentage: ");
   fscanf  (stdin, "%d", &polpct);
   factor = 100.0 / (float) polpct;
   fprintf (stderr, "Multiplicative factor: %f\n", factor);
   strcpy (namtmp, namimg);
   for (i=0; i < strlen (namimg); i++)
      {
      idot = i;
      if (namimg[i] == '.')  break;
      }
   namtmp [idot] = '\0';
   sprintf (namout, "%s.bk%02d", namtmp, polpct);
   fprintf (stderr, "Output file name : %s\n", namout);

   /*** Open input & output image files. ***/

   cphskp (namimg);
   if (idtype != 10)
      {
      fprintf (stderr, "Invalid image data type (%d).  Should be pB image.\n",
	       idtype);
      exit (-1);
      }
   fdin = open (namimg, 0);
   if (fdin < 0)
      {
      fprintf (stderr, "Unable to open %s\n", namimg);
      exit (-2);
      }
   fdout = creat (namout, 0644);
   cphskp (namimg);
   nbylin = npixl * nbypix;
   nfblin = npixl * sizeof (float);
   if (nbypix == 4)
      {
      nbyhk = npixl;
      nbymap = nfblin - npixl;
      }
   else nbyhk = nbymap = nbylin;
   printf ("npixl: %d   nbypix: %d   nbyhk: %d   nbymap: %d\n",
	   npixl, nbypix, nbyhk, nbymap);
   printf ("pscale: %g\n", pscale);

   /*** Copy housekeeping & bitmap records. ***/

   for (i=0; i<maxhk;  i++)  hk [i] = (char) 0;
   for (i=0; i<maxmap; i++)  bitmap [i] = (char) 0;
   read (fdin, hk, nbyhk);
   read (fdin, bitmap, nbymap);
   hk [103] = (char) 32;
   hk [220] = (char) 0;
   hk [221] = (char) 32;		/* Bk data type. */
   write (fdout, hk, npixl);
   write (fdout, bitmap, (nfblin-npixl));

   /*** Multiply input image by constant factor and write to output file. ***/

   for (line = 0; line < npixl; line++)
      {
      read (fdin, linbuf, nbylin);
      if (bytord == 1)  srevbyt (linbuf, nbypix, npixl);

      for (i=0; i<npixl; i++)
	 *(flinbuf + i) = ((float) *(linbuf + i)) * factor * pscale;

      write (fdout, flinbuf, nfblin);
      }

   close (fdin);
   close (fdout);
}
