/* average (nave, buf, nval)
 *--------------------------------------------------------------------
 *** Averaging routine for an array of floating point numbers.
 *--------------------------------------------------------------------
 *    Andrew L. Stanger   HAO/NCAR   SMM C/P
 *    4 March 1983
 *    6 August 1984: converted from 11/34 (f4p) to VAX 750 (C).
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *
 *    nave = # elements to average.
 *    buf  = floating point array.
 *    nval = number of elements in array buf.
 *
 */

#include <sys/types.h>
#include "/usr/people/smm/lib/include/cplib.h"

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

average (nave, buf, nval)

u_char buf[];
int nave;	/* # points to average. */
int nval;	/* # values in array buf. */

{

#define NT 896
   float	temp[NT];	/* Temporary storage array. */
   float	sum;
   int i, is, navehalf;
   short	*ps;


   if (nave <= 1)  return;
   if (nval > NT)
      {
      printf ("Array too large for smoothing routine.\n");
      return;
      }

   /*** Copy input array into temp buffer. ***/

   if (nbypix == 1)
      {
      for (i = 0; i < nval; i++)  temp[i] = (float) buf[i];

      /*** Average over 'nave' points. ***/

      navehalf = nave / 2;
      for (i = navehalf; i < (nval-navehalf); i++)
         {
         sum = 0.;
         for (is = 0; is < nave; is++)  sum = sum + temp[i-navehalf+is];
         *(buf + i) = (u_char) (sum / (float) nave);
         }
      }

   else

      {
      ps = (short *) buf;
      for (i = 0; i < nval; i++)  temp[i] = (float) *(ps + i);

      /*** Average over 'nave' points. ***/

      navehalf = nave / 2;
      for (i = navehalf; i < (nval-navehalf); i++)
         {
         sum = 0.;
         for (is = 0; is < nave; is++)  sum = sum + temp[i-navehalf+is-1];
         *(ps + i) = (char) (sum / (float) nave);
         }
      }

   return (0);
}
