/* blrmcms.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * SMM C/P blemish removal.
 * For calibration reticle images.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 31 July 1992: SGI GL version.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#define NBOX 8

blrmcms (imgbuf, xdim, ydim)

unsigned short *imgbuf;				/* Image buffer. */
int xdim, ydim;					/* Image dimension.s */
{
   int level = -1;
   int x, y;
   int dx, dy;
   static int nbox = NBOX;
   static int xx  [NBOX] = {274, 274, 274, 281, 286, 286, 283, 180};
   static int yy  [NBOX] = {240, 264, 278,  63, 143, 284, 400, 140};
   static int dxx [NBOX] = { 34, 42,  34,   26,  16,  18,  22,  40};
   static int dyy [NBOX] = { 28, 16,  18,   80,  98, 116, 112,  46};
   static char dir2[3] = "ru";
   static char ddir[2] = "l";

   /*** Center spot. ***/

   hints (imgbuf, xdim, ydim, level, 2,
          &xx [0], &yy [0], &dxx [0], &dyy [0], dir2);

   vints (imgbuf, xdim, ydim, level, 1,
          &xx [2], &yy [2], &dxx [2], &dyy [2], dir2);

   /*** Vertical line. ***/

   hints (imgbuf, xdim, ydim, level, 4,
          &xx [3], &yy [3], &dxx [3], &dyy [3], dir2);

   /*** Upper left diagonal line. ***/

   x = 276;   y = 280;
   dx = 20;   dy = 50;
   strcpy (ddir, "l");
   dfill (imgbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);

   x = 238;   y = 320;
   dx = 20;   dy = 50;
   dfill (imgbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);

   x = 194;   y = 370;
   dx = 20;   dy = 50;
   dfill (imgbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);

   x = 150;   y = 420;
   dx = 20;   dy = 85;
   dfill (imgbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);

   /*** Lower left diagonal line. ***/

   x = 212;   y = 182;
   dx = 20;   dy = 62;
   strcpy (ddir,  "r");
   dfill (imgbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);

   /*** Lower left bullet hole. ***/

   vints (imgbuf, xdim, ydim, level, 1,
          &xx [7], &yy [7], &dxx [7], &dyy [7], dir2);

   return (0);
}
