/* blrmcms4.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * SMM C/P blemish removal for calibration reticle images.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 17 November 1988
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#define NBOX 6

blrmcms (lgrdev, cha, chb)

int lgrdev;		/* Grinnell device [0,1] */
int cha, chb;		/* Input & output Grinnell channels. */
{
int level = -1;
int x, y;
int dx, dy;
static int nbox = NBOX;
static int xx[NBOX] = {270,268,301,273,270,185};
static int yy[NBOX] = {284,218,266,243, 63,145};
static int dxx[NBOX] ={ 11, 10,  8, 37, 43, 36};
static int dyy[NBOX] ={ 23, 20, 24,268,180, 41};
static char dir2[3] = "ru";
static char ddir[2] = "l";

	disp (cha);
	if (cha != chb)  chcopy (cha, chb);
	disp (chb);
	rwech (chb);

/* Lower left bullet hole. */

	vints(lgrdev,chb,chb,level,1,&xx[5],&yy[5],&dxx[5],&dyy[5],dir2);

/* Vertical line. */

	strcpy (dir2, "ru");
	vints(lgrdev,chb,chb,level,3,&xx[0],&yy[0],&dxx[0],&dyy[0],dir2);
	hints(lgrdev,chb,chb,level,2,&xx[3],&yy[3],&dxx[3],&dyy[3],dir2);

/* Upper left diagonal line. */

	x = 280;
	y = 280;
	dx = 20;
	dy = 50;
	strcpy (ddir, "l");
	dfill (lgrdev,chb,chb,level,x,y,dx,dy,dir2,ddir);
	x = 242;
	y = 320;
	dx = 20;
	dy = 50;
	dfill (lgrdev,chb,chb,level,x,y,dx,dy,dir2,ddir);
	x = 197;
	y = 370;
	dx = 20;
	dy = 50;
	dfill (lgrdev,chb,chb,level,x,y,dx,dy,dir2,ddir);
	x = 152;
	y = 420;
	dx = 20;
	dy = 85;
	dfill (lgrdev,chb,chb,level,x,y,dx,dy,dir2,ddir);

/* Lower left diagonal line. */

	x = 215;
	y = 182;
	dx = 16;
	dy = 62;
	strcpy (ddir, "r");
	dfill (lgrdev,chb,chb,level,x,y,dx,dy,dir2,ddir);
   return(0);
}
