/* blrms.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * SMM C/P blemish removal.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 11 August 1986
 * 23 July 1992: SGI GL version.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#define NBOX 6

blrms (imgbuf, xdim, ydim)

unsigned short *imgbuf;				/* Image buffer. */
int xdim, ydim;					/* Image dimension.s */
{
   int level = -1;
   int x, y;
   int dx, dy;
   static int nbox = NBOX;
   static int xx  [NBOX] = {270, 268, 301, 270, 185};
   static int yy  [NBOX] = {284, 218, 266,  63, 145};
   static int dxx [NBOX] = { 11,  10,   8,  44,  36};
   static int dyy [NBOX] = { 23,  20,  24, 448,  41};
   static char dir2[3] = "ru";
   static char ddir[2] = "l";

   /*** Vertical line. ***/

   strcpy (dir2, "ru");

   vints (imgbuf, xdim, ydim, level, 3,
          &xx [0], &yy [0], &dxx [0], &dyy [0], dir2);

   hints (imgbuf, xdim, ydim, level, 1,
          &xx [3], &yy [3], &dxx [3], &dyy [3], dir2);

   /*** Upper left diagonal line. ***/

   x = 280;   y = 280;
   dx = 20;   dy = 50;
   strcpy (ddir, "l");
   dfill (imgbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);

   x = 242;   y = 320;
   dx = 20;   dy = 50;
   dfill (imgbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);

   x = 197;   y = 370;
   dx = 20;   dy = 50;
   dfill (imgbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);

   x = 152;   y = 420;
   dx = 20;   dy = 85;
   dfill (imgbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);

   /*** Lower left diagonal line. ***/

   x = 215;   y = 182;
   dx = 16;   dy = 62;
   strcpy (ddir,  "r");
   dfill (imgbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);

   /*** Lower left bullet hole. ***/

   vints (imgbuf, xdim, ydim, level, 1, &xx[4], &yy[4], &dxx[4], &dyy[4], dir2);

   return (0);
}
