/* bpimg.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Plot bright point locations (pinholes).
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 30 April 1993
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

#define NDOTS 10 
#define SBOX 5 

main (argc, argv)

int argc;
char *argv [];

{
   static unsigned char imgbuf [448][448];
   static char namfil [80];

   int cx, cy;
   int fd;
   int i;
   int idot;
   int ix, iy;
   int ndots;
   int xdim = 448;
   int ydim = 448;

   static int nbox = NDOTS;
   static int dx =  SBOX;
   static int dy =  SBOX;

   static int xb [NDOTS] = {208, 226, 215, 253, 250, 371, 494, 497, 325, 414};
   static int yb [NDOTS] = {504, 504, 493, 494, 418, 340, 303, 228, 159, 130};
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

   if (argc == 2)
      {
      strcpy (namfil, argv [1]);
      }
   else
      {
      fprintf (stderr, "usage: %s output_file_name\n", argv [0]);
      exit (-1);
      }

   ndots = NDOTS;

   /*** Initialize entire image to white. ***/

   for (iy = 0; iy < ydim; iy++)
      for (ix = 0; ix < xdim; ix++)
	 imgbuf [iy][ix] = (unsigned char) 255;

   /*** For each reseau dot, write a small box outline in black. ***/

   for (idot = 0; idot < ndots; idot++)
      {
      cy = 510 - yb [idot];			/* Convert coordinates. */
      cx = xb [idot] - 63;
      printf ("dot:%3d   cx:%3d   cy:%3d\n", idot, cx, cy);
      for (iy = cy - dy/2; iy <= cy + dy/2; iy++)
	 for (ix = cx - dx/2; ix <= cx + dx/2; ix++)
	    imgbuf [iy][ix] = (unsigned char)   0;

/*
      iy = cy - dy/2;
      for (ix = cx - dx/2; ix <= cx + dx/2; ix++)
	    imgbuf [iy][ix] = (unsigned char) 0;
      iy = cy + dy/2;
      for (ix = cx - dx/2; ix <= cx + dx/2; ix++)
	    imgbuf [iy][ix] = (unsigned char) 0;

      ix = cx - dx/2;
      for (iy = cy - dy/2; iy <= cy + dy/2; iy++)
	    imgbuf [iy][ix] = (unsigned char) 0;

      ix = cx + dx/2;
      for (iy = cy - dy/2; iy <= cy + dy/2; iy++)
	    imgbuf [iy][ix] = (unsigned char) 0;

 */
      }

   /*** Write image to disk file. ***/

   fd = creat (namfil, 0644);
   write (fd, imgbuf, xdim*ydim);
   close (fd);

   return (0);
}
