/* cftest.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Test circular interpolation.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 9 December 1992
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "/usr/people/smm/lib/include/cplib.h"

main (argc, argv)

int argc;
char *argv [];

{
   extern char *rdfimg () ;
   static char namimg [80] ;	/* Image name. */
   static char namlst [80] ;	/* File list name. */
   static char namout [80] ;	/* Image name. */

   char  *cpimg ;		/* Pointer to 1 byte image array + header. */
   char  *imgbuf ;		/* Pointer to 1 byte image array. */

   int   i;			/* General index. */
   int   idot;			/* Index for '.' */
   int   fd ;			/* File descriptor. */
   int   nbyhdr ;		/* # bytes in image header (hskp + bitmap). */
   int   nbypx ;		/* # bytes per pixel. */
   int   nbyimg ;		/* # bytes per image. */
   int   nrechdr ;		/* # logical records in image header. */
   int   seq = 0;		/* Sequence: =0 no, =1 yes. */
   int   xd, yd ;		/* Dimensions of imgbuf. */
   int   rc = 20 ;		/* Circle radius (pixel units). */
   int   xc = 137, yc = 346 ;	/* Circle center coordinates (pixel units). */

   FILE *LIST;

   if (argc == 2)
      strcpy (namimg, argv [1]) ;
   else
   if (argc == 3)
      {
      sscanf (argv [1], "%d", &rc);
      strcpy (namimg, argv [2]) ;
      }
   else
   if (argc == 5)
      {
      sscanf (argv [1], "%d", &rc);
      sscanf (argv [2], "%d", &xc);
      sscanf (argv [3], "%d", &yc);
      strcpy (namimg, argv [4]) ;
      }
   else
      {
      fprintf (stderr, "usage: %s [radius] [xcen ycen] cp_image | @filelist\n",
	       argv [0]) ;
      exit (0) ;
      }

   if (namimg [0] == '@')
      {
      seq = 1;
      strcpy (namlst, &namimg [1]);
      if ((LIST = fopen (namlst, "r")) == NULL)
	 {
	 fprintf (stderr, "Unable to open file: %s\n", namlst);
	 exit (-1);
	 }
      }
   else seq = 0;

next:

   if (seq)
      if ((fscanf (LIST, "%s", namimg)) == EOF)  exit (0);

   /*** Read C/P image into memory. ***/

   cpimg = rdfimg (namimg) ;
   nbypx = nbypix ;
   if (nbypx == 4)  nrechdr = 1;  else nrechdr = 2;
   nbyhdr = npix * nbypx * nrechdr;
   nbyimg = npix * npix * nbypx ;
   xd = yd = npix ;
   imgbuf = cpimg + nbyhdr ;

   /*** Perform circular interpolation. ***/

   cirint (imgbuf, nbypx, xd, yd, rc, xc, yc);
   cirint (imgbuf, nbypx, xd, yd, rc, xc+1, yc);

   /*** Write interpolated image to disk. ***/

   strcpy (namout, namimg);
   for (i = 0; i < strlen (namimg); i++)
      {
      if (namimg [i] == '.')
	 {
	 idot = i;
	 break;
	 }
      }
   namout [idot+1] = 'r';
   printf ("namout: %s\n", namout);

   fd = creat (namout, 0644) ;
   write (fd, cpimg , nbyhdr) ;
   write (fd, imgbuf, nbyimg) ;
   close (fd) ;

   free (cpimg);
   if (seq)  goto next;

   exit (0) ;
}
