/* blrms.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * SMM C/P beam blemish removal.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 *  7 June 1993
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "/usr/people/smm/lib/include/cplib.ext"

blrms (ibuf, nbypx, xdim, ydim, width)

unsigned char *ibuf;		/* Image buffer. */
int nbypx;				/* # bytes per pixel. */
int xdim;			/* X-dimension. */
int ydim;			/* Y-dimension. */
int width;			/* Width of vertical blemish (pixels). */
{
   unsigned char *cbuf;
   static char dirint [2] = "v" ;	/* Interpolation direction. */
/*
   static int xloc [11] = { 14,  38,  90, 218, 142, 156, 167, 174, 214, 230, 230};
   static int yloc [11] = {  6,  31,  88, 224, 339, 327, 321, 314, 277,   0, 447};
 */
   static int xloc [11] = { 14,  38,  90, 214, 159, 211, 221, 154, 215, 230, 230};
   static int yloc [11] = {  6,  32,  91, 225, 317, 270, 248, 330, 273,   0, 447};

   int i;
   int iarg;				/* Argument index. */
   int idot;				/* Index for '.' */
   int linloc = 0;			/* Flag: line location specification. */
   int nint   = 0 ;			/* # pixels for interpolation. */
   int nbyimg;				/* # bytes per image. */
   int seq = 0;				/* Sequence: =0 no, =1 yes. */
   int xd, yd;				/* Image dimensions. */
   int xbeg, ybeg ;			/* End coordinates of line. */
   int xend, yend ;			/* End coordinates of line. */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

   cbuf = (unsigned char *) ibuf;
   nbypx = 1;
   xd = yd = npix;

   xbeg =  20 ;			/* Defaults for upper left diagonal line. */
   ybeg =  13 ;
   xend = 218 ;
   yend = 223 ;

   /*** Upper left diagonal line. ***/

   strcpy (dirint, "h");
   nint = 17;
   slint (cbuf, nbypx, xd, yd, xloc [0], yloc [0], xloc [1], yloc [1],
          nint, dirint);

   strcpy (dirint, "v");
   nint = 27;
   slint (cbuf, nbypx, xd, yd, xloc [1], yloc [1], xloc [2], yloc [2],
          nint, dirint);

   nint = 27;
   slint (cbuf, nbypx, xd, yd, xloc [2], yloc [2], xloc [3], yloc [3],
          nint, dirint);

   /*** Lower left diagonal line.  ***/

   nint = 15;
   strcpy (dirint, "v");
   slint (cbuf, nbypx, xd, yd, xloc [4], yloc [4], xloc [5], yloc [5],
          nint, dirint);
   nint = 7;
   strcpy (dirint, "h");
   slint (cbuf, nbypx, xd, yd, xloc [5], yloc [5], xloc [6], yloc [6],
          nint, dirint);
/*
 *   slint (cbuf, nbypx, xd, yd, xloc [6], yloc [6], xloc [7], yloc [7],
 *          nint, dirint);
 *   slint (cbuf, nbypx, xd, yd, xloc [7], yloc [7], xloc [8], yloc [8],
 *          nint, dirint);
 */

   /*** Vertical line blemish. ***/

   if (width == 0)
      return  (0);
   else
      nint = width;

   strcpy (dirint, "h");

   if (linloc == 0)
      {
      xbeg = xloc [9];
      ybeg = yloc [9];
      xend = xloc [10];
      yend = yloc [10];
      }

   slint (cbuf, nbypx, xd, yd, xbeg, ybeg, xend, yend,
	  nint, dirint);

   return (0);
}
