/* cpim.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Test mr_box & mw_box.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 17 July 1992
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include <gl/gl.h>
#include <device.h>
#include <fmclient.h>
#include "/usr/people/smm/lib/include/cplib.h"
#include "/usr/people/smm/lib/include/img_scale.h"
int DSP = 1;

main (argc, argv)

int argc;
char *argv [];

{
   extern char *malloc ();
   static char dir2 [4] = "ru";
   static char namimg [80];
   static unsigned char *ibuf;
   static unsigned char *obuf;
   unsigned short *sbuf;

   unsigned char *cibuf;
   unsigned short *sibuf;
   float *fibuf;

   unsigned char *cobuf;
   unsigned short *sobuf;
   float *fobuf;

   int xll, yll, xur, yur;
   int nbypx;
   int linit = 1;

   if (argc == 2)
      strcpy (namimg, argv [1]);
   else
   if (argc == 3)
      {
      strcpy (namimg, argv [1]);
      strcpy (dir2, argv [2]);
      }
   else
      {
      fprintf (stderr, "usage: %s cp_filename [dir2]\n", argv [0]);
      exit (0);
      }

/*
 *   cpbuf = rdfimg (namimg);
 *   if (nbypix == 4)
 *      ibuf = cpbuf [npix*nbypix];
 *   else
 *      ibuf = cpbuf [2*npix*nbypix];
 */
   /*** Initialize GL software. ***/

   cphskp (namimg);
   foreground ();
   if (H.ires == 1)
   prefposition (760, 1271, 480, 991);/* 512x512 window in upper right corner.*/
   else
   prefposition (266, 1279,   0, 1023);/*1024x1024 window: upper right corner.*/
   fminit ();			/* Initialize SGI font manager. */

   winopen ("cpw");		/* Create GL window. */
   gl_wclear (BLACK);		/* Clear window to black. */

   glcp_view (namimg, linit, 0);	/* Display image in GL window. */

   sbuf = (unsigned short *) malloc (npix*npix*2);
   ibuf = (unsigned char *) sbuf;

   /*** Read C/P image from GL window. ***/

   xll = 63;
   yll = 63;
   xur = 510;
   yur = 510;
   rectread (xll, yll, xur, yur, sbuf);
   nbypx = sizeof (short);

   obuf = (unsigned char *) malloc (npix * npix * nbypx);

   if (nbypx == 1)
      {
      cibuf = (unsigned char *) ibuf;
      cobuf = (unsigned char *) obuf;
      }
   if (nbypx == 2)
      {
      sibuf = (unsigned short *) ibuf;
      sobuf = (unsigned short *) obuf;
      }
   if (nbypx == 4)
      {
      fibuf = (float *) ibuf;
      fobuf = (float *) obuf;
      }


   printf ("cpim> nbypix: %d   nbypx: %d   npix: %d\n", nbypix, nbypx, npix);

   printf ("%s\n", dir2);
   mr_box (ibuf, npix, npix, obuf, 0, 0, npix, npix, dir2);
   rectwrite (xll, yll, xur, yur, sobuf);

   sleep (3);
   mw_box (ibuf, npix, npix, obuf, 0, 0, npix, npix, dir2);
   rectwrite (xll, yll, xur, yur, sibuf);

   /*** Window remains on screen until terminated by mouse. ***/

   qdevice (ESCKEY);
   qdevice (WINCLOSE);
   qdevice (WINQUIT);
   for (;;)
      {
      short val;
      switch (qread (&val))
         {
         case REDRAW:
            glcp_view (namimg, linit, 0);
            break;
         case ESCKEY:
         case WINCLOSE:
         case WINQUIT:
            gexit ();
            exit (0);
         }
      }
}
