/* dkimg.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Plot dark point locations (reseau dots).
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 30 April 1993
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

#define NDOTS 26 
#define SBOX 5 

main (argc, argv)

int argc;
char *argv [];

{
   static unsigned char imgbuf [448][448];
   static char namfil [80];

   int cx, cy;
   int fd;
   int i;
   int idot;
   int ix, iy;
   int ndots;
   int xdim = 448;
   int ydim = 448;

   static int nbox = NDOTS;
   static int dx =  SBOX;
   static int dy =  SBOX;

   static int xd [NDOTS] = {112, 207, 306, 410,       108, 207, 306, 407, 508, 
                           107, 208, 308, 407, 505,  105, 210, 310, 408, 502, 
                           100, 209, 310, 407, 494,  422, 179};

   static int yd [NDOTS] = {497, 491, 489, 487,       390, 387, 388, 389, 387, 
                           285, 284, 286, 288, 286,  185, 183, 183, 184, 181, 
                            92,  84,  81,  78,  72,  227, 146};

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

   if (argc == 2)
      {
      strcpy (namfil, argv [1]);
      }
   else
      {
      fprintf (stderr, "usage: %s output_file_name\n", argv [0]);
      exit (-1);
      }

   ndots = 24;

   /*** Initialize entire image to white. ***/

   for (iy = 0; iy < ydim; iy++)
      for (ix = 0; ix < xdim; ix++)
	 imgbuf [iy][ix] = (unsigned char) 255;

   /*** For each reseau dot, write a small black box. ***/

   for (idot = 0; idot < ndots; idot++)
      {
      cy = 510 - yd [idot];			/* Convert coordinates. */
      cx = xd [idot] - 63;
      printf ("dot:%3d   cx:%3d   cy:%3d\n", idot, cx, cy);

      for (iy = cy - dy/2; iy <= cy + dy/2; iy++)
	 for (ix = cx - dx/2; ix <= cx + dx/2; ix++)
	    imgbuf [iy][ix] = (unsigned char)   0;
      }

   /*** Write image to disk file. ***/

   fd = creat (namfil, 0644);
   write (fd, imgbuf, xdim*ydim);
   close (fd);

   return (0);
}
