/* duprow.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * replace rows at top & bottom of C/P image. 
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 *  6 January 1993
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "/usr/people/smm/lib/include/cplib.ext"

duprow (ibuf, xdim, ydim, nbypx, inrow, outrow)

unsigned char *ibuf;		/* Image buffer. */
int xdim, ydim;			/* Image dimensions. */
int nbypx;			/* # bytes per pixel. */
int inrow, outrow;		/* Input/output rows. */

{
   unsigned short *sbuf;
   float *fbuf;

   int ix;

   if (nbypx == 1)
      {
      for (ix = 0; ix < xdim; ix++)
         *(ibuf + ix + outrow*xdim) = *(ibuf + ix + inrow*xdim);
      }

   else
   if (nbypx == 2)
      {
      sbuf = (unsigned short *) ibuf;
      for (ix = 0; ix < xdim; ix++)
         *(sbuf + ix + outrow*xdim) = *(sbuf + ix + inrow*xdim);
      }

   else
   if (nbypx == 4)
      {
      fbuf = (float *) ibuf;
      for (ix = 0; ix < xdim; ix++)
         *(fbuf + ix + outrow*xdim) = *(fbuf + ix + inrow*xdim);
      }

   return (0);
}
