/* fibrms.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Fiber removal (1989: upper right).
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 16 October 1992
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#define NBOX 1 
#define NSEARCH 50
#define NINT 20 

fibrms (imgbuf, xdim, ydim)

unsigned short *imgbuf;		/* Image buffer. */
int xdim;			/* X-dimension. */
int ydim;			/* Y-dimension. */
{
   static char dir2 [] = "ru";
   static unsigned short pixval [NSEARCH][NSEARCH];

   float pixsum = 0.0;
   int pixave =   0;
   int pixcnt =   0;
   int pixdif =   0;
   int pixmin = 767;

   int darkpx, darkpy;
   int dpx, dpy;
   int ibox;
   int level = -1;
   int x, y;
   int xmin = 0;
   int ymin = 0;
   int xs, ys;
   int xp, yp;

   static int nbox = NBOX;
   static int dx =  NINT;
   static int dy =  NINT;
   static int dxs = NSEARCH;
   static int dys = NSEARCH;

   static int xd [NBOX] = {340};	/* Lower left corner of box. */
   static int yd [NBOX] = {350};
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

   /*** Fiber Loop. ***/

   for (ibox = 0; ibox < nbox; ibox++)
      {

      /* Lower left corner of box. */

      xs = xd [ibox];
      ys = yd [ibox];

      if (xs + dxs > 511)  xs = 511 - dxs;
      if (ys + dys > 511)  ys = 511 - dys;
      if (xs < 0)  xmin = 0;
      if (ys < 0)  ys = 0;

      /*** Read box centered about estimated reseau dot location. ***/

      mr_box (imgbuf, xdim, ydim, pixval, xs, ys, dxs, dys, dir2);

      pixsum = 0.0;
      pixave = 0;
      pixcnt = 0;

      /*** Find average pixel intensity within box. ***/

      for (y = 0; y < dys; y++)
         {
         yp = ys + y;
         if (yp > 62 && yp < 511)

            for (x = 0; x < dxs; x++)
               {
               xp = xs + x;
               if (xp > 62 && xp < 511)
                  {
		  if (pixval [y][x] < pixmin)  pixmin = pixval [y][x];
                  pixsum += (float) pixval [y][x];
                  pixcnt++;
                  }
              }
         }

      pixave = (int) (pixsum / (float) pixcnt);
      pixdif = pixave - pixmin;
      level = pixave - (int) (pixdif * 0.33);
      printf ("pixave: %d   pixcnt: %d   pixsum: %6.2f\n",
              pixave, pixcnt, pixsum);

      /*** Replace any pixel whose value is less than pixave with pixave. ***/

      for (y = 0; y < dys; y++)
         {
         yp = ys + y;
         if (yp > 62 && yp < 511)

            for (x = 0; x < dxs; x++)
               {
               xp = xs + x;
               if (xp > 62 && xp < 511)
                  {
                  if (*(imgbuf + xp + yp*xdim) < level)
                     *(imgbuf + xp + yp*xdim) = pixave;
                  }
              }
         }

      /*** Perform horizontal interpolation for each box. ***/

/*      hint (imgbuf, xdim, ydim, level, nbox, xd, yd, dxs, dys, dir2); */
      }

   return (0);
}
