/* fpixave.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Pixel average.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 9 December 1992
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

float
fpixave (imgbuf, nx, ny, ix, iy)

float *imgbuf;			/* image buffer. */
int ix, iy;			/* x/y indices. */
int nx, ny;			/* x/y dimensions. */

{
   float sum;

   sum = (float) *(imgbuf + ix     + (iy    ) * nx) +
         (float) *(imgbuf + ix     + (iy - 1) * nx) +
         (float) *(imgbuf + ix     + (iy + 1) * nx) +

	 (float) *(imgbuf + ix - 1 + (iy    ) * nx) +
	 (float) *(imgbuf + ix - 1 + (iy - 1) * nx) +
	 (float) *(imgbuf + ix - 1 + (iy + 1) * nx) +

	 (float) *(imgbuf + ix + 1 + (iy    ) * nx) +
	 (float) *(imgbuf + ix + 1 + (iy - 1) * nx) +
	 (float) *(imgbuf + ix + 1 + (iy + 1) * nx) ;

   return ( (sum / 9.0) );
}
