/* swapcols
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Reverse image left to right.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

swapcols (imgbuf, nbypx, xsize, ysize, pmode)

char *imgbuf;
int nbypx;
int xsize, ysize;
int pmode;

{
int ix, nx;
int iy;
int xhalf, xmax;
char cval;
short sval;
float fval;
short *simgbuf;
float *fimgbuf;

   if (pmode)
      fprintf (stderr,
           "   swapcols> nbypx: %d   xsize: %d   ysize: %d\n", nbypx, xsize, ysize);
   simgbuf = (short *) imgbuf;
   fimgbuf = (float *) imgbuf;

   /*** Flip image left to right. ***/

   xmax = xsize - 1;
   xhalf = xsize / 2;

   if (nbypx == 1)				/* Byte image. */
      {
      for (ix = 0; ix < xhalf; ix++)
         {
         nx = xmax - ix; 
         for (iy = 0; iy < ysize; iy++)
            {
            cval = *(imgbuf + ix + iy*xsize);
            *(imgbuf + ix + iy*xsize) = *(imgbuf + nx + iy*xsize);
            *(imgbuf + nx + iy*xsize) = cval;
            }
         }
      }

   else
   if (nbypx == 2)				/* Short image. */
      {
      for (ix = 0; ix < xhalf; ix++)
         {
         nx = xmax - ix; 
         for (iy = 0; iy < ysize; iy++)
            {
            sval = *(simgbuf + ix + iy*xsize);
            *(simgbuf + ix + iy*xsize) = *(simgbuf + nx + iy*xsize);
            *(simgbuf + nx + iy*xsize) = sval;
            }
         }
      }

   else
   if (nbypx == 4)				/* Floating point image. */
      {
      for (ix = 0; ix < xhalf; ix++)
         {
         nx = xmax - ix; 
         for (iy = 0; iy < ysize; iy++)
            {
            fval = *(fimgbuf + ix + iy*xsize);
            *(fimgbuf + ix + iy*xsize) = *(fimgbuf + nx + iy*xsize);
            *(fimgbuf + nx + iy*xsize) = fval;
            }
         }
      }

   return (0);
}
