/* swaprows
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Reverse image top to bottom.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

swaprows (imgbuf, nbypx, xsize, ysize, pmode)

char *imgbuf;
int nbypx;
int xsize, ysize;
int pmode;

{
int ix;
int iy, ny;
int yhalf, ymax;
char cval;
short sval;
float fval;
short *simgbuf;
float *fimgbuf;

   if (pmode)
      fprintf (stderr,
           "   swaprows> nbypx: %d   xsize: %d   ysize: %d\n", nbypx, xsize, ysize);
   simgbuf = (short *) imgbuf;
   fimgbuf = (float *) imgbuf;

   /*** Flip image so that origin is lower left instead of upper left. ***/

   ymax = ysize - 1;
   yhalf = ysize / 2;

   if (nbypx == 1)				/* Byte image. */
      {
      for (iy = 0; iy < yhalf; iy++)
         {
         ny = ymax - iy; 
         for (ix = 0; ix < xsize; ix++)
            {
            cval = *(imgbuf + ix + iy*xsize);
            *(imgbuf + ix + iy*xsize) = *(imgbuf + ix + ny*xsize);
            *(imgbuf + ix + ny*xsize) = cval;
            }
         }
      }
   else
   if (nbypx == 2)				/* Short integer image. */
      {
      for (iy = 0; iy < yhalf; iy++)
         {
         ny = ymax - iy; 
         for (ix = 0; ix < xsize; ix++)
            {
            sval = *(simgbuf + ix + iy*xsize);
            *(simgbuf + ix + iy*xsize) = *(simgbuf + ix + ny*xsize);
            *(simgbuf + ix + ny*xsize) = sval;
            }
         }
      }

   else
   if (nbypx == 4)				/* Floating point image. */
      {
      for (iy = 0; iy < yhalf; iy++)
         {
         ny = ymax - iy; 
         for (ix = 0; ix < xsize; ix++)
            {
            fval = *(fimgbuf + ix + iy*xsize);
            *(fimgbuf + ix + iy*xsize) = *(fimgbuf + ix + ny*xsize);
            *(fimgbuf + ix + ny*xsize) = fval;
            }
         }
      }

   return (0);
}
