/* scrm3s.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Scratch mark interpolation.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   SMM C/P
 * 26 October 1988
 *  9 October 1992: use vertical interpolation for left part of scratch.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#define NBOX 7 
extern int dhfill ();
extern int dvfill ();
extern int vints ();
extern int hints ();


scrm3s (imgbuf, xdim, ydim, ifx, ify)

unsigned short *imgbuf;			/* Image buffer. */
int xdim, ydim;				/* Image dimension.s */
int ifx, ify;				/* X/Y location of F intersection.*/
			/* (where lower flag of F meets diagonal bar. */

{
   int level = -1;
   int i;
   int mx, my;			/* Amount to move coordinate for registration.*/
   int scx, scy;
   int sfx = 321, sfy = 197;	/* Reference location for F/diag intersect. */
   int x, y;
   static int nbox = NBOX;
/*
 *   static int xx [NBOX] =  { 338, 370, 423, 296, 317, 327};
 *   static int yy [NBOX] =  { 194, 209, 205, 162, 196, 200};
 *   static int dxx [NBOX] = {  18,  54,  83,  32,  22,  22};
 *   static int dyy [NBOX] = {  21,  16,  16,  16,   7,  17};
 */

/*                               dv    v     h     v     dv    v     v    */
   static int   X [NBOX]   = {  294,  329,  324,  321,  345,  381,  427};
   static int   Y [NBOX]   = {  173,  206,  198,  197,  197,  217,  210};
   static int   dxx [NBOX]  = {   32,   16,   16,   12,   37,   48,   70};
   static int   dyy [NBOX]  = {   12,   12,    8,    6,   12,   12,   12};
   static float yinc [NBOX] = { 0.85, 1.00, 1.00, 1.00, 0.56, 1.00, 1.00};

   static int xx [NBOX];
   static int yy [NBOX];

   static char dir2 [] = "ru";
   static char ddir [] = "r";

   printf ("scrm3s\n");

/*
 *   scloc (imgbuf, xdim, ydim, &scx, &scy);
 *   printf ("scx: %3d  scy: %3d\n", scx, scy);
 */
   if (ifx == 0 && ify == 0)
      mx = my = 0;
   else
      {
      mx = ifx - sfx;
      my = ify - sfy;
      }
   printf ("mx: %3d  my: %3d\n", mx, my);

   xx [0] = X [0] + mx;
   yy [0] = Y [0] + my - dyy [0] / 2;

   xx [1] = X [1] + mx;
   yy [1] = Y [1] + my - dyy [1] / 2;   

   xx [2] = X [2] + mx - dxx [2] / 2;
   yy [2] = Y [2] + my;

   xx [3] = X [3] + mx;
   yy [3] = Y [3] + my - dyy [3] / 2;

   xx [4] = X [4] + mx;
   yy [4] = Y [4] + my - dyy [4] / 2;

   xx [5] = X [5] + mx;
   yy [5] = Y [5] + my - dyy [5] / 2;

   xx [6] = X [6] + mx;
   yy [6] = Y [6] + my - dyy [6] / 2;

   for (i = 0; i < NBOX; i++)
      printf ("box: %2d   xx: %3d   yy: %3d   dx: %3d   dy: %3d   slope: %5.2f\n",
              i, xx [i], yy [i], dxx [i], dyy [i], yinc [i]);


   /*** Interpolation. ***/

   dvfill (imgbuf, xdim, ydim, level, xx[0], yy[0], dxx[0], dyy[0], yinc[0],
           dir2, ddir);

   vints (imgbuf, xdim, ydim, level, 1, &xx[1], &yy[1], &dxx[1], &dyy[1], dir2);

   hints (imgbuf, xdim, ydim, level, 1, &xx[2], &yy[2], &dxx[2], &dyy[2], dir2);

   vints (imgbuf, xdim, ydim, level, 1, &xx[3], &yy[3], &dxx[3], &dyy[3], dir2);

   dvfill (imgbuf, xdim, ydim, level, xx[4], yy[4], dxx[4], dyy[4], yinc[4],
           dir2, ddir);

   vints (imgbuf, xdim, ydim, level, 2, &xx[5], &yy[5], &dxx[5], &dyy[5], dir2);

   return (0);
}
