/* sltest.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Test slint.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 10 December 1992
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "/usr/people/smm/lib/include/cplib.h"

main (argc, argv)

int argc;
char *argv [];

{
   extern char rdfimg () ;
   static char namimg [80] ;		/* Image filename. */
   static char namlst [80] ;		/* Filelist name. */
   static char namout [80] ;		/* Image filename. */
   static char dirint [2] = "v" ;	/* Interpolation direction. */
   static char dint [2] = "\0" ;	/* Interpolation direction. */
   static int xloc [11] = { 14,  38,  90, 218, 142, 156, 167, 174, 214, 230, 230};
   static int yloc [11] = {  6,  31,  88, 224, 339, 327, 321, 314, 277,   0, 447};

   char *cpbuf;				/* C/P file memory array pointer. */
   char *imgbuf;			/* Image memory array pointer. */

   int fd;				/* File descriptor. */
   int i;
   int iarg;				/* Argument index. */
   int idot;				/* Index for '.' */
   int lenudl = 0;			/* # pixels for interpolation. */
   int lenvl = 0;			/* # pixels for interpolation. */
   int lenldl = 0;			/* # pixels for interpolation. */
   int linloc = 0;			/* Flag: line location specification. */
   int nint  = 11 ;			/* # pixels for interpolation. */
   int nbyimg;				/* # bytes per image. */
   int nbypx;				/* # bytes per pixel. */
   int seq = 0;				/* Sequence: =0 no, =1 yes. */
   int xd, yd;				/* Image dimensions. */
   int xbeg, ybeg ;			/* End coordinates of line. */
   int xend, yend ;			/* End coordinates of line. */

   FILE *LIST;
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

   xbeg =  20 ;			/* Defaults for upper left diagonal line. */
   ybeg =  13 ;
   xend = 218 ;
   yend = 223 ;

   if (argc == 2)
      strcpy (namimg, argv [1]) ;
   else
   if ((argc > 2) && *(argv [1]) == '-')
      {
      for (i  = 1; i < strlen (argv [1]); i++)
	 {
	 if (*(argv [1] + i) == 'd')
	    {
            strcpy (dint, argv [1+i]) ;
	    }
	 if (*(argv [1] + i) == 'u')
	    {
            sscanf (argv [1+i], "%d", &lenudl) ;
	    }
	 if (*(argv [1] + i) == 'v')
	    {
            sscanf (argv [1+i], "%d", &lenvl) ;
	    }
	 if (*(argv [1] + i) == 'l')
	    {
            sscanf (argv [1+i], "%d", &lenldl) ;
	    }
	 if (*(argv [1] + i) == 'p')
            {
	    linloc = 1;
            sscanf (argv [1+i], "%d", &xbeg) ;
            sscanf (argv [2+i], "%d", &ybeg) ;
            sscanf (argv [3+i], "%d", &xend) ;
            sscanf (argv [4+i], "%d", &yend) ;
	    }
	 }
      strcpy (namimg, argv [argc-1]) ;
      }
   else
      {
      fprintf (stderr, "usage: %s [-duvlp] [dirudi] [lenudl] [lenvl] [lenldl] [xbeg ybeg xend yend] cp_filename | @cp_filelist\n", argv [0]);
      exit (0) ;
      }

   if (namimg [0] == '@')
      {
      seq = 1;
      strcpy (namlst, &namimg [1]);
      if ((LIST = fopen (namlst, "r")) == NULL)
	 {
	 fprintf (stderr, "Unable to open file: %s\n", namlst);
	 exit (-1);
	 }
      }
   else seq = 0;

next:

   if (seq)
      if ((fscanf (LIST, "%s", namimg)) == EOF)  exit (0);

   strcpy (namout, namimg);
   for (i = 0; i < strlen (namimg); i++)
      {
      if (namimg [i] == '.')
	 {
	 idot = i;
	 break;
	 }
      }
   namout [idot+1] = 's';
   printf ("namout: %s\n", namout);

   /*** Read C/P image into memory. ***/

   cpbuf = (char *) rdfimg (namimg) ;
   imgbuf = cpbuf + npix * 2;
   nbypx = nbypix;
   nbyimg  = (npix + 2) * npix * nbypx;
   xd = yd = npix;

   /*** Upper left diagonal line. ***/

   strcpy (dirint, "h");
   nint = 17;
   slint (imgbuf, nbypx, xd, yd, xloc [0], yloc [0], xloc [1], yloc [1],
          nint, dirint);

   if (dint [0] == '\0')
      strcpy (dirint, "v");
   else
      strcpy (dirint, dint);

   if (lenudl == 0)
      {
      nint = 27;
      }
   else
      nint = lenudl;

   if (linloc == 0)
      {
      xbeg = xloc [1];
      ybeg = yloc [1];
      xend = xloc [3];
      yend = yloc [3];
      }

   slint (imgbuf, nbypx, xd, yd, xbeg, ybeg, xend, yend,
          nint, dirint);
/*
   nint = 27;
   slint (imgbuf, nbypx, xd, yd, xloc [1], yloc [1], xloc [2], yloc [2],
          nint, dirint);
   slint (imgbuf, nbypx, xd, yd, xloc [2], yloc [2], xloc [3], yloc [3],
          nint, dirint);
 */

   /*** Lower left diagonal line.  ***/

   strcpy (dirint, "v");

   if (lenldl == 0)
      {
      nint = 15;
      }
   else
      nint = lenldl;

   slint (imgbuf, nbypx, xd, yd, xloc [4], yloc [4], xloc [5], yloc [5],
          nint, dirint);
   slint (imgbuf, nbypx, xd, yd, xloc [5], yloc [5], xloc [6], yloc [6],
          nint, dirint);
   slint (imgbuf, nbypx, xd, yd, xloc [6], yloc [6], xloc [7], yloc [7],
          nint, dirint);
   slint (imgbuf, nbypx, xd, yd, xloc [7], yloc [7], xloc [8], yloc [8],
          nint, dirint);

   /*** Vertical line blemish. ***/

   strcpy (dirint, "h");

   if (lenvl == 0)
      {
      nint = 50;
      }
   else
      nint = lenvl;

   slint (imgbuf, nbypx, xd, yd, xloc [9], yloc [9], xloc [10], yloc [10],
	  nint, dirint);

   if ((fd = creat (namout, 0644)) <= 0)
      {
      fprintf (stderr, "Unable to create file: %s\n", namout);
      exit (-2);
      }
   write (fd, cpbuf, nbyimg);
   close (fd);

   free (cpbuf);
   if (seq)  goto next;

   exit (0);
}
