/* sltest.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Test slint.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 10 December 1992
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "/usr/people/smm/lib/src/cp/cplib.h"

main (argc, argv)

int argc;
char *argv [];

{
   extern char rdfimg () ;
   static char namimg [80] ;		/* Image filename. */
   static char namout [80] ;		/* Image filename. */
   static char dirint [2] = "v" ;	/* Interpolation direction. */
   static int xloc [7] = { 20, 218, 142, 156, 167, 174, 214};
   static int yloc [7] = { 13, 227, 339, 327, 321, 314, 277};

   char *cpbuf;				/* C/P file memory array pointer. */
   char *imgbuf;			/* Image memory array pointer. */

   int fd;				/* File descriptor. */
   int i;
   int iarg;				/* Argument index. */
   int nint  = 11 ;			/* # pixels for interpolation. */
   int nbyimg;				/* # bytes per image. */
   int nbypx;				/* # bytes per pixel. */
   int xd, yd;				/* Image dimensions. */
   int xbeg, ybeg ;			/* End coordinates of line. */
   int xend, yend ;			/* End coordinates of line. */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

   xbeg =  20 ;			/* Defaults for upper left diagonal line. */
   ybeg =  13 ;
   xend = 218 ;
   yend = 223 ;

   if (argc == 2)
      strcpy (namimg, argv [1]) ;
   else
   if ((argc > 2) && *(argv [1]) == '-')
      {
      for (i  = 1; i < strlen (argv [1]); i++)
	 {
	 if (*(argv [1] + i) == 'd')
	    {
            strcpy (dirint, argv [1+i]) ;
	    }
	 if (*(argv [1] + i) == 'n')
	    {
            sscanf (argv [1+i], "%d", &nint) ;
	    }
	 if (*(argv [1] + i) == 'c')
            {
            sscanf (argv [1+i], "%d", &xbeg) ;
            sscanf (argv [2+i], "%d", &ybeg) ;
            sscanf (argv [3+i], "%d", &xend) ;
            sscanf (argv [4+i], "%d", &yend) ;
	    }
	 }
      strcpy (namimg, argv [argc-1]) ;
      }
   else
      {
      fprintf (stderr, "usage: %s [-dnc] [dirint] [nint] {xbeg ybeg xend yend] cp_filename\n", argv [0]);
      exit (0) ;
      }

   sprintf (namout, "%s.sl", namimg) ;

   cpbuf = (char *) rdfimg (namimg) ;
   imgbuf = cpbuf + npix * 2;
   nbypx = nbypix;
   nbyimg  = (npix + 2) * npix * nbypx;
   xd = yd = npix;

   /*** Upper left diagonal line. ***/

   nint = 20;
   slint (imgbuf, nbypx, xd, yd, xloc [0], yloc [0], xloc [1], yloc [1],
          nint, dirint);

   /*** Lower left diagonal line.  ***/

   nint = 12;
   slint (imgbuf, nbypx, xd, yd, xloc [2], yloc [2], xloc [3], yloc [3],
          nint, dirint);
   slint (imgbuf, nbypx, xd, yd, xloc [3], yloc [3], xloc [4], yloc [4],
          nint, dirint);
   slint (imgbuf, nbypx, xd, yd, xloc [4], yloc [4], xloc [5], yloc [5],
          nint, dirint);
   slint (imgbuf, nbypx, xd, yd, xloc [5], yloc [5], xloc [6], yloc [6],
          nint, dirint);

   /*** Vertical line blemish. ***/

   strcpy (dirint, "h");
   nint = 32;
   xbeg = 230;
   xend = 230;
   ybeg =   0;
   yend = 447;
   slint (imgbuf, nbypx, xd, yd, xbeg, ybeg, xend, yend, nint, dirint);

   fd = creat (namout, 0644);
   write (fd, cpbuf, nbyimg);
   close (fd);

   return (0);
}
