/* topbot.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * replace rows at top & bottom of C/P image. 
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 *  6 January 1993
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "/usr/people/smm/lib/include/cplib.h"

main (argc, argv)

int argc;
char *argv [];

{
   extern unsigned char rdfimg () ;
   static char namimg [80] ;		/* Image filename. */
   static char namlst [80] ;		/* Filelist name. */
   static char namout [80] ;		/* Image filename. */
   static char dirint [2] = "v" ;	/* Interpolation direction. */
   static int xloc [11] = { 14,  38,  90, 218, 142, 156, 167, 174, 214, 230, 230};
   static int yloc [11] = {  6,  31,  88, 224, 339, 327, 321, 314, 277,   0, 447};

   unsigned char *cpbuf;		/* C/P file memory array pointer. */
   unsigned char *imgbuf;		/* Image memory array pointer. */

   int fd;				/* File descriptor. */
   int i;
   int iarg;				/* Argument index. */
   int idot;				/* Index for '.' */
   int lenint = 0;			/* # pixels for interpolation. */
   int linloc = 0;			/* Flag: line location specification. */
   int nint  = 11 ;			/* # pixels for interpolation. */
   int nbyimg;				/* # bytes per image. */
   int nbypx;				/* # bytes per pixel. */
   int seq = 0;				/* Sequence: =0 no, =1 yes. */
   int xd, yd;				/* Image dimensions. */
   int xbeg, ybeg ;			/* End coordinates of line. */
   int xend, yend ;			/* End coordinates of line. */

   FILE *LIST;
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

   if (argc == 2)
      strcpy (namimg, argv [1]) ;
   else
      {
      fprintf (stderr, "usage: %s cp_filename | @filelist\n", argv [0]);
      exit (0) ;
      }

   if (namimg [0] == '@')
      {
      seq = 1;
      strcpy (namlst, &namimg [1]);
      if ((LIST = fopen (namlst, "r")) == NULL)
	 {
	 fprintf (stderr, "Unable to open file: %s\n", namlst);
	 exit (-1);
	 }
      }
   else seq = 0;

next:

   if (seq)
      if ((fscanf (LIST, "%s", namimg)) == EOF)  exit (0);

   strcpy (namout, namimg);
   for (i = 0; i < strlen (namimg); i++)
      {
      if (namimg [i] == '.')
	 {
	 idot = i;
	 break;
	 }
      }
   namout [idot+1] = 'r';
   printf ("namout: %s\n", namout);

   /*** Read C/P image into memory. ***/

   cpbuf = (unsigned char *) rdfimg (namimg) ;
   imgbuf = cpbuf + npix * 2;
   nbypx = nbypix;
   nbyimg  = (npix + 2) * npix * nbypx;
   xd = yd = npix;

   duprow (imgbuf, xd, yd, nbypx, 5, 0);
   duprow (imgbuf, xd, yd, nbypx, 9, 1);
   duprow (imgbuf, xd, yd, nbypx, 7, 2);
   duprow (imgbuf, xd, yd, nbypx, 8, 3);
   duprow (imgbuf, xd, yd, nbypx, 6, 4);
   duprow (imgbuf, xd, yd, nbypx, 9, 5);
/*
   duprow (imgbuf, xd, yd, nbypx, 7, 6);
 */

   duprow (imgbuf, xd, yd, nbypx, 444, 447);
   duprow (imgbuf, xd, yd, nbypx, 445, 446);

   if ((fd = creat (namout, 0644)) <= 0)
      {
      fprintf (stderr, "Unable to create file: %s\n", namout);
      exit (-2);
      }
   write (fd, cpbuf, nbyimg);
   close (fd);

   free (cpbuf);
   if (seq)  goto next;

   exit (0);
}
