/* wrimg.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Write SMM C/P image from memory array to a disk file.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Solar Maximum Mission   Coronagraph/Polarimeter
 * Andrew L. Stanger
 * 6 August 1984
 * 7 February 1990: use Sun-4 byte order for output.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <sys/types.h>
#include <stdio.h>
#include "/usr/people/smm/lib/include/cplib.ext"

/* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

wrimg (namimg, image)

char *namimg;	/* Pointer to image disk file name. */
u_char *image;	/* Pointer to image array. */

{
   register int	 imgfd;    /* File descriptor for image disk file. */
   register int  imgsiz;   /* Image size (bytes) (excluding hskp & bitmap). */
   register long nwrite;
   int nhdrec;

   /*** Open image file. ***/

   if ((imgfd = creat (namimg, 0644)) < 0)
      {
      fprintf (stderr, "wrimg> Can't create file %s\n", namimg);
      return (NULL);
      }
   close (imgfd);

   if ((imgfd = open (namimg, 1)) < 0)
      {
      fprintf (stderr, "wrimg> Can't open file %s\n", namimg);
      return (NULL);
      }

   /*** Position I/O pointer to beginning of disk file. ***/

   if (nbypix == 4)
      nhdrec = 1;
   else
      nhdrec = 2;
   imgsiz = ((npix + nhdrec) * npix * nbypix);

   if ((nwrite = write (imgfd, image, imgsiz)) <= 0)
      {
      fprintf (stderr,"wrimg> image write error.\n");
      return (NULL);
      }

/*   printf ("wrimg> nwrite: %d\n", nwrite); */

   if (close (imgfd) == -1)
      {
      fprintf (stderr, "wrimg> file close error.%s\n", namimg);
      return (NULL);
      }

  return (0);
}
