/* blrms.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * SMM C/P blemish removal.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 10 February 1993
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

blrms (cbuf, nbypx, xdim, ydim)

unsigned char	*cbuf;		/* Image buffer. */
int		nbypx;		/* # bytes per pixel. */
int		xdim, ydim;	/* Image dimensions */
{

   static char dirint [4] = "v" ;	/* Interpolation direction. */
   static int xloc [11] = { 14,  38,  90, 218, 142,
			   156, 167, 174, 214, 230, 230};
   static int yloc [11] = {  6,  31,  88, 224, 339,
			   327, 321, 314, 277,   0, 447};
   int nint;
   int rc = 25 ;		/* Circle radius (pixel units). */
   int xbeg, ybeg;
   int xc = 137, yc = 346 ;	/* Circle center coordinates (pixel units). */
   int xend, yend;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
   if (nbypx != 1)
      {
      fprintf (stderr, "blrms> Invalid image type. Must be byte image.\n");
      return (-1);
      }

   /*** Upper left diagonal line. ***/

   strcpy (dirint, "h");
   nint = 17;
   slint (cbuf, nbypx, xdim, xdim, xloc [0], yloc [0], xloc [1], yloc [1],
          nint, dirint);

   strcpy (dirint, "v");
   nint = 27;
   slint (cbuf, nbypx, xdim, xdim, xloc [1], yloc [1], xloc [2], yloc [2],
          nint, dirint);
   nint = 27;
   slint (cbuf, nbypx, xdim, xdim, xloc [2], yloc [2], xloc [3], yloc [3],
          nint, dirint);

   /*** Lower left diagonal line.  ***/

   strcpy (dirint, "v");
   nint = 15;
   slint (cbuf, nbypx, xdim, xdim, xloc [4], yloc [4], xloc [5], yloc [5],
          nint, dirint);
   slint (cbuf, nbypx, xdim, xdim, xloc [5], yloc [5], xloc [6], yloc [6],
          nint, dirint);
   slint (cbuf, nbypx, xdim, xdim, xloc [6], yloc [6], xloc [7], yloc [7],
          nint, dirint);
   slint (cbuf, nbypx, xdim, xdim, xloc [7], yloc [7], xloc [8], yloc [8],
          nint, dirint);

   /*** Vertical line blemish. ***/

   strcpy (dirint, "h");
   nint = 50;
   slint (cbuf, nbypx, xdim, xdim, xloc [9], yloc [9], xloc [10], yloc [10],
	  nint, dirint);

   /*** Perform circular interpolation. ***/

   cirint (cbuf, nbypx, xdim, ydim, rc, xc, yc);
   cirint (cbuf, nbypx, xdim, ydim, rc, xc+1, yc);

   return (0);
}
