/* blrms.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * SMM C/P blemish removal.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 11 August 1986
 * 23 July 1992: SGI GL version.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "/usr/people/smm/lib/include/cplib.ext"
#define NBOX 5

blrms (sbuf, xdim, ydim)

unsigned short *sbuf;				/* Image buffer. */
int xdim, ydim;					/* Image dimensions */
{
   int i;
   int level = -1;
   int x, y;
   int dx, dy;
   static int nbox = NBOX;
   static int xx  [NBOX] = {207, 205, 238, 207, 122};	/* Lo res. */
   static int yy  [NBOX] = {204, 273, 221,   0, 325};
   static int dxx [NBOX] = { 11,  10,   8,  44,  36};	/* Lo res. */
   static int dyy [NBOX] = { 23,  20,  24, 448,  41};
   static int xs  [NBOX], ys  [NBOX];
   static int dxs [NBOX], dys [NBOX];
   static char dir2 [4] = "ru";
   static char ddir [4] = "l";

   for (i = 0; i < NBOX; i++)
      {
      xs [i]  = xx [i] * nres;
      ys [i]  = yy [i] * nres;
      dxs [i] = dxx [i] * nres;
      dys [i] = dyy [i] * nres;
      printf ("blrms> nres:%d  xdim:%3d  ydim:%3d  xs:%3d  ys:%3d  dxs:%3d  dys:%3d\n",
	       nres, xdim, ydim, xs [i], ys [i], dxs [i], dys [i]);
      }

   /*** Vertical line. ***/

   strcpy (dir2, "ru");

   vints (sbuf, xdim, ydim, level, 3,
          &xs [0], &ys [0], &dxs [0], &dys [0], dir2);

   hints (sbuf, xdim, ydim, level, 1,
          &xs [3], &ys [3], &dxs [3], &dys [3], dir2);

   /*** Upper left diagonal line. ***/

   x =  20 * nres;   y =   4 * nres;
   dx = 12 * nres;   dy = 25 * nres;
   strcpy (ddir, "r");
   dfill (sbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);

   x =  33 * nres;   y =   23 * nres;
   dx = 20 * nres;   dy = 200 * nres;
   dfill (sbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);

/*
   x = 114 * nres;   y =  90 * nres;
   dx = 20 * nres;   dy = 50 * nres;
   dfill (sbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);

   x =  69 * nres;   y =   5 * nres;
   dx = 20 * nres;   dy = 85 * nres;
   dfill (sbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);
 */

   /*** Lower left diagonal line. ***/

   x = 168 * nres;   y = 266 * nres;
   dx = 16 * nres;   dy = 62 * nres;
   strcpy (ddir,  "l");
   dfill (sbuf, xdim, ydim, level, x, y, dx, dy, dir2, ddir);

   /*** Lower left bullet hole. ***/

   vints (sbuf, xdim, ydim, level, 1,
	  &xs [4], &ys [4], &dxs [4], &dys [4], dir2);

   return (0);
}
