/* cpcoord.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Test rcoord.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 30 August 1991
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include <math.h>
#include "/usr/people/smm/lib/src/cp/cplib.h"

main (argc, argv)

int argc;
char *argv [];

{
   static char carg [80];
   static char namimg [80] = "/picard/i/stanger/movie/801050544.c4q";
   float radius, theta;
   float x, y;
   float thmin, thmax;
   int i, roll;

   if (argc == 2)
      {
      strcpy (carg, argv [1]);
      sscanf (carg, "%d", &roll);
      }
   else
      {
      fprintf (stderr, "Usage: %s [S/C_roll]\n", argv [0]);

      fprintf (stderr, "Enter S/C roll: ");
      fscanf  (stdin,  "%d", &roll);
      }

/*
   fprintf (stderr, "Enter min/max angles: ");
   fscanf  (stdin,  "%f,%f", &thmin, &thmax);
 */

   radius = 2.0;

/*
   xcen = ycen = 223.0;
   rspix = 961.0 / (5.933 * 4.0);
   pixrs = 1.0 / rspix;
   degrad = acos (-1.0);
   raddeg = 1.0 / degrad;
 */
   cphskp (namimg);

   /*** 1st quadrant. ***/

   fprintf (stdout, "1st quadrant:   [roll = %d degrees]\n", roll);
   y = 224.0;
   for (x = 448.0; x > 224.0; x -= 1.0)
      {
      y -= 1.0;
      rcoord (&radius, &theta, &x, &y, -1, roll);
      fprintf (stdout, "x:%6.2f  y:%6.2f   radius:%5.2f  theta: %7.2f\n",
               x, y, radius, theta);
      }

   /*** 2nd quadrant. ***/

   fprintf (stdout, "2nd quadrant:   [roll = %d degrees]\n", roll);
   y = 0.0;
   for (x = 224.0; x >= 0.0; x -= 1.0)
      {
      y += 1.0;
      rcoord (&radius, &theta, &x, &y, -1, roll);
      fprintf (stdout, "x:%6.2f  y:%6.2f   radius:%5.2f  theta: %7.2f\n",
               x, y, radius, theta);
      }

   /*** 3rd quadrant. ***/

   fprintf (stdout, "3rd quadrant:   [roll = %d degrees]\n", roll);
   y = 223.0;
   for (x = 0.0; x < 224.0; x += 1.0)
      {
      y += 1.0;
      rcoord (&radius, &theta, &x, &y, -1, roll);
      fprintf (stdout, "x:%6.2f  y:%6.2f   radius:%5.2f  theta: %7.2f\n",
               x, y, radius, theta);
      }

   /*** 4th quadrant. ***/

   fprintf (stdout, "4th quadrant:   [roll = %d degrees]\n", roll);
   y = 448.0;
   for (x = 223.0; x < 448.0; x += 1.0)
      {
      y -= 1.0;
      rcoord (&radius, &theta, &x, &y, -1, roll);
      fprintf (stdout, "x:%6.2f  y:%6.2f   radius:%5.2f  theta: %7.2f\n",
               x, y, radius, theta);
      }
   
   exit (0);
}
