/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * mouse_poly : Define polygon area using mouse device.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 12 November 1991
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <gl/gl.h>
#include <gl/device.h>
#include <stdio.h>
#include "/usr/people/smm/lib/include/cplib.ext"
#include "/usr/people/smm/lib/include/ov_color.h"
#include "cp_mass.ext"

mouse_poly (xocp, yocp, xo, yo, xs, ys, xmaxscrn, ymaxscrn, poly, nver)

int xocp, yocp;			/* C/P image origin. */
long *xo, *yo;			/* Window origin. */
long *xs, *ys;			/* Window size. */
short xmaxscrn, ymaxscrn;	/* Screen size. */
int poly [][2];			/* Polygon vertex array. */
int *nver;			/* # vertices in polygon. */

{
   short val;
   Colorindex dummy;		/* for strict ANSI C prototyping */
   int boxsize = 3;		/* size of box to indicate cursor points. */
   int dev;
   int ip;
   int xwin, ywin;		/* x/y window coordinates. */
   int pxwin, pywin;		/* x/y window coordinates. */

   float xcp, ycp;		/* x/y coordinates for C/P image file. */
   float r, th;			/* radius & position angle for C/P image. */

   ip = 0;

   while (1)
      {
      while (qtest ())
         {
         dev = qread (&val);
         switch (dev)
            {
            case ESCKEY:	/* Return to main program. */
                 if (val == 1)
                    {
                    setvaluator (MOUSEX, (short)(*xs/2), 0, xmaxscrn);
                    setvaluator (MOUSEY, (short)(*ys/2), 0, ymaxscrn);
                    qreset ();
                    *nver = ip;
                    return (0);
                    }
                 break;

            case REDRAW:	/* Clear window to black. */
                 reshapeviewport ();
                 getsize (xs, ys);
                 getorigin (xo, yo);
                 color (BLACK);
                 clear ();
                 break;

            case ONEKEY:	/* cursor associated with 1-key. */
                 setcursor (1, dummy, dummy);
                 setvaluator (MOUSEX, (short)(*xo + (0.5 * *xs)), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(*yo + (0.5 * *ys)), 0, ymaxscrn);
                 break;

            case TWOKEY:	/* cursor associated with 2-key. */
                 setcursor (2, dummy, dummy);
                 setvaluator (MOUSEX, (short)(*xo + (0.5 * *xs)), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(*yo + (0.5 * *ys)), 0, ymaxscrn);
                 break;

            case THREEKEY:	/* cursor associated with 3-key. */
                 setcursor (3, dummy, dummy);
                 xwin = *xo + xocp + (0.5 * (*xs - xocp));
                 ywin = *yo + xocp + (0.5 * (*ys - xocp));
                 setvaluator (MOUSEX, (short)(xwin), 0, xmaxscrn);
                 setvaluator (MOUSEY, (short)(ywin), 0, ymaxscrn);
                 break;

            case LEFTMOUSE:	/* Left Mouse Button. */
                 if (val == 1)	/* Read position when left key depressed. */
                    {
                    getdev (XY, mdev, mval);
                    xwin = mval [X] - *xo;		/* x window position. */
                    ywin = mval [Y] - *yo;		/* y window position. */
                    xcp = (float) (xwin - xocp); 	/* x C/P position. */
                    ycp = (float) (yocp - ywin); 	/* y C/P position. */
                    rcoord (&r, &th, &xcp, &ycp, -1, scroll);	/* Get r & th.*/
/*
 *                    fprintf (stdout," %3d  %3d  %3.0f  %3.0f  %5.2f  %6.2f\n",
 *                             xwin, ywin, xcp, ycp, r, th);
 */
                    wglbox (xwin, ywin, boxsize, ov_red);  /* Draw small box. */
                    poly [ip][0] = (int) xcp;
                    poly [ip][1] = (int) ycp;
                    if (ip)  gl_wvec (pxwin, pywin, xwin, ywin, ov_green);
                    pxwin = xwin;
                    pywin = ywin;
                    ip++;
                    }
                 break;

            default:
                 break;
            }
         }
      }
}
