/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * win_init : create GL window, define & activate cursor.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include <gl/gl.h>
#include <gl/device.h>
#include "cp_mass.ext"

win_init (nampgm, ires, xo, yo, xs, ys, xmaxscrn, ymaxscrn)

char nampgm [];			/* Program name. */
int ires;			/* C/P image resolution: 0=HI, 1=LO. */
long *xo, *yo;			/* Window origin. */
long *xs, *ys;			/* Window size. */
short *xmaxscrn, *ymaxscrn;	/* Screen size. */

{
   Colorindex dummy;		/* for strict ANSI C prototyping */
   int xscrnsize;		/* size of screen in x used to set globals */
   static unsigned short cursor [128];
   static Cursor plus = {0x0100, 0x0100, 0x0100, 0x0100,
                         0x0100, 0x0100, 0x0100, 0xFEFE,
                         0x0100, 0x0100, 0x0100, 0x0100,
                         0x0100, 0x0100, 0x0100, 0x0000};
 
   static Cursor plus1 = {0x0100, 0x0100, 0x0100, 0x0100,
                          0x0100, 0x0100, 0x0380, 0xFEFE,
                          0x0380, 0x0100, 0x0100, 0x0100,
                          0x0100, 0x0100, 0x0100, 0x0000};

   xscrnsize = getgdesc (GD_XPMAX);
   if (xscrnsize == 1280)
      {
      *xmaxscrn = 1279;
      *ymaxscrn = 1023;
      }
   else if (xscrnsize = 1023)
      {
      *xmaxscrn = 1023;
      *ymaxscrn = 767;
      }
   else
      {
      fprintf(stderr, "Something's EXTREMELY wrong:  ");
      fprintf(stderr, "xscrnsize=%d\n", xscrnsize);
      return (-1) ;
      }

   /*** Initialize GL software. ***/

   foreground ();
   if (ires == 1)
   prefposition (760, 1271, 480, 991);/* 512x512 window in upper right corner.*/
   else
   prefposition (266, 1279,   0, 1023);/*1024x1024 window: upper right corner.*/
   fminit ();			/* Initialize SGI font manager. */

   winopen (nampgm);		/* Create GL window. */
   getsize (xs, ys);		/* Get window size. */
   getorigin (xo, yo);	/* Get window origin (lower left corner). */
   qdevice (ESCKEY);
   qdevice (ZEROKEY);
   qdevice (ONEKEY);
   qdevice (TWOKEY);
   qdevice (THREEKEY);
   qdevice (LEFTMOUSE);
   qdevice (MIDDLEMOUSE);

   mdev [X] = MOUSEX;
   mdev [Y] = MOUSEY;

   curstype (CCROSS);			/* Crosshair cursor. */
   defcursor (1, cursor);
   curorigin (1,0,0);

   curstype (C16X1);			/* Small crosshair cursor. */
   defcursor (2, plus1);
   curorigin (2,7,7);

   curstype (C16X1);			/* Modified small crosshair cursor. */
   defcursor (3, plus1);
   curorigin (3,7,7);

   setcursor (1, dummy, dummy);
   setvaluator (MOUSEX, (short)(*xo + (0.5 * *xs)), (short) 0, *xmaxscrn);
   setvaluator (MOUSEY, (short)(*yo + (0.5 * *ys)), (short) 0, *ymaxscrn);

   gl_wclear (BLACK);		/* Clear window to black. */
   return (0);
}
