/* glcp_scalers.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Draw solar radius measuring scale.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 *  4 April 1991: SGI/GL version.
 * 24 June  1993: fix "+" location for low resolution images.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include "/home/stanger/lib/include/cplib.ext"
#include "/home/stanger/lib/include/img_scale.ext"

glcp_scalers (cindex)

int cindex;	/* Color LUT index. */
{
int x;
int ixg =  63;	/* X-dimension offset for image in window. */
int dxg = 448;	/* X-dimension image size. */
int xgs, xgdim;
int gpixrs;	/* # pixels/Rsun. */
int tx =    4;	/* Size of 1/2 of tick mark. */
int tgx;
int yt;		/* frame buffer y-coordinate for top of tick mark. */
int ym;		/* frame buffer y-coordinate for middle of tick mark. */
int yb =  52;	/* frame buffer y-coordinate for bottom of tick mark. */
int ygb;

   xgs   = ixg * nres;
   xgdim = dxg * nres;
   ygb   = yb  * nres;
   tgx   = tx  * nres;

   ym = ygb + tgx;
   yt = ym  + tgx;

   /*** Draw ticks along the bottom of the image. ***/

   gpixrs = pixrs / nres;
   x = (int) xcen / nres + gMINCOL;
   gl_wvec (x-tgx, ym, x+tgx, ym, cindex);
   gl_wvec (x, yt, x, ygb, cindex);

/*
 *   printf ("glcp_scalers> res:%d  pixrs:%5.2f gpixrs:%3d xcen:%5.2f x:%3d gMINCOL:%3d\n",
 *	    H.ires, pixrs, gpixrs, xcen, x, gMINCOL);
 */

   while ( ( (x += gpixrs) > xgs) && (x < (xgs + xgdim) ) )
      {
      gl_wvec (x, yt, x, ygb, cindex);
      }

   x = (int) xcen / nres + gMINCOL;
   while ( ( (x -= gpixrs) > xgs) && (x < (xgs + xgdim) ) )
      {
      gl_wvec (x, yt, x, ygb, cindex);
      }

   return (0);
}
