/* merge2s.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Merge 2 images together and store in a new image array.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   SMM C/P
 * 25 September 1987
 * 16 March 1989
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>

unsigned short *
merge2s (image1, image2, imdx, imdy, ithresh)

unsigned short *image1;		/* HAO/SMM C/P image array. */
unsigned short *image2;		/* MLSO Mark-III image array. */
int imdx, imdy;			/* Dimensions of images (same for all 3). */
int ithresh;			/* Intensity threshold for image #3. */

{
extern char *malloc();
register unsigned short int *im1, *im2, *im3;
register int i;
register int maxbrt;
register int threshold;
int npximg;
int nbyimg;

   /* Initialize variables. */

   maxbrt = 249;
   threshold = ithresh;
   npximg = imdx * imdy;
   nbyimg = npximg * sizeof(short);
   im1 = (unsigned short int *) image1;
   im2 = (unsigned short int *) image2;
   im3 = (unsigned short int *) malloc (nbyimg);

   /* Combine 2 images together: use the highest value at each pixel location.*/

   fprintf (stderr, "Merging 2 image channels . . . Please wait.\n");
   for (i=0; i<npximg; i++)
      {
      if (*(im2 + i) > threshold)  *(im2 + i) = maxbrt;
      *(im3 + i) = (*(im1 + i) > *(im2 + i)) ? *(im1 + i) : *(im2 + i);
      if (*(im3 + i) > 250)  *(im3 + i) = maxbrt;
      }

   return (im3);
}
