/* mskimg.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Mask image: set area of image beyond a specified radius to zero.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 15 September 1987
 */

mskimg (image, xmin, ymin, xmax, ymax, cx, cy, rmax)

unsigned short *image;
int xmin, ymin, xmax, ymax, cx, cy;
int rmax;

{
   float rsq;
   float rsqmax;
   float x, y, ysq;
   int ix, iy;

   rsqmax = rmax * rmax;

   for (iy = ymin; iy < ymax; iy++)
      {
      y = (float) (iy - cy);
      ysq = y * y;
      for (ix = xmin; ix < xmax; ix++)
         {
         x = (float) (ix - cx);
         rsq = x * x + ysq;
         if ((int) rsq > rsqmax)  *(image + ix + iy * xmax) = 0;
         }
      }
}
