/* glcp_scalers.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Draw solar radius measuring scale.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 *  4 April 1991: SGI/GL version.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include "/usr/people/smm/lib/include/cplib.ext"
#include "/usr/people/smm/lib/include/grscale.ext"

glcp_scalers (hires, cindex)

int hires;	/* =0 for 512x512 resolution, =1 for 1024x1024 resolution. */
int cindex;	/* Color LUT index. */
{
int x;
int ixg = 63;
int dxg = 448;
int xgs, xgdim;
int gpixrs;
int tx = 4;	/* Size of 1/2 of tick mark. */
int tgx;
int yt;		/* frame buffer y-coordinate for top of tick mark. */
int ym;		/* frame buffer y-coordinate for middle of tick mark. */
int yb = 52;	/* frame buffer y-coordinate for bottom of tick mark. */
int ygb;


   if (hires)
      {
      xgs = ixg * 2;
      xgdim = dxg * 2;
      ygb = yb * 2;
      tgx = tx * 2;
      }
   else
      {
      xgs = ixg;
      xgdim = dxg;
      ygb = yb;
      tgx = tx;
      }

   /*** Write black in Rsun scale box. ***/

/*    wsolid (0, xgs, ygb*(hires+1), xgdim, (2*tgx+1)*(hires+1), "ru"); */

    ym = ygb + tgx;
    yt = ym + tgx;

   /*** Draw ticks along the bottom of the image. ***/

    gpixrs = pixrs / nres;
    x = (int) xcen / nres + gMINROW;
    glwvec (x-tgx, ym, x+tgx, ym, cindex);
    glwvec (x, yt, x, ygb, cindex);

    while(((x += gpixrs) > xgs) && (x < (xgs + xgdim)))
      {
      glwvec(x, yt, x, ygb, cindex);
      }

    x = (int) xcen / nres + gMINROW;
    while(((x -= gpixrs) > xgs) && (x < (xgs + xgdim)))
      {
      glwvec(x, yt, x, ygb, cindex);
      }
   return (0);
}
