/* pmscale.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Rescale intensity levels in a prominence monitor image.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 4 May 1988
 */

#include <stdio.h>
#include <math.h>

pmscale (image, dx, dy, omin, omax, nmin, nmax, clipmin, clipmax)

unsigned short *image;
int dx, dy;				/* Image dimensions. */
int omin, omax, nmin, nmax;		/* Old & new intensity limits. */
int clipmin, clipmax;			/* Low & high cutoff limits. */

{
   extern double sqrt ();
   float fnmin, fomin, fact;
   double domin, domax;
   int n, new;
   register int outlo, outhi;
   register int val;
   register unsigned short *sreg;

   fprintf(stderr,"pmscale> oldmin:%d  oldmax:%d  newmin:%d  newmax:%d\n",
                  omin, omax, nmin, nmax);
   fprintf (stderr, "pmscale> clipmin:%d   clipmax:%d\n", clipmin, clipmax);

   outlo = clipmin;
   outhi = clipmax;
/*
 *   domin = (double) omin;
 *   domax = (double) omax;
 *   fact = (float) (nmax-nmin) / (float) sqrt(domax - domin);
 */
   fact = (float) (nmax-nmin) / (float) (omax - omin);

   fnmin = (float) nmin;
   fomin = (float) omin;
   sreg = image;
   n = dx * dy;
      while(n--)
         {
         val = (int) (*sreg - omin);
         if ( (val - omin) < 0 ) *sreg++ = (unsigned short) outlo;
         else
            {
/*
 *            val = (short) (((float) sqrt((double) val - domin)) * fact + fnmin);
 */
            val = (short) (((float) (val - omin)) * fact + fnmin);
            if (val < outlo)  val = outlo;
            if (val > outhi)  val = outhi;
            *sreg++ = (unsigned short) val;
	    }
         }
   return(0);
}
