/* rdmk3.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Read MLSO Mark-III K-Coronameter from disk into memory.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 23 September 1987
 */

unsigned short *
rdmk3 (namimg, dx, dy, cx, cy)

char *namimg;		/* Name of image file. */
int *dx, *dy;		/* Dimensions of image. */
int *cx, *cy;		/* Coordinates of disk center. */

{
   extern char *malloc();
   register unsigned char *linbyt;
   register unsigned short *ims;
   register int x, y;
   register nx;
   int nseek;
   int imgsiz;
   int imgfd, nread;
   int edge = 9;

   *dx = 494;   *dy = 494;
   *cx = *dx / 2;   *cy = *dy / 2;
   nx = *dx;
   imgsiz = *dx * *dy * sizeof(short);
   linbyt = (unsigned char *)  malloc (512);
   ims = (unsigned short *) malloc (imgsiz);

/*
 * Open disk file, skip first 9 lines, read central 494 pixels from each
 * line of the following 494 lines.
 */

   imgfd = open (namimg, 0);
   if (imgfd <= 0)  {printf ("Unable to open %s\n", namimg);  exit(-1);}
   nseek = lseek (imgfd, (long) (edge*512), 0);

   for (y=0; y<*dy; y++)
      {
      nread = read (imgfd, linbyt, 512);
      if (nread != 512)  {printf("nread:%d\n", nread);  exit(-2);}
      for (x=0; x<*dx; x++)
         *(ims + x + y*nx) = (unsigned short) (*(linbyt + edge + x) & 0377);
      }
   close (imgfd);

   free (linbyt);
   return (ims);
}
