/* rdpmhead.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Read prominence monitor header produced by Eikon digitizer.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

rdpmhead (header, xdim, ydim, xcenter, ycenter, year, doy, hrs, mins, rad, ang)

char *header; 
int *xdim, *ydim, *xcenter, *ycenter;
int *year, *doy, *hrs, *mins;
float *ang, *rad;

/* Read Eikon-digitized Prominence Monitor header information from file. */

{
   int n;
   int hdrlen, secs;

/*
 *   fprintf (stdout, "Here is the header\n%s\n", header);
 */

   sscanf (header + 15, "%3d", &hdrlen);
   sscanf (header + 24, "%2d", year);
   sscanf (header + 31, "%3d", doy);
   sscanf (header + 38, "%2d", hrs);
   sscanf (header + 45, "%2d", mins);
   sscanf (header + 52, "%2d", &secs);
   sscanf (header + 60, "%3d", xdim);
   sscanf (header + 69, "%3d", ydim);
   sscanf (header + 81, "%3d", xcenter);
   sscanf (header + 93, "%3d", ycenter);
   sscanf (header + 104, "%f", rad);
   sscanf (header + 116, "%f", ang);

   fprintf (stdout, "hdrlen: %d\n", hdrlen);
   fprintf (stdout, "GMT: 19%02d %03d %02d:%02d:%02d\n",
            *year, *doy, *hrs, *mins, secs);
   fprintf (stdout, "xdim: %d   ydim: %d   ", *xdim, *ydim);
   fprintf (stdout, "xcenter = %d   ", *xcenter);
   fprintf (stdout, "ycenter = %d\n", *ycenter);
   fprintf (stdout, "radius = %g   ", *rad);
   fprintf (stdout, "offang = %g\n", *ang);

   return (0);
}
