/* rescale.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Rescale intensity levels in an image.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 30 September 1987
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

rescale (image, dx, dy, omin, omax, nmin, nmax, clipmin, clipmax)

unsigned short *image;
int dx, dy;				/* Image dimensions. */
int omin, omax, nmin, nmax;	/* Old & new intensity limits. */
int clipmin, clipmax;			/* Low & high cutoff limits. */

{
   float fnmin, fomin, fact;
   int val, n, new;
   register unsigned short *sreg;

   fprintf(stderr,"resc: oldmin=%d,oldmax=%d,newmin=%d,newmax=%d\n",omin,omax,nmin,nmax);
   fact = (float) (nmax-nmin) / (float) (omax-omin);
   fnmin = (float) nmin;
   fomin = (float) omin;
   sreg = image;
   n = dx * dy;
   while (n--)
      {
      val = (int) (((float) *sreg - fomin) * fact + fnmin);
      if ( val < clipmin )  val = clipmin;
      else if ( val > clipmax )  val = clipmax;
      *sreg++ = (unsigned short) val;
      }
   return(0);
}
