/* scalers3.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Draw solar radius measuring scale.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   SMM C/P
 * 19 July 1990: crop image to 400x400 pixels.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* #include "/u/rose/svgrin2/grin.h" */
#define DEF 0200000
#include "/u/smm/lib/src/cp/cplib.h"
#include "/u/smm/lib/src/grin/grscale.ext"

scalers (subch)
int subch;			/* Grinnell sub-channel mask. */
{
int x;
int ix = 95;
int iy = 95;
int gpixrs;
int dx = 4;	/* Size of 1/2 of tick mark. */
int dxgs = 384;
int yt;		/* Grinnell y-coordinate for top of tick mark. */
int ym;		/* Grinnell y-coordinate for middle of tick mark. */
int yb = 52;	/* Grinnell y-coordinate for bottom of tick mark. */

   wsolid (0, ix, yb, dxgs, 2*dx+1, "ru"); /* Write black in Rsun scale box. */
   ym = yb + dx;
   yt = ym + dx;
   scmask (subch);		/* Set sub-channel mask. */

/* Draw ticks along the bottom of the image. */

   gpixrs = pixrs / nres;
   x = (int) xcen / nres + gMINROW;
   wvec (x-dx, ym, x+dx, ym);
   wvec (x-dx, ym-1, x+dx, ym-1);
   wvec (x, yt, x, yb);

   while (((x += gpixrs) > ix) && (x < (ix + dxgs)))
      {
      wvec (x, yt, x, yb);
      }

   x = (int) xcen / nres + gMINROW;
   while (((x -= gpixrs) > ix) && (x < (ix + dxgs)))
      {
      wvec (x, yt, x, yb);
      printf ("x: %d,   yt: %d   yb: %d\n", x, yt, yb);
      }
   scmask (DEF);			/* Set sub-channel mask. */
}
