/* select_font.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Select font & font size.
 * Uses SGI GL fontmanager.
 * Assumes fminit() has been called prior to select_font.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 *  3 April 1991
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include <fmclient.h>

select_font (face, size)

char *face;
int size;

{
   fmfonthandle fh, fhs;

   fh = fmfindfont (face);	/* Select font. */
   if (!fh)
      {
      fprintf (stderr, "Unable to find font: %s\n", face);
      return (-1);
      }
   fhs = fmscalefont (fh, (double) size);	/* Set point size for font. */
   fmsetfont (fhs);				/* Set current font-face-size.*/

   return (0);
}
