/* suncir.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * S U N C I R ( )	- Draw a dotted circular pattern at 1.0 Rsun.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   SMM C/P
 * 18 July 1990
 * 21 August 1990: adapt for C/P + Mark-III + Pmon composite image.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include "/u/rose/grin2/grin.h"
#include "/u/smm/lib/src/cp/cplib.h"
#include "/u/smm/lib/src/grin/grscale.ext"

suncir (subch)

int subch;		/* Image channel. */

{
extern int nres;
float x, y;		/* (x,y) coordinates corresponding to (r,th). */
float r = 1.0;		/* Radius in R/Rsun units. */
float th;		/* Position angle in degrees. */
int xg, yg;		/* Grinnell coordinates. */
int xg1, yg1, xg2, yg2;

float radius;
float x1, y1, x2, y2;
float r1, r2;

   scmask (subch);			/* Set sub-channel mask. */

   /*** Draw radial scans (r=0.2 ->1.0; th= 0,90,180,270). ***/

   for (th = 0.0; th < 360.0; th += 90.0)
      for (radius = 0.2; radius < 1.0; radius += 0.2)
         {
	 rcoord (&radius, &th, &x, &y, 1, scroll);
         xg = ((x / nres) + 0.5) + gMINROW;
         yg = gMAXCOL - ((y / nres) + 0.5);
         if (xg >= gMINCOL && xg <= gMAXCOL &&
	     yg >= gMINROW && yg <= gMAXROW)  wvec (xg, yg, xg, yg+1);
	 }
/*
 *   r1 = 0.12;
 *   r2 = 0.9;
 *   for (th = 0.0; th < 360.0; th += 90.0)
 *      {
 *      rcoord (&r1, &th, &x1, &y1, 1, scroll);
 *      rcoord (&r2, &th, &x2, &y2, 1, scroll);
 *      xg1 = ((x1 / nres) + 0.5) + gMINROW;
 *      yg1 = gMAXCOL - ((y1 / nres) + 0.5);
 *      xg2 = ((x2 / nres) + 0.5) + gMINROW;
 *      yg2 = gMAXCOL - ((y2 / nres) + 0.5);
 *      if (xg1 >= gMINCOL && xg1 <= gMAXCOL &&
 *          yg1 >= gMINROW && yg1 <= gMAXROW &&
 *          xg2 >= gMINCOL && xg2 <= gMAXCOL &&
 *          yg2 >= gMINROW && yg2 <= gMAXROW)
 *            wvec (xg1, yg1, xg2, yg2);
 *      }
 */

   /*** Draw sun circle at 1.0 Rsun.  One dot every 10 degrees. ***/

   for (th = 0; th < 360; th += 10)
      {
      rcoord (&r, &th, &x, &y, 1, scroll);
      xg = ((x / nres) + 0.5) + gMINROW;
      yg = gMAXCOL - ((y / nres) + 0.5);
      if (xg >= gMINCOL && xg <= gMAXCOL &&
	  yg >= gMINROW && yg <= gMAXROW)  wvec (xg, yg, xg, yg+1);
      }

   scmask (DEF);			/* Set sub-channel mask. */
   return (0);
}
