/* swaprows
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Reverse image top to bottom.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

swaprows (imgbuf, nbypx, xdim, ydim)

char *imgbuf;
int nbypx;
int xdim, ydim;

{
int ix;
int iy, ny;
int yhalf, ymax;
char cval;
short sval;
float fval;
short *simgbuf;
float *fimgbuf;

   printf ("   swaprows> nbypx: %d   xdim: %d   ydim: %d\n", nbypx, xdim, ydim);
   simgbuf = (short *) imgbuf;
   fimgbuf = (float *) imgbuf;

   /*** Flip image so that origin is lower left instead of upper left. ***/

   ymax = ydim - 1;
   yhalf = ydim / 2;

   if (nbypx == 1)				/* Byte image. */
      {
      for (iy = 0; iy < yhalf; iy++)
         {
         ny = ymax - iy; 
         for (ix = 0; ix < xdim; ix++)
            {
            cval = *(imgbuf + ix + iy*xdim);
            *(imgbuf + ix + iy*xdim) = *(imgbuf + ix + ny*xdim);
            *(imgbuf + ix + ny*xdim) = cval;
            }
         }
      }
   else
   if (nbypx == 2)				/* Short integer image. */
      {
      for (iy = 0; iy < yhalf; iy++)
         {
         ny = ymax - iy; 
         for (ix = 0; ix < xdim; ix++)
            {
            sval = *(simgbuf + ix + iy*xdim);
            *(simgbuf + ix + iy*xdim) = *(simgbuf + ix + ny*xdim);
            *(simgbuf + ix + ny*xdim) = sval;
            }
         }
      }

   else
   if (nbypx == 4)				/* Floating point image. */
      {
      for (iy = 0; iy < yhalf; iy++)
         {
         ny = ymax - iy; 
         for (ix = 0; ix < xdim; ix++)
            {
            fval = *(fimgbuf + ix + iy*xdim);
            *(fimgbuf + ix + iy*xdim) = *(fimgbuf + ix + ny*xdim);
            *(fimgbuf + ix + ny*xdim) = fval;
            }
         }
      }

   return (0);
}


/* swapcols
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Reverse image left to right.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

swapcols (imgbuf, nbypx, xdim, ydim)

char *imgbuf;
int nbypx;
int xdim, ydim;

{
int ix, nx;
int iy;
int xhalf, xmax;
char cval;
short sval;
float fval;
short *simgbuf;
float *fimgbuf;

   printf ("   swapcols> nbypx: %d   xdim: %d   ydim: %d\n", nbypx, xdim, ydim);
   simgbuf = (short *) imgbuf;
   fimgbuf = (float *) imgbuf;

   /*** Flip image left to right. ***/

   xmax = xdim - 1;
   xhalf = xdim / 2;

   if (nbypx == 1)				/* Byte image. */
      {
      for (ix = 0; ix < xhalf; ix++)
         {
         nx = xmax - ix; 
         for (iy = 0; iy < ydim; iy++)
            {
            cval = *(imgbuf + ix + iy*xdim);
            *(imgbuf + ix + iy*xdim) = *(imgbuf + nx + iy*xdim);
            *(imgbuf + nx + iy*xdim) = cval;
            }
         }
      }

   else
   if (nbypx == 2)				/* Short image. */
      {
      for (ix = 0; ix < xhalf; ix++)
         {
         nx = xmax - ix; 
         for (iy = 0; iy < ydim; iy++)
            {
            sval = *(simgbuf + ix + iy*xdim);
            *(simgbuf + ix + iy*xdim) = *(simgbuf + nx + iy*xdim);
            *(simgbuf + nx + iy*xdim) = sval;
            }
         }
      }

   else
   if (nbypx == 4)				/* Floating point image. */
      {
      for (ix = 0; ix < xhalf; ix++)
         {
         nx = xmax - ix; 
         for (iy = 0; iy < ydim; iy++)
            {
            fval = *(fimgbuf + ix + iy*xdim);
            *(fimgbuf + ix + iy*xdim) = *(fimgbuf + nx + iy*xdim);
            *(fimgbuf + nx + iy*xdim) = fval;
            }
         }
      }

   return (0);
}
