/* wdisk.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Write a solid disk at a specified numerical level into a Grinnell channel.
 * Accepts a 2-byte-per-pixel image.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <math.h>
typedef unsigned short u_short;


wdisk (image, dx, dy, cx, cy, radius, level)

u_short *image;
int cx, cy, radius;
int dx, dy, level;
{
  int lx, rx, uy, ly, y;
  int xrad;
  double drad2;
  double rsun;
  u_short uslev, *limg;
  register u_short *rimg;

	rsun = (double) radius;
	drad2 = ( rsun * rsun );
	uslev = (u_short) level;
	y = 0;
	do {
	    xrad = (float) sqrt ( drad2 - (double)( y * y ) );
	    lx = cx - xrad;
	    rx = cx + xrad;
	    if( lx < 0 )   lx = 0;
	    if( rx >= dx ) rx = dx-1;
	    uy = cy + y;
	    ly = cy - y;
	    if( ly < 0 ) ly = 0;
	    if( uy >= dy ) uy = dy - 1;
	    if( (lx < dx) && (rx > 0) )
		{
		if( uy > 0 )
		   {
		   limg = image + uy*dx;
		   for( rimg=limg+lx; rimg<=limg+rx; rimg++ ) *rimg = uslev;
		   }
		if( ly < dy )
		   {
		   limg = image + ly*dx;
		   for( rimg=limg+lx; rimg<=limg+rx; rimg++ ) *rimg = uslev;
		   }
		}
	    y++;
	} while( y <= radius );
}
