/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * mulimg.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Multiply a calibrated, low resolution C/P image by a constant factor.
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include "/usr/people/smm/lib/include/cplib.h"

main()
{
char *image;
static char namimg [80];
static char namtmp [80];
static char namout [80];
static char hk[896];
static char bitmap[896];
static short linbuf[448];
int fdin;
int fdout;
int i, line;
int idot;
int polpct;
/* float factor = 1.666666;  Polarization = .6  */
/* float factor = 1.5;       Polarization = .67 */
/* float factor = 1.5873;    Polarization = .63 */ 
/* float factor =1.53846;    Polarization = .65 */
/* float factor = 1.0000;    Polarization = 1. */
 float factor = 2.000;   /*  Polarization = .50 */
/* float factor = 1.81818;   Polarization = .55 */

   fprintf (stdout, "Enter name of image file: ");
   fscanf  (stdin,  "%s", namimg);

   fprintf (stdout, "Enter polarization percentage: ");
   fscanf  (stdin, "%d", &polpct);
   factor = 100.0 / (float) polpct;
   fprintf (stderr, "Multiplicative factor: %f\n", factor);
   strcpy (namtmp, namimg);
   for (i=0; i < strlen (namimg); i++)
      {
      idot = i;
      if (namimg[i] == '.')  break;
      }
   namtmp [idot] = '\0';
   sprintf (namout, "%s.bk%02d", namtmp, polpct);
   fprintf (stderr, "Output file name : %s\n", namout);

   /*** Open input & output image files. ***/

   fdin = open (namimg, 0);
   fdout = creat (namout, 0644);
   cphskp (namimg);

   /*** Copy housekeeping & bitmap records. ***/

   read (fdin, hk, 896);
   read (fdin, bitmap, 896);
   write (fdout, hk, 896);
   write (fdout, bitmap, 896);

   /*** Multiply input image by constant factor and write to output file. ***/

   for (line=0; line<448; line++)
      {
      read (fdin, linbuf, 896);
      if (bytord == 1)  srevbyt (linbuf, nbypix, 448);
      for (i=0; i<448; i++)  *(linbuf + i) = (short) (*(linbuf + i) * factor);
      if (bytord == 1)  srevbyt (linbuf, nbypix, 448);
      write (fdout, linbuf, 896);
      }

   close (fdin);
   close (fdout);
}
