
/* srevbyt4.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Reverse byte order for a 4-byte/pixel image.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 27 February 1989
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

srevbyt4 (image, nbytpx, nelem)

char *image;		/* Image array. */
int nbytpx;		/* # bytes per pixel. */
int nelem;		/* # elements in array. */

{
   register char *cimage;
   register char ctemp;
   register int i;

   if (nbytpx != 4)
      {
      fprintf (stderr, "srevbyt4> image pixels are NOT 4-byte entities.\n");
      return (-1);
      }

   cimage = (char *) image;

/*** Reverse bytes (0 & 3), (1 & 2) in image array. ***/

   for (i=0; i<nelem; i++)
      {
      ctemp = *(cimage + 4*i);
      *(cimage + 4*i)   = *(cimage + 4*i+3);
      *(cimage + 4*i+3) = ctemp;

      ctemp = *(cimage + 4*i+1);
      *(cimage + 4*i+1)   = *(cimage + 4*i+2);
      *(cimage + 4*i+2) = ctemp;
      }
   return (0);
}
