/* wrlinp1.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Write one line of data for each image: Br, Bt, p123, pB.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 23 January 1987
 * 14 November 1988: reverse bytes for Vax-11/750.
 * 27 February 1989: replace polarization image with p123.
 * 21 November 1989: use Sun byte order for output images.
 * 19 April 1990: revise order of arguments.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "/usr/people/smm/lib/include/cplib.ext"

wrlinp (lunpb, lunbrt, lunbt, lunbr, pb, brt, bt, br)

int lunpb, lunbrt, lunbt, lunbr;	/* File descriptors for output files. */
short *pb, *brt, *bt, *br;		/* Line arrays for pB, Brt, Bt, Br. */

{
int nbylin;	/* # bytes per vidicon line in image. */
int nwrite;	/* # bytes written to file. */

   nbylin = nbypix * npix;

   /*** Write one vidicon line to each output file. ***/

   nwrite = write (lunpb,  pb,  nbylin);
   nwrite = write (lunbrt, brt, nbylin);
   nwrite = write (lunbt,  bt,  nbylin);
   nwrite = write (lunbr,  br,  nbylin);

   return (0);
}
