/* avarea.c
 ****************************************************************************
 * Computes average of a box (nxn pixels).
 ****************************************************************************
 * Andrew L. Stanger   HAO/NCAR   SMM C/P
 *  2 June 1983
 * 13 July 1984: converted from F4P to F77.
 * 6 May 1985
 * 18 November 1985: replace 'coord' with 'rcoord'.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 */

#define nv 256
#include "/usr/people/smm/lib/src/cp/cplib.h"

avarea (rinv)

float rinv [3][3];
{

extern int rcoord ();
extern char nam1 [], nam2 [], nam3 [];
static char namp1 [32], namp2 [32], namp3 [32];

static int ibox [nv][3];
int ierr, n, nhalf, nval;
int ip1, ip2, ir1, ir2;
int i;
int ix, iy;

float r, th;
float sum1, sum2, sum3;
static float s [3], ss [3];
float si, sq, su, pct;
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
   ierr = 0;
   strcpy (namp1, nam1);
   strcpy (namp2, nam2);
   strcpy (namp3, nam3);

   /*** Request polar coordinates of box. ***/

   fprintf (stderr, "Enter radius (rsun) and angle (degrees) for box area : ");
   fscanf  (stdin,  "%f,%f", &r, &th);

   /*** Convert r,th into x,y coordinates. ***/

   ierr = rcoord (&r, &th, &ix, &iy, 1, H.roll);

   /*** Request size of box. ***/

boxsize:
   fprintf (stderr, "Enter # pixels on one side of box : ");
   fscanf  (stdin,  "%d", n);
   nhalf = n / 2;
   nval = n * n;
   if (n < 1)
      {
      fprintf (stderr, "Box size must be 1 or greater... try again.");
      goto boxsize;
      }
   if (n > 16)
      {
      fprintf (stderr, "Box size must be <= 16 ... try again.");
      goto boxsize;
      }

   ip1 = ix - nhalf;
   ip2 = ip1 + n - 1;
   ir1 = iy - nhalf;
   ir2 = ir1 + n - 1;

   /*** Draw box on IRIS. ***/

   if (igr == 1)
      {

      /*** Connect 4 box vertices on IRIS. ***/

      gl_wvec (ip1/nres+62, 511-ir1/nres,  ip2/nres+62, 511-ir1/nres, gl_RED);
      gl_wvec (ip2/nres+62, 511-ir1/nres,  ip2/nres+62, 511-ir2/nres, gl_RED);
      gl_wvec (ip2/nres+62, 511-ir2/nres,  ip1/nres+62, 511-ir2/nres, gl_RED);
      gl_wvec (ip1/nres+62, 511-ir2/nres,  ip1/nres+62, 511-ir1/nres, gl_RED);
      }

   /*** Exract data values. ***/

   getbox (namp1, ip1, ir1, ip2, ir2, ibox[1][1], nval);
   getbox (namp2, ip1, ir1, ip2, ir2, ibox[1][2], nval);
   getbox (namp3, ip1, ir1, ip2, ir2, ibox[1][3], nval);

   /*** Average data in box. ***/

   sum1 = 0.0;
   sum2 = 0.0;
   sum3 = 0.0;
   for (i = 0; i<nval; i++)
      {
      sum1 += ibox [i][1];
      sum2 += ibox [i][2];
      sum3 += ibox [i][3];
      }
   s [1] = sum1 / (float) nval;
   s [2] = sum2 / (float) nval;
   s [3] = sum3 / (float) nval;

   /*** Compute ss : the resultant Stokes vector. ***/

   mxm (rinv, 3, s, 3, ss, 1);
   si = ss [1];
   sq = ss [2];
   su = ss [3];

   pct = 0.0;
   if ( si != 0.0 )  pct = sqrt ( sq*sq + su*su ) / si;

   /*** Report results. ***/

   fprintf (stdout, "box averages (p1,p2,p3): %f %f %f\n", s[1], s[2], s[3]);
   fprintf (stdout, "i, q, u : %f %f %f\n", si, sq, su);
   fprintf (stdout, "polarization fraction : %f\n", pct);

   return (0);
}
