/* calscn.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Radial/Theta scan router for polscn.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   SMM C/P
 * 15 February 1985
 * 23 May 1985: Add 'rdimg' function call.
 * 10 June 1985: add include statement for cpsun.
 * 29 July 1985: add include statement for cpsize.
 * 17 June 1991: Adapt for SGI/IRIS GL windows.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include "scan.ext"
#include "/usr/people/smm/lib/include/cplib.ext"

calscn (scntyp, namimg, scan, scandx, ns)

char	scntyp [];	/* Scan type ("radial" or "theta"). */
char	namimg [];	/* Image file name. */
float	scan [];	/* Dependent axis scan array. */
float	scandx [];	/* Independent axis scan array. */
int	*ns;		/* Number of values in scan. */

{
extern char *rdimg ();	/* Read image from disk to memory. */
static int stype = 1;	/* Scan type variable for 'rscan'. 1=radial, 2=line. */
char *image;		/* Pointer to image array. */
int ierr;		/* Error status. */

   fprintf (stdout, "calscn> Scanning image %s\n", namimg);

   /*** Read image from disk file into memory array. ***/

   image = rdimg (namimg);

   /*** Radial scan. ***/

   if (scntyp [0] == 'r')
      ierr = gl_rscan (namimg, image, rmin, rmax, rinc, theta, stype,
                    scan, scandx, ns);

   /*** Theta scan. ***/

   if (scntyp [0] == 't')
      ierr = gl_tscan (namimg, image, thmin, thmax, thinc, radius,
                    scan, scandx, ns);

   /*** Relinquish storage for image array. ***/

   free (image);

   return (ierr);
}
