/* inv3.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Compute inverse of 3x3 matrix.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * From "Data Reduction & Error Analysis for the Physical Sciences" by
 * Phillip R. Bevington
 * Andrew L. Stanger
 * 14 June 1985
 */
#define n 3

inv3 (a)

float a[n][n];

{
float amax, det, save;
static int ik[n], jk[n];
int i, j, k, l;

/* Find the largest element of a[][] in the remainder of the matrix. */

   det = 1.;
   for (k=0; k<n; k++)
	{
	amax = 0.; 
s21:
	for (i=k; i<n; i++)
	   {
	   for (j=k; j<n; j++)
		{
		if (abs((double) amax) <= abs((double) a[j][i]))
		   {
		   amax = a[j][i];
		   ik[k] = i;
		   jk[k] = j;
		   }
		}
	   }

/* Interchange rows and columns so that amax is in a[k][k]. */

	if (amax == 0)
	   {
	   det = 0.;
	   return (0);
	   }

	i = ik[k];
	if (i < k)
	   goto s21;
	else
	if (i > k)
	   {
	   for (j=0; j<n; j++)
		{
		save = a[j][k];
		a[j][k] = a[j][i];
		a[j][i] = - save;
		}
	   }

	j = jk[k];
	if (j < k)
	   goto s21;
	else
	if (j > k)
	   for (i=0; i<n; i++)
		{
		save = a[k][i];
		a[k][i] = a[j][i];
		a[j][i] = - save;
		}

/* Accumulate elements of inverse matrix. */

	for (i=0; i<n; i++)
	   {
	   if (i != k) a[k][i] = -a[k][i] / amax;
	   }


	for (i=0; i<n; i++)
	   {
	   for (j=0; j<n; j++)
		{
		if (i != k )
		   {
		   if (j != k)  a[j][i] += a[k][i] * a[j][k];
		   }
		}
	   }


	for (j=0; j<n; j++)
	   {
	   if (j != k)  a[j][k] /= amax;
	   }

	a[k][k] = 1. / amax;
	det *= amax;
	}

/* Restore ordering of the matrix. */

   for (l=0; l<n; l++)
	{
	k = n - l;
	j = ik[k];
	if (j > k)
	   {
	   for (i=0; i<n; i++)
		{
		save = a[k][i];
		a[k][i] = - a[j][i];
		a[j][i] = save;
		}
	   }

	i = jk[k];
	if (i > k)
	   {
	   for (j=0; j<n; j++)
		{
		save = a[j][k];
		a[j][k] = - a[j][i];
		a[j][i] = save;
		}
	   }
	}

   return (0);

}
