      subroutine mxm(a, nar, b, nac, c, nbc)
c----------------------------------------------------------------------
c*** Matrix multiplication routine.
c    Form is c = a * b, where c:c(nar,nbc),  a:a(nar,nac), b:b(nac,nbc).
c----------------------------------------------------------------------
c    Kevin Cole   HAO/NCAR   SMM C/P
c    1983
c----------------------------------------------------------------------
c
c... dictionary.
c      a       - first matrix of product.
c      nar     - row dimension of a and c.
c      b       - second matrix of product.
c      nac     - number of columns of a and number of rows of b.
c      c       - result matrix.
c      nbc     - column dimension of b and c.
c----------------------------------------------------------------------
c
      real a(nar,nac), b(nac,nbc), c(nar,nbc)
c
      do 3 k=1,nar
        do 2 i=1,nbc
          x = 0.0
          do 1 j=1,nac
            x = x + a(k,j) * b(j,i)
  1       continue
          c(k,i) = x
  2     continue
  3   continue
c
      return
      end
