/* mxmc.c
 *----------------------------------------------------------------------
 **** Matrix multiplication routine.
 *    Form is c = a * b, where c:c(nar,nbc),  a:a(nar,nac), b:b(nac,nbc).
 *----------------------------------------------------------------------
 * Kevin Cole   HAO/NCAR   SMM C/P
 * 1983
 * 15 July 1984: converted from 11/34 (f4p) to VAX 750 (C).
 * 11 June 1985
 *----------------------------------------------------------------------
 *
 *... dictionary.
 *      a       - first matrix of product.
 *      nar     - row dimension of a and c.
 *      b       - second matrix of product.
 *      nac     - number of columns of a and number of rows of b.
 *      c       - result matrix.
 *      nbc     - column dimension of b and c.
 *----------------------------------------------------------------------
 *
 */

#define nar 3
#define nac 3
#define nbc 1

mxmc (a, b, c)

float a[nac][nar];
float b[nac];
float c[nar];
{
   int j, k;
   float x;

   for (k=0; k<nar; k++)
	{
	x = 0.;
	for (j=0; j<nac; j++)
		{
		x += a[j][k] * b[j];
		}
	c[k] = x;
	}

   return(0);
}
