/*---------------------------------------------------------------------------
 * D B A S E ( )	- Data base routines used by the image scanning
 *		  	  program scan.
 *
 * Routines included:
 *     opendb(database)   - open the database and setup data view windows.
 *     opendbfile(dbfile) - open a database file.
 *---------------------------------------------------------------------------
 */

#include "scandb.h"

int dummy, length, STATUS;

opendb(database, dbfile)	/* opendb()  --	Opens the scan data base */

char *database;
char *dbfile;
{
    char buff[80];
    int status;

/* Open the SMMCP DATABASE.  */
    if((status = dbselect(DBOPEN, database)))
       switch(status)
       {
       case DOES_NOT_EXIST:
  	    (void) sprintf(buff,"DATA BASE %s NOT FOUND", database);
	    disp_err(buff);
	    return(status);
	    break;

       default:
	    (void) sprintf(buff,"STATUS returned from DBOPEN is %d",status);
   	    disp_err(buff);
	    return(status);
       }
    opendbfile(dbfile);	/* open the data base file */
    return(0);
}


opendbfile(dbfile)
char *dbfile;
{
    extern struct dbview fieldlist[];
    int status;
    char buff[80];

/* Select the CATALOG file    */
    if((status = dbselect(FILEOPEN, dbfile)))
    {
	(void) sprintf(buff,"STATUS returned from FILEOPEN of %s = %d"
			,dbfile,status);
       	disp_err(buff);
    }
    if((status = dbunlock(dbfile)))
    {
	(void) sprintf(buff,"DBUNLOCK of %s returned STATUS = %d"
			,dbfile,status);
       	disp_err(buff);
    }
    if((STATUS = dbstructview(dbfile, fieldlist, 10)))
    {
	(void) sprintf(buff,
	  	   "DBSTRUCTVIEW of %s returned STATUS = %d",dbfile,status);
	disp_err(buff);
    }		
} 


closedbfile(dbfile)
char *dbfile;
{
    int status;
    char buff[80];

    if((status = dbselect(FILECLOSE, dbfile)))
    {
	(void) sprintf(buff,"FILECLOSE of %s returned STATUS = %d"
			,dbfile,status);
	disp_err(buff);
    }
}


/*---------------------------------------------------------------------------
 * dbget(search)	- get and display (if grinnell selected) an image;
 *			  depending on the value of search, (EQUAL,GREATER,
 *			  PREVIOUS,NEXT ....(see INFORMIX manual)).
 *--------------------------------------------------------------------------- 
 */
dbget(dbfile, search, key, rec)
char *dbfile;
char *key;
int search;
struct dbrec rec;
{
    char buff[80];
    int length, status;
    extern int tolower();

loop0:
	status = dbfind(dbfile, search, key, &length, &rec);
	switch(status)
	{
	case FOUND:
		return(0);
	case NOT_FOUND:
		return(-1);
	}
}

/* dbput()  -- add new entry to dbfile
 */
dbput(dbfile, rec)	
char *dbfile;
struct dbrec  rec;
{
    int status;
    char buff[80];

/* open the data base file  */
    opendbfile(dbfile);	

    status = dbadd(dbfile, &rec);

    switch(status)
    {
    case FOUND:
    	    break;

    case FOUND_DUPLICATE:
  	    (void) sprintf(buff,"Duplicate entry found in dbput");
	    disp_err(buff);
	    break;

    default:
	    (void) sprintf(buff,"dbput to %s returned STATUS=%d",dbfile,status);
	    disp_err(buff);
    }
    closedbfile(dbfile);
    return(status);
}

/*---------------------------------------------------------------------------
 * dbupdate()		- Performs an update of the current record from 
 *			  the smmcp_notes data file. 
 * on entry:
 *	rec.id contains the file name.
 * on exit:
 *	note_rec contains the notes which have been entered for this file.
 *      function returns FOUND if successfull or STATUS otherwise.
 *---------------------------------------------------------------------------*/

updatedb(dbfile,key,rec)
char *dbfile,*key;
struct dbrec rec;
{
    int status, length;
    char buff[80];
    extern struct dbrec dummyrec;

    dummyrec = (struct dbrec) malloc(sizeof(dbrec));
    if(status = dbfind(dbfile,EQUAL, key, &length, &dummyrec));
    {
	(void) sprintf(buff,"DBFIND of %s returned status = %d",dbfile,status);
	disp_err(buff);
    }

/* unlock the file */
    if((status = dbunlock(dbfile)))
    {
       	(void) sprintf(buff,"DBUNLOCK of %s returned status=%d",dbfile,status);
	disp_err(buff);
    }

/* Perform the update */
    status = dbupdate(dbfile, &rec);
    if(status) 
    {
	(void) sprintf(buff,"DBUPDATE of %s returned STATUS=%d",dbfile,status);
	disp_err(buff);
    }
}

