/*----------------------------------------------------------------------------
 * R E A D F I L E ()	- Read image from disk file and store in memory array.
 *                        If image display option has been selected, the image
 *			  will be displayed as well.
 *----------------------------------------------------------------------------
 * Andrew L. Stanger   HAO/NCAR   SMM C/P
 * 21 September 1990: Isolated as a C function by Mike Hoswell.
 *----------------------------------------------------------------------------
 */
#include "cp.h"

readfile ( filename, image, swin )

char filename[64];
struct IMAGE *image[];
WINDOW *swin;
{
   char buff[81];

   hion ();
      (void) sprintf (buff, "READING FILE: %s    ", filename);
      mvwaddstr (swin, 6, 0, buff);
      wrefresh (swin);
   hioff();

   /* Return cursor to beginning of line.  This is to allow space for 
    * output which may occur from smm_resc() when the image is a high 
    * resolution frame.
    */
   wmove (swin, 7, 0);
   wrefresh (swin);

   /* Increment the file structure array index and open the new file.  */

   scans->index++;
   if (scans->index > (Max_Images-1)) scans->index = 0;
   image [scans->index] = NULL;
   if ((image [scans->index] = make (filename, "SMM")) == NULL) 
      {
      scans->index--;		/* Open failed; reset index back 1. */
      scans->maxindex = scans->index;
      (void) sprintf (buff, "UNABLE TO OPEN %s <return> ", filename);
      mvwaddstr (swin, 7,0, buff);
      wrefresh (swin);
      wclear (swin);
      wrefresh (swin);
      delwin (swin);
      return (-1);
      }
   nres = 1;			/* Low resolution image. */
   if (image [scans->index]->ires == 0) nres = 2;/* High resolution image. */
   scans->OPENFLAG = 1;		/* An image file is now available    */
/*
 *	if (strcmp (image[scans->index]->type, "QUAD4") == 0)
 *		{
 *		SMM = 0;
 *		QUAD4 = 1;
 *		ATM = 0;
 *		}
 *	display (rope, 1);
 */

   /* If the image display option is active, then display this image
    * with the appropriate grid.
    */
   if (scans->GRN)
      {
      rwech (image [scans->index]);
      rwech_batch_on ();
         gr_erase (scans->index);
         disp (scans->index);
         if (scans->ERASEOVL == 1)  gr_erase(7);
         disp (7);
         rwech (scans->index);
         addimg (image[scans->index]);

         /* if this is a (896x896) image, then average to (448x448). */

         if (image [scans->index]->ires == 0)  smm_avg (image [scans->index]);

         labelsmm (image [scans->index], 1, scans->index);
         annotsmm (image [scans->index], scans->index);
   /* grid (image [scans->index], "SMM"); */
      rwech_batch_off ();
      }
   revon ();
   mvwaddstr (swin, 1+scans->index, 3 , filename);
   wrefresh (swin);
   mvwaddstr (swin, 6,0, ".................................................");
   mvwaddstr (swin, 7,0, ".................................................");
   wrefresh (swin);
}
