/* suncir.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * S U N C I R ( )	- Draw a dotted circular pattern at 1.0 Rsun.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   SMM C/P
 * 18 July 1990
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include "/u/rose/svgrin2/grin.h"
#include "/u/smm/lib/src/ip/new/iproc.ext"

suncir (ifc, subch)

struct IMAGE *ifc;
int subch;		/* Image channel. */

{
extern int nres;
float x, y;		/* (x,y) coordinates corresponding to (r,th). */
float r = 1.0;		/* Radius in R/Rsun units. */
float th;		/* Position angle in degrees. */
int xg, yg;		/* Grinnell coordinates. */

float radius;
float x1, y1, x2, y2;
float r1, r2;
int xg1, yg1, xg2, yg2;

   scmask (subch);			/* Set sub-channel mask. */

   /*** Draw radial scans (r=0.2 ->1.4; th= 0,90,180,270). ***/

   for (th = 0.0; th < 360.0; th += 90.0)
      for (radius = 0.2; radius < 1.4; radius += 0.1)
	 {
	 coord (ifc, &radius, &th, &x, &y, 1);
         xg = ((x / nres) + 0.5) + gminrow;
         yg = gmaxcol - ((y / nres) + 0.5);
         if (xg >= gmincol && xg <= gmaxcol &&
	     yg >= gminrow && yg <= gmaxrow)  wvec (xg, yg, xg, yg);
	 }
/*
    r1 = 0.12;
    r2 = 0.9;
    for (th = 0.0; th < 360.0; th += 90.0)
       {
	 coord (ifc, &r1, &th, &x1, &y1, 1);
	 coord (ifc, &r2, &th, &x2, &y2, 1);
         xg1 = ((x1 / nres) + 0.5) + gminrow;
         yg1 = gmaxcol - ((y1 / nres) + 0.5);
         xg2 = ((x2 / nres) + 0.5) + gminrow;
         yg2 = gmaxcol - ((y2 / nres) + 0.5);
         if (xg1 >= gmincol && xg1 <= gmaxcol &&
	     yg1 >= gminrow && yg1 <= gmaxrow &&
             xg2 >= gmincol && xg2 <= gmaxcol &&
	     yg2 >= gminrow && yg2 <= gmaxrow)
	    wvec (xg1, yg1, xg2, yg2);
       }
 */

   /*** Draw sun circle at 1.0 Rsun.  One dot every 10 degrees. ***/

   for (th = 0; th < 360; th += 10)
      {
      coord (ifc, &r, &th, &x, &y, 1);
      xg = ((x / nres) + 0.5) + gminrow;
      yg = gmaxcol - ((y / nres) + 0.5);
      if (xg >= gmincol && xg <= gmaxcol &&
	  yg >= gminrow && yg <= gmaxrow)  wvec (xg, yg, xg, yg);
      }

   scmask (DEF);			/* Set sub-channel mask. */
   return (0);
}
