
/*------------------------------------------------------------------------------
 * T L I B . C  --  Enhanced terminal library.
 * 		    This file contains routines for setting attribute bytes 
 *                  for various terminals.
 *------------------------------------------------------------------------------
 */

/* Allocate the control strings. 
 */
char shion[10];
char shioff[10];
char srevon[10];
char srevoff[10];
char sulon[10];
char suloff[10];
char sblinkon[10];
char sblinkoff[10];
char shirevon[12];
char shirevulon[14];



/* ----------------------------------------------------------------------------
 * I S G R A P H O N ()  -- Returns true if this is a GraphOn terminal (VT-100).
 * ----------------------------------------------------------------------------
 */
isgraphon()
{
    char    *getenv();
    char    term_name[32];

    strcpy(term_name,getenv("TERM"));

    if(strcmp(term_name,"go140"))
	return(0);
    else
	return(1);
}


/* ----------------------------------------------------------------------------
 * I S T V 9 2 x ()  -- Returns true if this is a televideo 920 or 925
 * ----------------------------------------------------------------------------
 */
istv92x()
{
    char   *getenv();
    char   term_name[32];

    strcpy(term_name, getenv("TERM"));

    if(strncmp(term_name, "tv92",4))
	return(0);
    else
	return(1);
}


/* H I O N ()  --  Turn on high intensity
 */
hion()
{
	printf("%s",shion);
}


/* H I O F F ()  -- Turn off high intensity.
 */
hioff()
{
	printf("%s", shioff);
}


/* U L O N ()  -- Turn on underlining
 */
ulon()
{
	printf("%s", sulon);
}


/* U L O F F -- Turn off underlining.
 */
uloff()
{
	printf("%s", suloff);
}


/* R E V O N () -- Turn reverse background on.
 */
revon()
{
	printf("%s", srevon);
}


/* R E V O F F () --  Turn reverse background off.
 */
revoff()
{
	printf("%s", srevoff);
}


/* B L I N K O N ()  --  Turn blinking on.
 */
blinkon()
{
	printf("%s", sblinkon);
}


/* B L I N K O F F -- Turn off blinking.
 */
blinkoff()
{
	printf("%s", sblinkoff);
}


/* H I R E V O N -- Turn on high intensity and reverse background.
 */
hirevon()
{
	printf("%s", shirevon);
}


/* H I R E V U L O N -- Turn on high intensity and underline on.
 */
hirevulon()
{
	printf("%s", shirevulon);
}


/* D O _ G R A P H O N () -- Set up escape sequences for GraphOn terminal.
 */
do_graphon()
{
	strcpy(shion,    "\033[1m");	/* hi intensity on 		*/
	strcpy(shioff,    "\033[0m");	 /* hi intensity off 		*/
	strcpy(sblinkon,  "\033[5m");	 /* blink on 			*/
	strcpy(sblinkoff, "\033[0m");	 /* blink off 			*/
	strcpy(srevon,    "\033[7m");	 /* reverse background on  	*/
	strcpy(srevoff,   "\033[0m");	 /* reverse background off 	*/
	strcpy(sulon,	  "\033[4m");	 /* underline on		 */
	strcpy(suloff,	  "\033[0m");	 /* underline off		 */
	strcpy(shirevon,  "\033[1;7m");	 /* hi int + rev back            */
	strcpy(shirevulon,"\033[1;7;4m"); /* hi int + rev back + un line  */
}

/*  D O _ D U M B ()  -- Initialze escape sequences for a dumb terminal 
 *			 (no features at all).
 */
do_dumb()
{
	strcpy(shion,    "\0");
	strcpy(shioff,   "\0");
	strcpy(sblinkon, "\0");
	strcpy(sblinkoff,"\0");
	strcpy(srevon,   "\0");
	strcpy(srevoff,  "\0");
	strcpy(sulon,	 "\0");
	strcpy(suloff,	 "\0");
}
