/* iglcp_view.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Display SMM C/P image in current SGI/IRIS GL window.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include <fmclient.h>
#include "/usr/people/stanger/lib/src/ip/iproc.ext"
#include "/usr/people/stanger/lib/src/gl/gl_color.h"

   /* `Screen' font sizes:
    * 7 => 6x7
    * 11,13,15 => 8x15
    *
    * `Screen-Bold' font sizes:
    * 13,15 => 9x15
    *
    * `Helvetica-Bold' font sizes:
    *  8 => 11x13
    * 10 => 14x15
    * 12 => 18x20
    * 14 => 20x22
    * 18 => 27x29
    * 24 => 37x38
    *
    * `Charter-Black' font sizes:
    *  8 => 12x13
    * 10 => 14x15
    * 12 => 16x17
    * 14 => 22x23
    * 19 => 28x30
    * 25 => 38x40
    */

   long afh, bfh, cfh;
   char font1 [] = "Screen";
   char font2 [] = "Screen-Bold";
   char font3 [] = "Helvetica-Bold";
   char font4 [] = "Charter-Black";
   char afont [32];
   char bfont [32];
   char cfont [32];

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * D S P I M G ( )	- Write the image at address IMG->addr to the default
 *			  GL window channel.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *  7 June 1991: adapt for SGI/IRIS GL windows.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

dspimg (IMG)

struct IMAGE *IMG;	/* Pointer to IMAGE structure. */
{
   float dmin, dmax;
   int imin, imax;

   /*** Write 'byte' image to GL window channel. ***/

   if (IMG->bppx == 1)
      {
      if (IMG->lscale == 1)
         {
         dmin = IMG->oldmin;
         dmax = IMG->oldmax;
         imin = IMG->newmin;
         imax = IMG->newmax;
         }
      else
         {
         dmin = 0.0;
         dmax = 250.0;
         imin =   0;
         imax = 250;
         }
      gl_wimg (IMG->addr, IMG->ip, IMG->ir, IMG->dx, IMG->dy, IMG->bppx,
               dmin, dmax, imin, imax);
      }
   else
   if (IMG->bppx == 2)		/* 2 bytes/pixel (short integer). */
      {
      if (IMG->lscale == 1)
         {
         dmin = IMG->oldmin;
         dmax = IMG->oldmax;
         imin = IMG->newmin;
         imax = IMG->newmax;
         }
      else
      if (IMG->ipw != 0)
         {
         dmin = 0.0;
         dmax = 200.0;
         imin =   0;
         imax = 250;
         }
      else
         {
         dmin = 0.0;
         dmax = 500.0;
         imin =   0;
         imax = 250;
         }
      gl_wimg (IMG->addr, IMG->ip, IMG->ir, IMG->dx, IMG->dy, IMG->bppx,
               dmin, dmax, imin, imax);
      }
   else
   if (IMG->bppx == 4)
      {
      if (IMG->lscale == 1)
         {
         dmin = IMG->oldmin;
         dmax = IMG->oldmax;
         imin = IMG->newmin;
         imax = IMG->newmax;
         }
      else
         {
         if (IMG->dtype == 4)  {dmin = 0.0;  dmax = 5.e+15;}   /* elec/cm2 */
         if (IMG->dtype == 5)  {dmin = -5.e-9;  dmax = 5.e-9;} /* B1 - B2  */
         if (IMG->dtype == 6)  {dmin = 0.0;  dmax = 3.e-9;}  /* Bk       */
         if (IMG->dtype == 7)  {dmin = -1.0;  dmax = 1.0;}   /* Bcme-Bbkg/Bk */
         if (IMG->dtype == 8)  {dmin = -1.0;  dmax = 1.0;}   /* Bcme-Bbkg/Bbkg*/
         if (IMG->dtype == 9)  {dmin = 0.0;  dmax = 1.0;}    /* polarization */
         if (IMG->dtype == 10) {dmin = 0.0;  dmax = 5.e-9;}  /* pB */
         if (IMG->dtype == 11) {dmin = 0.0;  dmax = 5.e-9;}  /* Br+t */
         if (IMG->dtype == 12) {dmin = 0.0;  dmax = 5.e-9;}  /* Bt */
         if (IMG->dtype == 13) {dmin = 0.0;  dmax = 5.e-9;}  /* Br */
         if (IMG->dtype == 14) {dmin = 0.0;  dmax = 2.5e-9;} /* F+S mask */
         if (IMG->dtype == 15) {dmin = 0.0;  dmax = 2.0;}    /* B1/B2 */
         imin =   0;
         imax = 250;
         }
      gl_wimg (IMG->addr, IMG->ip, IMG->ir, IMG->dx, IMG->dy, IMG->bppx,
               dmin, dmax, imin, imax);
      }

   /*** Relinquish storage for 'img' array. ***/

   return (0);
}


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Label SMM C/P image.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 22 February 1985
 * 24 April 1989: modified for Sun-4/280 (Yoda).
 * 20 October 1989: revised iproc.ext file.
 *  6 June 1991: modified for SGI/IRIS GL windows & scan program.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

labelsmm (IMG, lfull, lbottom, cval1, cval4)

struct IMAGE *IMG;
int lfull;	/* Flag for full redrawing of labels. */
int lbottom;	/* Bottom flag: =0 normal; =1 no information below image. */
int cval1;	/* Color map index for labels. */
int cval4;	/* Color map index for HAO logo. */
{
   extern char *malloc  ();
   extern int nres;
   static char logo [] = "HAO/SMM   CORONAGRAPH / POLARIMETER";
   short *cbar;				/* Color bar array. */
   int asize, bsize, csize;		/* Font point size designations. */
   int afx, afy, bfx, bfy, cfx, cfy;	/* Font x/y sizes. */
   int afx15;
   int barlength = 512, barwidth = 12;	/* Color bar dimensions. */
   int begrow, begcol, endrow, endcol;
   int cby0, cby1;			/* Color bar y-axis limits. */
   int charheight;
   int colormax = 255;			/* Maximum color index value. */
   int ix, iy;
   int ppc = 2;				/* # pixels per color in color bar. */
   int startcol;
   int startrow;
   int step;
   int x1 = 0, x2 = 62, x3 = 511;
   int y1 = 0, y2 = 62, y3 = 511;
   int xc, yc;
   int xs, ys;
   int xstr;
   int xstart = 1;
   int xwl, xil, xwr;
   int ystart = 501;
   int ywb, yib, ywt;

   charheight = 43;
   if (IMG->ires == 1)			/* Low resolution. */
      {
      xs = xstart;
      ys = ystart;
      strcpy (afont, font1);
      asize = 7;
      afx = 6;  afy = 7;
      strcpy (bfont, font4);
      bsize = 10;
      bfx = 14;  bfy = 15;
      strcpy (cfont, font4);
      csize = 12;
      cfx = 16;  cfy = 17;
      xwl = x1;  xil = x2;   xwr = x3;
      ywb = y1;  yib = y2;   ywt = y3;
      startcol = 1;
      ppc = 2;
      barlength = 512;
      barwidth = 12;
      }
   else					/* High resolution. */
      {
      xs = xstart * 2;
      ys = ystart * 2;
      strcpy (afont, font4);
      asize = 8;
      afx = 12;  afy = 13;
      strcpy (bfont, font4);
      bsize = 14;
      bfx = 22;  bfy = 23;
      strcpy (cfont, font4);
      csize = 19;
      cfx = 28;  cfy = 30;
      xwl = x1 * 2;  xil = x2 * 2;   xwr = x3 * 2;
      ywb = y1 * 2;  yib = y2 * 2;   ywt = y3 * 2;
      startcol = 2;
      ppc = 4;
      barlength = 1024;
      barwidth = 24;
      }
/*   startrow = 17 + barwidth; */
   ys = ywt - afy;
   yc = bfy * 3;
   begcol = 0;
   endcol = startcol + barlength - 1;

   gl_setfont (afont, asize);	/* Small font & size. */
   if (IMG->icm == 2)
      gl_wstr ("CAL MIRROR", xs, ys - 16*afy - 17*bfy, gl_grey);
   else
      gl_wstr ("ROLL      ", xs, ys - 16*afy - 17*bfy, gl_grey);

   if (lfull)
      {
      /*** Draw box around image window. ***/

      gl_wvec (xwl, ywb, xwr, ywb, cval1);
      gl_wvec (xwr, ywb, xwr, ywt, cval1);
      gl_wvec (xwr, ywt, xwl, ywt, cval1);
      gl_wvec (xwl, ywt, xwl, ywb, cval1);
      gl_wvec (xwl, yib, xwr, yib, cval1);
      gl_wvec (xil, yib, xil, ywt, cval1);

      /*** Write annotation labels into frame buffer. ***/

      afh = gl_setfont (afont, asize);	/* Small font & size. */
      gl_wstr ("YEAR:DOY",   xs, ys,                   cval1);
      gl_wstr ("TIME",       xs, ys -  2*afy -  2*bfy, cval1);
      gl_wstr ("DATE",       xs, ys -  4*afy -  4*bfy, cval1);
      gl_wstr ("FILTER",     xs, ys -  6*afy -  7*bfy, cval1);
      gl_wstr ("POLAROID",   xs, ys -  8*afy -  9*bfy, cval1);
      gl_wstr ("SECTOR",     xs, ys - 10*afy - 11*bfy, cval1);
      gl_wstr ("EXPOSURE",   xs, ys - 12*afy - 13*bfy, cval1);
      gl_wstr ("RESOLUTION", xs, ys - 14*afy - 15*bfy, cval1);

      gl_wstr ("FRAME  ", xs, ys - 18*afy - 19*bfy, cval1);

      /*** Write HAO logo & cval1 bar only if 'lbottom = 0'. ***/

      if (lbottom == 1)  return (0);

      /*** Add annotation for the color bar ***/

      gl_setfont (afont, asize);	/* Small font & size. */
      cby0 = 1 * nres;
      afx15 = (int) ((afx * 1.5) + 0.5);
      gl_wstr ("0"  , (startcol+1),               cby0, cval1);
      gl_wstr ("64" , (startcol + 64 *ppc-afx),   cby0, cval1);
      gl_wstr ("128", (startcol + 128*ppc-afx15), cby0, cval1);
      gl_wstr ("192", (startcol + 192*ppc-afx15), cby0, cval1);
      gl_wstr ("255", (endcol-afx*3),             cby0, cval1);

      /*** Add tick marks to color bar ***/

      cby0 += afy + 2;
      cby1 = cby0 + 4 * nres;
      gl_wvec (startcol,         cby0, (startcol),         cby1, cval1);
      gl_wvec (startcol+32*ppc , cby0, (startcol+32*ppc),  cby1, cval1);
      gl_wvec (startcol+64*ppc , cby0, (startcol+64*ppc),  cby1, cval1);
      gl_wvec (startcol+96*ppc , cby0, (startcol+96*ppc),  cby1, cval1);
      gl_wvec (startcol+128*ppc, cby0, (startcol+128*ppc), cby1, cval1);
      gl_wvec (startcol+160*ppc, cby0, (startcol+160*ppc), cby1, cval1);
      gl_wvec (startcol+192*ppc, cby0, (startcol+192*ppc), cby1, cval1);
      gl_wvec (startcol+224*ppc, cby0, (startcol+224*ppc), cby1, cval1);
      gl_wvec (startcol+255*ppc, cby0, (startcol+255*ppc), cby1, cval1);

      /*** Draw the color bar. ***/

      barlength = (colormax + 1) * ppc;
      cbar = (short *) malloc (barlength * barwidth * sizeof (short));

      for (iy = 0; iy < barwidth; iy++)
         for (step = 0; step <= colormax; step++)
            for (ix = 0; ix < ppc; ix++)
               *(cbar + (step*ppc+ix) + (iy*barlength)) =
                (short) (step & 0377) + cmapoff;

      begrow = cby1 + 1;
      endrow = begrow + barwidth - 1;
      rectwrite (begcol, begrow, endcol, endrow, cbar);
      free (cbar);

      /*** Write HAO ID. ***/

      cfh = gl_setfont (cfont, csize);		/* Large font & size. */
      xstr = fmgetstrwidth (cfh, logo);
      gl_wstr (logo, xil + ((xwr - xil + 1) - (xstr)) / 2,
               endrow + 5*nres, cval4);
      }
}


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Write SMM C/P image annotation to Grinnell channel.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 22 February 1985
 *  6 June 1991: modified for SGI/IRIS GL windows & scan program.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

annotsmm (IMG, lbottom, cval1, cval2, cval3, cval4)

struct IMAGE *IMG;	/* Pointer to image info structure. */
int lbottom;	/* Bottom flag: =0 normal; =1 no information below image. */
int cval1;	/* Color map index for labels. */
int cval2;	/* Color map index for annotation. */
int cval3;	/* Color map index for graphics. */
int cval4;	/* Color map index for HAO logo. */
{
  extern char *month_name();	/* Function to look up ASCII month name. */
  extern int month_day();	/* Function to compute mont & day from DOY. */
  static char month[4]; 
  static char wbuf[12];
  static char namgls[] = "MASF";

   int afx, afy, bfx, bfy;
   int annot_state = 1;
   int charheight = 43;
   int offset = -21;
   int xstart = 2;
   int ystart = 485;
   int xc, yc;			/* Height & width for character annotation. */
   int xs, ys;			/* Start position for character annotation. */
   int year, doy;
   int imonth, iday;
   int asize, bsize;

   if (IMG->ires == 1)			/* Low resolution. */
      {
      ystart = 510;
      xs = xstart;
      ys = ystart;
      yc = charheight;
      strcpy (afont, font1);
      strcpy (bfont, font4);
      asize =  7;
      bsize = 10;
      afx =  6;
      afy =  7;
      bfx = 14;
      bfy = 15;
      }
   else
   if (IMG->ires == 0)			/* High resolution. */
      {
      ystart = 1022;
      xs = xstart * 2;
      ys = ystart * 2;
      yc = charheight * 2;
      strcpy (afont, font4);
      strcpy (bfont, font4);
      asize = 10;
      bsize = 19;
      afx = 14;
      afy = 15;
      bfx = 28;
      bfy = 30;
      }
   ys = ystart - afy;

   gl_setfont (bfont, bsize);		/* Charter-Black font. */

   /*** Year and Day-Of-Year: ***/

   (void) sprintf (wbuf, "%d: %3d", IMG->year, IMG->doy);
   wbuf [7] = '\0';
   gl_wstr (wbuf, xs, ys - 1*bfy, cval2);

   /*** Time: ***/

   (void) sprintf (wbuf,"%02d:%02d:%02d\0",IMG->hour,IMG->minute,IMG->sec);
   gl_wstr (wbuf, xs, ys - 2*afy - 3*bfy, cval2);

   /*** Day and month. ***/

   year = IMG->year + 1900;
   (void) month_day (year, IMG->doy, &imonth, &iday);
   strcpy (month, month_name(imonth));
   sprintf (wbuf, "%2d %s ", iday, month);
   gl_wstr (wbuf, xs, ys - 4*afy - 5*bfy, cval2);
   sprintf (wbuf, "%d", year);
   gl_wstr (wbuf, xs, ys - 4*afy - 6*bfy, cval2);

   /*** Spectral filter: ***/

   switch (IMG->ifw) 
      {
      case 0: sprintf(wbuf,"RED   "); break;
      case 1: sprintf(wbuf,"Halpha"); break;
      case 2: sprintf(wbuf,"OPEN  "); break;
      case 3: sprintf(wbuf,"BLUE  "); break;
      case 4: sprintf(wbuf,"WIDEBD"); break;
      case 5: sprintf(wbuf,"GREEN "); break;
      case 6: sprintf(wbuf,"Fe-XIV"); break;
      default: sprintf(wbuf,"******"); break;
      }
   if (IMG->iglstw == 1)  sprintf(wbuf,"%03d %c ",
			  IMG->iglpos, namgls[IMG->iglstw]);
   gl_wstr(wbuf, xs, ys - 6*afy - 8*bfy, cval2);


   /*** Polaroid filter: ***/

   switch (IMG->ipw) 
      {
      case 0: sprintf(wbuf,"CLR"); break;
      case 1: sprintf(wbuf,"+60"); break;
      case 2: sprintf(wbuf,"-60"); break;
      case 3: sprintf(wbuf,"0DG"); break;
      default: sprintf(wbuf,"***"); break;
      }
   gl_wstr (wbuf, xs, ys - 8*afy - 10*bfy, cval2);


/* Sector mirror: */

   switch (IMG->ism) 
      {
      case 0:  sprintf(wbuf,"SW  "); break;
      case 1:  sprintf(wbuf,"S   "); break;
      case 2:  sprintf(wbuf,"SE  "); break;
      case 3:  sprintf(wbuf,"E   "); break;
      case 4:  sprintf(wbuf,"NE  "); break;
      case 5:  sprintf(wbuf,"N   "); break;
      case 6:  sprintf(wbuf,"NW  "); break;
      case 7:  sprintf(wbuf,"W   "); break;
      case 8:  sprintf(wbuf,"NESW"); break;
      default: sprintf(wbuf,"****");
      }
   gl_wstr (wbuf, xs, ys - 10*afy - 12*bfy, cval2);


   /*** Exposure (1.024 second units) : ***/

   (void) sprintf(wbuf,"%-4u",IMG->exp);
   gl_wstr (wbuf, xs, ys - 12*afy - 14*bfy, cval2);


   /*** Resolution : ***/

   if ( IMG->ires == 0 ) (void) sprintf(wbuf,"HIGH");
   else (void) sprintf(wbuf,"LOW ");
   gl_wstr (wbuf, xs, ys - 14*afy - 16*bfy, cval2);

   /*** S/C Roll : ***/

   if (IMG->icm == 1)
      {
      if (annot_state)
         labelsmm (IMG, 0, 0);
      (void) sprintf(wbuf, "%-4d", IMG->roll);
      gl_setfont (bfont, bsize);			/* Charter-Black font.*/
      gl_wstr (wbuf, xs, ys - 16*afy - 18*bfy, cval2);

      annot_state = 1;
      }

   /*** Calibration Mirror: ***/

   else
      {
      switch (IMG->icm)
         {
         case 0: (void) sprintf(wbuf,"MOVE"); break;
         case 1: (void) sprintf(wbuf,"OUT "); break;
         case 2: (void) sprintf(wbuf,"IN  "); break;
         case 3: (void) sprintf(wbuf,"BAD "); break;
         default: (void) sprintf(wbuf,"****"); break;
         }
      if (annot_state) 
         labelsmm (IMG, 0, 0);
      gl_setfont (bfont, bsize);			/* Charter-Black font.*/
      gl_wstr (wbuf, xs, ys - 16*afy - 18*bfy, cval2);
      annot_state = 0;
      }

   /*** Image count (frame number) : ***/

   (void) sprintf (wbuf,"%-4u",IMG->frameno);
   gl_wstr (wbuf, xs, ys - 18*afy - 20*bfy, cval2);

   xc = (int) IMG->xcen;
   yc = (int) IMG->ycen;

   /*** Draw pointer at disk center. ***/
   /*** Draw sun circle at 1.0 Rsun. ***/
   /*** Draw solar radius scale.     ***/

   pointer (IMG, xc, yc, 0.1, 0.3, cval3);
   suncir  (IMG, 0.4, 1.5, 0.1, 90.0, 1.0, 1.5, 0.2, 30.0, cval3);
   scalers (IMG, cval3);
}


/*-----------------------------------------------------------------------------
 * P O I N T E R ()   - Draws a North pointer with center (screen coordinates)
 *		        at (x,y), circle radius cirrad, tip radius tiprad.
 *-----------------------------------------------------------------------------
 * If the coordinates fall outside the displayable screen area,
 * the coordinates are clipped to the screen boundary.
 *
 * externals required;
 *    gl_wvec()	- draw a vector on the display screen.
 *    gMINROW, gMAXROW  - integers. Minimum and maximum vertical pixels.
 *    gMINCOL, gMAXCOL  - integers. Minimum and maximum horizontal pixels.
 *-----------------------------------------------------------------------------
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 4 April 1991: SGI/IRIS GL version.
 * 7 June 1991: adapt for IMAGE structure used by scan program.
 *-----------------------------------------------------------------------------
 */

pointer (IMG, x, y, cirrad, tiprad, cindex)

struct IMAGE *IMG;
int x, y;				/* cross hair center position */
float cirrad;				/* Pointer circle radius (Rsun). */
float tiprad;				/* Pointer tip radius (Rsun). */
int cindex;				/* Color map index. */
{
extern int nres;
float r, th;
float xx, yy;
int xg, yg;	/* Inner circle. */
int xcn, ycn;	/* North of center. */
int xcs, ycs;	/* South of center. */
int xce, yce;	/* East of center. */
int xcw, ycw;	/* West of center. */
int xpn, ypn;	/* North pointer tip. */
int xwe, ywe;	/* Left wing tip. */
int xww, yww;	/* Right wing tip. */

 
   /*** North pointer tip coordinates. ***/

   r = tiprad;
   th = 0.0;
   coord (IMG, &r, &th, &xx, &yy, 1);
   xpn = ((xx / nres) + 0.5) + gMINROW;
   ypn = gMAXCOL - ((yy / nres) + 0.5);

   /*** East wing tip coordinates. ***/

   r = tiprad;
   th = 90.0;
   coord (IMG, &r, &th, &xx, &yy, 1);
   xwe = ((xx / nres) + 0.5) + gMINROW;
   ywe = gMAXCOL - ((yy / nres) + 0.5);

   r = cirrad;
   coord (IMG, &r, &th, &xx, &yy, 1);
   xce = ((xx / nres) + 0.5) + gMINROW;
   yce = gMAXCOL - ((yy / nres) + 0.5);

   /*** West wing tip coordinates. ***/

   r = tiprad;
   th = 270.0;
   coord (IMG, &r, &th, &xx, &yy, 1);
   xww = ((xx / nres) + 0.5) + gMINROW;
   yww = gMAXCOL - ((yy / nres) + 0.5);

   r = cirrad;
   coord (IMG, &r, &th, &xx, &yy, 1);
   xcw = ((xx / nres) + 0.5) + gMINROW;
   ycw = gMAXCOL - ((yy / nres) + 0.5);

   /*** Draw dots surrounding disk center pixel. ***/

   r = 0.0;
   th = 0.0;
   coord (IMG, &r, &th, &xx, &yy, 1);
   xg = ((xx / nres) + 0.5) + gMINROW;
   yg = gMAXCOL - ((yy / nres) + 0.5);
   if (xg  >= gMINCOL && xg  <= gMAXCOL && yg  >= gMINROW && yg  <= gMAXROW)
      {
      gl_wvec (xg-1, yg,   xg-1, yg,   cindex);
      gl_wvec (xg+1, yg,   xg+1, yg,   cindex);
      gl_wvec (xg,   yg-1, xg,   yg-1, cindex);
      gl_wvec (xg,   yg+1, xg,   yg+1, cindex);
      }

   /*** Draw circle around disk center. ***/

   r = cirrad;
   for (th=0.0; th<=360.0; th += 5.0)
      {
      coord (IMG, &r, &th, &xx, &yy, 1);
      xg = ((xx / nres) + 0.5) + gMINROW;
      yg = gMAXCOL - ((yy / nres) + 0.5);
      if (xg  >= gMINCOL && xg  <= gMAXCOL && yg  >= gMINROW && yg  <= gMAXROW)
         gl_wvec (xg, yg, xg, yg, cindex);
      }

   /*** Draw line from circle to north pointer tip. ***/

   r = cirrad;
   th = 0.0;
   coord (IMG, &r, &th, &xx, &yy, 1);
   xg = ((xx / nres) + 0.5) + gMINROW;
   yg = gMAXCOL - ((yy / nres) + 0.5);
/*
 *   if (xpn >= gMINCOL && xpn <= gMAXCOL && ypn >= gMINROW && ypn <= gMAXROW &&
 *       xg  >= gMINCOL && xg  <= gMAXCOL && yg  >= gMINROW && yg  <= gMAXROW)
 *	gl_wvec (xg, yg, xpn, ypn);
 */
 
   /*** Draw north pointer. ***/

   /* North pointer tip to east wing tip. */

   if (xpn >= gMINCOL && xpn <= gMAXCOL && ypn >= gMINROW && ypn <= gMAXROW &&
       xwe >= gMINCOL && xwe <= gMAXCOL && ywe >= gMINROW && ywe <= gMAXROW)
	gl_wvec (xpn, ypn, xwe, ywe, cindex);

   /* Circle to east wing tip. */

   if (xce >= gMINCOL && xce <= gMAXCOL && yce >= gMINROW && yce <= gMAXROW &&
       xwe >= gMINCOL && xwe <= gMAXCOL && ywe >= gMINROW && ywe <= gMAXROW)
	gl_wvec (xce, yce, xwe, ywe, cindex);

   /* North pointer tip to west wing tip. */

   if (xpn >= gMINCOL && xpn <= gMAXCOL && ypn >= gMINROW && ypn <= gMAXROW &&
       xww >= gMINCOL && xww <= gMAXCOL && yww >= gMINROW && yww <= gMAXROW)
	gl_wvec (xpn, ypn, xww, yww, cindex);

   /* Circle to west wing tip. */

   if (xcw >= gMINCOL && xcw <= gMAXCOL && ycw >= gMINROW && ycw <= gMAXROW &&
       xww >= gMINCOL && xww <= gMAXCOL && yww >= gMINROW && yww <= gMAXROW)
	gl_wvec (xcw, ycw, xww, yww, cindex);

   return (0);
}


/*-----------------------------------------------------------------------------
 * S C A L E R S ( ) : Draw solar radius measuring scale.
 *-----------------------------------------------------------------------------
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 4 April 1991: SGI/IRIS GL version.
 * 7 June 1991: adapt for IMAGE structure used by scan program.
 *-----------------------------------------------------------------------------
 */
scalers (IMG,  cindex)

struct IMAGE *IMG;
int cindex;				/* Color map index. */
{
extern int nres;
int ixg = 64;
int dxg = 448;
int gpixrs;
int tx = 4;		/* Size of 1/2 of tick mark. */
int tgx;
int x;
int xgs, xgdim;
int yt;			/* Window y-coordinate for top of tick mark. */
int ym;			/* Window y-coordinate for middle of tick mark. */
int yb = 52;		/* Window y-coordinate for bottom of tick mark. */
int ygb;

   if (nres == 1)
      {
      xgs = ixg - 1;
      xgdim = dxg;
      ygb = yb;
      tgx = tx;
      }
   else
   if (nres == 2)
      {
      xgs = ixg * 2 - 1;
      xgdim = dxg * 2;
      ygb = yb * 2;
      tgx = tx * 2;
      }

   /*** Write black in Rsun scale region. ***/

/*   wsolid (0, xgs, ygb, xgdim, tgx, "ru"); */

   ym = ygb + tgx;
   yt = ym  + tgx;

   /*** Draw tick marks along bottom of image. ***/

   gpixrs = IMG->pixsr / nres;
   x = (int) IMG->xcen / nres + gMINROW;
   gl_wvec (x-tgx, ym, x+tgx, ym,  cindex);
   gl_wvec (x,     yt, x,     ygb, cindex);

   while (((x += gpixrs) > xgs) && (x < (xgs + xgdim)))
      {
      gl_wvec (x, yt, x, yb, cindex);
      }

   return (0);
}


/*-----------------------------------------------------------------------------
 * S U N C I R ( )	- Draw a dotted circular pattern at 1.0 Rsun.
 *-----------------------------------------------------------------------------
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 4 April 1991: SGI/IRIS GL version.
 * 7 June 1991: adapt for IMAGE structure used by scan program.
 *-----------------------------------------------------------------------------
 */
suncir (IMG, r1min, r1max, r1inc, ang1inc, r2min, r2max, r2inc, ang2inc, cindex)

struct IMAGE *IMG;
float r1min, r1max;	/* Radial limits for major dotted lines. */
float r1inc;		/* Radial increment for major dotted lines. */
float ang1inc;		/* Angular increment between major lines. */
float r2min, r2max;	/* Radial limits for minor dotted lines. */
float r2inc;		/* Radial increment for minor dotted lines. */
float ang2inc;		/* Angular increment between minor lines. */
int cindex;		/* Color map index. */

{
extern int nres;
float r = 1.0;		/* Radius in R/Rsun units. */
float r1, r2;
float radius;
float th;		/* Position angle in degrees. */
float x, y;		/* (x,y) coordinates corresponding to (r,th). */
float x1, y1, x2, y2;

int xg, yg;		/* Grinnell coordinates. */
int xg1, yg1, xg2, yg2;

   /*** Draw radial scans (r=r1min -> r1max) every ang1inc degrees. ***/

   for (th = 0.0; th < 360.0; th += ang1inc)
      {
      if (th == 180.0)  r1min = 0.2;  else r1min = 0.4;
      for (radius = r1min; radius < r1max; radius += r1inc)
	 {
	 coord (IMG, &radius, &th, &x, &y, 1);
         xg = ((x / nres) + 0.5) + gMINROW;
         yg = gMAXCOL - ((y / nres) + 0.5);
         if (xg >= gMINCOL && xg <= gMAXCOL &&
	     yg >= gMINROW && yg <= gMAXROW)
            {
            gl_wvec (xg,   yg-1, xg,   yg+1, cindex);
            gl_wvec (xg-1, yg,   xg+1, yg,   cindex);
            }
	 }
      }

   /*** Draw radial scans (r=r2min -> r2max) every ang2inc degrees. ***/

   for (th = 0.0; th < 360.0; th += ang2inc)
      for (radius = r2min; radius < r2max; radius += r2inc)
         {
         coord (IMG, &radius, &th, &x, &y, 1);
         xg = ((x / nres) + 0.5) + gMINROW;
         yg = gMAXCOL - ((y / nres) + 0.5);
         if (xg >= gMINCOL && xg <= gMAXCOL &&
             yg >= gMINROW && yg <= gMAXROW)
            {
            gl_wvec (xg,   yg-1, xg,   yg+1, cindex);
            gl_wvec (xg-1, yg,   xg+1, yg,   cindex);
            }
         }

   /*** Draw sun circle at 1.0 Rsun.  One dot every 10 degrees. ***/

   for (th = 0.0; th < 360.0; th += 10.0)
      {
      coord (IMG, &r, &th, &x, &y, 1);
      xg = ((x / nres) + 0.5) + gMINROW;
      yg = gMAXCOL - ((y / nres) + 0.5);
      if (xg >= gMINCOL && xg <= gMAXCOL &&
	  yg >= gMINROW && yg <= gMAXROW)
         {
         gl_wvec (xg,   yg-1, xg,   yg+1, cindex);
         gl_wvec (xg-1, yg,   xg+1, yg,   cindex);
         }
      }

   return (0);
}
