
/*
 * dbio.h -- ALL - Applications Language Library Header File
 *
 *  Copyright (C) 1981, 1982, 1983 Relational Database Systems, Inc
 *
 */

#define DBOPEN     1
#define DBCLOSE    2
#define FILEOPEN   3
#define RELOPEN    3
#define FILECLOSE  4
#define RELCLOSE   4

#define COMPARISON 1
#define FIRST	   2
#define LAST	   3
#define NEXT	   4
#define PREVIOUS   5
#define EQUAL	   6
#define GTEQ	   7
#define GREATER	   8
#define CURRENT    9
#define LOCK	   0400

struct dbview
    {
    char *vwname;	/* name of attribute	*/
    int vwstart;	/* offset in view	*/
    int vwtype;		/* type of attribute	*/
    int vwlen;		/* length in bytes	*/
    };

#define CHARTYPE	0
#define INTTYPE		1
#define INTSIZE		2
#define LONGTYPE	2
#define LONGSIZE	4
#define DOUBLETYPE	3
#define DOUBLESIZE	(sizeof(double))
#define FLOATTYPE	4
#define FLOATSIZE	(sizeof(float))
#define SERIALTYPE	(0x0100 + LONGTYPE)
#define SERIALSIZE	LONGSIZE
#define DATETYPE	(0x0200 + LONGTYPE)
#define EDATETYPE	(0x0300 + LONGTYPE)
#define YDATETYPE	(0x0400 + LONGTYPE)
#define DATESIZE	LONGSIZE
#define MONEYTYPE	(0x0500 + DOUBLETYPE)
#define MONEYSIZE	DOUBLESIZE
#define COMPOSTYPE	(-1)

extern double floor(), ceil(), fabs();

#define	CENTS(d)	(ROUND(d*100.0))
#define DOLLARS(c)	(c/100.0)
#define ROUND(c)	(c>=0.0 ? floor(c+0.5) : ceil(c-0.5))

