/* fcorona(r,th)
 * ----------------------------------------------------------------------
 * Determines F-corona for radius r (Rsun units), and position angle th (deg).
 * Derived from Alice Lecinski's F-corona in the ATM "Green Book".
 *----------------------------------------------------------------------
 * Andrew L. Stanger   NCAR/HAO   SMM C/P
 * 17 March 1986
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 */

float
fcorona(r, th)

float r;	/* Radius (R/Rsun). */
float th;	/* Theta (position angle). */

{
# define ntab 85

double sin();
float	f;			/* Storage for F-corona value. */
float	Cexp = 1.e-11;		/* Scale factor for calibrated images. */
float raddeg;			/* Radians per degree. */


   raddeg = 3.14159 / 180.0;
   f = Cexp * 4739.6 *
	(1. + 0.23732 * (float) (pow(sin((double)(th*raddeg),(double)2.))))
	* (float) pow(r,(double)-2.72375);

   return(f);
}
