
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * remvig (rsun, nr, data, ndata)                                    *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Removes vignetting from array 'data'.
 *----------------------------------------------------------------------
 *    Andrew L. Stanger   programmer III   NCAR/HAO   SMM C/P
 *    4 February 1983: PDP-11/34 Fortran-4+ RSX-11M
 *    18 July 1984: conversion to VAX 750 (C).
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *    rsun  = array of radial values (units of rsun). 
 *    nr = # elements in rsun array (=1 for radial scan, =ndata for theta scan).
 *    data  = array of intensity values (units of 10**-11 b/bsun).
 *    ndata = # elements in array data.
 *----------------------------------------------------------------------
 */

#include <stdio.h>

remvig (rsun, nr, data, ndata)

int nr, ndata;
float rsun[];
float data[];

{

int i;
float r;
float v;
extern float vignet();

	if (nr > 1 && nr < ndata)
	  {
	   fprintf(stdout,"# rsun values:%d less than # data values:%d\n",
                   nr, ndata);
	   return(-1);
	  }

	else

/* Radial scans. */

	if (nr > 1)
	  {
	   for (i=0; i<ndata; i++)
		{
		 r = rsun[i];
		 data[i] *= vignet(r);
		}
	   return(0);
	  }

	else

/* Theta scans. */

	if (nr == 1)
	  {
	   r = rsun[0];
	   v = vignet(r);
	   for (i=0; i<ndata; i++)  data[i] *= v;
	   return(0);
	  }
}
