/* command.c
 *-----------------------------------------------------------------------------
 * command()	- command processor. This routine is entered when the user
 *		  enters a ':' as the first character in a command.
 * routines called:
 *	disp_status()	- display string on status line.
 *-----------------------------------------------------------------------------
 */
#include "sscan.ext"

command()
{
    int  fullrefresh,row,col,i;
    char c,buff[81], buff2[80], buff3[30], iedcmd[15];
    int  start_row, start_col, ibuff1, ibuff2, ibuff3;
    extern WINDOW *Comm,*Help,*stdscr;

    help();
    disp_status(":\n");
    row = 1; col = 1;
    fullrefresh = 0;			/* Messy screen indicator to caller. */
    wmove(Comm, row,col); wrefresh(Comm);
    i = 0;

    getyx(Comm, start_row, start_col);
    nl();  noecho();
	
    /* Now, let's read the command line. */

    while((c = wgetch(Comm)) != '\n')
    {
	if(c == ESC) return(0);

	if((c == DEL1) || (c == DEL2)) 
	{	
  	    getyx(Comm,row,col);
	    if(--col < 1) return(0);
	    wmove(Comm, row,col);
	    wdelch(Comm,c);
	    wrefresh(Comm);
	    i--;
	}
	else
	{
	    if(i < 0) i = 0;
	    buff[i++] = c;
	    waddch(Comm, c);
	    wrefresh(Comm);
	}
    }
    wmove(Comm, start_row, start_col);
    wrefresh(Comm);
    buff[i] = '\0';
		
    /* process shell escape */

    if(buff[0] == '!')		/* This is a shell command. */
    {
	nl(); echo();
	squeeze(buff, '!');
	printf("\n");
	stopwin();
	(void) system(buff);
        printf("\nPRESS RETURN TWICE TO CONTINUE...");
	c = (char) fgetc(stdin);
	printf("\n");
	winit();
	nonl(); noecho();
	while((c = wgetch(stdscr)) != CR);
	wmove(Comm, 1,0);
	wclear(Comm);
	wclear(stdscr);
	wrefresh(Comm);
	wrefresh(stdscr);
	return(1);	/* Indicates that a screen refresh is needed. */
    }
    else			/* This is an ied command. */
    {
	(void) sscanf(buff, "%s", iedcmd);

        /* Process 'erase' command.  */

	if(strcmp(iedcmd,"erase") == 0)
	{
	    (void) sscanf(buff,"%s %s", iedcmd, buff2);
	    if((strncmp(buff2,"blue",1) == 0) ||  (strcmp(buff,"8") == 0));
		gr_erase(8);
	    if((strncmp(buff2,"green",1) == 0) || (strcmp(buff,"9") == 0));
		gr_erase(9);
	    if((strncmp(buff2,"red",1) == 0) ||   (strcmp(buff,"10") == 0))
		gr_erase(10);
	    if((strncmp(buff2,"white",1) == 0) || (strcmp(buff,"11") == 0))
		gr_erase(11);
	}

	/* 'disp channel'.  */

	if(strcmp(iedcmd, "disp") == 0)
	{
	    (void) sscanf(buff,"%s %s", iedcmd, buff2);
	    if((strncmp(buff2,"blue",1) == 0) ||  (strcmp(buff,"8") == 0));
		disp(8);
	    if((strncmp(buff2,"green",1) == 0) || (strcmp(buff,"9") == 0));
		disp(9);
	    if((strncmp(buff2,"red",1) == 0) ||   (strcmp(buff,"10") == 0))
		disp(10);
	    if((strncmp(buff2,"white",1) == 0) || (strcmp(buff,"11") == 0))
		disp(11);
	    (void) sscanf(buff, "%s %d",iedcmd,&ibuff2);
	    if(strncmp(buff2,"0",1) == 0)
		disp(0);
	    if(strncmp(buff2,"1",1) == 0)
		disp(1);
	    if(strncmp(buff2,"2",1) == 0)
		disp(2);
	    if(strncmp(buff2,"3",1) == 0)
	    {
		if(scans->GRNDEV == 1) disp(3);
		else disp_err("Invalid channel #");
	    }
	    fullrefresh = 0;
	}

	/* 'col string '. */

	if(strcmp(iedcmd, "col") == 0)
	{
	    (void) sscanf(buff, "%s %s", iedcmd,buff2);
	    /*col(buff2); */
	}

	/* 'ovoff overlay#'. */

	if(strcmp(iedcmd, "ovoff") == 0)
	{
	    (void) sscanf(buff,"%s %s", iedcmd, buff2);
	    if((strncmp(buff2,"blue",1) == 0) ||  (strncmp(buff,"8",1) == 0));
		ovoff(8);
	    if((strncmp(buff2,"green",1) == 0) || (strncmp(buff,"9",1) == 0));
		ovoff(9);
	    if((strncmp(buff2,"red",1) == 0) ||   (strncmp(buff,"10",2) == 0))
		ovoff(10);
	    if((strncmp(buff2,"white",1) == 0) || (strncmp(buff,"11",2) == 0))
		ovoff(11);
	}
	    
	/* 'chcopy from to ' */

	if(strcmp(iedcmd,"chcopy") == 0)
	{
	    if(sscanf(buff,"%s %d %d",iedcmd,&ibuff1,&ibuff2) == 3)
	    {
		disp(ibuff2);
		chcopy(ibuff1, ibuff2);
		disp(ibuff1);
	    }
	    else
		disp_err("USAGE: chcopy {1,2,3,4},{1,2,3,4}");
       }
	
        /* Process help request. */

	if(strcmp(iedcmd,"help") == 0)
	{
/*
	    if(sscanf(buff, "%s %s",iedcmd,buff2) == 2)
		help(buff2); 
	    else
		help("help"); 
	    fullrefresh = 1;
*/
	}
	if(strcmp(iedcmd,"grinnell") == 0)
	{
	    if(sscanf(buff,"%s %s",iedcmd,buff2) == 2)
		if(strncmp(buff2,"on",2) == 0)
		{
		    scans->GRN = 1;	/* indicate on */
    		    ginitscr(scans->GRNDEV,scans->GRNCHA,scans->GRNOVL);
    		    gsetdef(scans->GRNDEV,scans->GRNCHA,scans->GRNOVL, 63,510,448, 448);
		}
		else if(strncmp(buff2,"off",3) == 0)
		{
			scans->GRN = 0;	/* indicate off */
		}
		else
			disp_err("USAGE: grinnell [on off]");

		fullrefresh = 0;
	}
    }
    wmove(Comm, 0,0);
    return(fullrefresh);
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * I S S E C T O R	- Returns true if buff contains a valid sector position;
 *			  else returns false.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
issector(buff)

char *buff;
{
	if(strcmp(buff,"n")  == 0)
		return(1);		
	if(strcmp(buff,"ne") == 0)
		return(1);
	if(strcmp(buff,"e")  == 0)
		return(1);
	if(strcmp(buff,"se") == 0)
		return(1);
	if(strcmp(buff,"s")  == 0)
		return(1);
	if(strcmp(buff,"sw") == 0)
		return(1);
	if(strcmp(buff,"w")  == 0)
		return(1);
	if(strcmp(buff,"nw") == 0)
		return(1);
	return(0);
}
