/* fix80.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Fix first two records of 1980 synoptic map file.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 30 April 1991
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

/* structure for synoptic file records. */

struct S
   {
   float  net, et, set, swt, wt, nwt;
   double nec, ec, sec, swc, wc, nwc;
   short  th[361];
   };

main ()

{
   static char namsyn [80];
   FILE *FD;
   int i;
   int sizSYN;
   long offset;		/* offset for fseek.*/
   struct S STT;
   struct S *SYN = &STT;
   /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

   fprintf (stdout, "Enter 1980 synoptic file name: ");
   fscanf  (stdin, "%s", namsyn);
   FD = fopen (namsyn, "r+");

   sizSYN = sizeof (STT);
   fprintf (stderr, "sizSYN: %d\n", sizSYN);
   fflush (stderr);

   i = 0;
   offset = i * sizSYN;
   fseek (FD, offset, 0);
   SYN->net = SYN->et = SYN->set = SYN->swt = SYN->wt = SYN->nwt = 2068.0;
   SYN->nec = SYN->ec = SYN->sec = SYN->swc = SYN->wc = SYN->nwc = 0.0;
   for  (i=0; i<361; i++)  SYN->th [i] = 0;
   if (fwrite ((char *) SYN, sizSYN, 1, FD) == 0)
      {
      fprintf(stderr,"write error: new rec  %d\n", i);
      exit (-2);
      }
   rewind (FD);

   i = 1;
   offset = i * sizSYN;
   fseek (FD, offset, 0);
   SYN->net = SYN->et = SYN->set = SYN->swt = SYN->wt = SYN->nwt = 2068.5;
   if (fwrite ((char *) SYN, sizSYN, 1, FD) == 0)
      {
      fprintf(stderr,"write error: new rec  %d\n", i);
      exit (-3);
      }
   rewind (FD);

   fflush (FD);
   fclose (FD);
   exit (0);

}
