/* synlint(x, xtable, ytable, ntab)
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Linear interpolation: synlint will interpolate on tables.
 *    xtable: float
 *    ytable: integer
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger
 * SMM C/P   HAO/NCAR
 * 5 January 1988
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

/* ------------------------------------------------------------------------- */

float
synlint (x, xtable, ytable, ntab)

float x;		/* independent variable. */
float xtable[];		/* independent variable table. */
int ytable[];		/* dependent variable table. */
int ntab;		/* # values in table. */

{
int i, k;
float y;
float y0, y1;

   for (i=1; i<ntab; i++)
     {
      k = i - 1;
      y0 = (float) ytable[k];
      y1 = (float) ytable[k+1];

      if(x < xtable[i])
        {
        y = y0 + (y1 - y0) * ((x - xtable[k])
              / (xtable[k+1] - xtable[k]));
        return(y);
        }

      if(x == xtable[i])  return((float) ytable[i]);
     }
   return(-1.);

}
