/* synbege.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Synodic (Carrington) rotation start (doy, year).
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   SMM C/P
 * 10 December 1996: use ephemeris.h file.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include "ephemeris.h"

int
syndure (carrot, doy, year)

int carrot;
float &doy ;
int &year ;

{
int irot ;
int begrot ;
int endrot ;
int begyear ;
int endyear ;

float frot ;
float begdoy ;
float enddoy ;
float durrot ;

   frot = (float) carrot ;

   begrot = (int) CRtable [0][0] ;
   endrot = (int) CRtable [NUMROT-2][0] ;

   if (carrot < begrot || carrot > endrot)
      {
      fprintf (stderr,
	 "syndur> Carrington Rotation #%4d is beyond table range (%4d->%4d).\n",
	 carrot, begrot, endrot) ;
      return (-1.0) ;
      }

   for (irot = 0; irot < NUMROT; irot++)
      {
      if (CRtable [irot][0] == frot)  break ;
      }

   begdoy = CRtable [irot][1] ;
   enddoy = CRtable [irot+1][1] ;

   begyear = (int) CRtable [irot][2] ;
   endyear = (int) CRtable [irot+1][2] ;

   if (begyear < endyear)
      {
      if (isleap (begyear))
	 enddoy += 366.0 ;
      else
	 enddoy += 365.0 ;
      }

   &doy  = begdoy ;
   &year = begyear ;

   return (0) ;
}
