/* syndates.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Synodic (Carrington) rotation begin/end dates.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   SMM C/P
 * 10 December 1996: use ephemeris.h file.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include "ephemeris.h"

int
syndates (carrot, beg_doy, beg_year, end_doy, end_year)

int carrot;
float *beg_doy ;
int   *beg_year ;
float *end_doy ;
int   *end_year ;


{
int irot ;
int begrot ;
int endrot ;
int begyear ;
int endyear ;

float frot ;
float begdoy ;
float enddoy ;
float durrot ;

   frot = (float) carrot ;

   begrot = (int) CRtable [0][0] ;
   endrot = (int) CRtable [NUMROT-2][0] ;

   if (carrot < begrot || carrot > endrot)
      {
      fprintf (stderr,
	 "syndates> Carrington Rotation #%4d is beyond table range (%4d->%4d).\n",
	 carrot, begrot, endrot) ;
      return (-1) ;
      }

   for (irot = 0; irot < NUMROT; irot++)
      {
      if (CRtable [irot][0] == frot)  break ;
      }

   begdoy = CRtable [irot][1] ;
   enddoy = CRtable [irot+1][1] ;

   begyear = (int) CRtable [irot][2] ;
   endyear = (int) CRtable [irot+1][2] ;

   if (begyear < endyear)
      {
      if (isleap (begyear))
	 enddoy += 366.0 ;
      else
	 enddoy += 365.0 ;
      }

   durrot = enddoy - begdoy ;

   *beg_doy  = begdoy ;
   *beg_year = begyear ;
   *end_doy  = enddoy ;
   *end_year = endyear ;

   return (0) ;
}
