/* syndoye.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Determine Day-of-year for the start of a Synodic Rotation.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   3 December 1996
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <stdio.h>
#include "ephemeris.h"

float
syndoye (crot)

int crot;
{
   int irot ;
   int begrot ;
   int endrot ;
   float crday;
   int   iyear ;

   begrot = CRtable [0][0] ;
   endrot = CRtable [NUMROT-1][0] ;

   if (crot < begrot || crot > endrot)
      {
      fprintf (stderr, "syndoy> Carrington Rotation #%4d is beyond table range (%4d->%4d)\n",
	       crot, begrot, endrot) ;
      }
   for (irot = 0; irot < NUMROT; irot++)
      {
      if ((int) CRtable [irot][0] == crot)  break ;
      }

   crday =       CRtable [irot][1] ;
   iyear = (int) CRtable [irot][2] ;

/*
 *   print  f ("syndoy> year: %d   rotation: %d   doy: %7.2f\n",
 *            iyear, crot, crday);
 */
   return (crday);
}
