/*
 *  Same as below but gives values for 2 minutes into the future
 * solar.c - solar ephemeris calculations.  Produces sun's
 * ra, dec, az, el, p, b0, sradius calculations
 *
 * SEE ALSO: astrotime.c for time calculations, jday, and last for
 * unix commands, astro.h for miscellaneous definitions.
 */
#include	<stdio.h>
#include "astro.h"

main(argc,argv)
int argc;
char **argv;
{
	long gmt;
	long jday;
	ANGLE Az, El, Sradius, P, B0, L0, Last, Ra, Dec, Ha, Airmass;
	long hh,mm,ss;

	fscanf ( stdin,"%ld %ld %ld %ld",&jday,&hh,&mm,&ss );
	mm += 2;
	if ( mm > 59 )
		{
		mm -= 60;
		hh++;
		if ( hh > 23 )
			{
			hh -=24;
			jday++;
			}
		}
	gmt = hmstosec(hh,mm,ss);

	Last = last(jday,gmt);			/* radians -> degrees */
	Last = fr2d(Last) * 24./ 360.;	/* degrees -> hours */
	Last = fmod(fmod(Last,24.)+24.,24.);	/* positive angle */

	azel((long)jday,(long)gmt,&Az,&El,&Sradius,&P,&B0,&L0);
	solarEphm((long)jday,(long)gmt,&Ra,&Dec,&Sradius,&P,&B0,&L0);
	Az = fr2d(Az);
	if ( Az < 0. )
		Az += 360.;
	fprintf ( stderr,"	Current + 2 minutes\n" );
	fprintf(stderr,"gmt %lg hrs, last %lg hrs, Az %lg deg., El %lg deg.\n",
				(double)gmt/3600.,Last,Az,fr2d(El));
	fprintf(stderr,"sradius %lg, P %lg, B0 %lg, L0 %lg\n",
		fr2d(Sradius)*3600.,fr2d(P),fr2d(B0),fr2d(L0));

	Ra = fr2d(Ra) * 24./ 360.;	/* degrees -> hours */
	Ra = fmod(fmod(Ra,24.)+24.,24.);	/* positive angle */
	Dec = fr2d(Dec);
	Dec = fmod(Dec,360.);	/* positive angle */
	Ha = (Last-Ra)*360./24.;
	Airmass = 1./cos(.01745*Ha);
	fprintf(stderr,"Ra %lg hours., Dec %lg deg. H.A. %lg  Airmass %lg\n",
		Ra,Dec,Ha,Airmass );
/*
fprintf (stderr, "Bench %lg deg.\n",Ha+fr2d(P));
*/
 }
