/* mkengfiles.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Read Spartan 201-3 Engineering Telemetry structure from a disk file.
 * Write individual Spartan 201-3 Engineering Telemetry items to separate files.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   9 October 1996
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "sp201lib.h"
unsigned char ebuf [128] ;		/* Engineering telemetry buffer. */

main (argc, argv)

int argc ;
char *argv [] ;

{
   FILE *FD_ETLM ;
   FILE *FD_MET ;
   FILE *FD_V28 ;
   FILE *FD_V5 ;
   FILE *FD_V12 ;
   FILE *FD_TED_V ;
   FILE *FD_CCD_BAT ;
   FILE *FD_CCD_5 ;
   FILE *FD_CCD_P15 ;
   FILE *FD_CCD_M15 ;
   FILE *FD_CSP ;
   FILE *FD_FMII ;
   FILE *FD_TRG ;
   FILE *FD_YFP ;
   FILE *FD_RFP ;
   FILE *FD_PESP ;
   FILE *FD_PESY ;
   FILE *FD_FBLK ;
   FILE *FD_O1 ;
   FILE *FD_FIL ;
   FILE *FD_ELC ;
   FILE *FD_DET ;
   FILE *FD_TED ;
   FILE *FD_P5V ;
   FILE *FD_EP2 ;
   FILE *FD_K68 ;
   FILE *FD_PIA0AR ;
   FILE *FD_PIA0BR ;
   FILE *FD_PIA1AR ;
   FILE *FD_PIA1BR ;
   FILE *FD_RSTS ;
   FILE *FD_VER ;
   FILE *FD_RELP ;
   FILE *FD_ORB ;
   FILE *FD_IMG ;
   FILE *FD_ACSBP ;
   FILE *FD_PIA1BW ;
   FILE *FD_MSGS ;
   FILE *FD_ACSB07 ;
   FILE *FD_OPTDAT ;
   FILE *FD_LSR ;
   FILE *FD_LSS ;
   FILE *FD_TBL ;
   FILE *FD_PRG ;
   FILE *FD_EOM ;
   FILE *FD_UPCHG ;
   FILE *FD_UVRAST ;
   FILE *FD_WLCCAL ;
   FILE *FD_LWLC ;
   FILE *FD_CCDMD ;
   FILE *FD_CCDER ;
   FILE *FD_CCDEXP ;
   static char file_eng [80] ;
   static char file_met [] = "T95_MET.dat" ;
   static char file_v28 [] = "T95_V28.dat" ;
   static char file_v5  [] = "T95_V5.dat" ;
   static char file_v12  [] = "T95_V12.dat" ;
   static char file_ted_v [] = "T95_TED_V.dat" ;
   static char file_ccd_bat [] = "T95_CCD_BAT.dat" ;
   static char file_ccd_5   [] = "T95_CCD_5.dat" ;
   static char file_ccd_p15 [] = "T95_CCD_P15.dat" ;
   static char file_ccd_m15 [] = "T95_CCD_M15.dat" ;
   static char file_csp [] = "T95_CSP.dat" ;
   static char file_fmii [] = "T95_FMII.dat" ;
   static char file_trg [] = "T95_TRG.dat" ;
   static char file_yfp [] = "T95_YFP.dat" ;
   static char file_rfp [] = "T95_RFP.dat" ;
   static char file_yaw_off [] = "T95_YAW_OFF.dat" ;
   static char file_roll_off [] = "T95_ROLL_OFF.dat" ;
   static char file_pesp [] = "T95_PESP.dat" ;
   static char file_pesy [] = "T95_PESY.dat" ;
   static char file_fblk [] = "T95_FBLK.dat" ;
   static char file_o1 [] = "T95_O1.dat" ;
   static char file_fil [] = "T95_FIL.dat" ;
   static char file_elc [] = "T95_ELC.dat" ;
   static char file_det [] = "T95_DET.dat" ;
   static char file_ted [] = "T95_TED.dat" ;
   static char file_p5v [] = "T95_P5V.dat" ;
   static char file_ep2 [] = "T95_EP2.dat" ;
   static char file_k68 [] = "T95_K68.dat" ;
   static char file_pia0ar [] = "T95_PIA0AR.dat" ;
   static char file_pia0br [] = "T95_PIA0BR.dat" ;
   static char file_pia1ar [] = "T95_PIA1AR.dat" ;
   static char file_pia1br [] = "T95_PIA1BR.dat" ;
   static char file_rsts [] = "T95_RSTS.dat" ;
   static char file_ver [] = "T95_VER.dat" ;
   static char file_relp [] = "T95_RELP.dat" ;
   static char file_orb [] = "T95_ORB.dat" ;
   static char file_img [] = "T95_IMG.dat" ;
   static char file_acsbp [] = "T95_ACSBP.dat" ;
   static char file_pia1bw [] = "T95_PIA1BW.dat" ;
   static char file_msgs [] = "T95_MSGS.dat" ;
   static char file_acsb07 [] = "T95_ACSB07.dat" ;
   static char file_optdat [] = "T95_OPTDAT.dat" ;
   static char file_lsr [] = "T95_LSR.dat" ;
   static char file_lss [] = "T95_LSS.dat" ;
   static char file_tbl [] = "T95_TBL.dat" ;
   static char file_prg [] = "T95_PRG.dat" ;
   static char file_eom [] = "T95_EOM.dat" ;
   static char file_upchg [] = "T95_UPCHG.dat" ;
   static char file_uvrast [] = "T95_UVRAST.dat" ;
   static char file_wlccal [] = "T95_WLCCAL.dat" ;
   static char file_lwlc [] = "T95_LWLC.dat" ;
   static char file_ccdmd [] = "T95_CCDMD.dat" ;
   static char file_ccder [] = "T95_CCDER.dat" ;
   static char file_ccdexp [] = "T95_CCDEXP.dat" ;
   int irec = 0 ;
   int size_SPEH ;

   size_SPEH = sizeof (SPEH) ;

   if (argc == 2)
      strcpy (file_eng, argv [1]) ;
   else
      {
      fprintf (stderr, "usage: %s eng_telem_name\n", argv [0]) ;
      exit (0) ;
      }

   if (( FD_ETLM = fopen (file_eng, "r")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_eng) ;
      exit (-1) ;
      }

   if (( FD_MET = fopen (file_met, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_met) ;
      exit (-1) ;
      }

   if (( FD_V28 = fopen (file_v28, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_v28) ;
      exit (-1) ;
      }

   if (( FD_V5 = fopen (file_v5, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_v5) ;
      exit (-1) ;
      }

   if (( FD_V12 = fopen (file_v12, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_v12) ;
      exit (-1) ;
      }

   if (( FD_TED_V = fopen (file_ted_v, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_ted_v) ;
      exit (-1) ;
      }

   if (( FD_CCD_BAT = fopen (file_ccd_bat, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_ccd_bat) ;
      exit (-1) ;
      }

   if (( FD_CCD_5 = fopen (file_ccd_5, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_ccd_5) ;
      exit (-1) ;
      }

   if (( FD_CCD_P15 = fopen (file_ccd_p15, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_ccd_p15) ;
      exit (-1) ;
      }

   if (( FD_CCD_M15 = fopen (file_ccd_m15, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_ccd_m15) ;
      exit (-1) ;
      }

   if (( FD_CSP = fopen (file_csp, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_csp) ;
      exit (-1) ;
      }

   if (( FD_FMII = fopen (file_fmii, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_fmii) ;
      exit (-1) ;
      }

   if (( FD_TRG = fopen (file_trg, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_trg) ;
      exit (-1) ;
      }

   if (( FD_YFP = fopen (file_yfp, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_yfp) ;
      exit (-1) ;
      }

   if (( FD_RFP = fopen (file_rfp, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_rfp) ;
      exit (-1) ;
      }

   if (( FD_PESP = fopen (file_pesp, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_pesp) ;
      exit (-1) ;
      }

   if (( FD_PESY = fopen (file_pesy, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_pesy) ;
      exit (-1) ;
      }

   if (( FD_FBLK = fopen (file_fblk, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_fblk) ;
      exit (-1) ;
      }

   if (( FD_O1 = fopen (file_o1, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_o1) ;
      exit (-1) ;
      }

   if (( FD_FIL = fopen (file_fil, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_fil) ;
      exit (-1) ;
      }

   if (( FD_ELC = fopen (file_elc, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_elc) ;
      exit (-1) ;
      }

   if (( FD_DET = fopen (file_det, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_det) ;
      exit (-1) ;
      }

   if (( FD_TED = fopen (file_ted, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_ted) ;
      exit (-1) ;
      }

   if (( FD_P5V = fopen (file_p5v, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_p5v) ;
      exit (-1) ;
      }

   if (( FD_EP2 = fopen (file_ep2, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_ep2) ;
      exit (-1) ;
      }

   if (( FD_K68 = fopen (file_k68, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_k68) ;
      exit (-1) ;
      }

   if (( FD_PIA0AR = fopen (file_pia0ar, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_pia0ar) ;
      exit (-1) ;
      }

   if (( FD_PIA0BR = fopen (file_pia0br, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_pia0br) ;
      exit (-1) ;
      }

   if (( FD_PIA1AR = fopen (file_pia1ar, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_pia1ar) ;
      exit (-1) ;
      }

   if (( FD_PIA1BR = fopen (file_pia1br, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_pia1br) ;
      exit (-1) ;
      }

   if (( FD_RSTS = fopen (file_rsts, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_rsts) ;
      exit (-1) ;
      }

   if (( FD_VER = fopen (file_ver, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_ver) ;
      exit (-1) ;
      }

   if (( FD_RELP = fopen (file_relp, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_relp) ;
      exit (-1) ;
      }

   if (( FD_ORB = fopen (file_orb, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_orb) ;
      exit (-1) ;
      }

   if (( FD_IMG = fopen (file_img, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_img) ;
      exit (-1) ;
      }

   if (( FD_ACSBP = fopen (file_acsbp, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_acsbp) ;
      exit (-1) ;
      }

   if (( FD_PIA1BW = fopen (file_pia1bw, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_pia1bw) ;
      exit (-1) ;
      }

   if (( FD_MSGS = fopen (file_msgs, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_msgs) ;
      exit (-1) ;
      }

   if (( FD_ACSB07 = fopen (file_acsb07, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_acsb07) ;
      exit (-1) ;
      }

   if (( FD_OPTDAT = fopen (file_optdat, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_optdat) ;
      exit (-1) ;
      }

   if (( FD_LSR = fopen (file_lsr, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_lsr) ;
      exit (-1) ;
      }

   if (( FD_LSS = fopen (file_lss, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_lss) ;
      exit (-1) ;
      }

   if (( FD_TBL = fopen (file_tbl, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_tbl) ;
      exit (-1) ;
      }

   if (( FD_PRG = fopen (file_prg, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_prg) ;
      exit (-1) ;
      }

   if (( FD_EOM = fopen (file_eom, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_eom) ;
      exit (-1) ;
      }

   if (( FD_UPCHG = fopen (file_upchg, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_upchg) ;
      exit (-1) ;
      }

   if (( FD_UVRAST = fopen (file_uvrast, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_uvrast) ;
      exit (-1) ;
      }

   if (( FD_WLCCAL = fopen (file_wlccal, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_wlccal) ;
      exit (-1) ;
      }

   if (( FD_LWLC = fopen (file_lwlc, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_lwlc) ;
      exit (-1) ;
      }

   if (( FD_CCDMD = fopen (file_ccdmd, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_ccdmd) ;
      exit (-1) ;
      }

   if (( FD_CCDER = fopen (file_ccder, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_ccder) ;
      exit (-1) ;
      }

   if (( FD_CCDEXP = fopen (file_ccdexp, "a")) == NULL)
      {
      fprintf (stderr, "Unable to open file: %s\n", file_ccdexp) ;
      exit (-1) ;
      }

   /*** Read Engineering Telemetry to a disk file. ***/

/*
   while (fread (SPEH, size_SPEH, 1, FD_ETLM) == 1)
      {
      fwrite (SPEH->met, sizeof (int), 1, FD_MET) ;
      fwrite (SPEH->p28v, sizeof (int), 1, FD_V28) ;
      fwrite (SPEH->p5v, sizeof (int), 1, FD_V5) ;
      fwrite (SPEH->p12v, sizeof (int), 1, FD_V12) ;
      fwrite (SPEH->rs232_ted_volt, sizeof (int), 1, FD_TED_V) ;
      fwrite (SPEH->ccd_bat_p6v, sizeof (int), 1, FD_CCD_BAT) ;
      fwrite (SPEH->ccd_p5v, sizeof (int), 1, FD_CCD_5) ;
      fwrite (SPEH->ccd_p15v, sizeof (int), 1, FD_CCD_P15) ;
      fwrite (SPEH->ccd_m15v, sizeof (int), 1, FD_CCD_M15) ;
      fwrite (SPEH->sun_pres, sizeof (int), 1, FD_CSP) ;
      fwrite (SPEH->fine_mode2, sizeof (int), 1, FD_FMII) ;
      fwrite (SPEH->pitch_trig_rate, sizeof (int), 1, FD_TRG) ;
      fwrite (SPEH->yaw_fine_pos, sizeof (int), 1, FD_YFP) ;
      fwrite (SPEH->roll_fine_pos, sizeof (int), 1, FD_RFP) ;
      fwrite (SPEH->pes_pitch, sizeof (int), 1, FD_PESP) ;
      fwrite (SPEH->pes_yaw, sizeof (int), 1, FD_PESY) ;
      fwrite (SPEH->front_bulk_temp, sizeof (int), 1, FD_FBLK) ;
      fwrite (SPEH->o1_temp, sizeof (int), 1, FD_O1) ;
      fwrite (SPEH->fw_temp, sizeof (int), 1, FD_FIL) ;
      fwrite (SPEH->ccd_elec_temp, sizeof (int), 1, FD_ELC) ;
      fwrite (SPEH->ccd_det_temp, sizeof (int), 1, FD_DET) ;
      fwrite (SPEH->ted_hot_temp, sizeof (int), 1, FD_TED) ;
      fwrite (SPEH->p5v_supply_temp, sizeof (int), 1, FD_P5V) ;
      fwrite (SPEH->elec_pkg2_temp, sizeof (int), 1, FD_EP2) ;
      fwrite (SPEH->m68000_temp, sizeof (int), 1, FD_K68) ;
      fwrite (SPEH->, sizeof (int), 1, FD_PIA0AR) ;
      fwrite (SPEH->, sizeof (int), 1, FD_PIA0BR) ;
      fwrite (SPEH->, sizeof (int), 1, FD_PIA1AR) ;
      fwrite (SPEH->, sizeof (int), 1, FD_PIA1BR) ;
      fwrite (SPEH->, sizeof (int), 1, FD_RSTS) ;
      fwrite (SPEH->, sizeof (int), 1, FD_VER) ;
      fwrite (SPEH->, sizeof (int), 1, FD_RELP) ;
      fwrite (SPEH->, sizeof (int), 1, FD_ORB) ;
      fwrite (SPEH->, sizeof (int), 1, FD_IMG) ;
      fwrite (SPEH->acs_pointer, sizeof (int), 1, FD_ACSBP) ;
      fwrite (SPEH->, sizeof (int), 1, FD_PIA1BW) ;
      fwrite (SPEH->msg_flag_sot, sizeof (int), 1, FD_MSGS) ;
      fwrite (SPEH->acs_buf, sizeof (int), 1, FD_ACSB07) ;
      fwrite (SPEH->optoo_data_id, sizeof (int), 1, FD_OPDAT) ;
      fwrite (SPEH->last_sunrise, sizeof (int), 1, FD_LSR) ;
      fwrite (SPEH->last_sunset, sizeof (int), 1, FD_LSS) ;
      fwrite (SPEH->table_num, sizeof (int), 1, FD_TBL) ;
      fwrite (SPEH->prog_num, sizeof (int), 1, FD_PRG) ;
      fwrite (SPEH->eom_flag, sizeof (int), 1, FD_EOM) ;
      fwrite (SPEH->undet_pitch_flag, sizeof (int), 1, FD_UPCHG) ;
      fwrite (SPEH->uvcs_raster_flag, sizeof (int), 1, FD_UVRAST) ;
      fwrite (SPEH->wlc_cal_flag, sizeof (int), 1, FD_WLCCAL) ;
      fwrite (SPEH->wlc_liss_flag, sizeof (int), 1, FD_LWLC) ;
      fwrite (SPEH->ccd_mode, sizeof (int), 1, FD_CCDMD) ;
      fwrite (SPEH->ccd_erase, sizeof (int), 1, FD_CCDER) ;
      fwrite (SPEH->ccd_expdur, sizeof (int), 1, FD_CCDEXP
      }
 */

   while (fread (ebuf, 128, 1, FD_ETLM) == 1)
      {
      fwrite (&ebuf [  6], 2, 1, FD_MET) ;

      fwrite (&ebuf [ 12], 2, 1, FD_V28) ;
      fwrite (&ebuf [ 14], 2, 1, FD_V5) ;
      fwrite (&ebuf [ 16], 2, 1, FD_V12) ;

      fwrite (&ebuf [ 20], 2, 1, FD_TED_V) ;
      fwrite (&ebuf [ 22], 2, 1, FD_CCD_BAT) ;
      fwrite (&ebuf [ 24], 2, 1, FD_CCD_5) ;
      fwrite (&ebuf [ 26], 2, 1, FD_CCD_P15) ;
      fwrite (&ebuf [ 28], 2, 1, FD_CCD_M15) ;

      fwrite (&ebuf [ 34], 2, 1, FD_CSP) ;
      fwrite (&ebuf [ 36], 2, 1, FD_FMII) ;
      fwrite (&ebuf [ 38], 2, 1, FD_TRG) ;
      fwrite (&ebuf [ 40], 2, 1, FD_YFP) ;
      fwrite (&ebuf [ 42], 2, 1, FD_RFP) ;

      fwrite (&ebuf [ 48], 2, 1, FD_PESP) ;
      fwrite (&ebuf [ 50], 2, 1, FD_PESY) ;
      fwrite (&ebuf [ 52], 2, 1, FD_FBLK) ;
      fwrite (&ebuf [ 54], 2, 1, FD_O1) ;
      fwrite (&ebuf [ 56], 2, 1, FD_FIL) ;
      fwrite (&ebuf [ 58], 2, 1, FD_ELC) ;
      fwrite (&ebuf [ 60], 2, 1, FD_DET) ;

      fwrite (&ebuf [ 66], 2, 1, FD_TED) ;
      fwrite (&ebuf [ 68], 2, 1, FD_P5V) ;
      fwrite (&ebuf [ 70], 2, 1, FD_EP2) ;
      fwrite (&ebuf [ 72], 2, 1, FD_K68) ;

      fwrite (&ebuf [ 74], 1, 1, FD_PIA0AR) ;
      fwrite (&ebuf [ 75], 1, 1, FD_PIA0BR) ;
      fwrite (&ebuf [ 76], 1, 1, FD_PIA1AR) ;
      fwrite (&ebuf [ 77], 1, 1, FD_PIA1BR) ;
      fwrite (&ebuf [ 78], 1, 1, FD_RSTS) ;
      fwrite (&ebuf [ 79], 1, 1, FD_VER) ;
      fwrite (&ebuf [ 80], 2, 1, FD_RELP) ;
      fwrite (&ebuf [ 82], 1, 1, FD_ORB) ;
      fwrite (&ebuf [ 83], 1, 1, FD_IMG) ;
      fwrite (&ebuf [ 84], 1, 1, FD_ACSBP) ;
      fwrite (&ebuf [ 85], 1, 1, FD_PIA1BW) ;
      fwrite (&ebuf [ 86], 1, 1, FD_MSGS) ;
      fwrite (&ebuf [ 87], 8, 1, FD_ACSB07) ;

      fwrite (&ebuf [ 95], 1, 1, FD_OPTDAT) ;
      fwrite (&ebuf [ 96], 4, 1, FD_LSR) ;
      fwrite (&ebuf [100], 4, 1, FD_LSS) ;

      fwrite (&ebuf [112], 1, 1, FD_TBL) ;
      fwrite (&ebuf [113], 1, 1, FD_PRG) ;
      fwrite (&ebuf [114], 1, 1, FD_EOM) ;
      fwrite (&ebuf [115], 1, 1, FD_UPCHG) ;

      fwrite (&ebuf [117], 1, 1, FD_UVRAST) ;
      fwrite (&ebuf [118], 1, 1, FD_WLCCAL) ;
      fwrite (&ebuf [119], 1, 1, FD_LWLC) ;
      fwrite (&ebuf [114], 1, 1, FD_CCDMD) ;
      fwrite (&ebuf [125], 1, 1, FD_CCDER) ;
      fwrite (&ebuf [126], 2, 1, FD_CCDEXP) ;
      }

   fclose (FD_ETLM) ;
   fclose (FD_MET) ;
   fclose (FD_V28) ;
   fclose (FD_V5) ;
   fclose (FD_V12) ;
   fclose (FD_TED_V) ;
   fclose (FD_CCD_BAT) ;
   fclose (FD_CCD_5) ;
   fclose (FD_CCD_P15) ;
   fclose (FD_CCD_M15) ;
   fclose (FD_CSP) ;
   fclose (FD_FMII) ;
   fclose (FD_TRG) ;
   fclose (FD_YFP) ;
   fclose (FD_RFP) ;
   fclose (FD_PESP) ;
   fclose (FD_PESY) ;
   fclose (FD_O1) ;
   fclose (FD_FIL) ;
   fclose (FD_ELC) ;
   fclose (FD_DET) ;
   fclose (FD_TED) ;
   fclose (FD_P5V) ;
   fclose (FD_EP2) ;
   fclose (FD_K68) ;
   fclose (FD_PIA0AR) ;
   fclose (FD_PIA0BR) ;
   fclose (FD_PIA1AR) ;
   fclose (FD_PIA1BR) ;
   fclose (FD_RSTS) ;
   fclose (FD_VER) ;
   fclose (FD_RELP) ;
   fclose (FD_ORB) ;
   fclose (FD_IMG) ;
   fclose (FD_ACSBP) ;
   fclose (FD_PIA1BW) ;
   fclose (FD_MSGS) ;
   fclose (FD_ACSB07) ;
   fclose (FD_OPTDAT) ;
   fclose (FD_LSR) ;
   fclose (FD_LSS) ;
   fclose (FD_TBL) ;
   fclose (FD_PRG) ;
   fclose (FD_EOM) ;
   fclose (FD_UPCHG) ;
   fclose (FD_UVRAST) ;
   fclose (FD_WLCCAL) ;
   fclose (FD_LWLC) ;
   fclose (FD_CCDMD) ;
   fclose (FD_CCDER) ;
   fclose (FD_CCDEXP) ;

   return (0) ;
}
