/* newimg.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Write Spartan image to disk.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   20 September 1996
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

newimg ()

{
   extern int met_prev ;
   extern int ir ;			/* ir: current block (record) index. */
   extern int ib ;			/* ib: current byte index. */
   extern int blkcnt ;			/* # data blocks in raw tape or file. */
   extern unsigned short imgbuf [256][320] ;	/* Image 2D buffer. */
   extern unsigned char  blkbuf [8200] ;	/* Data Block buffer. */
   extern unsigned char *blkhdr ;		/* Block header data. */
   extern unsigned char *dbuf ;			/* Data. */
   extern int dblknum  ;		/* Data block number. */
   extern int derrcnt ;			/* Data block error count. */
   extern int npxlin ;			/* # pixels per line. */
   extern int nbyimg ;			/* # bytes per image = 256 * 320 * 2. */
   extern int nbypix ;			/* # bytes per pixel. */
   extern int npximg ;			/* # pixels per image  = 256 * 320. */
   extern FILE *FD_RAW, *FD_IMG, *FD_LOG ;

   static char imgfile [80] ;
   static int ldaymo [12] = {31,29,31,30,31,30,31,31,30,31,30,31};
   static int ndaymo [12] = {31,28,31,30,31,30,31,31,30,31,30,31};
   int iyear ;
   int idoy  ;
   int imonth ;
   int iday ;
   int ihour ;
   int imin ;
   int isec ;
   int iyear0 =  95 ;
   int idoy0  = 251 ;
   int ihour0 =  15 ;
   int imin0  =  47 ;
   int sct0   =   0 ;
   float sec0  = 35.0 ;

   /*** MET = 0 corresponds to 1995 DOY 251 15:42:25 + 00:05:10 = 15:47:35 ***/

   metgmt (iyear0, idoy0, ihour0, imin0, sec0, sct0, met_prev,
	  &iyear,  &idoy,  &ihour,  &imin,  &isec) ;

   month_day (iyear, idoy, &imonth, &iday) ;

   sprintf (imgfile, "sp201.19%02d%02d%02d.%02d%02d%02d.img",
	    iyear, imonth, iday, ihour, imin, isec) ;

/*
 *   sprintf (imgfile, "sp201-3.%08d.img", met_prev) ;
 */

   fprintf (FD_LOG, "---> Writing image to file: %s\n", imgfile) ;
   fprintf (stdout, "---> Writing image to file: %s\n", imgfile) ;
   if (( FD_IMG = fopen (imgfile, "w")) == NULL)
      {
      fprintf (stderr, "imgfmt> Unable to open file: %s\n", imgfile) ;
      exit (-201) ;
      }
   fwrite (imgbuf, npximg, nbypix, FD_IMG) ;
   fclose (FD_IMG) ;

   return (0) ;
}
