/* msgfmt.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Spartan 201-04 Message Data Formatter.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   17 Sep 1996
 * 13 May 1998: "sp201lib.h" replaced by "sp2014lib.h".
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "sp2014lib.h"

msgfmt (pmode)

int pmode ;					/* Print mode. */
{
   extern int msgmet_prev ;
   extern int ifd ;			/* ifd: current data frame index. */
   extern int ib ;			/* ib: current byte index. */
   extern int blkcnt ;				/* # data blocks in tape/file.*/
   extern unsigned char  blkbuf [BLKSIZ] ;
   extern unsigned char  *blkhdr ;
   extern unsigned char  *dbuf ;
   extern int dblknum  ;
   extern int derrcnt ;
   extern long ifloc ;                  /* Byte position within telem. file. */
   extern int nbymsg;		/* # bytes per msg frame = 40 [nbymdf] */
   extern FILE *FP_RAW, *FP_DLOG ;

   /*** Sync Pattern (bytes 0-5) : 063 052 146 125 000 010 (octal) ***/

   int msg1 ;			/* bytes  6 -  7. */
   int msg1_met ;		/* bytes  8 - 11. */
   int msg2 ;			/* bytes 12 - 13. */
   int msg2_met ;		/* bytes 14 - 17. */
   int msg3 ;			/* bytes 18 - 19. */
   int msg3_met ;		/* bytes 20 - 23. */
   int msg4 ;			/* bytes 24 - 25. */
   int msg4_met ;		/* bytes 26 - 29. */
   int msg5 ;			/* bytes 30 - 31. */
   int msg5_met ;		/* bytes 32 - 35. */
   int msg_ptr ;		/* bytes 36 - 37. */

   static unsigned char mbuf [NBYMDF] ;	/* Message telemetry buffer. */

   int i ;
   int is ;
   int msgmet_new = 0 ;
   int nbyend = 0 ;		/* # msg bytes remaining at end of block. */
   int nbybeg = 0 ;		/* # msg bytes remaining at start of block.*/

   fseek (FP_RAW, -6L, SEEK_CUR) ;
   fread (mbuf, 1, NBYMDF, FP_RAW) ;

   /*** Decode Message Telemetry Frame. ***/

   spmtlm (mbuf, pmode) ;

   fprintf (FP_DLOG, "msgfmt> msg1:%4d  msg1_met:%4d\n",
		     SPMH->msg1, SPMH->msg1_met) ;

   fprintf (FP_DLOG, "msgfmt> msg2:%4d  msg2_met:%4d\n",
		     SPMH->msg2, SPMH->msg2_met) ;

   fprintf (FP_DLOG, "msgfmt> msg3:%4d  msg3_met:%4d\n",
		     SPMH->msg3, SPMH->msg3_met) ;

   fprintf (FP_DLOG, "msgfmt> msg4:%4d  msg4_met:%4d\n",
		     SPMH->msg4, SPMH->msg4_met) ;

   fprintf (FP_DLOG, "msgfmt> msg5:%4d  msg5_met:%4d\n",
		     SPMH->msg5, SPMH->msg5_met) ;

   fprintf (FP_DLOG, "msgfmt> msgptr:%4d\n",
		     SPMH->msg_pointer) ;

   /*** Write Message Telemetry to disk. ***/

   newmsg (mbuf, pmode) ;

   return (0) ;
}
