/* neweng.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Write Spartan 201-4 Engineering Telemetry to a disk file.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   4 October 1996
 * 13 May 1998: "sp201lib.h" replaced by "sp2014lib.h".
 * 14 Oct 1998: "sp2014lib.h" replaced by "sp2015lib.h".
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "sp2015lib.h"

neweng (ebuf, pmode)

unsigned char ebuf [NBYEDF] ;		/* Engineering telemetry buffer. */

{
   extern int idf ;			/* idf: current data frame index. */
   extern int ib ;			/* ib: current byte index. */
   extern long ifloc ;                  /* Byte position within telem. file. */
   extern FILE *FP_ETLM ;
   int size_SPEH ;

   size_SPEH = sizeof (SPEH) ;

   /*** Write Engineering Telemetry to a disk file. ***/

/*
   if (fwrite (SPEH, size_SPEH, 1, FP_ETLM) == 0)
      {
      fprintf (stderr, "neweng> write error... idf: %d  ifloc: %d\n",
	       idf, ifloc) ;
      exit (-1) ;
      }
 */

   if (fwrite (ebuf, 1, NBYEDF, FP_ETLM) == 0)
      {
      fprintf (stderr, "neweng> write error... idf: %d  ifloc: %d\n",
	       idf, ifloc) ;
      exit (-1) ;
      }

   return (0) ;
}
