/* newmsg.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Write Spartan 201-4 Message Telemetry to a disk file.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   25 April 1997
 * 13 May 1998: "sp201lib.h" replaced by "sp2014lib.h".
 * 14 Oct 1998: "sp2014lib.h" replaced by "sp2015lib.h".
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "sp2015lib.h"

newmsg (mbuf, pmode)

unsigned char mbuf [NBYMDF] ;		/* Message telemetry buffer. */

{
   extern int idf ;		/* Current data frame index. */
   extern long ifloc ;		/* Byte position within telemetry file. */
   extern FILE *FP_MTLM ;
   int size_SPMH ;

   size_SPMH = sizeof (SPMH) ;

   /*** Write Message Telemetry to a disk file. ***/

/*
   if (fwrite (SPMH, size_SPMH, 1, FP_MTLM) == 0)
      {
      fprintf (stderr, "newmsg> write error... idf: %d  ifloc: %d\n",
	       idf, ifloc) ;
      exit (-1) ;
      }
 */

   if (fwrite (mbuf, NBYMDF, 1, FP_MTLM) == 0)
      {
      fprintf (stderr, "newmsg> write error... idf: %d  ifloc: %d\n",
	       idf, ifloc) ;
      exit (-1) ;
      }

   return (0) ;
}
