;Date: Thu, 6 Apr 1995 16:30:13 -0400
;From: lika@madhu.gsfc.nasa.gov (Madhulika Guhathakurta, 301 286 0722)
;To: card@hao.ucar.edu
;Subject: This is the program that dumps the tape to disk.

;-------------------------------------------------------------------------------
; dump_tape.pro
;-------------------------------------------------------------------------------
; DUMP_TAPE dumps a SPARTAN 201 WLC digital tape to a disk file for use in
; reformatting.
; D.M. fecit, 26 May, 1993.
; Modified, 2 November, 1994 for 680 cluster tape choice.
;-------------------------------------------------------------------------------
print, '**** You MUST have a tape logical unit number defined. ****'
print, '**** That is, ther emust be a logical name of the form ****'
print, '**** mt<n>, where <n> is a single digit, e.g. mt0.     ****'

tape_unit = '' & READ, 'Tape unit number [0 - 4]   ', tape_unit
tape_unit = FIX (tape_unit)

MOUNT, tape_unit

tape_header = INTARR (4100)
TAPRD, tape_header, tape_unit
n_block = tape_header (0)
tape_number = tape_header (3)
tape_number = STRMID (STRING (100 + tape_number, format = '(i3)'), 1, 2)
default_file_name = 'tape_' + tape_number + '.dat'

file_name = ''
read,'File name for dumped data [D = ' + default_file_name + ']      ', $
   file_name
IF file_name eq '' then file_name = default_file_name

OPENW, dump_unit, 'spartan$data:' + file_name, 8192, /get_lun
w = ASSOC (dump_unit, BYTARR (8192))
b = BYTARR (8200)

;--- Write last block first to allocate the disk space now.

w (n_block) = b (8:*)

ON_IOERROR, fred
!err = 0
i_rec = 0

WHILE (!err GE 0) DO BEGIN
   TAPRD, b, tape_unit
   w (i_rec) = b (8:*)
   IF (i_rec MOD 50 EQ 0) THEN print, $
      '%DUMP_TAPE-I-WORKING, wrote block ' + STRTRIM (i_rec,2) + ' to disk.'
   i_rec = i_rec + 1
END

fred: CLOSE, dump_unit
FREE_LUN, dump_unit
DISMOUNT, tape_unit
print,'%DUMP_TAPE-S-FINISHED, closed file SPARTAN$DATA:' + file_name
print,'                       after writing ' + STRTRIM (i_rec,2) + ' blocks.'
;
END
;-------------------------------------------------------------------------------
