;From: lika@sdac.gsfc.nasa.gov
;Date: Thu, 6 Apr 1995 16:28:08 -0400
;To: card@hao.ucar.edu
;Subject: Find_image.pro is used by reformat program
;-------------------------------------------------------------------------------
; find_image.pro
;-------------------------------------------------------------------------------
; FIND_IMAGE finds the vector indices of the beginning of putative image
; data frames in the SPARTAN 201 WLC data.
; D.M. fecit, 16 May, 1993.
;-------------------------------------------------------------------------------
PRO find_image, data_array, image_frame

;--- First two and sixth sync pattern bytes to identify image data frames.
;--- (Hope this is enough.)

b0 = '33'xb
b1 = '2a'xb
bd = 4b

w0 = WHERE (data_array EQ b0)
w1 = WHERE (data_array EQ b1)
w2 = WHERE (data_array EQ bd)

a1 = data_array (w0 + 1)
a2 = data_array (w0 + 5)

wz = WHERE ((a1 EQ b1) * (a2 EQ bd))
wx = w0 (wz)

n_frame = N_ELEMENTS (wx)

print, 'FIND_IMAGE-I-N_FRAME, number of image frames found =', n_frame

image_frame = wx

RETURN
END
;-------------------------------------------------------------------------------
