From lika@madhu.gsfc.nasa.gov Thu Apr  6 14:29 MDT 1995
Received: from madhu (madhu.gsfc.nasa.gov [128.183.57.192]) by hao.ucar.edu (8.6.11/8.6.6.Beta9) with SMTP id OAA10268 for <card@hao.ucar.edu>; Thu, 6 Apr 1995 14:29:38 -0600
Date: Thu, 6 Apr 1995 16:33:03 -0400
Message-Id: <95040616330317@madhu.gsfc.nasa.gov>
From: lika@madhu.gsfc.nasa.gov (Madhulika Guhathakurta, 301 286 0722)
To: card@hao.ucar.edu
Subject: find_telem.pro
X-VMS-To: SMTP%"card@hao.ucar.edu"
X-VMS-Cc: LIKA
Content-Type: text
Content-Length: 673
Status: R

; FIND_TELEM
; FIND_TELEM finds the vector indices of the beginning of putative telemetry
; data frames in the SPARTAN 201 WLC data.
; D.M. fecit, 16 May, 1993.
;
pro find_telem, data_array, telem_frame
;
; First two and sixth synch pattern bytes to identify telemetry data frames.
; (Hope this is enough.)
;
b0 = '33'xb & b1 = '2a'xb & bd = 0b
;
w0 = where(data_array eq b0) & w1 = where(data_array eq b1)
w2 = where(data_array eq bd)
a1 = data_array(w0 + 1) & a2 = data_array(w0 + 5)
wz = where((a1 eq b1)*(a2 eq bd))
wx = w0(wz) & n_frame = n_elements(wx)
;
print,'FIND_TELEMETRY-I-N_FRAME, number of telemetry frames found =', n_frame
;
telem_frame = wx
;
return & end

