PRO SPFINDSYNC, fmt, ibuf, obuf
;
; procedure to find the next occurence of one of the sync patterns in the 
; input buffer. This assumes that the sync pattern for all formats has
; 6 bytes for which the 1st 5 are the same. A better algorithm would be nice
;
;	Author: Greg Ucker
;	Date:	21 October 1993
;
; MODIFICATIONS:
sslen = 127L
synclen = 6L
csync = fmt(0).sync(0L:synclen-2L)
ncom = n_elements(csync)
ssbin = min ([sslen, ibuf.ibvalid - ibuf.ibpos - 1L])
sync_found = 0B
csync_found = 0B

while ((ibuf.ibpos + synclen le ibuf.ibvalid) and (not sync_found)) do begin

match0 = ibuf.ibpos+where(ibuf.ib(ibuf.ibpos:ibuf.ibpos+ssbin-1L) eq csync(0))

	nth = 0L
	npossible = n_elements(match0)

	if match0(nth) ge ibuf.ibpos then begin

	while ((nth lt npossible) and (not sync_found)) do begin
;	   ibuf.ibpos = match0(nth)
	   if match0(nth)+synclen le ibuf.ibvalid then begin
		csync_found = $
			(total(ibuf.ib(match0(nth):match0(nth)+ncom-1L) $
			eq csync) eq ncom)
		if csync_found then begin
		   fmti  = where(fmt(*).sync(5) eq $
				ibuf.ib(match0(nth)+synclen-1L))
		   sync_found = (fmti(0) gt -1L)	; now its real
		endif
	   endif
	   nth = nth+1L
	endwhile

	if not sync_found then begin
		ibuf.ibpos = ibuf.ibpos + ssbin
		ssbin = min( [sslen, ibuf.ibvalid - ibuf.ibpos -1L] )
	endif

	endif else begin
		ibuf.ibpos = ibuf.ibpos + ssbin
		ssbin = min ([sslen, ibuf.ibvalid - ibuf.ibpos -1L])
		fmti = [-1L]
	endelse


endwhile


; tells at what point a) sync was found, or b) to which position was searched
; also screens for the first sync found in the stream
if sync_found then begin
	ibuf.ibpos = match0(nth-1L)+synclen
	ibuf.syncfnd = fmti(0)
endif else begin
	ibuf.syncfnd = -1L
endelse

return
end

