PRO SPREAD, ilun, ibuf, ifstat, nbzeros
; reads out the raw input stream and sticks it in the input
; buffer. Detects the eof of the istream file gracefully
; and sets ibuf.ibend to the number of actual bytes read in the eof
; case, otherwise its n_elements(ib)
;
;	Author:	Greg Ucker HAO/NCAR
;	Date:	20 October 1993
;
; MODIFICATIONS:
;		A) take care of buffer of zeros at end of input files
;			GJU 15 Dec 1993
;

stat = fstat(ilun)
ibsize = stat.size - stat.cur_ptr - nbzeros

; handle case where the remaining data in the file is less than the 
; ibuf.tbrd parameter
if ibsize le ibuf.tbrd then begin
	ib = bytarr(ibsize)
	readu,ilun,ib
	ibuf.ib(ibuf.ibvalid:ibuf.ibvalid+ibsize-1L) = ib
	ibuf.ibvalid = ibuf.ibvalid + ibsize
	ibuf.tbrd = 0L
	ifstat.eofflag = 1
endif else begin
	ib = bytarr(ibuf.tbrd)
	readu,ilun,ib
	ibuf.ib(ibuf.ibvalid:ibuf.ibvalid+ibuf.tbrd-1L) = ib
	ibuf.ibvalid = ibuf.ibvalid + ibuf.tbrd
	ibuf.tbrd = 0L
	ifstat.eofflag = 0
endelse

ibuf.ibpos = 0L	; set the 1st valid byte to 1st byte in buffer

return
end
