/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * fbsrf2.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Read byte image from SGI/WHIP frame buffer & convert it to a sun rasterfile.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR   26 May 1993
 * 14 Dec 1993: 
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include <gl/gl.h>
#include <whip.h>

main (argc, argv )

int argc;
char *argv [];
{
   extern char *malloc ();
   unsigned char *imgbuf;
   unsigned char *cbuf;
   unsigned short *sbuf;
   float *fbuf;
   static unsigned char red [256], green [256], blue [256];

   static char namsrf [80];
   int FB = 0;			/* Frame Buffer number. */
   int dx, dy, dz;		/* Frame Buffer size. */
   int fbd;			/* Frame Buffer descriptor. */
   int i;
   int imin, imax;
   int nbypx;			/* # bytes per pixel. */
   int nbyimg;
   int rel = 0;			/* relative flag for fb_setaddr. */
   int row;			/* row index counter. */
   int startx = 0;		/* X location for writing. */
   int xll, yll;		/* Lower left  corner coordinates. */
   int xur, yur;		/* Upper right corner coordinates. */
   float frange;

   xll = yll = 0;
   xur = yur = 511;

   if (argc  == 6)
      {
      strcpy (namsrf, argv [1]);
      sscanf (argv [2], "%d", &xll);
      sscanf (argv [3], "%d", &yll);
      sscanf (argv [4], "%d", &xur);
      sscanf (argv [5], "%d", &yur);
      }
   else
   if (argc == 2)
      {
      strcpy (namsrf, argv [1]);
      }
   else
      {
      fprintf (stderr, "Usage: %s [sun_rasterfile_name]\n", argv [0]);

      fprintf (stderr, "Enter name of output sun rasterfile: ");
      fscanf  (stdin,  "%s", namsrf);
      }

   /*** Fetch current frame buffer number. ***/

/*
   fbd = fb_getfb ();
   fb_getsize (fbd, &dx, &dy, &dz);
   nbypx = fb_bytes (fb_kind (FB));
 */
   dx = xur - xll + 1;
   dy = yur - yll + 1;
   if (dx == 0 || dy == 0)
      dx = dy = 512;
   nbypx = 1;

   /*** Allocate memory for image array. ***/

   nbyimg = dx * dy * nbypx;
   imgbuf = (unsigned char *) malloc (nbyimg);
   switch (nbypx)
      {
      case 1: cbuf = (unsigned char *)  imgbuf;  break;
      default: fprintf (stderr, "Invalid FB kind; nbypx = %d\n", nbypx);
               exit (-1);
      }


   /*** Copy image from frame buffer to memory. ***/

   fb_open ();					/* Initialize WHIP software. */
   fb_setfb (FB);				/* Set current FB. */
   fb_xstep ();					/* Auto increment in x axis. */

   for (row = 0; row < dy; row++)
      {
      fb_setaddr (FB, rel, xll, yur - row, 0);	/* Set read address in FB. */
      fb_read (imgbuf + row*dx, dx);		/* Read one row from FB. */
/*      fb_getline (rel, dx, 0, row, 0, imgbuf+row*dx); */
      }
   fb_close ();					/* Terminate WHIP software. */

   /*** Read color table. ***/

   noport ();
   winopen (argv [0]);
   get_scmap (512, 256, red, green, blue);

   bytsrf (namsrf, imgbuf, dx, dy, red, green, blue);

   free (imgbuf);
   exit (0);
}
