/* fits2srf.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Convert FITS file to Sun Rasterfile format.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   17 March 1994
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

main (argc, argv)

int argc ;
char *argv [] ;

{
   extern dofits2srf () ;	/* Read FITS, write SRF. */
   FILE *LIST ;			/* File descriptor. */
   unsigned char *rdfits () ;	/* Function to read FITS image. */
   static char namfit [84] ;	/* Name of FITS file. */
   static char namlst [84] ;	/* Name of FITS list file. */

   int seq = 0 ;		/* Sequence ? =0 no,  =1 yes. */

   if (argc == 2)
      strcpy (namfit, argv [1]) ;
   else
      {
      fprintf (stderr, "usage: %s [@]fits_file\n", argv [0]) ;
      exit (0) ;
      }

   /*** Sequence of images. ***/

   if (namfit [0] == '@')
      {
      seq = 1 ;
      strcpy (namlst, &namfit [1]) ;
      if ((LIST = fopen (namlst, "r")) == NULL)
	 {
	 fprintf (stderr, "Unable to open file: %s\n", namlst) ;
	 exit (-1) ;
	 }
      while (fscanf (LIST, "%s", namfit) != EOF)
	 dofits2srf (namfit) ;
	 {
	 }
      }

   /*** Single image. ***/

   else
      dofits2srf (namfit) ;

   exit (0) ;
}
