/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * imgsrf.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Read byte image from file & convert it to a Sun rasterfile.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   1 November 1990   SGI version
 * 11 December 1991: add command line arguments.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include <gl.h>

main (argc, argv)

int argc ;
char *argv [] ;
{
FILE *LIST ;

unsigned char *imgbuf ;
unsigned char *line ;
static unsigned char red [256], green [256], blue [256] ;

static char nambyt [80] ;
static char namlst [80] ;
static char namsrf [80] ;
static char dir2 [4] ;			/* Scan direction: rd, ru. */
int nx, ny ;
int fd ;
int i ;
int imin, imax ;
int iy ;
int nbyimg ;
int nread ;
int seq = 0;

   /*** Read command line arguments. ***/

   if (argc == 5)
      {
      sscanf (argv [1], "%d", &nx) ;
      sscanf (argv [2], "%d", &ny) ;
      strcpy (dir2, argv [3]) ;
      strcpy (nambyt, argv [4]) ;
      }
   else
      {
      fprintf (stderr,
	       "usage: %s x_size y_size scan_dir byte_image_name | @img_list\n",
	       argv [0]);
      exit (0) ;
      }

   if ((strcmp (dir2, "rd") != 0) && (strcmp (dir2, "ru") != 0))
      {
      fprintf (stderr,
	 "Unsupported scan direction (%s) . . . must be rd or ru.\n", dir2) ;
      exit (-1) ;
      }

   if (nambyt [0] == '@')
      {
      seq = 1 ;
      strcpy (namlst, &nambyt [1]) ;
      if ((LIST = fopen (namlst, "r")) == NULL)
	 {
	 fprintf (stderr, "Unable to open file: %s\n", namlst) ;
	 exit (-2) ;
	 }
      }

   /*** Read color map (#2) from SGI workstation. ***/

   noport () ;
   winopen (argv [0]) ;
   get_scmap (512, 256, red, green, blue) ;

loop:

   if (seq)
      if (fscanf (LIST, "%s", nambyt) == EOF)
	 {
         gexit () ;
	 exit (0) ;
	 }

   sprintf (namsrf, "%s.sun", nambyt) ;
   fprintf (stdout, "namsrf: %s\n", namsrf) ;

   /*** Open input image file. ***/

   if ((fd = open (nambyt, 0)) <= 0)
      {
      fprintf (stderr, "Unable to open %s\n", nambyt) ;
      exit (-1) ;
      }

   /*** Read image from file. ***/

   nbyimg = nx * ny ;
   imgbuf = (unsigned char *) malloc (nbyimg) ;

   if (strcmp (dir2, "ru") == 0)	/* Reverse image top-to-bottom.*/
   for (iy = 0; iy < ny; iy++)
      {
      line = imgbuf + (ny - 1 - iy) * nx ;
      nread = read (fd, line, nx) ;
      }
   else
      nread = read (fd, imgbuf, nbyimg) ;

   /*** Write image to new file in Sun rasterfile format. ***/

   bytsrf (namsrf, imgbuf, nx, ny, red, green, blue) ;

   free (imgbuf) ;

   if (seq)
      goto loop ;

   gexit () ;
   exit (0) ;
}
