/* loadcm.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Load SGI color look-up tables.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 3 February 1992
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <gl/gl.h>

loadcm (begindex, numindex, r, g, b)

int begindex;		/* starting index value for color LUT. */
int numindex;		/* # consecutive entries. */
short r [], g [], b [];	/* arrays containing Red/Green/Blue color intensities.*/
{
   Colorindex it;		/* Colorindex = unsigned short. */
   int ic;
   short red, green, blue;

   for (ic = 0; ic < numindex; ic++)
      {
      it = ic + begindex;
      red   = (short) r [ic] & 0xff;
      green = (short) g [ic] & 0xff;
      blue  = (short) b [ic] & 0xff;
      mapcolor (it, red, green, blue);
      }

/*   gflush (); */

   return (0);
}
