/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * M A G I M G ( )	Magnify a portion of an image.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

unsigned char *
magimg (imgbuf, nbypx, dx, dy, nx, ny)

unsigned char *imgbuf ;	/* Pointer to input image array. */
int nbypx ;		/* # bytes per pixel. */
int dx, dy ;		/* Dimensions of box to be magnified. */
int nx, ny ;		/* Dimensions of output image. */
{
   extern float blint () ;	/* Bilinear interpolator. */
   unsigned char *imgout ;	/* Pointer to output image array. */
   float fvalue = 0;
   float xxcen, yycen ;		/* Center of output image. */
   float xinc, yinc ;		/* Magnification. */
   float x, y ;			/* Pixel coordinates. */
   float xx, yy ;		/* Pixel coordinates. */
   register float *xp, *yp ;	/* Pointers to pixel coordinates. */
   int outsiz ;			/* # elements in output image. */
   register int ix, iy ;	/* Indices. */
   register int value = 0 ;	/* Temporary storage for pixel value. */
   register unsigned char  *obc ;
   register unsigned short *obs ;
   register float          *obf ;
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	xp = &xx ;
	yp = &yy ;

	outsiz = nx * ny * nbypx;
	imgout = (unsigned char *) malloc (outsiz) ;

	x = 0.0 ;		/* Lower left x-coordinate. */
	y = 0.0 ;		/* Lower left y-coordinate. */

	xinc = (float) (dx) / (float) (nx) ;	/* X-axis increment. */
	yinc = (float) (dy) / (float) (ny) ;	/* Y-axis increment. */

printf ("nbypx: %4d\n", nbypx) ;
printf ("imgout: %d   outsiz: %d\n", imgout, outsiz) ;
printf ("outsiz: %d\n", outsiz) ;
printf ("x: %6.2f  y: %6.2f\n", x, y) ;
printf ("dx: %d   dy: %d   nx: %d   ny:  %d\n", dx, dy, nx, ny) ;
printf ("xinc: %f   yinc: %f\n", xinc, yinc) ;

   if (nbypx == 1)
      {
      obc = (unsigned char *) imgout ;
      *yp = y - yinc ;
      for (iy = 0 ; iy < ny; iy++)
         {
         *yp += yinc ;
         *xp = x - xinc ;
         for (ix = 0 ; ix < nx; ix++)
            {
            *xp += xinc ;
            value = (int) blint (imgbuf, nbypx, dx, dy, xp, yp) ;
            *(obc + ix + iy*ny) = (unsigned char) (value & 0377) ;
            }
         }
      }
   else
   if (nbypx == 2)
      {
      obs = (unsigned short *) imgout ;
      *yp = y - yinc ;
      for (iy = 0 ; iy < ny; iy++)
         {
         *yp += yinc ;
         *xp = x - xinc ;
         for (ix = 0 ; ix < nx; ix++)
            {
            *xp += xinc ;
            value = (int) blint (imgbuf, nbypx, dx, dy, xp, yp) ;
            *(obs + ix + iy*ny) = (unsigned short) (value & 0177777) ;
            }
         }
      }
   else
   if (nbypx == 4)
      {
      obf = (float *) imgout ;
      *yp = y - yinc ;
      for (iy = 0 ; iy < ny; iy++)
         {
         *yp += yinc ;
         *xp = x - xinc ;
         for (ix = 0 ; ix < nx; ix++)
            {
            *xp += xinc ;
            fvalue = (float) blint (imgbuf, nbypx, dx, dy, xp, yp) ;
            *(obf + ix + iy*ny) = fvalue ;
            }
         }
      }

/*   free (imgbuf) ; */
   return (imgout) ;
}
