/* wboxb.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Move a BYTE image from memory array to SGI IRIS frame buffer.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 *  8 March 1991
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include <whip.h>

wboxb (imgbuf, xs, ys, dx, dy, dir2)

char *imgbuf;			/* image array. */
int xs, ys;			/* origin of image in frame buffer. */
int dx, dy;			/* # pixels in x & y dimensions. */
char dir2 [3];			/* write direction: "rd", "ru", "ld", "lu". */

{
   int FB = 6;			/* 512x512 byte frame buffer (colormap). */
   int fast = 1;		/* Parameter for fb_clear. */
   int rel = 0;			/* relative flag for fb_setaddr. */
   int row;			/* row index counter. */
   int z = 0;			/* Z location for writing. */
   float grey = 0.0;		/* Grey level for fb_clear. */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

   /*** Clear frame buffer to zero, then copy disk image to frame buffer. ***/

   fb_open ();					/* Initialize WHIP software. */
   FB = fb_getfb ();
   fb_setfb (FB);				/* Set current FB. */
   fb_clear (FB, &grey, fast);			/* Clear frame buffer. */
   fb_xstep ();					/* Auto increment in x axis. */

   for (row=0; row<dy; row++)
      {
/*      printf ("wboxb> row: %3d\n", row); */
/*      fb_setaddr (FB, rel, xs, ys, z); */		/* Set write address in FB. */
      fb_write (imgbuf + row*dx, dx);		/* Write one row to FB. */
      }

   fb_close ();					/* Terminate WHIP software. */
   return (0);
}
