/* wimgfb.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Move a BYTE image from memory array to SGI IRIS frame buffer.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 12 December 1991
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include <whip.h>

wimgfb (FB, imgbuf, xs, ys, xdim, ydim)

int FB;				/* frame buffer number. */
char *imgbuf;			/* image array. */
int xs, ys;			/* origin of image in frame buffer. */
int xdim, ydim;			/* # pixels in x & y dimensions. */

{
   int fast = 1;		/* Parameter for fb_clear. */
   int rel = 0;			/* relative flag for fb_setaddr. */
   int row;			/* row index counter. */
   int xpos, ypos;		/* Start position for writing each line. */
   int z = 0;			/* Z location for writing. */
   float grey = 0.0;		/* Grey level for fb_clear. */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

   /*** Clear frame buffer to zero, then copy disk image to frame buffer. ***/

   fb_setfb (FB);				/* Set current FB. */
   fb_clear (FB, &grey, fast);			/* Clear frame buffer. */
   fb_xstep ();					/* Auto increment in x axis. */

   xpos = 0;
   for (row = 0; row < ydim; row++)
      {
      ypos = ys - row;
      fb_setaddr (FB, rel, xpos, ypos, z);	/* Set address in FB. */
      fb_write (imgbuf + row * xdim, xdim);	/* Write row to FB.   */
      }
   return (0);
}
