/* day_of_year.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Compute day-of-year from month & day.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   6 January 1994
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
static int day_tab [2][13] =
   {
      { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},
      { 0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31}
   } ;


day_of_year (year, month, day)

int year  ;
int month ;
int day   ;

{
   int doy, i, leap ;

   doy = day ;
   leap = year % 4 == 0 && year % 100 != 0 || year % 400 == 0 ;

   for (i = 1; i < month; i++)
      doy += day_tab [leap][i] ;

   return (doy);
}
