/* hkfits.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Read FITS header data unit(s) & print associated variables.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   17 March 1994
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "/home/stanger/lib/include/fitslib.h"

#define NBYFIT 2880
#define NCHLIN 80
#define NLINES 36

main (argc, argv)

int argc ;
char *argv [] ;

{
   FILE *FD ;			/* file descriptor. */
   static char namfit [84] ;	/* Name of FITS file. */

   if (argc == 2)
      strcpy (namfit, argv [1]) ;
   else
      {
      fprintf (stderr, "usage: %s fits_file\n", argv [0]) ;
      exit (0) ;
      }

   printf ("namfit: %s\n", namfit) ;

   /*** Open FITS file. ***/

   if ((FD = fopen (namfit, "r")) == NULL)
      {
      fprintf (stderr, "Unable to open FITS file: %s\n", namfit) ;
      exit (-1) ;
      }
   fclose (FD) ;

   /*** Read FITS header data unit(s). ***/

   rdhdu (namfit) ;

   print_fits () ;
   
   exit (0) ;
}
