/* mk3ba.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Read MLSO Mark-III barrel angles.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   9 February 1994
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>
#include "/home/stanger/lib/include/mk3lib.h"

main (argc, argv)

int argc;
char *argv [];

{
   char imgbuf;
   static char name [80];
   static char nameba [80];
   static char namlst [80];
   FILE *LIST, *IN, *OUT;
   int nelem;

   if (argc == 2)
      {
      strcpy (name, argv [1]);
      }
   else
      {
      fprintf (stderr, "usage: %s [image_file | @image_file_list]\n", argv [0]);
      exit (-1);
      }


   if (name [0] == '@')
      {
      strcpy (namlst, &name [1]);
      if ((LIST = fopen (namlst, "r")) == NULL)
	 {
	 fprintf (stderr, "Unable to open file: %s\n", namlst);
	 exit (-2);
	 }
      while (fscanf (LIST, "%s", nameba) != EOF)
	 {
         rdmk3ba (nameba);
	 }
      fclose (LIST);
      }
   else
      {
      strcpy (nameba, name);
      rdmk3ba (nameba);
      }

   exit (0);
}
