/* fc.c
 * ----------------------------------------------------------------------
 * Determines F-corona for radius r (Rsun units)
 *----------------------------------------------------------------------
 * Andrew L. Stanger   NCAR/HAO   SMM C/P
 * 15 May 1986: F-corona equation taken from ATM/WLCE Technical Memo #15.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 */
#include <math.h>

float
fcorona (r, th)

float r;	/* Radius (R/Rsun). */
float th;	/* Position Angle (degrees). */

{
double	sin ();			/* Sine function. */
float	f;			/* Storage for F-corona value. */
float	s;			/* Storage for sine function value. */
float	Cexp = 1.0e-11;		/* Scale factor for calibrated images. */
float	raddeg = 0.017453293;	/* Conversion factor: radians / degree. */

/* ---------------------------------------------------------------------- */

  s = (float) (sin ((double) (th * raddeg)));
  f = Cexp * 4739.6 * (1.0 + 0.23732 * s*s)
		* (float) pow ((double) r, (double) -2.72375);

   return (f);
}
