
/* remstr.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Removes stray light from array 'data'.
 *----------------------------------------------------------------------
 * rsun  = array of radial values (units of rsun). 
 * nr = # elements in rsun array (=1 for radial scan, =ndata for theta scan).
 * data  = array of intensity values (units of 10**-11 b/bsun).
 * ndata = # elements in array data.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * Andrew L. Stanger   programmer III   NCAR/HAO   SMM C/P
 *  3 February 1983: PDP-11/34 Fortran-4+ RSX-11M
 * 18 July 1984: conversion to VAX 750 (C).
 *----------------------------------------------------------------------
 */

#include <stdio.h>

remstr (rsun, nr, data, ndata)

int nr, ndata;
float rsun [];
float data [];

{

int i;
float r;
float s;
extern float stray ();

   if (nr > 1 && nr < ndata)
      {
      fprintf (stderr, "# rsun values:%d less than # data values:%d\n",
               nr, ndata);
      return (-1);
      }

   if (nr > 1)		/* Radial scans. */
      {
      for (i=0; i<ndata; i++)
         {
         r = rsun [i];
         data [i] -= stray (r);
         }
      return (0);
      }

   else
   if (nr == 1)		/* Theta scans. */
      {
       r = rsun [0];
       s = stray (r);
       for (i=0; i<ndata; i++)  data [i] -= s;
       return (0);
       }
}
