/* srevbyt.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Reverse byte order for a short integer image.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   SMM C/P   HAO/NCAR
 * 21 March 1988
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

srevbyt (ucbuf, nbytpx, nelem)

unsigned char *ucbuf;	/* Image array. */
int nbytpx;		/* # bytes per pixel. */
int nelem;		/* # elements in array. */

{
   register unsigned char *cimg;
   register unsigned char ctemp;
   register int i;

   if (nbytpx != 2)
      {
      fprintf (stderr, "srevbyt> image pixels are NOT short integers.\n");
      return (-1);
      }

   cimg = (unsigned char *) ucbuf;

   /*** Reverse odd & even bytes in image array. ***/

   for (i=0; i<nelem; i++)
      {
      ctemp = *(cimg + 2*i);
      *(cimg + 2*i)   = *(cimg + 2*i+1);
      *(cimg + 2*i+1) = ctemp;
      }
   return (0);
}
