/* glmk3_scalers.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Draw solar radius measuring scale.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Andrew L. Stanger   HAO/NCAR   4 April 1991: SGI/GL version.
 * 7 January 1994: adapt for MLSO Mark-III.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include "/home/stanger/lib/include/mk3lib.ext"
#include "/home/stanger/lib/include/img_scale.ext"
#include "/home/stanger/lib/include/gl_color.h"

glmk3_scalers (cindex)

int cindex;	/* Color LUT index. */
{
   int x;
   int x0 = 63;
   int xdim = 512;
   int xgs, xgdim;
   int gpixrs;
   int tx = 4;		/* Size of 1/2 of tick mark. */
   int yt;		/* frame buffer y-coordinate for top of tick mark. */
   int ym;		/* frame buffer y-coordinate for middle of tick mark. */
   int yb = 52;		/* frame buffer y-coordinate for bottom of tick mark. */

   gpixrs = (int) MK3I->pixrs;
   ym = yb + tx;
   yt = ym + tx;

   /*** Write black in Rsun scale box. ***/

   color (gl_black);
   rectfi (x0, yb, x0 + xdim - 1, yt);

   /*** Draw ticks along the bottom of the image. ***/

   /*** At X sun center position. ***/

    x = (int) (MK3I->xcen + 0.0) + gMINROW;
    gl_wvec (x-tx, ym, x+tx, ym, cindex);
    gl_wvec (x,    yt, x,    yb, cindex);

   /*** To right of X sun center position. ***/

    while (((x += gpixrs) > x0) && (x < (x0 + xdim)))
      {
      gl_wvec (x, yt, x, yb, cindex);
      }

   /*** To left  of X sun center position. ***/

    x = (int) (MK3I->xcen + 0.0) + gMINROW;
    while (((x -= gpixrs) > x0) && (x < (x0 + xdim)))
      {
      gl_wvec (x, yt, x, yb, cindex);
      }

   return (0);
}
