;+
; NAME		suninfo
;
; PURPOSE	Computes solar P-angle, B-angle, and radius (arcsec).
;
; SYNTAX	suninfo, 'dd-mmm-yyyy hh:mm:ss'
;
; EXTERNAL	pb0r.pro (found in solar software package)
;
; AUTHOR	Andrew L. Stanger   HAO/NCAR   11 Nov 1998
;+

PRO suninfo, date_time

; date_time = '1-nov-1998 00:00:00'

ang = pb0r (date_time, /arcsec)

pangle = ang [0]
bangle = ang [1]
rsun   = ang [2]

print, 'pangle: ', pangle, 'degrees'
print, 'bangle: ', bangle, 'degrees'
print, 'rsun:   ', rsun, ' arcsec'

END
