/* sec.c
 * -----------------------------------------------------------------------------
 * Test soleph.c [compute solar ephemeris parameters].
 * -----------------------------------------------------------------------------
 * Andrew L. Stanger   HAO/NCAR    9 Dec 2002
 * -----------------------------------------------------------------------------
 */

#include <stdio.h>

main (argc, argv)

int argc ;
char *argv [] ;

{
    extern int soleph () ;

    int year ;
    int month ;
    int day ;
    int hour ;
    int minute ;
    int second ;

    int crot ;

    float Ro ;
    float Bo ;
    float Lo ;
    float Po ;
    float RA ;
    float DEC ;

    /*** Get date & time from command line. ***/

    if (argc < 7)
	{
	fprintf (stderr, "Usage: %s year month day hour minute second\n",
		 argv [0]) ;
        exit (0) ;
	}
    else
	{
        sscanf (argv [1], "%d", &year) ;
        sscanf (argv [2], "%d", &month) ;
        sscanf (argv [3], "%d", &day) ;
        sscanf (argv [4], "%d", &hour) ;
        sscanf (argv [5], "%d", &minute) ;
        sscanf (argv [6], "%d", &second) ;
	}

    soleph (year, month, day, hour, minute, second,
	    &Ro, &Po, &Bo, &Lo, &RA, &DEC, &crot) ;

    printf ("\n") ;
    printf ("date: %4d-%02d-%02d\n", year, month, day) ;
    printf ("time: %02d:%02d:%02d\n", hour, minute, second) ;
    printf ("Po:   %9.4f [deg]\n",    Po) ;
    printf ("Bo:   %9.4f [deg]\n",    Bo) ;
    printf ("Lo:   %9.4f [deg]\n",    Lo) ;
    printf ("crot: %d\n",           crot) ;
    printf ("Ro:   %9.4f [arcsec]\n", Ro) ;
    printf ("RA:   %9.4f [deg]\n",    RA) ;
    printf ("DEC:  %9.4f [deg]\n",   DEC) ;

    exit (0) ;
}
