/*  This is the stucture of the solution of the MK4 telescope parameters.
   
    In this version elements X21 and X31 of 
    the X matrix are 2-d.

    Written by Alice Lecinski, June 2001.

    I strongly suggest *not* editting this code at all, unless
    you are absolutely sure you've found an error that
    needs fixing.

    If you edit it, you risk destroying the integrity of the
    code.  So if you do edit it, insure results pre and post
    actually match.
   

 */

struct telhd {

    struct mk4_header hd0i;
    struct mk4_header hd0q;
    struct mk4_header hd0u;
    struct mk4_header hd15i;
    struct mk4_header hd15q;
    struct mk4_header hd15u;
    struct mk4_header hdCi;     /* C for coronal */
    struct mk4_header hdCq;
    struct mk4_header hdCu;

    unsigned short tdysdate;
    short fill;
    float TiltPhi200; /* Phase in degrees of the Tilt15q image at pixel 200 */
    float TiltPhi300; /* Phase in degrees of the Tilt15q image at pixel 300 */

    float Bopal;
    float ang1;   /* -9999.0 */
    float fp1;    /* 0.0 */
    float ang0;   /* -9999.0 */
    float fp0;    /* 0.0 */
    float trt;
    float fpt;

    float x11;  /* 1.0 */
    float x12;  /* 0.0 */
    float x13;  /* 0.0 */
    float x21[NPX];  /* just for plotting convenience, use 2-d below */
    float x22[NPX];
    float x23[NPX];
    float x31[NPX];  /* just for plotting convenience, use 2-d below */
    float x32[NPX];
    float x33[NPX];

    float vgain[NPX]; /* just for plotting convenience, use 2-d below */

    float Gain[NAZ*NPX];  /* NOTE this is a theta by R array */
    float x21a[NAZ*NPX];  /* NOTE this is a theta by R array */
    float x31a[NAZ*NPX];  /* NOTE this is a theta by R array */

} ;


typedef struct telhd * (TLH) ;


#ifdef START
    struct telhd telscp;
    struct telhd *thd = &telscp;
#else
    extern struct telhd  telscp , *thd ;
#endif
