/*
 *		F O P . C
 *
 *	F77-callable arithmetic operations
 *
 *	iand	inot	ior	ishft	ishftl	ishftr	ixor
 *
 *	C language	4.2 bsd UNIX	HAO VAX-11/750
 */

/*
 * Arithmetic AND operation :
 */

int iand_(i,mask)
  int *i, *mask ;
  {
   return (*i & *mask) ;
  }

/*
 * Arithmetic NOT operation (1's complement) :
 */

int inot_(i)
  int *i ;
  {
   return (~*i) ;
  }

/*
 * Inclusive OR operation :
 */

int ior_(i,mask)
  int *i, *mask ;
  {
   return (*i | *mask) ;
  }

/*
 * Bit shift (left) operation :
 */

int ishft_(i,mask)
  int *i, *mask ;
  {
   return (*i << *mask) ;
  }

/*
 * Left bit shift operation :
 */


int ishftl_(i,nbits)
  int *i, *nbits ;
  {
   return (*i << *nbits) ;
  }

/*
 * Right bit shift operation :
 */

int ishftr_(i,nbits)
  int *i, *nbits ;
  {
   return (*i >> *nbits) ;
  }

/*
 * Exclusive OR operation :
 */

int ixor_(i,mask)
  int *i, *mask ;
  {
   return (*i ^ *mask) ;
  }
