/* gmtdatim.c
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Current date & time in UTC (universal coordinated time).
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
#include <stdio.h>

main (argc, argv)

int argc ;
char *argv [] ;

{
   extern int gmt_time () ;
   int iyear, idoy, iday, imonth, ihour, imin, isec ;
   static int ig [7] ;

   gmt_time (ig) ;

   fprintf (stdout, "iyear:  %d\n", ig [0] + 1900) ;
   fprintf (stdout, "idoy:   %d\n", ig [1]) ;
   fprintf (stdout, "iday:   %d\n", ig [2]) ;
   fprintf (stdout, "imonth: %d\n", ig [3]) ;
   fprintf (stdout, "ihour:  %d\n", ig [4]) ;
   fprintf (stdout, "imin:   %d\n", ig [5]) ;
   fprintf (stdout, "isec:   %d\n", ig [6]) ;

   exit (0) ;
}


/* gmt_time (ic)
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Fetches current date and time (UTC: Universal Coordinated Time).
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Uses current date and time to return decimal values for
 * Day-of-Year, day, month, and year-1900.
 * Also returns values for hours, minutes, and seconds.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * 7 February 2000
 * Andrew L. Stanger
 * IRIX 6.5   C-programming language
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 */

#include <sys/types.h>
#include <time.h>

gmt_time (gt)

struct { int iyear; int idoy; int iday; int imonth;
         int ihour; int imin; int isec; } *gt;
{
   struct tm *gmtime (), *gts ;
   long time (), t;

   t = time (0);

   gts = gmtime (&t) ;

   gt->iyear  = gts->tm_year;
   gt->idoy   = gts->tm_yday + 1;
   gt->iday   = gts->tm_mday;
   gt->imonth = gts->tm_mon + 1;
   gt->ihour  = gts->tm_hour;
   gt->imin   = gts->tm_min;
   gt->isec   = gts->tm_sec;

   return (0) ;
}
