#!/opt/local/bin/perl

#
# This cgi script will search the data on
#   toshi and return the requested filenames
#   along with their full pathname.
#

use strict;
use Cwd;
use Time::JulianDay;

#my $base = "http://hao.ucar.edu/internal/cgi-bin";
my $base = "http://mlso.hao.ucar.edu/cgi-bin";
my $images = "http://download.hao.ucar.edu/d5/www/images";
my $styles = "http://download.hao.ucar.edu/d5/www/styles";
my $query = $ENV{QUERY_STRING};
my @query = split(/&/,$query);
my $numargs = @query;
my ($year,$mon,$day,$inst,$wavelength,$image_type,$doy,$yrddoy,$quality);
#my ($yearsearch, $monthsearch, $daysearch,$filestr,$searchstr);
my ($yearsearch, $monthsearch, $daysearch,$filestr,$numfiles);
my @filestats = stat "mlso_getdata.cgi";
my @gm_arr = localtime($filestats[9]);
my $create_str = sprintf("%02d/%02d/%02d %02d:%02d:%02d",
        $gm_arr[4]+1,$gm_arr[3],$gm_arr[5]-100,$gm_arr[2],$gm_arr[1],$gm_arr[0]);

sub where;
sub getimgs;

if ($numargs == 7){ 		#Daily listing
  $year       = $query[0];
  $mon        = $query[1];
  $day        = $query[2];
  $inst       = $query[3];
  $wavelength = $query[4];
  $image_type = $query[5];
  $quality    = $query[6];
  $doy	= julian_day($year,$mon,$day) - julian_day($year-1,12,31);
  $yrddoy = sprintf("%02dd%03d",substr($year,2,2),$doy);
  $daysearch = 1;
} elsif ($numargs == 6) {	#Monthly Listing
  $year       = $query[0];
  $mon        = $query[1];
  $inst       = $query[2];
  $wavelength = $query[3];
  $image_type = $query[4];
  $quality    = $query[5];
  $day  = 1;
  $doy	= julian_day($year,$mon,$day) - julian_day($year-1,12,31);
  $yrddoy = sprintf("%02dd%03d",substr($year,2,2),$doy);
  $monthsearch = 1;
} else {			#Yearly listing
  $year       = $query[0];
  $inst       = $query[1];
  $wavelength = $query[2];
  $image_type = $query[3];
  $quality    = $query[4];
  $day = 1;
  $mon = 1;
  $doy = 1;
  $yrddoy = sprintf("%02dd%03d",substr($year,2,2),$doy);
  $yearsearch = 1;
}

my $logdir = "/puu/f/cordyn/DATA_BASE";
my $basedir = "/toshi/ftp";

my @months =("01_jan","02_feb","03_mar","04_apr","05_may",
	     "06_jun","07_jul","08_aug","09_sep","10_oct","11_nov","12_dec");

my %instruments = ('CHIP',"chp",'PICS',"dpm",'MKIV',"mk4");
my %logs = ('CHIP',"chiasLogs",'PICS',"pciasLogs",'MKIV',"midx");
my (@files,$here,$month,$logpath,@bestname);

if ($inst ne "MKIV"){
  $logpath = "$logdir/$logs{$inst}";
} else {
  $logpath = "/puu/f/cordyn/mk4_best/$year";
}
 
# if quality = "all" then we don't need to search
# the processing logs.

if ($yearsearch && ($quality eq "all")){
   @files = ();
   for (my $index = 0; $index <= 11; $index++){
     chdir "$basedir/$year/$months[$index]";
     my $datestr = sprintf("%d%02d",$year,$index + 1);
     $here = cwd();
     opendir DATA, $here;
     my @temp = grep /^$datestr(.*?)$instruments{$inst}(.*?)$image_type/, readdir DATA;
     closedir DATA;
     @temp = grep /$wavelength/,@temp;
     # put in pathname info for href tag
     foreach my $t (@temp){
       $t =~  s/^/$here\//;
       my @tmp = split("/",$t);
       $t = join("/",@tmp[3..6]);
     }
     push @files, @temp;
   }
} elsif ($monthsearch && ($quality eq "all")){
   my $datestr   = sprintf("%d%02d",$year,$mon);
   chdir "$basedir/$year/@months[$mon-1]";
   $here = cwd();
   opendir DATA, $here;
   @files = grep /^$datestr(.*?)$instruments{$inst}(.*?)$image_type/, readdir DATA;
   closedir DATA;
   @files = sort(grep /$wavelength/,@files);
   # put in pathname info for href tag
   foreach my $t (@files){
     $t =~  s/^/$here\//;
     my @tmp = split("/",$t);
     $t = join("/",@tmp[3..6]);
   }

} elsif ($daysearch && ($quality eq "all")){
   my $datestr   = sprintf("%d%02d%02d",$year,$mon,$day);
   chdir "$basedir/$year/@months[$mon-1]";
   $here = cwd();
   opendir DATA, $here;
   @files = grep /^$datestr(.*?)$instruments{$inst}(.*?)$image_type/, readdir DATA;
   closedir DATA;
   @files = grep /$wavelength/,@files;
   # put in pathname info for href tag
   foreach my $t (@files){
     $t =~  s/^/$here\//;
     my @tmp = split("/",$t);
     $t = join("/",@tmp[3..6]);
   }
# Now we do need to go thru the processing logs to extract
# the Good, Bad, Best, or Archive images.
} elsif ($yearsearch){
  my $mon = 0;
  for(my $index = 0; $index <=11; $index++){
   #my $mon += $index;
   $mon++;
   for (my $i = 1;$i <= 31; $i++){
     $day = $i;
     $doy = julian_day($year,$mon,$day) - julian_day($year-1,12,31);
     $yrddoy = sprintf("%02dd%03d",substr($year,2,2),$doy);
     push(@files,getimgs($year,$mon,$day,$yrddoy));
   }
  }
} elsif ($monthsearch){
  @files = ();
  for (my $i = 1;$i <= 31; $i++){
    $day = $i;
    $doy = julian_day($year,$mon,$day) - julian_day($year-1,12,31);
    $yrddoy = sprintf("%02dd%03d",substr($year,2,2),$doy);
    push(@files,getimgs($year,$mon,$day,$yrddoy));
  }
} elsif ($daysearch){
  @files = getimgs($year,$mon,$day,$yrddoy);
}
$numfiles = @files;
my @jpegs = sort(grep /jpg/, @files);
my @fits = sort(grep /fts/, @files);
my $numjpegs = @jpegs;
my $numfits = @fits;
my $jpegstr = join '&',@jpegs;
my $fitsstr = join '&',@fits;

#
#  Create the HTML page with file listing.
#
print <<END_OF_PAGE;
Content-type: text/html

<html>
<head>
<title>$inst Data Search Results</title>

<link rel="stylesheet" type="text/css"
href="$styles/mlsohome.css" />

<script language="JavaScript">
<!--

function MM_swapImgRestore() { //v2.0
  if (document.MM_swapImgData != null)
    for (var i=0; i<(document.MM_swapImgData.length-1); i+=2)
      document.MM_swapImgData[i].src = document.MM_swapImgData[i+1];
}

function MM_preloadImages() { //v2.0
  if (document.images) {
    var imgFiles = MM_preloadImages.arguments;
    if (document.preloadArray==null) document.preloadArray = new Array();
    var i = document.preloadArray.length;
    with (document) for (var j=0; j<imgFiles.length; j++) if (imgFiles[j].charAt(0)!="#"){
      preloadArray[i] = new Image;
      preloadArray[i++].src = imgFiles[j];
  } }
}

function MM_swapImage() { //v2.0
  var i,j=0,objStr,obj,swapArray=new Array,oldArray=document.MM_swapImgData;
  for (i=0; i < (MM_swapImage.arguments.length-2); i+=3) {
    objStr = MM_swapImage.arguments[(navigator.appName == 'Netscape')?i:i+1];
    if ((objStr.indexOf('document.layers[')==0 && document.layers==null) ||
        (objStr.indexOf('document.all[')   ==0 && document.all   ==null))
      objStr = 'document'+objStr.substring(objStr.lastIndexOf('.'),objStr.length);
    obj = eval(objStr);
    if (obj != null) {
      swapArray[j++] = obj;
      swapArray[j++] = (oldArray==null || oldArray[j-1]!=obj)?obj.src:oldArray[j];
      obj.src = MM_swapImage.arguments[i+2];
  } }
  document.MM_swapImgData = swapArray; //used for restore
}
//-->

</script>
</head>

<body onLoad="MM_preloadImages('$images/btnContact2.png','#88238');MM_preloadImages('$images/btnData2.png','#88238');MM_preloadImages('$images/btnDocs2.png','#88238');MM_preloadImages('$images/btnHome2.png','#88238');MM_preloadImages('$images/btnImages2.png','#88238');MM_preloadImages('$images/btnInst2.png','#88238');MM_preloadImages('$images/btnMissions2.png','#88238');MM_preloadImages('$images/btnMovies2.png','#88238');MM_preloadImages('$images/btnSpaceWx2.png','#88238')">

<p align="center">
<img src="$images/mlso_banner3.sml.gif">
</p>
<p align="center">

<a href="mlso_homepage.cgi" onMouseOut="MM_swapImgRestore()" 
onMouseOver="MM_swapImage('document.homeBtn','document.homeBtn', '$images/btnHome2.png')">
<img name="homeBtn" border="0" src="$images/btnHome1.png"></a><a 

href="mlso_data.cgi?2001&MLSO" onMouseOut="MM_swapImgRestore()" 
onMouseOver="MM_swapImage('document.dataBtn','document.dataBtn',
'$images/btnData2.png')"><img  border="0" name="dataBtn" src="$images/btnData2.png"></a><!--<a 

href="mlso_instruments.cgi" onMouseOut="MM_swapImgRestore()" 
onMouseOver="MM_swapImage('document.instrumentsBtn','document.instrumentsBtn','$images/btnInst2.png')"
><img name="instrumentsBtn" border="0" src="$images/btnInst1.png"></a><a 

href="mlso_documentation.cgi" onMouseOut="MM_swapImgRestore()" 
onMouseOver="MM_swapImage('document.docsBtn','document.docsBtn','$images/btnDocs2.png')"
><img name="docsBtn" border="0" src="$images/btnDocs1.png"></a><a 

href="mlso_spacewx.cgi" onMouseOut="MM_swapImgRestore()" 
onMouseOver="MM_swapImage('document.spacewxBtn','document.spacewxBtn','$images/btnSpaceWx2.png')"
><img name="spacewxBtn" border="0" src="$images/btnSpaceWx1.png"></a><a 

href="mlso_pastmissions.cgi" onMouseOut="MM_swapImgRestore()" 
onMouseOver="MM_swapImage('document.missionsBtn','document.missionsBtn','$images/btnMissions2.png')"
><img name="missionsBtn" border="0" src="$images/btnMissions1.png"></a>--><a 

href="mlso_contact.cgi" onMouseOut="MM_swapImgRestore()" 
onMouseOver="MM_swapImage('document.contactusBtn','document.contactusBtn','$images/btnContact2.png')"
><img name="contactusBtn" border="0" src="$images/btnContact1.png"></a> 

<H1 class = "datatitle">$inst Data Search Results</h1>
<br>
<form name="myform" method="GET">
<input type="button" name="animate_but" value="Animate jpegs" onClick='location = "$base/mlso_animate.cgi?$jpegstr"'>
<input type="button" name="download_but" value="Download jpegs" onClick='location = "$base/mlso_download.cgi?$jpegstr&/mlsodata.jpgs.tar"'>
<input type="button" name="download_but" value="Download fits" onClick='location = "$base/mlso_download.cgi?$fitsstr&/mlsodata.fits.tar"'>
</form>

<br>
There were $numfits fits files and $numjpegs jpg files returned for this search
<br>

END_OF_PAGE

my ($i,$f,$t);
#@files = sort(@files);
#foreach $f (@files){
#  my $l = substr($f, rindex($f,"/")+1);  #extract the filename from full path.
#  print "<a href=ftp://download.hao.ucar.edu/$f><tt>$l</tt></a><br>";
#}
$i = 0;
foreach $f (@fits){
  my $j = $jpegs[$i];
  my $l = substr($f, rindex($f,"/")+1);  #extract the filename from full path.
  my $m = substr($j, rindex($j,"/")+1);  #extract the filename from full path.
  print "<a href=ftp://download.hao.ucar.edu/$f><tt>$l</tt></a>&nbsp&nbsp&nbsp&nbsp";
  print "<a href=ftp://download.hao.ucar.edu/$j><tt>$m</tt></a><br>";
  $i++;
}

print <<DONE;
<address>
<p>Webpage written and maintained by: <br>
<a href="mailto:tdarnell\@ucar.edu">Tony Darnell</a> <br>
Last modified:  $create_str
</p>
</address>
DONE

print "</body>\n";
print "</html>\n";

#
#  Modeled after the IDL where function
#
sub where {
  my($arrayRef, $target) = @_;
  my(@array)             = @{$arrayRef};
  my($numElements)       = scalar(@array);
  my(@indexes)           = (0..$numElements);
  my(@elements);

  @elements = grep @{$arrayRef}[$_] =~ /$target/, @indexes;
  return(wantarray ? @elements : $elements[0]);
} 

sub getimgs {
  my $year = $_[0];
  my $mon = $_[1];
  my $day = $_[2];
  my $yrddoy = $_[3];
  my @files;
  my $doy = sprintf("%d",substr($yrddoy,3,3));

  chdir "$basedir/$year/@months[$mon-1]";
  $here = cwd();
  $here =~ s/\/toshi\/ftp\///; #Get rid of the /toshi/ftp part of path
  if ($inst ne "MKIV"){
    my $newqual = $quality;
    if ($quality eq "BEST"){$newqual = "ARCHIVE";}
    open(LOGFILE, "< $logpath/$yrddoy.log");
    @bestname = grep /$newqual/, <LOGFILE>;
    close(LOGFILE);
    @bestname = grep /$wavelength/,@bestname;
    foreach (@bestname){
      my (@tmp,$time);
      s/$newqual//; #Get rid of quality keyword
      s/\s+$//;	#remove whitespace

      # The filename format changed for acosfits here
      if (($inst eq "PICS") && ($year <= 2000) && ($doy < 200)){ 
	@tmp = split /_/;
	$time = substr($tmp[4],0,8);
      } else {
        @tmp = split /\./;
        $time = $tmp[1]; 
      }
      my $hr = substr($time,0,2);
      my $mn = substr($time,2,2);
      my $sc = substr($time,4,2);

      #Rebuild filename with format of those on toshi.

      $here = cwd();
      my $datestr = sprintf("%d%02d%02d.%02d%02d%02d",$year,$mon,$day,$hr,$mn,$sc);
      opendir DATA, $here;
      my @temp = grep /^$datestr(.*?)$instruments{$inst}(.*?)$wavelength(.*?)$image_type/, readdir DATA;
      closedir(DATA);
      push @files,@temp;
      $here =~ s/\/toshi\/ftp\///; #Get rid of the /toshi/ftp part of path
      foreach (@files){
      	s/^/$here\//;
      }

     #if ($inst eq "CHIP"){
#      push(@files,sprintf("$here/%d%02d%02d.%d.%s.%s.%s.gz",$year,$mon,$day,$time,$instruments{$inst},$wavelength,$image_type));
#      } else {
#      	if (@tmp[3] eq "asr"){
#      	  push(@files,sprintf("$here/%d%02d%02d.%d.%s.%s.crop.%s.gz",
#	       $year,$mon,$day,$time,$instruments{$inst},$wavelength,$image_type));
      #	} else { push(@files,"$here/$_.gz");}
      #}

    }
  } else { # Now deal with MKIV
    open(LOGFILE, "< $logpath/$yrddoy.gbu");
    @bestname = grep /$quality/, <LOGFILE>;
    close(LOGFILE);

    foreach (@bestname){
      s/(Good|BEST|CALIBRATION|Bad|Ugly)//g;
      s/\s+//;
      my $time = (split /\./)[1];
      $time =~ /(..)_(..)/;
      my $hr = $1;
      my $mn = $2;
      my $datestr = sprintf("%d%02d%02d.%02d%02d",$year,$mon,$day,$hr,$mn);
      chdir "$basedir/$year/@months[$mon-1]";
      $here = cwd();
      opendir DATA, $here;
      #@files = grep /^$datestr(.*?)$instruments{$inst}(.*?)$wavelength(.*?)$image_type/, readdir DATA;
      my @temp = grep /^$datestr(.*?)$instruments{$inst}(.*?)$wavelength(.*?)$image_type/, readdir DATA;
      closedir(DATA);
      push @files,@temp;
      #@files = @bestname;
      $here =~ s/\/toshi\/ftp\///; #Get rid of the /toshi/ftp part of path
      foreach (@files){
	s/^/$here\//;
      }
    }
  }
  #return(sort(@files));
  return(@files);
}
