package mlso;

require Exporter;
use DBI;
use Cwd;
use Date::EzDate;
@ISA = qw(Exporter);
@EXPORT = qw(PrintDataTable getimages getnumimgs);
@EXPORT_OK = qw(@files);



my $images = "http://download.hao.ucar.edu/d5/www/images";

#my $base = "http://hao.ucar.edu/internal/cgi-bin/tdarnell";
#my $base = "http://mlso.hao.ucar.edu/cgi-bin";
my $getdata_cmnd="mlso_getdata.cgi";

sub getnumimgs{
  my $type = shift;
  my %params = @_;
  my $self = {};
  $self->{Year} = $params{Year};
  $self->{Month} = $params{Month};
  $self->{Day} = $params{Day};

  my $date_str = "$self->{Year}-$self->{Month}-$self->{Day}";
  my $dbh = DBI->connect("DBI:mysql:ACOS:hao",'acos','generic');
  my $query = "select * from tbl_numfiles where NUM_ID='$date_str'";
  my $sth = $dbh->prepare($query);
  $sth ->execute();
  my ($date,$numchipint,$numchipvel,$numdisk,$numasc,$numlimb,$numcpb,$numrpb,$numvig,$nummk3c,$nummk3r,$nummk3rv) = $sth->fetchrow_array();
  $dbh->disconnect;
  
  $self->{numchipint} = $numchipint;
  $self->{numchipvel} = $numchipvel;
  $self->{numasc} = $numasc;
  $self->{numdisk} = $numdisk;
  $self->{numlimb} = $numlimb;
  $self->{numcpb} = $numcpb;
  $self->{numrpb} = $numrpb;
  $self->{numvig} = $numvig;
  $self->{nummk3c} = $nummk3c;
  $self->{nummk3r} = $nummk3r;
  $self->{nummk3rv} = $nummk3rv;

  return bless $self, $type;
}

sub getimages {
   
   my $year       = shift;
   my $mon        = shift;
   my $day        = shift;
   my $inst       = shift;
   my $wavelength = shift;
   my $image_type = shift;
   my $basedir    = "/toshi/ftp";
   my @months =("01_jan","02_feb","03_mar","04_apr","05_may",
	"06_jun","07_jul","08_aug","09_sep","10_oct","11_nov","12_dec");
   my %instruments = ('CHIP',"chp",'PICS',"dpm",'MKIV',"mk4");
   my (@files,@nextdayfiles,$here,$month);
   my $datestr	 = sprintf("%d%02d%02d",$year,$mon,$day);

   # Calculate the next calendar day.
   my $nextday = Date::EzDate->new();
   $nextday->{'month number base 1'} = $mon;
   $nextday->{'year'} = $year;
   $nextday->{'day of month'} = $day;
   $nextday->{'epochday'}++;

   my $nextdaystr = sprintf("%d%02d%02d",$nextday->{'year'},
      $nextday->{'month number base 1'},$nextday->{'day of month'});
   
   chdir "$basedir/$year/$months[$mon-1]";
   $here = cwd();
   opendir DATA, $here;
   @files = grep /^$datestr\.[12](.*?)\.$instruments{$inst}(.*?)$image_type/,
readdir DATA;
   seekdir DATA, 0;
   @nextdayfiles=grep /^$nextdaystr\.0(.*?)\.$instruments{$inst}(.*?)$image_type/,
	readdir DATA;
   push(@files,@nextdayfiles);
   closedir DATA;
   
   @files = grep /$wavelength/,@files;
   return(@files);
}

sub PrintDataTable{

my $dataset = shift;
my $year = shift;
my $mon  = shift;
my $day  = shift;
my $a = shift;
my $thedate = Date::EzDate->new();
   $thedate->{'month number base 1'} = $mon;
   $thedate->{'year'} = $year;
   $thedate->{'day of month'} = $day;

if ($dataset eq "ACOS"){

  my $mk3enddate   = 'Sep 30, 1999';
  my $mk4startdate = 'Oct 31, 1998';
  PrintTableHead($dataset, $year, $mon, $day);
  if ($thedate < $mk3enddate){
    PrintMk3Pb($a->{nummk3c});
    PrintMk3Rpb($a->{nummk3r});
    PrintMk3Vig($a->{nummk3rv});
  }
  if ($thedate > $mk4startdate){
    PrintMkivPb($a->{numcpb});
    PrintMkivRpb($a->{numrpb});
    PrintMkivVig($a->{numvig});
  }
  PrintChipInt($a->{numchipint});
  PrintChipVel($a->{numchipvel});
  PrintPicsDisk($a->{numdisk});
  PrintPicsAsc($a->{numasc});
  PrintPicsLimb($a->{numlimb});

  print ("</TABLE>\n");
  print ("</FORM>\n");

} elsif ($dataset eq "CHIP"){

  PrintTableHead($dataset, $year, $mon, $day);
  PrintChipInt($a->{numchipint});
  PrintChipVel($a->{numchipvel});
  print ("</TABLE>\n");
  print ("</FORM>\n");

} elsif ($dataset eq "MKIV"){

  PrintTableHead($dataset, $year, $mon, $day);
  PrintMkivPb($a->{numcpb});
  PrintMkivRpb($a->{numrpb});
  PrintMkivVig($a->{numvig});
  print ("</TABLE>\n");
  print ("</FORM>\n");

} elsif ($dataset eq "MKIII"){

  PrintTableHead($dataset, $year, $mon, $day);
  PrintMk3Pb($a->{nummk3c});
  PrintMk3Rpb($a->{nummk3r});
  PrintMk3Vig($a->{nummk3rv});
  print ("</TABLE>\n");
  print ("</FORM>\n");

} elsif ($dataset eq "PICS"){

  PrintTableHead($dataset, $year, $mon, $day);
  PrintPicsDisk($a->{numdisk});
  PrintPicsAsc($a->{numasc});
  PrintPicsLimb($a->{numlimb});
  print ("</TABLE>\n");
  print ("</FORM>\n");

}
}

sub PrintTableHead{

my $dataset = shift;
my $year = shift;
my $mon = shift;
my $day = shift;

print <<DONE;

<FORM name="myform" ACTION = $getdata_cmnd METHOD = "GET">
<INPUT TYPE="hidden" NAME="year" VALUE="$year">
<INPUT TYPE="hidden" NAME="mon" VALUE="$mon">
<INPUT TYPE="hidden" NAME="day" VALUE="$day">
<TABLE BORDER = "3" align = "center">
  <tr>
  <th colspan="3" class="title">Available $dataset Data Products </th>
  </tr>

DONE
}

sub PrintChipInt{
my $numimgs = shift;
print <<DONE;
  <tr>
    <tr>
      <td colspan = "3" class="acostitle">CHIP He 1083 nm Intensity</td>
    </tr>
    <tr>
      <td>
        <img src="http://download.hao.ucar.edu/d5/www/images/chip_int.jpg" 
        height=170 width=170 hspace=3 vspace=5>
      </td>
      <td>
       This is the ACOS CHIP Helium I 1083 nm intensity data <br>
       taken every three minutes at MLSO.  Provides a good <br>
       indication of large scale structure of upper chromosphere <br>
       and corona including active regions, prominences and <br> 
       filaments, coronal holes, filament channels, etc.
      </td>
      <td align="center">
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="Best CHIP Intensity image">
       <br>
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
        VALUE="All CHIP Intensity Data">
	<br>
        <INPUT CLASS="moviebutton" STYLE='width:200' TYPE="submit" NAME="search_str" 
         VALUE="Show CHIP Intensity Movie">
	<br>
       <b>$numimgs images available</b><br>
      </td>
    </tr>
  </tr>
DONE
}
sub PrintChipVel{
my $numimgs = shift;
print <<DONE;
  <tr>
    <tr>
       <td colspan = "3" class="acostitle">CHIP He 1083 nm Velocity</td>
    </tr>
    <tr>
       <td>
           <img src="http://download.hao.ucar.edu/d5/www/images/chip_vel.jpg" 
           height=170 width=170 hspace=3 vspace=5>
       </td>
       <td>
       This is ACOS CHIP Helium 1083 nm Velocity Data. <br>
       Together with CHIP Intensity Data, this dataset <br>
       provides a good view of activity in the upper <br>
       chromosphere region, particularly prominence and <br>
       filament activity and eruptions.   This data is <br>
       taken every three minutes.
       </td>
       <td align="center">
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="Best CHIP Velocity image">
       <br>
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="All CHIP Velocity data">
       <br>
        <INPUT CLASS="moviebutton" STYLE='width:200' TYPE="submit" NAME="search_str" 
         VALUE="Show CHIP Velocity Movie">
	<br>
       <b>$numimgs images available</b>
       </td>
    </tr>
  </tr>
DONE
}

sub PrintPicsDisk{
my $numimgs = shift;
print <<DONE;
  <tr>
    <tr>
      <td colspan = "3" class="acostitle">PICS H-Alpha Disk</td>
    </tr>
    <tr>
      <td>
       <img src="http://download.hao.ucar.edu/d5/www/images/pics_disk.jpg" 
       height=170 width=170 hspace=3 vspace=5>
      </td>
      <td>
	PICS H-Alpha disk data provides a good view into <br>
	prominence and filament activity and eruptions,  <br>
	as well as flare activity.  These images are taken <br>
	every three minutes and have had a limb darkening <br>
	correction applied as well as some contrast enhancement.
      </td>
      <td align="center">
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="Best PICS Disk image">
       <br>
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="All PICS Disk images">
       <br>
        <INPUT CLASS="moviebutton" STYLE='width:200' TYPE="submit" NAME="search_str" 
         VALUE="Show PICS Disk Movie">
	<br>
       <b>$numimgs images available</b>
      </td>
    </tr>
  </tr>
DONE
}

sub PrintPicsAsc{
my $numimgs = shift;
print <<DONE;
  <tr>
    <tr>
      <td colspan = "3" class="acostitle">PICS H-Alpha Disk (Dark corrected)</td>
    </tr>
    <tr>
      <td>
       <img src="http://download.hao.ucar.edu/d5/www/images/pics_asc.jpg" 
       height=170 width=170 hspace=3 vspace=5>
      </td>
      <td>
	PICS H-Alpha disk data provides a good view into <br>
	prominence and filament activity and eruptions,  <br>
	as well as flare activity.  These images are taken <br>
	every three minutes and have had minimal processing <br>
	done.  Only a dark subtraction and hot pixel cleanup <br>
	has been done on these images.<br>  
	<b>These images have not been rotated for p-angle.</b>
      </td>
      <td align="center">
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="Best PICS Corrected image">
       <br>
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="All PICS Corrected images">
       <br>
        <INPUT CLASS="moviebutton" STYLE='width:200' TYPE="submit" NAME="search_str" 
         VALUE="Show PICS Corrected Movie">
	<br>
       <b>$numimgs images available</b>
      </td>
    </tr>
  </tr>
DONE
}

sub PrintPicsLimb{
my $numimgs = shift;
print <<DONE;
   <tr>
     <tr>
       <td colspan = "3" class="acostitle">PICS H-Alpha Limb</td>
     </tr>
     <tr>
       <td>
        <img src=
	"http://download.hao.ucar.edu/d5/www/images/pics_limb.cropped.jpg" 
	height=170 width=170 hspace=3 vspace=5>
       </td>
       <td>
       PICS H-Alpha limb data provide views of solar <br>
       limb activity by occulting the solar disk.  These <br>
       data are taken every three minutes.  No processing <br>
       is done on these data.<br>
       <b>These images have not been rotated for p-angle.</b>
       </td>
       <td align="center">
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="Best PICS Limb image">
       <br>
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="All PICS Limb data">
       <br>
        <INPUT CLASS="moviebutton" STYLE='width:200' TYPE="submit" NAME="search_str" 
         VALUE="Show PICS Limb Movie">
	<br>
       <b>$numimgs images available</b>
       </td>
     </tr>
  </tr>
DONE
}

sub PrintMkivPb{
my $numimgs = shift;
print <<DONE;
  <tr>
    <tr>
       <td colspan="3" class="acostitle">
         MKIV White Light Polarization Brightness Data 
         (Polar Coordinates)
       </td>
    </tr>
    <tr>
	<td>
	  <img src="http://download.hao.ucar.edu/d5/www/images/mk4.cpb.jpg" 
	  height=170 width=170 hspace=3 vspace=5>
	</td>
        <td>
	These images are in polar coordinates and are ideal for <br>
	azimuthal and radial scans.  <b>Polarization Brightness <br>
	data are required for measuring coronal densities <br>
	and computing masses. </b>
       </td>
       <td align="center">
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="Best MKIV Polar pB image">
       <br>
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="Avg MKIV Polar pB image">
       <br>
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="All MKIV Polar pB Data">
       <br>
       <b>$numimgs images available</b>
       </td>
    </tr>
  </tr>
DONE
}

sub PrintMkivRpb{
my $numimgs = shift;
print <<DONE;
  <tr>
    <tr>
      <td colspan = "3" class="acostitle">
      MKIV White Light Polarization Brightness Data
	(Rectangular Coordinates)
      </td>
    </tr>
    <tr>
      <td>
	  <img src="http://download.hao.ucar.edu/d5/www/images/mk4.rpb.170.jpg"
	  height=170 width=170 hspace=3 vspace=5>
      </td>
      <td>
	   These images are identical to the MKIV pB data in polar <br>
	   coordinates, except for the coordinate system.  <br>
	   <b>Polarization Brightness data are required for <br>
	   measuring coronal densities and computing masses.</b><br>
           These images are in rectangular coordinates.
      </td>
      <td align="center">
       <INPUT STYLE='width:210' TYPE="submit" NAME="search_str" 
       VALUE="Best MKIV Rectangular pB image">
       <br>
       <INPUT STYLE='width:210' TYPE="submit" NAME="search_str" 
       VALUE="Avg MKIV Rectangular pB image">
       <br>
       <INPUT STYLE='width:210' TYPE="submit" NAME="search_str" 
       VALUE="All MKIV Rectangular pB Data">
       <br>
       <b>$numimgs images available</b>
      </td>
    </tr>
  </tr>
DONE
}

sub PrintMkivVig{
my $numimgs = shift;
print <<DONE;
  <tr>
    <tr>
        <td colspan = "3"class="acostitle">
 	  MKIV White Light Vignetted Data 
	  (Rectangular Coordinates)
       	</td>
    </tr>
    <tr>
        <td>
          <img src=
	    "http://download.hao.ucar.edu/d5/www/images/mk4.rpb.vig.jpg"
	    height=170 width=170 hspace=3 vspace=5>
        </td>
        <td>
	 Qualitative white light coronal images.  These images <br>
	 have had an artificial vignetting function applied which <br>
	 reduces the radial density gradient in order to enhance <br>
	 contrast. These images are in no quantitative units.   <br>
	 They are useful for <b> viewing activity and making <br>
	 position measurements. </b> The jpegs are made <br>
	 from these images.
       </td>
       <td align="center">
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="Best MKIV Vignetted image">
       <br>
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="Avg MKIV Vignetted image">
       <br>
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="All MKIV Vignetted data">
       <br>
        <INPUT CLASS="moviebutton" STYLE='width:200' TYPE="submit" NAME="search_str" 
         VALUE="Show MKIV Vignetted Movie">
	<br>
       <b>$numimgs images available</b>
       </td>
    </tr>
  </tr>
DONE
}

sub PrintMk3Pb{
my $numimgs = shift;
print <<DONE;
  <tr>
    <tr>
       <td colspan="3" class="acostitle">
         MK3 White Light Polarization Brightness Data 
         (Polar Coordinates)
       </td>
    </tr>
    <tr>
	<td>
	  <img src="http://download.hao.ucar.edu/d5/www/images/mk4.cpb.jpg" 
	  height=170 width=170 hspace=3 vspace=5>
	</td>
        <td>
	These images are in polar coordinates and are ideal for <br>
	azimuthal and radial scans.  <b>Polarization Brightness <br>
	data are required for measuring coronal densities <br>
	and computing masses. </b>
       </td>
       <td align="center">
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="Best MK3 Polar pB image">
       <br>
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="Avg MK3 Polar pB image">
       <br>
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="All MK3 Polar pB Data">
       <br>
       <b>$numimgs images available</b>
       </td>
    </tr>
  </tr>
DONE
}

sub PrintMk3Rpb{
my $numimgs = shift;
print <<DONE;
  <tr>
    <tr>
      <td colspan = "3" class="acostitle">
      MK3 White Light Polarization Brightness Data
	(Rectangular Coordinates)
      </td>
    </tr>
    <tr>
      <td>
	  <img src="http://download.hao.ucar.edu/d5/www/images/mk4.rpb.170.jpg"
	  height=170 width=170 hspace=3 vspace=5>
      </td>
      <td>
	   These images are identical to the MKIV pB data in polar <br>
	   coordinates, except for the coordinate system.  <br>
	   <b>Polarization Brightness data are required for <br>
	   measuring coronal densities and computing masses.</b><br>
           These images are in rectangular coordinates.
      </td>
      <td align="center">
       <INPUT STYLE='width:210' TYPE="submit" NAME="search_str" 
       VALUE="Best MK3 Rectangular pB image">
       <br>
       <INPUT STYLE='width:210' TYPE="submit" NAME="search_str" 
       VALUE="Avg MK3 Rectangular pB image">
       <br>
       <INPUT STYLE='width:210' TYPE="submit" NAME="search_str" 
       VALUE="All MK3 Rectangular pB Data">
       <br>
       <b>$numimgs images available</b>
      </td>
    </tr>
  </tr>
DONE
}

sub PrintMk3Vig{
my $numimgs = shift;
print <<DONE;
  <tr>
    <tr>
        <td colspan = "3"class="acostitle">
 	  MK3 White Light Vignetted Data 
	  (Rectangular Coordinates)
       	</td>
    </tr>
    <tr>
        <td>
          <img src=
	    "http://download.hao.ucar.edu/d5/www/images/mk4.rpb.vig.jpg"
	    height=170 width=170 hspace=3 vspace=5>
        </td>
        <td>
	 Qualitative white light coronal images.  These images <br>
	 have had an artificial vignetting function applied which <br>
	 reduces the radial density gradient in order to enhance <br>
	 contrast. These images are in no quantitative units.   <br>
	 They are useful for <b> viewing activity and making <br>
	 position measurements. </b> The jpegs are made <br>
	 from these images.
       </td>
       <td align="center">
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="Best MK3 Vignetted image">
       <br>
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="Avg MK3 Vignetted image">
       <br>
       <INPUT STYLE='width:200' TYPE="submit" NAME="search_str" 
       VALUE="All MK3 Vignetted data">
       <br>
        <INPUT CLASS="moviebutton" STYLE='width:200' TYPE="submit" NAME="search_str" 
         VALUE="Show MK3 Vignetted Movie">
	<br>
       <b>$numimgs images available</b>
       </td>
    </tr>
  </tr>
DONE
}

1;
