#!/opt/local/bin/perl

use strict;
use mlso_navbar;

my $images = "http://download.hao.ucar.edu/d5/www/images";
my $styles = "http://download.hao.ucar.edu/d5/www/styles";
my @filestats = stat "mlso_events.cgi";
my @gm_arr = localtime($filestats[9]);
my $create_str = sprintf("%02d/%02d/%02d %02d:%02d:%02d",
	$gm_arr[4]+1,$gm_arr[3],$gm_arr[5]-100,$gm_arr[2],$gm_arr[1],$gm_arr[0]);

print <<END_OF_PAGE;
Content-type: text/html

<HTML>
<HEAD>
<TITLE> MLSO Special Events </TITLE>
<link rel="stylesheet" type="text/css"
href="$styles/mlsohome.css" />

END_OF_PAGE

PrintJavaScript();
PrintACOSbar("mlso_banner3.sml.gif");

print <<END_OF_PAGE;
<h1 align=center>
<font color="#FF0000"> Movie Events Archive </font> </h1>
<hr>

<h2 align=center> Movies Showing Solar Rotation </h2>

Animations of the H-alpha (PICS), K-corona (Mk3/Mk4) and Helium-I (CHIP)
data have been made of the current year to date.
They are updated once weekly (Tuesdays).

<ul>
<li>  
     <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/mk3.mpg"> 
     <b> K-corona </b></a> Mk3 movie (MPEG, 400kB).
<li>  
     <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/dpm.mpg"> 
     <b> H-alpha </b></a> PICS movie (MPEG, 700kB).
<li> 
     <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/chip.mpg"> 
     <b> Helium-I </b></a> CHIP movie (MPEG, 2MB).
</ul>

<hr>

<a name="MOVIE">
<h2 align=center> Movies of Activity and Events: </h2>
</a>
For convenience, we have used several <a href="abbrev.html"> abbreviations </a>
    in the descriptions below.
<ul>
<li> <b>Typical Events Near Solar Maximum.</b>
     <br>
	<a href="#89d003"> 89d003,</a>
	<a href="#89d082"> 89d082,</a>
	<a href="#89d229"> 89d229,</a>
	<a href="#90d093"> 90d093,</a>
	<a href="#90d134"> 90d134,</a>
	<a href="#90d167"> 90d167,</a>
	<a href="#90d196"> 90d196,</a>
	<a href="#90d298"> 90d298,</a>
	<br><br>

<li> <b>Typical Events Near Solar Minimum.</b>
        <br>
	<a href="#86d288"> 86d288,</a>
	<a href="#96d126"> 96d126,</a>
	<br><br>

<li> <b>Events by date :</b> <br>

    <br> <b>1980</b> <br>
	<a href="#80d046">    15feb  </a> <br>
	<a href="#80d122">     1may  </a> <br>
	<a href="#80d155">     3jun  </a> <br>
	<a href="#80d218">     5aug  </a>
	<a href="#80d221">     8aug  </a>
	<a href="#80d235">    23aug  </a> <br>
	<a href="#80d245">     1sep  </a>
	<a href="#80d271">    27sep  </a> <br>

    <br> <b>1981</b> <br>
	<a href="#81d024">    24jan  </a> <br>
	<a href="#81d076">    17mar  </a>	
	<a href="#81d084">    25mar  </a> <br>
	<a href="#81d097">     7apr  </a>	
	<a href="#81d114">    24apr  </a> <br>
	<a href="#81d131">    11may  </a> <br>
	<a href="#81d241">    29aug  </a> <br>
	<a href="#81d286">    13oct  </a> <br>
	<a href="#81d322">    18nov  </a> <br>
	<a href="#81d349">    12dec  </a> <br>

    <br> <b>1984</b> <br>
	<a href="#84d079">    19mar </a> <br>

    <br> <b>1986</b> <br>
	<a href="#86d288">    15oct </a> <br>

    <br> <b>1988</b> <br>
	<a href="#88d063">     3mar </a> <br>

     <br> <b>1989</b> <br>
	<a href="#89d003">     3jan  </a>
	<a href="#89d018">    18jan  </a> <br>
	<a href="#89d057">    26feb  </a> <br>
	<a href="#89d076">    17mar  </a>
	<a href="#89d082">    23mar  </a>
	<a href="#89d085">    26mar  </a> <br>
	<a href="#89d100">    10apr  </a> <br>
	<a href="#89d208">    27jul  </a>
	<a href="#89d210">    29jul  </a>
	<a href="#89d212">    31jul  </a> <br>
	<a href="#89d218">     6aug  </a>
	<a href="#89d229">    17aug  </a>
	<a href="#89d230">    18aug  </a>
	<a href="#89d243">    31aug  </a> <br>
	<a href="#89d252">     9sep  </a>
	<a href="#89d261">    18sep  </a> <br>
	<a href="#89d278">     5oct  </a>
	<a href="#89d293">    20oct  </a>
	<a href="#89d295">    22oct  </a> <br>
	<a href="#89d311">     7nov  </a> <br>
	<a href="#89d344">    10dec  </a>
	<a href="#89d345">    11dec  </a> <br>

     <br> <b>1990</b> <br>
	<a href="#90d029">    29jan  </a> <br>
	<a href="#90d093">     3apr  </a> <br>
	<a href="#90d128">     8may  </a>
	<a href="#90d134">    13may  </a>
	<a href="#90d148">    27may  </a>
	<a href="#90d152">    31may  </a> <br>
	<a href="#90d167">    15jun  </a> <br>
	<a href="#90d186">     5jul  </a>
	<a href="#90d196">    15jul  </a> <br>
	<a href="#90d233">    21aug  </a> <br>
	<a href="#90d256">    12sep  </a> <br>
	<a href="#90d279">     6oct  </a>
	<a href="#90d293">    20oct  </a>
	<a href="#90d298">    25oct  </a> <br>

     <br> <b>1991</b> <br>
	<a href="#91d038">     7feb  </a>
	<a href="#91d058">    27feb  </a> <br>
	<a href="#91d063">     4mar  </a>
	<a href="#91d064">     5mar  </a> <br>
	<a href="#91d145">    25may  </a>
	<a href="#91d150">    30may  </a> <br>

     <br> <b>1992</b> <br>
	<a href="#92d108">    17apr  </a> <br>

     <br> <b>1993</b> <br>
	<a href="#93d071">    12mar  </a> <br>

     <br> <b>1995</b> <br>
	<a href="#95d023">    23jan  </a> <br>
	<a href="#95d230">    18aug  </a> <br>
	<a href="#95d247">     4sep  </a> <br>
	<a href="#95d290">    17oct  </a> <br>
	<a href="#95d323">    19nov  </a> <br>

     <br> <b>1996</b> <br>
	<a href="#96d047">    16feb  </a> <br>
	<a href="#96d126">     5may  </a> <br>
	<a href="#96d158">     6jun  </a> <br>
	<a href="#96d261">    18sep  </a>
	<a href="#96d269">    25sep  </a> <br>
	<a href="#96d276">     2oct  </a>
	<a href="#96d293">    19oct  </a> <br>

     <br> <b>1997</b> <br>
	<a href="#97d031">    31jan  </a>
	<a href="#97d156">     4jun  </a> <br>
	<a href="#97d160">     9jun  </a>
	<a href="#97d167">    16jun  </a> <br>
	<a href="#97d206">    25jul  </a> <br>
	<a href="#97d252">     9sep  </a>
	<a href="#97d262">    19sep  </a>
	<a href="#97d272">    29sep  </a> <br>
	<a href="#97d276">     3oct  </a>
	<a href="#97d296">    23oct  </a> <br>
	<a href="#97d328">    24nov  </a> <br>
 	<a href="#97d335">     1dec  </a>	
	<a href="#97d352">    18dec  </a>	
	<a href="#97d362">    28dec  </a>	
 	<a href="#97d363">    29dec  </a> <br>

     <br> <b>1998</b> <br>
 	<a href="#98d010">    10jan  </a>	
	<a href="#98d027">    27jan  </a> <br>
	<a href="#98d053">    22feb  </a>	
	<a href="#98d055">    24feb  </a> <br>
	<a href="#98d060">     1mar  </a>	
	<a href="#98d064">     5mar  </a>	
	<a href="#98d067">     8mar  </a>	
  	<a href="#98d072">    13mar  </a>	
	<a href="#98d076">    17mar  </a>	
	<a href="#98d086">    27mar  </a> <br>
	<a href="#98d094">     4apr  </a> 	
 	<a href="#98d105">    15apr  </a>	
 	<a href="#98d111">    21apr  </a> <br>
 	<a href="#98d166">    15jun  </a>	
 	<a href="#98d167">    16jun  </a> <br>
 	<a href="#98d187">     6jul  </a>	
 	<a href="#98d192">    11jul  </a>	
 	<a href="#98d199">    18jul  </a> <br>
 	<a href="#98d217">     5aug  </a>	
 	<a href="#98d227">    15aug  </a>	
 	<a href="#98d228">    16aug  </a>	
 	<a href="#98d229">    17aug  </a>	
 	<a href="#98d231">    19aug  </a>	
 	<a href="#98d236">    24aug  </a>	
 	<a href="#98d242">    30aug  </a> <br>
 	<a href="#98d280">     7oct  </a>	
 	<a href="#98d282">     9oct  </a> <br>
 	<a href="#98d352">    18dec  </a>	
 	<a href="#98d353">    19dec  </a> <br>

     <br> <b>1999</b><br>
 	<a href="#99d020">    20jan    </a> <br>
 	<a href="#99d036">     5feb    </a> <br>
 	<a href="#99d103">    13apr    </a> <br>
 	<a href="#99d129">     9may    </a> <br>
 	<a href="#99d168">    17jun    </a> <br>
 	<a href="#99d299">    26oct    </a> <br>
 	<a href="#99d323">    19nov    </a> <br>
</ul>

<hr>
<h3>Events by date:</h3>
<ul>

<hr>

<li>
<a name="80d046"> <b>80d046</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME80d046.gif"> CME</a>
    from <b>February 15, 1980, </b> (2MB, Merged-GIF).
    YEAH!!!  The first CME event for the MKIII instrument.  The CME is very
    slow, but can be seen moving away from the sun at position angle 210 
    degrees.  There is quite a bit of prominence material leading the CME from
    the sun rather than the classical advancing loop.  The event takes place
    from 19:46-21:37 UT.  Notice how the Coronal Mass Ejection gets larger as
    it moves farther away from the sun.

<li>
<a name="80d122"> <b>80d122</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME80d122.gif"> CME</a>
    from <b>May 1, 1980, </b> (707kB, Merged-GIF).
    A HUGE CME centered at position angle 100 degrees can be seen blasting
    off from the sun.  There is an abundance of prominence material between
    80-100 degrees.  The event takes place from 19:18-19:43 UT.

<li>
<a name="80d155"> <b>80d155</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME80d155.gif"> CME</a>
    from <b>June 3, 1980, </b> (979kB, Merged-GIF).
    Don't mind the bugs while admiring this CME at position angle 95 degrees.
    Notice the classical advancing loop and the embedded prominence material
    following the loop.  This spectacular event takes place from 21:36-22:09 UT.

<li>
<a name="80d218"> <b>80d218</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME80d218.gif"> CME</a>
    from <b>August 5, 1980, </b> (260kB, Merged-GIF).
    A beautiful CME can be seen moving away from the East limb at position 
    angle 70 degrees.  In the beginning it looks like a comma (,), but this
    quickly dissipates as the large amount of prominence material moves
    farther away from the limb.  The entire event takes place from 
    18:43-20:32 UT.

<li>
<a name="80d221"> <b>80d221</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME80d221.gif"> CME</a>
    from <b>August 8, 1980, </b> (106kB, Merged-GIF).
    A CME at position angle 120 degrees is moving away from the sun from
    20:00-20:34 UT.

<li>
<a name="80d235"> <b>80d235</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME80d235.gif"> CME</a>
    from <b>August 23, 1980, </b> (257kB, Merged-GIF).
    A CME is in progress at the beginning of the observing period at position
    angle 275 degrees.  There is an abundance of prominence material 
    ejecting out from the sun, and it can still be seen in the field of view
    when the event is cut short.  The event seen takes place from 
    17:45-18:04 UT.

<li>
<a name="80d245"> <b>80d245</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME80d245.gif"> CME</a>
    from <b>September 1, 1980, </b> (694kB, Merged-GIF).
    A faint CME can be seen at position angle 80 degrees.  The event occurs
    from 17:54-18:20 UT.


<li>
<a name="80d271"> <b>80d271</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME80d271.gif"> CME</a>
    from <b>September 27, 1980, </b> (954kB, Merged-GIF).
    A rather strange shaped CME at position angle 270 degrees.  It is in
    progress at the beginning of the observation period, 17:23-18:09 UT.
    There is prominence material following the advancing loop.

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li>
<a name="81d024"> <b>81d024</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME81d024.gif"> CME</a>
    from <b>January 24, 1981, </b> (755kB, Merged-GIF).
    A faint CME with some visible prominence material is positioned at
    85 degrees.  The event takes place from 22:56-23:23 UT.

<li>
<a name="81d076"> <b>81d076</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME81d076.gif"> CME</a>
    from <b>March 17, 1981, </b> (467kB, Merged-GIF).
    A faint CME with little prominence material is at position angle 60
    degrees.  The event occurs from 19:57-20:23 UT.

<li>
<a name="81d084"> <b>81d084</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME81d084.gif"> CME</a>
    from <b>March 25, 1981, </b> (119kB, Merged-GIF).
    A huge and bright CME explodes away from the sun at position angle 280
    degrees.  There is a huge amount of prominence material following
    the classic advancing loop.  The event takes place over 20:43-21:38 UT.

<li>
<a name="81d097"> <b>81d097</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME81d097.gif"> CME</a>
    from <b>April 7, 1981, </b> (1.1MB, Merged-GIF).
    A large CME can be seen at position angle 60 degrees.  There is a classic
    advancing loop.  The entire event takes place from 18:40-19:33 UT.

<li>
<a name="81d114"> <b>81d114</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME81d114.gif"> CME</a>
    from <b>April 24, 1981, </b> (1.8MB, Merged-GIF).
    A classic double loop CME can be seen exploding away from the sun between
    position angles 60-90 degrees.  The larger of the the two loops is the
    advancing wave front.  The inner loop is actually the prominence loop
    ejecting out.  The entire event takes place from 21:40-22:46 UT.

<li>
<a name="81d131"> <b>81d131</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME81d131.gif"> CME</a>
    from <b>May 11, 1981, </b> (925kB, Merged-GIF).
    A CME at position angle 60 degrees can be seen from 18:28-19:34 UT.

<li>
<a name="81d241"> <b>81d241</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME81d241.gif"> CME</a>
    from <b>August 29, 1981, </b> (762kB, Merged-GIF).
    A large CME from position angle 90-130 degrees can be seen exploding
    away from the sun between 19:38-20:36 UT.  There is an abundance of
    prominence material following the advancing loop.

<li>
<a name="81d286"> <b>81d286</b> </a><br>
    A <A HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME81d286.gif"> CME</a>
    from <b>October 13 1981, </b> (377kB, Merged-GIF).
    A large CME at position angle 90 degrees can be seen moving away from
    the sun between 18:13-18:41 UT.  

<li>
<a name="81d322"> <b>81d322</b> </a><br>
    A <A HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME81d322.gif"> CME</a>
    from <b>November 18, 1981, </b> (1.5MB, Merged-GIF).
    A huge CME at position angle 260 degrees can be seen blasting out from
    the sun.  There is a large advancing loop followed by an enormous
    amount of embedded prominence material.  This material seems to enlarge
    as it advances out and into the cavity of the CME.  The event takes 
    place from 20:15-21:58 UT.

<li>
<a name="81d349"> <b>81d349</b> </a><br>
    A <A HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME81d349.gif"> CME</a>
    from <b>December 12, 1981, </b> (719kB, Merged-GIF).
    A beautiful CME at position angle 280 explodes away from the sun
    from 19:46-20:41 UT.  The southern region of the CME contains an
    abundance of prominence material.

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li>
<a name="84d079"> <b>84d079</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME84d079.mpg"> 
    double CME</a>, 
    a double CME from <b>March 19, 1984 </b>, (429kB, mpeg).  The
    first CME consists of two loops.  It occurs at position angle 25-50 from
    19:09 to 20:18 UT.  The second CME is a blob of matter.  It occurs at
    position angle 95-110 from 19:53 to 21:36 UT.

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li>
<a name="86d288"> <b>86d288</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME86d288.gif"> 
    double-loop CME</a>, a double-loop 
    CME from <b>October 15, 1986 </b>, (558kB, Merged-GIF).
    This magnificent event occurs at position angle 270-325 from 
    20:34 - 21:21 UT.

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li>
<a name="88d063"> <b>88d063</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME88d063.mpg"> 
    polar CME</a>, a CME over the south pole from
   <b>March 3, 1988 </b>, (153kB, mpeg).  This appears from
   21:30 - 22:39 UT at position angle 160-190.

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li>
<a name="89d003"> <b>89d003</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d003.mpg"> CME</a>
    from <b>January 3, 1989 </b>, (88kB, mpeg).
    Welcome to Solar Maximum!  A large CME can be seen moving away from
    the sun at position angle 130 degrees.  It takes place from
    18:04-18:39 UT.  

<li>
<a name="89d018"> <b>89d018</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d018.mpg"> CME</a>
    from <b>January 18, 1989 </b>, (157kB, mpeg).
    A huge CME can be seen between position angles 290 degrees
    and the north pole.  It occurs from 18:20-19:11 UT. It
    looks like there may be two CME's, but in actuality there
    is only one.  A small loop can be seen moving away from
    the limb around 18:59 UT, but it is merely prominence material
    being pulled (so to speak) away with the force of the CME.

<li>
<a name="89d057"> <b>89d057</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d057.mpg"> CME</a>
    from <b>February 26, 1989 </b>, (174kB, mpeg).
    A CME can be seen moving away from the sun near position
    angle 20 degrees.  It occurs from 18:38-19:45 UT.

<li>
<a name="89d076"> <b>89d076</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d076.mpg"> CME</a>
    from <b>March 17, 1989 </b>, (128kB, mpeg).
    This bright CME can be seen between 17:33-18:21 UT. It occurs
    at position angle 300 degrees.

<li>
<a name="89d082"> <b>89d082</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d082.mpg"> CME</a>
    from <b>March 23, 1989 </b>, (124kB, mpeg).
    Short but sweet!  This CME can be seen at position angle 330
    degrees.  The classical advancing loop can be seen moving away
    from the sun at 19:27-20:13 UT.

<li>
<a name="89d085"> <b>89d085</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d085.mpg"> CME</a>
    from <b>March 26, 1989 </b>, (353kB, mpeg).
    A CME with a fair amount of prominence material can be seen
    exploding off the sun at position angle 40 degrees.  It occurs
    between 17:58-20:38 UT.

<li>
<a name="89d100"> <b>89d100</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d100.mpg"> CME</a>
    from <b>April 10, 1989 </b>, (184kB, mpeg).
    A large CME can be seen exploding off the sun between 0-10 degrees.
    The event is quite bright and occurs from 18:37-20:19 UT.

<li>
<a name="89d208"> <b>89d208</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d208.gif"> CME</a>
    from <b>July 27, 1989 </b>, (520kB, Merged-GIF).
    What an incredible sight!!  The huge advancing loop can be seen from
    17:41-18:22.  It is quite large and occurs between 270-200 degrees.

<li>
<a name="89d210"> <b>89d210</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d210.gif"> CME</a>
    from <b>July 29, 1989 </b>, (587kB, Merged-GIF).
    This faint, but large CME can be seen moving away from the
    sun between Position Angles 100-160 degrees.  The advancing
    loop can be seen throughout the field of view from 16:59-17:43 UT.

<li>
<a name="89d212"> <b>89d212</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d212.gif"> CME</a>
    Experience <b>The Trilogy</b> from <b>July 31, 1989 </b>,
    (1MB, Merged-GIF).
    There are 3 CME's that can be seen.  The 1st occurs at position angle 100
    degrees from 18:00-18:18 UT.  It is very faint, and may be mistaken as a
    wave front leading the second CME.  This is a very large CME between PA:
    100-110 degrees.  There is an abundance of prominence material embedded
    just behind the advancing loop.  It's rather spectacular.  This event occurs
    from 18:27-19:05 UT.  The 3rd CME appears at 20:01-20:53 UT before leaving
    the field of view.  Although very faint, this CME can be seen at PA:  110
    degrees.

<li>
<a name="89d218"> <b>89d218</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d218.gif"> CME</a>
    from <b>August 6, 1989 </b>, (1MB, Merged-GIF).
    A rather large CME can be seen moving away from the sun at position angle
    100 degrees.  There is prominence material embedded on the southern edge
    of the CME.  The material remains in the field of view longer than the
    advancing loop of the CME making the entire event last from 17:36-19:00 UT.

<li>
<a name="89d229"> <b>89d229</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d229.gif"> CME</a>
    from <b>August 17, 1989 </b>, (536kB, Merged-GIF).
    A beautiful CME can seen coming off the sun at position angle 260 degrees.
    The advancing loop, along with enormous amount of embedded prominence
    material can be viewed from 18:32-19:16 UT.

<li>
<a name="89d230"> <b>89d230</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d230.gif"> CME</a>
    from <b>August 18, 1989 </b>, (882kB, Merged-GIF).
    A CME can be seen at position angle 270 degrees.  It occurs from 
    17:36-18:47 UT. before disappearing out of the field of view.

<li>
<a name="89d243"> <b>89d243</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d243.gif"> CME</a>
    from <b>August 31, 1989 </b>, (971kB, Merged-GIF).
    A beautiful CME can be seen at position angle 110 degrees. It
    occurs from 17:05-19:42 UT.

<li>
<a name="89d252"> <b>89d252</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d252.gif"> CME</a>
    on <b>September 9, 1989 </b>, (819kB, Merged-GIF).
    A CME can be viewed at position angle 260 degrees.  Its rather
    large and occurs from 19:28-20:30 UT before leaving the field
    of view.

<li>
<a name="89d261"> <b>89d261</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d261.gif"> CME</a>
    on <b>September 18, 1989 </b>, (522kB, Merged-GIF).
    At position angle 280 degrees the classic CME with what looks to
    be 2 advancing loops can be seen leaving the sun. There is in fact 1 CME
    that occurs between 20:59-21:36 UT.  The observing was cut short, hence 
    the CME is still in the field of view at 21:36 UT.

<li>
<a name="89d278"> <b>89d278</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d278.gif"> CME</a>
    on <b>October 5, 1989 </b>, (769kB, Merged-GIF).
    It's rather beautiful at position angle 290 degrees.  There is a huge
    amount of prominence material embedded just behind the advancing loop.
    The event occurs from 17:14-18:10 UT.  Remnants of the CME can still
    be seen in the field of view at 18:10 UT.

<li>
<a name="89d293"> <b>89d293</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d293.gif"> CME</a>
    on <b>October 20, 1989 </b>, (683kB, Merged-GIF).
    It is a nice classical CME with an advancing loop at position angle 270
    degrees.  There is some prominence material, though not much.  The event
    takes place during 20:27-21:45 UT.

<li>
<a name="89d295"> <b>89d295</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d295.gif"> CME</a>
    on <b>October 22, 1989 </b>, (899kB, Merged-GIF).
    WOW!! Centered around 250 degrees, this CME extends from 180 degrees to
    290 degrees.  It is absolutely huge.  Prominence material can be seen
    exploding away from the sun just behind the advancing loop.  The event
    occurs between 17:33-18:45 UT.

<li>
<a name="89d311"> <b>89d311</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d311.gif"> CME</a>
    on <b>November 7, 1989 </b>, (606kB, Merged-GIF).
    At position angle 60 degrees.  The event takes place from 20:37-21:34 UT.
    There is a stream of prominence material following the advancing loop
    above 60 degrees.  It looks like smoke rising up and out of the field of
    view.

<li>
<a name="89d344"> <b>89d344</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d344.gif"> CME</a>
    on <b>December 10, 1989 </b>, (1MB, Merged-GIF).
    At position angle 160 degrees, this CME is slow moving though brilliant
    none-the-less.  The CME looks as if it is made up of a huge "clump" of
    prominence material.  The event takes place from 17:44-19:45 UT. 

<li>
<a name="89d345"> <b>89d345</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME89d345.gif"> CME</a>
    on <b>December 11, 1989 </b>, (640kB, Merged-GIF).
    Beginning at 18:22-19:23 UT this CME can be seen at position angle 80
    degrees.  Prominence material can be seen just beyond the advancing loop
    starting at 18:54 UT.

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li>
<a name="90d029"> <b>90d029</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME90d029.gif"> CME</a>
    from <b>January 29, 1990 </b>, (335kB, Merged-GIF).
    It is located at Position Angle 260 degrees 
    from 20:11 - 20:39 UT.

<li>
<a name="90d093"> <b>90d093</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME90d093.gif"> CME</a>
    from <b>April 3, 1990 </b>, (559kB, Merged-GIF).
    It appears that there are 2 magnetic loops that meet at
    the limb around 60 degrees.  There is in fact only 1
    huge CME that extends from Position Angle 30 degrees -
    110 degrees.  It occurs from 17:23 - 18:04 UT.

<li>
<a name="90d128"> <b>90d128</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME90d128.gif"> CME</a>
    from <b>May 8, 1990 </b>, (990kB, Merged-GIF).
    There are 2 CME's present.  The first occurs at Position Angle
    280 degrees from 18:43 - 19:31 UT.  The second occurs at 
    Position Angle 200 degrees from 18:43 - 20:36 UT.  It is very
    faint against the dark background.  It can be seen best 
    starting at 19:31 UT. 

<li>
<a name="90d134"> <b>90d134</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME90d134.mpg"> CME</a>
    from <b>May 13, 1990 </b>, (79kB, mpeg).
    Today's CME occurs at Position Angle 130 degrees from
    18:29 - 19:57 UT.  There appears to be an abundance of
    prominence material embedded in the CME following the
    advancing loop.  Interestingly, the prominence material
    appears to approximately maintain its structure as it moves through
    the field of view.

<li>
<a name="90d148"> <b>90d148</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME90d148.gif"> CME</a>
    from <b>May 27, 1990 </b>, (316kB, Merged-GIF).
    This CME occurs at Position Angle 320 degrees from
    17:45 - 18:06 UT.

<li>
<a name="90d152"> <b>90d152</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME90d152.mpg"> CME</a>
    from <b>May 31, 1990 </b>, (251kB, mpeg).
    A narrow Coronal Mass Ejection can be seen at Position Angle
    345 degrees. The familiar loop of an advancing CME doesn't 
    appear to be leading this CME from the sun, instead it looks  
    like a stream of smoke rising up and out of the field of view.  
    The CME occurs from 18:43 - 20:06 UT.

<li>
<a name="90d167"> <b>90d167</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME90d167.gif"> CME</a>
    from <b>June 15, 1990 </b>, (1MB, Merged-GIF).
    The Coronal Mass Ejection occurs between Position Angles 0 degrees
    and 20 degrees.  There is an abundance of prominence material
    embedded in the CME following the advancing loop.  The show takes
    place between 18:00 - 19:28 UT.

<li>
<a name="90d186"> <b>90d186</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME90d186.gif"> CME</a>
    from <b>July 5, 1990 </b>, (296kB, Merged-GIF).
    The faint CME can be seen between the North Pole and 5 degrees.
    It occurs from 18:42 - 19:57 UT.

<li>
<a name="90d196"> <b>90d196</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME90d196.gif"> CME</a>
    from <b>July 15, 1990 </b>, (153kB, Merged-GIF).
    A big CME can be seen exploding off the sun near Position Angle
    350 degrees.  It occurs during the time of 18:49-19:32 UT.

<li>
<a name="90d233"> <b>90d233</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME90d233.gif"> CME</a>
    from <b>August 21, 1990 </b>, (850kB, Merged-GIF).
    One large CME can be seen from Position Angle 280-310 degrees
    between 17:21-18:24 UT.  At approximately 18:12 UT embedded
    prominence material is visible near Position Angle 280 degrees.  
    Upon reviewing the H-alpha data, it is likely that this is
    an arch prominence which erupts (EPL).

<li>
<a name="90d256"> <b>90d256</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME90d256.mpg"> CME</a>
    from <b>September 12, 1990 </b>, (94kB, mpeg).
    A CME can be seen erupting at Position Angle 160 degrees. The
    classic advancing loop can be seen moving away from the sun
    at 17:50-18:16 UT.

<li>
<a name="90d279"> <b>90d279</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME90d279.gif"> CME</a>
    from <b>October 6, 1990 </b>, (502kB, Merged-GIF).
    POOF!  A CME can be seen moving away from the sun between
    270-315 degrees.  It looks like a puff of smoke, but in this
    case it is a huge puff of ionized particles.  
    It occurs from 18:58-19:45 UT.

<li>
    <a name="90d293"> <b>90d293</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME90d293.gif"> CME</a>
    from <b>October 20, 1990 </b>, (182kB, Merged-GIF).
    It's a bird! It's a plane! NO, it's a CME exploding away
    from the sun faster than a speeding bullet (~200km/sec), and way more
    powerful than a locomotive (2*10^8 kg).  This sight can be seen at
    300 degrees between 18:01-18:41 UT.  Don't miss it!

<li>
<a name="90d298"> <b>90d298</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME90d298.gif"> CME</a> 
    from <b>October 25, 1990 </b>, (555kB, Merged-GIF).
    A huge CME can be seen leaving the sun between 17:20-18:05 UT.
    There is an abundance of prominence material exploding outward
    at position angle 300 degrees.  The main advancement of the CME
    occurs is the same area, though the edges extend from 270-350 degrees.

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li>
<a name="91d038"> <b>91d038</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME91d038.gif"> CME</a>
    from <b>February 7, 1991 </b>, (297kB, Merged-GIF).
    It is located at Position Angle 260 from 21:28 - 21:54 UT.

<li>
<a name="91d058"> <b>91d058</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME91d058.mpg"> CME</a>
    from <b>February 27, 1991 </b>, (224kB, mpeg).
    It is located at Position Angle 320 from 18:47 - 20:39 UT.

<li>
<a name="91d063"> <b>91d063</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME91d063.mpg"> CME</a>
    from <b>March 4, 1991 </b>, (94kB, mpeg).
    It is located at Position Angle 45-90 from 19:15 - 19:47 UT.

<li>
<a name="91d064"> <b>91d064</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME91d064.mpg"> CME</a>
    from <b>March 5, 1991 </b>, (124kB, mpeg).
    It is located at Position Angle 80 from 17:35 - 18:42 UT.

<li>
<a name="91d145"> <b>91d145</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME91d145.mpg"> CME</a>
    from <b>May 25, 1991 </b>, (235kB, mpeg).
    The first CME appears at Position Angle 280, from 17:16 - 17:55 UT.
    A second CME is visible over the north pole between Position
    Angles 280 in the northwest and 10 in the northeast, from 
    18:04 - 18:46 UT.


<li>
<a name="91d150"> <b>91d150</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME91d150.mpg"> CME</a>
    from <b>May 30, 1991 </b>, (139kB, mpeg).
    The CME appears at Position Angle 80 - 120 degrees.  It occurs
    from 19:41 - 20:16 UT.

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li>
<a name="92d108"> <b>92d108</b> </a><br>
    <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME92d108.mpg"> 
    Two CME's</a>, (176kB, mpeg), 
    from <b>April 17, 1992</b>.
    The first appears to be an erupting prominence which occurs at position 
    angle 65 from 19:00 - 19:32 UT.  The second appears to be an exploding 
    loop at position angle 110 from 20:18 - 20:31 UT.  These were discovered
    by Duc Chu.

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li>
<a name="93d071"> <b>93d071</b> </a><br>
    Vodka, <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME93d071.mpg"> 
    a double-loop CME</a>, (44kB, mpeg)
    from <b>March 12, 1993</b>.  
    The CME has two loops:  one at a position angle 
    of 250 - 320 degrees, the
    other at a position angle of 280 - 305 degrees.  The CME occurs from
    17:47 - 18:06 UT.
    Often, CME's are named by their discover.  This one is named 
    after Cathy's dog.

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li> 
<a name="95d023"> <b>95d023</b> </a><br>
    A huge <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP95d023.mpg">
    prominence eruption</a> in H-alpha
    which occurred on <b>January 23, 1995 </b>,
    (123kB, mpeg), from the time 17:43-19:35 UT.  The event 
    begins before our
    observing day started.  It is centered near the Position Angle (PA) 75,
    measured counter-clockwise from the North.  This region has been
    modified slightly to enhance contrast.

<li>
<a name="95d230"> <b>95d230</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME95d230.mpg">
    loop/cavity CME</a>,
    from <b>August 18, 1995 </b>, (117kB, mpeg).  This
    CME consists of a loop and cavity and has a bright central spot which
    moves out, but then falls back to the sun.  This CME occurs at 17:13 - 
    17:55 UT at a position angle (measured counter-clockwise from the north)
    of 60-95 degrees.  
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP95d230.mpg"> 
    eruptive prominence</a>,
    (128kB, mpeg) was simultaneously observed in H-alpha.
    Note that the dpm CCD saturated at the beginning of this event, and there
    may be an instrumental reflection to the north of the true event.
    Also note that post flare loops appear in the last image at 193004 UT.

<li>
<a name="95d247"> <b>95d247</b> </a><br>
    An EP in <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP95d247.mpg">
    H-alpha</a>, from <b>September 4, 1995 </b>, (170kB, mpeg)
    showing a loop structure.

<li>
<a name="95d290"> <b>95d290</b> </a><br>
    An EP in <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP95d290.mpg"> 
    H-alpha</a>, from <b>October 17, 1995 </b>, (41kB, mpeg).

<li>
<a name="95d323"> <b>95d323</b> </a><br>
    An AP in <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/EPL95d323.mpg">
    H-alpha</a>, from <b>November 19, 1995 </b>, (303kB, mpeg).

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li>
<a name="96d047"> <b>96d047</b> </a><br>
    An AP in <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP96d047.mpg">
    H-alpha</a> from <b>February 16, 1996 </b>, (89kB, mpeg).

<li>
<a name="96d126"> <b>96d126</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME96d126.gif"> CME</a>
    on <b>May 5, 1996, </b> (823kB, Merged-GIF).
    A brilliant CME is seen leaving the sun between position angles 90-120 
    degrees. Near position angle 120 degrees prominence material can be
    seen embedded in the CME.  The event takes place from 18:30-19:45 UT.  It 
    will be known as the flower CME due to its tulip shape beginning around
    19:22 UT.

<li>
<a name="96d158"> <b>96d158</b> </a><br>
    An EP in <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP96d158.mpg">
    H-alpha</a> from <b>June 6, 1996 </b>, (347kB, mpeg)   
    and in the <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CHIP96d158.gif">     Helium-I line</a>, (556kB, Merged-GIF).
    The prominence is also seen in the MK3 coronal data.  
    <a href="http://download.hao.ucar.edu/d5/mk3/daily_images/1996/06_jun/96d158.21_37.ch0.rpB.slit.gif">
    <b> Image at 21:37UT</b></a>

<li>
<a name="96d261"> <b>96d261</b> </a><br>
    An AP in <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP96d261.mpg"> 
    H-alpha</a> from <b>September 18, 1996, </b> (305kB, mpeg).
    <b>Note, it was very windy on this day, and hence there are many
    double exposures and blurry images. </b>

<li>
<a name="96d269"> <b>96d269</b> </a><br>
    A <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CHIP96d269.gif">              disappearing filament</a>,
    in the Helium-I line
    from <b>September 25, 1996 </b>, (1.3M, Merged-GIF).

<li>
<a name="96d276"> <b>96d276 277 278</b> </a><br>
    The evolution of prominence as seen in Helium-I over three days from
    <ul>
    <li>
    <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CHIP96d276.gif">October 2,       1996 </a>, (585kB, Merged-GIF),
    <li>
    <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CHIP96d277.gif">October 3,      1996 </a>, (386kB, Merged-GIF),
    <li>
    <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CHIP96d278.gif">October 4,       1996 </a>, (608kB, Merged-GIF).
    </ul>
    <b>NOTE:</b> Pay special attention to October 4, 1996, 
    as you can see prominence material flowing along magnetic field lines to 
    the southern polar region.

<li>
<a name="96d293"> <b>96d293</b> </a><br>
    From <b> October 19, 1996, </b>
    an <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CHIP96d293.gif">EP</a>       (420kB, Merged-GIF)
    in Helium-I line.
    The same in <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP96d293.mpg">
    H-alpha</a> (98kB, mpeg), 
    and the associated 
    <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME96d293.mpg"> CME</a>
    (95kB, mpeg).
    <b>The coronal data is marred by clouds during this event.</b>

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li>
<a name="97d031"> <b>97d031</b> </a><br>
    From <b> January 31, 1997, </b>
    an AP in <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CHIP97d031.gif">
    Helium-I</a> (597kB, Merged-GIF).
    The same prominence in 
    <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP97d031.mpg">
    H-alpha</a> (424kB, mpeg), and the associated
    <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME97d031.mpg"> 
    coronal activity </a> (280kB, mpeg).
    There are two different "exposures" in this last movie loop, 
    one emphasizing the outer corona, the other the inner.
    <b>The coronal data is marred by insects during this event.</b>

<li>
<a name="97d156"> <b>97d156</b> </a><br>
    From <b> June 5, 1997, </b> 
    an <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP97d156.mpg">EP</a>
    (87kB, mpeg) in H-alpha.
    <br>
    And an <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CHIP97d156.gif">
    AF</a> (688kB, Merged-GIF) in Helium-I,
    at approx. 20 degrees west/35 degrees south on the sun's disk,
    creating a spider-like formation.
    (See this 
    <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CHIP97d156.171527.gif">
    full disk</a> image for reference.)  This continued on 
    <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CHIP97d157.gif">
    <b> June 6, 1997, </b> </a> (708kB, Merged-GIF).
    The filament now appears less organized,
    and material moves from the center to either leg of the spider.

<li>
<a name="97d160"> <b>97d160</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME97d160.gif"> CME</a>
    from <b> June 9, 1997, </b> (900kB, Merged-GIF).
    A faint CME can be seen exploding off the sun at position angle
    300 degrees.  It can be seen between 19:53-20:01 UT.  A 
    classical CME usually has a visible advancing loop.  This CME is
    peculiar in that it looks as if it is coming off sideways.  That
    is, it looks like a side view of an advancing loop.

<li>
<a name="97d167"> <b>97d167</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME97d167.mpg"> CME</a>
    from <b> June 16, 1997, </b> (720kB, mpeg).
    A <b>slow</b> moving CME can be seen at position angle 305 degrees.
    (Note: the MK3 is mispointed too far North until 21:19UT).
    The most obvious movement is that of the embedded prominence material
    slowly leaving the suns gravitational field.  The
    event occurs from 19:53-23:11 UT.  The 
    <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP97d167.mpg"> 
    H-alpha</a> (394kB, mpeg) data shows the
    same slow moving prominence material.

<li>
<a name="97d206"> <b>97d206</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME97d206.gif"> CME</a>
    on <b> July 25, 1997, </b> (410kB, Merged-GIF).
    A CME was spotted at Position Angle 300 degrees.  It occurs between
    20:24-20:43 UT.  The CME was also seen in 
    <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CHIP97d206.gif"> 
    Helium-I line</a>
    (286kB, Merged-GIF).
    The Helium data shows that the CME originated at 55W/15N on
    the disk.  Note the shock wave.

<li>
<a name="97d252"> <b>97d252</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME97d252.gif"> CME</a>
    on <b> September 9, 1997, </b> (665kB, Merged-GIF).
    A beautiful CME can be seen near position angle 320 degrees.  There
    appears to be an abundance of prominence material embedded just behind
    the advancing loop.  The event takes place from 19:07-20:26 UT.

<li>
<a name="97d262"> <b>97d262</b> </a><br>
    An <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP97d262.gif">AP</a>
    on <b> September 19, 1997, </b> (1M, Merged-GIF).
    This large prominence shows activity at PA 242-258 on the west limb.</a>

<li>
<a name="97d272"> <b>97d272</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME97d272.gif"> CME</a>
    on <b>September 29, 1997, </b> (252kB, Merged-GIF).
    This CME is dedicated to Lee Lacey.  He was instrumental in the beautiful
    images we see from the mk3 coronameter.  The classic advancing loop can be
    seen from 17:47-18:38 UT. at position angle 90 degrees.

<li>
<a name="97d276"> <b>97d276</b> </a><br>
    From <b> October 3, 1997, </b>
    an <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP97d276.gif">EP</a>
    (1.2MB, gif) in H-alpha on the
    east limb at PA 50.

<li>
<a name="97d296"> <b>97d296</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME97d296.gif"> CME</a>
    on <b>October 23, 1997, </b> (1.2MB, Merged-GIF).
    At position angle 90 degrees the CME can be seen exploding away from
    the sun.  A well defined cavity is seen throughout the event, with an
    abundance of prominence material embedded within it.  The prominence 
    material is interesting because it is moving away non-radially in a
    southeasterly direction.  The entire event takes place from 20:26-21:42 UT.

<li>
<a name="97d328"> <b>97d328</b> </a><br>
    A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME97d328.gif"> CME</a>
    on <b>November 24, 1997, </b> (2.8MB, Merged-GIF).
    At position angle 110 degrees a very slow and faint CME can be seen
    exploding away from the sun.  There appears to be two advancing loops,
    though there is actually only one CME.  The event is in progress at the
    beginning of the observing period.  Because of the image quality only
    those images between 17:35-21:20 UT. can be seen.  The CME is also in 
    at the end of 21:20 UT.

<li>
<a name="97d335"> <b>97d335</b> </a><br>
   A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME97d335.gif"> CME</a>
   on <b>December 1, 1997, </b> (206kB, Merged-GIF).
   At position angle 60 degrees this CME is very fast, so look quick!  It
   occurs from 18:34-19:32 UT. It looks to be in progress when the observing
   period is over.

<li>
<a name="97d352"> <b>97d352</b> </a><br>
    From <b> December 18, 1997, </b>
    an <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP97d352.gif">EP</a>
    (255kB, Merged-GIF) in H-alpha on the
    east limb at PA 50-68.

<li>
<a name="97d362"> <b>97d362</b> </a><br>
    From <b> December 28, 1997, </b>
    an <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP97d362.gif">EP</a> 
    (244kB, Merged-GIF) in H-alpha on the
    south-east limb at PA 132-140.

<li>
<a name="97d363"> <b>97d363</b> </a> 29 December 1997 <br>
   A <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME97d363.gif"> CME</a>
   on <b>December 29, 1997, </b> (460kB, Merged-GIF).
   At position angle 300 degrees the somewhat faint CME can be seen from
   17:51-18:31 UT. An 
   <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP97d363.gif"> EP</a>
   (174kB Merged-GIF)
   associated with this CME can be seen on the limb in H-alpha.

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li>
<a name="98d010">
    <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/AP98d010.gif">
    10 January 1998 </a> : <b>DOY010</b> (350kB, Merged-GIF) <br>
    An AP event occurred in H-alpha on the north-west limb at PA 306-317.
    This prominence is very large and active and grows in height during the day.

<li>
<a name="98d027">
    From <b> January 27, 1998, </b>
    <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP98d027.gif">
    27 January 1998 </a> : <b>DOY027</b> (731kB, Merged-GIF) <br>
    An impressive ERP in H-alpha is seen on the south-east limb at PA 115-133.
    Prominence material splits up high above the limb with some continuing
    outward and the rest falling back down to the sun.

<li>
<a name="98d053">
    <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d053.gif">
    22 February 1998 </a> : <b>DOY053</b> (894 kB, Merged-GIF) <br>
    A large CME on the north east limb between position angles 60-80 degrees.
    The entire event occurs from 17:38-18:39 UT. 

<li>
<a name="98d055">
    <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d055.gif">
    24 February 1998 </a> : <b>DOY055</b> (987 kB, Merged-GIF) <br>
    A large CME at position angle 240 degrees is seen here exploding away
    from the sun.  The entire event takes place over 17:40-18:47 UT.

<li>
<a name="98d060">
    <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d060.gif">
    1 March 1998 </a> : <b>DOY060</b> (1.2MB, Merged-GIF) <br>
    A beautiful CME at position angle 290 degrees can be seen blasting off
    the sun from 18:40-20:39 UT.  An eruptive prominence can be seen
    following the advancing loop of the CME around the same time. The ERP is
    also seen in a movie in 
    <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP98d060.gif">H-alpha</a>
    (471kB, Merged-GIF).

<li>
<a name="98d064">
    <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d064.gif">
    5 March 1998 </a> : <b>DOY064</b> (2.3 MB, Merged-GIF) <br>
    An exciting double loop CME at position angle 230 degrees can be seen
    in progress at the start of the observing period at 17:44-20:37 UT.
    An abundance of prominence material is embedded in the second loop,
    before erupting into the cavity of the first loop.
    <br>The associated ERP
    <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP98d064.gif"> in
    H-alpha </a> (474kB, Merged-GIF)
    and in
    <a href="http://download.hao.ucar.edu/d5/chip/daily_images/1998/03_mar/98_03_05_heliumI_MOVIE.gif">
    Helium-I </a> (3.6Mb Merged-GIF)
    can also be seen.

<li>
<a name="98d067">
    <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d067.gif">
    8 March 1998 </a> : <b>DOY067</b> (1.3 MB, Merged-GIF) <br>
    An exciting day on the sun!  There are 3 CME's that can be seen.  The
    1st is at position angle 90 degrees.  It is very faint, so look close.
    This event occurs from 18:21-18:54 UT.  The 2nd CME is at position 
    angle 300 degrees.  Also faint, but a classical advancing loop is
    noticeable.  This event occurs from 18:54-19:26 UT.  Finally, the 3rd
    CME is located near position angle 110 degrees.  There is a beautiful
    advancing loop followed by embedded prominence material.  This event
    occurs from 19:14-19:58 UT.  Enjoy!

<li>
<a name="98d072">
    <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d072.gif">
    13 March 1998 </a> : <b>DOY072</b> (675kB, Merged-GIF) <br>
    A CME at position angle 270 degrees can be seen blowing out away from
    the sun.  There is a classic advancing loop followed by some embedded
    prominence material.  The entire event occurs from 21:01-21:39 UT.

<li>
<a name="98d076">
    <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP98d076.gif">
    17 March 1998 </a> : <b>DOY076</b> (216 kB, Merged-GIF) <br>
    A small ERP in H-alpha appears on the south-west limb at PA 257-258. 

<li>
<a name="98d086">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d086.gif">
   27 March 1998 </a> : <b>DOY086</b> (1.3 MB, Merged-GIF) <br>
   A beautiful double loop CME at position angle 200 degrees can be seen
   blasting off the sun.  There appears to be an abundance of prominence
   material embedded in the second loop.  The entire even takes place from
   20:28-21:52 UT.
   <br>The <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP98d086.gif">
   ERP</a> (131kB, Merged-GIF) can be seen 
   in this H-alpha movie that runs from 20:52-21:31 UT.  This ERP does not
   seem to be associated with the above CME, suggesting that the CME
   was a "backside" event.

<li>
<a name="98d094">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d094.gif">
   4 April 1998 </a> : <b>DOY094</b> (675 kB, Merged-GIF) <br>
   This CME can be seen at position angle 260 degrees.  The entire event
   takes place from 17:55-18:38 UT.

<li>
<a name="98d105">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP98d105.gif">
   15 April 1998 </a> : <b>DOY105</b> (355 kB, Merged-GIF) <br>
   ERP event at PA 250-264 from 21:12 to 22:06 UT.

<li>
<a name="98d111">
<b>98d111</b> </a> 21 April 1998 <br>
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d111.gif">
   21 April 1998 </a> : <b>DOY111</b> (2.2 MB, Merged-GIF) <br>
   There are two CME's to look out for.  The first is at position angle
   300 degrees from 17:52-19:54 UT.  There is an abundance of prominence
   material following the advancing loop before erupting out into the cavity.  
   The 2nd CME occurs from postion angle 90 to 150 degrees.  It looks like a 
   cloud burst as it explodes away from the sun.  This event occurs from 
   19:51-20:40 UT.

   <br>
   Two ERPs on the same day can be seen in
   <ul>
   <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP98d111.gif">
   H-alpha</a> (456kB, Merged-GIF)
   </ul>
   and 
   <ul>
   <a href="http://download.hao.ucar.edu/d5/chip/daily_images/1998/04_apr/98d111_heliumI_MOVIE.gif">
   Helium-I </a> (5MB, Merged-GIF).
   </ul>
   The first
   occurs at 16:41-17:53 UT at PA 319-329, and the second occurs
   at 17:38-19:34 UT at PA 286-304.
   <b> Note: the annotation in the H-alpha data indicates
   April 22 -- it should be April 21. </b>

<li>
<a name="98d166">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d166.gif">
   15 June 1998 </a> : <b>DOY166</b> (1.3 MB, Merged-GIF) <br>
   There are two simultaneous CMEs.
   The most obvious is at position angle 125 degrees.
   There is an abundance of prominence material imbedded in this CME
   near its more northern "leg".  
   The 2nd CME is dimmer and is located near the south pole.
   Both events occur from about 16:43-18:20 UT.

<li>
<a name="98d167">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d167.gif">
   16 June 1998 </a> : <b>DOY167</b> (0.6 MB, Merged-GIF) <br>
   There is one large CME on the west limb,
   extending from about 240 to 330 degrees PA.
   One can see embedded prominence material at about PA 248.
   The event is in the MK3 FOV from about 18:00 to 18:50 UT.<br>
   The associated ERP can be seen in
   <a href="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/ERP98d167.gif">H-alpha</a>
   (130kB, Merged-GIF).

<li>
<a name="98d187">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d187.gif">
   6 July 1998 </a> : <b>DOY187</b> (0.5 MB, Merged-GIF) <br>
   There is a small CME on the west limb,
   just north of due west at PA 275 degrees.
   It lasts from about 19:00 to 19:30 UT.<br>

<li>
<a name="98d192">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d192.gif">
   11 July 1998 </a> : <b>DOY192</b> (0.4 MB, Merged-GIF) <br>
   There is a small CME on the west limb,
   just north of due west at PA 272 degrees.
   It lasts from about 18:28 to 18:58 UT.<br>

<li>
<a name="98d199">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d199.gif">
   18 July 1998 </a> : <b>DOY199</b> (0.3 MB, Merged-GIF) <br>
   There is a very dim CME on the east limb.
   It lasts from about 17:00 to 17:24 UT.<br>

<li>
<a name="98d217">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d217.gif">
   5 August 1998 </a> : <b>DOY217</b> (0.6 MB, Merged-GIF) <br>
   There is a small CME on the east limb, at ~78 degrees PA. 
   It lasts from about 17:50 to 18:13 UT.<br>

<li>
<a name="98d227">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d227.gif">
   15 August 1998 </a> : <b>DOY227</b> (0.6 MB, Merged-GIF) <br>
   A CME very similar to that on 1998, doy 228 but not as well defined.
   It is centered at 68 degrees PA lasting from about 18:10 to 18:42 UT.<br>
   Speed of the front of the loop is near 580 km/sec.
   At 18:10 angular extent is from 43      to  94 degrees PA.
   At 18:03 angular extent is from 33(???) to 104 degrees PA.
   There also appears to be material flowing along the southern leg near
   the end of the CME.

<li>
<a name="98d228">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d228.gif">
   16 August 1998 </a> : <b>DOY228</b> (1 MB, Merged-GIF) <br>
   A beautiful expanding loop CME on the east limb, centered around
   60 degrees PA. 
   It lasts from about 17:37 to 18:45 UT.<br>
   Speed of the front of the loop is near 770 km/sec.
   At 17:40 angular extent is from 45 to  75 degrees PA.
   At 18:03 angular extent is from 30 to 104 degrees PA.
   There appears to be quite a bit of material flowing along the
   southern leg, seen in mk3 FOV beginning at 18:00 until 18:47.

<li>
<a name="98d229">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d229.gif">
   17 August 1998 </a> : <b>DOY229</b> (1 MB, Merged-GIF) <br>
   This is the first of two CMEs which occur at the same location.
   It is in the mk3 fov from 18:16 to 18:43 at PA 45
   degrees, fairly narrow width, from 35 to 55 degrees PA.
   Speed is dificult to estimate.
   <p>
   Second CME occurs at a time when patches of clouds were
   passing by the observatory. So details may be incorrect.
   CME is in mk3 fov from 21:16 to 21:30 at PA 46 degrees.
   Width at 21:21 extends from 34 to 59 degrees PA.
   Width at 21:30 extends from 30 to 66 degrees PA.
   Speed is difficult to check, seems fast, 800 km/sec.

<li>
<a name="98d231">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d231.gif">
   19 August 1998 </a> : <b>DOY231</b> (0.5 MB, Merged-GIF) <br>
   A large fast CME is seen late in the day.
   It is seen in mk3 FOV from 21:41 to 21:50 at PA 53 degrees.
   Width at 21:44 extends from 37 to 75 degrees PA. 
   Width at 21:50 extends from 30 to 75 degrees PA.
   Speed estimate, fast, >1200km/sec.
   A faint Morton wave may be seen in the
   <a HREF="http://download.hao.ucar.edu/d5/chip/daily_images/1998/08_aug/98d231_heliumI_MOVIE.gif">
   Helium-I </a> data.

<li>
<a name="98d236">
   <a HREF="http://download.hao.ucar.edu/d5/chip/daily_images/1998/08_aug/98_08_24_heliumI_MOVIE.gif">
   24 August 1998 </a> : <b>DOY236</b> (8 MB, Merged-GIF) <br>
   A Morton wave is seen in the Helium-I data (CHIP) emanating from an
   active region near 20 N latitude, ~5 E longitude at ~22:00 UT.
   There is also some interesting "precursor" activity.

<li>
<a name="98d242">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d242.gif">
   30 August 1998 </a> : <b>DOY242</b> (1 MB, Merged-GIF) <br>
   A slow moving CME is seen in mk3 FOV from 17:15 to 18:29 at PA 306 degrees
   (upper right).  Width extends from 292 to 320 degrees PA. 

<li>
<a name="98d280">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d280.gif">
   7 October 1998 </a> : <b>DOY280</b> (0.6 MB, Merged-GIF) <br>
   A small, narrow CME is seen in mk3 FOV from 17:47 to 18:31 at PA 125 degrees
   (lower left).  Width extends from 119 to 130 degrees PA. 

<li>
<a name="98d282">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d282.gif">
   9 October 1998 </a> : <b>DOY282</b> (0.8 MB, Merged-GIF) <br>
   There are actually 2 CMEs on this day. Only the first one is shown.
        In the first one, all one can see is a
	huge prominence eruption. There is
        no classic loop front at all.  It is first seen at 18:46
	at PA 51 and is in the mk3 fov until 19:30.  An estimated speed
        for the prominence material of 342km/sec.
<p>
        Second is hard to see in the late day noise.  It begins at 21:06
        at PA 99.  It is in the mk3 fov until 21:26 (?) very hard to
        see in the late day noise.  Speed estimate 513 km/sec.

<li>
<a name="98d352">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/TRF98d352.gif"> 
   18 December 1998 </a> : <b>DOY354</b> (1.2 MB, Merged-GIF) <br>
   This event occurs in the NE quadrant of the disk and is visible in H-Alpha
   and less so in the HeI dataset.  It begins at 17:29 UT and lasts until
   approximately 19:19 UT.  Clouds decreased contrast on the disk but 
   it is possible to see detail.

<li>
<a name="98d353">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME98d353.gif">
   19 December 1998</a> : <b>DOY353</b> (0.4 MB, Merged-GIF) <br>
   This CME is in progress at beginning of observing day and is visible until
   18:07 UT.  Prominence material can be seen following a radial path outward
   at PA 224.  Approximate width of the CME is 15 degrees.

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li>
<a name="99d020">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME99d020.gif">
   20 January 1999 </a> : <b>DOY020</b> (0.9 MB, Merged-GIF) <br>
   Very large CME centered at PA 64 begins at 18:42 UT and remains visible in
   the MK3 field of view until approximately 19:43 UT.  This event appears to
   have a LOOP/CAVITY/CORE structure but the prominence (CORE) material is not
   very distinct.  The width of the LOOP feature is approximately
   45 degrees.  This event affects a large area because the magnetic field
   lines associated with the LOOP appear to push out the outer edges of the
   helmet streamer containing it.  Because it is visible in the MK3 FOV for 
   only one hour suggests a fast moving event.

<li>
<a name="99d036">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME99d036.gif">
   5 February 1999 </a> : <b>DOY036</b> ( 2.3MB, Merged-GIF) <br>
   Large, slower moving CME with prominence material centered at PA 230.  
   There is a distinct core (prominence) and cavity feature as well as a less
   distinct loop feature.  The width of the outer loop is approximately
   46 degrees at it's widest.  As the core rises, the CME appears to push
   against the surrounding corona, widening the cavity region.  The core
   first becomes visible in the MK3 FOV at 19:34 UT and leaves it by 22:29 UT.

<li>
<a name="99d103">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/TRF99d103.gif"> 
   13 April 1999 </a> : <b>DOY103</b> (2.1 MB, Merged-GIF) <br>
   This two-ribbon flare begins in H-Alpha data at approximately 17:37 UT.
   Activity remains visible until the end of the observing day.  There 
   appears to be material moving eastward along the surface of the disk.
   This motion is confirmed by CHIP velocity data which suggests that 
   material is moving away from the observer.  This is consistent with the
   idea that material is moving toward the limb with a large velocity
   component directed away from the observer.

<li>
<a name="99d129">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME99d129.gif">
   9 May 1999 </a> : <b>DOY129</b> (1.0 MB, Merged-GIF) <br>
   Very bright, fast CME visible in MK3 from 18:04-18:41 UT and is centered
   at PA 304 degrees.  Approximate width is 33 degrees.  This event is very
   bright in the MK3 direct images and has a nice LOOP/CAVITY/CORE structure.
   The outer loop seems to travel northward, pushing the helmet streamer to
   the north as it travels outward.  Prominence material can be seen 
   following the cavity.  The entire event seems pulled or deflected northward
   a bit as it travels outward.

<li>
<a name="99d168">
   <a HREF="http://download.hao.ucar.edu/d5/dpm/MLSO_Events/CME99d168.gif">
   17 June 1999 </a> : <b>DOY168</b> (4.9 MB, Merged-GIF) <br>
   This rather large sized file is included here to show one of the first
   CME's observed in the new MK4 k-coronameter.  This CME is centered at
   PA 306 degrees and is visible in MK4 from 17:19-19:03 UT.  According
   to MK3 logs, this event is visible from 17:30-17:53 UT, so MK4
   observed the events for over an hour longer than in MK3 and more
   fine detail can be seen.  There is a clear LOOP structure and a
   somewhat complicated looking CAVITY structure.

<li>
<a name="99d299">
   <a HREF="http://download.hao.ucar.edu/d5/events/mk4/mk4.26oct99.sqrt.movie.gif">
   26 October 1999 </a> : <b>DOY399</b> (2.7 MB, Merged-GIF)<br>
   This event is visible from 21:18 until 22:28 UT on the west limb.
   It appears to be a double loop structure.

<li>
<a name="99d323">
   <a HREF="http://download.hao.ucar.edu/d5/events/mk4/mk4.19nov99.sqrt.movie.gif">
   19 November 1999 </a> : <b>DOY323</b> (3.6 MB, Merged-GIF)<br>
   Here one can see a faint loop, presumably a bit out of the plane of the sky,
   accompanied by a prominence in the south-west.

<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

<li>
<a name="00d359">
   24 December 2000: <b>DOY 359</b>
   <br>
   <a HREF="http://download.hao.ucar.edu/d5/events/mk4/00d359/s256/js256.00d359.html">
   256x256</a> javascript movie.
   <br>
   <a HREF="http://download.hao.ucar.edu/d5/events/mk4/00d359/s360/js360.00d359.html">
   360x360</a> javascript movie.
   <br>
   <a HREF="http://download.hao.ucar.edu/d5/events/mk4/00d359/s512/js512.00d359.html">
   512x512</a> javascript movie.
<hr>
   <a href="#MOVIE">Back to the movie marquee.</a><br>
<hr>

</ul>
</ul>
<p>
Many more events have been observed by the Mk3 and Mk4 instruments.
An updated list is 
<A HREF="mlsoeventtree.html"> available.</A>  
<hr>
<P>
<A HREF = "mlso_homepage.html">
<IMG align=middle src="icons/home01.gif" alt="&lt; &gt;"
height=33 width=33 hspace=10></A>
Return to MLSO
<A HREF = "mlso_homepage.html">Home Page</A>
</P>

<address>
<p>Webpage written and maintained by: <br>
<a href="mailto:tdarnell\@ucar.edu">Tony Darnell</a> <br>
Last modified:  $create_str
</p>
</address>

</BODY>
</HTML>

END_OF_PAGE
