#!/opt/local/bin/perl

use strict;
use Time::JulianDay;
use mlso_navbar;
use mlso;

my $images = "http://download.hao.ucar.edu/d5/www/images";
my $styles = "http://download.hao.ucar.edu/d5/www/styles";
my $rootdir = $ENV{DOCUMENT_ROOT};
#my $me = "$rootdir/internal/mlso_data.cgi";

my $me = "$base/mlso_movies.cgi";
my $href = "$base/mlso_getmovie.cgi";

#my $year = "2001";
my $tmp = $ENV{QUERY_STRING};
my @query = split(/&/,$tmp);
my $year = $query[0];
my $inst = $query[1];
my $month;
my $logdir = "http://download.hao.ucar.edu/d5/mlso/log/observer/$year";
my @filestats = stat "mlso_movies.cgi";
my @gm_arr = localtime($filestats[9]);
my $create_str = sprintf("%02d/%02d/%02d %02d:%02d:%02d",
        $gm_arr[4]+1,$gm_arr[3],$gm_arr[5]-100,$gm_arr[2],$gm_arr[1],$gm_arr[0]);

sub getcolor;

print <<END_OF_PAGE;
Content-type: text/html

<html>
<head>
<title>Available $inst Movies for $year</title> 

<link rel="stylesheet" type="text/css"
href="$styles/mlsohome.css" />

END_OF_PAGE

PrintJavaScript();
PrintACOSbar("mlso_banner3.sml.gif");

my %yrselected = ('2003',"",'2002',"",'2001',"",'2000',"",'1999',"",'1998',"",'1997',"",'1996',"",'1995',"",'1994',"");
$yrselected{$year} = "selected";
my %instselected = ('MKIV',"",'PICS',"",'CHIP',"");
my %instsrchstr = ('MKIV',"rp[bB]",'PICS',"as[rl]",'CHIP',"hsh");
$instselected{$inst} = "selected";

print <<END_OF_PAGE;

<div align="center">
<img src='$images/caltext.gif'>
</div>

<form name="myform">
<select name= "myyear" onChange='location = "$me?"+document.myform.myyear.options[document.myform.myyear.selectedIndex].value+"&"+document.myform.myinst.options[document.myform.myinst.selectedIndex].value'>
  <option value="2003" $yrselected{2003}>2003
  <option value="2002" $yrselected{2002}>2002
  <option value="2001" $yrselected{2001}>2001
  <option value="2000" $yrselected{2000}>2000
  <option value="1999" $yrselected{1999}>1999
  <option value="1998" $yrselected{1998}>1998
  <option value="1997" $yrselected{1997}>1997
  <option value="1996" $yrselected{1996}>1996
  <option value="1995" $yrselected{1995}>1995
  <option value="1994" $yrselected{1994}>1994
</select>

<select name="myinst" onChange='location = "$me?"+document.myform.myyear.options[document.myform.myyear.selectedIndex].value+"&"+document.myform.myinst.options[document.myform.myinst.selectedIndex].value'>
  <option value="MKIV" $instselected{MKIV}>MK4 (White Light)
  <option value="PICS" $instselected{PICS}>Pics (H Alpha)
  <option value="CHIP" $instselected{CHIP}>Chip (He 10830nm)
</select>

</form>

<H1 class="datatitle">Available $inst Movies for $year</h1>

<table class="calendar" border=4 align="center">
END_OF_PAGE

if ($year > 1996){
  #print "<TH colspan = 7 bgcolor=\"green\">All datasets available</TH>
  print "<TH colspan = 7 bgcolor=\"\#33ff33\">All datasets available</TH>
  <TD></TD>
  <TH colspan = 7 BGCOLOR=\"yellow\">Some instruments offline</TH>
  <TD></TD>
  <TH colspan = 7 bgcolor=\"red\">No data available</TH>";
} elsif ($year == 1996){
print <<THATSIT
  Note: at some point during this year, the format of the observer logs
  changed and the color coding sheme no longer works.  Please click on the 
  date you're interested in for more accurate, detailed information.
THATSIT
} else {
print <<THATSIT
  Note:  the color coding scheme does not work prior to 1996, please click on
  the date you're interested in for more accurate, detailed information.
THATSIT
}

#
# Run unix cal command on one year and parse the
#	output.  Need to turn each day into
#	a link that points to available
#	data.
# If cal ever changes it's output, this code
#	will break.
#
my $weekline = 1;
open(CAL, "/usr/bin/cal $year |");
while (<CAL>){
    my $tag;
    my $endtag;
    my $bgcolor;
    my @data = ();
    my $i;

    if (($. == 1) || ($. == 2) || ($. == 3)) { print ""; next; } #Ignore first three lines

    print "<TR>";
    # Grab the 
    if (/^Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec$/) {
      s/^\s*(.*?)\s*$/$1/;            ## trim whitespace
      $tag= "TH colspan=8"; $endtag="TH";
      @data = split(/\s+/, $_);
      #$bgcolor = "teal";
      $bgcolor = "#ccccff";
    } elsif (/$year/) {		      # Deal with year title
      s/^\s*(.*?)\s*$/$1/;            ## trim whitespace
      $tag= "TH colspan=23"; $endtag="TH";
      @data = split(/\s+/, $_);
      #$bgcolor = "teal";
    } elsif (/^S|M|Tu|W|Th|F|S$/) {   # Deal with week headers
      $weekline = $.;
      s/^\s*(.*?)\s*$/$1/;            ## trim whitespace
      $tag = "TD"; $endtag="TD";
      #$bgcolor = "teal";
      @data = split(/\s+/, $_);
    } elsif (($. % 8) == 0){         # This is the first row of each month
     @data = split(/\s{2,3}/, $_);
     $tag = "TD"; $endtag="TD";
     foreach (@data){
        s/^\s*(.*?)\s*$/$1/;            ## trim whitespace
     }
     #$bgcolor=getcolor($year,7,11);
    } else { 
      if ($. == ($weekline+2)){  # This is the second row of each month
        s/^\s*(.*?)\s*$/$1/;            ## trim whitespace
        $tag = "TD"; $endtag="TD";
        @data = split(/\s+/, $_);
      } elsif ($. == ($weekline+3)){ # Third row
        s/^\s*(.*?)\s*$/$1/;	     # trim whitespace
        $tag = "TD"; $endtag="TD";
        @data = split(/\s+/, $_);
      } elsif ($. == ($weekline+6)){ #Last row of each month.
        @data = split(/\s{1,3}/, $_); #Trim whitespace and cut down line
					#size by 1/3
	splice(@data, 4,1);		# Cut out one space in first month
	splice(@data, 10,1);		# Cut out one space in second month
        $tag = "TD"; $endtag="TD";	# All done
      } else { 				# Everything else
	@data=split(/\s{1,3}/,$_);
      }
      $tag = "TD"; $endtag="TD"; 
      #$bgcolor=getcolor($year,7,11);
    } 

    #
    # Print out the @data gathered above
    #
      #print "<pre>@data</pre>";
      #print "<pre>$data[0]</pre>";
      if ($. <= 13){  # Jan Feb Mar
	$month = 1;
      } elsif (($. > 13) && ($. < 22)){ # Apr May Jun
	$month = 4;
      } elsif (($. > 22) && ($. < 30)){  # Jul Aug Sep
	$month = 7;
      } else { # Oct Nov Dec
	$month = 10;
      }
    for $i (0 .. $#data) { 
      if ((($i % 7) == 0) && ($i > 0)){ #print space between months and
	$month++; 			#increment $month
	print "<TD></TD>";
      }  
      $bgcolor=getcolor($year,$month,$data[$i],$inst);
      print "<$tag BGCOLOR=\"$bgcolor\")><a href=$href?$year&$month&$data[$i]&$inst&$instsrchstr{$inst}&jpg>$data[$i]</a></$endtag>";
    }
    print "</TR>\n";

}
close(CAL);

print <<END_OF_PAGE;
</table>

<div align="center">
<img src='$images/ncartext.gif'>
</div>

<address>
<p>Webpage written and maintained by: <br>
<a href="mailto:tdarnell\@ucar.edu">Tony Darnell</a> <br>
Last modified:  $create_str
</p>
</address>

</body> 
</html>

END_OF_PAGE

sub getcolor{

  my $year = $_[0];
  my $month = $_[1];
  my $day = $_[2];
  my $inst = $_[3];
  my $bgcolor = "white";
  my $logdir = "/toshi/ftp/d5/mlso/log/observer/$year";
  my $doy;

  if ($day =~ /^Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec$/){
    #return $bgcolor = "teal";
    return $bgcolor = "#ccccff";
  } elsif ($day == $year) {
    #return $bgcolor = "teal";
    return $bgcolor = "#ccccff";
  } elsif ($day =~ /^S|M|Tu|W|Th|F|S$/){
    #return $bgcolor = "teal";
    return $bgcolor = "#ccccff";
  } else {
    $doy = julian_day($year,$month,$day)-julian_day($year-1,12,31);
  }

  return if !($day);

  #print "$year $month $day ";
  #print "$month ";
  my $yrddoy = sprintf("%dd%03d",$year,$doy);
  #print "$yrddoy ";
  #return $bgcolor = "white";

  opendir LOGFILES, $logdir;
  my @logfiles = readdir LOGFILES;
  closedir LOGFILES;
  @logfiles = sort (@logfiles);
  my $num_files = @logfiles;
  my $lastfile = $logfiles[$#logfiles];
  my @tmp = split(/\./,$lastfile);
  my $lastyrddoy = $tmp[1];
  @tmp = split(/d/,$lastyrddoy);
  my $lastdoy = $tmp[1];

  if ($doy > $lastdoy){return $bgcolor="white";}

  my $logfile = "mlso.$yrddoy.olog";
  open(LOG, "< $logdir/$logfile") || return $bgcolor="red";
  my @log = <LOG>;
  close(LOG);

  # Get all starttimes of all instruments
  my @startimes = grep(/Start/,@log);
  my @endtimes  = grep(/End/,@log);
  my @mk4files = grep(/rawmk4/,@log);
  my @mk3files = grep(/rawmk3/,@log);

  if (($year == 1998) && ($month >= 10)){
    @mk4files = @mk3files;
  }
  if (($year == 1999) && ($month <= 9)){
    @mk4files = @mk3files;
  }

  # Now sort them out
  if ($inst eq "MLSO"){
    my @chipstart = grep(/CHIP/,@startimes);
    my @picsstart = grep(/PICS/,@startimes);
    my @mk4start  = grep(/MKIV/,@startimes);

    my @chipend   = grep(/CHIP/,@endtimes);
    my @picsend   = grep(/PICS/,@endtimes);
    my @mk4end    = grep(/MKIV/,@endtimes);

    my $numchiptimes = @chipstart + @chipend;
    my $numpicstimes = @picsstart + @picsend;
    my $nummk4times = @mk4start;
    my $nummk4 = @mk4files;

    #print "<pre class=\"calendar\">$numchiptimes $numpicstimes $nummk4times $nummk4</pre>";
    if ($numchiptimes && $numpicstimes && $nummk4){
      #$bgcolor = "green";
      $bgcolor = "#33ff33";
    } elsif ($numchiptimes || $numpicstimes || $nummk4){
      $bgcolor = "yellow";
    } else {$bgcolor = "red";}

  } else {
    my @inststart;
    if ($inst ne "MKIV"){
      @inststart = grep(/$inst/, @startimes);
      push(@inststart,grep(/$inst/,@endtimes));
    } else {
      #@inststart = grep(/rawmk4/,@log);
      @inststart = @mk4files;
    }
    my $numinsttimes = @inststart;
    if ($numinsttimes){
      #$bgcolor="green";
      $bgcolor="#33ff33";
    } else { $bgcolor = "red";}
  }

  return $bgcolor;

}

